--
-- PostgreSQL database dump
--

SET client_encoding = 'SQL_ASCII';
SET standard_conforming_strings = off;
SET check_function_bodies = false;
SET client_min_messages = warning;
SET escape_string_warning = off;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: gvp_world; Type: TABLE; Schema: public; Owner: root; Tablespace: 
--

CREATE TABLE gvp_world (
    idgvpw integer,
    name character varying(40),
    descript text,
    volpnt point
);


ALTER TABLE public.gvp_world OWNER TO root;

--
-- Data for Name: gvp_world; Type: TABLE DATA; Schema: public; Owner: root
--

COPY gvp_world (idgvpw, name, descript, volpnt) FROM stdin;
1	West Eifel Volcanic Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>West Eifel Volcanic Field</b></font><br /><font size="5"><b>Germany</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/015001.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Maars<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 600 m<br /><b>Latitude:</b> 50.17&deg;N<br /><b>Longitude:</b> 6.85&deg;E</td></tr><tr><td colspan="2"><p align="justify">The West Eifel volcanic field in the Rhineland district of western Germany SW of the city of Bonn is a dominantly Pleistocene group of 240 scoria cones, maars, and small stratovolcanoes covering an area of about 600 sq km.  The West Eifel volcanic field lies about 40 km SW of the smaller, but better known East Eifel volcanic field.  Individual vents, most of which cover a broad NW-SE-trending area extending about 50 km from the towns of Ormont on the NW to Bad Bertrich on the SE, were erupted above a mantle plume through Devonian sedimentary and metamorphic rocks.  Scoria cones, about half of which have produced lava flows, form two-thirds of the volcanic centers, and about 30% are maars or tuff rings, many of which are occupied by lakes.  About 230 eruptions have occurred during the past 730,000 years.  The latest eruptions formed the Ulmener, Pulvermaar, and Strohn maars around the end of the Pleistocene and the beginning of the Holocene.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0100-01-&amp;volpage=photos&amp;photo=015001">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0100-01-">Smithsonian Volcano Information</a></td></tr></table>	(50.170000000000002,6.8499999999999996)
2	Chane des Puys	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Chane des Puys</b></font><br /><font size="5"><b>France</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/088002.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 1464 m<br /><b>Latitude:</b> 45.775&deg;N<br /><b>Longitude:</b> 2.97&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Chane des Puys, prominent in the history of volcanology, form a N-S-trending chain of basaltic and trachytic cinder cones, basaltic maars, and trachytic lava domes in France's Massif Central that has been active into the Holocene.  Construction of the present-day Chane des Puys began about 70,000 years before present (BP), and was largely completed by the beginning of the Holocene.  Holocene eruptions constructed lava domes such as the Puy de Dme, whose growth was accompanied by pyroclastic flows, cinder cones that fed lengthy lava flows, and maars.  The latest well-documented activity took place about 6000 years BP near Besse-en-Chandesse and included the powerful explosions that formed the Lac Pavin maar.  The dating of younger tephras has not yet been confirmed, and reports of historical eruptions as late as 1000 years BP have been discredited.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0100-02-&amp;volpage=photos&amp;photo=088002">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0100-02-">Smithsonian Volcano Information</a></td></tr></table>	(45.774999999999999,2.9700000000000002)
3	Olot Volcanic Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Olot Volcanic Field</b></font><br /><font size="5"><b>Spain</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119091.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 893 m<br /><b>Latitude:</b> 42.17&deg;N<br /><b>Longitude:</b> 2.53&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Olot volcanic field (also known as the Garrotxa volcanic field) occupies the NE corner of Spain south of the Pyrenees Mountains about 90 km NNE of Barcelona.  The Olot volcanic field consists of a large number of strombolian pyroclastic cones and associated alkali basaltic lava flows and is part of the NE Volcanic Province, which includes the Ampurdn and Selva areas to the SE.  The pyroclastic cones are preferentially located at the intersection of E-W and NW-SE faults that cut sedimentary and metamorphic basement rocks.  The latest dated eruption at Olot occurred during the early Holocene, and stratigraphic evidence suggests that more recent eruptions have occurred.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0100-03-&amp;volpage=photos&amp;photo=119091">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0100-03-">Smithsonian Volcano Information</a></td></tr></table>	(42.170000000000002,2.5299999999999998)
4	Calatrava Volcanic Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Calatrava Volcanic Field</b></font><br /><font size="5"><b>Spain</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/118054.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Maars<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1117 m<br /><b>Latitude:</b> 38.87&deg;N<br /><b>Longitude:</b> 4.02&deg;W</td></tr><tr><td colspan="2"><p align="justify">The dominantly Pliocene Calatrava volcanic field lies in central Spain near Ciudad Real.  The more than 300 basaltic-to-foiditic pyroclastic cones, maars, and lava domes cover an area of more than 5000 sq km.  The Calatrava volcanic field is mostly of Pliocene or late-Pleistocene age, although late-stage phreatomagmatic activity at Columba volcano was dated at the mid-Holocene.   The volcanic field lies in a continental rift setting and contains several lake-filled maars.  Fumarolic activity was recorded in the Sierra de Valenzuela area during the 16th-18th centuries.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0100-04-&amp;volpage=photos&amp;photo=118054">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0100-04-">Smithsonian Volcano Information</a></td></tr></table>	(38.869999999999997,-4.0199999999999996)
5	Larderello	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Larderello</b></font><br /><font size="5"><b>Italy</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/094048.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Explosion craters</td><td width="50%" align="left"><b>Summit Elev:</b> 500? m<br /><b>Latitude:</b> 43.25&deg;N<br /><b>Longitude:</b> 10.87&deg;E</td></tr><tr><td colspan="2"><p align="justify">Larderello, one of the world's most productive geothermal areas, is located in the southern part of the Tuscany region of Italy.  This extensive solfatara field lies in an area underlain by sediments of Eocene-to-Pliocene age.  The geothermal activity is considered to be related to a cooling granitic pluton of Pliocene age beneath sedimentary and metamorphic rocks ranging from Paleozoic to Tertiary age, although the area is cut by faults with hydrothermal mineralization related to Pliocene-to-Quaternary Tuscan magmatism.  The only surficial morphological manifestation of volcanism is a series of about a dozen explosion craters 30-250 m in diameter.  The Lago Vecchienna crater, now filled by a 250-m-wide lake, ejected blocks and ash during a phreatic eruption in about 1282 AD (Marinelli, 1969).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0101-001&amp;volpage=photos&amp;photo=094048">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0101-001">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ct.ingv.it/">INGV Catania Section</a></td><td width="33%"><a href="http://www.ingv.it/">Istituto Nazionale di Geofisica e Vulcanologia</a></td></tr></table>	(43.25,10.869999999999999)
6	Vulsini	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Vulsini</b></font><br /><font size="5"><b>Italy</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/015006.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Tuff cones</td><td width="50%" align="left"><b>Summit Elev:</b> 800? m<br /><b>Latitude:</b> 42.60&deg;N<br /><b>Longitude:</b> 11.93&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Vulsini volcanic complex in central Italy covers about 2200 sq km at the northern end of the Roman magmatic province.  Following lava extrusion and explosive eruptions that constructed the main Vulsini complex, the 16-km-wide, lake-filled Bolsena caldera on the east and the 8 x 11 km Latera caldera on the west were formed during major Pleistocene explosive eruptions at about 0.3 and 0.16 million years ago, respectively.  Five major plinian fall deposits were erupted from vents at or near Latera caldera during the late Pleistocene.  The latest major eruption formed unwelded pumice flows and welded airfall tuffs of the Pitigliano Formation, associated with collapse of the Vepe caldera about 166,000 years ago at the NW end of Latera caldera.  Post-caldera volcanism produced scoria cones and lava flows from vents within and to the west of Latera caldera and lasted until subrecent times.  Youthful-looking remnants of ash cones in Lake Bolsena may have given rise to a legend of a pre-historical fire-god, Volta.  An historical report noted that &quot;a flame shot up near Volsini&quot; in 104 BC.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0101-003&amp;volpage=photos&amp;photo=015006">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0101-003">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ct.ingv.it/">INGV Catania Section</a></td><td width="33%"><a href="http://www.ingv.it/">Istituto Nazionale di Geofisica e Vulcanologia</a></td></tr></table>	(42.600000000000001,11.93)
7	Campi Flegrei	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Campi Flegrei</b></font><br /><font size="5"><b>Italy</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/015011.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Tuff rings</td><td width="50%" align="left"><b>Summit Elev:</b> 458 m<br /><b>Latitude:</b> 40.827&deg;N<br /><b>Longitude:</b> 14.139&deg;E</td></tr><tr><td colspan="2"><p align="justify">Campi Flegrei is a large 13-km-wide caldera on the outskirts of Naples that contains numerous phreatic tuff rings and pyroclastic cones.  The caldera margins are poorly defined and on the south lie beneath the Gulf of Pozzuoli.  Episodes of dramatic uplift and subsidence within the dominantly trachytic caldera have occurred since Roman times.  The earliest known eruptive products are dated 47,000 years before present (BP).  The Campi Flegrei caldera formed following two large explosive eruptions, the massive Campanian ignimbrite about 36,000 years BP, and the &gt;40 cu km Neapolitan Yellow Tuff (NYT) about 15,000 years BP.  Following eruption of the NYT a large number of eruptions have taken place from widely scattered subaerial and submarine vents.  Most activity occurred during three intervals: 15,000-9500, 8600-8200, and 4800-3800 years BP.  Two eruptions have occurred in historical time, one in 1158 at Solfatara and the other in 1538 that formed the Monte Nuovo cinder cone.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0101-01=&amp;volpage=photos&amp;photo=015011">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0101-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ov.ingv.it/">INGV Osservatorio Vesuviano</a></td><td width="33%"><a href="http://www.ingv.it/">Istituto Nazionale di Geofisica e Vulcanologia</a></td></tr></table>	(40.826999999999998,14.138999999999999)
8	Vesuvius	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Vesuvius</b></font><br /><font size="5"><b>Italy</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/015031.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Somma volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1281 m<br /><b>Latitude:</b> 40.821&deg;N<br /><b>Longitude:</b> 14.426&deg;E</td></tr><tr><td colspan="2"><p align="justify">One of the world's most noted volcanoes, Vesuvius (Vesuvio) forms a dramatic backdrop to the Bay of Naples.  The historically active cone of Vesuvius was constructed within a large caldera of the ancestral Monte Somma volcano, thought to have formed incrementally beginning about 17,000 years ago.  The Monte Somma caldera wall has channeled lava flows and pyroclastic flows primarily to the south and west.  Eight major explosive eruptions have taken place in the last 17,000 years, often accompanied by large pyroclastic flows and surges, such as during the well-known 79 AD Pompeii eruption.  Intermittent eruptions since 79 AD were followed by a period of frequent long-term explosive and effusive eruptions beginning in 1631 and lasting until 1944.  The 1631 eruption was the largest since 79 AD and produced devastating pyroclastic flows that reached as far as the coast and caused great destruction.  Many towns are located on the volcano's flanks, and several million people live within areas potentially affected by eruptions of Vesuvius.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0101-02=&amp;volpage=photos&amp;photo=015031">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0101-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ov.ingv.it/">INGV Osservatorio Vesuviano</a></td><td width="33%"><a href="http://www.ingv.it/">Istituto Nazionale di Geofisica e Vulcanologia</a></td></tr></table>	(40.820999999999998,14.426)
9	Ischia	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ischia</b></font><br /><font size="5"><b>Italy</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104074.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 789 m<br /><b>Latitude:</b> 40.73&deg;N<br /><b>Longitude:</b> 13.897&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Ischia volcanic complex forms a rectangular, 6 x 9 km island immediately SW of the Campi Flegrei area at the western side of the Bay of Naples.  The eruption of the trachytic Green Tuff ignimbrite about 56,000 years ago was followed by caldera formation.  The high point on the island, 789-m-high Monte Epomeo, is a volcanic horst composed of the Green Tuff ignimbrite deposit that was submerged after its eruption and then uplifted.  Volcanism on the island has been significantly affected by tectonism that formed a series of horsts and grabens; at least 800 m of uplift has formed as a result of resurgent doming during past 33,000 years.  Many small monogenetic volcanoes were formed around the uplifted block.  Volcanism during the Holocene produced a series of pumiceous tephras, tuff rings, lava domes, and lava flows, and a major collapse of Mount Epomeo produced a large submarine debris-avalanche deposit.  The latest eruption of Ischia, in 1302 AD, produced a spatter cone and the Arso lava flow, which reached the NE coast.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0101-03=&amp;volpage=photos&amp;photo=104074">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0101-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ov.ingv.it/">INGV Osservatorio Vesuviano</a></td><td width="33%"><a href="http://www.ingv.it/">Istituto Nazionale di Geofisica e Vulcanologia</a></td></tr></table>	(40.729999999999997,13.897)
10	Palinuro	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Palinuro</b></font><br /><font size="5"><b>Italy</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> -70 m<br /><b>Latitude:</b> 39.48&deg;N<br /><b>Longitude:</b> 14.83&deg;E</td></tr><tr><td colspan="2"><p align="justify">Palinuro seamount in the Tyrrhenian Sea north of the Eolian Islands rises nearly 3000 m to within 70 m of the sea surface and has a horseshoe-shaped summit caldera.   A marine ash layer (PL-1) radiocarbon dated (calibrated age) at 9990 +/- 90 years ago is chemically and stratigraphically similiar to two ash layers of similar composition onland in southern Italy and was tentatively correlated to the Palinuro seamount activity (Siani et al., 2004).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0101-031">Smithsonian Volcano Information</a></td></tr></table>	(39.479999999999997,14.83)
11	Stromboli	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Stromboli</b></font><br /><font size="5"><b>Aeolian Islands (Italy)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/091031.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 924 m<br /><b>Latitude:</b> 38.789&deg;N<br /><b>Longitude:</b> 15.213&deg;E</td></tr><tr><td colspan="2"><p align="justify">Spectacular incandescent nighttime explosions at Stromboli volcano have long attracted visitors to the &quot;Lighthouse of the Mediterranean.&quot;  Stromboli, the NE-most of the Aeolian Islands, has lent its name to the frequent mild explosive activity that has characterized its eruptions throughout much of historical time.  The small, 924-m-high island of Stromboli is the emergent summit of a volcano that grew in two main eruptive cycles, the last of which formed the western portion of the island.  The Neostromboli eruptive period from about 13,000 to 5000 years ago was followed by formation of the modern Stromboli edifice.  The active summit vents are located at the head of the Sciara del Fuoco, a prominent horseshoe-shaped scarp formed about 5000 years ago as a result of the most recent of a series of slope failures that extend to below sea level.  The modern volcano has been constructed within this scarp, which funnels pyroclastic ejecta and lava flows to the NW.  Essentially continuous mild strombolian explosions, sometimes accompanied by lava flows, have been recorded at Stromboli for more than a millennium.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0101-04=&amp;volpage=photos&amp;photo=091031">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0101-04=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ct.ingv.it/">INGV Catania Section</a></td><td width="33%"><a href="http://www.ingv.it/">Istituto Nazionale di Geofisica e Vulcanologia</a></td></tr></table>	(38.789000000000001,15.212999999999999)
12	Lipari	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Lipari</b></font><br /><font size="5"><b>Aeolian Islands (Italy)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/015035.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 602 m<br /><b>Latitude:</b> 38.48&deg;N<br /><b>Longitude:</b> 14.95&deg;E</td></tr><tr><td colspan="2"><p align="justify">Lipari, the largest of the Aeolian Islands, is located immediately north of Vulcano Island.  The irregular-shaped island contains numerous small stratovolcanoes, craters, and lava domes on a basement of submarine volcanic deposits.  Lipari was formed in three major eruptive cycles, the first of which took place from about 223 to 188 thousand years ago (ka) from N-S-trending fissures on the western side of the island.  The second eruptive period from about 102 to 53 ka included the formation of the Monte San Angelo and Costa d'Agosto stratovolcanoes in the center of the island.  The third eruptive cycle (40 ka to the present) included the Monte Guardia sequence, erupted at the southern tip of the island between about 22,600 and 16,800 years ago, and Holocene rhyolitic pyroclastic deposits and obsidian lava flows at the NE end of the island.  The latest eruption, at Monte Pilato on the NE tip of the island, formed the Rocche Rosse and Forgia Vecchia obsidian lava flows, which have been dated variously from about 500 to 1230 AD.  Objects made of obsidian from Lipari have been found throughout southern Italy.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0101-042&amp;volpage=photos&amp;photo=015035">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0101-042">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ct.ingv.it/">INGV Catania Section</a></td><td width="33%"><a href="http://www.ingv.it/">Istituto Nazionale di Geofisica e Vulcanologia</a></td></tr></table>	(38.479999999999997,14.949999999999999)
13	Vulcano	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Vulcano</b></font><br /><font size="5"><b>Aeolian Islands (Italy)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/015041.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 500 m<br /><b>Latitude:</b> 38.404&deg;N<br /><b>Longitude:</b> 14.962&deg;E</td></tr><tr><td colspan="2"><p align="justify">The word volcano is derived from Vulcano stratovolcano in Italy's Aeolian Islands.  Vulcano was constructed during six volcanic stages during the past 136,000 years.  Two overlapping calderas, the 2.5-km-wide Caldera del Piano on the SE and the 4-km-wide Caldera della Fossa on the NW, were formed at about 100,000 and 24,000-15,000 years ago, respectively, and volcanism has migrated to the north over time.  La Fossa cone, active throughout the Holocene and the location of most of the historical eruptions of Vulcano, occupies the 3-km-wide Caldera della Fossa at the  NW end of the elongated, 3 x 7 km island.  The Vulcanello lava platform forms a low, roughly circular peninsula on the northern tip of Vulcano that was formed as an island beginning in 183 BC and was connected to Vulcano in about 1550 AD.  Vulcanello is capped by three pyroclastic cones and was active intermittently until the 16th century.  The latest eruption from Vulcano consisted of explosive activity from the Fossa cone from 1898 to 1900.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0101-05=&amp;volpage=photos&amp;photo=015041">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0101-05=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ct.ingv.it/">INGV Catania Section</a></td><td width="33%"><a href="http://www.ingv.it/">Istituto Nazionale di Geofisica e Vulcanologia</a></td></tr></table>	(38.404000000000003,14.962)
14	Etna	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Etna</b></font><br /><font size="5"><b>Sicily (Italy)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/015052.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3330 m<br /><b>Latitude:</b> 37.734&deg;N<br /><b>Longitude:</b> 15.004&deg;E</td></tr><tr><td colspan="2"><p align="justify">Mount Etna, towering above Catania, Sicily's second largest city, has one of the world's longest documented records of historical volcanism, dating back to 1500 BC.  Historical lava flows of basaltic composition cover much of the surface of this massive volcano, whose edifice is the highest and most voluminous in Italy.  The Mongibello stratovolcano, truncated by several small calderas, was constructed during the late Pleistocene and Holocene over an older shield volcano. The most prominent morphological feature of Etna is the Valle del Bove, a 5 x 10 km horseshoe-shaped caldera open to the east.  Two styles of eruptive activity typically occur at Etna.  Persistent explosive eruptions, sometimes with minor lava emissions, take place from one or more of the three prominent summit craters, the Central Crater, NE Crater, and SE Crater (the latter formed in 1978).  Flank vents, typically with higher effusion rates, are less frequently active and originate from fissures that open progressively downward from near the summit (usually accompanied by strombolian eruptions at the upper end).  Cinder cones are commonly constructed over the vents of lower-flank lava flows.  Lava flows extend to the foot of the volcano on all sides and have reached the sea over a broad area on the SE flank.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0101-06=&amp;volpage=photos&amp;photo=015052">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0101-06=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ct.ingv.it/">INGV Catania Section</a></td><td width="33%"><a href="http://www.ingv.it/">Istituto Nazionale di Geofisica e Vulcanologia</a></td></tr></table>	(37.734000000000002,15.004)
15	Campi Flegrei Mar Sicilia	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Campi Flegrei Mar Sicilia</b></font><br /><font size="5"><b>Italy</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/000099.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcanoes</td><td width="50%" align="left"><b>Summit Elev:</b> -8 m<br /><b>Latitude:</b> 37.10&deg;N<br /><b>Longitude:</b> 12.70&deg;E</td></tr><tr><td colspan="2"><p align="justify">Campi Flegrei del Mar di Sicilia (Phlegraean Fields of the Sicily Sea) is composed of a group of submarine volcanoes SW of Sicily.  The volcanoes were constructed within a submarine depression about 1000 m deep in the Strait of Sicily between the SW coast of Sicily and the NE tip of Tunisia, forming submarine banks that are capped by cones that rise to near sea level.  Submarine eruptions were reported at the Giulia-Ferdinandeo and Pinne banks during the first Punic war (264-241 BC), and from the 17th to 20th centuries, sometimes producing ephemeral islands.  The 1831 eruption at Graham Island (also known as Graham Bank, Giulia-Ferdinandeo Bank,  or Ferdinandea Bank) produced an ephemeral island that was promptly claimed by the navies of France, Britain, Spain, and Italy.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0101-07=&amp;volpage=photos&amp;photo=000099">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0101-07=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ct.ingv.it/">INGV Catania Section</a></td><td width="33%"><a href="http://www.ingv.it/">Istituto Nazionale di Geofisica e Vulcanologia</a></td></tr></table>	(37.100000000000001,12.699999999999999)
16	Pantelleria	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Pantelleria</b></font><br /><font size="5"><b>Italy</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/115002.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 836 m<br /><b>Latitude:</b> 36.77&deg;N<br /><b>Longitude:</b> 12.02&deg;E</td></tr><tr><td colspan="2"><p align="justify">The island of Pantelleria is constructed above a drowned continental rift in the Strait of Sicily and has been the locus of intensive volcano-tectonic activity.  Two large Pleistocene calderas dominate the island, which contains numerous post-caldera lava domes and cinder cones and is the type locality for peralkaline rhyolitic rocks, pantellerites.  The 15-km-long island is the emergent summit of a largely submarine edifice.  The 6-km-wide Cinque Denti caldera, the youngest of the two calderas, formed about 45,000 years ago and contains the two post-caldera shield volcanoes of Monte Grande and Monte Gibele.  Holocene eruptions have constructed pumice cones, lava domes, and short, blocky lava flows.  Many Holocene vents are located on three sides of the uplifted Montagna Grande block on the SE side of the island.  A submarine eruption in 1891 from a vent off the NW coast is the only confirmed historical activity.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0101-071&amp;volpage=photos&amp;photo=115002">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0101-071">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ct.ingv.it/">INGV Catania Section</a></td><td width="33%"><a href="http://www.ingv.it/">Istituto Nazionale di Geofisica e Vulcanologia</a></td></tr></table>	(36.770000000000003,12.02)
17	Methana	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Methana</b></font><br /><font size="5"><b>Greece</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/088009.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 760 m<br /><b>Latitude:</b> 37.615&deg;N<br /><b>Longitude:</b> 23.336&deg;E</td></tr><tr><td colspan="2"><p align="justify">Methana volcano consists of a basaltic-andesite to rhyodacitic lava dome complex forming the Methana Peninsula in the Sarronian Gulf on the NE side of  Peloponnesus.  Potassium-Argon ages for the older part of the complex range from 900,000 to 550,000 years, although activity may have begun during the late Pliocene.  A younger phase of activity took place from about 380,000-290,000 years ago, forming a series of lava domes and flows.  The youngest dome, Kameno Vouno, on the NW side of the peninsula, was formed in the 3rd century BC and produced a lava flow that traveled 500 m beyond the coastline.  Hot springs are found at several locations along the coast of the peninsula.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0102-02=&amp;volpage=photos&amp;photo=088009">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0102-02=">Smithsonian Volcano Information</a></td></tr></table>	(37.615000000000002,23.335999999999999)
18	Mlos	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mlos</b></font><br /><font size="5"><b>Greece</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/088015.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Tuff rings</td><td width="50%" align="left"><b>Summit Elev:</b> 751 m<br /><b>Latitude:</b> 36.699&deg;N<br /><b>Longitude:</b> 24.439&deg;E</td></tr><tr><td colspan="2"><p align="justify">Mlos and adjacent small islands have grown from submarine and subaerial volcanism that initially was dominantly andesitic and basaltic, but ended with predominately rhyolitic eruptions.  The oldest volcanic rocks are Pliocene submarine rhyolitic pyroclastic-flow deposits overlying basement metamorphic and sedimentary rocks.  The latest activity during the late Pleistocene was concentrated in the eastern half of the low, U-shaped Mlos Island, forming lava domes and phreatic explosion craters, and on Antimlos Island to the NW, where a composite volcano was constructed.  The youngest magmatic eruptions took place about 90,000 years ago, but phreatic explosions, commonly producing overlapping craters rarely more than 1 km in diameter, continued from late-Pleistocene to Recent times.  A lahar deposit in SE Mlos, east of Fyriplaka tuff ring, buried walls of a Roman harbor town and overlies a coarse ash layer, and was considered to originate from a small phreatic explosion through basement rocks.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0102-03=&amp;volpage=photos&amp;photo=088015">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0102-03=">Smithsonian Volcano Information</a></td></tr></table>	(36.698999999999998,24.439)
19	Santorini	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Santorini</b></font><br /><font size="5"><b>Greece</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/001006.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 367 m<br /><b>Latitude:</b> 36.404&deg;N<br /><b>Longitude:</b> 25.396&deg;E</td></tr><tr><td colspan="2"><p align="justify">Renowned Santorini (Thera), with its steep-walled caldera rim draped by whitewashed villages overlooking an active volcanic island in the center of a caldera bay, is one of the scenic highlights of the Aegean.  The circular island group is composed of overlapping shield volcanoes cut by at least four partially overlapping calderas.  The oldest southern caldera was formed about 180,000 years before present (BP), followed by the Skaros caldera about 70,000 years BP, and then the Cape Riva caldera about 21,000 years BP.  The youngest caldera formed about 3600 years BP during the Late-Bronze-Age Minoan eruption  that forced abandonment of the thriving Aegean Sea island.  Post-Minoan eruptions beginning in 197 BC constructed a series of lava domes and flows that form two islands near the center of the caldera.  A submarine eruption took place in 1650 AD outside the caldera NE of Thera.  The latest eruption at Santorini produced a small lava dome and flow in 1950, accompanied by explosive activity.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0102-04=&amp;volpage=photos&amp;photo=001006">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0102-04=">Smithsonian Volcano Information</a></td></tr></table>	(36.404000000000003,25.396000000000001)
20	Nisyros	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Nisyros</b></font><br /><font size="5"><b>Greece</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/089100.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 698 m<br /><b>Latitude:</b> 36.586&deg;N<br /><b>Longitude:</b> 27.160&deg;E</td></tr><tr><td colspan="2"><p align="justify">The easternmost volcano of the Aegean arc forms the 9-km-wide island of Nisyros, which is truncated by a 3-4 km wide caldera.  The island was constructed during the past 150,000 years, with three cone-building stages including explosive and effusive andesitic eruptions and effusive and extrusive dacitic and rhyolitic activity.  The age of the caldera is variously considered to be &lt;24,000 years before present (BP) (Keller et al., 1990) and &gt;44,000 years BP (Limburg and Varekamp, 1991).  Five large post-caldera lava domes completely fill the western part of the caldera.  The NE-most (Boriatiko) and SW-most (Karaviotis) lava domes and flows are significantly younger than the other domes.  A sixth post-caldera dome, outside the SW caldera rim, produced lava flows that reached the coast.  Historical phreatic eruptions occurred from craters within the caldera between 1422 and 1888.  Intense hydrothermal activity continues in the form of many fumaroles on the caldera floor and hot springs along the coast.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0102-05=&amp;volpage=photos&amp;photo=089100">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0102-05=">Smithsonian Volcano Information</a></td></tr></table>	(36.585999999999999,27.16)
21	Yali	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Yali</b></font><br /><font size="5"><b>Greece</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110097.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 180 m<br /><b>Latitude:</b> 36.671&deg;N<br /><b>Longitude:</b> 27.140&deg;E</td></tr><tr><td colspan="2"><p align="justify">Yali, a small island between the northern coast of Nisyros Island and the SW coast of Kos Island, consists of rhyolitic obsidian domes and pumice deposits.  Yali is located within the inferred location of the large submarine caldera associated with the eruption of the voluminous Kos Plateau Tuff, dated about 160,000 years before present.  This eruption produced extensive ignimbrites that blanket much of the western half of the island of Kos and produced a caldera whose dimensions are uncertain, but which may extend from Kefalos Bay on the SW side of Kos Island to Nisyros Island, south of Yali.  The crescent-shaped island of Yali is oriented NNE-SSW and contains two distinct segments connected by a narrow isthmus formed of modern reef sediments.  The SW part of the island consists primarily of a layered pumice-fall unit about 200 m thick, and the NE part contains rhyolitic obsidian lava flows of similar thickness.  No historical eruptions are known from Yali, but the most recent pumice eruptions of Yali overlie soils containing pottery and Neolithic obsidian artifacts (Keller, 1982).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0102-051&amp;volpage=photos&amp;photo=110097">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0102-051">Smithsonian Volcano Information</a></td></tr></table>	(36.670999999999999,27.140000000000001)
22	Kula	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kula</b></font><br /><font size="5"><b>Western Turkey</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/114057.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 750? m<br /><b>Latitude:</b> 38.58&deg;N<br /><b>Longitude:</b> 28.52&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Kula volcanic field, the westernmost area of young volcanism in Turkey, lies about 450 km WNW of its closest Holocene neighbor in central Turkey, the Karapinar volcanic field.  The Kula field consists of a broad area of Quaternary alkaline basanitic-to-phonotephritic cinder cones and maars erupted along a roughly E-W-trending line SW of the city of Selendi.  Most of the Kula volcanoes are Pleistocene in age, between about 1.1 million and 10,000 years old.  The initial stage produced lava flows from vents along the ring fracture of caldera identified from satellite images.  The second and third stages took place along an E-W-trending graben and produced lava flows with ultramafic xenoliths.  Although activity was considered to have continued until the beginning of the Holocene (Yilmaz, 1990), or almost to historical times (Borsi et al., 1972), the age of the most recent eruption from the Kula field is not known.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0103-00-&amp;volpage=photos&amp;photo=114057">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0103-00-">Smithsonian Volcano Information</a></td></tr></table>	(38.579999999999998,28.52)
23	Karapinar Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Karapinar Field</b></font><br /><font size="5"><b>Central Turkey</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/101044.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 1302 m<br /><b>Latitude:</b> 37.67&deg;N<br /><b>Longitude:</b> 33.65&deg;E</td></tr><tr><td colspan="2"><p align="justify">The basaltic Karapinar volcanic field is comprised of five cinder cones, two lava fields and several explosion craters and maars located on the Konya-Eregli plain SW of the Karacadag stratovolcano.  The 300-m-high Meke Dagi is one of the largest cinder cones in Central Anatolia.  The explosion craters and maars are located along a SW-NE line consistent with the elongation of Karacadag volcano.  The maars evolved from hyaloclastite tuff rings to maars to cinder cones, reflecting varying lake water levels during the eruption.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0103-001&amp;volpage=photos&amp;photo=101044">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0103-001">Smithsonian Volcano Information</a></td></tr></table>	(37.670000000000002,33.649999999999999)
24	Hasan Dagi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hasan Dagi</b></font><br /><font size="5"><b>Central Turkey</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/015075.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 3253 m<br /><b>Latitude:</b> 38.13&deg;N<br /><b>Longitude:</b> 34.17&deg;E</td></tr><tr><td colspan="2"><p align="justify">The massive double-peaked stratovolcano Hasan Dagi in Central Anatolia has undergone four episodes of caldera collapse, the latest of which formed a 4-5 km wide caldera at the summit.  The modern edifice is the youngest of four major basaltic-to-rhyolitic volcanic complexes dating back to the mid Miocene and was constructed within the latest caldera.  Andesitic-to-dacitic lava domes form the two principal summits, of which the westernmost is the highest and is capped by two nested craters.  Lava domes and associated pyroclastic-flow deposits blanket more than half the flanks of the Mount Hasan volcanic complex.  A group of more than 25 Quaternary cinder cones, maars, and lava flows dot the plains surrounding Hasan Dagi.  Interpretations of neolithic paintings representing eruptions from Hasan Dagi are controversial, but geologic evidence supports eruptive activity continuing into the Holocene.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0103-002&amp;volpage=photos&amp;photo=015075">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0103-002">Smithsonian Volcano Information</a></td></tr></table>	(38.130000000000003,34.170000000000002)
25	Acigl-Nevsehir	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Acigl-Nevsehir</b></font><br /><font size="5"><b>Central Turkey</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/115004.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Maars<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1689 m<br /><b>Latitude:</b> 38.57&deg;N<br /><b>Longitude:</b> 34.52&deg;E</td></tr><tr><td colspan="2"><p align="justify">Acigl-Nevsehir caldera is located in central Turkey and is traversed by the national highway between the towns of Acigl and Nevsehir.  The elliptical 7 x 8 km wide late-Pleistocene caldera is part of a now partially buried larger caldera and contains a group of maars, lava domes, basaltic lava flows, and pyroclastic cones.  Three groups of obsidian lava flows have been dated; pre-collapse flows between about 190,000 and 180,000 years before present (BP), 75,000 yrs BP lava domes (such as Taskesik Tepe on the eastern side of the caldera) post-dating formation of the Acigl-Nevsehir caldera, and young lava domes on the western caldera floor about 20,000 to 15,000 years old.  Thirteen scoria layers from local tephras erupted between about 11,000 and 4300 years ago were found in sediment cores in the late Pleistocene Eski Acigl maar.  An ash layer from the Acigl-Nevsehir volcanic group overlies 2300-1850 BC artifacts of Roman-Cappadocian age.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0103-004&amp;volpage=photos&amp;photo=115004">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0103-004">Smithsonian Volcano Information</a></td></tr></table>	(38.57,34.520000000000003)
26	Erciyes Dagi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Erciyes Dagi</b></font><br /><font size="5"><b>Central Turkey</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/015074.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3916 m<br /><b>Latitude:</b> 38.52&deg;N<br /><b>Longitude:</b> 35.48&deg;E</td></tr><tr><td colspan="2"><p align="justify">The massive, eroded stratovolcano Erciyes Dagi at the northern end of the Sultansazligi Basin in central Anatolia covers an area of about 1300 sq km.  Growth of the modern volcano began about 0.9 million years ago, following Pliocene caldera collapse of the Kocdag complex.  Numerous parasitic cones and lava domes are found mostly on the north flank of the modern edifice, many along radial fissures.  The youngest dated rock was from an 83,000-year-old dacitic lava flow, but rhyodacitic eruptions and lava dome growth occurred later at the Perikartin dome.  One of the latest documented events was an edifice collapse that produced a large debris avalanche that extended to the east.  An early Holocene distal tephra layer in Lebanon was attributed to Erciyes Dagi.  Uncertainty remains regarding reported historical eruptions of Erciyes Dagi and their possible depiction on Roman Cappadocian coins.  Historical accounts possibly referring to eruptions could also be attributed to methane releases from a swamp in the Sultansazligi Basin.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0103-01=&amp;volpage=photos&amp;photo=015074">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0103-01=">Smithsonian Volcano Information</a></td></tr></table>	(38.520000000000003,35.479999999999997)
27	Karaca Dag	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Karaca Dag</b></font><br /><font size="5"><b>Eastern Turkey</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 1957 m<br /><b>Latitude:</b> 37.67&deg;N<br /><b>Longitude:</b> 39.83&deg;E</td></tr><tr><td colspan="2"><p align="justify">Karaca Dag (also known as Karacalidag) is a broad, 1957-m-high basaltic shield volcano in SE Turkey about 100 km north of the Syrian border.  The volcano lies on the Arabian foreland about 150 km SW of the boundary with the Anatolian Plate and has been active since the Pliocene along a N-S-trending set of fissures and craters associated with the nearby Akcakale graben.  Potassium-Argon dates of mid-Pleistocene age have been obtained from Karaca Dag lava flows, but Landsat imagery suggests that some lava flows, particularly those on the east flank, may perhaps be only a few thousand years old (Pearce et al., 1990).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0103-011">Smithsonian Volcano Information</a></td></tr></table>	(37.670000000000002,39.829999999999998)
28	Nemrut Dagi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Nemrut Dagi</b></font><br /><font size="5"><b>Eastern Turkey</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104036.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2948 m<br /><b>Latitude:</b> 38.65&deg;N<br /><b>Longitude:</b> 42.23&deg;E</td></tr><tr><td colspan="2"><p align="justify">Nemrut Dagi is the westernmost of a group of volcanoes near Lake Van in eastern Anatolia and the only one that has erupted in historical time.  Nemrut Dagi contains a 9 x 5 km caldera partially filled on its western side by a caldera lake.  Post-caldera volcanism, of basaltic to rhyolitic composition, initially occurred along the caldera rim and floor.  Pyroclastic flows and the emission of glassy obsidian lava flows accompanied construction of lava domes within the caldera; later activity formed a series of cinder cones and lava domes erupted along N-S-trending fissures on the northern flank.  The most recent activity has been concentrated along a NNW-trending fissure cutting the eastern caldera floor and extending beyond the north caldera rim; nearly two dozen cinder cones and lava domes were constructed on the caldera floor.  Ash layers in Lake Van document numerous Holocene eruptions, and an historical eruption in 1441 AD from a north-flank fissure involved compositionally bimodal lava flows.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0103-02=&amp;volpage=photos&amp;photo=104036">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0103-02=">Smithsonian Volcano Information</a></td></tr></table>	(38.649999999999999,42.229999999999997)
29	Sphan Dagi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sphan Dagi</b></font><br /><font size="5"><b>Eastern Turkey</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119093.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 4158 m<br /><b>Latitude:</b> 38.92&deg;N<br /><b>Longitude:</b> 42.82&deg;E</td></tr><tr><td colspan="2"><p align="justify">Sphan Dagi is a 4158-m-high basaltic-to-rhyolitic stratovolcano located immediately north of Lake Van.  A glacial icecap mantles the summit of the volcano, the 2nd highest in Turkey.  During construction of the volcano andesitic-dacitic lava flows alternated with fluid basaltic flows, followed by construction of a large lava dome over the central vent.  The flanks of the volcano are dotted with numerous lava domes and pyroclastic cones erupted along radial and circumferential fissures, particularly on the northern, souther, and eastern sides.  The 1.5-km-wide, low-rimmed Aygirgl maar was erupted on the lower southern flank.  During the latest stage of activity, voluminous basaltic lava flows traveled as far as 30 km from the summit.  Potassium-Argon dates for Sphan Dagi range from 2 to about 0.1 million years, but the latest basaltic eruption occurred about 10,000 years ago (Yilmaz et al., 1998).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0103-021&amp;volpage=photos&amp;photo=119093">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0103-021">Smithsonian Volcano Information</a></td></tr></table>	(38.920000000000002,42.82)
30	Girekol	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Girekol</b></font><br /><font size="5"><b>Eastern Turkey</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Unknown</td><td width="50%" align="left"><b>Latitude:</b> 39.17&deg;N<br /><b>Longitude:</b> 43.33&deg;E</td></tr><tr><td colspan="2"><p align="justify">Girekol is a Pleistocene-to-Holocene calc-alkaline to alkaline volcanic center located directly north of the NE arm of Lake Van in eastern Anatolia (Yilmaz, 1990).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0103-022">Smithsonian Volcano Information</a></td></tr></table>	(39.170000000000002,43.329999999999998)
31	Tendrek Dagi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tendrek Dagi</b></font><br /><font size="5"><b>Eastern Turkey</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117056.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3584 m<br /><b>Latitude:</b> 39.37&deg;N<br /><b>Longitude:</b> 43.87&deg;E</td></tr><tr><td colspan="2"><p align="justify">Tendrek Dagi, also known as Tendrk Dagi, is an elongated shield volcano that rises 1800 m above the plain of Dogubayazit, near the Iranian border, south of Mount Ararat.   An E-W-trending summit ridge, developed north of an arcuate caldera structure exposed only on the southern side, contains two well-developed cones.  The higher western cone is capped by a steep-walled crater with a trachytic spine at its eastern edge.  The flatter eastern crater contains a warm lake.   The shield volcano developed during a period when highly mobile lava flows from the western crater covered an area of 500 sq km.  Following summit caldera formation, numerous flank eruptions took place from N-S-trending fissures, producing viscous trachytic lava domes and flows as well as fluid basaltic pahoehoe flows that extend 10-20 km to the north and south.  The latest activity formed two major basaltic lava flows from large cones on the NE and SE flanks.  An eruption took place from a vent on the SE flank about 2500 years ago, and a gas-and-ash eruption took place in 1855.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0103-03=&amp;volpage=photos&amp;photo=117056">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0103-03=">Smithsonian Volcano Information</a></td></tr></table>	(39.369999999999997,43.869999999999997)
32	Ararat	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ararat</b></font><br /><font size="5"><b>Eastern Turkey</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120038.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 5165 m<br /><b>Latitude:</b> 39.70&deg;N<br /><b>Longitude:</b> 44.30&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 5165-m-high, double-peaked stratovolcano Mount Ararat, also known as Agri Dagi, is Turkey's highest, largest volume, and easternmost volcano.  Glacier-clad Ararat, along with its twin volcano, 3925-m-high Kucuk Ararat (or Lesser Ararat), covers an area of 1000 sq km at the eastern end of a SSW-ESE line of volcanoes extending from Nemrut Dagi.  Construction of the Greater and Lesser Ararat volcanoes was followed by a period of extensive flank eruptions, many erupted along N-S-trending fissures.  The initial stage of flank eruptions produced a cluster of cinder cones and dacitic-rhyolitic lava domes surrounding Greater Ararat and a series of pyroclastic cones and domes on the western flank of Lesser Ararat.  Late-stage activity formed large pyroclastic cones lower on the flanks of the two volcanoes.  Ararat appears to have been active during the 3rd millennium BC; pyroclastic-flow deposits overlie early Bronze Age artifacts and human remains.   Karakhanian et al. (2002) reported historical evidence for a phreatic eruption and pyroclastic flow at the time of a July 1840 earthquake and landslide.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0103-04-&amp;volpage=photos&amp;photo=120038">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0103-04-">Smithsonian Volcano Information</a></td></tr></table>	(39.700000000000003,44.299999999999997)
33	Elbrus	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Elbrus</b></font><br /><font size="5"><b>Southwestern Russia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/102077.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 5633 m<br /><b>Latitude:</b> 43.33&deg;N<br /><b>Longitude:</b> 42.45&deg;E</td></tr><tr><td colspan="2"><p align="justify">Elbrus, the highest peak of the Caucasus Mountains of SW Russia, is a large glaciated stratovolcano with twin summits.  The 5595-m-high eastern summit has a 250-m-wide, well-preserved crater, separated by a low saddle from the 5633-m-high western summit.  Products of Mount Elbrus cover 260 sq km; its longest lava flow traveled 24 km down the NNE flank.  The most recent lava flows from Elbrus are fresh-looking, and the latest eruptions took place during the Holocene (Catalog of Active Volcanoes of the World).  Weak solfataric activity near the summit continues, and hot springs are present on the volcano's flanks.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0104-01-&amp;volpage=photos&amp;photo=102077">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0104-01-">Smithsonian Volcano Information</a></td></tr></table>	(43.329999999999998,42.450000000000003)
34	Kasbek	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kasbek</b></font><br /><font size="5"><b>Georgia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/102075.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 5050 m<br /><b>Latitude:</b> 42.70&deg;N<br /><b>Longitude:</b> 44.50&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 5050-m-high, glacier-covered Kasbek stratovolcano in the Caucasus Mountains of Georgia, just south of the border with Russia, has produced long lava flows down flank valleys.  Next to Mount Elbrus, Kasbek is the highest volcano in Caucasus Mountains.  The summit cone and the latest lava flows are of postglacial age, and the latest andesitic-dacitic lava flow was radiocarbon dated at about 6000 years ago.  Gushchenko (1979) listed an 800-700 BC eruption from Kasbek.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0104-02-&amp;volpage=photos&amp;photo=102075">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0104-02-">Smithsonian Volcano Information</a></td></tr></table>	(42.700000000000003,44.5)
35	Kabargin Oth Group	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kabargin Oth Group</b></font><br /><font size="5"><b>Georgia</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 3650 m<br /><b>Latitude:</b> 42.55&deg;N<br /><b>Longitude:</b> 44.00&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Kabargin Oth volcano group consists of a dozen andesitic-to-dacitic cinder cones and lava domes of lower-Pleistocene to Holocene age.  These volcanoes were constructed near the Georgia-Russia border SW of Kasbek volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0104-03-">Smithsonian Volcano Information</a></td></tr></table>	(42.549999999999997,44)
36	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>Georgia</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3750 m<br /><b>Latitude:</b> 42.45&deg;N<br /><b>Longitude:</b> 44.25&deg;E</td></tr><tr><td colspan="2"><p align="justify">An unnamed group of five early Pleistocene to Holocene andesitic-to-dacitic cinder cones and lava cones is located in northern Georgia SW of Kasbek volcano and SE of the Karbagin Oth volcano group.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0104-04-">Smithsonian Volcano Information</a></td></tr></table>	(42.450000000000003,44.25)
37	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>Georgia</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3400 m<br /><b>Latitude:</b> 41.55&deg;N<br /><b>Longitude:</b> 43.60&deg;E</td></tr><tr><td colspan="2"><p align="justify">An unnamed group of seven early Pleistocene to Holocene lava cones is located in the Obul-Samarask upland of southern Georgia.  The volcanic cones are located SW of the capital city of Tbilisi, near the borders with Turkey and Armenia.  Many of the craters have well-preserved morphologies.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0104-05-">Smithsonian Volcano Information</a></td></tr></table>	(41.549999999999997,43.600000000000001)
38	Aragats	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Aragats</b></font><br /><font size="5"><b>Armenia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/101041.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 4095 m<br /><b>Latitude:</b> 40.53&deg;N<br /><b>Longitude:</b> 44.20&deg;E</td></tr><tr><td colspan="2"><p align="justify">Aragats is a large andesitic-to-dacitic stratovolcano in NW Armenia about 40 km NW of the capital city of Yerevan.  The 4095-m-high main edifice of Aragats is dissected by glaciers and is of Pliocene-to-Pleistocene age.  Satellitic cones and fissures are located on all sides of the volcano and were the source of large lava flows that descended its lower flanks.  Several of these were considered to be of Holocene age, but later Potassium-Argon dating indicated mid- to late-Pleistocene ages.  The youngest lower-flank flows have not been precisely dated, but are constrained as occurring between the end of the late-Pleistocene and 3000 BC (Kharakanian et al., 2003).  A 13-km-long, WSW-ENE-trending line of craters and pyroclastic cones cuts across the northern crater rim and is the source of young lava flows and lahars; the latter were considered to be characteristic of Holocene summit eruptions.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0104-06-&amp;volpage=photos&amp;photo=101041">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0104-06-">Smithsonian Volcano Information</a></td></tr></table>	(40.530000000000001,44.200000000000003)
39	Ghegam Ridge	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ghegam Ridge</b></font><br /><font size="5"><b>Armenia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111005.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 3597 m<br /><b>Latitude:</b> 40.275&deg;N<br /><b>Longitude:</b> 44.75&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Ghegam Ridge, located in west-central Armenia between the capital city of Yerevan and Lake Sevan, contains a broad concentration of lava domes and pyroclastic cones of Pleistocene-to-Holocene age.  The volcanoes and associated lava flows cover a 65-km-long, 35-km-wide area west of Lake Sevan and south of the Hrazdan River and are concentrated along 3 NNW-SSE-trending alignments.  Lava flows from the central and eastern clusters flowed into Lake Sevan.  Initial explosive eruptions at the Ghegam Ridge volcanic field were followed by the extrusion of rhyolitic obsidian lava domes and flows.  The latest activity produced a series of andesitic and basaltic-andesite cinder cones and lava flows.  The central and eastern portions of the Ghegam Ridge contains large areas of Holocene eruptions with morphologically fresh lava flows devoid of vegetation.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0104-07-&amp;volpage=photos&amp;photo=111005">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0104-07-">Smithsonian Volcano Information</a></td></tr></table>	(40.274999999999999,44.75)
40	Dar-Alages	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Dar-Alages</b></font><br /><font size="5"><b>Armenia</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3329 m<br /><b>Latitude:</b> 39.70&deg;N<br /><b>Longitude:</b> 45.542&deg;E</td></tr><tr><td colspan="2"><p align="justify">A group of six cinder and lava cones of Pleistocene-to-Holocene age is located in southern Armenia on the western slopes of the Vardeniss volcanic ridge, south of Lake Sevan.  The andesitic Dar-Alages volcano, also known as Daly-Tapa, formed in postglacial times (Sviatlovsky, 1959).  The Vaiyots-Sar and Smbatassar pyroclastic cones of Holocene age (Karakhanian et al., 2002) are located in this part of the Vardeniss volcanic ridge.  Vaiyots-Sar volcano lies just north of the major Areni-Zanghezour Fault, near the town of Vaik, and produced a fissure-fed lava flow several thousand years ago that dammed the Arpah River and flowed to the west for 6 km.  The youthful-looking Smbatassar cinder cone is located 17 km to the NW and produced lava flows that traveled 11 and 17 km north and south, respectively.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0104-08-">Smithsonian Volcano Information</a></td></tr></table>	(39.700000000000003,45.542000000000002)
41	Porak	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Porak</b></font><br /><font size="5"><b>Armenia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/112036.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2800 m<br /><b>Latitude:</b> 40.02&deg;N<br /><b>Longitude:</b> 45.78&deg;E</td></tr><tr><td colspan="2"><p align="justify">The mid-Pleistocene Porak volcano lies in the Vardeniss volcanic ridge about 20 km SE of Lake Sevan.  The volcanic field straddles the Armenia/Azerbaijan border, and lava flows extend into both countries.  The flanks of the volcano are dotted with 10 satellitic cones and fissure vents.  Porak volcano was constructed along the active Pambak-Sevan strike-slip fault, which has bisected the mid-Pleistocene Khonarassar volcano, separating its two halves by about 800 m.  Two large lava flows from Porak volcano traveled up to 21 km north and NW, and fresh-looking lava flows form peninsulas extending into Lake Alagyol.  Fifth century BC petroglyphs were interpreted to depict volcanic eruptions (Karakhanian et al., 2002).  Porak volcano is referred to in a famous cuneiform inscription as Mount Bamni, and stratigraphic and archeological evidence indicates that an explosive eruption also producing a lava flow occurred at the time of a military battle dated to 782-773 BC.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0104-09-&amp;volpage=photos&amp;photo=112036">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0104-09-">Smithsonian Volcano Information</a></td></tr></table>	(40.020000000000003,45.780000000000001)
42	Tskhouk-Karckar	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tskhouk-Karckar</b></font><br /><font size="5"><b>Armenia</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3000? m<br /><b>Latitude:</b> 39.73&deg;N<br /><b>Longitude:</b> 46.02&deg;E</td></tr><tr><td colspan="2"><p align="justify">A group of pyroclastic cones is located in the central part of the Siunik volcanic ridge along the Armenia/Azerbaijan border about 60 km SE of Lake Sevan.  The Tskhouk-Karckar volcano group was constructed within offset segments of the major Pambak-Sevan strike-slip fault trending SE from Lake Sevan.  Eight pyroclastic cones produced three generations of Holocene lava flows (Karakhanian et al., 2002).  Abundant petroglyphs, burial kurgans, and masonry walls were found on flows of the older two age groups, but not on the youngest.  Lava flows from cinder cones of the Tskhouk-Karckar volcano group overlie petroglyphs dated to the end of the 4th millennium and beginning of the 3rd millennium BC and are themselves used in gravesites dated at 4720 +/- 140 yrs ago.  Following these eruptions, the area was not repopulated until the Middle Ages.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0104-10-">Smithsonian Volcano Information</a></td></tr></table>	(39.729999999999997,46.020000000000003)
43	Jebel at Tair	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Jebel at Tair</b></font><br /><font size="5"><b>Yemen</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119001.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 244 m<br /><b>Latitude:</b> 15.55&deg;N<br /><b>Longitude:</b> 41.83&deg;E</td></tr><tr><td colspan="2"><p align="justify">The basaltic Jebel at Tair volcano rises from a 1200 m depth in the south-central Red Sea, forming an oval-shaped island about 3 km long.  Jebel at Tair (one of many variations of the name, including Djebel Teyr, Jabal al Tayr, and Jibbel Tir ) is the northernmost known Holocene volcano in the Red Sea and lies SW of the Farisan Islands.  Youthful basaltic pahoehoe lava flows from the steep-sided central vent, Jebel Duchan, cover most of the island.  They drape a circular cliff cut by wave erosion of an older edifice and extend beyond it to form a flat coastal plain.  Pyroclastic cones are located along the NW and southern coasts, and fumarolic activity occurs from two uneroded scoria cones at the summit.  Radial fissures extend from the summit, some of which were the sources of lava flows.  The island is of Holocene age, and explosive eruptions were reported in the 18th and 19th centuries.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-01=&amp;volpage=photos&amp;photo=119001">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-01=">Smithsonian Volcano Information</a></td></tr></table>	(15.550000000000001,41.829999999999998)
44	Jebel Zubair	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Jebel Zubair</b></font><br /><font size="5"><b>Yemen</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117024.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Soria cones<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 191 m<br /><b>Latitude:</b> 15.05&deg;N<br /><b>Longitude:</b> 42.18&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 5-km-long Jebel Zubair Island is the largest of a group of 10 small islands and submerged shoals that rise from a shallow platform in the Red Sea rift.  The platform and eruptive vents forming the islands and shoals are oriented NNW-SSE, parallel to the rift.  An early explosive phase was followed by a brief period of marine erosion, and then by renewed explosive activity accompanied by the extrusion of basaltic pahoehoe lava flows.  This latest phase of activity occurred on the morphologically youngest islands of Zubair, Centre Peak, Saba, and Haycock.  Historical explosive activity was reported from Saddle Island in the 19th century.  Spatter cones and pyroclastic cones were erupted along fissures that form the low spine of Zubair Island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-02=&amp;volpage=photos&amp;photo=117024">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-02=">Smithsonian Volcano Information</a></td></tr></table>	(15.050000000000001,42.18)
45	Zukur	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Zukur</b></font><br /><font size="5"><b>Yemen</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117022.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 624 m<br /><b>Latitude:</b> 14.02&deg;N<br /><b>Longitude:</b> 42.75&deg;E</td></tr><tr><td colspan="2"><p align="justify">Zukur (Zugar), the northernmost large island of the Zukur-Hanish island group in the southern Red Sea, is formed of Holocene basaltic pyroclastic cones and spatter cones that issued youthful-looking pahoehoe lava flows.  This island group, in contrast to other Red Sea islands such as Jebel at Tair or the Zubair Islands, lies in shallow waters south of the Red Sea median trough.  Products of phreatic eruptions at Zukur form small islands and coastal cones.  Late-stage trachytic lava domes produced viscous lava flows.  Vents on Zukur are aligned along a NE-SW trend.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-021&amp;volpage=photos&amp;photo=117022">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-021">Smithsonian Volcano Information</a></td></tr></table>	(14.02,42.75)
46	Hanish	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hanish</b></font><br /><font size="5"><b>Yemen</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117023.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 422 m<br /><b>Latitude:</b> 13.72&deg;N<br /><b>Longitude:</b> 42.73&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Hanish Islands are formed from a series of volcanic vents along a NE-SW trend, and include the Holocene Great Hanish, Little Hanish, and many other small islands and submarine shoals.  The Zukur-Hanish island group, in contrast to other Red Sea islands such as Jebel at Tair or the Zubair Islands, lies in shallow waters south of the Red Sea median trough. Spatter cones, cinder cones, and ash cones line the crest of the 20-km-long Great Hanish island.  Short lava flows reach the coast on both sides of the island.  As with the Zukur group to the north, initial eruptions were phreatic.  Subsequently basaltic cinder cones were formed, and spatter cones produced fluid lava flows.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-022&amp;volpage=photos&amp;photo=117023">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-022">Smithsonian Volcano Information</a></td></tr></table>	(13.720000000000001,42.729999999999997)
47	Jalua	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Jalua</b></font><br /><font size="5"><b>Eritrea</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111078.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 713 m<br /><b>Latitude:</b> 15.042&deg;N<br /><b>Longitude:</b> 39.82&deg;E</td></tr><tr><td colspan="2"><p align="justify">Jalua, the northernmost volcano in the Eritrea/Ethiopia area, occupies an isolated location in the arid Danakil depression.  It contains a large, central volcanotectonic depression that is open to the Zula Gulf and an isolated central cone.  Jalua lies NW of basaltic lava flows of the Alid graben and south of the Zula Gulf.  No historical eruptions are known, although fumarolic activity continues on its western flank.  The nomenclature of volcanic features in the Afar region reflects that of the two dominant ethnic groups, the Afar (on the Ethiopian side) and the Issas (in the SE Afar depression).  Each group has their own names for physiographic features, and consequently more than one name may apply to the same feature.  A similar situation occurs throughout Ethiopia, where names often reflect local politics.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-03=&amp;volpage=photos&amp;photo=111078">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-03=">Smithsonian Volcano Information</a></td></tr></table>	(15.042,39.82)
48	Alid	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Alid</b></font><br /><font size="5"><b>Eritrea</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/059054.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 904 m<br /><b>Latitude:</b> 14.88&deg;N<br /><b>Longitude:</b> 39.92&deg;E</td></tr><tr><td colspan="2"><p align="justify">Alid is an isolated, dissected volcano in the central Danakil depression.  The volcano is elongated in an E-W direction perpendicular to the orientation of the Alid graben.  Alid consists of a structural dome of uplifted sedimentary rocks, capped by basaltic-to-rhyolitic lava flows, that rises 700 m above the graben floor.  Late-stage rhyolitic eruptions during the late Pleistocene ejected rhyolitic pumice.  Steep-sided lava flows drape the flanks of the structural dome, which was produced by intrusion of a silicic magma body.  A 2 x 3 km graben cuts the top of the dome, and the crater that produced the plinian eruption occupies the western third of the summit depression.  Vast lava fields of probable Holocene age originating from fissure vents bank up against the flanks of Alid to the NW and SE.  Small cones and craters that were the source of the flows are localized along NNW-trending fissures.  Fumarolic activity continues from broad areas on the northern summit and flank.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-04=&amp;volpage=photos&amp;photo=059054">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-04=">Smithsonian Volcano Information</a></td></tr></table>	(14.880000000000001,39.920000000000002)
49	Dallol	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Dallol</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/099008.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Explosion craters</td><td width="50%" align="left"><b>Summit Elev:</b> -48 m<br /><b>Latitude:</b> 14.242&deg;N<br /><b>Longitude:</b> 40.30&deg;E</td></tr><tr><td colspan="2"><p align="justify">Numerous phreatic explosion craters dot the Salt Plain NNE of the Erta Ale Range in one of the lowest areas of the desolate Danakil depression.  These craters mark Earth's lowest known subaerial volcanic vents.  The most recent of these craters, Dallol, lies 48 m below sea level and was formed during an eruption in 1926.  Colorful hot brine springs are found in the Dallol area.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-041&amp;volpage=photos&amp;photo=099008">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-041">Smithsonian Volcano Information</a></td></tr></table>	(14.242000000000001,40.299999999999997)
50	Gada Ale	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Gada Ale</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/099005.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 287 m<br /><b>Latitude:</b> 13.975&deg;N<br /><b>Longitude:</b> 40.408&deg;E</td></tr><tr><td colspan="2"><p align="justify">Gada Ale, also known as Kebrit Ale, is the most prominent volcano at the northern end of the Erta Ale Range.  It is formed of interstratified lava flows and hyaloclastites.  Fumarolic activity is continuing, and a small lake filled by boiling mud occupies the crater.  Like other Erta Ale Range volcanoes, Gada Ale is considered to be of Holocene age (Barberi and Varet, 1970).  A fissure on the SE flank has produced spatter cones and a cinder cone; the latter fed lava flows that reach to Lake Bakili.  The symmetrical Catherine tuff ring is located along this same SE trend west of Lake Bakili, and other tuff rings occur on the east side of the lake.  A 2-km-wide salt dome west of Gada Ale has uplifted lava flows as much as 100 m, and the structure of Gada Ale itself also appears to be related to salt diapir uplift.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-05=&amp;volpage=photos&amp;photo=099005">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-05=">Smithsonian Volcano Information</a></td></tr></table>	(13.975,40.408000000000001)
51	Alu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Alu</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120074.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 429 m<br /><b>Latitude:</b> 13.825&deg;N<br /><b>Longitude:</b> 40.508&deg;E</td></tr><tr><td colspan="2"><p align="justify">The summit region of Alu volcano, lying immediately NW of conical Dalaffilla volcano, is an ellipsoidal volcanic horst, elongated in a NNW-SSE direction, and formed primarily of older basaltic lava flows.  Very recent fractures along the axis of the Erta Ale range cut the main volcanic horst of Alu and areas to the SSE.  Major fumarolic activity is located on the numerous parallel faults, some of which have uplifts of 100 m.  Fissure vents west of the horst have fed silicic lava flows, and voluminous youthful basaltic lava flows to the east extend north as far as Lake Bakili.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-06=&amp;volpage=photos&amp;photo=120074">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-06=">Smithsonian Volcano Information</a></td></tr></table>	(13.824999999999999,40.508000000000003)
52	Dalaffilla	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Dalaffilla</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/099007.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 613 m<br /><b>Latitude:</b> 13.792&deg;N<br /><b>Longitude:</b> 40.55&deg;E</td></tr><tr><td colspan="2"><p align="justify">Dalaffilla, also referred to as Gabuli, is a small, but steep-sided conical stratovolcano that rises 300 m above surrounding lava fields SE of Alu volcano.  This morphology, unusual for the Erta Ale Range volcanoes, results from the extrusion of viscous, silicic lava flows with primary slopes up to about 35 degrees.  These silicic flows extend primarily to the east; on the west they are blocked by walls of a horst structure along the crest of the Erta Ale range.  Other basaltic lava flows from regional fissures surround the 613-m-high volcano.  Fumarolic activity occurs in the 100-m-wide summit crater and has weathered surrounding lava flows.  The first historical eruption of Dalaffilla took place in 2008, when lava flows from W and NW flank vents traveled to the NE.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-07=&amp;volpage=photos&amp;photo=099007">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-07=">Smithsonian Volcano Information</a></td></tr></table>	(13.792,40.549999999999997)
53	Borale Ale	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Borale Ale</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/099014.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 668 m<br /><b>Latitude:</b> 13.725&deg;N<br /><b>Longitude:</b> 40.60&deg;E</td></tr><tr><td colspan="2"><p align="justify">Borale Ale is a complex  volcano located near the center of the Erta Ale Range.  The earliest activity formed submarine lava flows partially covered by Quaternary reef deposits.  An embryonic shield volcano is located on the SW side of the complex and is cut by curvilinear faults; youthful chains of spatter cones follow this same curvilinear pattern and form concentric semi-circles.  The 668-m-high summit of the Borale Ale complex is located on the NE side of the massif and consists of a silicic stratovolcano that is the largest of the Erte Ale Range.  It has produced steep-sided viscous lava flows that have traveled up to 5 km from the volcano.  Strong fumarolic activity occurs within a 300-m-wide summit crater.  Regional faulting has fed very recent basaltic lava flows from a NNW-trending fissure that cuts the stratovolcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-071&amp;volpage=photos&amp;photo=099014">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-071">Smithsonian Volcano Information</a></td></tr></table>	(13.725,40.600000000000001)
54	Erta Ale	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Erta Ale</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/099009.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 613 m<br /><b>Latitude:</b> 13.60&deg;N<br /><b>Longitude:</b> 40.67&deg;E</td></tr><tr><td colspan="2"><p align="justify">Erta Ale is an isolated basaltic shield volcano that is the most active volcano in Ethiopia.  The broad, 50-km-wide volcano rises more than 600 m from below sea level in the barren Danakil depression.   Erta Ale is the namesake and most prominent feature of  the Erta Ale Range.  The 613-m-high volcano contains a 0.7 x 1.6 km, elliptical summit crater housing steep-sided pit craters.  Another larger 1.8 x 3.1 km wide depression elongated parallel to the trend of the Erta Ale range is located to the SE of the summit and is bounded by curvilinear fault scarps on the SE side.  Fresh-looking basaltic lava flows from these fissures have poured into the caldera and locally overflowed its rim.  The summit caldera is renowned for one, or sometimes two long-term lava lakes that have been active since at least 1967, or possibly since 1906.   Recent fissure eruptions have occurred on the northern flank of Erta Ale.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-08=&amp;volpage=photos&amp;photo=099009">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-08=">Smithsonian Volcano Information</a></td></tr></table>	(13.6,40.670000000000002)
55	Ale Bagu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ale Bagu</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117026.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1031 m<br /><b>Latitude:</b> 13.52&deg;N<br /><b>Longitude:</b> 40.63&deg;E</td></tr><tr><td colspan="2"><p align="justify">Ale Bagu, also known as Ummuna, is an elongated, 1031-m-high stratovolcano located SW of Erta Ale volcano.  It is the highest of the Erta Ale Range volcanoes and is located west of the axis of the range.  In contrast to other volcanoes of the Erta Ale Range, Ale Bagu is mantled by basaltic pyroclastic rocks.  Summit craters are elongated along a NNW-SSE trend.  The main crater is a steep-walled, 750 x 450 m depression occupied by a steep-sided lava cone that has fed trachytic lava flows over the crater floor.  Silicic lavas from the axial regional fissure extend to the NW and SE.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-09=&amp;volpage=photos&amp;photo=117026">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-09=">Smithsonian Volcano Information</a></td></tr></table>	(13.52,40.630000000000003)
56	Hayli Gubbi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hayli Gubbi</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/099001.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 521 m<br /><b>Latitude:</b> 13.50&deg;N<br /><b>Longitude:</b> 40.72&deg;E</td></tr><tr><td colspan="2"><p align="justify">Hayli Gubbi is the southernmost volcano of the Erta Ale Range.  Recent tectonism has created a graben at the summit of 521-m-high volcano.  A symmetrical scoria cone with a 200-m-wide crater displaying fumarolic activity occupies the center of the graben.  An older shield volcano is covered on the north by recent fissure-fed lava flows.  Lava flows from the axial portion of a fissure system extending to the south have reached the floor of the Giulietti Plain south of the Erta Ale Range.  The open fissures extend for more than 10 km and are lined with dozens of small spatter cones and pit craters.  The distal portion of lava flows issuing from the fissure system cover 8200-year-old sedimentary deposits on the Giuletti Plain.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-091&amp;volpage=photos&amp;photo=099001">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-091">Smithsonian Volcano Information</a></td></tr></table>	(13.5,40.719999999999999)
57	Dubbi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Dubbi</b></font><br /><font size="5"><b>Eritrea</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/089075.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1625 m<br /><b>Latitude:</b> 13.58&deg;N<br /><b>Longitude:</b> 41.808&deg;E</td></tr><tr><td colspan="2"><p align="justify">Dubbi, located east of the Erta Ale Range and south of the crystalline basement rocks of the Danakil Alps, is a large volcanic massif that rises to 1625 m above the western shore of the Red Sea.  About 20 small cinder cones are located at the summit, and extensive basaltic lava fields to the north and NE, known as the Edd lava field, cover an area of 2700 sq km and reach the Red Sea coast.  The two most-recent eruptive centers are fissure systems that extend NW-SE and NNE-SSW.  The former produced lava flows that reached the Red Sea in 1400 AD.  The second created 19 small craters at the summit in 1861.  Ash fell more than 300 km from the volcano.  Two villages were destroyed and more than 100 persons were killed during Africa's largest eruption in historical time.  Lava flows from the 1861 eruption traveled as far as 22 km and reached the coast.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-10=&amp;volpage=photos&amp;photo=089075">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-10=">Smithsonian Volcano Information</a></td></tr></table>	(13.58,41.808)
58	Asavyo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Asavyo</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/112012.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1200? m<br /><b>Latitude:</b> 13.07&deg;N<br /><b>Longitude:</b> 41.60&deg;E</td></tr><tr><td colspan="2"><p align="justify">Asavyo is the SW-most of three large silicic stratovolcanoes constructed along a NE-SW-trending line in the Danakil horst.  A large 12-km-wide caldera truncates the summit of the volcano.  Basaltic lava flows blanket the flanks of Asavyo, which merge into the Mogorros plains to the south.  Although the age of the volcano is not known precisely, Asavyo was considered to have erupted during last 2000 years (International Association of Volcanology and Chemistry of the Earth's Interior 1973).  A large post-caldera cone was constructed near the center of the caldera, and smaller pyroclastic cones occur within the caldera and on its flanks.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-104&amp;volpage=photos&amp;photo=112012">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-104">Smithsonian Volcano Information</a></td></tr></table>	(13.07,41.600000000000001)
59	Mat Ala	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mat Ala</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/112014.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 523 m<br /><b>Latitude:</b> 13.10&deg;N<br /><b>Longitude:</b> 41.15&deg;E</td></tr><tr><td colspan="2"><p align="justify">Mat Ala is a low, 523-m-high shield volcano in the southern Tat Ali Range, east of Afder volcano.  A 300-m-deep, 2.5 x 3.5 km wide caldera is found at the summit of the volcano, whose flanks are cut by numerous N-S-trending faults.  Mat Ala has been active during the Holocene, and fumarolic activity occurs along a fissure SW of the volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-105&amp;volpage=photos&amp;photo=112014">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-105">Smithsonian Volcano Information</a></td></tr></table>	(13.1,41.149999999999999)
60	Tat Ali	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tat Ali</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/112013.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 700+ m<br /><b>Latitude:</b> 13.28&deg;N<br /><b>Longitude:</b> 41.07&deg;E</td></tr><tr><td colspan="2"><p align="justify">Tat Ali volcano is the dominant feature of the Tat Ali Range, east of Lake Afrera.  The low Holocene shield volcano has an elongated summit depression and has produced a variety of rock types, ranging from basalts to pantellerites.  NNW-SSE-trending fissures cutting the volcano have fed basaltic lava flows; those NE of Lake Afrera are of prehistorical age.  Late-stage volcanism produced youthful basaltic lava flows on the floor of the summit depression, which is also the site of prominent fumarolic activity.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-106&amp;volpage=photos&amp;photo=112013">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-106">Smithsonian Volcano Information</a></td></tr></table>	(13.279999999999999,41.07)
61	Borawli	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Borawli</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/099002.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 812 m<br /><b>Latitude:</b> 13.30&deg;N<br /><b>Longitude:</b> 40.98&deg;E</td></tr><tr><td colspan="2"><p align="justify">Borawli stratovolcano, of Holocene age, rises above the eastern shore of Lake Afrera, also known as Lake Giulietti.  The upper part of the 812-m-high conical volcano consists of trachytic lava flows overlying older basaltic flows.  Young pantelleritic obsidian domes south of the volcano are the probable source of rounded pumice fragments found around Lake Afrera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-107&amp;volpage=photos&amp;photo=099002">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-107">Smithsonian Volcano Information</a></td></tr></table>	(13.300000000000001,40.979999999999997)
62	Ma Alalta	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ma Alalta</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111080.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1815 m<br /><b>Latitude:</b> 13.02&deg;N<br /><b>Longitude:</b> 40.20&deg;E</td></tr><tr><td colspan="2"><p align="justify">Ma Alalta volcano, also known as Pierre Pruvost, is an 1815-m-high stratovolcano located well to the west of the Danakil depression at the foot of the regional Ethiopian scarp.  The volcano is situated between two large horsts of uplifted basement blocks.  A large trachytic and rhyolitic stratovolcano at the center of the Ma Alalta complex contains nested oval-shaped summit calderas, 8 x 5 km and 5 x 2.5 km wide.  Ignimbrite deposits, perhaps associated with formation of the larger caldera, extend beyond the volcano primarily to the NE and SE.  Young basaltic lava flows were erupted on the NW, SE, and eastern flanks of the volcano.  Recent silicic activity has produced pantelleritic obsidian domes and lava flows on the volcano's southern flank.  Fumarolic activity continues at one of the domes.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-111&amp;volpage=photos&amp;photo=111080">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-111">Smithsonian Volcano Information</a></td></tr></table>	(13.02,40.200000000000003)
63	Alayta	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Alayta</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111081.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 1501 m<br /><b>Latitude:</b> 12.88&deg;N<br /><b>Longitude:</b> 40.57&deg;E</td></tr><tr><td colspan="2"><p align="justify">The massive Alayta shield volcano covers an area of 2700 sq km in the western Danakil depression SW of Lake Afrera.  A series of very recent craters is aligned along the NNW-trending axis of the basaltic-to-trachytic shield.  The Alayta lava field, covered by very fresh lava flows, was erupted from N-S-trending fissures along the east side of the shield volcano and laps up against the western flank of Afder volcano.  Two historical eruptions that were formerly attributed to Afder volcano actually originated from Alayta.  One of those eruptions, in 1907, produced a large lava flow from a SE-flank vent.  Fumarolic activity occurs at two locations in the southern part of the complex.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-112&amp;volpage=photos&amp;photo=111081">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-112">Smithsonian Volcano Information</a></td></tr></table>	(12.880000000000001,40.57)
64	Dabbahu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Dabbahu</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/115083.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1442 m<br /><b>Latitude:</b> 12.60&deg;N<br /><b>Longitude:</b> 40.48&deg;E</td></tr><tr><td colspan="2"><p align="justify">Dabbahu, also known as Boina, Boyna, or Moina, is a Holocene volcanic massif forming an axial range of the Afar depression SSW of the Alayta massif.  Pantelleritic obsidian flows, lava domes, and pumice cones form the summit and upper flanks of the volcano, which rises above the Teru Plain and was built over a base of basaltic-to-trachytic lava flows of a shield volcano.  Late-stage basaltic fissure eruptions occurred at the NW base of the volcano.  Abundant fumaroles are located along the crest of the volcano and extend NE towards Alayta volcano.  The first historical eruption of Dabbahu took place from a fissure vent on the NE flank of the volcano in September 2005 and produced ashfall deposits and a small pumice dome.  More than 6000 persons were evacuated from neighboring villages.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-113&amp;volpage=photos&amp;photo=115083">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-113">Smithsonian Volcano Information</a></td></tr></table>	(12.6,40.479999999999997)
65	Dabbayra	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Dabbayra</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111083.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1302 m<br /><b>Latitude:</b> 12.38&deg;N<br /><b>Longitude:</b> 40.07&deg;E</td></tr><tr><td colspan="2"><p align="justify">Dabbayra, the westernmost volcano of the Afar depression, was constructed along an offshoot of the Ethiopian escarpment, SW of the Teru plain.  In contrast to structural trends in other parts of Afar, Dabbayra (also known as Bar-Ali) consists of a basaltic shield volcano elongated in an ENE-WSW direction.  The only silicic volcanic rocks are a NNW-trending line of lava domes and lava flows near the crest of the 1302-m-high volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-114&amp;volpage=photos&amp;photo=111083">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-114">Smithsonian Volcano Information</a></td></tr></table>	(12.380000000000001,40.07)
66	Manda Hararo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Manda Hararo</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119049.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 600+ m<br /><b>Latitude:</b> 12.17&deg;N<br /><b>Longitude:</b> 40.82&deg;E</td></tr><tr><td colspan="2"><p align="justify">The southernmost axial range of western Afar, the Manda Hararo complex is located in the Kalo plain, SSE of Dabbahu volcano.  The massive complex is 105 km long and 20-30 km wide, and represents an uplifted segment of a mid-ocean ridge spreading center.  A small basaltic shield volcano is located at the northern end of the complex, south of which is an area of abundant fissure-fed lava flows.  Two basaltic shield volcanoes, the largest of which is Unda Hararo, occupy the center of the complex.  The dominant part of the complex lies to the south, where the Gumatmali-Gablaytu fissure system is located.  Voluminous fluid lava flows issued from these NNW-trending fissures, and solidified lava lakes occupy two large craters.  The small Gablaytu shield volcano forms the SE-most end of the Manda Hararo complex.  Lava flows from Gablaytu and from Manda overlie 8000-year-old sediments.  Hot springs and fumaroles occur around Daorre lake.  The first historical eruption of Manda Hararo produced fissure-fed lava flows in 2007.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-115&amp;volpage=photos&amp;photo=119049">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-115">Smithsonian Volcano Information</a></td></tr></table>	(12.17,40.82)
67	Groppo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Groppo</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 930 m<br /><b>Latitude:</b> 11.73&deg;N<br /><b>Longitude:</b> 40.25&deg;E</td></tr><tr><td colspan="2"><p align="justify">Groppo volcano is a small 930-m-high alkali rhyolitic stratovolcano located in the western Afar near the Ethiopian escarpment, NE of Dessye.  The volcano was considered to have been active during the past 2000 years (IAVCEI, 1973).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-116">Smithsonian Volcano Information</a></td></tr></table>	(11.73,40.25)
68	Kurub	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kurub</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111072.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 625 m<br /><b>Latitude:</b> 11.88&deg;N<br /><b>Longitude:</b> 41.208&deg;E</td></tr><tr><td colspan="2"><p align="justify">The small Holocene Kurub shield volcano, also known as Kurub Koma, Kurub Koba, or Curub, lies in the Saha Plain, SE of the Manda Hararo complex in the South Danakil region.  The easternmost lava flow of Kurub volcano was potassium-argon dated at about 0.3 million years.  Wind-blown sand fills the summit crater of the very recent basaltic volcano.  Initial subaqueous activity occurred along NNW-trending fissures.  Fumarolic activity observed in the 1930s was not seen during field work in the 1970s.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-12=&amp;volpage=photos&amp;photo=111072">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-12=">Smithsonian Volcano Information</a></td></tr></table>	(11.880000000000001,41.207999999999998)
69	Manda Gargori	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Manda Gargori</b></font><br /><font size="5"><b>Northeastern Africa</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Fissure vents<br />&nbsp;&nbsp;&nbsp; Lava dome<br />&nbsp;&nbsp;&nbsp; Tuff ring</td><td width="50%" align="left"><b>Latitude:</b> 11.75&deg;N<br /><b>Longitude:</b> 41.48&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Manda Gargori rift, located north of the town of Aisa Aita NE of Borawli volcano and SE of Kurub volcano, is the youngest rift segment in the Afar depression and is only one third the width of the adjacent Manda Hararo-Goba'ad rift system to the west.  Two older lava flows from the Manda Gargori rift have Pleistocene potassium-argon dates.  Youthful-looking lava flows, some of which may have been subaqueous, have been emitted from NNW-trending fissures.  A hyaloclastite tuff ring is also present, and a rhyolitic lava dome surrounded by two basaltic lava flows is located north of Uddummi lake.  No historical activity has been reported at the dominantly basaltic Manda Gargori rift, but human footprints have been observed in a fresh ashfall deposit, and the eruptive activity is considered to be of historical age.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-120">Smithsonian Volcano Information</a></td></tr></table>	(11.75,41.479999999999997)
70	Borawli	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Borawli</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111074.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 875 m<br /><b>Latitude:</b> 11.63&deg;N<br /><b>Longitude:</b> 41.45&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Borawli complex consists of a group of rhyolitic lava domes on the floor of the southern Kali plain, NE of the town of Aisa Aita.  A Pleistocene date was obtained from the southernmost lava flow of Borawli.  A 1631 eruption (sometimes listed as 1627) attributed possibly to Amado dome (United Nations, 1973) was considered more likely to be from Dama Ali (Gouin, 1979).  This 875-m-high dome complex is one of several volcanic features in Ethiopia named Borawli.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-121&amp;volpage=photos&amp;photo=111074">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-121">Smithsonian Volcano Information</a></td></tr></table>	(11.630000000000001,41.450000000000003)
71	Manda-Inakir	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Manda-Inakir</b></font><br /><font size="5"><b>Ethiopia/Djibouti</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/112015.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Fissure vents<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 600+ m<br /><b>Latitude:</b> 12.38&deg;N<br /><b>Longitude:</b> 42.20&deg;E</td></tr><tr><td colspan="2"><p align="justify">Manda-Inakir volcano consists of a series of NW-trending fissure vents and pyroclastic cones along the Ethiopia-Djibouti border.  The elongated complex represents an uplifted mid-ocean ridge spreading center now exposed above sea level.  An elongated dome of basement rocks is cut by two axial rifts, the northern of which was active during historical time.  Basaltic cinder cones along marginal faults of the rift have produced lava flows that traveled down the flanks of the structural dome, producing a shield-like morphology.  An eruption in 1928 or 1929 at the SE end of the Manda-Inakir rift near the town of Korili (in Djibouti) produced the Kammourta cinder cone and a lava flow.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-122&amp;volpage=photos&amp;photo=112015">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-122">Smithsonian Volcano Information</a></td></tr></table>	(12.380000000000001,42.200000000000003)
72	Mousa Alli	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mousa Alli</b></font><br /><font size="5"><b>Ethiopia/Eritrea/Djibouti</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/112016.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2028 m<br /><b>Latitude:</b> 12.47&deg;N<br /><b>Longitude:</b> 42.40&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Mousa Alli volcanic complex is a large Holocene stratovolcano constructed along the border between Ethiopia, Eritrea, and Djibouti.  The 2028-m-high trachytic-to-rhyolitic volcano is the most prominent topographic feature in this area and towers above its neighbor to the SW, Manda Inakir.  Rhyolitic lava domes and lava flows are found in the summit region, which is truncated by a caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-123&amp;volpage=photos&amp;photo=112016">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-123">Smithsonian Volcano Information</a></td></tr></table>	(12.470000000000001,42.399999999999999)
73	Gufa	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Gufa</b></font><br /><font size="5"><b>Eritrea/Djibouti</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/112017.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 600+ m<br /><b>Latitude:</b> 12.55&deg;N<br /><b>Longitude:</b> 42.53&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Gufa volcanic field, located along the Eritrea/Djibouti border, consists of a group of basaltic scoria cones and lava flows aligned in an E-W direction NE of the large Mousa Alli stratovolcano.  A second E-W-trending chain of cones is located to the north of the principal chain, most of which lies in Eritrea, and fed long lava flows that descend to the north, in the direction of the Red Sea.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-124&amp;volpage=photos&amp;photo=112017">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-124">Smithsonian Volcano Information</a></td></tr></table>	(12.550000000000001,42.530000000000001)
74	Assab Volcanic Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Assab Volcanic Field</b></font><br /><font size="5"><b>Eritrea</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111076.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 987 m<br /><b>Latitude:</b> 12.95&deg;N<br /><b>Longitude:</b> 42.43&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Assab volcanic field near the Red Sea coast in southern Eritrea forms a spectacular range of basaltic cinder cones and associated lava flows.  The massive lava field covers a 55 x 90 km area, and flows reached the Red Sea along a broad front.  The vents of the Assab volcanic field, also known as Ado Ale or Ud'ale,  were constructed along a broad E-W-trending line that extends to the coastal city of Assab.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-125&amp;volpage=photos&amp;photo=111076">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-125">Smithsonian Volcano Information</a></td></tr></table>	(12.949999999999999,42.43)
75	Ardoukba	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ardoukba</b></font><br /><font size="5"><b>Djibouti</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104004.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Fissure vents<br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Tuff cones</td><td width="50%" align="left"><b>Summit Elev:</b> 298 m<br /><b>Latitude:</b> 11.58&deg;N<br /><b>Longitude:</b> 42.47&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Ardoukba (Asal) Rift in Djibouti, trending NW from the Red Sea, contains a broad area of youthful fissure vents between Lake Asal and the Ghoubbat al Kharab gulf.  The rift is subaerially exposed over a 12 km distance between these two bodies of water and contains numerous basaltic cinder and spatter cones.  The silicic centers of Eger Alayta and Asa Aleyta, on the north and south sides of the rift, are remnants of a Pleistocene silicic center that has been disrupted and spread apart by the rift.  Magma-water interaction has produced tuff cones, some of which form islands or are breached by the sea.  The most recent lava flows are younger than lake sediments deposited 5300 years ago.  These lavas were thought to have been erupted during the past 3000 years (Delibrias et al., 1975).  The Ardoukba fissure erupted in 1978, producing a small cinder cone and lava flows that covered part of the rift floor near the Red Sea.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-126&amp;volpage=photos&amp;photo=104004">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-126">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://volcano.ipgp.jussieu.fr/djibouti/stationdj.html">IPGP Observatoire Volcanologique de Djibouti</a></td></tr></table>	(11.58,42.469999999999999)
76	Dama Ali	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Dama Ali</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111070.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1068 m<br /><b>Latitude:</b> 11.28&deg;N<br /><b>Longitude:</b> 41.63&deg;E</td></tr><tr><td colspan="2"><p align="justify">Dama Ali is a broad shield volcano that rises above the NW shore of Lake Abbe (also known as Lake Abhe) in eastern Ethiopia.  The 25-km-wide volcano was constructed at the southern end of the Kalo Plain.  Nested circular craters are located at the summit of the dominantly basaltic volcano, which also displays an older caldera rim.  An arcuate chain of rhyolitic lava domes occupies the northern, western, and southern flanks.  Youthful basaltic lava flows surround these domes and blanket the flanks of the volcano, and recent flows cover the young sediments of the Kalo and Abhe basins.  The Asmara basaltic pyroclastic cone located in the southern Kalo basin SW of the base of Dama Ali volcano and was considered to have had activity during the last 2000 years (International Association of Volcanology and Chemistry of the Earth's Interior, 1973).  Dama Ali is considered the most likely source of an eruption reported to have occurred in 1631 (Gouin, 1979).  Major fumarolic activity occurs in the summit crater, and abundant hot springs are found on the volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-141&amp;volpage=photos&amp;photo=111070">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-141">Smithsonian Volcano Information</a></td></tr></table>	(11.279999999999999,41.630000000000003)
77	Gabillema	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Gabillema</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111071.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1459 m<br /><b>Latitude:</b> 11.08&deg;N<br /><b>Longitude:</b> 41.27&deg;E</td></tr><tr><td colspan="2"><p align="justify">Gabillema is a rhyolitic stratovolcano along the axis of the Addado graben.  The volcano was constructed at the intersection of the central Afar rift zone with the northern end of the NE-SW-trending Ethiopian rift.  Rhyolitic lava domes are located on the flanks of the volcano, and a 5 x 17 km basaltic lava field that covers the Ado Bad plain north of the volcano originated from a broad area of fissure vents and spatter cones on the north side of Gabillema volcano.  Young lava flows also occur south and east of the volcano, the latter along E-W-trending fissures.  This period of rejuvenation, perhaps not directly related to Gabillema, has included rhyolitic as well as basaltic volcanism.  For the Ethiopian rift south of 11 degrees north, official names from the new Ethiopian Geological Survey's 1:250,000 topo maps have replaced earlier names published in the geological literature.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-15=&amp;volpage=photos&amp;photo=111071">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-15=">Smithsonian Volcano Information</a></td></tr></table>	(11.08,41.270000000000003)
78	Yangudi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Yangudi</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117030.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Scoria cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1383 m<br /><b>Latitude:</b> 10.58&deg;N<br /><b>Longitude:</b> 41.042&deg;E</td></tr><tr><td colspan="2"><p align="justify">Yangudi volcano, lying in the Addado graben of the northern Ethiopian rift, is a complex rhyolitic stratovolcano with an elliptical summit caldera.  A trachytic lava flow originating in the caldera covers part of the southern flank of Yangudi, also known as Angudi, Jangudi, or Langudi.  Rhyolitic obsidian domes on the NW flank are surrounded by younger basaltic lava flows.  Very recent scoria cones and lava flows are located south of Yangudi along the eastern graben faults.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-151&amp;volpage=photos&amp;photo=117030">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-151">Smithsonian Volcano Information</a></td></tr></table>	(10.58,41.042000000000002)
79	Ayelu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ayelu</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/001043.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2145 m<br /><b>Latitude:</b> 10.082&deg;N<br /><b>Longitude:</b> 40.702&deg;E</td></tr><tr><td colspan="2"><p align="justify">Ayelu is a vegetated rhyolitic stratovolcano, located south of the Asbahri plain in the southern Afar region.  On its eastern side, 2145-m-high  Ayelu is cut by regional faults and is overlain by ignimbrites erupted from Adwa volcano immediately to the east.  Ayelu was constructed by a series of thick rhyolitic lava flows, creating a higher and steeper-sided volcano than its neighbor Adwa.  Hot springs are located on the western flank of Ayelu.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-16=&amp;volpage=photos&amp;photo=001043">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-16=">Smithsonian Volcano Information</a></td></tr></table>	(10.082000000000001,40.701999999999998)
80	Adwa	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Adwa</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117029.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1733 m<br /><b>Latitude:</b> 10.070&deg;N<br /><b>Longitude:</b> 40.840&deg;E</td></tr><tr><td colspan="2"><p align="justify">Adwa, also known as Aabida, Amoissa, or Dabita, is a stratovolcano in the southern Afar area immediately east of Ayelu volcano.  Adwa is younger than the vegetated Ayelu and is a stratovolcano with a 4 x 5 km caldera that originated following eruption of voluminous ignimbrites.  A small 2.5-km-wide caldera cuts a trachytic dome extruded in the older caldera.  Scoria cones are located on the floor of a circular summit caldera and on its NW and SW flanks.  Extensive young basaltic lava flows cover the flanks of Adwa and overlap a sedimentary plain to the SE.  Many fumaroles occur within the caldera of Adwa.  Satellitic pyroclastic cones and lava domes were considered to be only a few hundred years old (Mohr 1980, pers. comm.).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-17=&amp;volpage=photos&amp;photo=117029">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-17=">Smithsonian Volcano Information</a></td></tr></table>	(10.07,40.840000000000003)
81	Hertali	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hertali</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117028.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Fissure vent</td><td width="50%" align="left"><b>Summit Elev:</b> 900? m<br /><b>Latitude:</b> 9.78&deg;N<br /><b>Longitude:</b> 40.33&deg;E</td></tr><tr><td colspan="2"><p align="justify">Hertali is a basaltic fissure vent that fed lava flows at the south end of the Awash plain, about 50 km NNE of Dofen volcano.  Hertali was considered by Mohr and Wood (1976) to have been active during the late Pleistocene to Holocene on the basis of its youthful-looking morphology.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-171&amp;volpage=photos&amp;photo=117028">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-171">Smithsonian Volcano Information</a></td></tr></table>	(9.7799999999999994,40.329999999999998)
82	Dofen	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Dofen</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/112018.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1151 m<br /><b>Latitude:</b> 9.35&deg;N<br /><b>Longitude:</b> 40.13&deg;E</td></tr><tr><td colspan="2"><p align="justify">Dofen, also called Dofane, is known as the &quot;smoking mountain.&quot;  It is a 1151-m-high stratovolcano that rises 450 m above the Awash plain in the northern Main Ethiopian Rift.  Numerous cinder cones, constructed along a 10-km-long, N-S-trending line, dot the flanks of the dominantly rhyolitic volcano.  The northern cones are younger, have well-preserved morphologies, and display strong fumarolic activity.  A major fumarole in a wide south-flank crater has precipitated large amounts of sulfur.  The latest eruptions of Dofen occurred during the Holocene (WoldeGabriel 1987, pers. comm.).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-18=&amp;volpage=photos&amp;photo=112018">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-18=">Smithsonian Volcano Information</a></td></tr></table>	(9.3499999999999996,40.130000000000003)
83	Fentale	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Fentale</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120075.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 2007 m<br /><b>Latitude:</b> 8.975&deg;N<br /><b>Longitude:</b> 39.93&deg;E</td></tr><tr><td colspan="2"><p align="justify">Fentale, also known as Fantale, is a large stratovolcano at the northern end of the Main Ethiopian Rift.  It consists primarily of rhyolitic obsidian lava flows with minor tuffs.  Welded pantelleritic ash flows accompanied formation of a 2.5 x 4.5 km summit caldera, which has steep-sided walls up to 500 m high.  The WNW-ESE-trending elliptical caldera has an orientation perpendicular to the Ethiopian Rift, and post-caldera vents occur along the same orientation.  Trachytic and obsidian lava flows occur on the caldera floor, and fresh-looking lava flows descend the flanks from satellitic vents.  An eruption from Fentale during the 13th century destroyed an Abyssinian town and church south of the volcano.  In 1820 basaltic lava flows were extruded onto the Main Ethiopian Rift from a 4-km-long fissure on the south flank, and lava flows were erupted on the floor of the caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-19=&amp;volpage=photos&amp;photo=120075">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-19=">Smithsonian Volcano Information</a></td></tr></table>	(8.9749999999999996,39.93)
84	Beru	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Beru</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111069.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 1100 m<br /><b>Latitude:</b> 8.95&deg;N<br /><b>Longitude:</b> 39.75&deg;E</td></tr><tr><td colspan="2"><p align="justify">An area of Holocene basaltic lava flows is located along the Main Ethiopian Rift at Beru, between Fentale and Kone (Gariboldi) volcanoes.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-191&amp;volpage=photos&amp;photo=111069">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-191">Smithsonian Volcano Information</a></td></tr></table>	(8.9499999999999993,39.75)
85	Kone	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kone</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104023.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1619 m<br /><b>Latitude:</b> 8.80&deg;N<br /><b>Longitude:</b> 39.692&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Kone volcanic complex, also known as Gariboldi, is composed of a series of silicic calderas and young basaltic cinder cones and lava flows about 30 km SW of Fentale volcano.  As many as eight silicic calderas are accompanied by ignimbrite outflow sheets.  Gariboldi, the youngest caldera, is an elliptical 5 x 7.5 km wide caldera trending E-W and oriented perpendicular to the Main Ethiopian Rift.  The rim of the caldera rises about 100 m above the caldera floor; the eastern rim overlaps with a smaller elliptical caldera.   Roughly N-S-trending regional fissures cut across the caldera and its flanks.  The youngest basalts were erupted during the first half of the 19th century from vents along a hinge line between the smaller eastern caldera and the larger western one.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-20-&amp;volpage=photos&amp;photo=104023">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-20-">Smithsonian Volcano Information</a></td></tr></table>	(8.8000000000000007,39.692)
86	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111068.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1300 m<br /><b>Latitude:</b> 8.70&deg;N<br /><b>Longitude:</b> 39.63&deg;E</td></tr><tr><td colspan="2"><p align="justify">An unnamed area of Holocene basaltic lava flows occupies both sides of the axis of the Main Ethiopian Rift.  They were erupted from pyroclastic cones located between Kone and Boset-Bericha volcanoes, SE of the capital city of Addis Ababa.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-201&amp;volpage=photos&amp;photo=111068">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-201">Smithsonian Volcano Information</a></td></tr></table>	(8.6999999999999993,39.630000000000003)
87	Boset-Bericha	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Boset-Bericha</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111067.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2447 m<br /><b>Latitude:</b> 8.558&deg;N<br /><b>Longitude:</b> 39.475&deg;E</td></tr><tr><td colspan="2"><p align="justify">Boset (Boseti-Gudda) and Bericha (Boseti-Bericcia) are composite dominantly rhyolitic-to-trachytic volcanoes rising 1000 m and 800 m, respectively, above the floor of the Ethiopian Rift valley.  Initial basaltic-to-trachytic activity at Boset (also known as Gudda) was followed by rhyolitic effusive and explosive eruptions that resulted in caldera formation.  A remnant of the caldera rim is found on the NW flank of Boset.  Elsewhere post-caldera activity has produced very recent pantelleritic obsidian fissure-fed lava domes and flows that have buried the caldera wall, and flank eruptions from fissures parallel to the rift have produced voluminous pantelleritic lava flows.  Bericha (also known as Bariccia) has produced similar very recent obsidian flows and associated pumice flows.  Fissures connecting Boset and Bericha have erupted youthful, prehistorical basaltic lava flows.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-21-&amp;volpage=photos&amp;photo=111067">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-21-">Smithsonian Volcano Information</a></td></tr></table>	(8.5579999999999998,39.475000000000001)
88	Bishoftu Volcanic Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bishoftu Volcanic Field</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111066.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Fissure vents<br />&nbsp;&nbsp;&nbsp; Tuff rings<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 1850+ m<br /><b>Latitude:</b> 8.78&deg;N<br /><b>Longitude:</b> 38.98&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Bishoftu volcanic field, also known as Debre Zeit, consists of an area of fissure-fed Holocene lava flows, cinder cones, tuff rings, and  maars.  Several of the maars are filled by lakes, which are popular recreational destinations from the nearby capital city of Addis Ababa.  Most of the craters and cones are aligned NE-SW, parallel to the direction of the Ethiopian Rift Valley.  The 750 x 1000 m wide Haro Maja tuff ring and its neighbor, lake-filled Kilole, are offset to the east.  The cones and maars of the Bishoftu volcanic field were erupted through rhyolitic welded tuffs.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-22-&amp;volpage=photos&amp;photo=111066">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-22-">Smithsonian Volcano Information</a></td></tr></table>	(8.7799999999999994,38.979999999999997)
89	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111065.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 1800? m<br /><b>Latitude:</b> 8.62&deg;N<br /><b>Longitude:</b> 38.95&deg;E</td></tr><tr><td colspan="2"><p align="justify">A small isolated area of basaltic spatter cones and Recent-to-prehistorical lava flows lies on the floor of the western Main Ethiopian Rift about 10 km NE of the prominent 2800-m-high Ziquala volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-221&amp;volpage=photos&amp;photo=111065">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-221">Smithsonian Volcano Information</a></td></tr></table>	(8.6199999999999992,38.950000000000003)
90	Sodore	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sodore</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111064.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1765 m<br /><b>Latitude:</b> 8.43&deg;N<br /><b>Longitude:</b> 39.35&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Sodore volcanic field is an extensive 15 x 25 km wide group of Pleistocene and Holocene pyroclastic cones and lava flows that covers the floor of the eastern side of the Ethiopian Rift Valley, north of the town of Malkassa, between Boset-Bericha and Gedamsa volcanoes.  The basaltic lava flows extend beyond the western flanks of Boset and Bericha volcanoes as far north as the village of Welenchiti.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-222&amp;volpage=photos&amp;photo=111064">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-222">Smithsonian Volcano Information</a></td></tr></table>	(8.4299999999999997,39.350000000000001)
91	Gedamsa	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Gedamsa</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111061.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1984 m<br /><b>Latitude:</b> 8.35&deg;N<br /><b>Longitude:</b> 39.18&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Gedamsa caldera is located along the Main Ethiopian Rift east of Lake Koka and SW of the Wonji Sugar Estate Farm.  The 7 x 9 km wide caldera (also spelled Gadamsa or Gedemsa) is cut by many NNE-SSW-trending regional faults of the Ethiopian Rift, particularly on the east side of the caldera.  The caldera is steep-sided, with 100-200 m high walls whose upper part consists primarily of rhyolitic lava flows, and formed as a result of the eruption of a series of trachytic ignimbrites.  Late-Pleistocene to Holocene volcanics form a chain of rhyolitic lava flows and pumice deposits, known as Ittisa, that rises about 200-250 m above the floor of the caldera.  A large 1-km-wide crater is located at the eastern part of the chain.  A Holocene lava dome or flow is found on the SW flank of the volcano.  Regional faults have truncated the volcano, and small basaltic spatter cones have formed inside the caldera rim.  Weak fumarolic activity was reported at two locations at Gedamsa.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-23-&amp;volpage=photos&amp;photo=111061">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-23-">Smithsonian Volcano Information</a></td></tr></table>	(8.3499999999999996,39.18)
92	Bora-Bericcio	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bora-Bericcio</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/001045.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pumice cones<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 2285 m<br /><b>Latitude:</b> 8.27&deg;N<br /><b>Longitude:</b> 39.03&deg;E</td></tr><tr><td colspan="2"><p align="justify">The silicic Bora and Bericcio pumice cones, among the most youthful volcanoes of the Ethiopian Rift valley, rise 350-500 m above the floor of the rift.  Bora has a 1.5-km-wide summit crater, and the more conical Bericcio is capped by a small summit crater and has a 1-km-wide crater on its south flank.  Small silicic pyroclastic cones are found on the east flanks of both Bora and Bericcio.  All volcanic products in this area are considered to be Holocene in age.  Vigorous fumarolic activity continues at Bora-Bericcio.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-24-&amp;volpage=photos&amp;photo=001045">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-24-">Smithsonian Volcano Information</a></td></tr></table>	(8.2699999999999996,39.030000000000001)
93	Tullu Moje	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tullu Moje</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111062.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pumice cone<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 2349 m<br /><b>Latitude:</b> 8.158&deg;N<br /><b>Longitude:</b> 39.13&deg;E</td></tr><tr><td colspan="2"><p align="justify">Tullu Moje is a youthful trachytic-to-rhyolitic pumice cone with a 700-m-wide summit crater, located in the middle of one of the most active parts of the Ethiopian Rift Valley.  A large silicic lava flow at Giano was erupted about two centuries ago from a regional fissure.  Flank fissures have produced silicic lava flows as recently as about 1900 AD.  The same fissures have also erupted prehistorical basaltic lava flows.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-25-&amp;volpage=photos&amp;photo=111062">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-25-">Smithsonian Volcano Information</a></td></tr></table>	(8.1579999999999995,39.130000000000003)
94	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111063.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 1800? m<br /><b>Latitude:</b> 8.07&deg;N<br /><b>Longitude:</b> 39.07&deg;E</td></tr><tr><td colspan="2"><p align="justify">A large unnamed area of Holocene basalts is located on the floor of the Ethiopian Rift Valley SW of Tulu Moje volcano.  The flows occupy a NE-SW-trending zone near the active eastern margin of the rift valley, NE of Lake Zwai and NW of the massive, 4000-m-high Pleistocene Ch'llalo (Cilallo) volcano, one of the largest volcanic structures of the central Ethiopian Rift Valley.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-251&amp;volpage=photos&amp;photo=111063">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-251">Smithsonian Volcano Information</a></td></tr></table>	(8.0700000000000003,39.07)
95	East Zway	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>East Zway</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/115021.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Fissure vents<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1889 m<br /><b>Latitude:</b> 7.95&deg;N<br /><b>Longitude:</b> 38.93&deg;E</td></tr><tr><td colspan="2"><p align="justify">A large area of Recent-to-prehistorical basaltic cinder cones and lava flows lies immediately east and south of Lake Zway (also spelled Zwai, Zeway, and Ziway) and forms islands along the east shore of the lake.  About 80 vents were formed along the East Zway segment of the Wonji Fault Belt.  The youngest lava flows at East Zway are unaffected by the latest tectonic faulting along the Ethiopian Rift.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-252&amp;volpage=photos&amp;photo=115021">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-252">Smithsonian Volcano Information</a></td></tr></table>	(7.9500000000000002,38.93)
96	Butajiri-Silti Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Butajiri-Silti Field</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/001046.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Fissure vents<br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 2281 m<br /><b>Latitude:</b> 8.05&deg;N<br /><b>Longitude:</b> 38.35&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Butajiri-Silti volcanic field consists of a large group of basaltic cinder cones, maars, and lava flows in an 80-km-long, NE-SW-trending area near the west margin of the Ethiopian Rift.  At least 13 maars, many filled by lakes, are located near the town of Debre Zeit, SE of the capital city of Addis Ababa.  The maars were erupted through Pleistocene rhyolitic lava flows and tuffs.  Eruptions of the younger basaltic cinder cones were contemporaneous with those that produced the maars.  Some of the lava flows associated with the cinder cones are very young and are considered to be prehistorical in age (Di Paola, 1972).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-26-&amp;volpage=photos&amp;photo=001046">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-26-">Smithsonian Volcano Information</a></td></tr></table>	(8.0500000000000007,38.350000000000001)
97	Alutu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Alutu</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104026.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2335 m<br /><b>Latitude:</b> 7.77&deg;N<br /><b>Longitude:</b> 38.78&deg;E</td></tr><tr><td colspan="2"><p align="justify">Alutu, between lakes Zway  and Mirrga (Langano), is a stratovolcano with multiple vents aligned along NNE-SSW and E-W fissures along a narrow graben between the two lakes.  This silicic volcanic center lies along the regional Wonji Fault Belt and has produced abundant pumice-flow and pumice-fall deposits, along with lesser rhyolitic lava flows.  Obsidian lava flows erupted from craters along the fissures have descended the flanks in all directions.  Cinder cones, lava domes, phreatic explosion craters, and thermal springs are structurally controlled.  The oldest known eruptions from Alutu produced the Hulo-Seyno Ignimbrite about 155,000 years ago.  The latest eruptions produced obsidian flows and pumice breccias about 2000 years ago.  Alutu eruptive products overlie recent basaltic lava flows to the west.  Strong fumarolic activity continues, and the volcano has been the object of a geothermal exploration program.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-27-&amp;volpage=photos&amp;photo=104026">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-27-">Smithsonian Volcano Information</a></td></tr></table>	(7.7699999999999996,38.780000000000001)
98	O'a Caldera	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>O'a Caldera</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104025.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2075 m<br /><b>Latitude:</b> 7.47&deg;N<br /><b>Longitude:</b> 38.58&deg;E</td></tr><tr><td colspan="2"><p align="justify">O'a caldera along the central Ethiopian Rift is the country's largest rift-valley caldera.  The caldera forms the eastern portion of the 15 x 25 km dumbbell-shaped Lake O'a (also known as Lake Shalla).  Formation of the caldera about 240,000 years ago was accompanied by the eruption of two ignimbrite deposits, the first of which was strongly welded.   The only post-caldera activity consists of two pyroclastic cones north of the caldera, one silicic and the other basaltic, and a group of tuff rings, spatter cones, and lava flows of Holocene (perhaps as young as prehistorical) age near the SW shore of the lake.  These were erupted along the Corbetti-Shalla segment of the Wonji Fault Belt, which extends north from Corbetti caldera.  Fumarolic activity continues on all sides of the lake.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-28-&amp;volpage=photos&amp;photo=104025">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-28-">Smithsonian Volcano Information</a></td></tr></table>	(7.4699999999999998,38.579999999999998)
99	Corbetti Caldera	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Corbetti Caldera</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/001047.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pumice cone</td><td width="50%" align="left"><b>Summit Elev:</b> 2320 m<br /><b>Latitude:</b> 7.18&deg;N<br /><b>Longitude:</b> 38.43&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 15-km-wide Corbetti caldera overlaps the NW margin of the older 30 x 40 km Awasa caldera.  Urji volcano was subsequently constructed in the center of Corbetti caldera, which also contains young lava flows.  Chabbi volcano, a large obsidian dome that grew on the SE caldera rim, has erupted lava flows onto the caldera floor.  The age of the latest eruptive activity at Corbetti caldera is not known, although many lava flows are too young to date by the Potassium-Argon method.  Fumarolic activity continues at the post-caldera cones of Urji, Chabbi, and an unnamed pyroclastic cone on the west rim.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-29-&amp;volpage=photos&amp;photo=001047">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-29-">Smithsonian Volcano Information</a></td></tr></table>	(7.1799999999999997,38.43)
100	Bilate River Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bilate River Field</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/115045.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Maars<br />&nbsp;&nbsp;&nbsp; Tuff rings</td><td width="50%" align="left"><b>Summit Elev:</b> 1700? m<br /><b>Latitude:</b> 7.07&deg;N<br /><b>Longitude:</b> 38.10&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Bilate River basin west of Lake Awasa contains a group of lake-filled maars and tuff rings of Pleistocene and probable Holocene age (WoldeGabriel 1987, pers. comm.).  Active hot springs and fumaroles are located in this area.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-291&amp;volpage=photos&amp;photo=115045">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-291">Smithsonian Volcano Information</a></td></tr></table>	(7.0700000000000003,38.100000000000001)
101	Tepi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tepi</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117027.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2728 m<br /><b>Latitude:</b> 7.42&deg;N<br /><b>Longitude:</b> 35.43&deg;E</td></tr><tr><td colspan="2"><p align="justify">The densely forested Tepi basaltic shield volcano, morphologically unmodified in a region of high rainfall, is capped by prominent cinder cones and small craters.  Three satellitic centers are located along an E-W line north of the main shield, whose 2728-m-high summit forms Ethiopia's highest Holocene volcano.  Lava flows have traveled down pre-existing valleys.  Tepi lies at the northern end of the Turkana rift, about 300 km west of the center of the main Ethiopian rift and was constructed along a zone of ENE-trending faults that extends in line with the Gulf of Aden.  Tepi has associated active hot springs and was considered by Davidson (1983) to be of probable Holocene age.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-292&amp;volpage=photos&amp;photo=117027">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-292">Smithsonian Volcano Information</a></td></tr></table>	(7.4199999999999999,35.43)
102	Tosa Sucha	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tosa Sucha</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/115044.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1650 m<br /><b>Latitude:</b> 5.93&deg;N<br /><b>Longitude:</b> 37.57&deg;E</td></tr><tr><td colspan="2"><p align="justify">A group of cinder cones at Tosa Sucha on the north shore of Lake Chamo in the southern Ethiopian Rift has produced unvegetated olivine basaltic lava flows and may have been active as recently as historical time (Ebinger et al., 1993).  The cones and flows on the eastern end of the Chamo Basin were erupted along NNE-trending fissures between Lake Chamo and Lake Abaya to the north.  Some cones form islands in Lake Chamo.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-31-&amp;volpage=photos&amp;photo=115044">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-31-">Smithsonian Volcano Information</a></td></tr></table>	(5.9299999999999997,37.57)
103	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>Ethiopia</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1200 m<br /><b>Latitude:</b> 5.65&deg;N<br /><b>Longitude:</b> 37.67&deg;E</td></tr><tr><td colspan="2"><p align="justify">A group of unnamed cinder cones erupted from NNE-trending fissures SE of Lake Chamo, along the southern Ethiopian Rift, has produced unvegetated olivine basaltic lava flows that may have erupted as recently as historical time (Ebinger et al., 1993).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-311">Smithsonian Volcano Information</a></td></tr></table>	(5.6500000000000004,37.670000000000002)
104	Mega Basalt Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mega Basalt Field</b></font><br /><font size="5"><b>Ethiopia-Kenya border</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/115020.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 1067 m<br /><b>Latitude:</b> 4.08&deg;N<br /><b>Longitude:</b> 37.42&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Mega Basalt field, straddling the Ethiopia-Kenya border, is referred to in Kenya as the Dukana volcanic field.  The Ethiopian portion was considered to have been active during the Holocene (Mohr, 1979; Davidson, 1983).  The Kenyan portion was mapped as Pleistocene in age, with one Potassium-Argon date of about 0.9 million years ago (Charsely, 1987).  The 1.8-km-wide Gof Dukana basaltic maar is surrounded by ejecta containing abundant basement igneous and metamorphic rocks.  About 50 pyroclastic cones with associated lava flows rise to about 150 m above the lava platform in northern Kenya.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-33-&amp;volpage=photos&amp;photo=115020">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0201-33-">Smithsonian Volcano Information</a></td></tr></table>	(4.0800000000000001,37.420000000000002)
105	North Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>North Island</b></font><br /><font size="5"><b>Kenya</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/100044.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Tuff cones</td><td width="50%" align="left"><b>Summit Elev:</b> 520 m<br /><b>Latitude:</b> 4.07&deg;N<br /><b>Longitude:</b> 36.05&deg;E</td></tr><tr><td colspan="2"><p align="justify">The small, 2-km-wide North Island in Lake Turkana is the northernmost and smallest of three volcanic islands in the lake.  North Island is the summit of Kenya's northernmost rift valley volcano and is primarily composed of trachyandesitic-to-trachytic phreatomagmatic deposits from overlapping eroded tuff cones or tuff rings.  The center of the island consists of a young tuff ring about 1 km in diameter nested inside an older tuff ring.  Two fresh unvegetated lava flows that reach the lake shore from the central tuff ring form lava deltas at the northern and western sides of the island; the northern delta is about 900 m wide.  The two blocky lava flows are younger than a terrace that formed less than 10,000 years ago during the last major high-water level of Lake Turkana (Key and Watkins, 1988).  Geothermal activity occurs along a curvilinear ridge on the southern half of the island and on wave-cut platforms and beaches on the SW shoreline.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-001&amp;volpage=photos&amp;photo=100044">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-001">Smithsonian Volcano Information</a></td></tr></table>	(4.0700000000000003,36.049999999999997)
106	Central Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Central Island</b></font><br /><font size="5"><b>Kenya</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/100043.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Tuff cones<br />&nbsp;&nbsp;&nbsp; Tuff rings</td><td width="50%" align="left"><b>Summit Elev:</b> 550 m<br /><b>Latitude:</b> 3.50&deg;N<br /><b>Longitude:</b> 36.042&deg;E</td></tr><tr><td colspan="2"><p align="justify">Central Island, also known as Crocodile Island, occupies the middle of Lake Turkana and is composed of more than a dozen craters and cones, three of which are filled by small lakes.  The two largest lakes partially fill craters up to a km wide and about 80 m deep whose floors lie near sea level.  The highest point on the dominantly basaltic island reaches 550 m, about 170 m above the lake surface.  An E-W-trending chain of small explosion craters cuts the eastern side of the 3-km-wide island.  Several small islands to the SE represent partially submerged crater rims, and other cones and lava plugs lie beneath the lake surface near the island.  The youngest Central Islands tuffs and lavas may be as young as Holocene (Karson and Curtis, 1992).   Fumarolic activity is concentrated along the NE-to-SE rim of the central crater, and sprays of sulfur from the fumaroles were observed by visitors in the 1930s.  In 1974 intense emission of molten sulfur and steam clouds were seen from the mainland.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-01=&amp;volpage=photos&amp;photo=100043">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-01=">Smithsonian Volcano Information</a></td></tr></table>	(3.5,36.042000000000002)
107	South Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>South Island</b></font><br /><font size="5"><b>Kenya</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119031.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Tuff cones</td><td width="50%" align="left"><b>Summit Elev:</b> 800 m<br /><b>Latitude:</b> 2.63&deg;N<br /><b>Longitude:</b> 36.60&deg;E</td></tr><tr><td colspan="2"><p align="justify">The southernmost and largest of the three volcanic islands in Lake Turkana, South Island contains numerous tuff cones.  Fresh-looking lava flows, erupted from a N-S fissure extending the 11-km length of the island, form much of the eastern shoreline.  South Island (sometimes referred to as Hohnel Island) rises 320 m above the lake to a height of 800 m and is part of a volcanic horst that extends 10 km to the north beneath the lake surface.  Early stage tuff cone formation may have been associated with a high stand of Lake Turkana dated at about 10,000 years ago, and later subaerial activity postdates the last high stand of the lake about 3200 years ago.  The dominantly basaltic lava flows are morphologically similar to the youthful Holocene flows of The Barrier volcano at the south end of Lake Turkana.  An eruption from a scoria cone on South Island was witnessed during Count von Teliki's 1888 expedition.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-02=&amp;volpage=photos&amp;photo=119031">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-02=">Smithsonian Volcano Information</a></td></tr></table>	(2.6299999999999999,36.600000000000001)
108	The Barrier	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>The Barrier</b></font><br /><font size="5"><b>Kenya</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/100042.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1032 m<br /><b>Latitude:</b> 2.32&deg;N<br /><b>Longitude:</b> 36.57&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Barrier volcanic complex separates Lake Turkana from the broad Suguta Trough to the south, the site of a former lake.  The volcano is comprised of four overlapping shield volcanoes, with the youngest, Kakorinya, located over the axis of the East African Rift.  Kalolenyang volcano lies west of Kakorinya, and Likaiu West and Likaiu East volcano are located to the ENE.  A 3.8-km-wide summit caldera was formed at Kakorinya volcano about 92,000 years ago.  Youthful-looking trachytic and phonolitic lava domes and flows erupted within the caldera and along its ring fracture fill much of the caldera floor.  Early Holocene fissure-related scoria cones and lava flows dot the volcano's southern and northern flanks.  Solfataric fields are located within the caldera and on the western and southern flanks of the volcano.  Historical eruptions from Teleki's and Andrew's cones on the northern and southern flanks, respectively, have produced basaltic explosive activity and lava flows during the 19th and 20th centuries.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-03=&amp;volpage=photos&amp;photo=100042">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-03=">Smithsonian Volcano Information</a></td></tr></table>	(2.3199999999999998,36.57)
109	Namarunu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Namarunu</b></font><br /><font size="5"><b>Kenya</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/100041.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Tuff rings</td><td width="50%" align="left"><b>Summit Elev:</b> 817 m<br /><b>Latitude:</b> 1.98&deg;N<br /><b>Longitude:</b> 36.43&deg;E</td></tr><tr><td colspan="2"><p align="justify">The largely Pliocene Namarunu trachytic shield volcano is topped by parasitic cones and lava flows of upper Pleistocene and Holocene age.  Voluminous basaltic effusive and explosive activity took place during the early Holocene on the lower northern, eastern, and southern flanks along the axis of the East African Rift, producing fissure-controlled subaerial basaltic scoria cones and lava flows, and partially or completely sublacustral tuff cones, tuff rings, and pillow lavas.  Fluid olivine basalts were also erupted from a breached scoria cone forming the summit of Namarunu.  The youngest eruptions postdated the drying out of Lake Sugata about 3000 years ago.  Some could be as recent as the historical eruptions at The Barrier volcano to the north (Dunkley et al., 1993).  Hot springs are located on some of the young volcanic cones on the rift valley floor and on the eastern side of the rift along the base of the Tirr Tirr Plateau.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-04-&amp;volpage=photos&amp;photo=100041">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-04-">Smithsonian Volcano Information</a></td></tr></table>	(1.98,36.43)
110	Segererua Plateau	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Segererua Plateau</b></font><br /><font size="5"><b>Kenya</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117039.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 699 m<br /><b>Latitude:</b> 1.57&deg;N<br /><b>Longitude:</b> 37.90&deg;E</td></tr><tr><td colspan="2"><p align="justify">A large number of late-Pleistocene to Holocene basaltic cones, lava flows, and maars occur along a roughly 50-km-long NE-SW trend on the Segererua and Rusarus Plateaus and areas to the SW.  This volcanic region is located well east of the East African Rift, south of the massive Marsabit shield volcano.  The two plateaus host most of the vents and are bounded by the Milgis River on the north and the Merille River to the south.  Other vents lie to the SW, east of the Kauro River, and another large area of basaltic lava flows lies west of the Segererua and Rusaurus Platueas.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-05-&amp;volpage=photos&amp;photo=117039">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-05-">Smithsonian Volcano Information</a></td></tr></table>	(1.5700000000000001,37.899999999999999)
111	Emuruangogolak	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Emuruangogolak</b></font><br /><font size="5"><b>Kenya</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/100040.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1328 m<br /><b>Latitude:</b> 1.50&deg;N<br /><b>Longitude:</b> 36.33&deg;E</td></tr><tr><td colspan="2"><p align="justify">The broad Emuruangogolak shield volcano is situated at a narrow constriction in the Gregory Rift and almost completely straddles it.  A 5 x 3.5 km summit caldera formed about 38,000 years ago.  Since then trachytic and basaltic lava flows were erupted on the northern and southern flanks and within the caldera.  A NNE-SSW-trending chain of lake-filled basaltic maars extends along the floor of the rift from the lower flanks of the volcano.  Young lava flows were also erupted from vents along rift valley faults.  Well-preserved parasitic cones erupted along rift-parallel faults cutting the volcano abound; the latest eruption produced a trachytic lava flow dated from secular magnetic variation measurements at about the beginning of the 20th century.  Fumarolic activity and hot steaming ground occurs along NNE-trending fissures within the caldera and along the lower NW flanks.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-051&amp;volpage=photos&amp;photo=100040">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-051">Smithsonian Volcano Information</a></td></tr></table>	(1.5,36.329999999999998)
112	Silali	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Silali</b></font><br /><font size="5"><b>Kenya</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/100039.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1528 m<br /><b>Latitude:</b> 1.15&deg;N<br /><b>Longitude:</b> 36.23&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 30-km-wide Silali trachytic shield volcano, the largest Quaternary volcano in the northern Gregory Rift, completely straddles the East African Rift.  An impressive 5 x 8 km summit caldera with 300 m deep walls is thought to have formed about 63,000 years ago.  Caldera formation is thought to have been incremental, related to eruption of the Kantenmening basaltic and trachytic lava flows.  A series of summit-area lava benches formed by eruptions from circumferential fissures has produced a volcano morphologically similar to Galapagos Islands volcanoes.  Northern, eastern, and southern flanks are cut by a prominent broad rift zone 10-km wide and 30-km long, dotted with numerous pyroclastic cones.  Lava domes on the upper eastern flank formed during the late Pleistocene and early Holocene, until about 7 ka.  Youthful parasitic cones abound on the caldera floor and on the northern and NE flanks; the youngest lava flows may be little more than a few hundred years old (Williams et al. 1984).  Geothermal activity occurs within the caldera and on the upper eastern flanks.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-052&amp;volpage=photos&amp;photo=100039">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-052">Smithsonian Volcano Information</a></td></tr></table>	(1.1499999999999999,36.229999999999997)
113	Paka	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Paka</b></font><br /><font size="5"><b>Kenya</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/100038.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1697 m<br /><b>Latitude:</b> 0.92&deg;N<br /><b>Longitude:</b> 36.18&deg;E</td></tr><tr><td colspan="2"><p align="justify">The dominantly Pleistocene Paka shield volcano in the Gregory Rift contains a small 1.5-km-wide summit caldera.  Eruption of large volumes of trachytic pyroclastic rocks around the end of the Pleistocene and the beginning of the Holocene formed a NW-trending ridge of pyroclastic cones across the summit region; collapse of this area formed the summit caldera and associated craters.  A second large crater SE of the caldera is 0.5 x 1 km wide and contains a pumice cone.  The summit caldera is narrowly breached on the north side, which has funneled post-caldera lava flows in this direction.  The three youngest post-caldera pyroclastic cones on the NE flank may be only a few hundred years old.  A series of viscous trachytic lava flows were erupted from vents on the volcano's lower flanks.  Young fissure-fed basalts were also erupted to the south, between Paka and Korosi volcanoes.  Surficial geothermal activity is widespread at Paka both within the summit caldera and on extensive portions of the northern flank.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-053&amp;volpage=photos&amp;photo=100038">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-053">Smithsonian Volcano Information</a></td></tr></table>	(0.92000000000000004,36.18)
114	Korosi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Korosi</b></font><br /><font size="5"><b>Kenya</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/100037.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Tuff ring<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1446 m<br /><b>Latitude:</b> 0.77&deg;N<br /><b>Longitude:</b> 36.12&deg;E</td></tr><tr><td colspan="2"><p align="justify">The trachytic Korosi shield volcano lies at the north end of Lake Baringo.  Unlike other rift valley volcanoes, it does not contain a summit caldera.  Lava domes on the northern flanks have fed trachytic lava flows.  The major stage of Korosi volcanism spanned a period between 0.4 and 0.1 million years ago and included the eruption of voluminous fluid basaltic lava flows and pyroclastic cone formation along a NNE-trending fissure cutting across the axis of the shield volcano.  This was followed by the eruption of trachytic lava domes and pumice/scoria cones.  The youngest activity, consisting of fissure-fed basaltic lava flows on the lower northern flanks between Korosi and Paka, was probably coeval with the latest eruptions on Ol Kokwe to the south, which are only a few hundred to a few thousand years old (Dunkley et al. 1993).  Fumaroles and hot steaming ground occur around the summit cones and NW flanks over an area of 30 sq km.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-054&amp;volpage=photos&amp;photo=100037">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-054">Smithsonian Volcano Information</a></td></tr></table>	(0.77000000000000002,36.119999999999997)
115	Ol Kokwe	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ol Kokwe</b></font><br /><font size="5"><b>Kenya</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/100036.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Scoria cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1130 m<br /><b>Latitude:</b> 0.62&deg;N<br /><b>Longitude:</b> 36.075&deg;E</td></tr><tr><td colspan="2"><p align="justify">The elongated Ol Kokwe Island in the center of Lake Baringo SW of Korosi volcano consists of young basaltic scoria cones that cap a trachytic shield volcano.  The volcano is the smallest in the northern part of the Kenya rift valley.  N-S-trending faults cut the complex, producing west-facing scarps.  Smaller islands to the north and south are faulted basaltic lava flows; Parmalok Island to the SW is a breached trachytic tuff cone that fed a small lava flow.  The latest eruptive activity at Ol Kokwe was estimated to have occurred within the past thousand years (Smith 1991, pers. comm.).  Hot springs, boiling mud pools, and fumaroles are present along the faults on the NE peninsula of the island and are frequently visited by tourists.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-055&amp;volpage=photos&amp;photo=100036">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-055">Smithsonian Volcano Information</a></td></tr></table>	(0.62,36.075000000000003)
116	Nyambeni Hills	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Nyambeni Hills</b></font><br /><font size="5"><b>Kenya</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/112019.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 750+ m<br /><b>Latitude:</b> 0.23&deg;N<br /><b>Longitude:</b> 37.87&deg;E</td></tr><tr><td colspan="2"><p align="justify">The broad NE-SW-trending Nyambeni shield volcano is capped by numerous phonolitic cumulodomes and basaltic cones and lava flows of late-Pleistocene to Holocene age (Hackman et al., 1989).  The basaltic cinder cones are the youngest features of Nyambeni Hills volcano.  They are clustered in a NE-trending belt along the crest of the shield, in a N-S-trending area including the Mula Hills, and in the Giaki area.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-056&amp;volpage=photos&amp;photo=112019">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-056">Smithsonian Volcano Information</a></td></tr></table>	(0.23000000000000001,37.869999999999997)
117	Menengai	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Menengai</b></font><br /><font size="5"><b>Kenya</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111057.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2278 m<br /><b>Latitude:</b> 0.20&deg;S<br /><b>Longitude:</b> 36.07&deg;E</td></tr><tr><td colspan="2"><p align="justify">The massive Menengai shield volcano occupies the floor of the East African Rift.  Construction of a 30 cu km shield volcano beginning about 200,000 years ago was followed by the eruption of two voluminous ash-flow tuffs, each preceded by major pumice falls.  The first took place about 29,000 years ago and produced a large caldera.  The second major eruption, producing about 30 cu km of compositionally zoned peralkaline trachytic magma about 8000 years ago, was associated with formation of the present-day 12 x 8 km summit caldera.  More than 70 post-caldera lava flows cover the caldera floor, the youngest of which may be only a few hundred years old.  No historical eruptions are known from Menengai.  Fumarolic activity is restricted to the caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-06=&amp;volpage=photos&amp;photo=111057">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-06=">Smithsonian Volcano Information</a></td></tr></table>	(-0.20000000000000001,36.07)
118	Homa Mountain	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Homa Mountain</b></font><br /><font size="5"><b>Kenya</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/094071.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1751 m<br /><b>Latitude:</b> 0.38&deg;S<br /><b>Longitude:</b> 34.50&deg;E</td></tr><tr><td colspan="2"><p align="justify">Homa Mountain is a large carbonatitic complex that forms a broad peninsula on the eastern shore of Lake Victoria.  The 1751-m-high flat-topped summit of the volcano rises about 600 m above the lake.  This dominantly Miocene-to-Pleistocene volcanic complex contains numerous flank vents, including the carbonatitic and ultramafic Lake Simbi maar on the lower east flank.  The Chiewo, Got Ojawa, and Got Oloo vents on the southern and western sides of Homa Mountain were formed during the latest stage of carbonatitic activity.  Legends of inhabitants near the Lake Simbi maar suggest that it may have been formed in historical time.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-07=&amp;volpage=photos&amp;photo=094071">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-07=">Smithsonian Volcano Information</a></td></tr></table>	(-0.38,34.5)
119	Elmenteita Badlands	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Elmenteita Badlands</b></font><br /><font size="5"><b>Kenya</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111058.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2126 m<br /><b>Latitude:</b> 0.52&deg;S<br /><b>Longitude:</b> 36.27&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Elmenteita Badlands, located between Lake Elmenteita and Eburru volcano, is an area of pyroclastic cones and lava flows of varying ages.  Large basaltic lava flows and basaltic ash cones of Holocene age post-date the 10,000-year-old high-stand of Lake Elmenteita (Thomson and Dodson, 1963).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-071&amp;volpage=photos&amp;photo=111058">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-071">Smithsonian Volcano Information</a></td></tr></table>	(-0.52000000000000002,36.270000000000003)
120	Ol Doinyo Eburru	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ol Doinyo Eburru</b></font><br /><font size="5"><b>Kenya</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111059.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2856 m<br /><b>Latitude:</b> 0.65&deg;S<br /><b>Longitude:</b> 36.22&deg;E</td></tr><tr><td colspan="2"><p align="justify">Eburru volcano is elongated perpendicular to the Gregory Rift NW of Lake Naivasha.  The 2856-m-high, E-W-trending main edifice is eroded, but young partly vegetated rhyolitic domes occur on the east flank and are probably of Holocene age (Thompson and Dodson, 1963).   Pleistocene phonolitic and trachytic lava flows are overlain by rhyolitic obsidian lava flows forming much of the northern and NE slopes of the main massif.  A prominent late-Pleistocene rhyolitic lava flow from a SE-flank vents extends almost to Lake Naivasha.  Extensive fumarolic activity occurs at cinder cones and craters constructed along dominantly N-S-trending faults cutting the massif.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-08=&amp;volpage=photos&amp;photo=111059">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-08=">Smithsonian Volcano Information</a></td></tr></table>	(-0.65000000000000002,36.219999999999999)
121	Olkaria	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Olkaria</b></font><br /><font size="5"><b>Kenya</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111060.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pumice cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2434 m<br /><b>Latitude:</b> 0.904&deg;S<br /><b>Longitude:</b> 36.292&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Olkaria volcanic complex, located immediately south of Lake Naivasha and west of Longonot volcano, comprises up to 80 individual commenditic and other peralkaline rhyolitic centers.  A thick, geochemically diverse basal complex is overlain by a dominantly silicic lava-dome and lava-flow complex active from about 20,000 years ago to the present.  The youngest known eruption originated from the Ololbutot fissue on the SE side of the complex produced lava flows and a pumice flow and has a radiocarbon age of about 180 years.  Fumarolic activity occurs at the Njorowa Gorge and at the Orengingnai and Olkaria (Orgaria) pumice cones.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-09=&amp;volpage=photos&amp;photo=111060">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-09=">Smithsonian Volcano Information</a></td></tr></table>	(-0.90400000000000003,36.292000000000002)
122	Longonot	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Longonot</b></font><br /><font size="5"><b>Kenya</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/094011.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2776 m<br /><b>Latitude:</b> 0.914&deg;S<br /><b>Longitude:</b> 36.446&deg;E</td></tr><tr><td colspan="2"><p align="justify">The trachytic Longonot stratovolcano SE of Lake Naivasha in the Gregory Rift valley contains a 8 x 12 km caldera.  Formation of the caldera accompanied large explosive eruptions about 21,000 years ago.  A large central cone that was constructed within the caldera forms the 2776-m-high summit of the volcano.  The younger cone is truncated by a circular, 1.8-km-wide crater.  Post-caldera lavas are found on the caldera floor and the volcano's flanks, marking a late stage of effusive eruptions.  A well-preserved satellitic cone is located on the NE flank.  Masai tradition records a lava flow on the northern flank during the 19th century.  Similarly youthful-looking lava flows occur on the SW flank.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-10=&amp;volpage=photos&amp;photo=094011">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-10=">Smithsonian Volcano Information</a></td></tr></table>	(-0.91400000000000003,36.445999999999998)
123	Suswa	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Suswa</b></font><br /><font size="5"><b>Kenya</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/114076.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 2356 m<br /><b>Latitude:</b> 1.175&deg;S<br /><b>Longitude:</b> 36.35&deg;E</td></tr><tr><td colspan="2"><p align="justify">The southernmost caldera of the Kenya rift, Suswa contains a prominent lava cone on the south side of its 8 x 12 km caldera.  Suswa lies south of Longonot volcano and about 50 km WNW of the capital city of Nairobi.  Construction of an early shield volcano was followed by eruption of voluminous Pleistocene pumice flows and lava flows that accompanied incremental formation of the caldera.  The 2356-m summit of the phonolitic-to-trachytic volcano is formed by the post-caldera lava cone of Ol Doinyo Onyoke (&quot;The Red Mountain,&quot; also known as Ol Doinyo Nyukie) on the south side of the caldera.  Its large elongated summit crater is truncated on the north by a ring graben.  This unusual 5-km-wide circular graben at the center of the older caldera isolates a tilted island block of caldera-floor lava flows.  The latest eruptions of Suswa have originated from satellitic vents that have issued still-unvegetated lava flows that may be only a century or so old.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-11=&amp;volpage=photos&amp;photo=114076">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-11=">Smithsonian Volcano Information</a></td></tr></table>	(-1.175,36.350000000000001)
124	Ol Doinyo Lengai	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ol Doinyo Lengai</b></font><br /><font size="5"><b>Tanzania</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/001095.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2962 m<br /><b>Latitude:</b> 2.764&deg;S<br /><b>Longitude:</b> 35.914&deg;E</td></tr><tr><td colspan="2"><p align="justify">The symmetrical Ol Doinyo Lengai stratovolcano is the only volcano known to have erupted carbonatite tephras and lavas in historical time.  The prominent volcano, known to the Maasai as &quot;The Mountain of God,&quot; rises abruptly above the broad plain south of Lake Natron in the Gregory Rift Valley.  The cone-building stage of the volcano ended about 15,000 years ago and was followed by periodic ejection of natrocarbonatitic and nephelinite tephra during the Holocene.  Historical eruptions have consisted of smaller tephra eruptions and emission of numerous natrocarbonatitic lava flows on the floor of the summit crater and occasionally down the upper flanks.  The depth and morphology of the northern crater have changed dramatically during the course of historical eruptions, ranging from steep crater walls about 200 m deep in the mid-20th century to shallow platforms mostly filling the crater.  Long-term lava effusion in the summit crater beginning in 1983 had by the turn of the century mostly filled the northern crater; by late 1998 lava had begun overflowing the crater rim.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-12=&amp;volpage=photos&amp;photo=001095">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-12=">Smithsonian Volcano Information</a></td></tr></table>	(-2.7639999999999998,35.914000000000001)
125	Chyulu Hills	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Chyulu Hills</b></font><br /><font size="5"><b>Kenya</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111054.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 2188 m<br /><b>Latitude:</b> 2.68&deg;S<br /><b>Longitude:</b> 37.88&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 100-km-long NW-SE-trending Chyulu Hills volcanic field is located 150 km east of the Kenya Rift.  It contains several hundred small cones and flows, including numerous Recent cinder cones.  Two of these, Shaitani and Chainu, erupted during the mid-19th century.  Volcanic activity began about 1.4 million years ago with eruptions in the northern Chyulu Hills and migrated to the SE, where a large number of Holocene cones are found.  Many of the cinder cones are aligned along dominantly NW-trending older faults and younger NNE-trending fissures.  The silica contents of the lava flows increased with time.  Early flows consisted of foidites; later Holocene lava flows are basanites and alkali basalts.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-13=&amp;volpage=photos&amp;photo=111054">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-13=">Smithsonian Volcano Information</a></td></tr></table>	(-2.6800000000000002,37.880000000000003)
126	Kilimanjaro	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kilimanjaro</b></font><br /><font size="5"><b>Tanzania</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/094014.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 5895 m<br /><b>Latitude:</b> 3.07&deg;S<br /><b>Longitude:</b> 37.35&deg;E</td></tr><tr><td colspan="2"><p align="justify">Massive Kilimanjaro, Africa's highest mountain, consists of three large stratovolcanoes constructed along a NW-SE trend.  The ice-capped, 5895-m-high summit towers 5200 m above the surrounding plains.  Activity at the older cone of Shira that forms the broad WNW shoulder of Kilimanjaro began during the Pliocene, and the extensively dissected Mawenzi forms a prominent, sharp-topped peak of Pleistocene age on the upper ESE flank dominated by a densely packed radial dike swarm.  More than 250 satellitic cones occupy a rift zone to the NW and SE of Kibo, the central stratovolcano.  A 2.4 x 3.6 km caldera gives the summit of Kibo an elongated, broad profile.  Most of Kilimanjaro was constructed during the Pleistocene, but a group of youthful-looking nested summit craters are of apparent Holocene age, and fumarolic activity continues.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-15=&amp;volpage=photos&amp;photo=094014">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-15=">Smithsonian Volcano Information</a></td></tr></table>	(-3.0699999999999998,37.350000000000001)
127	Meru	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Meru</b></font><br /><font size="5"><b>Tanzania</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/094020.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> 4565 m<br /><b>Latitude:</b> 3.25&deg;S<br /><b>Longitude:</b> 36.75&deg;E</td></tr><tr><td colspan="2"><p align="justify">Meru volcano, Africa's fourth highest mountain, is dwarfed by neighboring Kilimanjaro volcano, but is an impressive peak in its own right.  Seen from the west, Meru has a conical profile, but it contains a 5-km-wide breached caldera on the east side that formed about 7800 years ago when the summit of the volcano collapsed.  Associated massive debris avalanches and lahars traveled as far as the western flank of Kilimanjaro volcano.  Parasitic cones and lava domes are located on all sides; a maar field is present on the lower north flank.  The historically active Ash Cone forms a prominent symmetrical cone inside the breached caldera.   A second vent between it and the caldera headwall has fed lava flows that cover much of the caldera floor.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-16=&amp;volpage=photos&amp;photo=094020">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-16=">Smithsonian Volcano Information</a></td></tr></table>	(-3.25,36.75)
128	Igwisi Hills	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Igwisi Hills</b></font><br /><font size="5"><b>Tanzania</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Tuff cones</td><td width="50%" align="left"><b>Latitude:</b> 4.87&deg;S<br /><b>Longitude:</b> 31.92&deg;E</td></tr><tr><td colspan="2"><p align="justify">Three kimberlitic volcanoes of Pleistocene-to-Holocene age are located in the Igwisi Hills, WNW of the city of Tabora in NW Tanzania.  The volcanoes were erupted through granitic gneisses and are located on the western side of the Tanzanian Craton far from other Tanzanian volcanoes, which are located near the Gregory Rift.  Two well-preserved craters rising 15 to 45 m above the plain occur at Igwisi, with a less pristine crater in between.  The NE crater is the largest, 370 m in diameter, and has been breached on the ENE side, the source of a small lava flow about 1 km in length and width.  The SW crater is also breached on the ENE side, but no lava flow is visible.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-161">Smithsonian Volcano Information</a></td></tr></table>	(-4.8700000000000001,31.920000000000002)
129	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>Tanzania</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Latitude:</b> 8.63&deg;S<br /><b>Longitude:</b> 33.57&deg;E</td></tr><tr><td colspan="2"><p align="justify">A small unnamed basaltic tephra cone on the edge of the Usangu escarpment, overlooking the Usangu basin north of the Poroto Mountains, was considered by Ebinger et al. (1989) to be of probable Holocene age based on lack of vegetative cover.   A lava flow traveled westward away from the rift valley along the back-tilted flank of the rift.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-162">Smithsonian Volcano Information</a></td></tr></table>	(-8.6300000000000008,33.57)
130	SW Usangu Basin	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>SW Usangu Basin</b></font><br /><font size="5"><b>Tanzania</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2179 m<br /><b>Latitude:</b> 8.75&deg;S<br /><b>Longitude:</b> 33.80&deg;E</td></tr><tr><td colspan="2"><p align="justify">A group of late-Pleistocene to Holocene phonolitic lava domes is located at the SW end of the Usangu Basin, NE of the Poroto Mountains.  Vents of the SW Usangu Basin volcanic field are located along NNE-trending normal faults (Ebinger et al., 1989).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-163">Smithsonian Volcano Information</a></td></tr></table>	(-8.75,33.799999999999997)
131	Ngozi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ngozi</b></font><br /><font size="5"><b>Tanzania</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111094.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2622 m<br /><b>Latitude:</b> 8.97&deg;S<br /><b>Longitude:</b> 33.57&deg;E</td></tr><tr><td colspan="2"><p align="justify">Ngozi caldera is the most prominent volcanic feature of the Poroto Ridge, a transverse structure at the northern end of the Karonga basin.  The trachytic-to-phonolitic volcano contains a 3-km-wide caldera with a 1.5 x 2.5 km caldera lake that  is bounded by steep-walled cliffs 150-300 m high.  Numerous pyroclastic cones are situated along the ridge.  Eruption of the Kitulo Pumice, radiocarbon dated at  about 10,200 cal. years Before Present, is though to be related to formation of the caldera.  The youngest activity appears to have originated from the caldera and from youthful-looking pyroclastic cones to the north; the youngest known eruption produced a pyroclastic flow that swept at least 10 km to the south about 500 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-164&amp;volpage=photos&amp;photo=111094">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-164">Smithsonian Volcano Information</a></td></tr></table>	(-8.9700000000000006,33.57)
132	Izumbwe-Mpoli	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Izumbwe-Mpoli</b></font><br /><font size="5"><b>Tanzania</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1568 m<br /><b>Latitude:</b> 8.93&deg;S<br /><b>Longitude:</b> 33.40&deg;E</td></tr><tr><td colspan="2"><p align="justify">Two melanephelinite cones of probable Holocene age, Izumbwe and Mpoli, are located WNW of Ngozi caldera.  These pyroclastic cones represent the youngest eruptive activity within the Songwe Basin (Ebinger et al., 1989).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-165">Smithsonian Volcano Information</a></td></tr></table>	(-8.9299999999999997,33.399999999999999)
133	Rungwe	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Rungwe</b></font><br /><font size="5"><b>Tanzania</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/121026.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 2961 m<br /><b>Latitude:</b> 9.13&deg;S<br /><b>Longitude:</b> 33.67&deg;E</td></tr><tr><td colspan="2"><p align="justify">Rungwe volcano, the largest in the Karonga basin NW of Lake Malawi (Lake Nyasa), is capped by a 4-km-wide caldera that is breached to the west.  The western flanks of the volcano contain hummocky terrain from a debris-avalanche deposit produced by collapse of the summit and western flank.  The trachytic caldera is largely filled by a series of youthful-looking uneroded and sparsely vegetated pumice cones, lava domes, and explosion craters.  The latter are also found on the southern and northern flanks.  A large area of basaltic cones and lava flows are found on the NW flank of the volcano.  The most recent activity is of probable Holocene age.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-166&amp;volpage=photos&amp;photo=121026">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-166">Smithsonian Volcano Information</a></td></tr></table>	(-9.1300000000000008,33.670000000000002)
134	Kieyo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kieyo</b></font><br /><font size="5"><b>Tanzania</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/121028.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Scoria cones<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 2175 m<br /><b>Latitude:</b> 9.23&deg;S<br /><b>Longitude:</b> 33.78&deg;E</td></tr><tr><td colspan="2"><p align="justify">Late-stage activity of the Kieyo trachytic stratovolcano, NW of Lake Malawi (Lake Nyassa), consisted of the formation of numerous maars and cinder cones.  Maars, some of which contain lakes, surround the Kieyo area, and young basaltic cinder cones and lava flows cover an extensive area south of Kieyo.  The latest eruption around 1800 AD took place from two parasitic tephritic cones that were constructed along a NW-trending fissure: Sarabwe and Fiteko.  The eruption produced lava flows that overran several villages.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-17=&amp;volpage=photos&amp;photo=121028">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0202-17=">Smithsonian Volcano Information</a></td></tr></table>	(-9.2300000000000004,33.780000000000001)
135	Fort Portal	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Fort Portal</b></font><br /><font size="5"><b>Uganda</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120069.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Tuff cones<br />&nbsp;&nbsp;&nbsp; Maars<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 1615 m<br /><b>Latitude:</b> 0.70&deg;N<br /><b>Longitude:</b> 30.25&deg;E</td></tr><tr><td colspan="2"><p align="justify">The carbonatite lavas and tuffs of the Fort Portal volcanic field in Uganda, NE of Mount Ruwenzori between Lake Albert and Lake Edward, consists of a group of tuff cones and maars covering an area of about 145 sq km.  About 50 volcanic vents, some of which now contain crater lakes, were erupted through basement rocks of Precambrian gneiss in an WSW-ENE-trending area north of the town of Fort Portal.  Several additional vents are located in the Kasekere (Rusekere) area to the NE.  Radiocarbon dates of about 4700 to 4000 years ago were obtained from ash deposits from the Fort Portal volcanic field.   Holmes (1950) noted that Kasensankaranga Crater in the Fort Portal area means &quot;spewer of roasted material,&quot; implying an historical age.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0203-001&amp;volpage=photos&amp;photo=120069">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0203-001">Smithsonian Volcano Information</a></td></tr></table>	(0.69999999999999996,30.25)
136	Katwe-Kikorongo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Katwe-Kikorongo</b></font><br /><font size="5"><b>Uganda</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120068.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Tuff cones<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 1067 m<br /><b>Latitude:</b> 0.08&deg;S<br /><b>Longitude:</b> 29.92&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Katwe-Kikorongo volcanic field, stretching from the NE shore of Lake Edward to the western shore of Lake George, south of the Ruwenzori Range, is the most extensive of a series of volcanic fields in the Western Rift Valley of Uganda.  The volcanic field, straddling the equator, covers an area of about 180 sq km and contains a group of about 80 foiditic tuff cones and maars, some of which are filled by lakes.  Lake Katwe is a shallow 3-km-long body of water that occupies two of three intersecting craters immediately NE of Lake Edward.  Local folk tales suggest that volcanism in the Katwe-Kikorongo area has continued into historical times.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0203-003&amp;volpage=photos&amp;photo=120068">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0203-003">Smithsonian Volcano Information</a></td></tr></table>	(-0.080000000000000002,29.920000000000002)
137	Bunyaruguru	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bunyaruguru</b></font><br /><font size="5"><b>Uganda</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/114094.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Maars<br />&nbsp;&nbsp;&nbsp; Tuff cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1554 m<br /><b>Latitude:</b> 0.20&deg;S<br /><b>Longitude:</b> 30.08&deg;E</td></tr><tr><td colspan="2"><p align="justify">The late-Plestocene to Holocene Bunyaruguru volcanic field, also known as the Kichwambe volcanic field, straddles the equator along the eastern side of the Western Rift Valley, south of Lake George.  The Bunyaruguru volcanic field contains more than 130 maars, 27 of which contain lakes with water ranging from fresh to saline.  Friable calcareous volcanic tuffs are inter-bedded with Pleistocene and Recent sediments.  Only a few foiditic lava flows are found in the volcanic field.  Although no dated eruptions are known, Reece (1955) noted that volcanic activity probably continued into historical times.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0203-004&amp;volpage=photos&amp;photo=114094">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0203-004">Smithsonian Volcano Information</a></td></tr></table>	(-0.20000000000000001,30.079999999999998)
138	Katunga	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Katunga</b></font><br /><font size="5"><b>Uganda</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Tuff cone</td><td width="50%" align="left"><b>Summit Elev:</b> 1707 m<br /><b>Latitude:</b> 0.471&deg;S<br /><b>Longitude:</b> 30.191&deg;E</td></tr><tr><td colspan="2"><p align="justify">Katunga, an isolated tuff cone with associated lava flows located east of Lake Edward, is the southernmost feature of a N-S-trending chain of high-potassium foditic volcanic fields in the Western Rift Valley of Uganda.  Katunga is the type locality of the rock type katungite, an olivine-melilitite.  The undissected tuff cone was erupted through metamorphic basement rocks and its rim and flanks are blanketed with ejected schists.  Katunga contains a freshwater lake in its summit crater.  Two lava flows traveled to the NE from vents on the north and NE flanks.  The age of the cone is uncertain, but it is contemporaneous with late-Pleistocene to Recent tuff cones in the Bunyaruguru area, and the undissected condition of the tuff cone and associated lava flows implies a young age.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0203-005">Smithsonian Volcano Information</a></td></tr></table>	(-0.47099999999999997,30.190999999999999)
139	May-ya-moto	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>May-ya-moto</b></font><br /><font size="5"><b>Democratic Republic of Congo</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Fumarole field</td><td width="50%" align="left"><b>Summit Elev:</b> 950 m<br /><b>Latitude:</b> 0.93&deg;S<br /><b>Longitude:</b> 29.33&deg;E</td></tr><tr><td colspan="2"><p align="justify">May-ya-moto, also known as Maji ja moto, is an isolated hydrothermal field in the Albert National Park south of Lake Edward.  The thermal area is located at an altitude of 950 m in the eastern part of the Democratic Republic of Congo NW of the Virunga Mountains about 38 km north of the town of Rutschuru.   The May-ya-moto thermal area contains fumaroles and hot springs with temperatures of less than 100 degrees Centigrade.  Although the age of volcanic activity was not stated, May-ya-moto was included in the Catalog of Active Volcanoes of the World (Richard and Neumann van Padang, 1957) based on its thermal activity.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0203-01=">Smithsonian Volcano Information</a></td></tr></table>	(-0.93000000000000005,29.329999999999998)
140	Nyamuragira	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Nyamuragira</b></font><br /><font size="5"><b>Democratic Republic of Congo</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/109084.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3058 m<br /><b>Latitude:</b> 1.408&deg;S<br /><b>Longitude:</b> 29.20&deg;E</td></tr><tr><td colspan="2"><p align="justify">Africa's most active volcano, Nyamuragira is a massive high-potassium basaltic shield volcano that rises about 25 km north of Lake Kivu, NW of Nyiragongo volcano.  Nyamuragira,  also known as Nyamulagira, has a volume of 500 cu km, and extensive lava flows from the volcano blanket 1500 sq km of the western branch of the East African Rift.  The broad low-angle shield volcano contrasts dramatically with its steep-sided neighbor Nyiragongo.  The 3058-m-high summit of Nyamuragira is truncated by a small 2 x 2.3 km caldera that has walls up to about 100 m high.  Historical eruptions have occurred within the summit caldera, frequently modifying the morphology of the caldera floor, as well as from the numerous fissures and cinder cones on the volcano's flanks.  A lava lake in the summit crater, active since at least 1921, drained in 1938, at the time of a major flank eruption.  Historical lava flows extend down the flanks more than 30 km from the summit, reaching as far as Lake Kivu.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0203-02=&amp;volpage=photos&amp;photo=109084">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0203-02=">Smithsonian Volcano Information</a></td></tr></table>	(-1.4079999999999999,29.199999999999999)
141	Nyiragongo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Nyiragongo</b></font><br /><font size="5"><b>Democratic Republic of Congo</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/058064.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3470 m<br /><b>Latitude:</b> 1.52&deg;S<br /><b>Longitude:</b> 29.25&deg;E</td></tr><tr><td colspan="2"><p align="justify">One of Africa's most notable volcanoes, Nyiragongo contained a lava lake in its deep summit crater that was active for half a century before draining catastrophically through its outer flanks in 1977.  In contrast to the low profile of its neighboring shield volcano, Nyamuragira, 3470-m-high Nyiragongo displays the steep slopes of a stratovolcano.   Benches in the steep-walled, 1.2-km-wide summit crater mark levels of former lava lakes, which have been observed since the late-19th century.  Two older stratovolcanoes, Baruta and Shaheru, are partially overlapped by Nyiragongo on the north and south.  About 100 parasitic cones are located primarily along radial fissures south of Shaheru, east of the summit, and along a NE-SW zone extending as far as Lake Kivu.  Many cones are buried by voluminous lava flows that extend long distances down the flanks of the volcano, which is characterized by the eruption of foiditic rocks.  The extremely fluid 1977 lava flows caused many fatalities, as did lava flows that inundated portions of the major city of Goma in January 2002.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0203-03=&amp;volpage=photos&amp;photo=058064">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0203-03=">Smithsonian Volcano Information</a></td></tr></table>	(-1.52,29.25)
142	Karisimbi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Karisimbi</b></font><br /><font size="5"><b>Dem Rep Congo-Rwanda border</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111089.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 4507 m<br /><b>Latitude:</b> 1.50&deg;S<br /><b>Longitude:</b> 29.45&deg;E</td></tr><tr><td colspan="2"><p align="justify">Karisimbi, the highest of the Virunga volcanoes, is a complex volcano with a symmetrical sharp-peaked summit.  The 2-km-wide Branca caldera, located SE of the 4507-m-high summit, is filled by viscous lava flows and two explosion craters.  The large, 1.2-km-wide Muntango pit crater is located south of the summit of the basanitic-to-trachytic volcano.  A broad lava plain, formed from lava flows erupted within the caldera and along a chain of parasitic cones, extends SW.  More than 100 parasitic cones erupted along a NNE-SSW zone that extends to the shores of Lake Kivu.  The youngest Potassium-Argon date obtained is about 10,000 years before present (de Mulder, 1985).  The youngest eruptions from Karisimbi produced a group of dome-shaped parasitic vents east of the caldera, which fed viscous lava flows that traveled as far as 12 km to the east, and lava flows from the SW-flank satellitic lava vents.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0203-04-&amp;volpage=photos&amp;photo=111089">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0203-04-">Smithsonian Volcano Information</a></td></tr></table>	(-1.5,29.449999999999999)
143	Visoke	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Visoke</b></font><br /><font size="5"><b>Dem Rep Congo-Rwanda border</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/086068.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3711 m<br /><b>Latitude:</b> 1.47&deg;S<br /><b>Longitude:</b> 29.492&deg;E</td></tr><tr><td colspan="2"><p align="justify">The symmetrical Visoke volcano is the NE-most of a cluster of large stratovolcanoes at the southern end of the Virunga Range on the border of the Democratic Republic of Congo and Rwanda.  The 3711-m-high stratovolcano contains a 450-m-wide lake in its summit crater.  A NE-SW-trending fissure zone has produced many cinder cones NE of the trachyandesitic volcano.  An eruption in 1957 formed two small cones on the north flank, 11 km from the summit.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0203-05-&amp;volpage=photos&amp;photo=086068">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0203-05-">Smithsonian Volcano Information</a></td></tr></table>	(-1.47,29.492000000000001)
144	Muhavura	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Muhavura</b></font><br /><font size="5"><b>Uganda-Rwanda border</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111088.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 4127 m<br /><b>Latitude:</b> 1.38&deg;S<br /><b>Longitude:</b> 29.67&deg;E</td></tr><tr><td colspan="2"><p align="justify">Muhavura volcano rises to 4127 m at the NE end of the Virunga Range.  It is a relatively youthful stratovolcano with a small 40-m-wide lake in its summit crater.  The 3474-m-high Gahinga (Mgahinga) volcano is joined to Muhavura on the west by a broad saddle.  The two volcanoes have produced basanitic-to-trachyandesitic lavas.  A small parasitic crater has been recently active, but the age of the latest eruption of Muhavura is not known.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0203-06-&amp;volpage=photos&amp;photo=111088">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0203-06-">Smithsonian Volcano Information</a></td></tr></table>	(-1.3799999999999999,29.670000000000002)
145	Tshibinda	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tshibinda</b></font><br /><font size="5"><b>Democratic Republic of Congo</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1460+ m<br /><b>Latitude:</b> 2.32&deg;S<br /><b>Longitude:</b> 28.75&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Tshibinda volcanic field, located west of the SW end of Lake Kivu near the Congo-Rwanda border, consists of a group of three basaltic cinder cones and associated lava flows.  Their age is not known precisely, but they may have been active within the past 2000 years.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0203-08-">Smithsonian Volcano Information</a></td></tr></table>	(-2.3199999999999998,28.75)
146	San Carlos	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>San Carlos</b></font><br /><font size="5"><b>Bioko Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117032.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2260 m<br /><b>Latitude:</b> 3.35&deg;N<br /><b>Longitude:</b> 8.52&deg;E</td></tr><tr><td colspan="2"><p align="justify">San Carlos, a 2260-m-high basaltic shield volcano with a broad summit caldera, forms the toe on the SW side of boot-shaped Bioko (Fernando Poo) Island.  San Carlos was classified as having been active during the last 2000 years (International Association of Volcanology and Chemistry of the Earth's Interior, 1973), although little is known of its geologic history.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0204-002&amp;volpage=photos&amp;photo=117032">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0204-002">Smithsonian Volcano Information</a></td></tr></table>	(3.3500000000000001,8.5199999999999996)
147	San Joaquin	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>San Joaquin</b></font><br /><font size="5"><b>Bioko Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117031.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2009 m<br /><b>Latitude:</b> 3.35&deg;N<br /><b>Longitude:</b> 8.63&deg;E</td></tr><tr><td colspan="2"><p align="justify">San Joaquin, also known as Pico Biao or Pico do Moka, is a 2009-m-high basaltic shield volcano on the SE side of Bioko (Fernando Poo) Island.  A small lake-filled caldera cuts the summit of the forested shield volcano, and a crater lake lies on the NE flank of the volcano.  San Joaquin was classified as having been active during the last 2000 years (International Association of Volcanology and Chemistry of the Earth's Interior, 1973), although little is known about its geologic history.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0204-003&amp;volpage=photos&amp;photo=117031">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0204-003">Smithsonian Volcano Information</a></td></tr></table>	(3.3500000000000001,8.6300000000000008)
148	Santa Isabel	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Santa Isabel</b></font><br /><font size="5"><b>Bioko Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111014.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3007 m<br /><b>Latitude:</b> 3.58&deg;N<br /><b>Longitude:</b> 8.75&deg;E</td></tr><tr><td colspan="2"><p align="justify">Santa Isabel is the largest and highest of three coalescing basaltic shield volcanoes forming Bioko (Fernando Poo) Island.  Lying on the continental shelf along the Cameroon Line, Santa Isabel is modified by the same NNE faults as Mt. Cameroon across the Gulf of Guinea on the African mainland.  The 3007-m-high volcano contains numerous satellitic cinder cones.  Santa Isabel is the only Bioko Island volcano with reported historical eruptions, although they are poorly documented.  Three eruptions, during the late-19th and early-20th centuries, have been reported form SE flank vents.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0204-004&amp;volpage=photos&amp;photo=111014">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0204-004">Smithsonian Volcano Information</a></td></tr></table>	(3.5800000000000001,8.75)
149	Cameroon	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cameroon</b></font><br /><font size="5"><b>Cameroon</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/086085.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 4095 m<br /><b>Latitude:</b> 4.203&deg;N<br /><b>Longitude:</b> 9.170&deg;E</td></tr><tr><td colspan="2"><p align="justify">Mount Cameroon, one of Africa's largest volcanoes, rises to 4095 m above the coast of west Cameroon.  The massive steep-sided volcano of dominantly basaltic-to-trachybasaltic composition forms a volcanic horst constructed above a basement of Precambrian metamorphic rocks covered with Cretaceous to Quaternary sediments.  More than 100 small cinder cones, often fissure-controlled parallel to the long axis of the massive 1400 cu km volcano, occur on the flanks and surrounding lowlands.  A large satellitic peak, Etinde (also known as Little Cameroon), is located on the southern flank near the coast.  Historical activity, the most frequent of west African volcanoes, was first observed in the 5th century BC by the Carthaginian navigator Hannon.  During historical time, moderate explosive and effusive eruptions have occurred from both summit and flank vents.  A 1922 SW-flank eruption produced a lava flow that reached the Atlantic coast, and a lava flow from a 1999 south-flank eruption stopped only 200 m from the sea.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0204-01=&amp;volpage=photos&amp;photo=086085">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0204-01=">Smithsonian Volcano Information</a></td></tr></table>	(4.2030000000000003,9.1699999999999999)
150	Tombel Graben	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tombel Graben</b></font><br /><font size="5"><b>Cameroon</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111035.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 500? m<br /><b>Latitude:</b> 4.75&deg;N<br /><b>Longitude:</b> 9.67&deg;E</td></tr><tr><td colspan="2"><p align="justify">Young cinder cones and maars dot the low-lying Tombel Graben (also referred to as the Tombel Plain) between Mount Cameroon and Mount Manengouba.  Activity in the 10-20 km wide graben began with the emission of large lava flows over a basement of Precambrian metamorphic rocks and Cretaceous sandstones and concluded with explosive activity forming numerous cinder cones.  The 800 sq km Tombel Graben volcanic field erupted basanitic, basaltic, and trachybasaltic rocks and contains three large lake-filled maars, including Barombi Mbo, a compound maar near the town of Kumba.  Legends record an eruption of Le Djungo (also known as Mont Pel) that destroyed a village, consistent with its youthful, unvegetated morphology.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0204-011&amp;volpage=photos&amp;photo=111035">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0204-011">Smithsonian Volcano Information</a></td></tr></table>	(4.75,9.6699999999999999)
151	Todra Volcanic Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Todra Volcanic Field</b></font><br /><font size="5"><b>Niger</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119024.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1780 m<br /><b>Latitude:</b> 17.68&deg;N<br /><b>Longitude:</b> 8.50&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Todra volcanic field covers a broad area of about 1050 sq km in the Tuareg shield in the southern Ar region of Niger.  Activity began with the eruption of about 30 trachytic and phonolitic volcanoes through Precambrian basement rocks.  This was followed by the formation of about 130 basaltic cones that typically produced a valley filling lava flow.  A series of NW-SE-trending faults control volcano locations.  The date of the latest eruption of the Todra volcanic field is not known, but may have been as recent as a few centuries ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0205-001&amp;volpage=photos&amp;photo=119024">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0205-001">Smithsonian Volcano Information</a></td></tr></table>	(17.68,8.5)
152	Tin Zaouatene Volcanic Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tin Zaouatene Volcanic Field</b></font><br /><font size="5"><b>Mali</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Latitude:</b> 19.83&deg;N<br /><b>Longitude:</b> 2.83&deg;E</td></tr><tr><td colspan="2"><p align="justify">A small volcanic field in the Tin Zaouatene area of Iforas province in eastern Mali, near the border with Algeria and Niger, was assigned a Holocene age (Liegeois et al., 2005).  The alkaline Tin Zaouatene volcanic field covers an area of about 50 sq km in the Adrar des Iforas massif of the Tuareg shield.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0205-002">Smithsonian Volcano Information</a></td></tr></table>	(19.829999999999998,2.8300000000000001)
153	Tahalra Volcanic Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tahalra Volcanic Field</b></font><br /><font size="5"><b>Algeria</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119026.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Maars<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1467 m<br /><b>Latitude:</b> 22.67&deg;N<br /><b>Longitude:</b> 5.00&deg;E</td></tr><tr><td colspan="2"><p align="justify">The elongated, E-W-trending Tahalra volcanic field covers an area of about 1800 sq km in the Hoggar Province of southern Algeria.  The large volcanic field lies WSW of the town of Tamanrasset and was active from the Miocene to the Holocene, producing alkaline strombolian cones and lava flows.  The high point of the volcanic field, which was constructed over a basement of Precambrian metamorphic and plutonic rocks of the Tuareg shield, lies near its eastern end.  A dozen trachytic-to-rhyolitic lava domes and spines formed during the Pliocene, and Pliocene-to Pleistocene activity formed about 100 small strombolian basaltic (mostly basanitic) cones.  The most recent activity during the Pleistocene and Holocene produced about 20 maars and cones along the northern margin of the volcanic field.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0205-004&amp;volpage=photos&amp;photo=119026">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0205-004">Smithsonian Volcano Information</a></td></tr></table>	(22.670000000000002,5)
154	Atakor Volcanic Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Atakor Volcanic Field</b></font><br /><font size="5"><b>Algeria</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119027.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Scoria cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2918 m<br /><b>Latitude:</b> 23.33&deg;N<br /><b>Longitude:</b> 5.83&deg;E</td></tr><tr><td colspan="2"><p align="justify">The massive Atakor volcanic field is the largest in the Hoggar (or Ahaggar) volcanic province of southern Algeria and covers an area of 2150 sq km.   Basaltic (mostly basanitic) scoria cones and lava flows of Pleistocene-Holocene age lie near spectacular older trachytic and phonolitic lava domes and volcanic necks that form some of the most dramatic scenery of northern Africa.  The latest stage of activity began around 1.95 million years and continued almost to the present.  Lava flows cover Holocene lake sediments dated at about 10,000 year Before Present (BP) and alluvial terraces in which Neolithic artifacts have been found.  Historical pottery has been found within lava flows in the Tahifet area, and oral traditions of the Tuareg people also suggest that eruptions were witnessed.  Sporadic fumaroles and persistent small-scale seismicity has been noted during historical time.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0205-005&amp;volpage=photos&amp;photo=119027">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0205-005">Smithsonian Volcano Information</a></td></tr></table>	(23.329999999999998,5.8300000000000001)
155	Manzaz Volcanic Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Manzaz Volcanic Field</b></font><br /><font size="5"><b>Algeria</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119028.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Scoria cones<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 1672 m<br /><b>Latitude:</b> 23.92&deg;N<br /><b>Longitude:</b> 5.83&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Manzaz volcanic field, north of the Atakor volcanic field in the Hoggar (Ahaggar) volcanic district of Algeria, consists of a large number of scoria cones and associated lava flows.  The volcanic field covers an area of 1500 sq km, overlying Precambrian metamorphic and plutonic rocks of the Tuareg shield.  Many cones are breached, and the dominantly basaltic and basanitic volcanic products are rich in peridotite and pyroxenite xenoliths and megacrysts.  The youngest volcanoes rest on Neolithic terraces and are of Holocene age.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0205-006&amp;volpage=photos&amp;photo=119028">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0205-006">Smithsonian Volcano Information</a></td></tr></table>	(23.920000000000002,5.8300000000000001)
156	Haruj	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Haruj</b></font><br /><font size="5"><b>Libya</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/089060.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field<br />&nbsp;&nbsp;&nbsp; Scoria cones<br />&nbsp;&nbsp;&nbsp; Explosion craters</td><td width="50%" align="left"><b>Summit Elev:</b> 1200 m<br /><b>Latitude:</b> 27.25&deg;N<br /><b>Longitude:</b> 17.50&deg;E</td></tr><tr><td colspan="2"><p align="justify">The extensive Pliocene-to-Holocene Haruj volcanic field covers a broad 45,000 sq km area in central Libya and contains very well-preserved basaltic scoria cones, lava flows, and explosion craters.  The youngest lava flows of the Haruj field (also known as Al-Haruj al Aswad or Djebel Haroudj) were considered by Klitzsch (1968) to be Holocene in age and are located at the northern side of the field.  The Haruj field contains about 150 volcanoes, 30 of which are small shield volcanoes with heights of between 100 and 400 m.   The Haruj volcanics are located along the SE extension of the Hon graben system of late Cretaceous to Tertiary age, near the intersection of the Paleozoic southern Haruj uplift and the western edge of the Mesozoic Tibesti-Sirte uplift.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0205-007&amp;volpage=photos&amp;photo=089060">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0205-007">Smithsonian Volcano Information</a></td></tr></table>	(27.25,17.5)
157	Tarso Th	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tarso Th</b></font><br /><font size="5"><b>Chad</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119033.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 2000 m<br /><b>Latitude:</b> 21.33&deg;N<br /><b>Longitude:</b> 16.33&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Tarso Th Pleistocene-to-Holocene volcanic field in the NW part of the Tibesti Range of Chad contains 150 scoria cones and two maars.  Basaltic lava flows of the Tarso Th volcanic field fill valleys and plains over an area of 80 km in an E-W direction and 20-30 km in a N-S direction in the arid Tibesti Range north of the more well-known Tarso Toussid volcano.  The flows were erupted over a basement of Precambrian schists on the east and Paleozoic sandstones on the west.  Sediments within the Begour maar were radiocarbon dated at 8300 +/- 300 years (Hagedorn and Jakel, 1969).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0205-009&amp;volpage=photos&amp;photo=119033">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0205-009">Smithsonian Volcano Information</a></td></tr></table>	(21.329999999999998,16.329999999999998)
158	Tarso Toussid	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tarso Toussid</b></font><br /><font size="5"><b>Chad</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/103098.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3265 m<br /><b>Latitude:</b> 21.03&deg;N<br /><b>Longitude:</b> 16.45&deg;E</td></tr><tr><td colspan="2"><p align="justify">Tarso Toussid, a broad volcanic massif at the western end of the Tibesti Range, is capped by the Toussid stratovolcano, constructed at the western end of the 14-km-wide ignimbritic Yirrigue caldera of Pleistocene age.  The 6000 sq km Toussid massif was constructed over a basement of Precambrian schists on the east and Paleozoic sandstones on the west.  The summit of Toussid contains numerous fumaroles and very youthful lava flows that would be of historical age in an inhabited region (Vincent 1992, pers. comm.).  Fresh-looking trachytic and trachyandesitic lava flows from Toussid cover an area of 200 sq km and extend as far as 25 km from the summit on the western side.  The steep-sided, 1-km-deep, 8-km-wide Trou au Natron caldera cuts the SE rim of Yirrigue caldera and is one of the youngeset features of the massif.  Ehi Timi and Ehi Sosso volcanoes and the smaller 1.5-km-wide explosion crater of Doon Kidimi are located on the NE-to-ESE flanks of the massif.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0205-01=&amp;volpage=photos&amp;photo=103098">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0205-01=">Smithsonian Volcano Information</a></td></tr></table>	(21.030000000000001,16.449999999999999)
159	Tarso Voon	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tarso Voon</b></font><br /><font size="5"><b>Chad</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104064.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3100 m<br /><b>Latitude:</b> 20.92&deg;N<br /><b>Longitude:</b> 17.28&deg;E</td></tr><tr><td colspan="2"><p align="justify">The broad summit of Tarso Voon volcano, located in the west-central part of the Tibesti Range, is truncated by a shallow 14 x 18 km wide caldera.  Ignimbrite deposits surround the caldera to distances of 15-35 km.  Tarso Voon was constructed over a basement of Precambrian schists.  Youthful-looking Quaternary basaltic lava flows have been erupted from vents near the caldera rim over a 180 degree area extending counterclockwise from the NE and from Ehi Mousgau, a 3100-m-high stratovolcano located to the NW.  The Soborom solfatara field, the largest in the Tibesti Range, is located in an area of volcano-tectonic uplift 5 km west of the caldera rim.  Its fumaroles, active mud pots, and boiling waters are visited by Tibesti peoples for medicinal uses.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0205-02=&amp;volpage=photos&amp;photo=104064">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0205-02=">Smithsonian Volcano Information</a></td></tr></table>	(20.920000000000002,17.280000000000001)
160	Emi Koussi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Emi Koussi</b></font><br /><font size="5"><b>Chad</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/103050.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic shield<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3415 m<br /><b>Latitude:</b> 19.80&deg;N<br /><b>Longitude:</b> 18.53&deg;E</td></tr><tr><td colspan="2"><p align="justify">The large volcano of Emi Koussi at the SE end of the Tibesti Range forms the highest summit of the Sahara.  The 60 x 80 km massif was constructed over a basement of Cretaceous and Paleozoic sandstones.  Two nested calderas, 12 x 15 km in size, truncate the dominantly trachytic volcano, whose 3415 m high point lies on the southern caldera rim of the low-angle pyroclastic shield volcano.  The calderas contain several explosion craters, lava domes, and young scoria cones, along with lava flows of recent and pre-modern age (Geze et al., 1959).  The spectacular Era Kohor (Trou au Natron du Koussi) caldera on the SE floor of the 2nd caldera is 2-3 km wide and 350 m deep.  The latest activity in the calderas produced three maars, and numerous basaltic cinder cones and associated lava flows have been constructed both within the calderas and on their outer flanks.  The Yi-Yerra thermal area is located on the southern flank.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0205-021&amp;volpage=photos&amp;photo=103050">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0205-021">Smithsonian Volcano Information</a></td></tr></table>	(19.800000000000001,18.530000000000001)
161	Jebel Marra	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Jebel Marra</b></font><br /><font size="5"><b>Sudan</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119029.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 3042 m<br /><b>Latitude:</b> 12.95&deg;N<br /><b>Longitude:</b> 24.27&deg;E</td></tr><tr><td colspan="2"><p align="justify">The most prominent feature of the vast Jebel Marra volcanic field, located in the Darfur province of western Sudan, is the youthful Deriba caldera.  The 5-km-wide, steep-walled caldera, located at the southern end of the volcanic field, was formed about 3500 years ago at the time of the eruption of voluminous airfall pumice and pyroclastic flows that traveled more than 30 km from the volcano.  The Jebel Marra volcanic field covers a broad area of the Marra Mountains and contains early basaltic lava flows overlain by thick sequences of pyroclastic-flow deposits.  The northern part of the volcanic field displays trachytic lava plugs and spines forming residual inselbergs and young basaltic scoria cones and lava flows.  Ash eruptions at Deriba caldera may have continued into early historical time (Burton and Wickers, 1966), and fumarolic activity has been observed on the flanks of a small pyroclastic cone within the caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0205-03-&amp;volpage=photos&amp;photo=119029">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0205-03-">Smithsonian Volcano Information</a></td></tr></table>	(12.949999999999999,24.27)
162	Meidob Volcanic Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Meidob Volcanic Field</b></font><br /><font size="5"><b>Sudan</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104035.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Scoria cones<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 2000? m<br /><b>Latitude:</b> 15.32&deg;N<br /><b>Longitude:</b> 26.47&deg;E</td></tr><tr><td colspan="2"><p align="justify">The alkaline Meidob volcanic field in western Sudan, at the NE end of the Dafur volcanic province, covers an area of 5000 sq km with nearly 700 Pliocene-to-Holocene vents.  The volcanic field was constructed over an uplifted Precambrian igneous and metamorphic basement and is elongated in an E-W direction.  Basaltic scoria cones and associated lava flows dominate, but trachytic-phonolitic lava domes, tuff rings, and maars are among the youngest volcanic products.  Basaltic scoria cones are scattered throughout the field; their lavas have produced a broad lava plateau.  The central part of the field consists of younger phonolitic lava flows, trachytic pumice-fall deposits, ignimbrites, and maars.  The youngest dated eruptions about 5000 years ago produced a tuff ring and a lava flow.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0205-05-&amp;volpage=photos&amp;photo=104035">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0205-05-">Smithsonian Volcano Information</a></td></tr></table>	(15.32,26.469999999999999)
163	Bayuda Volcanic Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bayuda Volcanic Field</b></font><br /><font size="5"><b>Sudan</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104006.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Explosion craters</td><td width="50%" align="left"><b>Summit Elev:</b> 670? m<br /><b>Latitude:</b> 18.33&deg;N<br /><b>Longitude:</b> 32.75&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Bayuda volcanic field is located in the Bayuda Desert of NE Sudan, south of the major Abu Hamed bend of the Nile River about 300 km north of capital city of Khartoum.  More than 90 eruptive centers along a WNW-ESE line were constructed over Precambrian and Paleozoic granitic rocks near the center of the Bayuda Desert.  Most vents of the Bayuda field are cinder cones that produced lava flows which breached the cones.  About 10% of vents in the field are explosion craters, the largest of which, named Hosh ed Dalam, is 1.3 km wide and up to 500 m deep.  The youngest basalts of the Bayuda volcanic field appear to post-date the last period of moist climate in Sudan, which ended as recently as about 5000 years ago.  One of the least eroded lava flows at Bayuda was dated at  about 1100 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0205-06-&amp;volpage=photos&amp;photo=104006">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0205-06-">Smithsonian Volcano Information</a></td></tr></table>	(18.329999999999998,32.75)
164	Sharat Kovakab	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sharat Kovakab</b></font><br /><font size="5"><b>Syria</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 534 m<br /><b>Latitude:</b> 36.53&deg;N<br /><b>Longitude:</b> 40.85&deg;E</td></tr><tr><td colspan="2"><p align="justify">Sharat Kovakab is a truncated basaltic cone of Holocene age located in NW Syria (Malki, in International Association of Volcanology and Chemistry of the Earth's Interior, 1973).  One other cone is located nearby.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0300-01-">Smithsonian Volcano Information</a></td></tr></table>	(36.530000000000001,40.850000000000001)
165	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>Syria</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Latitude:</b> 36.67&deg;N<br /><b>Longitude:</b> 37.00&deg;E</td></tr><tr><td colspan="2"><p align="justify">An eruption that produced lava flows was reported to have occurred in 1222 AD at an unknown location near Kilis (also spelled Killis), in NW Syria near the border with Turkey (Catalog of Active Volcanoes of the World).  The city of Kilis lies just across the border in Turkey.  Miocene-to-Quaternary volcanic fields are found near the Aazaz area on the Syrian side of the border.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0300-02-">Smithsonian Volcano Information</a></td></tr></table>	(36.670000000000002,37)
166	Golan Heights	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Golan Heights</b></font><br /><font size="5"><b>Syria</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110039.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 1197 m<br /><b>Latitude:</b> 33.10&deg;N<br /><b>Longitude:</b> 35.97&deg;E</td></tr><tr><td colspan="2"><p align="justify">The basaltic Golan Heights volcanic field in the Anti-Lebanon Mountains of SW Syria near the borders with Lebanon and Israel contains numerous cinder cones of Pliocene-to-Holocene age.  The Golan Heights volcanic field covers a broad area NE of the Lake Tiberius (the Sea of Galilee) and SW of the city of Damascus (Dimashq) and includes the prehistoric cone of Majdel Shams in the Golan Heights.  The volcanic field lies on a basaltic plateau that dips to the west and SW, with steep slopes facing the Dead Sea rift valley.  It lies within the northern part of the massive alkaline Harrat Ash Shaam volcanic field that extends from southern Syria through NW Jordan to Saudi Arabia.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0300-03-&amp;volpage=photos&amp;photo=110039">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0300-03-">Smithsonian Volcano Information</a></td></tr></table>	(33.100000000000001,35.969999999999999)
167	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>Syria</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 945 m<br /><b>Latitude:</b> 33.00&deg;N<br /><b>Longitude:</b> 36.43&deg;E</td></tr><tr><td colspan="2"><p align="justify">An unnamed subalkaline basaltic volcanic field in SW Syria, south of Damascas (Dimashq) is the SW portion of a large area mapped as containing Holocene volcanic vents.  This volcanic field lies within the northern part of the massive alkaline Harrat Ash Shaam volcanic field that extends from southern Syria through NW Jordan to Saudi Arabia.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0300-04-">Smithsonian Volcano Information</a></td></tr></table>	(33,36.43)
168	Es Safa	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Es Safa</b></font><br /><font size="5"><b>Syria</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110041.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 979 m<br /><b>Latitude:</b> 33.25&deg;N<br /><b>Longitude:</b> 37.07&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Es Safa volcanic field, in southern Syria SE of the capital city of Damascas (Dimashq), consists of a lava field with broad areas containing Holocene volcanic vents.  The basaltic field (also referred to as As Safa) contains numerous vents erupted from NW-SE-trending fissures.  A boiling lava lake was reported in the Es Safa volcanic area in the middle of the 19th century.  This volcanic field lies within the northern part of the massive alkaline Harrat Ash Shaam volcanic field that extends from southern Syria through NE Jordan to Saudi Arabia.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0300-05-&amp;volpage=photos&amp;photo=110041">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0300-05-">Smithsonian Volcano Information</a></td></tr></table>	(33.25,37.07)
169	Jabal ad Druze	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Jabal ad Druze</b></font><br /><font size="5"><b>Syria</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119097.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 1803 m<br /><b>Latitude:</b> 32.658&deg;N<br /><b>Longitude:</b> 36.425&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Jabal ad Druze volcanic field, the southernmost in Syria, lies in the Haurun-Druze Plateau in SW Syria near the border with Jordan.  The most prominent feature of this volcanic field is 1803-m-high Jabal ad Druze (also known variously as Djebel Al-Arab, Jabal ed Duruz, Jabal al Druz, Jebel Duraz, Djebel ed Drouz).  The alkaline volcanic field consists of a group of 118 basaltic volcanoes active from the lower-Pleistocene to the Holocene.  The large SW Plateau depression is filled by basaltic lava flows from volcanoes aligned in a NW-SE direction.  This volcanic field lies within the northern part of the massive alkaline Harrat Ash Shaam volcanic field that extends from southern Syria through NW Jordan to Saudi Arabia.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0300-06-&amp;volpage=photos&amp;photo=119097">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0300-06-">Smithsonian Volcano Information</a></td></tr></table>	(32.658000000000001,36.424999999999997)
170	Al Harrah	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Al Harrah</b></font><br /><font size="5"><b>Saudi Arabia</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 1100 m<br /><b>Latitude:</b> 31.08&deg;N<br /><b>Longitude:</b> 38.42&deg;E</td></tr><tr><td colspan="2"><p align="justify">Al Harrah, a large basaltic volcanic field in northwestern Saudi Arabia near the Jordanian border, covers an area of 15,200 sq km.  The volcanic field forms the southern third of the massive Harrat Ash Shamah volcanic field, which extends from Syria through Jordan into northern Saudi Arabia.  The Saudi Arabian portion of the Harrat Ash Shamah volcanic field extends across a 210-km-long, roughly 75-km-wide NW-SE-trending area on the NE flanks of the Wadi Sirhan and reaches its 1100 m high point at Jabal al Amud.  Activity began during the Miocene; a younger eruptive stage, at the SE end of the volcanic field, occurred during the late-Pleistocene and Holocene (Brown et al., 1984).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0301-001">Smithsonian Volcano Information</a></td></tr></table>	(31.079999999999998,38.420000000000002)
171	Harrat ar Rahah	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Harrat ar Rahah</b></font><br /><font size="5"><b>Saudi Arabia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/105095.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 1950 m<br /><b>Latitude:</b> 27.80&deg;N<br /><b>Longitude:</b> 36.17&deg;E</td></tr><tr><td colspan="2"><p align="justify">Harrat ar Rahah is the northernmost of a series of Quaternary volcanic fields paralleling the Red Sea coast of Saudi Arabia.  The olivine basaltic volcanic field of Harrat ar Raha lies south of the Plain of El-'Hisma, south of the town of Tabuk.   There are fewer young volcanoes in Harrat ar Rahah than in other harrats (lava fields) to the south.  Harrat ar Rahah is erosionally divided into two segments and is about 35 km wide at its broadest extent on the west, narrowing down to less than a kilometer in width at the divide at Matar.  Lava flows are more numerous in the southern segment, where they rise up to 550 m above the Cambrian sandstone plain.  On the southern and SW sides the sandstones and the basaltic lava fields are dissected, and lava flows traveled mainly to the NE.  Neumann van Padang (1963) in the Catalog of Active Volcanoes of the World speculated that the Israelite account in Exodus 19:16-18 might refer to an eruption from Harrat ar Rahah.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0301-01=&amp;volpage=photos&amp;photo=105095">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0301-01=">Smithsonian Volcano Information</a></td></tr></table>	(27.800000000000001,36.170000000000002)
172	Harrat 'Uwayrid	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Harrat 'Uwayrid</b></font><br /><font size="5"><b>Saudi Arabia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104063.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 1920 m<br /><b>Latitude:</b> 27.08&deg;N<br /><b>Longitude:</b> 37.25&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Harrat 'Uwayrid, located in NW Saudi Arabia along the Bedouin pilgrim route to Syria, contains young basaltic scoria and tuff cones and associated lava fields.  The massive alkali olivine basaltic lava field reaches a height of 1920 m; it extends about 125 km in a NW-SE direction and is contiguous with the Harrat ar Rahat volcanic field to the NW.  The Catalog of Active Volcanoes of the World (Neumann van Pandang, 1963a) indicated that an eruption in about 640 AD at Harrat 'Uwayrid may have been from either Hala-'l-Bedr or Hala-'l-'Ischia, or both.  Bedouin legends say that Hala-'l-Bedr erupted fire and stones, killing herdsmen and their cattle and sheep.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0301-02=&amp;volpage=photos&amp;photo=104063">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0301-02=">Smithsonian Volcano Information</a></td></tr></table>	(27.079999999999998,37.25)
173	Harrat Lunayyir	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Harrat Lunayyir</b></font><br /><font size="5"><b>Saudi Arabia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104033.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 1370 m<br /><b>Latitude:</b> 25.17&deg;N<br /><b>Longitude:</b> 37.75&deg;E</td></tr><tr><td colspan="2"><p align="justify">Harrat Lunayyir is a basaltic volcanic field in NW Saudi Arabia, east of the Red Sea port of Umm Lajj.  It contains about 50 volcanic cones that were constructed over Precambrian crystalline rocks along a N-S axis.  Harrat Lunayyir is one of the smallest of the Holocene lava fields of Saudi Arabia, but individual flow lobes radiate long distances from the center of the Harrat, and flows reached the Red Sea in two places.   Lava flows are basaltic to basanitic in composition, and the Holocene flows are alkali olivine basalts.  One of the cones may have erupted around the 10th century AD or earlier.  A seismic swarm in May 2009 was interpreted to be consistent with intrusion of an 8-km-long dike to shallow crustal levels.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0301-04-&amp;volpage=photos&amp;photo=104033">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0301-04-">Smithsonian Volcano Information</a></td></tr></table>	(25.170000000000002,37.75)
174	Harrat Ithnayn	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Harrat Ithnayn</b></font><br /><font size="5"><b>Saudi Arabia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104019.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 1625 m<br /><b>Latitude:</b> 26.58&deg;N<br /><b>Longitude:</b> 40.20&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 4000 sq km Harrat Ithnayn volcanic field contains scattered shield volcanoes and scoria cones.  It merges with the much larger Harrat Khaybar volcanic field to the south.  The Harrat Ithnayn volcanic field overlies Cambrian sandstones and Precambrian basement rocks.  Vents of Harrat Ithnayn form a general N-S pattern, but are more scattered than those of Harrat Khaybar.  Harrat Ithnayn rocks are of basaltic and basanitic composition and lack the silicic components present in neighboring Harrat Khaybar.  The youngest lava flows from Harrat Ithnayn are less than 4500 years old.  An uncertain report of an historical eruption in 1800 AD is considered unlikely by Camp et al. (1991), who mapped no eruptive products younger than about 1500 years from Harrat Ithnayn.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0301-05=&amp;volpage=photos&amp;photo=104019">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0301-05=">Smithsonian Volcano Information</a></td></tr></table>	(26.579999999999998,40.200000000000003)
175	Harrat Khaybar	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Harrat Khaybar</b></font><br /><font size="5"><b>Saudi Arabia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119005.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 2093 m<br /><b>Latitude:</b> 25.00&deg;N<br /><b>Longitude:</b> 39.92&deg;E</td></tr><tr><td colspan="2"><p align="justify">Harrat Khaybar, one of Saudi Arabia's largest volcanic fields, covers an area of more than 14,000 sq km north of Madinah (Medina).  A spectacular 100-km-long N-S linear vent system contains felsic lava domes, tuff rings, the Jabal Qidr stratovolcano, as well as numerous small basaltic cones.  At least seven post-neolithic (&lt;4500 years old) and eight &quot;historical&quot; (&lt;1500 years old) lava flows are present.  In the latter category is the prominent 55-km-long Habir lava flow as well as Jabal Qidr stratovolcano, the only stratovolcano in the Harrats of western Saudi Arabia.  An eruption was reported at Harrat Khaybar in early Mohammedan times during the 7th century AD.  Lavas from Harrat Khaybar overlap older lavas of Harrat Kura to the west and merge with lavas from Harrat Ithnayn to the north.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0301-06=&amp;volpage=photos&amp;photo=119005">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0301-06=">Smithsonian Volcano Information</a></td></tr></table>	(25,39.920000000000002)
176	Harrat Rahat	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Harrat Rahat</b></font><br /><font size="5"><b>Saudi Arabia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104039.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 1744 m<br /><b>Latitude:</b> 23.08&deg;N<br /><b>Longitude:</b> 39.78&deg;E</td></tr><tr><td colspan="2"><p align="justify">Saudi Arabia's largest lava field, 20,000 sq km Harrat Rahat extends for 300 km south of the holy city of Al Madinah (Medina).  Four coalescing lava fields erupted from offset NNW-trending vent systems comprise Harrat Rahat, which has an average width of 60 km.  Lava flows extend as far as 100 km west of the axis of the field.  Basaltic scoria cones dominate Harrat Rahat, but the volcanic field has also produced more silicic trachy-basaltic to trachytic rocks.  Small shield volcanoes and pelean-type lava domes with associated pyroclastic-flow and -surge deposits are also present.  Activity has migrated to the north, resulting in eruptions in historical time near Madinah.  The best-known eruption took place in 1256 AD, when a 0.5 cu km lava flow erupted from six aligned scoria cones and traveled 23 km to within 4 km of Madinah.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0301-07=&amp;volpage=photos&amp;photo=104039">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0301-07=">Smithsonian Volcano Information</a></td></tr></table>	(23.079999999999998,39.780000000000001)
177	Harrat Kishb	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Harrat Kishb</b></font><br /><font size="5"><b>Saudi Arabia</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 1475 m<br /><b>Latitude:</b> 22.80&deg;N<br /><b>Longitude:</b> 41.38&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 5900 sq km Harrat Kishb volcanic field, located east of a N-S-trending line of volcanic fields in central Saudi Arabia, is comprised of basaltic scoria cones, tuff rings and maars, and phonolitic lava domes and flows.  Most of Harrat Kishb is of Pleistocene age; Holocene flows are restricted to three areas in the western half of the field.  Jabal Aslaj cone and its associated lava flows contain abundant granitic blocks from basement rocks and ultramafic nodules.  Jabal Hil is a large scoria cone with a 300-m-wide crater that was filled and overtopped by a lava lake.  Harrat Kishb includes several tuff rings and maars, including the 800 x 600 m wide Al Wabah maar in the west-central part of the Harrat.  The most recent products of Harrat Kishb, which include the scoria cones and lava flows of Jabal Aslaj and Jabal Hil and the Jabal Shalman lava-dome, lava-flow, and scoria-cone complex, are stratigraphically younger than a pluvial period dated about 6500-4000 years before present.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0301-071">Smithsonian Volcano Information</a></td></tr></table>	(22.800000000000001,41.380000000000003)
178	Harrat al Birk	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Harrat al Birk</b></font><br /><font size="5"><b>Saudi Arabia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119004.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 381 m<br /><b>Latitude:</b> 18.37&deg;N<br /><b>Longitude:</b> 41.63&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Harrat al Birk volcanic field, also known as Harrat Hayil or Hubhub al Sheikh, is the only Saudi Arabian volcanic field that lies directly along the Red Sea coast.  It covers an 1800 sq km area west of the town of Abha and separates the Tihamat ash Sham and Tihamat 'Asir coastal plains.  Volcanic activity dates back to the Miocene and concluded with the formation of Holocene cinder cones (Brown et al., 1984).  The Quaternary Harrat al Birk lava flows are of basaltic to trachybasaltic composition and contain ultramafic inclusions.  Cinder cones are scattered throughout the volcanic field, and a few outlying cones lie east of the main lava field.  Isolated patches of freshly eroded ash surround a vent at Jabal Ba'a, east of the main field, suggesting an eruption during the last century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0301-072&amp;volpage=photos&amp;photo=119004">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0301-072">Smithsonian Volcano Information</a></td></tr></table>	(18.370000000000001,41.630000000000003)
179	Jabal Yar	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Jabal Yar</b></font><br /><font size="5"><b>Saudi Arabia</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 305 m<br /><b>Latitude:</b> 17.05&deg;N<br /><b>Longitude:</b> 42.83&deg;E</td></tr><tr><td colspan="2"><p align="justify">Jabal Yar, the southernmost young volcanic field in Saudi Arabia, is a small olivine basaltic volcanic field along the Red Sea coast at the SW tip of Saudi Arabia.  It contains three groups of volcanoes, Qummatain, Djar'atain-Harra, and 'Ukwatain.  Hot springs occur south of Djar'atain and between it and 'Ukwatain.  A single historically documented eruption from Jabal Yar took place at the beginning of the 19th century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0301-08-">Smithsonian Volcano Information</a></td></tr></table>	(17.050000000000001,42.829999999999998)
180	Harra of Arhab	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Harra of Arhab</b></font><br /><font size="5"><b>Yemen</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 3100 m<br /><b>Latitude:</b> 15.63&deg;N<br /><b>Longitude:</b> 44.08&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Quaternary Harra of Arhab lava field in Yemen, north of the capital city of Sana'a, consists of a 1500 sq km basaltic plateau capped by a few small stratovolcanoes and about 60 scoria cones, two of which have erupted in historical time.  Cones in the volcanic field (also known as the Sana'a or the Sana'a-Amran volcanic field) are commonly aligned along a north-NW trend above a 100-250-m-thick volcanic plateau.  Pliocene-to-Holocene volcanic rocks have a dominantly basaltic-to-hawaiitic composition and overlie the northern end of an area of extensive Oligocene-Miocene basaltic-to-rhyolitic rocks that extends to the SW tip of the Arabian Peninsula.  The latest eruption at Harra of Arhab took place in pre-Islamic time between about 400 and 600 AD and produced a lava flow that traveled 9 km.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0301-09-">Smithsonian Volcano Information</a></td></tr></table>	(15.630000000000001,44.079999999999998)
181	Jabal Haylan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Jabal Haylan</b></font><br /><font size="5"><b>Yemen</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 1550 m<br /><b>Latitude:</b> 15.43&deg;N<br /><b>Longitude:</b> 44.78&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Jabal Haylan area contains a 75-km-long chain of tuff cones and associated olivine basaltic lava flows in eastern Yemen.  The chain crosses a NW-SE-trending fault extending between the highlands and desert lowlands to the east.  One of the lava flows covers alluvial terraces that accumulated behind man-made dams dating back to about 800-1200 BC (Catalog of Active Volcanoes of the World).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0301-11-">Smithsonian Volcano Information</a></td></tr></table>	(15.43,44.780000000000001)
182	Harras of Dhamar	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Harras of Dhamar</b></font><br /><font size="5"><b>Yemen</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 3500 m<br /><b>Latitude:</b> 14.57&deg;N<br /><b>Longitude:</b> 44.67&deg;E</td></tr><tr><td colspan="2"><p align="justify">The lava fields surrounding the town of Dhamar are part of a volcanic field extending 80 km to the east that includes several stratovolcanoes and many youthful volcanic cones.  Basaltic lava flows overlie older rhyolitic flows.  Harras of Dhamar was the source of the only 20th-century eruption in the Arabian Peninsula, where possible explosive activity occurred in 1937.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0301-12-">Smithsonian Volcano Information</a></td></tr></table>	(14.57,44.670000000000002)
183	Harra es- Sawd	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Harra es- Sawd</b></font><br /><font size="5"><b>Yemen</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 1737 m<br /><b>Latitude:</b> 13.58&deg;N<br /><b>Longitude:</b> 46.12&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Harra es-Sawd (or Shuqra) volcanic field in southern Yemen extends for nearly 100 km along the Gulf of Aden, east of the city of Shuqra (Shaqra).  The volcanic field is oriented WSW-ENE and contains about a hundred cones that have produced a 40 x 95 km lava field that blankets faulted basement limestones.  Most of the volcanic field is Holocene in age (Cox et al., 1977), and in many cases the flows and cones are essentially uneroded.  Although eruptions may have occurred in historical time, the only recorded event was a major, but poorly documented eruption in 1253 AD.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0301-16-">Smithsonian Volcano Information</a></td></tr></table>	(13.58,46.119999999999997)
184	Harra of Bal Haf	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Harra of Bal Haf</b></font><br /><font size="5"><b>Yemen</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/112041.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 233 m<br /><b>Latitude:</b> 14.05&deg;N<br /><b>Longitude:</b> 48.33&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Harra of Bal Haf is a small volcanic field along the Gulf of Aden in southern Yemen that contains tuff cones and large aa lava fields.  The volcanic field lies along the coast about 100 km SW of the city of Al Mukalla.  Lava flows erupted from cinder cones blanket much of the volcanic field and produce an irregular shoreline.  One fresh-looking basaltic flow may be of historical age (Catalog of Active Volcanoes of the World).  At-Tabb tuff cone along the coast rises from the sea to 233 m and has a 1.5-km-wide crater partially filled by a cinder cone and associated lava flows.  An adjacent tuff cone to the east is lake filled.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0301-17-&amp;volpage=photos&amp;photo=112041">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0301-17-">Smithsonian Volcano Information</a></td></tr></table>	(14.050000000000001,48.329999999999998)
185	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>Iran</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Latitude:</b> 39.25&deg;N<br /><b>Longitude:</b> 45.17&deg;E</td></tr><tr><td colspan="2"><p align="justify">A large Holocene lava field is located in the far NW corner of Iran, near the border with Azerbaijan, about 40 km east of the Iranian city of Maku (Karakhanian et al., 2002).  The volcanic field lies between two major NW-SE-trending fault systems, the Maku Fault on the south and the Sardarapat-Nakhichevan Fault on the north.  The roughly crescent-shaped lava field extends about 30 km in an east-west direction and about 25 km in a NW-SE direction.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0302-00-">Smithsonian Volcano Information</a></td></tr></table>	(39.25,45.170000000000002)
186	Sahand	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sahand</b></font><br /><font size="5"><b>Iran</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104042.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 3707 m<br /><b>Latitude:</b> 37.75&deg;N<br /><b>Longitude:</b> 46.43&deg;E</td></tr><tr><td colspan="2"><p align="justify">Sahand volcano (Kuh-e-Sahand) is located in NW Iran, about 60 km east of Lake Urmia and 40 km SSE of the city of Tabriz.  The massive, extensively eroded calc-alkaline stratovolcano is one of the highest peaks in the Azarbaijan region and reaches a height of 3707 m.  Numerous lava domes dot the lower flanks of the volcano.  Pleistocene Potassium-Argon dates from 1.2-0.8 million years ago have been obtained (Innocenti et al., 1982), but Karakhanian et al. (2002) stated that eruptions at Sahand continued into the Holocene.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0302-001&amp;volpage=photos&amp;photo=104042">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0302-001">Smithsonian Volcano Information</a></td></tr></table>	(37.75,46.43)
187	Sabalan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sabalan</b></font><br /><font size="5"><b>Iran</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/121031.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 4811 m<br /><b>Latitude:</b> 38.25&deg;N<br /><b>Longitude:</b> 47.92&deg;E</td></tr><tr><td colspan="2"><p align="justify">Sabalan volcano (Kuhha-ye-Sabalan) lies in NW Iran, about 90 km west of the Caspian Sea and west of the city of Ardabil.  The andesitic volcano reaches a height of 4811 m; it forms the highest point in NW Iran and is the country's 2nd highest volcano, exceeded only by Damavand.  Seven glaciers descend from the summit, and rock glaciers are also present.  Potassium-Argon dates at Sabalan ranged from 5.6 to 1.4 million years ago (Innocenti et al., 1982), but Karakhanian et al. (2002) indicated that activity at Sabalan continued into the Holocene.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0302-002&amp;volpage=photos&amp;photo=121031">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0302-002">Smithsonian Volcano Information</a></td></tr></table>	(38.25,47.920000000000002)
188	Damavand	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Damavand</b></font><br /><font size="5"><b>Iran</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119095.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 5670 m<br /><b>Latitude:</b> 35.951&deg;N<br /><b>Longitude:</b> 52.109&deg;E</td></tr><tr><td colspan="2"><p align="justify">Damavand volcano towers dramatically 70 km to the NE above Iran's capital city of Tehran and 70 km south of the Caspian Sea.  The 5670-m-high stratovolcano is the highest volcano in the Middle East.   A younger cone has been constructed during the past 600,000 years over an older edifice, remnants of which were previously interpreted as a caldera wall.  Flank vents are rare, and activity at the dominantly trachyandesite volcano has been concentrated at the summit vent, which has produced a series of radial lava flows.  Lava effusion has dominated at Damavand; pyroclastic activity has been limited and the only major explosive event produced a welded ignimbrite about 280,000 years ago.  The youngest activity has consisted of the eruption of a series of lava flows from the summit vent that cover the western side of the volcano.  The youngest dated lava flows were emplaced about 7000 years ago.  No historical eruptions are known from Damavand, but hot springs are located on the volcano's flanks, and fumaroles are found at the summit crater.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0302-01-&amp;volpage=photos&amp;photo=119095">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0302-01-">Smithsonian Volcano Information</a></td></tr></table>	(35.951000000000001,52.109000000000002)
189	Bazman	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bazman</b></font><br /><font size="5"><b>Iran</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104007.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3490 m<br /><b>Latitude:</b> 28.07&deg;N<br /><b>Longitude:</b> 60.00&deg;E</td></tr><tr><td colspan="2"><p align="justify">Bazman is a 3490-m-high stratovolcano in a remote region in SE Iran.  A well-preserved, 500-m-wide crater caps the summit of the dominantly andesitic volcano.  Its satellitic lava cones have been the source of fresh-looking viscous lava flows of olivine basaltic composition.  A steep-sided lava cone on the north flank produced a viscous lava flow that traveled to the north before diverging to the NW and NE.  No historical eruptions are known from Bazman, but minor fumarolic activity has been reported.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0302-03-&amp;volpage=photos&amp;photo=104007">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0302-03-">Smithsonian Volcano Information</a></td></tr></table>	(28.07,60)
190	Taftan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Taftan</b></font><br /><font size="5"><b>Iran</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104050.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 3940 m<br /><b>Latitude:</b> 28.60&deg;N<br /><b>Longitude:</b> 61.13&deg;E</td></tr><tr><td colspan="2"><p align="justify">Taftan is a strongly eroded andesitic stratovolcano with two prominent summits.  The volcano was constructed along a volcanic zone in Beluchistan, SE Iran, that extends into northern Pakistan.  The higher, 3940-m SE summit cone is well preserved and has been the source of very fresh-looking lava flows.  Highly active, sulfur-encrusted fumaroles occur at the summit of the SE cone.  The deeply dissected NW cone is of Pleistocene age.  In January 1902 the volcano was reported to be smoking heavily for several days, with occasional strong night-time glow.  A lava flow was reported at Taftan in 1993, but may have been a mistaken observation of a molten sulfur flow.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0302-05-&amp;volpage=photos&amp;photo=104050">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0302-05-">Smithsonian Volcano Information</a></td></tr></table>	(28.600000000000001,61.130000000000003)
191	La Grille	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>La Grille</b></font><br /><font size="5"><b>Grand Comore Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104055.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1087 m<br /><b>Latitude:</b> 11.47&deg;S<br /><b>Longitude:</b> 43.33&deg;E</td></tr><tr><td colspan="2"><p align="justify">La Grille shield volcano at the northern end of Grand Comore Island (also known as Ngazidja) lacks a summit caldera like its larger and more well-known neighbor to the south, Karthala volcano.  The basaltic La Grille volcano also contrasts with Karthala in its abundance of pyroclastic cones up to 800 m in height.  The cones were erupted along fissures paralleling the summit ridge, which has an irregular profile and is elongated in a N-S direction, and from radial fissures that reach as far as the coast.  Recent lava flows, some perhaps as young as a few hundred years, have reached the sea from fissures on the lower western, northern, and eastern flanks.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0303-001&amp;volpage=photos&amp;photo=104055">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0303-001">Smithsonian Volcano Information</a></td></tr></table>	(-11.470000000000001,43.329999999999998)
192	Karthala	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Karthala</b></font><br /><font size="5"><b>Grand Comore Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/115089.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2361 m<br /><b>Latitude:</b> 11.75&deg;S<br /><b>Longitude:</b> 43.38&deg;E</td></tr><tr><td colspan="2"><p align="justify">The southernmost and largest of the two shield volcanoes forming Grand Comore Island (also known as Ngazidja Island), Karthala contains a 3 x 4 km summit caldera generated by repeated collapse.  Elongated rift zones extend to the NNW and SE from the summit of the Hawaiian-style basaltic shield, which has an asymmetrical profile that is steeper to the south.  The lower SE rift zone forms the Massif du Badjini, a peninsula at the SE tip of the island.  Historical eruptions have modified the morphology of the compound, irregular summit caldera.  More than twenty eruptions have been recorded since the 19th century from both summit and flank vents.  Many lava flows have reached the sea on both sides of the island, including during many 19th-century eruptions from the summit caldera and vents on the northern and southern flanks.  An 1860 lava flow from the summit caldera traveled ~13 km to the NW, reaching the western coast north of the capital city of Moroni.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0303-01=&amp;volpage=photos&amp;photo=115089">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0303-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://volcano.ipgp.jussieu.fr/karthala/stationkar.html">Observatoire Volcanologique du Karthala</a></td></tr></table>	(-11.75,43.380000000000003)
193	Ambre-Bobaomby	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ambre-Bobaomby</b></font><br /><font size="5"><b>Madagascar</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104028.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 1475 m<br /><b>Latitude:</b> 12.60&deg;S<br /><b>Longitude:</b> 49.15&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Ambre-Bobaomby volcanic field at the northern tip of Madagascar consists of Miocene volcanics capped by very recent cones.  The earliest volcanism produced a large basaltic massif and minor pyroclastic flows.  Tertiary to Quaternary volcanic rocks span a wide geochemical spectrum, including basaltic, andesitic, rhyolitic, trachytic, phonolitic, and foiditic compositions.  The young volcanoes have very well-preserved morphologies and were mapped as Recent (Besairie, 1973).  Other very recent cones are located at the southern end of the massif, and crater lakes are also present.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0303-011&amp;volpage=photos&amp;photo=104028">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0303-011">Smithsonian Volcano Information</a></td></tr></table>	(-12.6,49.149999999999999)
194	Nosy-Be	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Nosy-Be</b></font><br /><font size="5"><b>Madagascar</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104021.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 214 m<br /><b>Latitude:</b> 13.32&deg;S<br /><b>Longitude:</b> 48.48&deg;E</td></tr><tr><td colspan="2"><p align="justify">Nosy-Be island off the NW coast of Madagascar contains very recent basaltic lava flows from well-preserved cinder cones.  Many large crater lakes are found in the central part of the island.  Nosy-Be volcanics, which are dominantly of low-silica foiditic compositions, overlie Mesozoic limestones and other sedimentary rocks.  Two periods of activity occurred at Nosy-Be.  Initial eruptions of fluid lava flows from the western side of the massif were followed by the construction of numerous strombolian cinder cones on the western plain.  Little is known about the age of the volcanic field, and the only K-Ar dates are Tertiary in age, but the Nosy-Be volcanics were mapped as Recent (Besairie, 1973).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0303-012&amp;volpage=photos&amp;photo=104021">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0303-012">Smithsonian Volcano Information</a></td></tr></table>	(-13.32,48.479999999999997)
195	Ankaizina Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ankaizina Field</b></font><br /><font size="5"><b>Madagascar</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2878 m<br /><b>Latitude:</b> 14.30&deg;S<br /><b>Longitude:</b> 48.67&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Ankaizina volcanic field, covering portions of the Tsaratanana and Ambondrona massifs in northern Madagascar, was active until the very recent Quaternary.  An initial dominantly silicic phase included pyroclastic-flow formation and was accompanied by the emission of minor basaltic lava flows.  An earlier now-eroded basaltic phase was followed by the most recent activity, which produced a series of perfectly preserved cinder cones and lava flows that traveled down current valley floors in the Bealanana region.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0303-013">Smithsonian Volcano Information</a></td></tr></table>	(-14.300000000000001,48.670000000000002)
196	Itasy Volcanic Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Itasy Volcanic Field</b></font><br /><font size="5"><b>Madagascar</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/114074.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Scoria cones<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 1800 m<br /><b>Latitude:</b> 19.00&deg;S<br /><b>Longitude:</b> 46.77&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Itasy volcanic field in central Madagascar contains a diverse assemblage of volcanic landforms, including scoria cones, lava domes, and maars.  Activity began in the Pliocene and has continued into the Holocene.  Early eruptions produced trachytic lava domes and basanitic lava flows.  Later activity produced trachytic lava flows and recent vulcanian eruptions.  A trachytic maar was formed near Saovinandriana at the beginning of the Holocene, and several other crater lakes are present.  Mild seismicity and thermal activity in the form of hot springs continues at Itasy.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0303-014&amp;volpage=photos&amp;photo=114074">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0303-014">Smithsonian Volcano Information</a></td></tr></table>	(-19,46.770000000000003)
197	Ankaratra Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ankaratra Field</b></font><br /><font size="5"><b>Madagascar</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/114075.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2644 m<br /><b>Latitude:</b> 19.40&deg;S<br /><b>Longitude:</b> 47.20&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Ankaratra volcanic field is the most prominent and volcanologically diverse on Madagascar.  It covers a 100-km-long area in central Madagascar between Avivonimamo and Antsirabe.  Activity at the Ankaratra volcanic massif took place from the Miocene until the very recent Quaternary (Besairie, 1973).  Trachytic lava domes were erupted during the initial stage and massive fissure eruptions created a series of tectonic lakes.  The latest activity occurred in the southern part of the massif and produced well-preserved strombolian basanitic cinder cones.  Vulcanian eruptions formed several lake-filled craters.  Hot springs occur at Ranomafana.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0303-015&amp;volpage=photos&amp;photo=114075">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0303-015">Smithsonian Volcano Information</a></td></tr></table>	(-19.399999999999999,47.200000000000003)
198	Piton de la Fournaise	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Piton de la Fournaise</b></font><br /><font size="5"><b>Reunion Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/003008.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2632 m<br /><b>Latitude:</b> 21.231&deg;S<br /><b>Longitude:</b> 55.713&deg;E</td></tr><tr><td colspan="2"><p align="justify">The massive Piton de la Fournaise basaltic shield volcano on the French island of Runion in the western Indian Ocean is one of the world's most active volcanoes.  Much of its &gt;530,000 year history overlapped with eruptions of the deeply dissected Piton des Neiges shield volcano to the NW.  Three calderas formed at about 250,000, 65,000, and less than 5000 years ago by progressive eastward slumping of the volcano.  Numerous pyroclastic cones dot the floor of the calderas and their outer flanks.  Most historical eruptions have originated from the summit and flanks of Dolomieu, a 400-m-high lava shield that has grown within the youngest caldera, which is 8 km wide and breached to below sea level on the eastern side.  More than 150 eruptions, most of which have produced fluid basaltic lava flows, have occurred since the 17th century.  Only six eruptions, in 1708, 1774, 1776, 1800, 1977, and 1986, have originated from fissures on the outer flanks of the caldera.  The Piton de la Fournaise Volcano Observatory, one of several operated by the Institut de Physique du Globe de Paris, monitors this very active volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0303-02=&amp;volpage=photos&amp;photo=003008">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0303-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://volcano.ipgp.jussieu.fr/reunion/stationreu2.html">IPGP Observatoire Volcanologique du Piton de la Fournaise</a></td></tr></table>	(-21.231000000000002,55.713000000000001)
199	Boomerang Seamount	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Boomerang Seamount</b></font><br /><font size="5"><b>Southern Indian Ocean</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> -650 m<br /><b>Latitude:</b> 37.721&deg;S<br /><b>Longitude:</b> 77.825&deg;E</td></tr><tr><td colspan="2"><p align="justify">An active submarine volcano 18 km NE of Amsterdam Island was first discovered during a bathymetric survey in 1996.  The volcano, named Boomerang Seamount, rises to within 650 m of the sea surface and has a 2-km-wide summit caldera that is 200 m deep.  Rift zones extend SE and north of the basaltic volcano, giving it an arcuate shape.  Boomerang Seamount lies along the axis of the Southeast Indian Ridge and marks the site of the Amsterdam-St. Paul hotspot.  This hotspot may have been the source of the Ninetyeast Ridge submarine volcanoes on the Australian Plate prior to its &quot;capture&quot; by the Southeast Indian Ridge, after which volcanism was restricted to the Antarctic Plate.  Very short half-life radionuclide dating of fresh volcanic glass samples recovered during the 1996 expedition indicated that Boomerang Seamount had erupted only about 5 months earlier (Johnson et al., 2000).  Water column temperature anomalies above the seamount suggest the presence of hydrothermal activity within the caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0304-00-">Smithsonian Volcano Information</a></td></tr></table>	(-37.720999999999997,77.825000000000003)
200	Amsterdam Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Amsterdam Island</b></font><br /><font size="5"><b>Southern Indian Ocean</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110076.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 881 m<br /><b>Latitude:</b> 37.83&deg;S<br /><b>Longitude:</b> 77.52&deg;E</td></tr><tr><td colspan="2"><p align="justify">The elliptical 7 x 10 km Amsterdam Island is the northernmost subaerial volcano on the Antarctic Plate.  The basaltic volcano is located near the axis of the East Indian Ocean Ridge adjacent to the Indian Plate.  Amsterdam volcano was formed during two episodes of cone growth accompanied by the formation of small calderas.  The caldera of the youngest eruptive center, 2 km ENE of the earlier one, contained a lava lake that fed several stages of lava outflows.  Minor late-stage eruptions formed more than two dozen scoria cones and many small lava flows.  No historical eruptions are known, although the fresh morphology of the latest volcanism at Dumas Crater on the NE flank suggests it may have occurred as recently as a century ago (Nougier, 1982).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0304-001&amp;volpage=photos&amp;photo=110076">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0304-001">Smithsonian Volcano Information</a></td></tr></table>	(-37.829999999999998,77.519999999999996)
201	St. Paul	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>St. Paul</b></font><br /><font size="5"><b>Southern Indian Ocean</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110075.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Scoria cones</td><td width="50%" align="left"><b>Summit Elev:</b> 268 m<br /><b>Latitude:</b> 38.72&deg;S<br /><b>Longitude:</b> 77.53&deg;E</td></tr><tr><td colspan="2"><p align="justify">The uninhabited triangular island of St. Paul is located near the axis of the East Indian Ocean Ridge, 80 km south of Amsterdam Island.  St. Paul is composed of a older tuff cone surmounted by a basaltic stratovolcano with a 1.8-km-wide caldera.  The entire NE half of the volcano was submerged following collapse along a NW-trending fault.  This breached the central caldera, leaving an 80-m-deep bay connected to the ocean by a narrow channel only a few meters deep.  Geothermal areas are located near the 268-m-high caldera rim and along the margins of the caldera bay.  The only recorded historical eruption took place in 1793 from a vent on the lower SW flank.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0304-002&amp;volpage=photos&amp;photo=110075">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0304-002">Smithsonian Volcano Information</a></td></tr></table>	(-38.719999999999999,77.530000000000001)
202	Heard	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Heard</b></font><br /><font size="5"><b>Southern Indian Ocean</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/003030.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2745 m<br /><b>Latitude:</b> 53.106&deg;S<br /><b>Longitude:</b> 73.513&deg;E</td></tr><tr><td colspan="2"><p align="justify">Heard Island on the Kerguelen Plateau in the southern Indian Ocean consists primarily of the emergent portion of two volcanic structures.  The large glacier-covered composite basaltic-to-trachytic cone of Big Ben comprises most of the island, and the smaller Mt. Dixon volcano lies at the NW tip of the island across a narrow isthmus.  Little is known about the structure of Big Ben volcano because of its extensive ice cover.  The historically active Mawson Peak forms the island's 2745-m high point and lies within a 5-6 km wide caldera breached to the SW side of Big Ben.  Small satellitic scoria cones are mostly located on the northern coast.  Several subglacial eruptions have been reported in historical time at this isolated volcano, but observations are infrequent and additional activity may have occurred.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0304-01=&amp;volpage=photos&amp;photo=003030">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0304-01=">Smithsonian Volcano Information</a></td></tr></table>	(-53.106000000000002,73.513000000000005)
203	McDonald Islands	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>McDonald Islands</b></font><br /><font size="5"><b>Southern Indian Ocean</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/087088.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 230 m<br /><b>Latitude:</b> 53.03&deg;S<br /><b>Longitude:</b> 72.60&deg;E</td></tr><tr><td colspan="2"><p align="justify">Historical eruptions have greatly modified the morphology of the McDonald Islands, located on the Kerguelen Plateau about 75 km west of Heard Island.   The largest island, McDonald, is composed of a layered phonolitic tuff plateau cut by phonolitic dikes and lava domes.  A possible nearby active submarine center was inferred from phonolitic pumice that washed up on Heard Island in 1992.  Volcanic plumes were observed in December 1996 and January 1997 from McDonald Island.  During March of 1997 the crew of a vessel that sailed near the island noted vigorous steaming from a vent at the northern side of the island along with possible pyroclastic deposits and lava flows.  A satellite image taken in November 2001 showed the island to have more than doubled in area since previous reported observations in November 2000.  The high point of the island group had shifted to the northern end of McDonald Island, which had merged with Flat Island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0304-011&amp;volpage=photos&amp;photo=087088">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0304-011">Smithsonian Volcano Information</a></td></tr></table>	(-53.030000000000001,72.599999999999994)
204	Ile de la Possession	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ile de la Possession</b></font><br /><font size="5"><b>Southern Indian Ocean</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/112007.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 934 m<br /><b>Latitude:</b> 46.42&deg;S<br /><b>Longitude:</b> 51.75&deg;E</td></tr><tr><td colspan="2"><p align="justify">Ile de la Possession, located immediately west of Ile de l'Est in the Crozet archipelago, consists of a stratovolcano intruded by ring and cone dikes and modified by block faulting, marine erosion, and uplift. The structural center of the volcano is located on the western side of the 14 x 19 km wide island, which has an irregular shoreline.  The stratovolcano was formed during at least five stages dating back to the Miocene.  The eruption of plateau basalts from a rift system during stage IV was followed by a glacial period and then by the eruption of scoria cones and lava flows.  The young scoria cones are of probable Holocene age and are distributed over much of the island.  They are concentrated at the structural center on the west side and along a series of N-S and NE-trending fractures.  The Mont Branca cone on the western flank has been estimated by Bellair (1964) to be not more than a few centuries old.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0304-04-&amp;volpage=photos&amp;photo=112007">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0304-04-">Smithsonian Volcano Information</a></td></tr></table>	(-46.420000000000002,51.75)
205	Ile aux Cochons	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ile aux Cochons</b></font><br /><font size="5"><b>Southern Indian Ocean</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 775 m<br /><b>Latitude:</b> 46.10&deg;S<br /><b>Longitude:</b> 50.23&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 8 x 10 km wide Ile aux Cochons, at the western end of the Crozet Islands, is a single stratovolcano with a small summit caldera and more than 60 scoria cones.  The production of phreatomagmatic breccias inter-bedded with thin lava flows was followed by block faulting and the eruption of scoria cones and lava flows along four radial fracture systems.  Bellair (1964) considered the Morne Rouge cone on the eastern coast to be even younger than an estimated several-hundred-year-old cone on Possession Island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0304-05-">Smithsonian Volcano Information</a></td></tr></table>	(-46.100000000000001,50.229999999999997)
206	Prince Edward Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Prince Edward Island</b></font><br /><font size="5"><b>Indian Ocean</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Scoria cones<br />&nbsp;&nbsp;&nbsp; Tuff cones</td><td width="50%" align="left"><b>Summit Elev:</b> 672 m<br /><b>Latitude:</b> 46.63&deg;S<br /><b>Longitude:</b> 37.95&deg;E</td></tr><tr><td colspan="2"><p align="justify">Uninhabited 5 x 10 km wide Prince Edward Island lies opposite Marion Island at the northern end of a submarine plateau on the Antarctic Plate immediately south of the SW Indian Ocean Ridge.  The low-angle Prince Edward Island is a remnant of a large shield volcano formerly centered off the current NW shore of the island.  Pleistocene and Holocene scoria cones and tuff cones are located throughout the unglaciated 672-m-high  island, which was active contemporaneously with nearby Marion Island.  Fifteen of the scoria cones and four tuff cones on the coastal plain were active during the Holocene.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0304-06-">Smithsonian Volcano Information</a></td></tr></table>	(-46.630000000000003,37.950000000000003)
207	Marion Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Marion Island</b></font><br /><font size="5"><b>Southern Indian Ocean</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/113094.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Tuff cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1230 m<br /><b>Latitude:</b> 46.90&deg;S<br /><b>Longitude:</b> 37.75&deg;E</td></tr><tr><td colspan="2"><p align="justify">Marion Island, South Africa's only historically active volcano, lies at the SW end of a submarine plateau immediately south of the SW Indian Ocean Ridge, opposite Prince Edward Island.  The low profile of 24-km-wide dominantly basaltic and trachybasaltic Marion Island is formed by two young shield volcanoes that rise above a flat-topped submarine platform.  The 1230-m-high island is dotted by about 150 cinder cones, smaller scoria cones, and coastal tuff cones.  The earliest dated eruptions took place about 450,000 years ago, but much of the island is covered by Holocene aa and pahoehoe lava flows, and more than 130 scoria cones formed during the Holocene.  Many of these appear younger than the 4020 BP peat layer overlying one of the flows (Verwoerd, 1981).  Young unvegetated lava flows appear to be only a few 100 years old (Verwoerd, 1967).  The first historical eruption, during 1980, produced explosive activity and lava flows from a 5-km-long fissure that extended from the summit to the west coast.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0304-07-&amp;volpage=photos&amp;photo=113094">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0304-07-">Smithsonian Volcano Information</a></td></tr></table>	(-46.899999999999999,37.75)
208	Kaikohe-Bay of Islands	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kaikohe-Bay of Islands</b></font><br /><font size="5"><b>North Island (New Zealand)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/003031.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 388 m<br /><b>Latitude:</b> 35.30&deg;S<br /><b>Longitude:</b> 173.90&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Kaikohe-Bay of Islands volcanic field at the upper end of the Northland Peninsula contains 30 Pleistocene to upper-Holocene eruptive centers, consisting primarily of basaltic scoria cones, lava flows, and small shield volcanoes, along with minor rhyolitic lava flows and domes.  The field lies at the northern end of the Northland Intraplate Province, and volcanism has progressively shifted to the SE, with the younger Taheke Basalts being aligned along a NE trend at the southern end of the volcanic field.  The most recent eruption produced explosive activity and lava flows from four well-preserved scoria cones at Te Puke about 1300-1800 years ago, although the precise date of the most recent eruption remains uncertain.  Hot springs occur at three locations, including near Lake Omapere, which was dammed by lava flows.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-01=&amp;volpage=photos&amp;photo=003031">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.geonet.org.nz/">New Zealand GeoNet Project</a></td><td width="33%"><a href="http://www.gns.cri.nz/what/earthact/volcanoes/index.html">Institute of Geological & Nuclear Sciences</a></td></tr></table>	(-35.299999999999997,173.90000000000001)
209	Auckland Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Auckland Field</b></font><br /><font size="5"><b>New Zealand</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/088006.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 260 m<br /><b>Latitude:</b> 36.90&deg;S<br /><b>Longitude:</b> 174.87&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 140 sq km Auckland volcanic field, which is a late Pleistocene to late Holocene in age, lies at the southern end of the Northland Peninsula and is overlain by New Zealand's largest city.  More than 50 maars, tuff rings, small lava shields, and scoria cones have formed in the past 140,000 years in an elliptical volcanic field 29 km long in its largest (N-S) direction.  The Auckland volcanic field has dominantly produced intraplate alkali basaltic to basantic rocks forming the northernmost of a group of Quaternary volcanic fields of the Auckland Intraplate Province.  Of the 19 eruptions known to have occurred within the past 20,000 years, only one eruptive center is known to have been active during the Holocene (Smith and Allen, 1993).  The Rangitoto eruption, about 600 years ago, was the largest of the Auckland volcanic field and created the 6-km-wide Rangitoto Island, which consists of multiple scoria cones up to 260-m high that cap a low shield volcano with a broad apron of lava flows.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-02=&amp;volpage=photos&amp;photo=088006">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.geonet.org.nz/">New Zealand GeoNet Project</a></td><td width="33%"><a href="http://www.gns.cri.nz/what/earthact/volcanoes/index.html">Institute of Geological & Nuclear Sciences</a></td></tr></table>	(-36.899999999999999,174.87)
210	Mayor Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mayor Island</b></font><br /><font size="5"><b>New Zealand</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117067.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 355 m<br /><b>Latitude:</b> 37.28&deg;S<br /><b>Longitude:</b> 176.25&deg;E</td></tr><tr><td colspan="2"><p align="justify">The small 4-km-wide Mayor Island, also known as Tuhua, in the Bay of Plenty is the emergent portion of a 15-km-wide compound peralkaline lava shield constructed between about 120,000 and 35,000 years ago.  A 3-km-wide composite caldera was formed in two or three collapse events, the last of which took place about 6300 years ago, and was accompanied by a plinian eruption that produced tephra deposits up to 70 cm thick on mainland North Island.  Post-caldera eruptions generated a series of lava domes and flows emplaced from NNE-trending vents within the caldera that have filled it to depths of at least 180 m.  The latest eruption of Mayor Island has not been dated, but was considered by Houghton et al. (1992) to perhaps have occurred only  500-1000 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-021&amp;volpage=photos&amp;photo=117067">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-021">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.geonet.org.nz/">New Zealand GeoNet Project</a></td><td width="33%"><a href="http://www.gns.cri.nz/what/earthact/volcanoes/index.html">Institute of Geological & Nuclear Sciences</a></td></tr></table>	(-37.280000000000001,176.25)
211	Taranaki [Egmont]	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Taranaki [Egmont]</b></font><br /><font size="5"><b>New Zealand</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/003037.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2518 m<br /><b>Latitude:</b> 39.30&deg;S<br /><b>Longitude:</b> 174.07&deg;E</td></tr><tr><td colspan="2"><p align="justify">The nearly symmetrical, steep-sided cone of Taranaki (also known as Egmont), is New Zealand's largest andesitic stratovolcano.  Taranaki is surrounded by a ring plain of debris-avalanche and lahar deposits that and extend to the coast.  The isolated Taranaki volcanic center is located on the west coast of central North Island at the southern end of a volcanic arc extending NW along the Northland Peninsula.  Taranaki is the youngest and SE-most of a group of three volcanoes beginning with the Pleistocene Kaitoke Range.  Fanthams Peak breaks the symmetry of Taranaki on its south flank, and four lava domes are located on the lower north and south flanks.  Multiple episodes of edifice collapse have occurred in the past 50,000 years.  Explosive activity, sometimes accompanied by pyroclastic flows and lava dome growth, has occurred frequently throughout the Holocene.  Taranaki's latest eruption took place in 1854 AD.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-03=&amp;volpage=photos&amp;photo=003037">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.geonet.org.nz/">New Zealand GeoNet Project</a></td><td width="33%"><a href="http://www.gns.cri.nz/what/earthact/volcanoes/index.html">Institute of Geological & Nuclear Sciences</a></td></tr></table>	(-39.299999999999997,174.06999999999999)
212	White Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>White Island</b></font><br /><font size="5"><b>New Zealand</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/016014.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 321 m<br /><b>Latitude:</b> 37.52&deg;S<br /><b>Longitude:</b> 177.18&deg;E</td></tr><tr><td colspan="2"><p align="justify">Uninhabited 2 x 2.4 km White Island, one of New Zealand's most active volcanoes, is the emergent summit of a 16 x 18 km submarine volcano in the Bay of Plenty about 50 km offshore of North Island.  The 321-m-high island consists of two overlapping andesitic-to-dacitic stratovolcanoes; the summit crater appears to be breached to the SE because the shoreline corresponds to the level of several notches in the SE crater wall.  Volckner Rocks, four sea stacks that are remnants of a lava dome, lie 5 km NNE of White Island.  Intermittent moderate phreatomagmatic and strombolian eruptions have occurred at White Island throughout the short historical period beginning in 1826, but its activity also forms a prominent part of Maori legends.  Formation of many new vents during the 19th and 20th centuries has produced rapid changes in crater floor topography.  Collapse of the crater wall in 1914 produced a debris avalanche that buried buildings and workers at a sulfur-mining project.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-04=&amp;volpage=photos&amp;photo=016014">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-04=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.geonet.org.nz/">New Zealand GeoNet Project</a></td><td width="33%"><a href="http://www.gns.cri.nz/what/earthact/volcanoes/index.html">Institute of Geological & Nuclear Sciences</a></td></tr></table>	(-37.520000000000003,177.18000000000001)
213	Okataina	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Okataina</b></font><br /><font size="5"><b>New Zealand</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/016016.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 1111 m<br /><b>Latitude:</b> 38.12&deg;S<br /><b>Longitude:</b> 176.50&deg;E</td></tr><tr><td colspan="2"><p align="justify">The massive, dominantly rhyolitic Okataina Volcanic Centre is surrounded by extensive ignimbrite and pyroclastic sheets produced during multiple caldera-forming eruptions.  Numerous lava domes and craters erupted from two subparallel NE-SW-trending vent lineations form the Haroharo and Tarawera volcanic complexes.  Lava domes of the Haroharo complex, at the northern end of the Okataina Volcanic Centre, occupy part of the 16 x 26 km Pleistocene Haroharo caldera, which formed incrementally between 300,000 and 50,000 years before present (BP).  The oldest exposed rocks on the caldera floor are about 22,000 years old.  The Tarawera complex at the southern end of Okataina consists of 11 rhyolitic lava domes and associated lava flows.  The oldest domes were formed as late as about 15,000 years BP, and the youngest were formed in the Kaharoa eruption about 800 years BP.  The NE-SW Tarawera vent lineation extends from the two dacitic cones of Maungaongaonga and Mangakakaramea on the SW to Mount Edgecumbe on the NE.  Construction of the Haroharo and Tarawera complexes impounded lakes Rotoiti, Totoehu, Okataina, and Tarawera against the outer margins of the Okataina ring structure.  A major hydrothermal area is located at Waimangu; the world-renowned Pink and White Terrace siliceous sinter deposits were destroyed during the major basaltic explosive eruption of 1886.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-05=&amp;volpage=photos&amp;photo=016016">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-05=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.geonet.org.nz/">New Zealand GeoNet Project</a></td><td width="33%"><a href="http://www.gns.cri.nz/what/earthact/volcanoes/index.html">Institute of Geological & Nuclear Sciences</a></td></tr></table>	(-38.119999999999997,176.5)
214	Reporoa	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Reporoa</b></font><br /><font size="5"><b>New Zealand</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/093080.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 592 m<br /><b>Latitude:</b> 38.42&deg;S<br /><b>Longitude:</b> 176.33&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 10 x 15 km wide Reporoa caldera, occupying the Reporoa-Broadlands basin, lies near the western margin of the Taupo volcanic zone SSW of the Okataina volcanic center.  Reporoa caldera formed about 230,000 years ago during the eruption of the voluminous ca. 100 cu km Kaingaroa Ignimbrite.  Large slump scallops cut the northern caldera rim; on the south the rim is buried by sediments.  The Deer Hill rhyolitic lava dome was erupted after caldera collapse on the southern rim; two other rhyolitic domes, Kairuru and Pukekahu, were emplaced within the caldera along a possible ring fault.  The active Reporoa hydrothermal field lies within the caldera, and the Waiotapu and Broadlands (Ohaki) hydrothermal fields lie occur north and south of the poorly defined caldera margin.  Eruptions within the caldera have not occurred since the late Pleistocene, but large hydrothermal explosions took place from the Waiotapu thermal area immediately to the north at the time of the Kaharoa eruption of neighboring Tarawera volcano about 770 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-06-&amp;volpage=photos&amp;photo=093080">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-06-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.geonet.org.nz/">New Zealand GeoNet Project</a></td><td width="33%"><a href="http://www.gns.cri.nz/what/earthact/volcanoes/index.html">Institute of Geological & Nuclear Sciences</a></td></tr></table>	(-38.420000000000002,176.33000000000001)
215	Maroa	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Maroa</b></font><br /><font size="5"><b>New Zealand</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/091079.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1156 m<br /><b>Latitude:</b> 38.42&deg;S<br /><b>Longitude:</b> 176.08&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 16 x 25 km Maroa caldera formed sometime after 230 thousand years ago (ka) in the NE corner of the 30 x 40 km Whakamaru caldera, which is the largest of the Taupo volcanic zone.  The Whakamaru caldera partially overlaps with the Taupo caldera on the south and was formed during the eruption of the Whakamaru Group ignimbrites between about 340 and 330 ka.  The Maroa caldera was subsequently filled by at least 70 rhyolitic lava domes or flows, mostly erupted along a SW-NE trend.  Lesser amounts of basalt were also erupted.  The latest dated magmatic eruption took place about 14 ka, when the rhyolitic Puketarata tuff ring and lava domes were formed (Brooker et al., 1993).  The Orakeikorako, Ngatamariki, Rotokaua, and Wairakei hydrothermal areas are located within or adjacent to the Whakamaru caldera.  Large hydrothermal eruptions have occurred at the Orakeikorako thermal area during the Holocene, the latest immediately prior to the 1800-year-old Taupo eruption.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-061&amp;volpage=photos&amp;photo=091079">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-061">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.geonet.org.nz/">New Zealand GeoNet Project</a></td><td width="33%"><a href="http://www.gns.cri.nz/what/earthact/volcanoes/index.html">Institute of Geological & Nuclear Sciences</a></td></tr></table>	(-38.420000000000002,176.08000000000001)
216	Taupo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Taupo</b></font><br /><font size="5"><b>New Zealand</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/016018.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 760 m<br /><b>Latitude:</b> 38.82&deg;S<br /><b>Longitude:</b> 176.00&deg;E</td></tr><tr><td colspan="2"><p align="justify">Taupo, the most active rhyolitic volcano of the Taupo volcanic zone, is a large, roughly 35-km-wide caldera with poorly defined margins.  It is a type example of an &quot;inverse volcano&quot; that slopes inward towards the most recent vent location.  The Taupo caldera, now filled by Lake Taupo, largely formed as a result of the voluminous eruption of the Oruanui Tephra about 22,600 years before present (BP).  This was the largest known eruption at Taupo, producing about 1170 cu km of tephra.  This eruption was preceded during the late Pleistocene by the eruption of a large number of rhyolitic lava domes north of Lake Taupo.  Large explosive eruptions have occurred frequently during the Holocene from many vents within Lake Taupo and near its margins.  The most recent major eruption took place about 1800 years BP from at least three vents along a NE-SW-trending fissure centered on the Horomotangi Reefs.  This extremely violent eruption was New Zealand's largest during the Holocene and produced the thin but widespread phreatoplinian Taupo Ignimbrite, which covered 20,000 sq km of North Island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-07=&amp;volpage=photos&amp;photo=016018">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-07=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.geonet.org.nz/">New Zealand GeoNet Project</a></td><td width="33%"><a href="http://www.gns.cri.nz/what/earthact/volcanoes/index.html">Institute of Geological & Nuclear Sciences</a></td></tr></table>	(-38.82,176)
217	Tongariro	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tongariro</b></font><br /><font size="5"><b>New Zealand</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/016021.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1978 m<br /><b>Latitude:</b> 39.13&deg;S<br /><b>Longitude:</b> 175.642&deg;E</td></tr><tr><td colspan="2"><p align="justify">Tongariro is a large andesitic volcanic massif, located immediately NE of Ruapehu volcano, that is composed of more than a dozen composite cones constructed over a period of 275,000 years.  Vents along a NE-trending zone extending from Saddle Cone (below Ruapehu volcano) to Te Mari crater (including vents at the present-day location of Ngauruhoe) were active during a several hundred year long period around 10,000 years ago, producing the largest known eruptions at the Tongariro complex during the Holocene.  North Crater stratovolcano, one of the largest features of the massif, is truncated by a broad, shallow crater filled by a solidified lava lake that is cut on the NW side by a small explosion crater.  The youngest cone of the complex, Ngauruhoe, has grown to become the highest peak of the massif since its birth about 2500 years ago.  The symmetrical, steep-sided Ngauruhoe, along with its neighbor Ruapehu to the south, have been New Zealand's most active volcanoes during historical time.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-08=&amp;volpage=photos&amp;photo=016021">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-08=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.geonet.org.nz/">New Zealand GeoNet Project</a></td><td width="33%"><a href="http://www.gns.cri.nz/what/earthact/volcanoes/index.html">Institute of Geological & Nuclear Sciences</a></td></tr></table>	(-39.130000000000003,175.642)
218	Ruapehu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ruapehu</b></font><br /><font size="5"><b>New Zealand</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/004013.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 2797 m<br /><b>Latitude:</b> 39.28&deg;S<br /><b>Longitude:</b> 175.57&deg;E</td></tr><tr><td colspan="2"><p align="justify">Ruapehu, one of New Zealand's most active volcanoes, is a complex stratovolcano constructed during at least 4 cone-building episodes dating back to about 200,000 years ago.  The 110 cu km dominantly andesitic volcanic massif is elongated in a NNE-SSW direction and is surrounded by another 100 cu km ring plain of volcaniclastic debris, including the Murimoto debris-avalanche deposit on the NW flank.  A series of subplinian eruptions took place at Ruapehu between about 22,600 and 10,000 years ago, but pyroclastic flows have been infrequent at Ruapehu.  A single historically active vent, Crater Lake, is located in the broad summit region, but at least five other vents on the summit and flank have been active during the Holocene.  Frequent mild-to-moderate explosive eruptions have occurred in historical time from the Crater Lake vent, and tephra characteristics suggest that the crater lake may have formed as early as 3000 years ago.  Lahars produced by phreatic eruptions from the summit crater lake are a hazard to a ski area on the upper flanks and to lower river valleys.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-10=&amp;volpage=photos&amp;photo=004013">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-10=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.geonet.org.nz/">New Zealand GeoNet Project</a></td><td width="33%"><a href="http://www.gns.cri.nz/what/earthact/volcanoes/index.html">Institute of Geological & Nuclear Sciences</a></td></tr></table>	(-39.280000000000001,175.56999999999999)
219	Clark	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Clark</b></font><br /><font size="5"><b>New Zealand</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/118071.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -860 m<br /><b>Latitude:</b> 36.446&deg;S<br /><b>Longitude:</b> 177.839&deg;E</td></tr><tr><td colspan="2"><p align="justify">Clark submarine volcano lies near the southern end of the Southern Kermadec arc.  This basaltic and dacitic stratovolcano consists of a basal substrate of massive lava flows, pillow lavas, and pillow tubes overlain by volcaniclastic sediments.  Craters occupy the complex crest of the volcano.  Clark is the southernmost volcano of the submarine chain that displays hydrothermal activity.   Diffuse hydrothermal venting and sulfide chimneys were observed near the summit of Clark volcano during a New Zealand-American NOAA Vents Program expedition in 2006.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-101&amp;volpage=photos&amp;photo=118071">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-101">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.geonet.org.nz/">New Zealand GeoNet Project</a></td><td width="33%"><a href="http://www.gns.cri.nz/what/earthact/volcanoes/index.html">Institute of Geological & Nuclear Sciences</a></td></tr></table>	(-36.445999999999998,177.839)
220	Tangaroa	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tangaroa</b></font><br /><font size="5"><b>New Zealand</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120044.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 600 m<br /><b>Latitude:</b> 36.321&deg;S<br /><b>Longitude:</b> 178.028&deg;E</td></tr><tr><td colspan="2"><p align="justify">Tangaroa submarine volcano in the southern Kermadec arc rises to within 600 m of the sea surface.  The volcano is elongated in a NW-SE direction and contains smaller cones on its SE to eastern flanks.  A larger edifice lies further to the SE.  Tangaroa lies between Clark and Rumble V submarine volcanoes near the southern end of the Kermadec arc and is one of more than a half dozen volcanoes in this part of the arc showing evidence for active hydrothermal vent fields.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-102&amp;volpage=photos&amp;photo=120044">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-102">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.geonet.org.nz/">New Zealand GeoNet Project</a></td><td width="33%"><a href="http://www.gns.cri.nz/what/earthact/volcanoes/index.html">Institute of Geological & Nuclear Sciences</a></td></tr></table>	(-36.320999999999998,178.02799999999999)
221	Rumble V	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Rumble V</b></font><br /><font size="5"><b>New Zealand</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120043.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 400? m<br /><b>Latitude:</b> 36.142&deg;S<br /><b>Longitude:</b> 178.196&deg;E</td></tr><tr><td colspan="2"><p align="justify">A previously unknown submarine volcano was discovered in 1992 at the southern end of the South Kermadec Ridge.  Rumble V volcano, the southernmost of a group of seamounts on the southern Kermadec Ridge, known as the Rumbles, rises more than 2000 m to nearly 400 m below the sea surface and shows a pristine morphology.   Andesitic and basaltic-andesite rocks have been dredged from Rumble V, which lies 17 km ESE of Rumble IV.  A large plume of gas bubbles was acoustically detected rising from the summit of Rumble V in 1992, and subsequent expeditions detected evidence of vigorous hydrothermal activity.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-11-&amp;volpage=photos&amp;photo=120043">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-11-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.geonet.org.nz/">New Zealand GeoNet Project</a></td><td width="33%"><a href="http://www.gns.cri.nz/what/earthact/volcanoes/index.html">Institute of Geological & Nuclear Sciences</a></td></tr></table>	(-36.142000000000003,178.196)
222	Rumble IV	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Rumble IV</b></font><br /><font size="5"><b>New Zealand</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 500 m<br /><b>Latitude:</b> 36.13&deg;S<br /><b>Longitude:</b> 178.05&deg;E</td></tr><tr><td colspan="2"><p align="justify">The submarine volcano Rumble IV was thought to have been active from April to December of 1966, based on hydrophone signals (Kibblewhite, 1967), but later evidence indicates that the hydrophone array had been damaged and that the signals originated from Rumble III (Hall, 1985).  Fresh, glassy andesitic lava was dredged from the summit of Rumble IV.   In 1992 gas bubbles were acoustically detected rising from Rumble IV (Global Volcanism Network Bulletin).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-12-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.geonet.org.nz/">New Zealand GeoNet Project</a></td><td width="33%"><a href="http://www.gns.cri.nz/what/earthact/volcanoes/index.html">Institute of Geological & Nuclear Sciences</a></td></tr></table>	(-36.130000000000003,178.05000000000001)
223	Rumble III	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Rumble III</b></font><br /><font size="5"><b>New Zealand</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120042.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -220 m<br /><b>Latitude:</b> 35.745&deg;S<br /><b>Longitude:</b> 178.478&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Rumble III seamount, the largest of the Rumbles group of submarine volcanoes along the South Kermadec Ridge, rises 2300 m from the sea floor to within about 200 m of the sea surface.  Collapse of the edifice produced a horseshoe-shaped caldera breached to the west and a large debris-avalanche deposit.  Fresh-looking andesitic rocks have been dredged from the summit of Rumble III and basaltic lava from its flanks.  Rumble III has been the source of several submarine eruptions detected by hydrophone signals.  Early surveys placed its depth at 117 m, and later depths of about 200 m, 140 m, and 220 m were determined.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-13-&amp;volpage=photos&amp;photo=120042">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-13-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.geonet.org.nz/">New Zealand GeoNet Project</a></td><td width="33%"><a href="http://www.gns.cri.nz/what/earthact/volcanoes/index.html">Institute of Geological & Nuclear Sciences</a></td></tr></table>	(-35.744999999999997,178.47800000000001)
224	Rumble II West	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Rumble II West</b></font><br /><font size="5"><b>New Zealand</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/121001.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 1200 m<br /><b>Latitude:</b> 35.353&deg;S<br /><b>Longitude:</b> 178.527&deg;E</td></tr><tr><td colspan="2"><p align="justify">The western of the twin Rumble II submarine volcanoes, located NW of Rumble II East, displays evidence of hydrothermal activity.  Rumble II West contains a 2.5-3 km wide summit caldera about 200 m deep with a central cone and is about twice the volume of Rumble II East.  Rumble II West rises 1800 m from the sea floor to within 1200 m of the sea surface and is the deepest of the Rumble group seamounts.  Satellitic cones are found on the flanks of the volcano.  Recent lava flows originating from near the caldera rim with little or no sediment cover blanket the western flanks.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-131&amp;volpage=photos&amp;photo=121001">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-131">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.geonet.org.nz/">New Zealand GeoNet Project</a></td><td width="33%"><a href="http://www.gns.cri.nz/what/earthact/volcanoes/index.html">Institute of Geological & Nuclear Sciences</a></td></tr></table>	(-35.353000000000002,178.52699999999999)
225	Healy	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Healy</b></font><br /><font size="5"><b>New Zealand</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/116091.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 980 m<br /><b>Latitude:</b> 35.004&deg;S<br /><b>Longitude:</b> 178.973&deg;E</td></tr><tr><td colspan="2"><p align="justify">Healy submarine volcano lies along the South Kermadec Ridge and consists of an elongated edifice with a 3 x 4 km wide caldera at the NE end whose rim reaches to 1150 m below sea level.  A smaller caldera lies to the SW, and a satellitic cone, Cotton volcano, rises to 980 below sea level at the SW end of the 15-km-long complex.  The flat-lying floor of the larger NE caldera lies 250-400 m below the caldera rim.  Rhyodacitic pumice deposits mantle the caldera floor and walls, as well as the flanks of the volcano.  Active hydrothermal venting has been observed on the lower part of the southern caldera wall.  The roughly 590-year-old sea-rafted Loisels Pumice deposit found in many Holocene beach sequences of North Island, New Zealand and as far away as the Chatham Islands, 650 km east of New Zealand, is chemically and texturally similar to pumices from Healy caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-14-&amp;volpage=photos&amp;photo=116091">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-14-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.geonet.org.nz/">New Zealand GeoNet Project</a></td><td width="33%"><a href="http://www.gns.cri.nz/what/earthact/volcanoes/index.html">Institute of Geological & Nuclear Sciences</a></td></tr></table>	(-35.003999999999998,178.97300000000001)
226	Brothers	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Brothers</b></font><br /><font size="5"><b>New Zealand</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/118069.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> -1350 m<br /><b>Latitude:</b> 34.875&deg;S<br /><b>Longitude:</b> 179.075&deg;E</td></tr><tr><td colspan="2"><p align="justify">The submarine Brothers volcano, located NE of the Healy submarine volcano, contains an oval-shaped summit caldera 3-3.5 km wide.  The volcano is elongated in a NW-SE direction, and the high point of the dominantly dacitic volcano lies on the NW caldera rim at about 1350 m below the sea surface.  The caldera floor is at about 1850 m depth, and a post-caldera lava dome was constructed on the southern caldera floor and partially merges with the southern caldera wall.  Brothers volcano displays major submarine hydrothermal activity, including a large field of &quot;black smoker&quot; vents on the NW caldera wall and vents on the post-caldera dome.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-15-&amp;volpage=photos&amp;photo=118069">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0401-15-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.geonet.org.nz/">New Zealand GeoNet Project</a></td><td width="33%"><a href="http://www.gns.cri.nz/what/earthact/volcanoes/index.html">Institute of Geological & Nuclear Sciences</a></td></tr></table>	(-34.875,179.07499999999999)
227	Volcano W	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Volcano W</b></font><br /><font size="5"><b>Kermadec Islands (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/118076.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcanoes<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Cones</td><td width="50%" align="left"><b>Summit Elev:</b> -900? m<br /><b>Latitude:</b> 31.85&deg;S<br /><b>Longitude:</b> 179.18&deg;W</td></tr><tr><td colspan="2"><p align="justify">Twin submarine volcanoes, known informally as Volcano W, were discovered during a New Zealand-American submarine vent mapping expedition to the Kermadec arc in 2004.  The two deep-water basaltic volcanoes lie SW of Curtis Island.  The summits of both volcanoes are cut by small calderas, and evidence of diffuse hydrothermal venting was observed on the SE volcano in 2005.  The SE volcano rises to within about 900 m of the sea surface and contains a cone in its summit caldera.  The caldera walls expose pillow lavas, pillow tubes, localized sheet flows, and pillow breccias, with higher proportions of volcaniclastic breccias in the upper portion.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0402-001&amp;volpage=photos&amp;photo=118076">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0402-001">Smithsonian Volcano Information</a></td></tr></table>	(-31.850000000000001,-179.18000000000001)
228	Macauley Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Macauley Island</b></font><br /><font size="5"><b>Kermadec Islands (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/116093.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 238 m<br /><b>Latitude:</b> 30.20&deg;S<br /><b>Longitude:</b> 178.47&deg;W</td></tr><tr><td colspan="2"><p align="justify">Macauley Island is a remnant of the rim of a large submarine caldera centered 8 km to the NW.  The 3-km-wide island consists of a low, gently sloping surface of rhyolitic pumice from the caldera-forming eruption truncated by steep cliffs formed of underlying basaltic lava flows.  The pre-caldera Macauley volcano consisted of two generations of shield volcanoes separated by a period of growth of a pyroclastic cone.  Eruption of the voluminous Sandy Bay Tuff about 6300 years ago truncated the NW side of the Annexation shield volcano and formed a 12-km-wide, 1.1-km deep caldera during one of the largest eruptions identified in the SW Pacific.   Following formation of the caldera and substantial marine erosion, a partly submarine and partly subaerial eruption centered about 2 km north of present-day Macauley Island produced basaltic scoriae and lava flows.  A reported possible eruption from &quot;Brimstone Island,&quot; 45 km west of Macauley at a location with a depth of about 2000 m and SW of Giggenbach submarine volcano, is likely a location error and could refer to an eruption from the submarine flank of Macauley caldera (Lloyd et al., 1996).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0402-021&amp;volpage=photos&amp;photo=116093">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0402-021">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.geonet.org.nz/">New Zealand GeoNet Project</a></td><td width="33%"><a href="http://www.gns.cri.nz/what/earthact/volcanoes/index.html">Institute of Geological & Nuclear Sciences</a></td></tr></table>	(-30.199999999999999,-178.47)
229	Giggenbach	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Giggenbach</b></font><br /><font size="5"><b>Kermadec Islands (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/118072.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Cones</td><td width="50%" align="left"><b>Summit Elev:</b> -65 m<br /><b>Latitude:</b> 30.036&deg;S<br /><b>Longitude:</b> 178.712&deg;W</td></tr><tr><td colspan="2"><p align="justify">Giggenbach submarine volcano, named after volcano gas geochemist Werner Giggenbach, lies NW of Macauley volcano.  The flat summit of the basaltic-to-dacitic volcano is cut by a 700-m-wide crater containing a central cone.  The volcano reaches to within 65 m of the sea surface, and the summit is cut by numerous small explosion pits and craters.  Much of the edifice is blanketed by dacitic pumice, and several edifice-collapse scarps cut its flanks.  Large satellite cones are found on the ENE and SSW flanks, and a chain of eight small satellitic cones that fed recent andesitic-dacitic lava flows lies on the west flank.  A large hydrothermal vent field was found within the summit crater.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0402-022&amp;volpage=photos&amp;photo=118072">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0402-022">Smithsonian Volcano Information</a></td></tr></table>	(-30.036000000000001,-178.71199999999999)
230	Raoul Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Raoul Island</b></font><br /><font size="5"><b>Kermadec Islands (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104041.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 516 m<br /><b>Latitude:</b> 29.27&deg;S<br /><b>Longitude:</b> 177.92&deg;W</td></tr><tr><td colspan="2"><p align="justify">Anvil-shaped Raoul Island is the largest and northernmost of the Kermadec Islands.  During the past several thousand years volcanism has been dominated by dacitic explosive eruptions.  Two Holocene calderas are found at Raoul.  The older caldera cuts the center of Raoul Island and is about 2.5 x 3.5 km wide.  Denham caldera, formed during a major dacitic explosive eruption about 2200 years ago, truncated the western side of the island and is 6.5 x 4 km wide.  Its long axis is parallel to the tectonic fabric of the Havre Trough that lies west of the volcanic arc.  Historical eruptions at Raoul during the 19th and 20th centuries have sometimes occurred simultaneously from both calderas, and have consisted of small-to-moderate phreatic eruptions, some of which formed ephemeral islands in Denham caldera.  A 240-m-high unnamed submarine cone, one of several located along a fissure on the lower NNE flank of Raoul volcano, has also erupted during historical time, and satellitic vents at Raoul are concentrated along two parallel NNE-trending lineaments.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0402-03=&amp;volpage=photos&amp;photo=104041">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0402-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.geonet.org.nz/">New Zealand GeoNet Project</a></td><td width="33%"><a href="http://www.gns.cri.nz/what/earthact/volcanoes/index.html">Institute of Geological & Nuclear Sciences</a></td></tr></table>	(-29.27,-177.91999999999999)
231	Monowai Seamount	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Monowai Seamount</b></font><br /><font size="5"><b>Kermadec Islands (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/116089.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> -132 m<br /><b>Latitude:</b> 25.887&deg;S<br /><b>Longitude:</b> 177.188&deg;W</td></tr><tr><td colspan="2"><p align="justify">Monowai seamount, also known as Orion seamount, rises to within 100 m of the sea surface about halfway between the Kermadec and Tonga island groups.  The volcano lies at the southern end of the Tonga Ridge and is slightly offset from the Kermadec volcanoes.  Small parasitic cones occur on the north and west flanks of the basaltic submarine volcano, which rises from a depth of about 1500 m and was named for one of the New Zealand Navy bathymetric survey ships that documented its morphology.  A large 8.5 x 11 km wide submarine caldera with a depth of more than 1500 m lies to the NNE.  Numerous eruptions from Monowai have been detected from submarine acoustic signals since it was first recognized as a volcano in 1977.   A shoal that had been reported in 1944 may have been a pumice raft or water disturbance due to degassing.  Surface observations have included water discoloration, vigorous gas bubbling, and areas of upwelling water, sometimes accompanied by rumbling noises.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0402-05-&amp;volpage=photos&amp;photo=116089">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0402-05-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.geonet.org.nz/">New Zealand GeoNet Project</a></td><td width="33%"><a href="http://www.gns.cri.nz/what/earthact/volcanoes/index.html">Institute of Geological & Nuclear Sciences</a></td></tr></table>	(-25.887,-177.18799999999999)
232	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>Tonga Islands (SW Pacific)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Cones</td><td width="50%" align="left"><b>Summit Elev:</b> -385 m<br /><b>Latitude:</b> 24.80&deg;S<br /><b>Longitude:</b> 177.02&deg;W</td></tr><tr><td colspan="2"><p align="justify">A large submarine volcano located at the southern end of the Tonga arc rises to within 385 m of the sea surface.  Known informally as Volcano 19, the basaltic to basaltic-andesite seamount contains two calderas, a 3.5 x 2.5 km wide outer caldera and a 1.9-km-wide inner caldera on the west side of the volcano.    A central cone complex lies in the center of the outer caldera, east of the inner caldera.  Two large hydrothermal fields are located near the summit of the central cone complex and at the base of the southern wall of the western inner caldera.  Large high-temperature chimney vents discharge clear fluids and black smoke.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-001">Smithsonian Volcano Information</a></td></tr></table>	(-24.800000000000001,-177.02000000000001)
233	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>Tonga Islands (SW Pacific)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -500? m<br /><b>Latitude:</b> 21.38&deg;S<br /><b>Longitude:</b> 175.65&deg;W</td></tr><tr><td colspan="2"><p align="justify">During an eruption in 1907 from an unnamed submarine volcano pyroclastic material was ejected to 100 m above the sea surface, and pumice rafts were produced.  The eruption was approximately located on Admiralty Chart 2421 at a point 48 km SW of Tongatapu Island, along the Tofua volcanic arc.  Tongatapu is located at the southern end of a chain of coral islands paralleling the Tofua volcanic arc on its eastern side.  The reported location of the 1907 eruption corresponds to sloping terrain at 1800 m depth on a 1982 bathymetric map, but a seamount of about 500 m depth is located about 10 km to the NE.  A second eruption from this area was reported in late 1932.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-01=">Smithsonian Volcano Information</a></td></tr></table>	(-21.379999999999999,-175.65000000000001)
234	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>Tonga Islands (SW Pacific)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Scoria cones</td><td width="50%" align="left"><b>Summit Elev:</b> -65 m<br /><b>Latitude:</b> 21.15&deg;S<br /><b>Longitude:</b> 175.75&deg;W</td></tr><tr><td colspan="2"><p align="justify">A large submarine volcano rises to within 65 m of the sea surface west of Tongatapu Island.  The volcano was informally named Volcano #1 by the scientists on the bathymetric survey that discovered the submarine volcano in 2003.  The summit of the andesitic-to-dacitic volcano is cut by a large 7 x 4.5 km wide caldera, with two young scoria cones forming the high point of the seamount.  A chain of explosion craters up to 100 m deep cut the flank of one of the scoria cones, and thick deposits of ash and scoria blanket the caldera floor nearby.  The lack of organic sediments between volcaniclastic deposits exposed in one portion of the caldera wall suggest it was constructed within the past 200 years.  Diffuse low-temperature hydrothermal vents and vigorous gas discharge occurs near the explosion craters.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-011">Smithsonian Volcano Information</a></td></tr></table>	(-21.149999999999999,-175.75)
235	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>Tonga Islands (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/107098.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -13 m<br /><b>Latitude:</b> 20.85&deg;S<br /><b>Longitude:</b> 175.53&deg;W</td></tr><tr><td colspan="2"><p align="justify">An unnamed submarine volcano is located 35 km NW of the Niu Aunofo lighthouse on Tongatapu Island.  Tongatapu is a coral island at the southern end of an island chain paralleling the Tofua volcanic arc on the east.  The volcano, whose first documented eruptions took place in 1911 and 1923, was constructed at the southern end of a submarine ridge segment of the Tofua volcanic arc extending NNE to Falcon Island.  Prior to an eruption in 1999, when an ephemeral island was formed, the volcano rose nearly 1400 m to within 13 m of the sea surface.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-03=&amp;volpage=photos&amp;photo=107098">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-03=">Smithsonian Volcano Information</a></td></tr></table>	(-20.850000000000001,-175.53)
236	Hunga Tonga-Hunga Ha'apai	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hunga Tonga-Hunga Ha'apai</b></font><br /><font size="5"><b>Tonga</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/107091.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Fissure vent</td><td width="50%" align="left"><b>Summit Elev:</b> 149 m<br /><b>Latitude:</b> 20.57&deg;S<br /><b>Longitude:</b> 175.38&deg;W</td></tr><tr><td colspan="2"><p align="justify">The small islands of Hunga Tonga and Hunga Ha'apai cap a large seamount located about 30 km SSE of Falcon Island.  The two linear andesitic islands are about 2 km long and represent the western and northern remnants of the rim of a largely submarine caldera lying east and south of the islands.  Hunga Tonga and Hunga Ha'apai reach an elevation of only 149 m and 128 m above sea level, respectively, and display inward-facing sea cliffs with lava and tephra layers dipping gently away from the submarine caldera.  A rocky shoal 3.2 km SE of Hunga Ha'apai and 3 km south of Hunga Tonga marks the most prominent historically active vent.  Several submarine eruptions have occurred at Hunga Tonga-Hunga Ha'apai since the first historical eruption in 1912.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-04=&amp;volpage=photos&amp;photo=107091">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-04=">Smithsonian Volcano Information</a></td></tr></table>	(-20.57,-175.38)
237	Falcon Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Falcon Island</b></font><br /><font size="5"><b>Tonga Islands (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/107088.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -17 m<br /><b>Latitude:</b> 20.32&deg;S<br /><b>Longitude:</b> 175.42&deg;W</td></tr><tr><td colspan="2"><p align="justify">The ephemeral Falcon Island in the central part of the Tonga Islands was named after the British vessel H.M.S. Falcon, which reported a shoal in 1865.  Falcon Island has been the site of island-forming eruptions on at least two occasions since the 19th century.  Islands up to 6 km in length were formed in eruptions beginning in 1885 and 1927; in 1933 the island had a height of more than 145 m.  Passing ships often reported &quot;smoke&quot; issuing from the site of Falcon Island.  The latest explosive eruptions were reported in 1936.  By 1949 the island had eroded beneath sea level, but the summit of the volcano remains at shallow depths.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-05=&amp;volpage=photos&amp;photo=107088">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-05=">Smithsonian Volcano Information</a></td></tr></table>	(-20.32,-175.41999999999999)
238	Tofua	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tofua</b></font><br /><font size="5"><b>Tonga Islands (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/107097.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 515 m<br /><b>Latitude:</b> 19.75&deg;S<br /><b>Longitude:</b> 175.07&deg;W</td></tr><tr><td colspan="2"><p align="justify">The low, forested Tofua Island in the central part of the Tonga Islands group is the emergent summit of a large stratovolcano that was seen in eruption by Captain Cook in 1774.  The first Caucasian to set foot on the 515-m-high island was Capt. William Bligh in 1789, just after the renowned mutiny on the &quot;Bounty.&quot;  The volcano's summit contains a 5-km-wide caldera whose walls drop steeply about 500 m.  Three post-caldera cones were constructed at the northern end of a cold fresh-water caldera lake, whose surface lies only 30 m above sea level.  The easternmost cone has three craters and produced young basaltic-andesite lava flows, some of which traveled into the caldera lake.  The largest and northernmost of the cones, Lofia, has a steep-sided crater that is 70 m wide and 120 m deep and has been the source of historical eruptions, first reported in the 18th century.   The fumarolically active crater of Lofia has a flat floor formed by a ponded lava flow.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-06=&amp;volpage=photos&amp;photo=107097">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-06=">Smithsonian Volcano Information</a></td></tr></table>	(-19.75,-175.06999999999999)
239	Kao	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kao</b></font><br /><font size="5"><b>Tonga Islands (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/114032.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1030 m<br /><b>Latitude:</b> 19.67&deg;S<br /><b>Longitude:</b> 175.03&deg;W</td></tr><tr><td colspan="2"><p align="justify">The highest and most spectacular volcano of the Tonga Islands, symmetrical Kao volcano rises steeply to 1030 m about 6 km north of Tofua Island.  Kao is elongated in a NNE-SSW direction and, with the exception of a small flat area on the SSW coast, rises at angles exceeding 35 degrees to the summit, which has a series of small coalescing craters.  The lower flanks of the basaltic-andesite volcano are densely jungled, but the upper slopes are almost vegetation free.  No historical eruptions are known from Kao, and fresh-appearing lava flows are not seen, although the absence of sufficient time for erosion to produce deep gullies or high sea cliffs suggests a very recent origin.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-061&amp;volpage=photos&amp;photo=114032">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-061">Smithsonian Volcano Information</a></td></tr></table>	(-19.670000000000002,-175.03)
240	Metis Shoal	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Metis Shoal</b></font><br /><font size="5"><b>Tonga Islands (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/016027.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 43 m<br /><b>Latitude:</b> 19.18&deg;S<br /><b>Longitude:</b> 174.87&deg;W</td></tr><tr><td colspan="2"><p align="justify">Metis Shoal, a submarine volcano midway between the islands of Kao and Late, has produced a series of ephemeral islands since the first confirmed activity in the mid-19th century.  An island, perhaps not in eruption, was reported in 1781 and subsequently was eroded away.  During periods of inactivity following 20th-century eruptions, waves have been observed to break on rocky reefs or sandy banks with depths of 10 m or less.  Dacitic tuff cones formed during the first 20th-century eruptions in 1967 and 1979 were soon eroded beneath the sea surface.  An eruption in 1995 produced an island with a diameter of 280 m and a height of 43 m following growth of a lava dome above the surface.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-07=&amp;volpage=photos&amp;photo=016027">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-07=">Smithsonian Volcano Information</a></td></tr></table>	(-19.18,-174.87)
241	Home Reef	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Home Reef</b></font><br /><font size="5"><b>Tonga Islands (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119056.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -10 m<br /><b>Latitude:</b> 18.992&deg;S<br /><b>Longitude:</b> 174.775&deg;W</td></tr><tr><td colspan="2"><p align="justify">Home Reef, a submarine volcano midway between Metis Shoal and Late Island in the central Tonga islands, was first reported active in the mid-19th century, when an ephemeral island formed.  An eruption in 1984 produced a 12-km-high eruption plume, copious amounts of floating pumice, and an ephemeral island 500 x 1500 m wide, with cliffs 30-50 m high that enclosed a water-filled crater.  Another island-forming eruption in 2006 produced widespread dacitic pumice rafts that reached as far as Australia.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-08=&amp;volpage=photos&amp;photo=119056">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-08=">Smithsonian Volcano Information</a></td></tr></table>	(-18.992000000000001,-174.77500000000001)
242	Late	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Late</b></font><br /><font size="5"><b>Tonga Islands (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/107092.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 540 m<br /><b>Latitude:</b> 18.806&deg;S<br /><b>Longitude:</b> 174.65&deg;W</td></tr><tr><td colspan="2"><p align="justify">The small, 6-km-wide circular island of Late, lying along the Tofua volcanic arc about 55 km WSW of the island of Vavau, contains a 400-m-wide, 150-m-deep summit crater with an ephemeral lake.  The largely submerged basaltic-andesite to andesitic volcano rises 1500 m from the sea floor, with its conical summit reaching 540 m above sea level.  Cinder cones are found north of the summit crater, west and north of a semicircular plateau 100-150 m below the summit, and on the NW coast.  A graben-like structure on the NE flank contains two large pit craters, the lower of which is partially filled by a saltwater lake.  Only two eruptions have occurred in historical time, both from NE-flank craters, which produced explosive activity and possible lava flows in 1790 and 1854.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-09=&amp;volpage=photos&amp;photo=107092">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-09=">Smithsonian Volcano Information</a></td></tr></table>	(-18.806000000000001,-174.65000000000001)
243	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>Tonga Islands (SW Pacific)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -40 m<br /><b>Latitude:</b> 18.325&deg;S<br /><b>Longitude:</b> 174.365&deg;W</td></tr><tr><td colspan="2"><p align="justify">A submarine volcano along the Tofua volcanic arc was first observed in September 2001.  The newly discovered volcano lies NW of the island of Vava'u about two-thirds of the way between Late and Fonualei volcanoes.  The site of the eruption is along a NNE-SSW-trending submarine plateau south of Fonualei with an approximate bathymetric depth of 300 m.  T-phase waves were recorded on September 27-28, and on the 27th local fishermen observed an ash-rich eruption column that rose above the sea surface.  No eruptive activity was reported after the 28th, but water discoloration was documented during the following month.  In early November rafts and strandings of dacitic pumice were reported along the coast of Kadavu and Viti Levu in the Fiji Islands.  The depth of the summit of the submarine cone following the eruption determined to be 40 m during a 2007 survey; the crater of the 2001 eruption was breached to the east.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-091">Smithsonian Volcano Information</a></td></tr></table>	(-18.324999999999999,-174.36500000000001)
244	Fonualei	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Fonualei</b></font><br /><font size="5"><b>Tonga Islands (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/107090.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> 180 m<br /><b>Latitude:</b> 18.02&deg;S<br /><b>Longitude:</b> 174.325&deg;W</td></tr><tr><td colspan="2"><p align="justify">The small, less than 2-km-wide island of Fonualei contains a fumarolically active crater, which is breached to the SW with a fresh lava flow extending to the sea and forming a rugged shoreline.  Steep, inward-facing scarps mark the rim of a partially exposed caldera which contains a pyroclastic cone that is breached to the east and forms the 180-m-high summit of the island.  Blocky lava flows from this cone fill much of the northern caldera moat and reach the sea through notches in the northern and eastern caldera rims.  In contrast to the andesitic and basaltic rocks of other islands of the Tonga arc, Fonualei lavas are of dominantly dacitic composition.  Eruptions have been recorded since 1791, with the largest taking place in June 1846, when explosive eruptions produced large pumice rafts, and ashfall damaged crops on the island of Vavua (56 km away) and fell on vessels up to 950 km distant.  In 1939 explosive and effusive activity occurred from summit and flank vents, and water spouts were reported 1.6 km SE of the island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-10=&amp;volpage=photos&amp;photo=107090">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-10=">Smithsonian Volcano Information</a></td></tr></table>	(-18.02,-174.32499999999999)
245	Curacoa	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Curacoa</b></font><br /><font size="5"><b>Tonga Islands (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/005001.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -33 m<br /><b>Latitude:</b> 15.62&deg;S<br /><b>Longitude:</b> 173.67&deg;W</td></tr><tr><td colspan="2"><p align="justify">A submarine volcano south of Curacoa Reef at the northern end of the Tofua volcanic arc was first observed in eruption in 1973.  Explosive eruptions, which produced large rafts of dacitic pumice covering an area of more than 100 sq km, were observed from the island of Tafahi, 27 km to the SSW.  The eruption site was located about 6.5 km SW of Curacoa Reef.  Multiple submarine vents are apparently located in this area; a second eruption was reported in 1979 from a location 13 km north of Tafahi.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-102&amp;volpage=photos&amp;photo=005001">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-102">Smithsonian Volcano Information</a></td></tr></table>	(-15.619999999999999,-173.66999999999999)
246	Niuafo'ou	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Niuafo'ou</b></font><br /><font size="5"><b>Tonga Islands (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/107100.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 260 m<br /><b>Latitude:</b> 15.60&deg;S<br /><b>Longitude:</b> 175.63&deg;W</td></tr><tr><td colspan="2"><p align="justify">Niuafo'ou (&quot;Tin Can Island&quot;) is a low, 8-km-wide island that forms the summit of a largely submerged basaltic shield volcano.  Niuafo'ou is an isolated volcanic island in the north central Lau Basin about 170 km west of the northern end of the Tofua volcanic arc.  The circular island encloses a 5-km-wide caldera that is mostly filled by a lake whose bottom extends to below sea level.  The inner walls of the caldera drop sharply to the caldera lake, named Big Lake (or Vai Lahi), which contains several small islands and pyroclastic cones on its NE shore.  Historical eruptions, mostly from circumferential fissures on the west-to-south side of the island, have been recorded since 1814 and have often damaged villages on this small ring-shaped island.  A major eruption at Niuafo'ou in 1946 forced evacuation of most of its 1200 inhabitants.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-11=&amp;volpage=photos&amp;photo=107100">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-11=">Smithsonian Volcano Information</a></td></tr></table>	(-15.6,-175.63)
247	Tafu-Maka	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tafu-Maka</b></font><br /><font size="5"><b>Tonga Islands (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/121006.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -1400 m<br /><b>Latitude:</b> 15.37&deg;S<br /><b>Longitude:</b> 174.23&deg;W</td></tr><tr><td colspan="2"><p align="justify">Two submarine volcanoes, Tafu and Maka, lie along a NE-SW-trending ridge segment on the southern part of the NE Lau Spreading Center (NELSC).  The NELSC is a back-arc spreading center in the northeast part of the Lau Basin.  Tafu (Tongan for &quot;source of fire&quot;) rises to about 1400 m below sea level at the NE end of the ridge segment, and Maka (Tongan for &quot;rock&quot;) reaches 1560 m below sea level at the SW end of the ridge segment.  A November 2008 NOAA Vents Program expedition discovered submarine hydrothermal plumes consistent with very recent (days to weeks?) submarine lava effusion from Maka volcano.  A return visit in May 2009 documented the freshly emplaced lava flow at Maka.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-12-&amp;volpage=photos&amp;photo=121006">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-12-">Smithsonian Volcano Information</a></td></tr></table>	(-15.369999999999999,-174.22999999999999)
248	West Mata	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>West Mata</b></font><br /><font size="5"><b>Tonga Islands (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/121004.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> -1174 m<br /><b>Latitude:</b> 15.10&deg;S<br /><b>Longitude:</b> 173.75&deg;W</td></tr><tr><td colspan="2"><p align="justify">West Mata, a submarine volcano rising to within 1174 m of the sea surface, is located in the northeastern Lau Basin at the northern end of the Tonga arc, about 200 km SW of Samoa.  West Mata volcano lies about 7 km west of another submarine volcano, East Mata; both lie at the northern end of the Tonga arc, north of the historically active Curacoa submarine volcano.  The two volcanoes were discovered during a November 2008 NOAA Vents Program expedition, and West Mata was found to be producing submarine hydrothermal plumes consistent with a recent or lava effusion.  A return visit in May 2009 documented explosive and effusive activity from two closely spaced vents, one at the summit, and the other on the SW rift zone.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-13-&amp;volpage=photos&amp;photo=121004">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0403-13-">Smithsonian Volcano Information</a></td></tr></table>	(-15.1,-173.75)
249	Vailulu'u	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Vailulu'u</b></font><br /><font size="5"><b>American Samoa (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117004.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> -592 m<br /><b>Latitude:</b> 14.215&deg;S<br /><b>Longitude:</b> 169.058&deg;W</td></tr><tr><td colspan="2"><p align="justify">A massive volcanic seamount, not discovered until 1975, rises 4200 m from the sea floor to a depth of 590 m about one-third of the way between Ta'u and Rose islands at the eastern end of the American Samoas.   The basaltic seamount, named Vailulu'u, is considered to mark the current location of the Samoan hotspot.  The summit of Vailulu'u contains a 2-km-wide, 400-m-deep oval-shaped caldera.  Two principal rift zones extend east and west from the summit, parallel to the trend of the Samoan hotspot, and a third less prominent rift extends SE of the summit.   The rift zones and escarpments produced by mass wasting phenomena give the seamount a star-shaped pattern.  On July 10, 1973, explosions from Vailulu'u were recorded by SOFAR (hydrophone records of underwater acoustic signals).  An earthquake swarm in 1995 may have been related to an eruption from the seamount.  Turbid water above the summit shows evidence of ongoing hydrothermal plume activity.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0404-00-&amp;volpage=photos&amp;photo=117004">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0404-00-">Smithsonian Volcano Information</a></td></tr></table>	(-14.215,-169.05799999999999)
250	Ta'u	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ta'u</b></font><br /><font size="5"><b>American Samoa (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120008.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 931 m<br /><b>Latitude:</b> 14.23&deg;S<br /><b>Longitude:</b> 169.454&deg;W</td></tr><tr><td colspan="2"><p align="justify">The rectangular, 6 x 10 km Ta'u Island, located at the eastern end of the Samoan islands, is ringed by sea cliffs.  The 931-m-high island is the emergent portion of the large Lata shield volcano.  Collapse and landsliding of the southern portion of the basaltic shield volcano have left an arcuate, south-facing embayment with a steep headwall overlooking several flat benches.  Two smaller shields were constructed along two rift zones at the NW and NE tips of the island.  The NW corner of the island is extended by a tuff-cone complex that draped sea cliffs and ejected large dunite xenoliths and coral blocks.  Numerous Holocene post-caldera cones occur at the summit and flanks of the Lata shield volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0404-001&amp;volpage=photos&amp;photo=120008">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0404-001">Smithsonian Volcano Information</a></td></tr></table>	(-14.23,-169.45400000000001)
251	Ofu-Olosega	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ofu-Olosega</b></font><br /><font size="5"><b>American Samoa (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120010.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 639 m<br /><b>Latitude:</b> 14.175&deg;S<br /><b>Longitude:</b> 169.618&deg;W</td></tr><tr><td colspan="2"><p align="justify">The two triangle-shaped islands of Ofu and Olosega in eastern Samoa, with a combined length of 6 km, are separated by a narrow strait.  The islands are formed by two eroded, coalescing basaltic shield volcanoes whose slopes dip to the east and west.  Steep cliffs up to 600-m high truncate the northern and southern sides of the islands.  The narrow, steep-sided ridge forming the eastern tip of Ofu Island consists of a dike complex.  The shield volcano on Ofu is cut on the north by the A'ofa caldera; bathymetry suggests that a caldera may also exist on the Sili shield volcano of Olosega.  The Nu'utele tuff cone, forming a small crescent-shaped island immediately off the west end of Ofu Island, is Holocene in age.  A submarine eruption took place in 1866 at the opposite end of the two islands, 3 km SE of Olosega, along the ridge connecting Olosega with Ta'u Island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0404-01=&amp;volpage=photos&amp;photo=120010">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0404-01=">Smithsonian Volcano Information</a></td></tr></table>	(-14.175000000000001,-169.61799999999999)
252	Tutuila	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tutuila</b></font><br /><font size="5"><b>American Samoa (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120007.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Tuff cones<br />&nbsp;&nbsp;&nbsp; Ash cones<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 653 m<br /><b>Latitude:</b> 14.295&deg;S<br /><b>Longitude:</b> 170.70&deg;W</td></tr><tr><td colspan="2"><p align="justify">The elongated, extensively eroded Tutuila Island in the center of the Samoan Islands consists of five Pliocene-to-Pleistocene volcanoes constructed along two or three rifts trending SSW-NNE.  The Pago basaltic-to-andesitic shield volcano in the center of the 32-km-long island is truncated by an eroded, 9-km-wide caldera that encloses Pago Pago harbor on its west side.  The caldera is now partially filled by cinder cones and trachytic lava domes.  ENE-trending dike complexes are prominently exposed on Pago volcano.  Following a lengthy period of erosion, submergence, and the construction of a barrier reef, the Leone volcanics were erupted during the Holocene along a 5-km-long N-S-trending fissure over a broad area at the southernmost part of the island (Stearns, 1944), forming a group of initially submarine tuff cones and subsequent subaerial cinder cones that produced fresh-looking pahoehoe lava flows.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0404-02-&amp;volpage=photos&amp;photo=120007">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0404-02-">Smithsonian Volcano Information</a></td></tr></table>	(-14.295,-170.69999999999999)
253	Upolu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Upolu</b></font><br /><font size="5"><b>Samoa (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119016.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1100 m<br /><b>Latitude:</b> 13.935&deg;S<br /><b>Longitude:</b> 171.72&deg;W</td></tr><tr><td colspan="2"><p align="justify">The massive, basaltic shield volcano forming 75-km-long Upolu Island in Samoa is elongated in an E-W direction and was constructed during two periods of extensive eruptions during the Pliocene and Pleistocene.  The most extensive activity during the Pleistocene took place along a 20-km segment along the central axis of the island.  Following a lengthy period of erosion, the latest lava flows, at least three of which were estimated to be as young as a few hundred to a few thousand years old, were erupted from vents near the crest of the island at its center and western side (Stearns, 1944).  One of the youngest flows reached the north-central coast along a roughly 1.5-km-wide front east of Vailele Bay, and another traveled down the Lefaga River channel and reached the SW coast at Lefaga Bay.  Apolima Island off the western tip of Upolu is a Holocene tuff cone too young to be fringed by a coral reef, and other reef-free areas along the coastline may be formed by Holocene lava flows.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0404-03-&amp;volpage=photos&amp;photo=119016">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0404-03-">Smithsonian Volcano Information</a></td></tr></table>	(-13.935,-171.72)
254	Savai'i	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Savai'i</b></font><br /><font size="5"><b>Samoa (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119015.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1858 m<br /><b>Latitude:</b> 13.612&deg;S<br /><b>Longitude:</b> 172.525&deg;W</td></tr><tr><td colspan="2"><p align="justify">Savai'i, the largest and highest of the Samoan islands, consists of a massive basaltic shield volcano constructed along a WNW-ESE-trending rift zone that splits into two rifts on the east side of the 75-km-long, oval-shaped island.  Pliocene and Pleistocene shield formation was followed by stream and marine erosion, partial submergence, and growth of coral reefs.  Late-stage Pleistocene and Holocene eruptions produced voluminous lava flows that partially buried fringing reefs.  Numerous cinder cones and lava cones dot the broad crest of Savai'i, which has a low-angle, dome-like profile and reaches an elevation of 1858 m.  Additional cones occur on the north-central flank, and a large number are found in the south-central part of the island.  Three eruptions, including two in the 20th century, occurred in historical time, and produced voluminous lava flows that reached the northern coast along broad fronts up to about 15 km wide, destroying several villages and overtopping fringing reefs.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0404-04=&amp;volpage=photos&amp;photo=119015">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0404-04=">Smithsonian Volcano Information</a></td></tr></table>	(-13.612,-172.52500000000001)
255	Wallis Islands	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Wallis Islands</b></font><br /><font size="5"><b>West of Samoa (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104066.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Tuff cones<br />&nbsp;&nbsp;&nbsp; Cinder cone</td><td width="50%" align="left"><b>Summit Elev:</b> 143 m<br /><b>Latitude:</b> 13.30&deg;S<br /><b>Longitude:</b> 176.17&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Wallis Islands consist of one relatively large island, 7 x 14 km Uvea Island, and 22 smaller islands and islets that are surrounded by a barrier reef.  The low, forested islands, formed of flat-lying basaltic lava flows that are cut by explosion craters and capped by tuff cones and cinder cones, reach a maximum height of only 143 m above sea level.  Numerous small shields (lava cones) and tuff cones are considered on morphological grounds to be of Pleistocene to Recent age (Stearns, 1945).  Potassium-Argon ages of dated samples range from 0.5 to 0.08 million years old, but rocks of Pleistocene or Holocene age are present (Price et al., 1991).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0404-05-&amp;volpage=photos&amp;photo=104066">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0404-05-">Smithsonian Volcano Information</a></td></tr></table>	(-13.300000000000001,-176.16999999999999)
256	Taveuni	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Taveuni</b></font><br /><font size="5"><b>Fiji Islands (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104052.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Fissure vents<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1241 m<br /><b>Latitude:</b> 16.82&deg;S<br /><b>Longitude:</b> 179.97&deg;W</td></tr><tr><td colspan="2"><p align="justify">Straddling the 180 degree meridian, Taveuni, the third largest of the Fiji islands, is known as the &quot;Garden Island&quot; as a result of its rich volcanic soils.  The massive, elongated basaltic shield volcano rises to 1241 m and is dotted by approximately 150 volcanic cones along a NE-SW rift that extends the length of the 40-km-long island.  A few cones in the central part of the volcano occur to the west of the axial rift zone.  At least 58 eruptions have occurred on Taveuni since the first known human settlements of the Fiji Islands about 950-750 BC; all of these eruptions affected the southern two-thirds of the island.  A period of voluminous eruptions between about 300 and 500 AD caused abandonment of the southern part the island of Taveuni until about 1100 AD.  The latest known eruption produced a lava flow at the southern tip of the island sometime between about 1450-1650 AD.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0405-01-&amp;volpage=photos&amp;photo=104052">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0405-01-">Smithsonian Volcano Information</a></td></tr></table>	(-16.82,-179.97)
257	Nabukelevu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Nabukelevu</b></font><br /><font size="5"><b>Fiji Islands (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110077.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 805 m<br /><b>Latitude:</b> 19.12&deg;S<br /><b>Longitude:</b> 177.98&deg;E</td></tr><tr><td colspan="2"><p align="justify">The andesitic-to-dacitic Nabukelevu lava-dome complex occupies the SW end of Kadavu Island at the southern end of the Fiji archipelago.  The high point of the Nabukelevu complex is 805 m Mt. Washington, an andesitic lava dome.  Flat-lying dacitic lava flows are found at Cape Washington along the west coast and at Talaulia Bay on the NE coast.  NNE-trending faults cut the complex in several locations and define its eastern boundary.  The dome complex is cut by several collapse scarps that were the source of debris avalanches that have incorporated human artifacts and remains.  Debris avalanches have entered the sea on the both the northern and southern sides of the volcano.  Onshore and offshore deposits as well as native legends indicate that several eruptions have occurred at Nabukelevu during the Holocene.  Block-and-ash flows related to dome growth have occurred within the past few hundred years.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0405-03-&amp;volpage=photos&amp;photo=110077">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0405-03-">Smithsonian Volcano Information</a></td></tr></table>	(-19.120000000000001,177.97999999999999)
258	St. Andrew Strait	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>St. Andrew Strait</b></font><br /><font size="5"><b>Admiralty Islands (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/004034.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 270 m<br /><b>Latitude:</b> 2.38&deg;S<br /><b>Longitude:</b> 147.35&deg;E</td></tr><tr><td colspan="2"><p align="justify">The St. Andrew Strait volcano, located in the Admiralty Islands north of Papua New Guinea, consists of a series of overlapping Quaternary cones formed by rhyolitic lava flows and pyroclastic materials on Lou and Tuluman Islands.  Volcanism is aligned on a curved arc extending through the 12-km-long Lou Island, which may represent an incipient caldera ring fracture.  The historically active Tuluman Islands, 1.5 km south of Lou Island, were formed during a 1953-1957 eruption.  Pam Lin and Pam Mandian Islands farther to the SE along the same arc contain fresh rhyolitic obsidian similar to that found on Tuluman.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0500-01=&amp;volpage=photos&amp;photo=004034">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0500-01=">Smithsonian Volcano Information</a></td></tr></table>	(-2.3799999999999999,147.34999999999999)
259	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>Admiralty Islands (SW Pacific)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -1300? m<br /><b>Latitude:</b> 3.03&deg;S<br /><b>Longitude:</b> 147.78&deg;E</td></tr><tr><td colspan="2"><p align="justify">SOFAR signals resembling those produced at known submarine eruptions were recorded in January 1972 at a location in the central Bismarck Sea (Johnson et al, 1981).  The source of the signals was at the junction of two segments of the northern margin of the South Bismarck plate.  The more easterly of these segments is a transform fault, whereas the more westerly is an area of oblique active seafloor spreading.  The signals were detected at a seismic station on nearby Manus Island, as well as at hydrophone stations on Wake and Midway Islands in the central Pacific.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0500-03-">Smithsonian Volcano Information</a></td></tr></table>	(-3.0299999999999998,147.78)
260	Blup Blup	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Blup Blup</b></font><br /><font size="5"><b>Northeast of New Guinea (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111008.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> 402 m<br /><b>Latitude:</b> 3.507&deg;S<br /><b>Longitude:</b> 144.605&deg;E</td></tr><tr><td colspan="2"><p align="justify">The small, 3.5-km-wide forested island of Blup Blup contains lava flows with well-defined flow fronts.  A weak thermal area is located on the west coast, and another on the north coast.  Most eruptive activity at the andesitic-dacitic volcano originated from a thickly wooded summit crater about 800 m in diameter, although a lava dome may be present on a ridge to the west, and a small satellite cone occurs along the SW coast.  Reports of eruptions during historical time are erroneous, but the island may have erupted during the Holocene (Johnson 1990, pers. comm.).  Blocks from a submarine debris avalanche lie to the NE of the island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0501-001&amp;volpage=photos&amp;photo=111008">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0501-001">Smithsonian Volcano Information</a></td></tr></table>	(-3.5070000000000001,144.60499999999999)
261	Kadovar	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kadovar</b></font><br /><font size="5"><b>Northeast of New Guinea (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111007.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 365 m<br /><b>Latitude:</b> 3.630&deg;S<br /><b>Longitude:</b> 144.631&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 2-km-wide island of Kadovar is the emergent summit of a Bismarck Sea stratovolcano of Holocene age.  Kadovar is part of the Schouten Islands, and lies off the coast of New Guinea, about 25 km north of the mouth of the Sepik River.   The village of Gewai is perched on the crater rim.  A 365-m-high lava dome forming the high point of the andesitic volcano fills an arcuate landslide scarp that is open to the south, and submarine debris-avalanche deposits occur in that direction.  Thick lava flows with columnar jointing forms low cliffs along the coast.  The youthful island lacks fringing or offshore reefs.  No certain historical eruptions are known; the latest activity was a period of heightened thermal phenomena in 1976.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0501-002&amp;volpage=photos&amp;photo=111007">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0501-002">Smithsonian Volcano Information</a></td></tr></table>	(-3.6299999999999999,144.631)
262	Bam	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bam</b></font><br /><font size="5"><b>Northeast of New Guinea (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/004036.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 685 m<br /><b>Latitude:</b> 3.613&deg;S<br /><b>Longitude:</b> 144.818&deg;E</td></tr><tr><td colspan="2"><p align="justify">The small 2.4 x 1.6 km island of Bam is the summit of a mostly submerged volcano that is one of the more active in Papua New Guinea.  Bam is the SE-most of the Schouten Islands, and lies off the coast of New Guinea, about 40 km NNE of the mouth of the Sepik River.  A steep-walled summit crater that is 300 m wide and 180 m deep is the source of Bam's recent eruptions, which have kept the upper half of the cone sparsely vegetated.  A NE-trending landslide scarp extends across the upper part of the andesitic volcano from the SW coast, and a large submarine debris-avalanche deposits lies to the south and SW.  The younger summit cone partially buries the eastern side of the collapse scarp.  A recent lava platform on the north flank supports the small island's only villages.  Historical eruptions, recorded since 1872, have been restricted to small-to-moderate explosive activity from the summit crater.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0501-01=&amp;volpage=photos&amp;photo=004036">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0501-01=">Smithsonian Volcano Information</a></td></tr></table>	(-3.613,144.81800000000001)
263	Manam	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Manam</b></font><br /><font size="5"><b>Northeast of New Guinea (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/004038.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1807 m<br /><b>Latitude:</b> 4.080&deg;S<br /><b>Longitude:</b> 145.037&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 10-km-wide island of Manam, lying 13 km off the northern coast of mainland Papua New Guinea, is one of the country's most active volcanoes.  Four large radial valleys extend from the unvegetated summit of the conical 1807-m-high basaltic-andesitic stratovolcano to its lower flanks.  These &quot;avalanche valleys,&quot; regularly spaced 90 degrees apart, channel lava flows and pyroclastic avalanches that have sometimes reached the coast.  Five small satellitic centers are located near the island's shoreline on the northern, southern and western sides.  Two summit craters are present; both are active, although most historical eruptions have originated from the southern crater, concentrating eruptive products during much of the past century into the SE avalanche valley.  Frequent historical eruptions, typically of mild-to-moderate scale, have been recorded at Manam since 1616.  Occasional larger eruptions have produced pyroclastic flows and lava flows that reached flat-lying coastal areas and entered the sea, sometimes impacting populated areas.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0501-02=&amp;volpage=photos&amp;photo=004038">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0501-02=">Smithsonian Volcano Information</a></td></tr></table>	(-4.0800000000000001,145.03700000000001)
264	Karkar	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Karkar</b></font><br /><font size="5"><b>Northeast of New Guinea (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/004041.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1839 m<br /><b>Latitude:</b> 4.649&deg;S<br /><b>Longitude:</b> 145.964&deg;E</td></tr><tr><td colspan="2"><p align="justify">Karkar is a 19 x 25 km wide, forest-covered island that is truncated by two nested summit calderas.  The 5.5-km-wide outer caldera was formed during one or more eruptions, the last of which occurred 9000 years ago.  The eccentric 3.2-km-wide inner caldera was formed sometime between 1500 and 800 years ago.  Parasitic cones are present on the northern and southern flanks of basaltic-to-andesitic Karkar volcano; a linear array of small cones extends from the northern rim of the outer caldera nearly to the coast.  Most historical eruptions, which date back to 1643, have originated from Bagiai cone, a pyroclastic cone constructed within the steep-walled, 300-m-deep inner caldera.  The floor of the caldera is covered by young, mostly unvegetated andesitic lava flows.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0501-03=&amp;volpage=photos&amp;photo=004041">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0501-03=">Smithsonian Volcano Information</a></td></tr></table>	(-4.649,145.964)
265	Long Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Long Island</b></font><br /><font size="5"><b>Northeast of New Guinea (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/004052.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1280 m<br /><b>Latitude:</b> 5.358&deg;S<br /><b>Longitude:</b> 147.12&deg;E</td></tr><tr><td colspan="2"><p align="justify">The broad profile of hexagonal-shaped Long Island is dominated by two steep-sided stratovolcanoes, Mount Reaumur in the north and Cerisy Peak in the south.  Collapse of the basaltic-andesitic volcanic complex produced a large 10 x 12.5 km caldera, now filled by Lake Wisdom.  Caldera formation occurred during at least three major explosive eruptions, about 16,000, 4000, and 300 years ago.  The latter was one of the largest historical eruptions in Papua New Guinea and deposited andesitic tephra across the New Guinea highlands, prompting legends of a &quot;Time of Darkness.&quot;  Post-caldera eruptions have constructed a small cone, Motmot Island, in the south-central part of Lake Wisdom.  Moderate explosive eruptions have occurred during the 20th century from vents at and near Motmot Island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0501-05=&amp;volpage=photos&amp;photo=004052">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0501-05=">Smithsonian Volcano Information</a></td></tr></table>	(-5.3579999999999997,147.12)
266	Umboi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Umboi</b></font><br /><font size="5"><b>Northeast of New Guinea (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104060.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Stratovolcanoes</td><td width="50%" align="left"><b>Summit Elev:</b> 1548 m<br /><b>Latitude:</b> 5.589&deg;S<br /><b>Longitude:</b> 147.875&deg;E</td></tr><tr><td colspan="2"><p align="justify">Umboi Island, 50 km in its longest dimension, is the largest of the volcanic islands off the north coast of New Guinea.  Dominantly basaltic-andesitic Umboi is comprised of several coalescing stratovolcanoes that are cut by a large 13 x 17 km caldera whose walls rise up to 1 km above its floor.  The caldera is widely breached to the sea on the NE side and contains three youthful post-caldera cones with summit crater lakes, Talo, Soal, and Barik.  The largest of these cones, 1494-m-high Talo, displays several thermal areas and has satellitic cones on its flanks.  No historical eruptions have been reported at Umboi, but activity of the post-caldera cones is thought to have continued until the last few hundred years (Johnson et al., 1972).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0501-06=&amp;volpage=photos&amp;photo=104060">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0501-06=">Smithsonian Volcano Information</a></td></tr></table>	(-5.5890000000000004,147.875)
267	Ritter Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ritter Island</b></font><br /><font size="5"><b>Northeast of New Guinea (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/004055.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 140 m<br /><b>Latitude:</b> 5.52&deg;S<br /><b>Longitude:</b> 148.121&deg;E</td></tr><tr><td colspan="2"><p align="justify">Prior to 1888, Ritter Island was a steep-sided, nearly circular island about 780 m high.  The current small, 140-m-high island is a topographically insignificant, 1900-m-long arcuate feature between Umboi and Sakar Islands.  Several historical explosive eruptions had been recorded prior to 1888, when large-scale slope failure destroyed the summit of the conical basaltic-andesitic volcano, leaving the arcuate 140-m-high island remnant with a steep west-facing scarp that descends below sea level.  Devastating tsunamis were produced by the collapse and swept the coast of Papua New Guinea and offshore islands.  Two minor post-collapse explosive eruptions, during 1972 and 1974, occurred offshore within the largely submarine 3.5 x 4.5 km breached depression formed by the collapse.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0501-07=&amp;volpage=photos&amp;photo=004055">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0501-07=">Smithsonian Volcano Information</a></td></tr></table>	(-5.5199999999999996,148.12100000000001)
268	Langila	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Langila</b></font><br /><font size="5"><b>New Britain</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/004056.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1330 m<br /><b>Latitude:</b> 5.525&deg;S<br /><b>Longitude:</b> 148.42&deg;E</td></tr><tr><td colspan="2"><p align="justify">Langila, one of the most active volcanoes of New Britain, consists of a group of four small overlapping composite basaltic-andesitic cones on the lower eastern flank of the extinct Talawe volcano.  Talawe is the highest volcano in the Cape Gloucester area of NW New Britain.  A rectangular, 2.5-km-long crater is breached widely to the SE; Langila volcano was constructed NE of the breached crater of Talawe.  An extensive lava field reaches the coast on the north and NE sides of Langila.  Frequent mild-to-moderate explosive eruptions, sometimes accompanied by lava flows, have been recorded since the 19th century from three active craters at the summit of Langila.  The youngest and smallest crater (no. 3 crater) was formed in 1960 and has a diameter of 150 m.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0502-01=&amp;volpage=photos&amp;photo=004056">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0502-01=">Smithsonian Volcano Information</a></td></tr></table>	(-5.5250000000000004,148.41999999999999)
269	Mundua	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mundua</b></font><br /><font size="5"><b>New Britain</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/115023.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 179 m<br /><b>Latitude:</b> 4.63&deg;S<br /><b>Longitude:</b> 149.35&deg;E</td></tr><tr><td colspan="2"><p align="justify">A cluster of basaltic volcanoes forms the Mundua Islands.  The largest volcanic center is formed by the western tip of the 7-km-wide, linear Mundua Island and the arcuate Wingoru Island immediately to the west.  The crater of this volcano is flooded by the sea through narrow channels on the northern and southern sides; remnants of crater walls form Wingoru island and are exposed at the western tip of Mundua island.  Five small cones occupy the central and eastern sides of Mundua.  Two of these have well-preserved craters and are of Holocene age (Johnson and Blake, 1972).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0502-021&amp;volpage=photos&amp;photo=115023">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0502-021">Smithsonian Volcano Information</a></td></tr></table>	(-4.6299999999999999,149.34999999999999)
270	Garove	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Garove</b></font><br /><font size="5"><b>New Britain</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/115022.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 368 m<br /><b>Latitude:</b> 4.692&deg;S<br /><b>Longitude:</b> 149.50&deg;E</td></tr><tr><td colspan="2"><p align="justify">Garove is the largest of the Witu Islands, which lie north of New Britain.  The low, 12-km-wide elongated island is cut by a 5-km-wide caldera that is flooded by the sea through a narrow breach on the southern side of the island, forming Johann Albrecht harbor.  The steep-sided caldera walls rise 100-150 m above the sea.  Satellitic cones were constructed along the NE and SW coasts.  No historical eruptions are known from Garove, but the preservation of fresh lava flow structures on the NW coast suggests an age as young as a few hundred years (Johnson and Blake, 1972).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0502-03=&amp;volpage=photos&amp;photo=115022">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0502-03=">Smithsonian Volcano Information</a></td></tr></table>	(-4.6920000000000002,149.5)
271	Dakataua	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Dakataua</b></font><br /><font size="5"><b>New Britain</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/004059.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 400+ m<br /><b>Latitude:</b> 5.056&deg;S<br /><b>Longitude:</b> 150.108&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 10.5 x 13.5 km Dakataua caldera, anchoring the northern tip of the Willaumez Peninsula, is one of New Britain's most dramatic volcanoes.  A major submarine debris-avalanche deposit NE of the volcano may represent edifice collapse prior to caldera formation.  The latest episode of caldera formation occurred as recently as about 1150 years ago, and was followed by at least 5 subplinian or vulcanian eruptions.  A 12-km-wide, freshwater lake whose surface is only about 50 m above sea level occupies the caldera.  Two vertical fault-bounded blocks form topographic highs at the western and eastern sides of the caldera.  A N-S-trending line of post-caldera cones, explosion craters, and part of an arcuate inner caldera rim form a large peninsula that nearly bisects the horseshoe-shaped caldera lake.  The peninsula includes the 350-m-high andesitic Mount Makalia stratovolcano, the largest of the post-caldera cones, which last erupted during the late-19th century.  Thermal areas occur at several locations along the central peninsula.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0502-04=&amp;volpage=photos&amp;photo=004059">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0502-04=">Smithsonian Volcano Information</a></td></tr></table>	(-5.056,150.108)
272	Bola	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bola</b></font><br /><font size="5"><b>New Britain</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/107065.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1155 m<br /><b>Latitude:</b> 5.15&deg;S<br /><b>Longitude:</b> 150.03&deg;E</td></tr><tr><td colspan="2"><p align="justify">Bola volcano (also known as Wangore) is a symmetrical stratovolcano, located immediately SW of Dakataua caldera, that forms the 1155-m high point of the Willaumez Peninsula.  The forested andesitic cone has a well-preserved, 400-m-wide crater with a 100-m-high eastern wall and a low western rim.  Three large explosion craters occupy the NE flank of Bola.  The most recent lava flow issued from the summit crater and flowed to the west.  This viscous flow is at least 50 m thick, leaving an irregularity in the profile of the volcano.  The pristine summit crater and weak fumarolic activity suggested to Lowder and Carmichael (1970) that the most recent eruption may have been only a few hundred years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0502-05=&amp;volpage=photos&amp;photo=107065">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0502-05=">Smithsonian Volcano Information</a></td></tr></table>	(-5.1500000000000004,150.03)
273	Garbuna Group	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Garbuna Group</b></font><br /><font size="5"><b>New Britain</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/107072.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 564 m<br /><b>Latitude:</b> 5.45&deg;S<br /><b>Longitude:</b> 150.03&deg;E</td></tr><tr><td colspan="2"><p align="justify">The basaltic-to-dacitic Garbuna volcano group consists of three volcanic peaks, Krummel, Garbuna, and Welcker.  They are located along a 7-km N-S line above a shield-like foundation at the southern end of the Willaumez Peninsula.  The central and lower peaks of the centrally located 564-m-high Garbuna volcano contain a large vegetation-free area that is probably the most extensive thermal field in Papua New Guinea.  A prominent lava dome and blocky lava flow in the center of thermal area have resisted destruction by thermal activity, and may be of Holocene age.  The 854-m-high Krummel volcano at the south end of the group contains a summit crater, breached to the NW.  The highest peak of the Garbuna group is 1005-m-high Welcker volcano, which has fed blocky lava flows that extend to the eastern coast of the peninsula.  The last major eruption from both it and Garbuna volcanoes took place about 1800 years ago.  The first historical eruption of the complex took place at Garbuna in October 2005.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0502-07=&amp;volpage=photos&amp;photo=107072">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0502-07=">Smithsonian Volcano Information</a></td></tr></table>	(-5.4500000000000002,150.03)
274	Pago	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Pago</b></font><br /><font size="5"><b>New Britain</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/106012.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava cone<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 742 m<br /><b>Latitude:</b> 5.58&deg;S<br /><b>Longitude:</b> 150.52&deg;E</td></tr><tr><td colspan="2"><p align="justify">Pago is a young post-caldera cone that was constructed within the 5.5 x 7.5 km Witori caldera.  The Buru caldera cuts the SW flank of Witori volcano.  The gently sloping outer flanks of Witori volcano consist primarily of dacitic pyroclastic-flow and airfall deposits produced during a series of five major explosive eruptions from about 5600 to 1200 years ago, many of which may have been assocciated with caldera formation.  The post-caldera cone of Witori, Mount Pago, may have formed less than 350 years ago.  Pago has grown to a height above that of the Witori caldera rim.  A series of ten dacitic lava flows from Pago covers much of the caldera floor.  The youngest of these was erupted during 2002-2003 from vents extending from the summit nearly to the NW caldera wall.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0502-08=&amp;volpage=photos&amp;photo=106012">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0502-08=">Smithsonian Volcano Information</a></td></tr></table>	(-5.5800000000000001,150.52000000000001)
275	Sulu Range	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sulu Range</b></font><br /><font size="5"><b>New Britain</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117049.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Maar</td><td width="50%" align="left"><b>Summit Elev:</b> 610 m<br /><b>Latitude:</b> 5.50&deg;S<br /><b>Longitude:</b> 150.942&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Sulu Range consists of a cluster of partially overlapping small stratovolcanoes and lava domes in north-central New Britain off Bangula Bay.   The 610-m Mount Malopu at the southern end forms the high point of the basaltic-to-rhyolitic complex.  Kaiamu maar forms a peninsula with a small lake extending about 1 km into Bangula Bay at the NW side of the Sulu Range.  The Walo hydrothermal area, consisting of solfataras and mud pots, lies on the coastal plain west of the SW base of the Sulu Range.  No historical eruptions are known from the Sulu Range, although some of the cones display a relatively undissected morphology.  A vigorous new fumarolic vent opened in 2006, preceded by vegetation die-off, seismicity, and dust-producing landslides.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0502-09=&amp;volpage=photos&amp;photo=117049">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0502-09=">Smithsonian Volcano Information</a></td></tr></table>	(-5.5,150.94200000000001)
276	Hargy	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hargy</b></font><br /><font size="5"><b>New Britain</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111019.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava cone</td><td width="50%" align="left"><b>Summit Elev:</b> 1148 m<br /><b>Latitude:</b> 5.33&deg;S<br /><b>Longitude:</b> 151.10&deg;E</td></tr><tr><td colspan="2"><p align="justify">This little-known volcano is one of several major calderas on the island of New Britain.  The 10 x 12 km Hargy caldera, whose floor is 150 m above sea level, contains an inner caldera with a steep west-facing wall.  A caldera lake on the SE side drains through a narrow gap in the northern caldera wall.  The latest caldera-forming eruption of Hargy volcano took place about 11,000 years ago.  The dacitic Galloseulo lava cone rises above and partially overtops the western rim of the caldera.  A double crater occupies a larger 700-m-wide crater.  Numerous small eruptions have taken place at Galloseulo over the past 7000 years, the last occurring about 1000 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0502-10=&amp;volpage=photos&amp;photo=111019">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0502-10=">Smithsonian Volcano Information</a></td></tr></table>	(-5.3300000000000001,151.09999999999999)
277	Bamus	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bamus</b></font><br /><font size="5"><b>New Britain</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/060090.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2248 m<br /><b>Latitude:</b> 5.20&deg;S<br /><b>Longitude:</b> 151.23&deg;E</td></tr><tr><td colspan="2"><p align="justify">Symmetrical 2248-m-high Bamus volcano, also referred to locally as South Son, is located SW of Ulawun volcano, known as the North Son.  These two volcanoes are the highest in the 1000-km-long Bismarck volcanic arc.  The andesitic Bamus stratovolcano is draped by rainforest and contains a breached summit crater filled with a lava dome.  A satellitic cone is located on the southern flank, and a prominent 1.5-km-wide crater with two small adjacent cones is situated halfway up the SE flank.  Young pyroclastic-flow deposits are found on the volcano's flanks, and villagers describe an eruption that took place during the late-19th century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0502-11=&amp;volpage=photos&amp;photo=060090">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0502-11=">Smithsonian Volcano Information</a></td></tr></table>	(-5.2000000000000002,151.22999999999999)
278	Ulawun	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ulawun</b></font><br /><font size="5"><b>New Britain</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/004062.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 2334 m<br /><b>Latitude:</b> 5.05&deg;S<br /><b>Longitude:</b> 151.33&deg;E</td></tr><tr><td colspan="2"><p align="justify">The symmetrical basaltic-to-andesitic Ulawun stratovolcano is the highest volcano of the Bismarck arc, and one of Papua New Guinea's most frequently active.  Ulawun volcano, also known as the Father, rises above the north coast of the island of New Britain across a low saddle NE of Bamus volcano, the South Son.  The upper 1000 m of the 2334-m-high Ulawun volcano is unvegetated.  A  prominent E-W-trending escarpment on the south may be the result of large-scale slumping.  Satellitic cones occupy the NW and eastern flanks.  A steep-walled valley cuts the NW side of Ulawun volcano, and a flank lava-flow complex lies to the south of this valley.  Historical eruptions date back to the beginning of the 18th century.  Twentieth-century eruptions were mildly explosive until 1967, but after 1970 several larger eruptions produced lava flows and basaltic pyroclastic flows, greatly modifying the summit crater.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0502-12=&amp;volpage=photos&amp;photo=004062">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0502-12=">Smithsonian Volcano Information</a></td></tr></table>	(-5.0499999999999998,151.33000000000001)
279	Lolobau	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Lolobau</b></font><br /><font size="5"><b>New Britain</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/016053.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 858 m<br /><b>Latitude:</b> 4.92&deg;S<br /><b>Longitude:</b> 151.158&deg;E</td></tr><tr><td colspan="2"><p align="justify">Lolobau volcano sits astride the western rim of a 6-km-wide caldera, which formed about 12,000 years ago.  The 8 x 13 km, oval-shaped Lolobau Island is located just off the coast of eastern New Britain.  A small lake occupies the SW part of the caldera.  A small lava dome (Hulu) caps Mount Lolobau, which has a 0.8 x 1.1 km summit crater that is breached to the NE.  Flank cones are found along the coast of the largely submerged volcano.  Several vents within the caldera along an E-W-trending line on the eastern flank of Mount Lolobau have been active during historical time.  The latest eruptions took place during the early-20th century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0502-13=&amp;volpage=photos&amp;photo=016053">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0502-13=">Smithsonian Volcano Information</a></td></tr></table>	(-4.9199999999999999,151.15799999999999)
280	Rabaul	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Rabaul</b></font><br /><font size="5"><b>New Britain</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/004068.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic shield<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 688 m<br /><b>Latitude:</b> 4.271&deg;S<br /><b>Longitude:</b> 152.203&deg;E</td></tr><tr><td colspan="2"><p align="justify">The low-lying Rabaul caldera on the tip of the Gazelle Peninsula at the NE end of New Britain forms a broad sheltered harbor utilized by what was the island's largest city prior to a major eruption in 1994.  The outer flanks of the 688-m-high asymmetrical pyroclastic shield volcano are formed by thick pyroclastic-flow deposits.  The 8 x 14 km caldera is widely breached on the east, where its floor is flooded by Blanche Bay and was formed about 1400 years ago.  An earlier caldera-forming eruption about 7100 years ago is now considered to have originated from Tavui caldera, offshore to the north.  Three small stratovolcanoes lie outside the northern and NE caldera rims of Rabaul.  Post-caldera eruptions built basaltic-to-dacitic pyroclastic cones on the caldera floor near the NE and western caldera walls.  Several of these, including Vulcan cone, which was formed during a large eruption in 1878, have produced major explosive activity during historical time.  A powerful explosive eruption in 1994 occurred simultaneously from Vulcan and Tavurvur volcanoes and forced the temporary abandonment of Rabaul city.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0502-14=&amp;volpage=photos&amp;photo=004068">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0502-14=">Smithsonian Volcano Information</a></td></tr></table>	(-4.2709999999999999,152.203)
281	Tavui	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tavui</b></font><br /><font size="5"><b>New Britain</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110045.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 200? m<br /><b>Latitude:</b> 4.12&deg;S<br /><b>Longitude:</b> 152.20&deg;E</td></tr><tr><td colspan="2"><p align="justify">The spectacular mostly submarine Tavui caldera lies off the NE tip of the Gazelle Peninsula north of Rabaul caldera.  The caldera was first discovered during a bathymetric cruise in 1985.  The SW wall of the roughly 10 x 12 km wide Tavui caldera cuts the NE tip of the peninsula and extends from Tavui Point at the northern tip of the peninsula SE to Laweo Point.  The 7100-year-old Raluan Ignimbrite, initially thought to have originated from Rabaul caldera, is now thought to have been produced by an eruption of Tavui caldera.  A basaltic scoria layer immediately underlies the rhyolitic ignimbrite, and the introduction of basaltic magma was considered to have triggered the rhyolitic eruption.  The lack of a major low-velocity region detectable beneath the caldera during a seismic tomography survey suggests that it is not currently active.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0502-15-&amp;volpage=photos&amp;photo=110045">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0502-15-">Smithsonian Volcano Information</a></td></tr></table>	(-4.1200000000000001,152.19999999999999)
282	Koranga	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Koranga</b></font><br /><font size="5"><b>New Guinea (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/004083.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Maar<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1500 m<br /><b>Latitude:</b> 7.33&deg;S<br /><b>Longitude:</b> 146.708&deg;E</td></tr><tr><td colspan="2"><p align="justify">Koranga Crater, a Pliocene-to-Holocene hydrothermal explosion vent complex (Pigram et al., 1977), is located in the Morobe goldfields in the Owen Stanley Range SW of Huon Gulf.  The gold mineralization here prompted one of the world's last great gold rushes, beginning in 1922.  Gold mineralization is thought to have been related to Pliocene maar formation and dacitic and andesitic lava dome extrusion.  Gas emission and a landslide from Koranga in May 1967 were considered to have had either a non-volcanic (Pigram et al., 1977; Fisher and Branch, 1981) or hydrothermal-eruption origin (Sillitoe et al., 1984).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0503-003&amp;volpage=photos&amp;photo=004083">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0503-003">Smithsonian Volcano Information</a></td></tr></table>	(-7.3300000000000001,146.708)
283	Madilogo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Madilogo</b></font><br /><font size="5"><b>New Guinea (SW Pacific)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> 850? m<br /><b>Latitude:</b> 9.20&deg;S<br /><b>Longitude:</b> 147.57&deg;E</td></tr><tr><td colspan="2"><p align="justify">Madilogo is an isolated, well-preserved pyroclastic cone located on the SW side of the Owen Stanley Range about 50 km NE of Port Moresby.  The small volcano, which was not recognized until 1969, rises about 250 m from the flood plain of the Naoro River.  A lava flow extends 1 km to the west from the breached summit crater.  The pyroclastic cone and lava flow were considered on the basis of revegetation rates and soil profiles to probably be less than 1000 years old and possibly as young as a few hundred years (Blake, 1976).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0503-004">Smithsonian Volcano Information</a></td></tr></table>	(-9.1999999999999993,147.56999999999999)
284	Lamington	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Lamington</b></font><br /><font size="5"><b>New Guinea (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/004090.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 1680 m<br /><b>Latitude:</b> 8.95&deg;S<br /><b>Longitude:</b> 148.15&deg;E</td></tr><tr><td colspan="2"><p align="justify">Lamington is an andesitic stratovolcano with a 1.3-km-wide breached summit crater containing a lava dome.  Prior to its renowned devastating eruption in 1951, the forested peak had not been recognized as a volcano.  Mount Lamington rises to 1680 m above the coastal plain north of the Owen Stanley Range.  A summit complex of lava domes and crater remnants rises above a low-angle base of volcaniclastic deposits that are dissected by radial valleys.  A prominent broad &quot;avalanche valley&quot; extends northward from the breached crater.  Ash layers from two early Holocene eruptions at Lamington have been identified.  After a long quiescent period, the volcano sprang suddenly to life in 1951, producing a powerful explosive eruption during which devastating pyroclastic flows and surges swept all sides of the volcano, killing nearly 3000 persons.  The eruption concluded with growth of a 560-m-high lava dome in the summit crater.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0503-01=&amp;volpage=photos&amp;photo=004090">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0503-01=">Smithsonian Volcano Information</a></td></tr></table>	(-8.9499999999999993,148.15000000000001)
285	Hydrographers Range	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hydrographers Range</b></font><br /><font size="5"><b>New Guinea</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/004084.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Explosion craters</td><td width="50%" align="left"><b>Summit Elev:</b> 1915 m<br /><b>Latitude:</b> 9.00&deg;S<br /><b>Longitude:</b> 148.37&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Hydrographers Range is a forested, deeply dissected andesitic volcanic massif extending from the eastern margin of Mount Lamington north to the coast of eastern Papua New Guinea.  Most activity took place during the Pleistocene, but perfectly preserved cinder cones and explosion craters on the southern side of the range suggested that some activity took place during the Holocene (Taylor, 1958).  Other well-preserved cones are situated in the high country overlooking Songade village on the coast.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0503-011&amp;volpage=photos&amp;photo=004084">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0503-011">Smithsonian Volcano Information</a></td></tr></table>	(-9,148.37)
286	Musa River	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Musa River</b></font><br /><font size="5"><b>New Guinea (SW Pacific)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Hydrothermal field</td><td width="50%" align="left"><b>Summit Elev:</b> 808 m<br /><b>Latitude:</b> 9.308&deg;S<br /><b>Longitude:</b> 148.13&deg;E</td></tr><tr><td colspan="2"><p align="justify">Hot springs and thermal vents at Musa River are located in metamorphic terrain with no obvious connection to recent volcanic activity.  Basement rocks are metamorphic schists, and Tertiary andesitic volcanics are found less than 1 km away (Catalog of Active Volcanoes of the World; IAVCEI, 1973-80).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0503-02=">Smithsonian Volcano Information</a></td></tr></table>	(-9.3079999999999998,148.13)
287	Managlase Plateau	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Managlase Plateau</b></font><br /><font size="5"><b>New Guinea (SW Pacific)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 1342 m<br /><b>Latitude:</b> 9.08&deg;S<br /><b>Longitude:</b> 148.33&deg;E</td></tr><tr><td colspan="2"><p align="justify">Thirty small volcanic centers of late-Pleistocene to Holocene age are located in SE Papua New Guinea on the Managlase Plateau, south of the Hydrographers Range and SW of the Dyke Ackland Bay.  The fault-bounded plateau forms a triangular-shaped area dotted with trachybasaltic lava cones and flows, scoria mounds, cinder cones, and explosion vents of the Uoivi Volcanics and capped on its eastern side by rhyodacitic ash cones, lava domes, and ashflow deposits of the Manna Volcanics .  The date of the most recent eruption on the Managlase Plateau is not known, but the trachybasaltic Kururui cinder cone and a nearby explosion crater were active within memory of nearby villagers (Ruxton, 1966).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0503-021">Smithsonian Volcano Information</a></td></tr></table>	(-9.0800000000000001,148.33000000000001)
288	Victory	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Victory</b></font><br /><font size="5"><b>New Guinea (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111009.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1925 m<br /><b>Latitude:</b> 9.20&deg;S<br /><b>Longitude:</b> 149.07&deg;E</td></tr><tr><td colspan="2"><p align="justify">The dominantly andesitic Mount Victory stratovolcano occupies the Cape Nelson area on the NE coast of Papua New Guinea.  Mount Victory is densely mantled by rainforest, which is somewhat stunted near the summit.  On the NE it abutts the deeply dissected Pleistocene Mount Trafalgar volcano.  The summit crater of Mount Victory is breached to the SE and is of possible landslide origin.  Several near-summit lava domes are present, the SE-most of which marks the 1925-m-high summit of the volcano.  Four small satellite cones are located on the SW side, and two others occur on the NE flank.  The only confirmed historical activity of Mount Victory was a long-term late-19th to early 20th-century eruption that provided a beacon for passing ships.  Pyroclastic flows that destroyed several villages and caused fatalities reached the coast.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0503-03=&amp;volpage=photos&amp;photo=111009">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0503-03=">Smithsonian Volcano Information</a></td></tr></table>	(-9.1999999999999993,149.06999999999999)
289	Sessagara	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sessagara</b></font><br /><font size="5"><b>New Guinea (SW Pacific)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 370 m<br /><b>Latitude:</b> 9.48&deg;S<br /><b>Longitude:</b> 149.13&deg;E</td></tr><tr><td colspan="2"><p align="justify">The low-lying Sessagara Hills, located near the mouth of the Uiaka River, south of Collingwood Bay, is a small alkalic andesitic volcanic field in eastern Papua New Guinea.  The age of the most recent eruption is not known, although the field clearly included Holocene volcanic activity (Smith, 1981).  Two of the cones north of the Goropu Mountains display preserved summit craters and were probably active during the Holocene; other cones may be of Pleistocene age.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0503-031">Smithsonian Volcano Information</a></td></tr></table>	(-9.4800000000000004,149.13)
290	Waiowa	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Waiowa</b></font><br /><font size="5"><b>New Guinea (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/061001.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> 640 m<br /><b>Latitude:</b> 9.57&deg;S<br /><b>Longitude:</b> 149.075&deg;E</td></tr><tr><td colspan="2"><p align="justify">Waiowa (also known as Goropu) is an isolated pyroclastic cone that was formed during 1943-44 by explosive eruptions through Paleozoic to pre-Cambrian metamorphic rocks.  The trachyandesitic volcano was born in an area of the eastern Papuan Peninsula without previous volcanic activity.  Intermittent minor explosions beginning September 18, 1943 preceded the first major explosion on December 27.  Additional large explosions occurred on February 13 and July 23, 1944, leveling 80 sq km of forest.  Following the final eruption on August 31, the topographically insignificant volcano was capped by a 500-m-wide, steep-walled crater that is now densely forested and contains a small lake.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0503-04=&amp;volpage=photos&amp;photo=061001">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0503-04=">Smithsonian Volcano Information</a></td></tr></table>	(-9.5700000000000003,149.07499999999999)
291	Goodenough	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Goodenough</b></font><br /><font size="5"><b>D'Entrecasteaux Islands (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/107070.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 220 m<br /><b>Latitude:</b> 9.48&deg;S<br /><b>Longitude:</b> 150.35&deg;E</td></tr><tr><td colspan="2"><p align="justify">Goodenough is a roughly circular volcanic island that is the westernmost of the D'Entrecasteaux Islands off the NE tip of Papua New Guinea.  Several basaltic-andesite and andesitic Holocene eruptive centers that may be only a few hundred years old are located around the margins of fault-bounded metamorphic rocks that form the central part of Goodenough Island.  The youngest volcanic features, which include the Walilagi Cones, are located at the SE end of the island.  These well-developed ash cones and blocky lava flows on the northern and eastern flanks of the Bwaido Peninsula may have erupted within the past few hundred years.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0503-041&amp;volpage=photos&amp;photo=107070">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0503-041">Smithsonian Volcano Information</a></td></tr></table>	(-9.4800000000000004,150.34999999999999)
292	Iamalele	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Iamalele</b></font><br /><font size="5"><b>D'Entrecasteaux Islands (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/108066.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 200 m<br /><b>Latitude:</b> 9.52&deg;S<br /><b>Longitude:</b> 150.53&deg;E</td></tr><tr><td colspan="2"><p align="justify">An area of youthful volcanism and active thermal fields is located on the SW part of Fergusson Island, in the center of the D'Entrecasteaux island group.  The Iamalele-Fagululu area contains a series of lava domes and lava flows of probable Holocene age in association with abundant hot springs and fumaroles (Smith 1981).   Two small lava domes are located near Fagululu village, the largest of which is a 150-m-high flat-topped, obsidian-bearing rhyolitic dome.  Six other lava domes are clustered around Salt Lake on the western side of the area.  Hot springs, boiling springs, fumaroles, and mud pools are found in an area of siliceous sinter near Iamalele village.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0503-05=&amp;volpage=photos&amp;photo=108066">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0503-05=">Smithsonian Volcano Information</a></td></tr></table>	(-9.5199999999999996,150.53)
293	Dawson Strait Group	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Dawson Strait Group</b></font><br /><font size="5"><b>D'Entrecasteaux Is</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/115025.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 500 m<br /><b>Latitude:</b> 9.62&deg;S<br /><b>Longitude:</b> 150.88&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Dawson Straits, located between eastern Fergusson and western Normanby Islands in the D'Entrecasteaux island group, contains a volcanic field with several volcanic centers that define a possible partly submerged caldera.  There have been no historical eruptions from this center, but morphology suggests an extremely young age for some lava flows, and the area displays vigorous thermal activity.  The most prominent volcanic centers are Mounts Lamonai and Oiau, located about 10 km apart on the SW tip of Fergusson Island.  The 500-m-high summit of Lamonai is capped by a steep-walled crater, and rhyolitic lava flows are exposed on the NE side of the cone.  Dominantly volcaniclastic Oiau cone has also produced obsidian lava flows.  Dobu Island to the south is formed of coalescing volcanic centers and likewise has produced youthful rhyolitic obsidian flows.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0503-06=&amp;volpage=photos&amp;photo=115025">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0503-06=">Smithsonian Volcano Information</a></td></tr></table>	(-9.6199999999999992,150.88)
294	Lihir	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Lihir</b></font><br /><font size="5"><b>New Ireland</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/107067.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic complex<br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 700 m<br /><b>Latitude:</b> 3.125&deg;S<br /><b>Longitude:</b> 152.642&deg;E</td></tr><tr><td colspan="2"><p align="justify">Lihir Island, the largest of an island group north of New Ireland, is a Pliocene-to-Holocene volcanic complex of several overlapping basaltic stratovolcanoes.  The youngest volcano, Luise, contains an elliptical, 5.5-km-wide caldera that is breached by the sea on the NE side as a result of edifice collapse about 0.4 million years ago, forming Luise Harbor.  The flanks of the volcano are only moderately dissected.  The steep-sided caldera wall rises to 700 m above sea level.  A central lava plug is strongly hydrothermally altered and displays extensive thermal activity along its margins.  Thermal activity includes boiling hot springs, mud pools, and sulfur-encrusted low-temperature fumaroles.  The Ladolam hydrothermal deposit hosts one of the youngest and largest gold deposits in the world, which is now being extracted by open-pit mining.  The near-surface, epithermal gold deposition extends to about 400 m below sea level over an area of about 2 sq km.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0504-01=&amp;volpage=photos&amp;photo=107067">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0504-01=">Smithsonian Volcano Information</a></td></tr></table>	(-3.125,152.642)
295	Ambitle	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ambitle</b></font><br /><font size="5"><b>New Ireland</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/107068.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 450 m<br /><b>Latitude:</b> 4.08&deg;S<br /><b>Longitude:</b> 153.65&deg;E</td></tr><tr><td colspan="2"><p align="justify">Ambitle is the larger of two adjacent islands forming the Feni Islands, which are located near the SE end of an island chain north and east of New Ireland.  Ambitle is a dominantly Pliocene-to-Pleistocene stratovolcano characterized by a variety of alkalic rocks types.  A 3-km-wide central caldera was constructed over Tertiary marine limestone deposits and is occupied by late-Pleistocene trachytic lava domes.  A maar on the eastern side of the domes formed about 2300 years ago.  Several thermal areas, consisting of hot and boiling springs, mud pools, and low-temperature fumaroles, are found on the western side of the caldera floor and near the western edge of the central lava dome.  Shallow-water hydrothermal venting also occurs in a coral reef environment just off the western coast of the island.  Babase Island, immediately to the NE of Ambitle, is composed of a Pleistocene stratovolcano and lava dome connected by a narrow isthmus.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0504-02=&amp;volpage=photos&amp;photo=107068">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0504-02=">Smithsonian Volcano Information</a></td></tr></table>	(-4.0800000000000001,153.65000000000001)
296	Tore	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tore</b></font><br /><font size="5"><b>Bougainville</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111004.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava cone<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 2200+ m<br /><b>Latitude:</b> 5.83&deg;S<br /><b>Longitude:</b> 154.93&deg;E</td></tr><tr><td colspan="2"><p align="justify">A 6 x 9 km caldera at Tore volcano in the Emperor Range on NW Bougainville Island is the source of two Pleistocene ignimbrites that form a broad fan that extends the coastline to the west.  The southern and SW sides of the caldera rim are covered by lava flows that extend up to 14 km from a large post-caldera lava cone.  The summit of the andesitic volcano consists of an erosional pyramidal peak and a forested satellitic ash cone 3 km to the NW.  The freshly preserved features of the post-caldera ash cone and lava cone indicate a Recent age (Blake and Miezitis, 1967).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0505-00-&amp;volpage=photos&amp;photo=111004">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0505-00-">Smithsonian Volcano Information</a></td></tr></table>	(-5.8300000000000001,154.93000000000001)
297	Balbi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Balbi</b></font><br /><font size="5"><b>Bougainville</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/004096.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2715 m<br /><b>Latitude:</b> 5.92&deg;S<br /><b>Longitude:</b> 154.98&deg;E</td></tr><tr><td colspan="2"><p align="justify">The large Balbi stratovolcano forms the highest point on Bougainville Island.  The 2715-m-high summit of the complex andesitic volcano is part of a large number of coalesced cones and lava domes.  Five well-preserved craters occupy a NW-SE-trending ridge north of the summit cone, which also contains a crater.  Three large valleys with steep headwalls dissect the flanks of the volcano.  The age of the most recent eruption of Balbi volcano is not known precisely.  An oral tradition of a major eruption during the 19th century is now thought to be in error, but could refer to minor eruptive activity from this relatively youthful-looking volcano.  Fumaroles ares located within 600-m-wide Crater B and on its western flank.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0505-01=&amp;volpage=photos&amp;photo=004096">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0505-01=">Smithsonian Volcano Information</a></td></tr></table>	(-5.9199999999999999,154.97999999999999)
298	Billy Mitchell	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Billy Mitchell</b></font><br /><font size="5"><b>Bougainville</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/004098.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic shield<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 1544 m<br /><b>Latitude:</b> 6.092&deg;S<br /><b>Longitude:</b> 155.225&deg;E</td></tr><tr><td colspan="2"><p align="justify">Billy Mitchell, a small pyroclastic shield immediately NE of Bagana volcano, has produced some of the largest Holocene eruptions of Papua New Guinea.  Andesitic-to-dacitic Billy Mitchell volcano is truncated by a 2-km-wide caldera containing a shallow lake with a small island near its southern shore.  Two major explosive eruptions, one about 900 years ago and the other about 370 years ago, produced dacitic pyroclastic-fall deposits that cover most of the northern half of Bougainville Island.  The younger eruption may have been responsible for formation of the nearly vertical, steep-walled summit caldera.  Pyroclastic-flow and -surge deposits from Billy Mitchell extend 25 km to the eastern coast of Bougainville Island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0505-011&amp;volpage=photos&amp;photo=004098">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0505-011">Smithsonian Volcano Information</a></td></tr></table>	(-6.0919999999999996,155.22499999999999)
299	Bagana	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bagana</b></font><br /><font size="5"><b>Bougainville</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/004100.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava cone<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 1750 m<br /><b>Latitude:</b> 6.140&deg;S<br /><b>Longitude:</b> 155.195&deg;E</td></tr><tr><td colspan="2"><p align="justify">Bagana volcano, occupying a remote portion of central Bougainville Island, is one of Melanesia's youngest and most active volcanoes.  Bagana is a massive symmetrical, roughly 1750-m-high lava cone largely constructed by an accumulation of viscous andesitic lava flows.  The entire lava cone could have been constructed in about 300 years at its present rate of lava production.  Eruptive activity at Bagana is frequent and is characterized by non-explosive effusion of viscous lava that maintains a small lava dome in the summit crater, although explosive activity occasionally producing pyroclastic flows also occurs.  Lava flows form dramatic, freshly preserved tongue-shaped lobes up to 50-m-thick with prominent levees that descend the volcano's flanks on all sides.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0505-02=&amp;volpage=photos&amp;photo=004100">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0505-02=">Smithsonian Volcano Information</a></td></tr></table>	(-6.1399999999999997,155.19499999999999)
300	Takuan Group	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Takuan Group</b></font><br /><font size="5"><b>Bougainville</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic complex<br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2210 m<br /><b>Latitude:</b> 6.442&deg;S<br /><b>Longitude:</b> 155.608&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Takuan volcano group in southern Bougainville Island consists of three closely spaced, NW-SE-trending andesitic-dacitic stratovolcanoes.  Two of these are relatively uneroded and have probably been active during the Holocene, and a third, extensively eroded volcano is probably Pleistocene in age (Blake and Meizitis 1967).  Along with Loloru volcano, the Takuan volcanoes are post-caldera cones constructed along the rim of the Pleistocene Laluai caldera.  The 2210-m NW-most volcano, Mount Takuan, is the highest of the group and is a lava cone that has fed viscous lavas flows to the south, similar to those at Bagana volcano.  The central volcano contains a large lava dome in its breached summit crater; this dome may represent the most recent activity of the Takuan volcano group.  Older, but still well-preserved lava flows are found on the flanks of this volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0505-021">Smithsonian Volcano Information</a></td></tr></table>	(-6.4420000000000002,155.608)
301	Loloru	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Loloru</b></font><br /><font size="5"><b>Bougainville</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/005004.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic shield<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 1887 m<br /><b>Latitude:</b> 6.52&deg;S<br /><b>Longitude:</b> 155.62&deg;E</td></tr><tr><td colspan="2"><p align="justify">Loloru, the SE-most volcano on Bougainville Island, is the source of a broad ignimbrite apron that covers much of the southern part of the island.  The summit consists of two nested calderas, and a forested andesitic lava dome that restricts a crescent-shaped lake to the eastern side of the younger caldera.  The smooth flanks of the pyroclastic shield are dissected by radiating deep valleys.  A pristine lava flow occurs on the SE flank.  Loloru is constructed within the 10 x 15 km Pleistocene Laluai caldera.  The topographically higher Taroka group of volcanoes to the NW and the Takuan group to the north also were constructed within the caldera and served to deflect the bulk of Loloru ignimbrites to the south.  The most recent of several major Holocene explosive eruptions at Loloru took place about 3000 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0505-03=&amp;volpage=photos&amp;photo=005004">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0505-03=">Smithsonian Volcano Information</a></td></tr></table>	(-6.5199999999999996,155.62)
302	Simbo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Simbo</b></font><br /><font size="5"><b>Solomon Islands (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117063.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Explosion craters</td><td width="50%" align="left"><b>Summit Elev:</b> 335 m<br /><b>Latitude:</b> 8.292&deg;S<br /><b>Longitude:</b> 156.52&deg;E</td></tr><tr><td colspan="2"><p align="justify">Simbo is a small island in the Western Solomons with three truncated andesitic volcanic centers.  The only Potassium-Argon date (2.3 +/- 1 million years ago from Mount Patukio) suggests a Pliocene-to-Pleistocene age for the island (Solomon Islands Geological Survey, 1982).  The southern half of the island is thermally active.  It contains fault-related fumarolic areas and hot springs near saltwater Lake Ove along the western coast and along the eastern coast near Mount Patukio, which has a steep-walled summit crater.  Grover (1955) noted native accounts of the explosive enlargement of the Ngusunu explosion crater along the SW coast of the island one to two generations prior to 1955, probably after a visit by Guppy in 1882.  Press reports mentioned an eruption at Simbo in the early 1900s that forced the evacuation of villages beside Lake Ove, immediately adjacent to Ngusunu crater.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0505-05=&amp;volpage=photos&amp;photo=117063">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0505-05=">Smithsonian Volcano Information</a></td></tr></table>	(-8.2919999999999998,156.52000000000001)
303	Kana Keoki	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kana Keoki</b></font><br /><font size="5"><b>Solomon Islands (SW Pacific)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -700 m<br /><b>Latitude:</b> 8.75&deg;S<br /><b>Longitude:</b> 157.03&deg;E</td></tr><tr><td colspan="2"><p align="justify">Bathymetry and petrologic evidence indicated the presence of an active dacitic submarine volcano SW of Rendova Island (Taylor, 1987).  Kana Keoki Seamount, located along the Ghizo Ridge south of the convergent margin between the Indo-Australian and Pacific plates, rises to within about 700 m of the surface from a depth of 3700 m and is surrounded by a volcaniclastic apron.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0505-052">Smithsonian Volcano Information</a></td></tr></table>	(-8.75,157.03)
304	Coleman Seamount	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Coleman Seamount</b></font><br /><font size="5"><b>Solomon Islands (SW Pacific)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Latitude:</b> 8.83&deg;S<br /><b>Longitude:</b> 157.17&deg;E</td></tr><tr><td colspan="2"><p align="justify">The research vessel &quot;Moana Wave&quot; of the University of Hawaii discovered a young submarine volcano SE of Kana Keoki seamount during a November 1985 to January 1986 cruise.  The volcano, named Coleman Seamount, was constructed over the eastern end of the inactive Woodlark spreading center, south of the convergent boundary between the Indo-Australian and Pacific plates.  Coleman Seamount is undissected and probably even more recently active than Kana Keoki Seamount.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0505-053">Smithsonian Volcano Information</a></td></tr></table>	(-8.8300000000000001,157.16999999999999)
305	Kavachi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kavachi</b></font><br /><font size="5"><b>Solomon Islands (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/016090.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> -20 m<br /><b>Latitude:</b> 9.02&deg;S<br /><b>Longitude:</b> 157.95&deg;E</td></tr><tr><td colspan="2"><p align="justify">Kavachi, one of the most active submarine volcanoes in the SW Pacific, occupies an isolated position in the Solomon Islands far from major aircraft and shipping lanes.  Kavachi, sometimes referred to as Rejo te Kvachi (&quot;Kavachi's Oven&quot;), is located south of Vangunu Island only about 30 km north of the site of subduction of the Indo-Australian plate beneath the Pacific plate.  The shallow submarine basaltic-to-andesitic volcano has produced ephemeral islands up to 1 km long many times since its first recorded eruption during 1939.  Residents of the nearby islands of Vanguna and Nggatokae (Gatokae) reported &quot;fire on the water&quot; prior to 1939, a possible reference to earlier submarine eruptions.  The roughly conical volcano rises from water depths of 1.1-1.2 km on the north and greater depths to the south.  Frequent shallow submarine and occasional subaerial eruptions produce phreatomagmatic explosions that eject steam, ash, and incandescent bombs above the sea surface.  On a number of occasions lava flows were observed on the surface of ephemeral islands.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0505-06=&amp;volpage=photos&amp;photo=016090">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0505-06=">Smithsonian Volcano Information</a></td></tr></table>	(-9.0199999999999996,157.94999999999999)
306	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>Solomon Islands (SW Pacific)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcanoes</td><td width="50%" align="left"><b>Summit Elev:</b> -240 m<br /><b>Latitude:</b> 8.92&deg;S<br /><b>Longitude:</b> 158.03&deg;E</td></tr><tr><td colspan="2"><p align="justify">An E-W-trending chain of seamounts is located immediately north of Kavachi submarine volcano.  The westernmost seamount, located 7 km NW of Kavachi, is the largest, and has a flat-topped summit that extended to within 70-m of the sea surface during a 1979 bathymetric survey.  Its summit is covered with calcareous rocks and is fringed by a reef, but thermal plumes were detected in 1992 from one of its two summit craters.  The central seamount to the east is lower and reaches to within 450 m of the sea surface.  The summit of the easternmost seamount, 9-km NE of Kavachi, lies 240-m beneath the ocean surface.  This unnamed andesitic seamount appears to have been formed by relatively recent eruptions.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0505-061">Smithsonian Volcano Information</a></td></tr></table>	(-8.9199999999999999,158.03)
307	Savo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Savo</b></font><br /><font size="5"><b>Solomon Islands (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/105096.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 485 m<br /><b>Latitude:</b> 9.13&deg;S<br /><b>Longitude:</b> 159.82&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 6 x 7 km island of Savo consists of a forested andesitic-to-dacitic stratovolcano with a shallow, elliptical 1 x 1.5 km wide summit crater.  Lava domes of historical age are located on the crater floor and its NE rim, and older domes occur on the flanks of the volcano.  Pyroclastic flows and mudflows traveled down valleys from the summit crater to form debris fans along the coast.   Thermal areas located in the summit crater, the south to SE flanks, and offshore include areas of steaming ground, fumaroles, small geysers, and hot springs.   Spanish explorers arrived in 1568 during the first historical eruption of Savo.  Pyroclastic flows during the climactic phase killed almost all inhabitants of the island, and oral traditions also note the expansion of the island on the northern side.  Other eruptive episodes occurred during the mid-17th century and during the 1830s to 1840s.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0505-07=&amp;volpage=photos&amp;photo=105096">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0505-07=">Smithsonian Volcano Information</a></td></tr></table>	(-9.1300000000000008,159.81999999999999)
308	Tinakula	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tinakula</b></font><br /><font size="5"><b>Santa Cruz Islands (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104075.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> 851 m<br /><b>Latitude:</b> 10.38&deg;S<br /><b>Longitude:</b> 165.80&deg;E</td></tr><tr><td colspan="2"><p align="justify">The small 3.5-km-wide island of Tinakula is the exposed summit of a massive stratovolcano that rises 3-4 km from the sea floor at the NW end of the Santa Cruz islands.  Tinakula resembles Stromboli volcano in containing a breached summit crater that extends from the 851-m-high summit to below sea level.  Landslides enlarged this scarp in 1965, creating an embayment on the NW coast.  The satellitic cone of Mendana is located on the SE side.  The dominantly andesitic Tinakula volcano has frequently been observed in eruption since the era of Spanish exploration began in 1595.  In about 1840, an explosive eruption apparently produced pyroclastic flows that swept all sides of the island, killing its inhabitants.  Frequent historical eruptions have originated from a cone constructed within the large breached crater.  These have left the upper flanks of the volcano and the steep apron of lava flows and volcaniclastic debris within the breach unvegetated.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0506-01=&amp;volpage=photos&amp;photo=104075">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0506-01=">Smithsonian Volcano Information</a></td></tr></table>	(-10.380000000000001,165.80000000000001)
309	Motlav	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Motlav</b></font><br /><font size="5"><b>Banks Islands (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111011.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 411 m<br /><b>Latitude:</b> 13.67&deg;S<br /><b>Longitude:</b> 167.67&deg;E</td></tr><tr><td colspan="2"><p align="justify">The elongated island of Motlav, also referred to as Mota Lava, is comprised of at least five Pleistocene basaltic stratovolcanoes capped by two well-preserved late-Pleistocene to Holocene pyroclastic cones, Tuntog and Vetnam.  Tuntog is a largely pyroclastic composite cone at the SW end of the island with a 500-m-wide summit crater.  Vetman, in the center of the island, is a pyroclastic cone truncated by a summit crater that is breached on the southern side.  The 411-m high point of Motlav is a remnant of older volcanics along the central ridge of the 12-km-long, NE-SW-trending island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0507-001&amp;volpage=photos&amp;photo=111011">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0507-001">Smithsonian Volcano Information</a></td></tr></table>	(-13.67,167.66999999999999)
310	Suretamatai	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Suretamatai</b></font><br /><font size="5"><b>Banks Islands (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111012.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 921 m<br /><b>Latitude:</b> 13.80&deg;S<br /><b>Longitude:</b> 167.47&deg;E</td></tr><tr><td colspan="2"><p align="justify">Suretamatai volcano forms much of Vanua Lava Island, one of the largest of Vanuatu's Banks Islands.  The younger lavas of 921-m-high Suretamatai (also known as Soritimeat) volcano overlie a number of small older stratovolcanoes that form the island.  In contrast to other large volcanoes of Vanuatu, the dominantly basaltic-to-andesitic Suretamatai does not contain a youthful summit caldera.  A chain of small stratovolcanoes, oriented along a NNE-SSW line, gives the low-angle volcano an irregular profile.  The youngest cone, near the northern end of the chain, is the largest and contains a lake of variable depth within its 900-m-wide, 100-m-deep summit crater.  Historical activity, beginning during the 19th century, has been restricted to moderate explosive eruptions.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0507-01=&amp;volpage=photos&amp;photo=111012">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0507-01=">Smithsonian Volcano Information</a></td></tr></table>	(-13.800000000000001,167.47)
311	Gaua	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Gaua</b></font><br /><font size="5"><b>Banks Islands (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/085033.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 797 m<br /><b>Latitude:</b> 14.27&deg;S<br /><b>Longitude:</b> 167.50&deg;E</td></tr><tr><td colspan="2"><p align="justify">The roughly 20-km-diameter Gaua Island, also known as Santa Maria, consists of a basaltic-to-andesitic stratovolcano with an 6 x 9 km wide summit caldera.  Small parasitic vents near the caldera rim fed Pleistocene lava flows that reached the coast on several sides of the island; several littoral cones were formed where these lava flows reached the sea.  Quiet collapse that formed the roughly 700-m-deep caldera was followed by extensive ash eruptions.  Construction of the historically active cone of Mount Garat (Gharat) and other small cinder cones in the SW part of the caldera has left a crescent-shaped caldera lake.  The symmetrical, flat-topped  Mount Garat cone is topped by three pit craters.  The onset of eruptive activity from a vent high on the SE flank of Mount Garat in 1962 ended a long period of dormancy.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0507-02=&amp;volpage=photos&amp;photo=085033">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0507-02=">Smithsonian Volcano Information</a></td></tr></table>	(-14.27,167.5)
312	Mere Lava	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mere Lava</b></font><br /><font size="5"><b>Banks Islands (SW Pacific)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1028 m<br /><b>Latitude:</b> 14.45&deg;S<br /><b>Longitude:</b> 168.05&deg;E</td></tr><tr><td colspan="2"><p align="justify">The small 4-km-wide symmetrical island of basaltic Mera Lava in the southern Banks Islands contains a well-preserved summit crater and an east-west line of young cinder cones cutting across the NE flank.  Several small cinder cones occupy the triangular summit crater of 1028-m-high Star Peak, the high point of the island.  The low degree of dissection indicates that Mera Lava was in eruption during the Holocene (Mallick and Ash, 1975).  Mere Lava was reported to have been smoking when it was first seen by the explorer Queiros in 1606.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0507-021">Smithsonian Volcano Information</a></td></tr></table>	(-14.449999999999999,168.05000000000001)
313	Aoba	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Aoba</b></font><br /><font size="5"><b>Vanuatu (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119011.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1496 m<br /><b>Latitude:</b> 15.40&deg;S<br /><b>Longitude:</b> 167.83&deg;E</td></tr><tr><td colspan="2"><p align="justify">Aoba, also known as Ambae, is a massive 2500 cu km basaltic shield volcano that is the most voluminous volcano of the New Hebrides archipelago.  A pronounced NE-SW-trending rift zone dotted with scoria cones gives the 16 x 38 km island an elongated form.  A broad pyroclastic cone containing three crater lakes is located at the summit of the Hawaiian-style shield volcano within the youngest of at least two nested calderas, the largest of which is 6 km in diameter.  Post-caldera explosive eruptions formed the summit craters of Lake Voui (also spelled Vui) and Lake Manaro Ngoru about 360 years ago.  A tuff cone was constructed within Lake Voui about 60 years later.  The latest known flank eruption, about 300 years ago, destroyed the population of the Nduindui area near the western coast.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0507-03=&amp;volpage=photos&amp;photo=119011">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0507-03=">Smithsonian Volcano Information</a></td></tr></table>	(-15.4,167.83000000000001)
314	Ambrym	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ambrym</b></font><br /><font size="5"><b>Vanuatu (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119013.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic shield<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1334 m<br /><b>Latitude:</b> 16.25&deg;S<br /><b>Longitude:</b> 168.12&deg;E</td></tr><tr><td colspan="2"><p align="justify">Ambrym, a large basaltic volcano with a 12-km-wide caldera, is one of the most active volcanoes of the New Hebrides arc.  A thick, almost exclusively pyroclastic sequence, initially dacitic, then basaltic, overlies lava flows of a pre-caldera shield volcano.  The caldera was formed during a major plinian eruption with dacitic pyroclastic flows about 1900 years ago.  Post-caldera eruptions, primarily from Marum and Benbow cones, have partially filled the caldera floor and produced lava flows that ponded on the caldera floor or overflowed through gaps in the caldera rim. Post-caldera eruptions have also formed a series of scoria cones and maars along a fissure system oriented ENE-WSW.  Eruptions have apparently occurred almost yearly during historical time from cones within the caldera or from flank vents.  However, from 1850 to 1950, reporting was mostly limited to extra-caldera eruptions that would have affected local populations.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0507-04=&amp;volpage=photos&amp;photo=119013">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0507-04=">Smithsonian Volcano Information</a></td></tr></table>	(-16.25,168.12)
315	Lopevi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Lopevi</b></font><br /><font size="5"><b>Vanuatu (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119014.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1413 m<br /><b>Latitude:</b> 16.507&deg;S<br /><b>Longitude:</b> 168.346&deg;E</td></tr><tr><td colspan="2"><p align="justify">The small 7-km-wide conical island of Lopevi, known locally as Vanei Vollohulu, is one of Vanuatu's most active volcanoes.  A small summit crater containing a cinder cone is breached to the NW and tops an older cone that is rimmed by the remnant of a larger crater.  The basaltic-to-andesitic volcano has been active during historical time at both summit and flank vents, primarily along a NW-SE-trending fissure that cuts across the island, producing moderate explosive eruptions and lava flows that reached the coast.  Historical eruptions at the 1413-m-high volcano date back to the mid-19th century.  The island was evacuated following major eruptions in 1939 and 1960.  The latter eruption, from a NW-flank fissure vent, produced a pyroclastic flow that swept to the sea and a lava flow that formed a new peninsula on the western coast.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0507-05=&amp;volpage=photos&amp;photo=119014">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0507-05=">Smithsonian Volcano Information</a></td></tr></table>	(-16.507000000000001,168.346)
316	Epi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Epi</b></font><br /><font size="5"><b>Vanuatu (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110036.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Submarine volcanoes</td><td width="50%" align="left"><b>Summit Elev:</b> 833 m<br /><b>Latitude:</b> 16.68&deg;S<br /><b>Longitude:</b> 168.37&deg;E</td></tr><tr><td colspan="2"><p align="justify">A large caldera, with submarine post-caldera cones active in historical time, lies off the eastern coast of Epi Island.  Epi Island itself, located slightly west of the main New Hebrides volcanic arc, largely consists of two Quaternary volcanoes, Mount Allombei on the west and Pomare (Tavani Kutali) on the east.  Tavani Ruro, which forms an elongated eastern extension of Epi Island across a narrow isthmus, is related to Kuwae caldera to the east.  Pomare volcano is the highest point on the island and has three well-preserved subsidiary cones to the east with youthful summit craters.  Pomare volcano is truncated on its eastern side by the largely submarine East Epi caldera, which has been the source of all historical eruptions.  Three small submarine basaltic and dacitic cones, known as Epi A, Epi B, and Epi C, are located along the northern rim of the breached caldera.  Ephemeral islands were formed during eruptions in 1920 and 1953, and the summit of the shallowest cone, Epi B, was at 34 m below sea level at the time of a 2001 survey.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0507-06=&amp;volpage=photos&amp;photo=110036">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0507-06=">Smithsonian Volcano Information</a></td></tr></table>	(-16.68,168.37)
317	Kuwae	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kuwae</b></font><br /><font size="5"><b>Vanuatu (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119010.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Stratovolcanoes</td><td width="50%" align="left"><b>Summit Elev:</b> -2 m<br /><b>Latitude:</b> 16.829&deg;S<br /><b>Longitude:</b> 168.536&deg;E</td></tr><tr><td colspan="2"><p align="justify">The largely submarine Kuwae caldera occupies the area between Epi and Tongoa islands.  The 6 x 12 km caldera contains two basins that cut the NW end of Tongoa Island and the flank of the late-Pleistocene or Holocene Tavani Ruru volcano on the SE tip of Epi Island.  Native legends and radiocarbon dates from pyroclastic-flow deposits have been correlated with a 1452 AD ice-core peak thought to be associated with collapse of Kuwae caldera; however, others considered the deposits to be of smaller-scale eruptions and the ice-core peak to be associated with another unknown major South Pacific eruption.  The submarine volcano Karua lies near the northern rim of Kuwae caldera and is one of the most active volcanoes of Vanuatu.  It has formed several ephemeral islands since it was first observed in eruption during 1897.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0507-07=&amp;volpage=photos&amp;photo=119010">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0507-07=">Smithsonian Volcano Information</a></td></tr></table>	(-16.829000000000001,168.536)
318	North Vate	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>North Vate</b></font><br /><font size="5"><b>Vanuatu (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119012.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 594 m<br /><b>Latitude:</b> 17.47&deg;S<br /><b>Longitude:</b> 168.353&deg;E</td></tr><tr><td colspan="2"><p align="justify">The islands of Nguna, Pele, and Emau, north of Vate Island (also known as Efat), have been variously mapped as Pleistocene and Pleistocene to Holocene.  Late-Pleistocene to Holocene eruptions constructed composite basaltic cones with well-preserved craters.  Largely submarine calderas north of Vate Island of varying sizes have been inferred, ranging from a large caldera whose southern rim is defined by the islands of Nguna, Pele, and Emao to a smaller caldera, but their submarine morphology is difficult to define.  Pumiceous deposits of the Efat Pumice Formation cover much of Vate (Efat) Island and record a major trachydacitic explosive eruption about 1 million years ago that originated from a submarine vent somewhere north of the island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0507-081&amp;volpage=photos&amp;photo=119012">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0507-081">Smithsonian Volcano Information</a></td></tr></table>	(-17.469999999999999,168.35300000000001)
319	Traitor's Head	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Traitor's Head</b></font><br /><font size="5"><b>Vanuatu (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104077.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 837 m<br /><b>Latitude:</b> 18.75&deg;S<br /><b>Longitude:</b> 169.23&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Traitor's Head Peninsula north of Cook Bay on eastern Erromango Island is comprised of three Holocene volcanic cones that are the youngest on the 50-km-long island.  Mounts Rantop, Nagat, and Oulenou are small basaltic-to-andesitic stratovolcanoes with well-preserved morphologies.  Mount Rantop is the largest, rising to 837 m, and 421-m-high Mount Oulenou is the most youthful looking, with an unbreached crater.  A low plateau to the NW is underlain by ash deposits distributed by southeasterly trade winds.  The volcanoes initially formed an offshore island that was joined to the mainland by uplift after volcanism ceased.  A submarine vent offshore between the tip of the peninsula and Goat Island, 5 km to the NE, erupted in 1881, the only historical activity of the Erromango volcanoes.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0507-09=&amp;volpage=photos&amp;photo=104077">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0507-09=">Smithsonian Volcano Information</a></td></tr></table>	(-18.75,169.22999999999999)
320	Yasur	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Yasur</b></font><br /><font size="5"><b>Vanuatu (SW Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/016098.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 361 m<br /><b>Latitude:</b> 19.53&deg;S<br /><b>Longitude:</b> 169.442&deg;E</td></tr><tr><td colspan="2"><p align="justify">Yasur, the best-known and most frequently visited of the Vanuatu volcanoes, has been in more-or-less continuous strombolian and vulcanian activity since Captain Cook observed ash eruptions in 1774.  This style of activity may have continued for the past 800 years.  Yasur, located at the SE tip of Tanna Island, is a mostly unvegetated 361-m-high pyroclastic cone with a nearly circular, 400-m-wide summit crater.  Yasur is largely contained within the small Yenkahe caldera and is the youngest of a group of Holocene volcanic centers constructed over the down-dropped NE flank of the Pleistocene Tukosmeru volcano.  The Yenkahe horst is located within the Siwi ring fracture, a 4-km-wide, horseshoe-shaped caldera associated with eruption of the andesitic Siwi pyroclastic sequence.  Active tectonism along the Yenkahe horst accompanying eruptions of Yasur has raised Port Resolution harbor more than 20 m during the past century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0507-10=&amp;volpage=photos&amp;photo=016098">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0507-10=">Smithsonian Volcano Information</a></td></tr></table>	(-19.530000000000001,169.44200000000001)
321	Eastern Gemini Seamount	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Eastern Gemini Seamount</b></font><br /><font size="5"><b>Southwestern Pacific Ocean</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -80 m<br /><b>Latitude:</b> 20.98&deg;S<br /><b>Longitude:</b> 170.28&deg;E</td></tr><tr><td colspan="2"><p align="justify">A submarine eruption, the first recorded in historical time from this previously little known seamount, was observed by a passing ship on February 18, 1996.  Water discoloration and bursts of very dark water were observed at Eastern Gemini.  Overflights as late as the 22nd noted periodic explosions that ejected black products to about 20 m above sea level.  Located ~100 km south of Aneityum Island, about halfway between Yasur volcano and Matthew Island, the Eastern Gemini seamount, also known as Oscostar, is one of several seamounts along the southern submarine extension of the New Hebrides island arc.  It consists of an elongated NNE-SSW-trending ridge of submarine volcanoes with satellitic cones.  Several basaltic samples and one andesitic rock dredged from this seamount in 1989 were described as glassy, vesicular, and extremely fresh.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0508-001">Smithsonian Volcano Information</a></td></tr></table>	(-20.98,170.28)
322	Matthew Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Matthew Island</b></font><br /><font size="5"><b>Southwestern Pacific Ocean</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/017003.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 177 m<br /><b>Latitude:</b> 22.33&deg;S<br /><b>Longitude:</b> 171.32&deg;E</td></tr><tr><td colspan="2"><p align="justify">Isolated Matthew Island is composed of two low andesitic-to-dacitic cones separated by a narrow isthmus.  Matthew Island was discovered in 1788 by a ship captain, who named the island after the owner of his vessel.  Only the triangular eastern portion of the small, 0.6 x 1.2 km wide island was present prior to the 1940s, when construction of the larger western segment began; it consists primarily of lava flows.  The 177-m-high western cone contains a crater that is breached to the NW and is filled by a lava flow whose terminus forms the NW coast.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0508-01=&amp;volpage=photos&amp;photo=017003">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0508-01=">Smithsonian Volcano Information</a></td></tr></table>	(-22.329999999999998,171.31999999999999)
323	Hunter Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hunter Island</b></font><br /><font size="5"><b>Southwestern Pacific Ocean</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 297 m<br /><b>Latitude:</b> 22.40&deg;S<br /><b>Longitude:</b> 172.05&deg;E</td></tr><tr><td colspan="2"><p align="justify">Hunter Island, the SE-most volcano of the New Hebrides arc, is a small 1-km-wide island consisting of a composite andesitic-to-dacitic cone topped by explosion craters and a lava dome.  The island was named after the vessel that discovered it in 1798.  A 100-m-deep, steep-sided crater occupies the NW part of the island, which contrasts with the southern cone, whose summit is filled by a lava dome.  Several poorly documented eruptions have been noted since the 19th century.  Large streams of lava were reported to be pouring from two craters on the eastern side of the island in 1895; the latest eruption apparently took place from the northern tip of the island.  Fumarolic and solfataric areas are located at the northern tip of the island and the NE and SE coasts.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0508-02=">Smithsonian Volcano Information</a></td></tr></table>	(-22.399999999999999,172.05000000000001)
324	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>Southwestern Pacific Ocean</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -2400? m<br /><b>Latitude:</b> 25.78&deg;S<br /><b>Longitude:</b> 168.63&deg;E</td></tr><tr><td colspan="2"><p align="justify">A hydrophone signal was detected in 1963 from a submarine eruption near the Norfold Island Ridge in the SW Pacific about 450 km SSE of New Caledonia.  A ship shortly thereafter observed large amounts of floating pumice from an area consistent with the hydrophone signal source.  The Norfolk Island Ridge rises at least 1100 m from a typical basin depth of 3500 m in this area.  The location listed here is that of the floating pumice observation.  Pumice has been also been observed previously at this location (Kibblewhite, 1966).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0508-03-">Smithsonian Volcano Information</a></td></tr></table>	(-25.780000000000001,168.63)
325	Newer Volcanics Prov	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Newer Volcanics Prov</b></font><br /><font size="5"><b>Australia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/097017.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Scoria cones<br />&nbsp;&nbsp;&nbsp; Tuff rings</td><td width="50%" align="left"><b>Summit Elev:</b> 1011 m<br /><b>Latitude:</b> 37.77&deg;S<br /><b>Longitude:</b> 142.50&deg;E</td></tr><tr><td colspan="2"><p align="justify">The voluminous Newer Volcanics province covers a broad 15,000 sq km area of SE Australia with nearly 400 small shield volcanoes and explosive vents of Tertiary-to-Holocene age.  Volumetrically the vast proportion of volcanic products consist of flat-lying lava flows, although the most prominent features of the volcanic field are the numerous small scoria cones, tuff rings, and maars that rise above the lava plain.  Several vents were active during the Holocene; another vent (Mount Tower) is now considered to be of late-Pleistocene age.  Late-Pleistocene to Holocene eruptions are characterized by small volume and low explosivity, forming a series of scoria cones, maars, tuff rings, and major valley filling lava flows.  The youngest dated eruptions took place at Mount Schank and Mount Gambier about 5000 years ago, when explosive activity formed several maars and associated lava flows.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0509-01-&amp;volpage=photos&amp;photo=097017">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0509-01-">Smithsonian Volcano Information</a></td></tr></table>	(-37.770000000000003,142.5)
326	Narcondum	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Narcondum</b></font><br /><font size="5"><b>Andaman Islands (Indian Ocean)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/098077.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 710 m<br /><b>Latitude:</b> 13.43&deg;N<br /><b>Longitude:</b> 94.28&deg;E</td></tr><tr><td colspan="2"><p align="justify">Narcondum volcano, an island possession of India in the Andaman Sea, is part of a volcanic arc that continues northward from Sumatra to Burma (Myanmar).  The small 3 x 4 km wide conical island, located about 130 km east of North Andaman Island, rises to 710 m, but its base lies an additional 1000 m beneath the sea.  The island is densely vegetated, bounded by cliffs on the southern side, and capped by three peaks.  No evidence of historical volcanism is present, although the summit region is less densely vegetated.  Volcanism at the andesitic volcano is considered to have continued into the Holocene (Krishnan, 1957).   The island's name means &quot;pit of hell,&quot; although the name could have been mistakenly transferred from the historically active Barren Island volcano, 140 km to the SSW.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0600-001&amp;volpage=photos&amp;photo=098077">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0600-001">Smithsonian Volcano Information</a></td></tr></table>	(13.43,94.280000000000001)
327	Barren Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Barren Island</b></font><br /><font size="5"><b>Andaman Is</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/017006.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> 354 m<br /><b>Latitude:</b> 12.278&deg;N<br /><b>Longitude:</b> 93.858&deg;E</td></tr><tr><td colspan="2"><p align="justify">Barren Island, a possession of India in the Andaman Sea about 135 km NE of Port Blair in the Andaman Islands, is the only historically active volcano along the N-S-trending volcanic arc extending between Sumatra and Burma (Myanmar).  The 354-m-high island is the emergent summit of a volcano that rises from a depth of about 2250 m.  The small, uninhabited 3-km-wide island contains a roughly 2-km-wide caldera with walls 250-350 m high.  The caldera, which is open to the sea on the west, was created during a major explosive eruption in the late Pleistocene that produced pyroclastic-flow and -surge deposits.  The morphology of a fresh pyroclastic cone that was constructed in the center of the caldera has varied during the course of historical eruptions.  Lava flows fill much of the caldera floor and have reached the sea along the western coast during historical eruptions.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0600-01=&amp;volpage=photos&amp;photo=017006">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0600-01=">Smithsonian Volcano Information</a></td></tr></table>	(12.278,93.858000000000004)
328	Seulawah Agam	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Seulawah Agam</b></font><br /><font size="5"><b>Sumatra (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119084.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas</td><td width="50%" align="left"><b>Summit Elev:</b> 1810 m<br /><b>Latitude:</b> 5.448&deg;N<br /><b>Longitude:</b> 95.658&deg;E</td></tr><tr><td colspan="2"><p align="justify">Seulawah Agam at the NW tip of Sumatra is an extensively forested volcano of Pleistocene-Holocene age constructed within the large Pleistocene Lam Teuba caldera.  A smaller 8 x 6 km caldera lies within Lam Teuba caldera.  The summit contains a forested, 400-m-wide crater.  The active van Heutsz crater, located at 650 m on the NNE flank of Suelawah Agam, is one of several areas containing active fumarole fields.  Sapper (1927) and the Catalog of Active Volcanoes of the World (CAVW) reported an explosive eruption in the early 16th century, and the CAVW also listed an eruption from the van Heutsz crater in 1839.  Rock et al. (1982) found no evidence for historical eruptions.  However the Volcanological Survey of Indonesia noted that although no historical eruptions have occurred from the main cone, the reported NNE-flank explosive activity may have been hydrothermal and not have involved new magmatic activity.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-02=&amp;volpage=photos&amp;photo=119084">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(5.4480000000000004,95.658000000000001)
329	Peuet Sague	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Peuet Sague</b></font><br /><font size="5"><b>Sumatra (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119080.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2801 m<br /><b>Latitude:</b> 4.914&deg;N<br /><b>Longitude:</b> 96.329&deg;E</td></tr><tr><td colspan="2"><p align="justify">Peuet Sague is a large volcanic complex that rises to 2801 m in NW Sumatra.  The volcano, whose name means &quot;square,&quot; contains four summit peaks, with the youngest lava dome being located to the north or NW.  This extremely isolated volcano lies several days journey on foot from the nearest village and is infrequently visited.  The first recorded historical eruption took place from 1918-21, when explosive activity and pyroclastic flows accompanied summit lava-dome growth.  The historically active crater is located SE of the Gunung Tutung lava dome and has typically produced small-to-moderate explosive eruptions.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-03=&amp;volpage=photos&amp;photo=119080">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(4.9139999999999997,96.328999999999994)
330	Bur ni Telong	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bur ni Telong</b></font><br /><font size="5"><b>Sumatra (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120019.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2617 m<br /><b>Latitude:</b> 4.769&deg;N<br /><b>Longitude:</b> 96.821&deg;E</td></tr><tr><td colspan="2"><p align="justify">The conical Bur ni Telong volcano was constructed at the southern base of the massive Bur ni Geureudong volcanic complex, one of the largest in northern Sumatra.  The historically active Bur ni Telong volcano lies 4.5 km from the summit of Geureudong and grew to a height of 2624 m.  The summit crater of Bur ni Telong has migrated to the ESE, leaving arcuate crater rims.  Lava flows are exposed on the southern flank.  Explosive eruptions were recorded during the 19th and 20th centuries.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-05=&amp;volpage=photos&amp;photo=120019">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-05=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(4.7690000000000001,96.820999999999998)
331	Sibayak	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sibayak</b></font><br /><font size="5"><b>Sumatra (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/005022.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 2212 m<br /><b>Latitude:</b> 3.23&deg;N<br /><b>Longitude:</b> 98.52&deg;E</td></tr><tr><td colspan="2"><p align="justify">Sibayak and Pinto are twin volcanoes within a compound caldera open to the north.  The 900-m-wide crater of Sibayak is partially filled on the north by Pinto volcano.  A lava flow traveled through a gap in the western crater wall from the summit lava dome of Sibayak.  Area residents record legends of eruptions.  Neumann van Padang (1983) cited a report by Hoekstra of ash clouds that were emitted from the volcano in 1881.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-07=&amp;volpage=photos&amp;photo=005022">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-07=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(3.23,98.519999999999996)
332	Sinabung	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sinabung</b></font><br /><font size="5"><b>Sumatra (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/005030.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 2460 m<br /><b>Latitude:</b> 3.17&deg;N<br /><b>Longitude:</b> 98.392&deg;E</td></tr><tr><td colspan="2"><p align="justify">Gunung Sinabung is a Pleistocene-to-Holocene stratovolcano with many lava flows on its flanks.  The migration of summit vents along a N-S line gives the summit crater complex an elongated form.  The youngest crater of  this conical andesitic-to-dacitic volcano is at the southern end of the four overlapping summit craters.  Solfataric activity was seen at the summit and upper flanks of Sinabung in 1912, although no historical eruptions have been recorded.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-08=&amp;volpage=photos&amp;photo=005030">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-08=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(3.1699999999999999,98.391999999999996)
333	Toba	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Toba</b></font><br /><font size="5"><b>Sumatra (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/114091.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2157 m<br /><b>Latitude:</b> 2.58&deg;N<br /><b>Longitude:</b> 98.83&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 35 x 100 km Toba caldera, the Earth's largest Quaternary caldera, was formed during four major Pleistocene ignimbrite-producing eruptions beginning at 1.2 million years ago.  The latest of these produced the Young Toba Tuff (YTT) about 74,000 years ago.  The YTT represents the world's largest known Quaternary eruption, ejecting about 2500-3000 cu km (dense rock equivalent) of ignimbrite and airfall ash from vents at the NW and SE ends of present-day Lake Toba.  Resurgent doming forming the massive Samosir Island and Uluan Peninsula structural blocks postdated eruption of the YTT.  Additional post-YTT eruptions include emplacement of a series of lava domes, growth of the solfatarically active Pusukbukit volcano on the south margin of the caldera, and formation of Tandukbenua volcano at the NW-most rim of the caldera.  Lack of vegetation suggests that this volcano may be only a few hundred years old (Chesner and Rose, 1991).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-09=&amp;volpage=photos&amp;photo=114091">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-09=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(2.5800000000000001,98.829999999999998)
334	Sorikmarapi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sorikmarapi</b></font><br /><font size="5"><b>Sumatra (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/005044.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 2145 m<br /><b>Latitude:</b> 0.686&deg;N<br /><b>Longitude:</b> 99.539&deg;E</td></tr><tr><td colspan="2"><p align="justify">Sorikmarapi is a forested stratovolcano with a 600-m-wide summit crater containing a crater lake and substantial sulfur deposits.  A smaller parasitic crater (Danau Merah) on the upper SE flank also contains a crater lake; these two craters and a series of smaller explosion pits occur along a NW-SE line.   Several solfatara fields are located on the eastern flank.  Phreatic eruptions have occurred from summit and flank vents during the 19th and 20th centuries.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-12=&amp;volpage=photos&amp;photo=005044">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-12=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(0.68600000000000005,99.539000000000001)
335	Malintang	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Malintang</b></font><br /><font size="5"><b>Sumatra (Indonesia)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 1983 m<br /><b>Latitude:</b> 0.47&deg;N<br /><b>Longitude:</b> 99.67&deg;E</td></tr><tr><td colspan="2"><p align="justify">Malintang is a 1983-m-high forested stratovolcano with a caldera breached to the south.  A 900 x 1500 m lake lies against the back caldera wall.  The flanks of Sorikmalintang are relatively pristine and uneroded, and it most likely has had significant eruptions within the past few thousand years (Kieh, 2009 pers. comm.).  The horseshoe-shaped caldera of the andesitic-to-dacitic volcano may be related to emplacement of a large debris avalanche.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-121">Smithsonian Volcano Information</a></td></tr></table>	(0.46999999999999997,99.670000000000002)
336	Talakmau	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Talakmau</b></font><br /><font size="5"><b>Sumatra (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/045011.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 2919 m<br /><b>Latitude:</b> 0.079&deg;N<br /><b>Longitude:</b> 99.98&deg;E</td></tr><tr><td colspan="2"><p align="justify">Talakmau (also known as Talamau) is a massive compound volcano rising above the western coastal plain of Sumatra.  The andesitic-dacitic volcano is constructed along a NE-SW line, rising to 2912 m, more than 700 m above its twin volcano Pasaman to the SW, which has its own adventive cone, Bukit Nilam, lying 3.4 km to the SW.  Three craters along the same NE-SW trend occur at the summit of Talakmau; the NE-most and highest crater is filled by a lava dome.  Reports of historical eruptions, including one with rumblings and &quot;smoke&quot; emission in 1937, are considered doubtful, but eruptive activity has occurred during the Holocene.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-13=&amp;volpage=photos&amp;photo=045011">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-13=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(0.079000000000000001,99.980000000000004)
337	Marapi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Marapi</b></font><br /><font size="5"><b>Sumatra (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120022.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 2891 m<br /><b>Latitude:</b> 0.381&deg;S<br /><b>Longitude:</b> 100.473&deg;E</td></tr><tr><td colspan="2"><p align="justify">Gunung Marapi, not to be confused with the better-known Merapi volcano on Java, is Sumatra's most active volcano.  Marapi is a massive complex stratovolcano that rises 2000 m above the Bukittinggi plain in Sumatra's Padang Highlands.  A broad summit contains multiple partially overlapping summit craters constructed within the small 1.4-km-wide Bancah caldera.  The summit craters are located along an ENE-WSW line, with volcanism migrating to the west.  More than 50 eruptions, typically consisting of small-to-moderate explosive activity, have been recorded since the end of the 18th century; no lava flows outside the summit craters have been reported in historical time.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-14=&amp;volpage=photos&amp;photo=120022">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-14=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-0.38100000000000001,100.473)
338	Tandikat	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tandikat</b></font><br /><font size="5"><b>Sumatra (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/005048.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes</td><td width="50%" align="left"><b>Summit Elev:</b> 2438 m<br /><b>Latitude:</b> 0.433&deg;S<br /><b>Longitude:</b> 100.317&deg;E</td></tr><tr><td colspan="2"><p align="justify">Tandikat and its twin volcano to the NNE, Singgalang, lie across the Bukittinggi plain from Marapi volcano.  Volcanic activity has migrated to the SSW from Singgalang and only Tandikat has had historical activity.  The summit of Tandikat has a partially eroded 1.2-km-wide crater containing a large central cone capped by a 360-m-wide crater with a small crater lake.  The only three reported historical eruptions, in the late 19th and early 20th centuries, produced only mild explosive activity.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-15=&amp;volpage=photos&amp;photo=005048">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-15=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-0.433,100.31699999999999)
339	Talang	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Talang</b></font><br /><font size="5"><b>Sumatra (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/010016.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 2597 m<br /><b>Latitude:</b> 0.978&deg;S<br /><b>Longitude:</b> 100.679&deg;E</td></tr><tr><td colspan="2"><p align="justify">Talang, which forms a twin volcano with the extinct Pasar Arbaa volcano, lies ESE of the major city of Padang and rises NW of Dibawah Lake.  Talang has two crater lakes on its flanks; the largest of these is 1 x 2 km wide Danau Talang.  Most historical eruptions have not occurred from the summit of the volcano, which lacks a crater.  Historical eruptions from Gunung Talang volcano have mostly involved small-to-moderate explosive activity first documented in the 19th century that originated from a series of small craters in a valley on the upper NE flank.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-16=&amp;volpage=photos&amp;photo=010016">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-16=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-0.97799999999999998,100.679)
340	Kerinci	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kerinci</b></font><br /><font size="5"><b>Sumatra (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120030.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 3800 m<br /><b>Latitude:</b> 1.697&deg;S<br /><b>Longitude:</b> 101.264&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 3800-m-high Gunung Kerinci in central Sumatra forms Indonesia's highest volcano and is one of the most active in Sumatra.  Kerinci is capped by an unvegetated young summit cone that was constructed NE of an older crater remnant.  The volcano contains a deep 600-m-wide summit crater often partially filled by a small crater lake that lies on the NE crater floor, opposite the SW-rim summit of Kerinci.  The massive 13 x 25 km wide volcano towers 2400-3300 m above surrounding plains and is elongated in a N-S direction.  The frequently active Gunung Kerinci has been the source of numerous moderate explosive eruptions since its first recorded eruption in 1838.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-17=&amp;volpage=photos&amp;photo=120030">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-17=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-1.6970000000000001,101.264)
341	Kunyit	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kunyit</b></font><br /><font size="5"><b>Sumatra (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/063018.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 2151 m<br /><b>Latitude:</b> 2.274&deg;S<br /><b>Longitude:</b> 101.483&deg;E</td></tr><tr><td colspan="2"><p align="justify">Kunyit volcano lies about 10 km south of Lake Kerinci, well to the north of its location listed in Neumann van Padang (1951).    The summit of the dacitic, 2151-m-high Kunyit volcano contains two craters open to the south, the uppermost of which has a small crater lake.  The age of the latest eruptive activity from Kunyit is not known, although fumarolic activity occurs at the youngest crater on the northern side of the summit area.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-171&amp;volpage=photos&amp;photo=063018">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-171">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-2.274,101.483)
342	Hutapanjang	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hutapanjang</b></font><br /><font size="5"><b>Sumatra (Indonesia)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 2021 m<br /><b>Latitude:</b> 2.33&deg;S<br /><b>Longitude:</b> 101.60&deg;E</td></tr><tr><td colspan="2"><p align="justify">Hutapanjang stratovolcano, located to the NW of Sumbing volcano,  was classified as active by Rock et al. (1982) and Posavec et al. (1973), with no additional information.  Little is known of this central Sumatran volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-172">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-2.3300000000000001,101.59999999999999)
343	Sumbing	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sumbing</b></font><br /><font size="5"><b>Sumatra (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120040.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 2507 m<br /><b>Latitude:</b> 2.414&deg;S<br /><b>Longitude:</b> 101.728&deg;E</td></tr><tr><td colspan="2"><p align="justify">Smaller than its prominent namesake on Java, Sumatra's Sumbing volcano has a complicated summit region containing several crater remnants and a 180-m-long crater lake.  Its only two known historical eruptions, in 1909 and 1921, produced moderate explosions.  Hot springs occur at the SW foot of the volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-18=&amp;volpage=photos&amp;photo=120040">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-18=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-2.4140000000000001,101.72799999999999)
344	Pendan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Pendan</b></font><br /><font size="5"><b>Sumatra (Indonesia)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Unknown</td><td width="50%" align="left"><b>Latitude:</b> 2.82&deg;S<br /><b>Longitude:</b> 102.02&deg;E</td></tr><tr><td colspan="2"><p align="justify">Pendan is a little-known volcano in central Sumatra that was listed as an active volcanic center by Rock et al. (1982) and Posavec et al. (1973), with no additional information.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-191">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-2.8199999999999998,102.02)
345	Belirang-Beriti	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Belirang-Beriti</b></font><br /><font size="5"><b>Sumatra (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/063019.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Compound volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1958 m<br /><b>Latitude:</b> 2.82&deg;S<br /><b>Longitude:</b> 102.18&deg;E</td></tr><tr><td colspan="2"><p align="justify">The compound Belerang-Beriti volcano rises above the Semalako Plain in SW Sumatra, forming a NW-SE-trending massif that contains a 1.2-km-wide crater breached to the NE.  The age of its latest eruptions is not known, although fumaroles occur in the crater walls.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-20=&amp;volpage=photos&amp;photo=063019">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-20=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-2.8199999999999998,102.18000000000001)
346	Bukit Daun	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bukit Daun</b></font><br /><font size="5"><b>Sumatra (Indonesia)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 2467 m<br /><b>Latitude:</b> 3.38&deg;S<br /><b>Longitude:</b> 102.37&deg;E</td></tr><tr><td colspan="2"><p align="justify">Located in a sparsely populated region of Sumatra, Bukit Daun forms a twin volcano with Gedang volcano, which is truncated by a 3-km-wide probable caldera.  The 600-m-wide summit crater of Bukit Daun contains a crater lake; a smaller crater lake is found at Tologo Kecil on the SSW flank.  No historical eruptions are known from Bukit Daun, although active fumaroles occur in the SSW flank crater.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-21=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-3.3799999999999999,102.37)
347	Kaba	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kaba</b></font><br /><font size="5"><b>Sumatra (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/063020.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> 1952 m<br /><b>Latitude:</b> 3.52&deg;S<br /><b>Longitude:</b> 102.62&deg;E</td></tr><tr><td colspan="2"><p align="justify">Kaba, a twin volcano with Mount Hitam, has an elongated summit crater complex dominated by three large historically active craters trending ENE from the summit to the upper NE flank.  The SW-most crater of 1952-m-high Gunung Kaba, Kawah Lama, is the largest.  Most historical eruptions have affected only the summit region of the volcano.  They mostly originated from the central summit craters, although the upper-NE flank crater Kawah Vogelsang also produced explosions during the 19th and 20th centuries.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-22=&amp;volpage=photos&amp;photo=063020">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-22=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-3.52,102.62)
348	Dempo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Dempo</b></font><br /><font size="5"><b>Sumatra (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/010023.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 3173 m<br /><b>Latitude:</b> 4.03&deg;S<br /><b>Longitude:</b> 103.13&deg;E</td></tr><tr><td colspan="2"><p align="justify">Dempo is a prominent 3173-m-high stratovolcano that rises above the Pasumah Plain of SE Sumatra.  The andesitic Dempo volcanic complex has two main peaks, Gunung Dempo and Gunung Marapi, constructed near the SE rim of a 3 x 5 km caldera breached to the north. The one called Dempo is slightly lower, with an elevation of 3049 m and lies at the SE end of the summit complex. The taller Marapi cone, with a summit elevation 3173 m, was constructed within a crater cutting the older Gunung Dempo edifice.  Remnants of 7 craters are found at or near the summit of the complex, with volcanism migrating to the WNW with time.  The large, 800 x 1100 m wide historically active summit crater cuts the NW side of Gunung Marapi (not to be confused with Marapi volcano 500 km to the NW in Sumatra) and contains a 400-m-wide lake located at the far NW end of the crater complex.  Historical eruptions have been restricted to small-to-moderate explosive activity that produced ashfall near the volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-23=&amp;volpage=photos&amp;photo=010023">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-23=">Smithsonian Volcano Information</a></td></tr></table>	(-4.0300000000000002,103.13)
349	Patah	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Patah</b></font><br /><font size="5"><b>Sumatra (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/017016.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Unknown</td><td width="50%" align="left"><b>Summit Elev:</b> 2817 m<br /><b>Latitude:</b> 4.27&deg;S<br /><b>Longitude:</b> 103.30&deg;E</td></tr><tr><td colspan="2"><p align="justify">Patah is a heavily forested, dissected Quaternary volcano SE of Dempo volcano.  The age of its latest eruptions is not known, although on May 1, 1989, a possible new crater with active fumaroles was observed by a cargo aircraft pilot in a heavily forested area about 6 km SE of the summit of Gunung Patah, near Bukit Baturigis (about 4 deg 18 min S, 103 deg 19 min E).  The exact location of the 150-m-wide crater, date of its formation, and its geologic relationship to nearby Patah volcano are uncertain.   Another vent containing a crater lake is located 1 km to the south.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-231&amp;volpage=photos&amp;photo=017016">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-231">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-4.2699999999999996,103.3)
350	Bukit Lumut Balai	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bukit Lumut Balai</b></font><br /><font size="5"><b>Sumatra (Indonesia)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano ?</td><td width="50%" align="left"><b>Summit Elev:</b> 2055 m<br /><b>Latitude:</b> 4.22&deg;S<br /><b>Longitude:</b> 103.62&deg;E</td></tr><tr><td colspan="2"><p align="justify">Bukit Lumut Balai is a heavily eroded volcano consisting of three eruption centers, two on Bukit Lumut and one on the NE side of Bukit Balai, 5 km to the east.  Large lava flows occur on the north side of Bukit Balai.  The age of the latest eruption of the volcano is not known, but active fumarole fields are found in two crescentic basins that open to the north on Bukit Lumut.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-24=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-4.2199999999999998,103.62)
351	Besar	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Besar</b></font><br /><font size="5"><b>Sumatra (Indonesia)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano ?</td><td width="50%" align="left"><b>Summit Elev:</b> 1899 m<br /><b>Latitude:</b> 4.43&deg;S<br /><b>Longitude:</b> 103.67&deg;E</td></tr><tr><td colspan="2"><p align="justify">Gunung Besar is a 1899-m-high volcano in SE Sumatra with a minor sulfur deposit in its crater.  A major solfatara field, Marga Bayur, is located along its north and NW flanks along the Semangko fault system.  A minor phreatic eruption occurred in 1940 from Gemurah Ilahan, one of four solfatara fields of the Marga Bayur field.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-25=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-4.4299999999999997,103.67)
352	Sekincau Belirang	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sekincau Belirang</b></font><br /><font size="5"><b>Sumatra (Indonesia)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Cone</td><td width="50%" align="left"><b>Summit Elev:</b> 1719 m<br /><b>Latitude:</b> 5.12&deg;S<br /><b>Longitude:</b> 104.32&deg;E</td></tr><tr><td colspan="2"><p align="justify">Sekincau volcano was constructed near the southern rim of the small NW-SE-trending double Belirang and Balak calderas, 2 and 2.5 km wide, respectively.  The 300-m-wide crater of Sekincau is open to the south.  The age of the latest eruptive activity is not known, although fumarolic activity occurs on the caldera floor and on the eastern and SE outer flanks of Balak caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-26=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-5.1200000000000001,104.31999999999999)
353	Suoh	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Suoh</b></font><br /><font size="5"><b>Sumatra (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/045013.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Maars<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1000 m<br /><b>Latitude:</b> 5.25&deg;S<br /><b>Longitude:</b> 104.27&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 8 x 16 km Suoh (or Suwoh) depression appears to have a dominantly tectonic origin, but contains a smaller complex of overlapping calderas oriented NNE-SSW.  Historically active maars and silicic domes lie along the margins of the depression, which lies along the Great Sumatran Fault that extends the length of the island.  Numerous hot springs occur along faults within the depression, which contains the Pematang Bata fumarole field.  Large phreatic explosions (0.2 cu km tephra) occurred at the time of a major tectonic earthquake in 1933.  Very minor hydrothermal explosions produced two 5-m-wide craters at the time of a February 1994 earthquake.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-27=&amp;volpage=photos&amp;photo=045013">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-27=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-5.25,104.27)
354	Hulubelu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hulubelu</b></font><br /><font size="5"><b>Sumatra (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/045014.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Fumarole field</td><td width="50%" align="left"><b>Summit Elev:</b> 1040 m<br /><b>Latitude:</b> 5.35&deg;S<br /><b>Longitude:</b> 104.60&deg;E</td></tr><tr><td colspan="2"><p align="justify">Hulubelu is an elliptical, 4-km-long caldera or volcano-tectonic depression in SE Sumatra.  The caldera floor, about 700 m above sea level, is surrounded by steep walls.  Post-caldera volcanism formed central cones and basaltic and andesitic flank volcanoes.  The age of its latest eruptions is not known, although solfataric areas, mud volcanoes, and hot springs occur at several locations.  Thermal areas are aligned NE of and parallel to the Great Sumatran Fault, which runs the entire length of the island of Sumatra.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-28=&amp;volpage=photos&amp;photo=045014">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-28=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-5.3499999999999996,104.59999999999999)
355	Rajabasa	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Rajabasa</b></font><br /><font size="5"><b>Sumatra (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110082.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1281 m<br /><b>Latitude:</b> 5.78&deg;S<br /><b>Longitude:</b> 105.625&deg;E</td></tr><tr><td colspan="2"><p align="justify">Rajabasa is a prominent, isolated volcano along the Sunda Strait at the SE-most tip of Sumatra.  The low, 1281-m-high conical volcano has a well-preserved 500 x 700 m summit crater with a swampy floor.  The age of its most recent eruptions is not known, although fumarolic activity occurs on the foot and flanks of the volcano.  Increased activity was reported in April 1863 and May 1892.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-29=&amp;volpage=photos&amp;photo=110082">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0601-29=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-5.7800000000000002,105.625)
356	Krakatau	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Krakatau</b></font><br /><font size="5"><b>Indonesia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/005068.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> 813 m<br /><b>Latitude:</b> 6.102&deg;S<br /><b>Longitude:</b> 105.423&deg;E</td></tr><tr><td colspan="2"><p align="justify">The renowned volcano Krakatau (frequently misstated as Krakatoa) lies in the Sunda Strait between Java and Sumatra.  Collapse of the ancestral Krakatau edifice, perhaps in 416 AD, formed a 7-km-wide caldera.  Remnants of this ancestral volcano are preserved in Verlaten and Lang Islands; subsequently Rakata, Danan and Perbuwatan volcanoes were formed, coalescing to create the pre-1883 Krakatau Island.  Caldera collapse during the catastrophic 1883 eruption destroyed Danan and Perbuwatan volcanoes, and left only a remnant of Rakata volcano.  This eruption, the 2nd largest in Indonesia during historical time, caused more than 36,000 fatalities, most as a result of devastating tsunamis that swept the adjacent coastlines of Sumatra and Java.  Pyroclastic surges traveled 40 km across the Sunda Strait and reached the Sumatra coast.  After a quiescence of less than a half century, the post-collapse cone of Anak Krakatau (Child of Krakatau) was constructed within the 1883 caldera at a point between the former cones of Danan and Perbuwatan.  Anak Krakatau has been the site of frequent eruptions since 1927.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0602-00=&amp;volpage=photos&amp;photo=005068">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0602-00=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-6.1020000000000003,105.423)
357	Pulosari	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Pulosari</b></font><br /><font size="5"><b>Western Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/114027.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1346 m<br /><b>Latitude:</b> 6.342&deg;S<br /><b>Longitude:</b> 105.975&deg;E</td></tr><tr><td colspan="2"><p align="justify">Pulosari volcano at the western end of Java lies south of the 15-km-wide Pleistocene Danau caldera.  The summit of Pulosari stratovolcano contains a nearly 300-m-deep crater with active solfataras on its wall.  The 1346-m-high basaltic-to-andesitic Pulosari volcano lies across a low saddle from the higher Karang volcano, which was constructed on the SE rim of Danau caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-01=&amp;volpage=photos&amp;photo=114027">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-6.3419999999999996,105.97499999999999)
358	Perbakti-Gagak	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Perbakti-Gagak</b></font><br /><font size="5"><b>Western Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/045016.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1699 m<br /><b>Latitude:</b> 6.75&deg;S<br /><b>Longitude:</b> 106.70&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Perbakti-Gagak volcanic complex, also known as Kiaraberes-Gagak, is a cluster of deeply eroded stratovolcanoes situated immediately SW of Salak volcano.  The 1699-m-high summit ridge of Gunung Perbakti is elongated in a NW-SE direction, and Gunung Endut volcano rises to 1474 m above a saddle SW of Perbakti.  Gunung Gagak lies to the NW; it is capped by pumice and obsidian, and obsidian lava flows extend to the north and NE.  Quaternary rhyolitic lava domes form a NNE-trending chain at the eastern side of the complex.  Two 2-km-wide depressions on the northern and southern sides of Perbakti form the headwaters of the Kaluwung Herang and Pamatutan rivers, respectively.   The volcanic complex is marked by vigorous geothermal activity.  Fumaroles, mud pots and hot springs are located on the south and SE flanks of Perbakti and at the Kiaraberes area, which includes the commercial geothermal field of Awibengkok.  Mild phreatic eruptions took place during the Holocene into historical time from flank fumarolic fields.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-04=&amp;volpage=photos&amp;photo=045016">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-04=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-6.75,106.7)
359	Salak	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Salak</b></font><br /><font size="5"><b>Western Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120031.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2211 m<br /><b>Latitude:</b> 6.72&deg;S<br /><b>Longitude:</b> 106.73&deg;E</td></tr><tr><td colspan="2"><p align="justify">Salak volcano was constructed at the NE end of an eroded volcanic range.  Satellitic cones occur on the SW flank and at the northern foot of the forested volcano.  Two large breached craters truncate the summit of Gunung Salak.  One crater is breached to the NE and the westernmost crater was the source of a debris-avalanche deposit that extends 10 km WNW of the summit.  Historical eruptions from Gunung Salak have been restricted to phreatic explosions from craters in a prominent solfataric area at 1400 m on the western flank.  Salak volcano has been the site of extensive geothermal exploration.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-05=&amp;volpage=photos&amp;photo=120031">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-05=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-6.7199999999999998,106.73)
360	Gede	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Gede</b></font><br /><font size="5"><b>Western Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120032.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 2958 m<br /><b>Latitude:</b> 6.78&deg;S<br /><b>Longitude:</b> 106.98&deg;E</td></tr><tr><td colspan="2"><p align="justify">Gede volcano is one of the most prominent in western Java, forming a twin volcano with Pangrango volcano to the NW.  The major cities of Cianjur, Sukabumi, and Bogor are situated below the volcanic complex to the east, south, and NW, respectively.  Gunung Pangrango, constructed over the NE rim of a 3 x 5 km caldera, forms the 3019 m high point of the complex.  Many lava flows are visible on the flanks of the younger Gunung Gede, including some that may have been erupted in historical time.  The steep-walled summit crater has migrated about 1 km to the NNW over time.  Two large debris-avalanche deposits on its flanks, one of which underlies the city of Cianjur, record previous large-scale collapses of Gede volcano.  Historical activity, recorded since the 16th century, typically consists of small explosive eruptions of short duration.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-06=&amp;volpage=photos&amp;photo=120032">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-06=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-6.7800000000000002,106.98)
361	Patuha	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Patuha</b></font><br /><font size="5"><b>Western Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/063077.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 2434 m<br /><b>Latitude:</b> 7.160&deg;S<br /><b>Longitude:</b> 107.40&deg;E</td></tr><tr><td colspan="2"><p align="justify">The forested twin volcano Gunung Patuha rises SW of the plain of Bandung.  The andesitic volcano contains two summit craters 600 m apart along a NW-SE line.  The NW-most and highest summit crater is dry, but the SE crater, Kawah Putih, contains a shallow greenish-white crater lake.  Kawah Putih is mined for sulfur.  A large debris-avalanche deposit produced by collapse of the volcano extends to the NE.  The volcano was formed during the late Pleistocene, but has a youthful morphology.  No historical eruptions are known from Patuha.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-07=&amp;volpage=photos&amp;photo=063077">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-07=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-7.1600000000000001,107.40000000000001)
362	Wayang-Windu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Wayang-Windu</b></font><br /><font size="5"><b>Western Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/045019.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 2182 m<br /><b>Latitude:</b> 7.208&deg;S<br /><b>Longitude:</b> 107.63&deg;E</td></tr><tr><td colspan="2"><p align="justify">Wayang-Windu, the site of a geothermal prospect, is a twin-peaked lava dome of Quaternary age about 40 km south of Bandung, immediately west of Kamojang volcano.  Gunung Wayang, with a 750-m-wide crescentic crater open to the west, contains four groups of fumaroles.  Gunung Windu, 1.6 to the SW, has a 350-m-wide crater open to the ESE.  The age of the latest eruptive activity from Wayang-Windu is not known.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-08=&amp;volpage=photos&amp;photo=045019">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-08=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-7.2080000000000002,107.63)
363	Tangkubanparahu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tangkubanparahu</b></font><br /><font size="5"><b>Western Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/005099.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 2084 m<br /><b>Latitude:</b> 6.77&deg;S<br /><b>Longitude:</b> 107.60&deg;E</td></tr><tr><td colspan="2"><p align="justify">Tangkubanparahu (also known as Tangkuban Perahu) is a broad shield-like stratovolcano overlooking Indonesia's former capital city of Bandung.  The volcano was constructed within the 6 x 8 km Pleistocene Sunda caldera, which formed about 190,000 years ago.  The volcano's low profile is the subject of legends referring to the mountain of the &quot;upturned boat.&quot;   The rim of Sunda caldera forms a prominent ridge on the western side; elsewhere the caldera rim is largely buried by deposits of Tangkubanparahu volcano.  The dominantly small phreatic historical eruptions recorded since the 19th century have originated from several nested craters within an elliptical 1 x 1.5 km summit depression.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-09=&amp;volpage=photos&amp;photo=005099">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-09=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-6.7699999999999996,107.59999999999999)
364	Papandayan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Papandayan</b></font><br /><font size="5"><b>Western Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/010043.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes</td><td width="50%" align="left"><b>Summit Elev:</b> 2665 m<br /><b>Latitude:</b> 7.32&deg;S<br /><b>Longitude:</b> 107.73&deg;E</td></tr><tr><td colspan="2"><p align="justify">Papandayan is a complex stratovolcano with four large summit craters, the youngest of which was breached to the NE by collapse during a brief eruption in 1772 and contains active fumarole fields.  The broad 1.1-km-wide, flat-floored Alun-Alun crater truncates the summit of Papandayan, and Gunung Puntang to the north gives the volcano a twin-peaked appearance.  Several episodes of collapse have given the volcano an irregular profile and produced debris avalanches that have impacted lowland areas beyond the volcano.  A sulfur-encrusted fumarole field occupies historically active Kawah Mas (&quot;Golden Crater&quot;).  After its first historical eruption in 1772, in which collapse of the NE flank produced a catastrophic debris avalanche that destroyed 40 villages and killed nearly 3000 persons, only small phreatic eruptions had occurred prior to an explosive eruption that began in November 2002.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-10=&amp;volpage=photos&amp;photo=010043">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-10=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-7.3200000000000003,107.73)
365	Kendang	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kendang</b></font><br /><font size="5"><b>Western Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117011.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 2608 m<br /><b>Latitude:</b> 7.23&deg;S<br /><b>Longitude:</b> 107.72&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Quaternary Gunung Kendang volcano (also spelled Kendeng) is located immediately north of Papandayan volcano.  Kendang contains four fumarole fields, the most prominent of which is Kawah Manuk, located in a broad 2.75-km-wide crater-like depression.  Thermal activity consists of fumaroles with sulfur sublimation, mud pots, and hot water pools with occasional mild water ejections.  The Darajat geothermal field is located on the eastern flank of Gunung Kendang.  The geothermal field is located along the Kendang fault, which extends NE to the Kawah Kamojang geothermal field.  The latest eruptions of Kendang volcano produced the very young Kiamis rhyolitic lava dome and obsidian lava flows.  Gunung Kiamis was labeled as Recent on a map of Whittome and Salveson (1990) and is located 2 km NE of the Darajat geothermal field.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-11=&amp;volpage=photos&amp;photo=117011">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-11=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-7.2300000000000004,107.72)
366	Guntur	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Guntur</b></font><br /><font size="5"><b>Western Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/010057.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano<br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 2249 m<br /><b>Latitude:</b> 7.143&deg;S<br /><b>Longitude:</b> 107.840&deg;E</td></tr><tr><td colspan="2"><p align="justify">Guntur is a complex of several overlapping stratovolcanoes about 10 km NW of the city of Garut in western Java.  Young lava flows, the most recent of which was erupted in 1840, are visible on the flanks of the erosionally unmodified Gunung Guntur, which rises about 1550 m above the plain of Garut.  Guntur is one of a group of younger cones constructed to the SW of an older eroded group of volcanoes at the NE end of the complex.  Guntur, whose name means &quot;thunder,&quot; is the only historically active center, with eruptions having been recorded since the late-17th century.  Although Guntur produced frequent explosive eruptions in the 19th century, making it one of the most active volcanoes of western Java, it has not erupted since.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-13=&amp;volpage=photos&amp;photo=010057">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-13=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-7.1429999999999998,107.84)
367	Tampomas	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tampomas</b></font><br /><font size="5"><b>Western Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/045022.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1684 m<br /><b>Latitude:</b> 6.77&deg;S<br /><b>Longitude:</b> 107.95&deg;E</td></tr><tr><td colspan="2"><p align="justify">Gunung Tampomas, the northernmost young volcano in western Java, is a small andesitic stratovolcano overlooking the northern coastal plain about halfway between Tangkubanparahu and Cereme volcanoes.  Youthful-looking lava flows are found on the flanks of Tampomas volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-131&amp;volpage=photos&amp;photo=045022">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-131">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-6.7699999999999996,107.95)
368	Galunggung	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Galunggung</b></font><br /><font size="5"><b>Western Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/010061.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 2168 m<br /><b>Latitude:</b> 7.25&deg;S<br /><b>Longitude:</b> 108.058&deg;E</td></tr><tr><td colspan="2"><p align="justify">The forested slopes of 2168-m-high Galunggung volcano in western Java are cut by a large horseshoe-shaped caldera breached to the SE that has served to channel the products of recent eruptions in that direction.  The &quot;Ten Thousand Hills of Tasikmalaya&quot; dotting the plain below the volcano are debris-avalanche hummocks from the collapse that formed the breached caldera about 4200 years ago.  Although historical eruptions, restricted to the central vent near the caldera headwall, have been infrequent, they have caused much devastation.  The first historical eruption in 1822 produced pyroclastic flows and lahars that killed over 4000 persons.  More recently, a strong explosive eruption during 1982-1983 caused severe economic disruption to populated areas near the volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-14=&amp;volpage=photos&amp;photo=010061">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-14=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-7.25,108.05800000000001)
369	Talagabodas	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Talagabodas</b></font><br /><font size="5"><b>Western Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/100068.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 2201 m<br /><b>Latitude:</b> 7.208&deg;S<br /><b>Longitude:</b> 108.07&deg;E</td></tr><tr><td colspan="2"><p align="justify">Gunung Talagabodas stratovolcano lies immediately north of the more well-known Galunggung volcano.  Talagabodas, also spelled Telagabodas, is one of the older Quaternary volcanoes in an arcuate N-S-trending volcano group east of the city of Garut and is built up of andesitic lavas and pyroclastics.  Younger pyroclastics from Gunung Putri-Eweranda overlap the Talagabodas products in the north.  The crater of Talagabodas has shifted 1.3 km north from the summit crater of Canar and contains a large sulfur-saturated lake.  Fumaroles, mud pots, and a warm spring are found around the lake, which has an elevated temperature.  The age of the most recent eruption from Talagabodas is not known.  Changes in lake color occurred in 1913 and 1921, and expanded solfataric activity was reported in 1927.  Suffocating gases have frequently killed animals that have wandered into the Pajagalan valley on the NE flank and the Kawah Saat geothermal area south of the crater lake.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-15=&amp;volpage=photos&amp;photo=100068">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-15=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-7.2080000000000002,108.06999999999999)
370	Kawah Karaha	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kawah Karaha</b></font><br /><font size="5"><b>Western Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/045025.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Fumarole field</td><td width="50%" align="left"><b>Summit Elev:</b> 1155 m<br /><b>Latitude:</b> 7.12&deg;S<br /><b>Longitude:</b> 108.08&deg;E</td></tr><tr><td colspan="2"><p align="justify">Kawah Karaha is a fumarole field in an area of eroded Quaternary volcanoes at the northern end of a chain of volcanoes extending north from Galunggung.  The Kawah Karaha fumarole field covers an area of 250 x 80 m and contains a sulfur deposit.  The age of the most recent eruption of Kawah Karaha is not known, although the Catalog of Active Volcanoes of the World (Neumann van Padang, 1951) reported an uncertain phreatic eruption in May, 1861.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-16=&amp;volpage=photos&amp;photo=045025">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-16=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-7.1200000000000001,108.08)
371	Cereme	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cereme</b></font><br /><font size="5"><b>Western Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120020.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 3078 m<br /><b>Latitude:</b> 6.892&deg;S<br /><b>Longitude:</b> 108.40&deg;E</td></tr><tr><td colspan="2"><p align="justify">The symmetrical stratovolcano Cereme, also known as Ciremai, is located closer to the northern coast than other central Java volcanoes.  A steep-sided double crater elongated in an E-W direction caps 3078-m-high Gunung Cereme, which was constructed on the northern rim of the 4.5 x 5 km Geger Halang caldera.  A large landslide deposit to the north may be associated with the origin of the caldera, although collapse may rather be due to a voluminous explosive eruption (Newhall and Dzurisin, 1988).  Eruptions, relatively infrequent in historical time, have included explosive activity and lahars, primarily from the summit crater.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-17=&amp;volpage=photos&amp;photo=120020">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-17=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-6.8920000000000003,108.40000000000001)
372	Slamet	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Slamet</b></font><br /><font size="5"><b>Central Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/063023.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3428 m<br /><b>Latitude:</b> 7.242&deg;S<br /><b>Longitude:</b> 109.208&deg;E</td></tr><tr><td colspan="2"><p align="justify">Slamet, Java's second highest volcano at 3428 m and one of its most active, has a cluster of about three dozen cinder cones on its lower SE-NE flanks and a single cinder cone on the western flank.  Slamet is composed of two overlapping edifices, an older basaltic-andesite to andesitic volcano on the west and a younger basaltic to basaltic-andesite one on the east.  Gunung Malang II cinder cone on the upper eastern flank on the younger edifice fed a lava flow that extends 6 km to the east.  Four craters occur at the summit of Gunung Slamet, with activity migrating to the SW over time.  Historical eruptions, recorded since the 18th century, have originated from a 150-m-deep, 450-m-wide, steep-walled crater at the western part of the summit and have consisted of explosive eruptions generally lasting a few days to a few weeks.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-18=&amp;volpage=photos&amp;photo=063023">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-18=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-7.242,109.208)
373	Dieng Volcanic Complex	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Dieng Volcanic Complex</b></font><br /><font size="5"><b>Central Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/010074.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 2565 m<br /><b>Latitude:</b> 7.20&deg;S<br /><b>Longitude:</b> 109.92&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Dieng plateau in the highlands of central Java is renowned both for the variety of its volcanic scenery and as a sacred area housing Java's oldest Hindu temples, dating back to the 9th century AD.  The Dieng volcanic complex consists of two or more stratovolcanoes and more than 20 small craters and cones of Pleistocene-to-Holocene age over a 6 x 14 km area.  Prahu stratovolcano was truncated by a large Pleistocene caldera, which was subsequently filled by a series of dissected to youthful cones, lava domes, and craters, many containing lakes.  Lava flows cover much of the plateau, but have not occurred in historical time, when activity has been restricted to minor phreatic eruptions.  Toxic volcanic gas emission has caused fatalities and is a hazard at several craters.  The abundant thermal features that dot the plateau and high heat flow make Dieng a major geothermal prospect.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-20=&amp;volpage=photos&amp;photo=010074">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-20=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-7.2000000000000002,109.92)
374	Sundoro	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sundoro</b></font><br /><font size="5"><b>Central Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/010077.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 3136 m<br /><b>Latitude:</b> 7.30&deg;S<br /><b>Longitude:</b> 109.992&deg;E</td></tr><tr><td colspan="2"><p align="justify">Gunung Sundoro, one Java's most symmetrical volcanoes, is separated by a 1400-m-high saddle from Sumbing volcano.  Parasitic craters and cones, the largest of which is Kembang, occur on the NW-to-southern flanks, and all fed lava flows.  A small lava dome occupies the summit crater of the 3136-m-high volcano, and numerous phreatic explosion vents were formed along radial fissure that cut the dome and extend across the crater rim.  Lava flows extend in all directions from the summit crater.  Deposits of a large prehistoric debris avalanche are located below the NE flank of Sundoro.  Pyroclastic-flow deposits dated at 1720 years before present extend as far as 13 km from the summit.  Historical eruptions typically have consisted of mild-to-moderate phreatic explosions, mostly from the summit crater.  Flank vents were also active in 1882 and 1903.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-21=&amp;volpage=photos&amp;photo=010077">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-21=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-7.2999999999999998,109.992)
375	Sumbing	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sumbing</b></font><br /><font size="5"><b>Central Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/010082.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3371 m<br /><b>Latitude:</b> 7.384&deg;S<br /><b>Longitude:</b> 110.070&deg;E</td></tr><tr><td colspan="2"><p align="justify">Gunung Sumbing is a prominent 3371-m-high stratovolcano that lies across a 1400-m-high saddle from symmetrical Sundoro volcano in central Java.  Prominent flank cones are located on the north and SE sides of Sumbing, which is somewhat more dissected than Sundoro volcano.  An 800-m-wide horseshoe-shaped summit crater breached to the NE is partially filled by a lava dome that fed a lava flow down to 2400 m altitude.  Emplacement of the dome followed the eruption of extensive pyroclastic flows down the NE flank.  The only report of historical activity at Sumbing volcano, in about 1730 AD, may have produced the small phreatic craters found at the summit.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-22=&amp;volpage=photos&amp;photo=010082">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-22=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-7.3840000000000003,110.06999999999999)
376	Ungaran	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ungaran</b></font><br /><font size="5"><b>Central Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/045028.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 2050 m<br /><b>Latitude:</b> 7.18&deg;S<br /><b>Longitude:</b> 110.33&deg;E</td></tr><tr><td colspan="2"><p align="justify">Gunung Ungaran volcano, south of the northern coastal city of Semarang, lies at the northern end of a transverse chain of Java volcanoes extending NNW from Merapi.  Ungaran was formed in three stages, with growth of the youngest edifice taking place during the late Pleistocene and Holocene.  The youngest Ungaran edifice was constructed south of three large remnant structural blocks of the 2nd Ungaran volcano.  A group of pyroclastic cones was also constructed along the margins of the older volcano.  Ungaran is deeply eroded and no historical eruptions have been reported, but two active fumarole fields are located on the volcano's flanks.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-23=&amp;volpage=photos&amp;photo=045028">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-23=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-7.1799999999999997,110.33)
377	Telomoyo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Telomoyo</b></font><br /><font size="5"><b>Central Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/086086.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> 1894 m<br /><b>Latitude:</b> 7.37&deg;S<br /><b>Longitude:</b> 110.40&deg;E</td></tr><tr><td colspan="2"><p align="justify">Telomoyo volcano, also spelled Telemojo, was constructed over the southern flank of the eroded Pleistocene Soropati volcano and is in part of Holocene age (van Bemmelen 1941).  It lies along a NNW-SSE-trending line of volcanoes extending from Ungaran in the north to Merapi in the south.  The eastern flank of Soropati volcano collapsed during the Pleistocene, leaving a U-shaped depression.  Telomoyo subsequently filled much of the southern side of this depression and grew to a height of 600 m above its rim.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-231&amp;volpage=photos&amp;photo=086086">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-231">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-7.3700000000000001,110.40000000000001)
378	Merbabu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Merbabu</b></font><br /><font size="5"><b>Central Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/011012.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 3145 m<br /><b>Latitude:</b> 7.45&deg;S<br /><b>Longitude:</b> 110.43&deg;E</td></tr><tr><td colspan="2"><p align="justify">Gunung Merbabu is a massive forested volcano that rises to the north above a broad 1500-m-high saddle from the renowned Merapi volcano in central Java.  The volcano is elongated in a NNW-SSE direction, parallel to the trend of the long transverse volcanic chain extending from Merapi to Ungaran volcano.  Three prominent U-shaped radial valleys extend from the 3145-m-high summit of Merbabu toward the NW, NE, and SE, dividing the volcano into three segments.  The most recent magmatic eruptions originated from a NNW-SSE fissure system that cut across the summit and fed the large-volume Kopeng and Kajor lava flows on the northern and southern flanks, respectively.  Moderate explosive eruptions have occurred from the summit crater of Merbabu in historical time.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-24=&amp;volpage=photos&amp;photo=011012">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-24=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-7.4500000000000002,110.43000000000001)
379	Merapi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Merapi</b></font><br /><font size="5"><b>Central Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/017022.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2968 m<br /><b>Latitude:</b> 7.542&deg;S<br /><b>Longitude:</b> 110.442&deg;E</td></tr><tr><td colspan="2"><p align="justify">Merapi, one of Indonesia's most active volcanoes, lies in one of the world's most densely populated areas and dominates the landscape immediately north of the major city of Yogyakarta.  Merapi is the youngest and southernmost of a volcanic chain extending NNW to Ungaran volcano.  Growth of Old Merapi volcano beginning during the Pleistocene ended with major edifice collapse perhaps about 2000 years ago, leaving a large arcuate scarp cutting the eroded older Batulawang volcano.  Subsequently growth of the steep-sided Young Merapi edifice, its upper part unvegetated due to frequent eruptive activity, began SW of the earlier collapse scarp.  Pyroclastic flows and lahars accompanying growth and collapse of the steep-sided active summit lava dome have devastated cultivated lands on the volcano's western-to-southern flanks and caused many fatalities during historical time.  The volcano is the object of extensive monitoring efforts by the Merapi Volcano Observatory.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-25=&amp;volpage=photos&amp;photo=017022">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-25=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-7.5419999999999998,110.44199999999999)
380	Muria	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Muria</b></font><br /><font size="5"><b>Central Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/115010.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1625 m<br /><b>Latitude:</b> 6.62&deg;S<br /><b>Longitude:</b> 110.88&deg;E</td></tr><tr><td colspan="2"><p align="justify">Muria stratovolcano forms the broad Muria Peninsula along the northern coast of central Java and lies well north of the main volcanic chain.  This 1625-m-high volcano occupies much of the peninsula and is flanked by Genuk volcano, an eroded lava-dome complex near the coast at the northern base of Muria.  Muria (also spelled Muriah) is largely Pleistocene in age and displays deeply eroded flanks.  The summit of the high-potassium volcano is cut by several large N-S-trending craters, some containing lava domes.  Numerous flank vents include lava domes, cinder cones, and maars.  The most recent eruptive activity at Muria produced three maars on the SE and NE flanks and a lava flow from a SE-flank vent that entered one of the maars.  Conflicting late-Pleistocene to Holocene age dates for these maars leave uncertainties about their ages, but their youthful morphology in surrounding eroded terrain suggests a probable Holocene age, and they could be as young as several thousand years.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-251&amp;volpage=photos&amp;photo=115010">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-251">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-6.6200000000000001,110.88)
381	Lawu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Lawu</b></font><br /><font size="5"><b>Central Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/011014.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Complex volcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 3265 m<br /><b>Latitude:</b> 7.625&deg;S<br /><b>Longitude:</b> 111.192&deg;E</td></tr><tr><td colspan="2"><p align="justify">The massive compound stratovolcano Lawu contains an older, deeply eroded volcano on the north separated by a crescentic rift valley from the younger Lawu volcano of Holocene age (van Bemmelen, 1949b).  Parasitic crater lakes and pyroclastic cones are found at the eastern side of the rift.  The younger Lawu volcano contains eroded crater rims; its latest activity, including construction of a lava dome, occurred at the south end.  A fumarolic area is located on the south flank at 2550 m.  The only reported historical eruption from Lawu took place in 1885, when rumblings and light ashfall were reported.  A major eruption reported from Lawu in 1752 was from neighboring Kelut volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-26=&amp;volpage=photos&amp;photo=011014">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-26=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-7.625,111.19199999999999)
382	Wilis	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Wilis</b></font><br /><font size="5"><b>Central Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/093056.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 2563 m<br /><b>Latitude:</b> 7.808&deg;S<br /><b>Longitude:</b> 111.758&deg;E</td></tr><tr><td colspan="2"><p align="justify">Gunung Wilis is a solitary volcanic massif surrounded by low-elevation plains on all but its southern side.  It was formed during three episodes dating back to the mid Pleistocene.  Following destruction of the 2nd edifice, the most recent cone grew during the Holocene.  No confirmed historical eruptions are known from Wilis volcano, although there was a report of an eruption in 1641 AD, the same year as a major eruption of nearby Kelut volcano.  Fumaroles and mud pots occur near Lake Ngebel on the lower western flank of Gunung Wilis.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-27=&amp;volpage=photos&amp;photo=093056">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-27=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-7.8079999999999998,111.758)
383	Kelut	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kelut</b></font><br /><font size="5"><b>Eastern Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/017033.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1731 m<br /><b>Latitude:</b> 7.93&deg;S<br /><b>Longitude:</b> 112.308&deg;E</td></tr><tr><td colspan="2"><p align="justify">The relatively inconspicuous, 1731-m-high Kelut stratovolcano contains a summit crater lake that has been the source of some of Indonesia's most deadly eruptions.  A cluster of summit lava domes cut by numerous craters has given the summit a very irregular profile.  Satellitic cones and lava domes are also located low on the eastern, western, and SSW flanks.  Eruptive activity has in general migrated in a clockwise direction around the summit vent complex.  More than 30 eruptions have been recorded from Gunung Kelut since 1000 AD.  The ejection of water from the crater lake during Kelut's typically short, but violent eruptions has created pyroclastic flows and lahars that have caused widespread fatalities and destruction.  After more than 5000 persons were killed during an eruption in 1919, an ambitious engineering project sought to drain the crater lake.  This initial effort lowered the lake by more than 50 m, but the 1951 eruption deepened the crater by 70 m, leaving 50 million cubic meters of water after repair of the damaged drainage tunnels.  After more than 200 deaths in the 1966 eruption, a new deeper tunnel was constructed, and the lake's volume before the 1990 eruption was only about 1 million cubic meters.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-28=&amp;volpage=photos&amp;photo=017033">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-28=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-7.9299999999999997,112.30800000000001)
384	Kawi-Butak	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kawi-Butak</b></font><br /><font size="5"><b>Eastern Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/092065.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes</td><td width="50%" align="left"><b>Summit Elev:</b> 2651 m<br /><b>Latitude:</b> 7.92&deg;S<br /><b>Longitude:</b> 112.45&deg;E</td></tr><tr><td colspan="2"><p align="justify">The broad Kawi-Butak volcanic massif lies immediately east of Kelut volcano and south of Arjuno-Welirang volcano.  The 2551-m-high Gunung Kawi was constructed to the NW of 2868-m-high Gunung Butak.  No historical eruptions are known from either volcano, but both are primarily of Holocene age.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-281&amp;volpage=photos&amp;photo=092065">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-281">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-7.9199999999999999,112.45)
385	Arjuno-Welirang	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Arjuno-Welirang</b></font><br /><font size="5"><b>Eastern Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/045031.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3339 m<br /><b>Latitude:</b> 7.725&deg;S<br /><b>Longitude:</b> 112.58&deg;E</td></tr><tr><td colspan="2"><p align="justify">The twin volcanoes of Arjuno and Welirang anchor the SE and NW ends, respectively, of a 6-km-long line of volcanic cones and craters.  The Arjuno-Welirang complex overlies two older volcanoes, Gunung Ringgit to the east and Gunung Linting to the south.  The summit areas of both Arjuno and Welirang volcanoes are unvegetated.  Additional pyroclastic cones are located on the north flank of Gunung Welirang and along an E-W-trending line cutting across the southern side of Gunung Arjuno that extends to the lower SE flank.  Fumarolic areas with sulfur deposition occur at several locations on Gunung Welirang.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-29=&amp;volpage=photos&amp;photo=045031">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-29=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-7.7249999999999996,112.58)
386	Penanggungan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Penanggungan</b></font><br /><font size="5"><b>Eastern Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/064080.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1653 m<br /><b>Latitude:</b> 7.62&deg;S<br /><b>Longitude:</b> 112.63&deg;E</td></tr><tr><td colspan="2"><p align="justify">Gunung Penanggungan, one of Java's most revered mountains, is a small stratovolcano constructed immediately north of the Arjuno-Welirang massif.  Numerous ruins of sanctuaries, monuments, and sacred bathing places dating from 977-1511 AD are found on the northern and western flanks of the volcano.  Lava flows from flank vents descend all sides of the 1653-m-high volcano and pyroclastic-flow deposits form an apron around it.  Penanggungan volcano was mapped as similar in age to Arjuno-Welirang and Semeru volcanoes by van Bemmelen (1937).  Penanggungan was considered to be extinct for at least 1000 years.  Its last eruption may have occurred about 200 AD.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-291&amp;volpage=photos&amp;photo=064080">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-291">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-7.6200000000000001,112.63)
387	Malang Plain	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Malang Plain</b></font><br /><font size="5"><b>Eastern Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117009.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Maars<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 680 m<br /><b>Latitude:</b> 8.02&deg;S<br /><b>Longitude:</b> 112.68&deg;E</td></tr><tr><td colspan="2"><p align="justify">A group of nine ash cones, maars, and volcanic plugs of subrecent-to-recent (Holocene) age are found on the Malang Plain, SE and NE of the city of Malang (van Bemmelen, 1937).  Some of these may be partly parasitic to Tengger Caldera, although others have no clear connection to any specific eruption center and are situated on a distinct N-S zone of tectonic weakness.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-292&amp;volpage=photos&amp;photo=117009">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-292">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.0199999999999996,112.68000000000001)
388	Semeru	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Semeru</b></font><br /><font size="5"><b>Eastern Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/007036.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 3676 m<br /><b>Latitude:</b> 8.108&deg;S<br /><b>Longitude:</b> 112.92&deg;E</td></tr><tr><td colspan="2"><p align="justify">Semeru, the highest volcano on Java, and one of its most active, lies at the southern end of a volcanic massif extending north to the Tengger caldera.  The steep-sided volcano, also referred to as Mahameru (Great Mountain), rises abruptly to 3676 m above coastal plains to the south.  Gunung Semeru was constructed south of the overlapping Ajek-ajek and Jambangan calderas.  A line of lake-filled maars was constructed along a N-S trend cutting through the summit, and cinder cones and lava domes occupy the eastern and NE flanks.  Summit topography is complicated by the shifting of craters from NW to SE.  Frequent 19th and 20th century eruptions were dominated by small-to-moderate explosions from the summit crater, with occasional lava flows and larger explosive eruptions accompanied by pyroclastic flows that have reached the lower flanks of the volcano.  Semeru has been in almost continuous eruption since 1967.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-30=&amp;volpage=photos&amp;photo=007036">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-30=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.1080000000000005,112.92)
389	Tengger Caldera	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tengger Caldera</b></font><br /><font size="5"><b>Eastern Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/011027.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2329 m<br /><b>Latitude:</b> 7.942&deg;S<br /><b>Longitude:</b> 112.95&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 16-km-wide Tengger caldera is located at the northern end of a volcanic massif extending from Semeru volcano.  The massive Tengger volcanic complex dates back to about 820,000 years ago and consists of five overlapping stratovolcanoes, each truncated by a caldera.  Lava domes, pyroclastic cones, and a maar occupy the flanks of the massif.  The Ngadisari caldera at the NE end of the complex formed about 150,000 years ago and is now drained through the Sapikerep valley.  The most recent of the Tengger calderas is the 9 x 10 km wide Sandsea caldera at the SW end of the complex, which formed incrementally during the late Pleistocene and early Holocene.  An overlapping cluster of post-caldera cones was constructed on the floor of the Sandsea caldera within the past several thousand years.  The youngest of these is Bromo, one of Java's most active and most frequently visited volcanoes.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-31=&amp;volpage=photos&amp;photo=011027">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-31=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-7.9420000000000002,112.95)
390	Lamongan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Lamongan</b></font><br /><font size="5"><b>Eastern Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/007048.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Maars<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1651 m<br /><b>Latitude:</b> 7.979&deg;S<br /><b>Longitude:</b> 113.342&deg;E</td></tr><tr><td colspan="2"><p align="justify">Lamongan, a small 1631-m-high stratovolcano located between the massive Tengger and Iyang-Argapura volcanic complexes, is surrounded by numerous maars and cinder cones.  The currently active cone has been constructed 650 m to the SW of Gunung Tarub, the volcano's high point.  As many as 27 maars with diameters from 150 to 700 m, some containing crater lakes, surround the volcano, along with about 60 cinder cones and spatter cones.  Lake-filled maars, including Ranu Pakis, Ranu Klakah, and Ranu Bedali, are located on the eastern and western flanks; dry maars are predominately located on the northern flanks.  None of the Lamongan maars has erupted during historical time, although several of the youthful maars cut drainage channels from Gunung Tarub.  Lamongan was very active from the time of its first historical eruption in 1799 through the end of the 19th century, producing frequent explosive eruptions and lava flows from vents on the western side of the volcano ranging from the summit to about 450 m elevation.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-32=&amp;volpage=photos&amp;photo=007048">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-32=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-7.9790000000000001,113.342)
391	Iyang-Argapura	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Iyang-Argapura</b></font><br /><font size="5"><b>Eastern Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/011038.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 3088 m<br /><b>Latitude:</b> 7.97&deg;S<br /><b>Longitude:</b> 113.57&deg;E</td></tr><tr><td colspan="2"><p align="justify">The massive Iyang-Argapura volcanic complex dominates the landscape between Raung and Lamongan volcanoes in eastern Java.  Valleys up to 1000 m deep dissect the strongly eroded basal Iyang volcano.  Several Holocene volcanic cones have been constructed at the center of a N-S-trending central rift.  No major eruptions have occurred within at least the last 500 years, although there was an unverified report of an eruption in 1597 AD.  Fumaroles occur in some of the many explosion pits found in the summit crater complex.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-33=&amp;volpage=photos&amp;photo=011038">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-33=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-7.9699999999999998,113.56999999999999)
392	Raung	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Raung</b></font><br /><font size="5"><b>Eastern Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/011043.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> 3332 m<br /><b>Latitude:</b> 8.125&deg;S<br /><b>Longitude:</b> 114.042&deg;E</td></tr><tr><td colspan="2"><p align="justify">Raung, one of Java's most active volcanoes, is a massive stratovolcano in easternmost Java that was constructed SW of the rim of Ijen caldera.  The 3332-m-high, unvegetated summit of Gunung Raung is truncated by a dramatic steep-walled, 2-km-wide caldera that has been the site of frequent historical eruptions.  A prehistoric collapse of Gunung Gadung on the west flank produced a large debris avalanche that traveled 79 km from the volcano, reaching nearly to the Indian Ocean.  Raung contains several centers constructed along a NE-SW line, with Gunung Suket and Gunung Gadung stratovolcanoes being located to the NE and west, respectively.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-34=&amp;volpage=photos&amp;photo=011043">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-34=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.125,114.042)
393	Ijen	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ijen</b></font><br /><font size="5"><b>Eastern Java (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/007081.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2799 m<br /><b>Latitude:</b> 8.058&deg;S<br /><b>Longitude:</b> 114.242&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Ijen volcano complex at the eastern end of Java consists of a group of small stratovolcanoes constructed within the large 20-km-wide Ijen (Kendeng) caldera.  The north caldera wall forms a prominent arcuate ridge, but elsewhere the caldera rim is buried by post-caldera volcanoes, including Gunung Merapi stratovolcano, which forms the 2799 m high point of the Ijen complex.  Immediately west of Gunung Merapi is the renowned historically active Kawah Ijen volcano, which contains a nearly 1-km-wide, turquoise-colored, acid crater lake.  Picturesque Kawah Ijen is the world's largest highly acidic lake and is the site of a labor-intensive sulfur mining operation in which sulfur-laden baskets are hand-carried from the crater floor.  Many other post-caldera cones and craters are located within the caldera or along its rim.  The largest concentration of post-caldera cones forms an E-W-trending zone across the southern side of the caldera.  Coffee plantations cover much of the Ijen caldera floor, and tourists are drawn to its waterfalls, hot springs, and dramatic volcanic scenery.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-35=&amp;volpage=photos&amp;photo=007081">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0603-35=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.0579999999999998,114.242)
394	Bratan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bratan</b></font><br /><font size="5"><b>Bali (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/089093.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Stratovolcanoes</td><td width="50%" align="left"><b>Summit Elev:</b> 2276 m<br /><b>Latitude:</b> 8.28&deg;S<br /><b>Longitude:</b> 115.13&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 11 x 6 km wide Bratan caldera (also known as Catur or Tjatur caldera or the Buyan-Bratan volcanic complex) in north-central Bali contains three caldera lakes.  Several post-caldera stratovolcanoes straddle its southern rim; the largest post-caldera cone, Batukau, is 10 km to the SW.  The cones are well-formed, but covered with thick soils and vegetation; they are thought to have been inactive for hundreds or thousands of years (Wheller, 1986).  Tapak and Lesong cones are not covered by deposits of the youngest dacitic pumice eruptions of nearby Batur volcano, and are thus &lt;23,000 years old.  The Buyan-Bratan geothermal field within the caldera has been developed to produce electrical power, and hot springs are located in more than a dozen locations.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-001&amp;volpage=photos&amp;photo=089093">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-001">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.2799999999999994,115.13)
395	Batur	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Batur</b></font><br /><font size="5"><b>Bali (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/011069.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1717 m<br /><b>Latitude:</b> 8.242&deg;S<br /><b>Longitude:</b> 115.375&deg;E</td></tr><tr><td colspan="2"><p align="justify">The historically active Batur volcano is located at the center of two concentric calderas NW of Agung volcano.  The outer 10 x 13.5 km wide caldera was formed during eruption of the Bali (or Ubud) Ignimbrite about 29,300 years ago and now contains a caldera lake on its SE side, opposite the satellitic cone of 2152-m-high Gunung Abang, the topographic high of the Batur complex.  The inner 6.4 x 9.4 km wide caldera was formed about 20,150 years ago during eruption of the Gunungkawi Ignimbrite.  The SE wall of the inner caldera lies beneath Lake Batur; Batur cone has been constructed within the inner caldera to a height above the outer caldera rim.  The 1717-m-high Batur stratovolcano has produced vents over much of the inner caldera, but a NE-SW fissure system has localized the Batur I, II, and III craters along the summit ridge.  Historical eruptions have been characterized by mild-to-moderate explosive activity sometimes accompanied by lava emission.  Basaltic lava flows from both summit and flank vents have reached the caldera floor and the shores of Lake Batur in historical time.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-01=&amp;volpage=photos&amp;photo=011069">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.2420000000000009,115.375)
396	Agung	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Agung</b></font><br /><font size="5"><b>Bali (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/017038.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava cone</td><td width="50%" align="left"><b>Summit Elev:</b> 3142 m<br /><b>Latitude:</b> 8.342&deg;S<br /><b>Longitude:</b> 115.508&deg;E</td></tr><tr><td colspan="2"><p align="justify">Symmetrical Agung stratovolcano, Bali's highest and most sacred mountain, towers over the eastern end of the island.  The volcano, whose name means &quot;Paramount,&quot; rises above the SE caldera rim of neighboring Batur volcano, and the northern and southern flanks of Agung extend to the coast.  The 3142-m-high summit of Agung contains a steep-walled, 500-m-wide, 200-m-deep crater.  The flank cone Pawon is located low on the SE side of Gunung Agung.  Only a few eruptions dating back to the early 19th century have been recorded from Agung in historical time.  Agung's 1963-64 eruption, one of the world's largest of the 20th century, produced voluminous ashfall and devastating pyroclastic flows and lahars that caused extensive damage and many fatalities.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-02=&amp;volpage=photos&amp;photo=017038">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.3420000000000005,115.508)
397	Rinjani	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Rinjani</b></font><br /><font size="5"><b>Lombok Island (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/121025.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> 3726 m<br /><b>Latitude:</b> 8.42&deg;S<br /><b>Longitude:</b> 116.47&deg;E</td></tr><tr><td colspan="2"><p align="justify">Rinjani volcano on the island of Lombok rises to 3726 m, second in height among Indonesian volcanoes only to Sumatra's Kerinci volcano.  Rinjani has a steep-sided conical profile when viewed from the east, but the west side of  the compound volcano is truncated by the 6 x 8.5  km, oval-shaped Segara Anak caldera.  The western half of the caldera contains a  230-m-deep lake whose crescentic form results from growth of the post-caldera cone Barujari at the east end of the caldera.  Historical eruptions at Rinjani dating back to 1847 have been restricted to Barujari cone and consist of moderate explosive activity and occasional lava flows that have entered Segara Anak lake.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-03=&amp;volpage=photos&amp;photo=121025">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.4199999999999999,116.47)
398	Tambora	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tambora</b></font><br /><font size="5"><b>Sumbawa Island (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/115009.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2850 m<br /><b>Latitude:</b> 8.25&deg;S<br /><b>Longitude:</b> 118.00&deg;E</td></tr><tr><td colspan="2"><p align="justify">The massive Tambora stratovolcano forms the entire 60-km-wide Sanggar Peninsula on northern Sumbawa Island.  The largely  trachybasaltic-to-trachyandesitic volcano grew to about 4000 m elevation before forming a caldera more than 43,000 years ago.  Late-Pleistocene lava flows largely filled the early caldera, after which activity changed to dominantly explosive eruptions during the early Holocene.  Tambora was the source of history's largest explosive eruption, in April 1815.  Pyroclastic flows reached the sea on all sides of the peninsula, and heavy tephra fall devastated croplands, causing an estimated 60,000 fatalities.  The eruption of an estimated more than 150 cu km of tephra formed a 6-km-wide, 1250-m-deep caldera and produced global climatic effects.  Minor lava domes and flows have been extruded on the caldera floor at Tambora during the 19th and 20th centuries.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-04=&amp;volpage=photos&amp;photo=115009">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-04=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.25,118)
399	Sangeang Api	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sangeang Api</b></font><br /><font size="5"><b>Lesser Sunda Islands (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/008003.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano<br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1949 m<br /><b>Latitude:</b> 8.20&deg;S<br /><b>Longitude:</b> 119.07&deg;E</td></tr><tr><td colspan="2"><p align="justify">Sangeang Api volcano, one of the most active in the Lesser Sunda Islands, forms a small 13-km-wide island off the NE coast of Sumbawa Island.  Two large trachybasaltic-to-tranchyandesitic volcanic cones, 1949-m-high Doro Api and 1795-m-high Doro Mantoi, were constructed in the center and on the eastern rim, respectively, of an older, largely obscured caldera.  Flank vents occur on the south side of Doro Mantoi and near the northern coast.  Intermittent historical eruptions have been recorded since 1512, most of them during in the 20th century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-05=&amp;volpage=photos&amp;photo=008003">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-05=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.1999999999999993,119.06999999999999)
400	Wai Sano	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Wai Sano</b></font><br /><font size="5"><b>Flores Island (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/063088.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 903 m<br /><b>Latitude:</b> 8.72&deg;S<br /><b>Longitude:</b> 120.02&deg;E</td></tr><tr><td colspan="2"><p align="justify">Wai Sano is a low, elliptical caldera, 3.5 x 2.5 km wide, at the western end of Flores Island.  Wai Sano contains a large caldera lake whose surface is 260 m below the 903 m high point on the southern caldera rim.  The SE caldera wall truncated the slopes of 1632-m-high Gunung Cerak.  Two solfataras are located at the SE shore of the lake.  No historical eruptions are known from Wai Sano, which was mapped as Holocene in age (Ratman and Yasin, 1978).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-06=&amp;volpage=photos&amp;photo=063088">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-06=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.7200000000000006,120.02)
401	Poco Leok	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Poco Leok</b></font><br /><font size="5"><b>Flores Island (Indonesia)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 1675 m<br /><b>Latitude:</b> 8.68&deg;S<br /><b>Longitude:</b> 120.48&deg;E</td></tr><tr><td colspan="2"><p align="justify">Poco Leok volcano in western Flores Island was constructed with an irregular 7-km-wide caldera of uncertain origin.  No pyroclastic-flow deposits are associated with the &quot;caldera,&quot; which is poorly known geologically (Casadevall, 1989, pers. comm.).  Poco Leok volcano was constructed within the caldera, culminating in the eruption of an andesite lava within the crater area.  Volcanism is of Quaternary age (van Bemmelen, 1949b), and four fumarole fields are located at elevations of 825-1200 m within the depression.  The Ulumbu geothermal field is located on the flank of Poco Leok at 650 m elevation and includes hot springs, fumaroles, mud pots, and steaming ground.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-07=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.6799999999999997,120.48)
402	Ranakah	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ranakah</b></font><br /><font size="5"><b>Flores Island (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/063033.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2350 m<br /><b>Latitude:</b> 8.62&deg;S<br /><b>Longitude:</b> 120.52&deg;E</td></tr><tr><td colspan="2"><p align="justify">A new lava dome, named Anak Ranakah (Child of Ranakah)  was formed in 1987 in an area without previous historical eruptions at the base of the large older lava dome of Gunung Ranakah.  An arcuate group of lava domes extending westward from Gunung Ranakah occurs on the outer flanks of the poorly known Poco Leok caldera on western Flores Island.  Pocok Mandosawa lava dome, at 2350 m the highest point on the island of Flores, lies west of Anak Ranakah.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-071&amp;volpage=photos&amp;photo=063033">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-071">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.6199999999999992,120.52)
403	Inierie	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Inierie</b></font><br /><font size="5"><b>Flores Island (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/100062.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2245 m<br /><b>Latitude:</b> 8.875&deg;S<br /><b>Longitude:</b> 120.95&deg;E</td></tr><tr><td colspan="2"><p align="justify">The symmetrical Gunung Inierie volcano in south-central Flores overlooks the Sawu Sea, and at 2245 m is the highest volcano on the island.  A small steep-walled crater is oriented E-W immediately east of the summit of the conical stratovolcano, whose upper slopes are unvegetated.  A somma wall lies west and NW of Inierie (also known as Rokka Peak).  A NNW-SSE-trending chain of volcanoes extends from across a low saddle to the NE of Inierie, including 1400-m-high Wolo Bobo.  These are part of the Pleistocene Bajawa cinder cone complex, which lies north to east of the volcano.  A column of &quot;smoke&quot; is sometimes visible from the crater of Inierie, as occurred in June 1911.  The age of the latest eruption of Inierie is not known, although the volcano was mapped as Holocene, and an eruption of Wolo Bobo was radiocarbon dated at about 10,000 years ago (Nasution et al., 2000).  Hot springs are located at the northern flank of the volcano, and additional geothermal areas are located to the east and NE.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-08=&amp;volpage=photos&amp;photo=100062">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-08=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.875,120.95)
404	Inielika	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Inielika</b></font><br /><font size="5"><b>Flores Island (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/100063.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1559 m<br /><b>Latitude:</b> 8.73&deg;S<br /><b>Longitude:</b> 120.98&deg;E</td></tr><tr><td colspan="2"><p align="justify">Inielika is a broad, low volcano in central Flores Island that was constructed within the Lobobutu caldera.  The complex summit of the 1559-m-high volcano contains ten craters, some of which are lake filled, in a 5-sq-km area north of the city of Bajawa.  The largest of these, Wolo Runu and Wolo Lega North, are 750 m wide.  The first historical eruption of Inielika, a phreatic explosion that formed a new crater, did not occur until 1905 and was the volcano's only eruption during the 20th century.  Another eruption took place about a century later, in 2001.  A chain of Pleistocene cinder cones, the Bajawa cinder cone complex, extends southward to Ineri.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-09=&amp;volpage=photos&amp;photo=100063">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-09=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.7300000000000004,120.98)
405	Ebulobo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ebulobo</b></font><br /><font size="5"><b>Flores Island (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/012014.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 2124 m<br /><b>Latitude:</b> 8.82&deg;S<br /><b>Longitude:</b> 121.18&deg;E</td></tr><tr><td colspan="2"><p align="justify">Ebulobo, also referred to as Amburombu or Keo Peak, is a symmetrical stratovolcano in central Flores Island.  The summit of 2124-m-high Gunung Ebulobo cosists of a flat-topped lava dome.  The 250-m-wide summit crater of the steep-sided volcano is breached on three sides.  The Watu Keli lava flow traveled from the northern breach to 4 km from the summit in 1830, the first of only four recorded historical eruptions of the volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-10=&amp;volpage=photos&amp;photo=012014">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-10=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.8200000000000003,121.18000000000001)
406	Iya	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Iya</b></font><br /><font size="5"><b>Flores Island (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/012022.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 637 m<br /><b>Latitude:</b> 8.897&deg;S<br /><b>Longitude:</b> 121.645&deg;E</td></tr><tr><td colspan="2"><p align="justify">Gunung Iya is the southernmost of a group of three volcanoes comprising a small peninsula south of the city of Ende on central Flores Island.  The cones to the north, Rooja and Pui, appear to be slightly older than Iya and have not shown historical activity, although Pui has a youthful profile (a reported 1671 eruption of Pui was considered to have originated from Iya volcano).  Iya, whose truncated southern side drops steeply to the sea, has had numerous moderate explosive eruptions during historical time.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-11=&amp;volpage=photos&amp;photo=012022">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-11=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.8970000000000002,121.645)
407	Sukaria Caldera	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sukaria Caldera</b></font><br /><font size="5"><b>Flores Island (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/064002.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 1500 m<br /><b>Latitude:</b> 8.792&deg;S<br /><b>Longitude:</b> 121.77&deg;E</td></tr><tr><td colspan="2"><p align="justify">The poorly known Sukaria caldera in central Flores Island, NE of Iya volcano, is 8 km in diameter.  A 750-m-high northern caldera wall rises above the village of Sukaria in the center of the caldera.  The southern caldera wall is very irregular.  A small fumarolic area on the western flank contains several vents that eject geyser-like water columns with a smell of hydrogen sulfide.  No historical eruptions are known from the caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-12=&amp;volpage=photos&amp;photo=064002">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-12=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.7919999999999998,121.77)
408	Ndete Napu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ndete Napu</b></font><br /><font size="5"><b>Flores Island (Indonesia)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Fumarole field</td><td width="50%" align="left"><b>Summit Elev:</b> 750 m<br /><b>Latitude:</b> 8.72&deg;S<br /><b>Longitude:</b> 121.78&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Ndete Napu fumarole field, located at 750 m elevation along the Lowomelo river valley in central Flores Island, originated during 1927-29.  In 1932 it contained mudpots and high-pressure water fountains.  The age of volcanism in the Ndete Napu area is not known precisely, but it was included in the Catalog of Active Volcanoes of the World (Neumann van Padang, 1951) based on its thermal activity.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-13=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.7200000000000006,121.78)
409	Kelimutu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kelimutu</b></font><br /><font size="5"><b>Flores Island (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/008069.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1639 m<br /><b>Latitude:</b> 8.77&deg;S<br /><b>Longitude:</b> 121.82&deg;E</td></tr><tr><td colspan="2"><p align="justify">Kelimutu is a small, but well-known Indonesian volcano in central Flores Island with three summit crater lakes of varying colors.  The western lake, Tiwi Ata Mbupu (Lake of Old People) is commonly blue.  Tiwu Nua Muri Kooh Tai (Lake of Young Men and Maidens) and Tiwu Ata Polo (Bewitched, or Enchanted Lake), which share a common crater wall, are commonly green- and red-colored, respectively, although lake colors vary periodically.  Active upwelling, probably fed by subaqueous fumaroles, occurs at the two eastern lakes.  The scenic lakes are a popular tourist destination and have been the source of minor phreatic eruptions in historical time.  The summit of the compound 1639-m-high Kelimutu volcano is elongated 2 km in a WNW-ESE direction; the older cones of Kelido and Kelibara are located respectively 3 km to the north and 2 km to the south.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-14=&amp;volpage=photos&amp;photo=008069">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-14=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.7699999999999996,121.81999999999999)
410	Paluweh	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Paluweh</b></font><br /><font size="5"><b>Lesser Sunda Islands (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/100057.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 875 m<br /><b>Latitude:</b> 8.32&deg;S<br /><b>Longitude:</b> 121.708&deg;E</td></tr><tr><td colspan="2"><p align="justify">Paluweh volcano, also known as Rokatenda, forms the 8-km-wide island of Paluweh north of the volcanic arc that cuts across Flores Island.  Although the volcano rises about 3000 m above the sea floor, its summit reaches only 875 m above sea level.  The broad irregular summit region contains overlapping craters up to 900 m wide and several lava domes.  Several flank vents occur along a NW-trending fissure.  The largest historical eruption of Paluweh occurred in 1928, when a strong explosive eruption was accompanied by landslide-induced tsunamis and lava dome emplacement.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-15=&amp;volpage=photos&amp;photo=100057">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-15=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.3200000000000003,121.708)
411	Egon	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Egon</b></font><br /><font size="5"><b>Flores Island (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/100065.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 1703 m<br /><b>Latitude:</b> 8.67&deg;S<br /><b>Longitude:</b> 122.45&deg;E</td></tr><tr><td colspan="2"><p align="justify">Gunung Egon volcano sits astride the narrow waist of eastern Flores Island.  The barren, sparsely vegetated summit region has a 350-m-wide, 200-m-deep crater that sometimes contains a lake.  Other small crater lakes occur on the flanks of the 1703-m-high volcano, which is also known as Namang.  A lava dome forms the southern 1671-m-high summit.  Solfataric activity occurs on the crater wall and rim and on the upper southern flank.   Reports of historical eruptive activity prior to explosive eruptions beginning in 2004 were inconclusive.  A column of &quot;smoke&quot; was often observed above the summit during 1888-1891 and in 1892.  Strong &quot;smoke&quot; emission in 1907 reported by Sapper (1917) was considered by the Catalog of Active Volcanoes of the World (Neumann van Padang, 1951) to be an historical eruption, but Kemmerling (1929) noted that this was likely confused with an eruption on the same date and time from Lewotobi Lakilaki volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-16=&amp;volpage=photos&amp;photo=100065">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-16=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.6699999999999999,122.45)
412	Ilimuda	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ilimuda</b></font><br /><font size="5"><b>Flores Island (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/063041.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 1100 m<br /><b>Latitude:</b> 8.478&deg;S<br /><b>Longitude:</b> 122.671&deg;E</td></tr><tr><td colspan="2"><p align="justify">The broad Ilimuda volcano, located 6.5 km north of Lewotobi Lakilaki volcano opposite Konga bay in eastern Flores Island, contains a 1-km-wide, 450-m-deep crescentic crater open to the SE.  Satellitic cones, including the Ilibotong lava dome, are located on the lower SE and NE flanks.  No historical eruptions are known from Gunung Ilimuda.  A fumarole is located inside the NE crater rim.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-17=&amp;volpage=photos&amp;photo=063041">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-17=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.4779999999999998,122.67100000000001)
413	Lewotobi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Lewotobi</b></font><br /><font size="5"><b>Flores Island (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117059.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Twin volcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1703 m<br /><b>Latitude:</b> 8.542&deg;S<br /><b>Longitude:</b> 122.775&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Lewotobi &quot;husband and wife&quot; twin volcano (also known as Lewetobi) in eastern Flores Island is composed of the Lewotobi Lakilaki and Lewotobi Perempuan stratovolcanoes.  Their summits are less than 2 km apart along a NW-SE line.  The conical 1584-m-high Lewotobi Lakilaki has been frequently active during the 19th and 20th centuries, while the taller and broader 1703-m-high Lewotobi Perempuan has erupted only twice in historical time.  Small lava domes have grown during the 20th century in the crescentic summit craters of both volcanoes, which are open to the north.  A prominent flank cone, Iliwokar, occurs on the east flank of Lewotobi Perampuan.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-18=&amp;volpage=photos&amp;photo=117059">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-18=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.5419999999999998,122.77500000000001)
414	Leroboleng	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Leroboleng</b></font><br /><font size="5"><b>Flores Island (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/100064.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1117 m<br /><b>Latitude:</b> 8.358&deg;S<br /><b>Longitude:</b> 122.842&deg;E</td></tr><tr><td colspan="2"><p align="justify">Leroboleng volcano, also known as Lereboleng or Lewono, lies at the eastern end of a 4.5-km-long, WSW-ESE-trending chain of three volcanoes straddling a narrow peninsula in NE Flores Island.  The summit of Gunung Leroboleng contains 29 small fissure-controlled craters, two containing lakes.  A small lava dome occupies one of the craters.  Most of the craters originated along three N-S-trending fissures immediately east of the summit of the volcano.  The largest crater, 250-m-wide Ili Gelimun, is located SSE of the summit and fed lava flows from a lower south-flank vent.  Explosive eruptions were reported from Burak crater during the 19th century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-20=&amp;volpage=photos&amp;photo=100064">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-20=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.3580000000000005,122.842)
415	Iliboleng	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Iliboleng</b></font><br /><font size="5"><b>Adonara Island (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/012031.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1659 m<br /><b>Latitude:</b> 8.342&deg;S<br /><b>Longitude:</b> 123.258&deg;E</td></tr><tr><td colspan="2"><p align="justify">Iliboleng stratovolcano was constructed at the SE end of Adonara Island across a narrow strait from Lomblen Island.  The volcano is capped by multiple, partially overlapping summit craters.  Lava flows modify its profile, and a cone low on the SE flank, Balile, has also produced lava flows.  Historical eruptions, first recorded in 1885,  have consisted of moderate explosive activity, with lava flows accompanying only the 1888 eruption.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-22=&amp;volpage=photos&amp;photo=012031">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-22=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.3420000000000005,123.258)
416	Lewotolo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Lewotolo</b></font><br /><font size="5"><b>Lomblen Island (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/083023.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1423 m<br /><b>Latitude:</b> 8.272&deg;S<br /><b>Longitude:</b> 123.505&deg;E</td></tr><tr><td colspan="2"><p align="justify">Anchoring the eastern end of an elongated peninsula that is connected to Lembata (formerly Lomblen) Island by a narrow isthmus and extends northward into the Flores Sea, Lewotolo rises to 1423 m.  Lewotolo is a symmetrical stratovolcano as viewed from the north and east.  A small cone with a 130-m-wide crater constructed at the SE side of a larger crater forms the volcano's high point.  Many lava flows have reached the coastline.  Historical eruptions, recorded since 1660, have consisted of explosive activity from the summit crater.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-23=&amp;volpage=photos&amp;photo=083023">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-23=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.2720000000000002,123.505)
417	Ililabalekan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ililabalekan</b></font><br /><font size="5"><b>Lomblen Island (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110078.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1018 m<br /><b>Latitude:</b> 8.55&deg;S<br /><b>Longitude:</b> 123.38&deg;E</td></tr><tr><td colspan="2"><p align="justify">Ililabalekan volcano is situated on a prominent peninsula in SW Lembata (formerly Lomblen) Island.  A satellitic cone was constructed on the SE flank of the steep-sided volcano.  Four craters, one of which contains a lava dome and two small explosion pits, occur at the summit of Mount Labalekan.  No historical eruptions are known from the volcano, although fumaroles are found near its summit.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-24=&amp;volpage=photos&amp;photo=110078">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-24=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.5500000000000007,123.38)
418	Iliwerung	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Iliwerung</b></font><br /><font size="5"><b>Lomblen Island (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/100071.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1018 m<br /><b>Latitude:</b> 8.53&deg;S<br /><b>Longitude:</b> 123.57&deg;E</td></tr><tr><td colspan="2"><p align="justify">Constructed on the southern rim of the Lerek caldera, Iliwerung forms a prominent south-facing peninsula on Lembata (formerly Lomblen) Island.  Craters and lava domes have formed along N-S and NW-SE lines on the complex volcano; during historical time vents from the summit to the submarine SE flank have been active.  The Iliwerung summit lava dome was formed during an eruption in 1870.  In 1948 Iligripe lava dome grew on the eastern flank at 120 m altitude.  Beginning in 1973-74, when three ephemeral islands were formed, submarine eruptions began on the lower SE flank at a vent named Hobal; several other eruptions took place from this vent before the end of the century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-25=&amp;volpage=photos&amp;photo=100071">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-25=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.5299999999999994,123.56999999999999)
419	Batu Tara	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Batu Tara</b></font><br /><font size="5"><b>Komba Island (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/063045.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 748 m<br /><b>Latitude:</b> 7.792&deg;S<br /><b>Longitude:</b> 123.579&deg;E</td></tr><tr><td colspan="2"><p align="justify">The small isolated island of Batu Tara in the Flores Sea about 50 km north of Lembata (fomerly Lomblen) Island contains a scarp on the eastern side similar to the Sciara del Fuoco of Italy's Stromboli volcano.  Vegetation covers the flanks of Batu Tara to within 50 m of the 748-m-high summit.  Batu Tara lies north of the main volcanic arc and is noted for its potassic leucite-bearing basanitic and tephritic rocks.  The first historical eruption from Batu Tara, during 1847-52, produced explosions and a lava flow.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-26=&amp;volpage=photos&amp;photo=063045">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-26=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-7.7919999999999998,123.57899999999999)
420	Sirung	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sirung</b></font><br /><font size="5"><b>Pantar Island (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/012044.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 862 m<br /><b>Latitude:</b> 8.508&deg;S<br /><b>Longitude:</b> 124.13&deg;E</td></tr><tr><td colspan="2"><p align="justify">Sirung volcano is located at the NE end of a 14-km-long line of volcanic centers that form a peninsula at the southern end of Pantar Island.  The low, 862-m-high volcano is truncated by a 2-km-wide caldera whose floor often contains one or more small lakes.  Much of the volcano is constructed of basaltic lava flows, and the Gunung Sirung lava dome forms the high point on the caldera's western rim.  A number of phreatic eruptions have occurred from vents within the caldera during the 20th century.  Forested Gunung Topaki, the 1390-m high point of the volcanic chain, lies at the SW end and contains a symmetrical summit crater.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-27=&amp;volpage=photos&amp;photo=012044">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0604-27=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-8.5079999999999991,124.13)
421	Gunungapi Wetar	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Gunungapi Wetar</b></font><br /><font size="5"><b>Banda Sea (Indonesia)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 282 m<br /><b>Latitude:</b> 6.642&deg;S<br /><b>Longitude:</b> 126.65&deg;E</td></tr><tr><td colspan="2"><p align="justify">Gunungapi Wetar volcano forms an isolated island in the Banda Sea north of Wetar Island.  The small circular island reaches only 282 m above the sea surface but is the summit of a massive stratovolcano that towers 5000 m above the sea floor.  The central crater contains a small cone.  Three large landslide scarps, the largest of which forms a prominent embayment on the NE coast, cut the flanks of the volcano.  The youngest lava flow descended the SW flank to the coast.  Explosive eruptions in 1512 and 1699 mark the only known historical activity of Gunungapi Wetar.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0605-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-6.6420000000000003,126.65000000000001)
422	Wurlali	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Wurlali</b></font><br /><font size="5"><b>Damar Island (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/012047.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 868 m<br /><b>Latitude:</b> 7.125&deg;S<br /><b>Longitude:</b> 128.675&deg;E</td></tr><tr><td colspan="2"><p align="justify">Wurlali volcano, also known as Damar, is the SW-most historically active volcano in the Banda arc.  The 868-m-high andesitic stratovolcano was constructed at the northern end of a 5-km-wide caldera on the eastern side of Damar Island in the Banda Sea.  Fumarolic activity occurs in the twin summit craters and on the SE flanks, producing exploitable sulfur deposits.  An explosive eruption in 1892 is the only known historical activity.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0605-04=&amp;volpage=photos&amp;photo=012047">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0605-04=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-7.125,128.67500000000001)
423	Teon	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Teon</b></font><br /><font size="5"><b>Banda Sea (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/063048.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 655 m<br /><b>Latitude:</b> 6.92&deg;S<br /><b>Longitude:</b> 129.125&deg;E</td></tr><tr><td colspan="2"><p align="justify">Teon, an elongated island in the southwestern Banda arc, is also known as Serawerna, the name of its active crater.  Another smaller crater is located to the NNE of Serawerna.  Explosive eruptions have been recorded from the andesitic Teon volcano since the 17th century.  The largest historical eruption, in 1660, produced pyroclastic flows and surges and caused damage and fatalities.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0605-05=&amp;volpage=photos&amp;photo=063048">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0605-05=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-6.9199999999999999,129.125)
424	Nila	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Nila</b></font><br /><font size="5"><b>Banda Sea (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/064032.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> 781 m<br /><b>Latitude:</b> 6.73&deg;S<br /><b>Longitude:</b> 129.50&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 5 x 6 km Nila Island in the Banda Sea is comprised of a low-rimmed caldera whose rim is breached at sea level on the south and east and contains a 781-m-high youthful forested cone.  Phreatic eruptions from the dominantly andesitic Nila, also known as Laworkawra, have occurred from summit vents and flank fissures in historical time.  A 1932 eruption from a fissure that extended from the summit to the SE coast produced heavy ashfall that forced abandonment of Rumadai village.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0605-06=&amp;volpage=photos&amp;photo=064032">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0605-06=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-6.7300000000000004,129.5)
425	Serua	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Serua</b></font><br /><font size="5"><b>Banda Sea (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119079.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 641 m<br /><b>Latitude:</b> 6.30&deg;S<br /><b>Longitude:</b> 130.00&deg;E</td></tr><tr><td colspan="2"><p align="justify">The small 2 x 4 km island of Serua is the emergent summit of a volcano rising 3600 m above the Banda Sea floor.  A truncated central cone surrounded by an old somma wall is capped by 641-m-high Gunung Wuarlapna lava dome.  The andesitic Serua volcano, also known as Legatala, lies near the center of the Banda arc and is one of the most active of the Banda Sea volcanoes, with many eruptions recorded since the 17th century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0605-07=&amp;volpage=photos&amp;photo=119079">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0605-07=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-6.2999999999999998,130)
426	Manuk	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Manuk</b></font><br /><font size="5"><b>Banda Sea (Indonesia)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 282 m<br /><b>Latitude:</b> 5.53&deg;S<br /><b>Longitude:</b> 130.292&deg;E</td></tr><tr><td colspan="2"><p align="justify">The small steep-sided island of Manuk is the easternmost volcano in the arcuate Banda volcanic arc.  The 282-m-high truncated andesitic cone rises 3000 m from the sea floor.  No confirmed historical eruptions are known from this uninhabited island, although there was an uncertain report that a member of the 1874 Challenger Expedition saw smoke rising from the crater of Manuk.  Highly altered fumarolic areas are located within the crater and on its western rim and were once the source of sulfur extraction by Chinese traders.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0605-08=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-5.5300000000000002,130.292)
427	Banda Api	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Banda Api</b></font><br /><font size="5"><b>Banda Sea (Indonesia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/008031.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Tuff cone</td><td width="50%" align="left"><b>Summit Elev:</b> 640 m<br /><b>Latitude:</b> 4.525&deg;S<br /><b>Longitude:</b> 129.871&deg;E</td></tr><tr><td colspan="2"><p align="justify">The small island volcano of Banda Api is the NE-most volcano in the Sunda-Banda arc and has a long period of historical observation because of its key location in the thriving Portuguese and Dutch spice trade.  The basaltic-to-rhyodacitic Banda Api is located in the SW corner of a 7-km-wide mostly submerged caldera that comprises the northernmost of a chain of volcanic islands in the Banda Sea. At least two episodes of caldera formation are thought to have occurred, with the arcuate islands of Lonthor and Neira considered to be remnants of the pre-caldera volcanoes.  Gunung Api forms a conical peak rising to 640 m at the center of the 3-km-wide Banda Api island.  Historical eruptions have been recorded since 1586, mostly consisting of strombolian eruptions from the summit crater, but larger explosive eruptions have occurred and occasional lava flows have reached the coast.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0605-09=&amp;volpage=photos&amp;photo=008031">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0605-09=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-4.5250000000000004,129.87100000000001)
428	Colo [Una Una]	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Colo [Una Una]</b></font><br /><font size="5"><b>Sulawesi</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/064098.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 507 m<br /><b>Latitude:</b> 0.17&deg;S<br /><b>Longitude:</b> 121.608&deg;E</td></tr><tr><td colspan="2"><p align="justify">Colo volcano forms the isolated small island of Una-Una in the middle of the Gulf of Tomini in northern Sulawesi.  The broad, low volcano, whose summit is only 507 m above sea level, contains a 2-km-wide caldera with a small central cone.  Only three eruptions have been recorded in historical time, but two of those caused widespread damage over much of the island.  The last eruption, in 1983, produced pyroclastic flows that swept over most of the island shortly after all residents had been evacuated.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0606-01=&amp;volpage=photos&amp;photo=064098">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0606-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-0.17000000000000001,121.608)
429	Ambang	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ambang</b></font><br /><font size="5"><b>Sulawesi</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/045034.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1795 m<br /><b>Latitude:</b> 0.75&deg;N<br /><b>Longitude:</b> 124.42&deg;E</td></tr><tr><td colspan="2"><p align="justify">The compound Ambang volcano is the westernmost of the active volcanoes on the northern arm of Sulawesi.  The 1795-m-high stratovolcano rises 750 m above lake Danau.  Several craters up to 400 m in diameter and five solfatara fields are located at the summit.  Ambang's only known historical eruption, of unspecified character, took place in the 1840s.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0606-02=&amp;volpage=photos&amp;photo=045034">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0606-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(0.75,124.42)
430	Soputan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Soputan</b></font><br /><font size="5"><b>Sulawesi</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/100069.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 1784 m<br /><b>Latitude:</b> 1.108&deg;N<br /><b>Longitude:</b> 124.73&deg;E</td></tr><tr><td colspan="2"><p align="justify">The small Soputan stratovolcano on the southern rim of the Quaternary Tondano caldera on the northern arm of Sulawesi Island is one of Sulawesi's most active volcanoes.  The youthful, largely unvegetated volcano rises to 1784 m and is located SW of Sempu volcano.  It was constructed at the southern end of a SSW-NNE trending line of vents.  During historical time the locus of eruptions has included both the summit crater and Aeseput, a prominent NE-flank vent that formed in 1906 and was the source of intermittent major lava flows until 1924.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0606-03=&amp;volpage=photos&amp;photo=100069">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0606-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(1.1080000000000001,124.73)
431	Sempu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sempu</b></font><br /><font size="5"><b>Sulawesi</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/012058.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Maar</td><td width="50%" align="left"><b>Summit Elev:</b> 1549 m<br /><b>Latitude:</b> 1.13&deg;N<br /><b>Longitude:</b> 124.758&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 1549-m-high Sempu stratovolcano was constructed within the 3-km-wide Sempu caldera.  Kawah Masem maar was formed in the SW part of the caldera and contains a crater lake.  No historical eruptions are known from Sempu.  Sulfur has been extracted from fumarolic areas in the maar since 1938.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0606-04=&amp;volpage=photos&amp;photo=012058">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0606-04=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(1.1299999999999999,124.758)
432	Tondano Caldera	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tondano Caldera</b></font><br /><font size="5"><b>Sulawesi</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/063052.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1202 m<br /><b>Latitude:</b> 1.23&deg;N<br /><b>Longitude:</b> 124.83&deg;E</td></tr><tr><td colspan="2"><p align="justify">Tondano is an approximately 20 x 30 km Quaternary caldera in north Sulawesi containing post-caldera pyroclastic cones, obsidian flows, and thermal areas.  Lake Tondano lies against the well-defined eastern caldera rim.  The historically active andesitic-to-basaltic stratovolcanoes Soputan, Sempu, Lokon-Empung and Mahawu (described elsewhere in this compilation) lie astride the poorly defined southern and northern rims of the caldera.  The age of the latest eruptions within the caldera is not known, although thermal areas occur at Batu Kolok and Sarangson, and at the Tampusu cinder cone and Lahendong maar.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0606-07-&amp;volpage=photos&amp;photo=063052">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0606-07-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(1.23,124.83)
433	Lokon-Empung	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Lokon-Empung</b></font><br /><font size="5"><b>Sulawesi</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/100070.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Twin volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1580 m<br /><b>Latitude:</b> 1.358&deg;N<br /><b>Longitude:</b> 124.792&deg;E</td></tr><tr><td colspan="2"><p align="justify">The twin volcanoes Lokon and Empung, rising about 800 m above the plain of Tondano, are among the most active volcanoes of Sulawesi.  Lokon, the higher of the two peaks ( whose summits are only 2.2 km apart), has a flat, craterless top.  The morphologically younger Empung volcano has a 400-m-wide, 150-m-deep crater that erupted last in the 18th century, but all subsequent eruptions have originated from Tompaluan, a 150 x 250 m wide double crater situated in the saddle between the two peaks.  Historical eruptions have primarily produced small-to-moderate ash plumes that have occasionally damaged croplands and houses, but lava-dome growth and pyroclastic flows have also occurred.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0606-10=&amp;volpage=photos&amp;photo=100070">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0606-10=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(1.3580000000000001,124.792)
434	Mahawu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mahawu</b></font><br /><font size="5"><b>Sulawesi</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/012070.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1324 m<br /><b>Latitude:</b> 1.358&deg;N<br /><b>Longitude:</b> 124.858&deg;E</td></tr><tr><td colspan="2"><p align="justify">The elongated Mahawu volcano immediately east of Lokon-Empung volcano is the northernmost of a series of young volcanoes along a SSW-NNE line near the margin of the Quaternary Tondano caldera.  Mahawu is capped by a 180-m-wide, 140-m-deep crater that sometimes contains a small crater lake, and has two pyroclastic cones on its northern flank.  Less active than its neighbor, Lokon-Empung, Mahawu's historical activity has been restricted to occasional small explosive eruptions recorded since 1789.  In 1994 fumaroles, mudpots, and small geysers were observed along the shores of a greenish-colored crater lake.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0606-11=&amp;volpage=photos&amp;photo=012070">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0606-11=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(1.3580000000000001,124.858)
435	Klabat	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Klabat</b></font><br /><font size="5"><b>Sulawesi</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111100.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1995 m<br /><b>Latitude:</b> 1.47&deg;N<br /><b>Longitude:</b> 125.03&deg;E</td></tr><tr><td colspan="2"><p align="justify">Klabat is an isolated symmetrical stratovolcano that rises to 1995 m near the eastern tip of the elongated northern arm of Sulawesi Island.  The volcano lies east of the city of Manado (also spelled Menado) and is the highest in Sulawesi.  Klabat has a shallow lake in its 170 x 250 m summit crater.  No verified historical eruptions have occurred from this volcano, but fumarolic activity has occurred within historical time.  A report of an eruption in 1683 probably was from nearby Tongkoko volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0606-12=&amp;volpage=photos&amp;photo=111100">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0606-12=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(1.47,125.03)
436	Tongkoko	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tongkoko</b></font><br /><font size="5"><b>Sulawesi</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/012071.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 1149 m<br /><b>Latitude:</b> 1.52&deg;N<br /><b>Longitude:</b> 125.20&deg;E</td></tr><tr><td colspan="2"><p align="justify">The NE-most volcano on the island of Sulawesi, Tongkoko (also known as Tangkoko) has a summit that is elongated in a NW-SE direction with a large deep crater that in 1801 contained a cone surrounded by lake water.  The slightly higher Dua Saudara stratovolcano is located only 3 km to the SW of Tongkoko, and along with Tongkoko, forms the most prominent features of Gunung Dua Saudara National Park, a noted wildlife preserve.  Eruptions occurred from the summit crater of Tongkoko in the 17th century and in 1801.  The prominent, flat-topped lava dome Batu Angus formed on the east flank of Tongkoko in 1801, and, along with an adjacent east flank vent, has been the source of all subsequent eruptions.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0606-13=&amp;volpage=photos&amp;photo=012071">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0606-13=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(1.52,125.2)
437	Ruang	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ruang</b></font><br /><font size="5"><b>Sangihe Is</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/012075.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 725 m<br /><b>Latitude:</b> 2.30&deg;N<br /><b>Longitude:</b> 125.37&deg;E</td></tr><tr><td colspan="2"><p align="justify">Ruang volcano, not to be confused with the better known Raung volcano on Java, is the southernmost volcano in the Sangihe Island arc, north of Sulawesi Island.  The 4 x 5 km island volcano rises to 725 m across a narrow strait SW of the larger Tagulandang Island.  The summit of Ruang volcano contains a crater partially filled by a lava dome initially emplaced in 1904.  Explosive eruptions recorded since 1808 have often been accompanied by lava dome formation and pyroclastic flows that have damaged inhabited areas.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0607-01=&amp;volpage=photos&amp;photo=012075">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0607-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(2.2999999999999998,125.37)
438	Karangetang [Api Siau]	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Karangetang [Api Siau]</b></font><br /><font size="5"><b>Siau I</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/101037.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1784 m<br /><b>Latitude:</b> 2.78&deg;N<br /><b>Longitude:</b> 125.40&deg;E</td></tr><tr><td colspan="2"><p align="justify">Karangetang (Api Siau) volcano lies at the northern end of the island of Siau, north of Sulawesi.  The 1784-m-high stratovolcano contains five summit craters along a N-S line.  Karangetang is one of Indonesia's most active volcanoes, with more than 40 eruptions recorded since 1675 and many additional small eruptions that were not documented in the historical record (Catalog of Active Volcanoes of the World: Neumann van Padang, 1951).  Twentieth-century eruptions have included frequent explosive activity sometimes accompanied by pyroclastic flows and lahars.  Lava dome growth has occurred in the summit craters; collapse of lava flow fronts has also produced pyroclastic flows.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0607-02=&amp;volpage=photos&amp;photo=101037">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0607-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(2.7799999999999998,125.40000000000001)
439	Banua Wuhu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Banua Wuhu</b></font><br /><font size="5"><b>Sangihe Is</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> -5 m<br /><b>Latitude:</b> 3.138&deg;N<br /><b>Longitude:</b> 125.491&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Banua Wuhu submarine volcano in the Sangihe Islands rises more than 400 m from the sea floor to form a shoal less than 5 m below sea level.  Several ephemeral islands were constructed during the 19th and 20th centuries.   An island 90 m high was formed in 1835, but dwindled to only a few rocks by 1848.  A new island formed in 1889 was 50 m high in 1894.  Five new craters were formed during an eruption that built a new island in 1904.  Another new island that formed in 1919 had disappeared by 1935.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0607-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(3.1379999999999999,125.491)
440	Awu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Awu</b></font><br /><font size="5"><b>Sangihe Is</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120023.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 1320 m<br /><b>Latitude:</b> 3.67&deg;N<br /><b>Longitude:</b> 125.50&deg;E</td></tr><tr><td colspan="2"><p align="justify">The massive Gunung Awu stratovolcano occupies the northern end of Great Sangihe Island, the largest of the Sangihe arc.  Deep valleys that form passageways for lahars dissect the flanks of the 1320-m-high volcano, which was constructed within a 4.5-km-wide caldera.  Awu is one of Indonesia's deadliest volcanoes; powerful explosive eruptions in 1711, 1812, 1856, 1892, and 1966 produced devastating pyroclastic flows and lahars that caused more than 8000 cumulative fatalities.  Awu contained a summit crater lake that was 1 km wide and 172 m deep in 1922, but was largely ejected during the 1966 eruption.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0607-04=&amp;volpage=photos&amp;photo=120023">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0607-04=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(3.6699999999999999,125.5)
441	Tarakan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tarakan</b></font><br /><font size="5"><b>Halmahera</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117047.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 318 m<br /><b>Latitude:</b> 1.83&deg;N<br /><b>Longitude:</b> 127.83&deg;E</td></tr><tr><td colspan="2"><p align="justify">Two large cinder cones are located near the shore of Galela Bay NE of Dukono volcano.  Tarakan Lamo and Tarakan Itji (large and small Tarakan) have well-formed summit craters 800 and 500 m in diameter and 160 and 125 m deep, respectively.  The cinder cones lie between Galela Bay and Lake Galela, whose bottom lies below sea level.  Supriatna (1980) mapped Tarakan as a basaltic volcano of Holocene age.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-001&amp;volpage=photos&amp;photo=117047">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-001">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(1.8300000000000001,127.83)
442	Dukono	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Dukono</b></font><br /><font size="5"><b>Halmahera</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/017041.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1335 m<br /><b>Latitude:</b> 1.68&deg;N<br /><b>Longitude:</b> 127.88&deg;E</td></tr><tr><td colspan="2"><p align="justify">Reports from this remote volcano in northernmost Halmahera are rare, but Dukono has been one of Indonesia's most active volcanoes.  More-or-less continuous explosive eruptions, sometimes accompanied by lava flows, occurred from 1933 until at least the mid-1990s, when routine observations were curtailed.  During a major eruption in 1550, a lava flow filled in the strait between Halmahera and the north-flank cone of Gunung Mamuya.  Dukono is a complex volcano presenting a broad, low profile with multiple summit peaks and overlapping craters.  Malupang Wariang, 1 km SW of Dukono's summit crater complex, contains a 700 x 570 m crater that has also been active during historical time.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-01=&amp;volpage=photos&amp;photo=017041">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(1.6799999999999999,127.88)
443	Tobaru	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tobaru</b></font><br /><font size="5"><b>Halmahera</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Unknown</td><td width="50%" align="left"><b>Summit Elev:</b> 1035 m<br /><b>Latitude:</b> 1.63&deg;N<br /><b>Longitude:</b> 127.67&deg;E</td></tr><tr><td colspan="2"><p align="justify">Gunung Tobaru, also known as Gunung Lolodai, is located in northern Halmahera WSW of Dukono volcano and NNE of Ibu volcano.  Supriatna (1980) mapped the little known 1035-m-high andesitic volcano as Holocene in age.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-02-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(1.6299999999999999,127.67)
444	Ibu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ibu</b></font><br /><font size="5"><b>Halmahera</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/100060.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 1325 m<br /><b>Latitude:</b> 1.488&deg;N<br /><b>Longitude:</b> 127.63&deg;E</td></tr><tr><td colspan="2"><p align="justify">The truncated summit of Gunung Ibu stratovolcano along the NW coast of Halmahera Island has large nested summit craters.  The inner crater, 1 km wide and 400 m deep, contained several small crater lakes through much of historical time.  The outer crater, 1.2 km wide, is breached on the north side, creating a steep-walled valley.  A large parasitic cone is located ENE of the summit.  A smaller one to the WSW has fed a lava flow down the western flank.  A group of maars is located below the northern and western flanks of the volcano.  Only a few eruptions have been recorded from Ibu in historical time, the first a small explosive eruption from the summit crater in 1911.  An eruption producing a lava dome that eventually covered much of the floor of the inner summit crater began in December 1998.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-03=&amp;volpage=photos&amp;photo=100060">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(1.488,127.63)
445	Gamkonora	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Gamkonora</b></font><br /><font size="5"><b>Halmahera</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/012087.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1635 m<br /><b>Latitude:</b> 1.38&deg;N<br /><b>Longitude:</b> 127.53&deg;E</td></tr><tr><td colspan="2"><p align="justify">The shifting of eruption centers on Gamkonora, at 1635 m the highest peak of Halmahera, has produced an elongated series of summit craters along a N-S trending rift.  Youthful-looking lava flows originate near the cones of Gunung Alon and Popolojo, south of Gamkonora.  Since its first recorded eruption in the 16th century, Gamkonora has typically produced small-to-moderate explosive eruptions.  Its largest historical eruption, in 1673, was accompanied by tsunamis that inundated villages.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-04=&amp;volpage=photos&amp;photo=012087">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-04=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(1.3799999999999999,127.53)
446	Todoko-Ranu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Todoko-Ranu</b></font><br /><font size="5"><b>Halmahera</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117046.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Stratovolcanoes</td><td width="50%" align="left"><b>Summit Elev:</b> 979 m<br /><b>Latitude:</b> 1.25&deg;N<br /><b>Longitude:</b> 127.47&deg;E</td></tr><tr><td colspan="2"><p align="justify">The twin caldera complex of Todoko-Ranu is part of a large volcanic complex south of Gamkonora.  The 2-km-wide, lava-filled Todoko caldera is south of the 2 x 2.8 km wide nested Ranu calderas and contains a young post-caldera cone, Sahu, on its south flank.  The northern Ranu caldera contains a caldera lake.  Gunung Onu, NW of Ranu caldera, lies at the northern end of the Todoko-Ranu complex.  No historical eruptions have been reported from the complex, mapped as Holocene by Supriatna (1980), but fumaroles are present at Ranu caldera and hot springs on Mt. Sahu.  Youthful-looking lava flows reach the sea from several locations within the complex.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-05=&amp;volpage=photos&amp;photo=117046">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-05=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(1.25,127.47)
447	Jailolo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Jailolo</b></font><br /><font size="5"><b>Halmahera</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117045.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas</td><td width="50%" align="left"><b>Summit Elev:</b> 1130 m<br /><b>Latitude:</b> 1.08&deg;N<br /><b>Longitude:</b> 127.42&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Jailolo volcanic complex forms a peninsula west of Jailolo Bay on the western coast of Halmahera Island.  Jailolo stratovolcano at the center of the complex has youthful lava flows on its eastern flank.  Small calderas are located west and SW of Jailolo.  The westernmost caldera, Idamdehe, truncates an older twin volcano of Jailolo.  Hot springs occur along the NW coast of the caldera.  Kailupa cone forms a small volcanic island off the southern coast of the peninsula.  Hot mudflows were reported from Jailolo volcano shortly prior to 1883, but no eruptions are known during historical time.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-051&amp;volpage=photos&amp;photo=117045">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-051">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(1.0800000000000001,127.42)
448	Hiri	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hiri</b></font><br /><font size="5"><b>Halmahera</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104080.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 630 m<br /><b>Latitude:</b> 0.90&deg;N<br /><b>Longitude:</b> 127.32&deg;E</td></tr><tr><td colspan="2"><p align="justify">Hiri, a small 3-km-wide forested island immediately north of Ternate Island, is the northernmost of a chain of volcanic islands off the western coast of Halmahera.  The conical volcano rises to 630 m, but is dominated by its larger and higher neighbor to the south, historically active 1716-m-high Ternate volcano.  Hiri has received less attention than Ternate, but Apandi and Sudana (1980) mapped Hiri as Holocene in age.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-052&amp;volpage=photos&amp;photo=104080">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-052">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(0.90000000000000002,127.31999999999999)
449	Gamalama	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Gamalama</b></font><br /><font size="5"><b>Halmahera</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/058021.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 1715 m<br /><b>Latitude:</b> 0.80&deg;N<br /><b>Longitude:</b> 127.33&deg;E</td></tr><tr><td colspan="2"><p align="justify">Gamalama (Peak of Ternate) is a near-conical stratovolcano that comprises the entire island of Ternate off the western coast of Halmahera and is one of Indonesia's most active volcanoes.  The island of Ternate was a major regional center in the Portuguese and Dutch spice trade for several centuries, which contributed to the thorough documentation of Gamalama's historical activity.  Three cones, progressively younger to the north, form the summit of Gamalama, which reaches 1715 m.  Several maars and vents define a rift zone, parallel to the Halmahera island arc, that cuts the volcano.  Eruptions, recorded frequently since the 16th century, typically originated from the summit craters, although flank eruptions have occurred in 1763, 1770, 1775, and 1962-63.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-06=&amp;volpage=photos&amp;photo=058021">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-06=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(0.80000000000000004,127.33)
450	Tidore	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tidore</b></font><br /><font size="5"><b>Halmahera</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/058032.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 1730 m<br /><b>Latitude:</b> 0.658&deg;N<br /><b>Longitude:</b> 127.40&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Tidore volcanic complex consists of two dramatically different volcanic structures.  The beautifully conical 1730-m-high Kiematabu peak on the south end of Tidore Island is the highest volcano of the North Maluku island chain west of Halmahera.  The broad, lower Sabale volcano on the north side of the island is a caldera containing two cones.  Maitara Island, 1 km off the NW coast, forms another volcanic construct.  Tidore was mapped as Holocene by Apandi and Sudana (1980).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-061&amp;volpage=photos&amp;photo=058032">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-061">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(0.65800000000000003,127.40000000000001)
451	Mare	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mare</b></font><br /><font size="5"><b>Halmahera</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117043.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 308 m<br /><b>Latitude:</b> 0.57&deg;N<br /><b>Longitude:</b> 127.40&deg;E</td></tr><tr><td colspan="2"><p align="justify">The small volcanic island of Mare, immediately south of Tidore, was mapped as Holocene in age by Apandi and Sudana (1980).  The 2 x 3 km island, part of a chain of volcanic islands off the western coast of Halmahera Island, is elongated in a NE-SW direction.  A large breached crater at the andesitic Mare volcano is located off the SW tip of the 308-m-high island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-062&amp;volpage=photos&amp;photo=117043">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-062">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(0.56999999999999995,127.40000000000001)
452	Moti	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Moti</b></font><br /><font size="5"><b>Halmahera</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117044.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 950 m<br /><b>Latitude:</b> 0.45&deg;N<br /><b>Longitude:</b> 127.40&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 5-km-wide island of Moti, also known as Motir, is part of a roughly N-S-trending chain of islands off the western coast of Halmahera Island.  Moti is located north of Makian volcano and south of Mare and Tidore islands and is surrounded by coral reefs.  The truncated, conical island rises to 950 m and contains a crater on its SSW side.  Moti was mapped as Holocene in age by Apandi and Sudana (1980).  An insignificant eruption was reported in 1774 or shorter before, but Gogarten (1918) indicated that this event was confused with the October 1773 eruption of nearby Gamalama volcano, which could have dropped ash on Moti.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-063&amp;volpage=photos&amp;photo=117044">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-063">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(0.45000000000000001,127.40000000000001)
453	Makian	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Makian</b></font><br /><font size="5"><b>Halmahera</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/063060.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1357 m<br /><b>Latitude:</b> 0.32&deg;N<br /><b>Longitude:</b> 127.40&deg;E</td></tr><tr><td colspan="2"><p align="justify">Makian volcano forms a 10-km-wide island near the southern end of a chain of volcanic islands off the west coast of Halmahera and has been the source of infrequent, but violent eruptions that have devastated villages on the island.  The large 1.5-km-wide summit crater, containing a small lake on the NE side, gives the 1357-m-high peak a flat-topped profile.   Two prominent valleys extend to the coast from the summit crater on the north and east sides.  Four parasitic cones are found on the western flanks.  Eruption have been recorded since about 1550; major eruptions in 1646, 1760-61, 1861-62, 1890, and 1988 caused extensive damage and many fatalities.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-07=&amp;volpage=photos&amp;photo=063060">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-07=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(0.32000000000000001,127.40000000000001)
454	Tigalalu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tigalalu</b></font><br /><font size="5"><b>Kayoa I</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117007.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 422 m<br /><b>Latitude:</b> 0.07&deg;N<br /><b>Longitude:</b> 127.42&deg;E</td></tr><tr><td colspan="2"><p align="justify">Gunung Tigalalu (Mount Tigalalu) is located at the northern end of Kayoa Island, which straddles the equator and is the southernmost of a chain of small volcanic islands off the western coast of Halmahera Island.  Tigalalu forms a 422-m-high N-S-trending volcanic ridge at the north end of the island, part of which is flanked by coral limestones.  Although much less known than its historically active neighbor to the north, Makian volcano, Tigalalu was mapped as Holocene in age by Apandi and Sudana (1980).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-071&amp;volpage=photos&amp;photo=117007">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-071">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(0.070000000000000007,127.42)
455	Amasing	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Amasing</b></font><br /><font size="5"><b>Bacan I</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117008.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes</td><td width="50%" align="left"><b>Summit Elev:</b> 1030 m<br /><b>Latitude:</b> 0.53&deg;S<br /><b>Longitude:</b> 127.48&deg;E</td></tr><tr><td colspan="2"><p align="justify">Bukit Amasing (Amasing Hill) is the largest and NW-most of a group of three small andesitic volcanoes of Holocene age (Yasin, 1980).  They are located along a NW-SE line on central Bacan Island, west of the southern tip of Halmahera.  Two smaller volcanoes, Cakasuanggi and Dua Saudara, were constructed to the SE, north of the metamorphic complex of the Sibela Mountains.  These mountains separate the Amasing volcano group from another group of three andesitic Holocene volcanoes in SE-most Bacan Island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-072&amp;volpage=photos&amp;photo=117008">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-072">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-0.53000000000000003,127.48)
456	Bibinoi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bibinoi</b></font><br /><font size="5"><b>Bacan I</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117001.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes</td><td width="50%" align="left"><b>Summit Elev:</b> 900 m<br /><b>Latitude:</b> 0.77&deg;S<br /><b>Longitude:</b> 127.72&deg;E</td></tr><tr><td colspan="2"><p align="justify">Bukit Bibinoi (Bibinoi Hill) is the largest and SE-most of a group of three andesitic Holocene stratovolcanoes located along a NW-SE line near the SE tip of Bacan Island, west of the southern tip of Halmahera (Yasin, 1980).  The smaller Songsu and Lansa volcanoes straddle a narrow isthmus separating the SE-most peninsula of Bacan Island from the Sibela Mountains metamorphic complex.  The Bibinoi volcano group lies along the same trend as the Amasing volcano group, which is located to the NW on the other side of the Sibela Mountains.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-073&amp;volpage=photos&amp;photo=117001">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0608-073">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://portal.vsi.esdm.go.id/joomla/">Centre of Volcanology and Geological Hazard Mitigation</a></td></tr></table>	(-0.77000000000000002,127.72)
457	Jolo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Jolo</b></font><br /><font size="5"><b>Sulu Is</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119036.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 811 m<br /><b>Latitude:</b> 6.013&deg;N<br /><b>Longitude:</b> 121.057&deg;E</td></tr><tr><td colspan="2"><p align="justify">Numerous pyroclastic cones and craters dot 60-km-wide Jolo Island at the SW end of the Philippines archipelago.  Jolo lies in the Sulu archipelago, about 150 km SW of the tip of the Zamboanga Peninsula on SW Mindanao Island.  The isolated location of Jolo and political unrest have inhibited geological studies of the volcanic island.  Youthful-looking Tumatangus volcano forms the 811 m high point of the island.  Bud Dajo (or Buddajo) is a young basaltic cinder cone that reaches 620 m elevation; nearby cones are Matanding, Guimba, and Sungal.  Hot springs have been reported at craters on Cagayan Sulu, and solfataras at Siit Lake.  A tsunami accompanied a possible submarine eruption in 1897.  A reported eruption in 1641 actually reflected ashfall from the eruption of Parker volcano on Mindanao.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0700-01=&amp;volpage=photos&amp;photo=119036">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0700-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(6.0129999999999999,121.057)
458	Balut	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Balut</b></font><br /><font size="5"><b>Mindanao</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110049.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 862 m<br /><b>Latitude:</b> 5.40&deg;N<br /><b>Longitude:</b> 125.375&deg;E</td></tr><tr><td colspan="2"><p align="justify">Balut volcano, also known as Sanguil, occupies a small island in the Sarangani Island group south of the Batulaki Peninsula forming the southern tip of Mindanao Island.  Hot springs and thermally altered ground are located on the west and SW flanks of the 862-m-high volcano, which rises about 1800 m above the sea floor.  Reports in Mindanao of a major eruption in 1641 from an unknown volcano to the south, which caused darkness over much of Mindanao, were originally attributed to Balut volcano.  Later work indicated that the source of the eruption was Parker volcano on southern Mindanao, about 80 km NW of Balut Island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0701-01=&amp;volpage=photos&amp;photo=110049">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0701-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(5.4000000000000004,125.375)
459	Parker	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Parker</b></font><br /><font size="5"><b>Mindanao</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119040.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 1824 m<br /><b>Latitude:</b> 6.113&deg;N<br /><b>Longitude:</b> 124.892&deg;E</td></tr><tr><td colspan="2"><p align="justify">Parker volcano, also known locally as Falen, is a low, vegetated stratovolcano overlooking Sarangani Bay near the southern tip of Mindanao Island.  The steep-sided, 1824-m-high andesitic-dacitic stratovolcano is surrounded by extensive, youthful pyroclastic-flow deposits that suggest parallels to Pinatubo volcano.  The summit of Parker is truncated by a 2.9-km-wide caldera with steep-sided walls that rise 200-500 m above heart-shaped Maughan Lake.  This volcano was unknown to most volcanologists until recent years, but it is now known to have been the source of a major explosive eruption in 1641 that was previously attributed to Awu volcano on Sangihe Island, Indonesia and caused darkness over the island of Mindanao.  The 1641 eruption included the emplacement of voluminous pyroclastic flows and lahars and resulted in the formation of the summit caldera.  This was the last of three major explosive eruptions from Parker during the last 3800 years.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0701-011&amp;volpage=photos&amp;photo=119040">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0701-011">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(6.1130000000000004,124.892)
460	Matutum	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Matutum</b></font><br /><font size="5"><b>Mindanao</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119038.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 2286 m<br /><b>Latitude:</b> 6.37&deg;N<br /><b>Longitude:</b> 125.07&deg;E</td></tr><tr><td colspan="2"><p align="justify">The symmetrical Matutum stratovolcano rises to 2286 m in southern Mindanao, NW of Sarangani Bay.  The summit of the andesitic-to-dacitic volcano is truncated by a well-preserved 320-m-wide crater that is breached by three gorges and has a 120-m-deep, densely forested floor.  Widespread silicic pyroclastic-flow deposits surround the volcano, which overlooks the major city of General Santos.  The youngest pyroclastic deposits were dated at about 2000 yrs BP.  A report stated that Matutum volcano was &quot;smoking&quot; on March 7, 1911 (Neumann van Padang, 1953).  The Akmoan and Lianan thermal areas are located on the WSW flank of the volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0701-02=&amp;volpage=photos&amp;photo=119038">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0701-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(6.3700000000000001,125.06999999999999)
461	Apo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Apo</b></font><br /><font size="5"><b>Mindanao</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119062.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2938 m<br /><b>Latitude:</b> 6.989&deg;N<br /><b>Longitude:</b> 125.269&deg;E</td></tr><tr><td colspan="2"><p align="justify">Apo volcano is the highest peak in the Philippines, but its geologic history is poorly known.  Apo, which means master, or grandfather, rises to 2938 m SW of the coastal city of Davao and has a flat-topped summit with three peaks.  The SW peak of the andesitic-to-dacitic volcano, also known as Davao volcano, is the highest and contains a 500-m-wide crater containing a small lake.  The youngest crater is on the northern peak.  A line of solfataras rises from a fissure on the SE side that extends from 2400 m to the summit.  Apo is one of several volcanoes to which the major 1641 eruption from Parker volcano was incorrectly attributed to, but no historical eruptions are known from Apo.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0701-03=&amp;volpage=photos&amp;photo=119062">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0701-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(6.9889999999999999,125.26900000000001)
462	Leonard Range	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Leonard Range</b></font><br /><font size="5"><b>Mindanao</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117013.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1080 m<br /><b>Latitude:</b> 7.382&deg;N<br /><b>Longitude:</b> 126.047&deg;E</td></tr><tr><td colspan="2"><p align="justify">An andesitic-to-dacitic stratovolcano complex in the Leonard Range is truncated by a 4 x 5 km caldera partially filled by Lake Leonard.  The volcano (also known as Leonard Kniazeff) is located east of the head of Davao Gulf in SE Mindanao, east of the major N-S-trending Philippine Fault.  Activity at the Leonard Range dates back to 1.1 million years.  A dome building stage began about 290,000 years ago, producing a series of lava domes in the region surrounding Lake Leonard.  A younger stage involved the eruption of the Paloc pyroclastic deposits from the late-Pleistocene to Holocene and the formation of the caldera.  Holocene radiocarbon dates ranging from about 6000 to 1800 years ago were obtained from the Paloc pyroclastic deposits.  The Leonard Range (or North Davao) area has been the object of a geothermal exploration program.  The Manat thermal area is located north of Lake Leonard, solfataras occur its SW rim, and active solfataras, fumaroles, and hot springs are found in the Amacan-Gopod thermal area south of the lake.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0701-031&amp;volpage=photos&amp;photo=117013">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0701-031">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(7.3819999999999997,126.047)
463	Makaturing	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Makaturing</b></font><br /><font size="5"><b>Mindanao</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111051.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1940 m<br /><b>Latitude:</b> 7.647&deg;N<br /><b>Longitude:</b> 124.32&deg;E</td></tr><tr><td colspan="2"><p align="justify">Makaturing volcano rises above the shore of Illana Bay at the west end of a chain of volcanoes in central Mindanao.  Eruptions at one time attributed to Makaturing were ascribed to neighboring Ragang volcano to the east by the Catalog of Active Volcanoes of the World (Neumann van Padang, 1953), but PHIVOLCS (2004) listed eruptions for Makaturing, several of which are in the same year as those from Ragang volcano.  A dense cover of vegetation that blankets Makaturing suggests long quiescence, but solfataric activity continues.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0701-04=&amp;volpage=photos&amp;photo=111051">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0701-04=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(7.6470000000000002,124.31999999999999)
464	Ragang	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ragang</b></font><br /><font size="5"><b>Mindanao</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110047.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 2815 m<br /><b>Latitude:</b> 7.70&deg;N<br /><b>Longitude:</b> 124.50&deg;E</td></tr><tr><td colspan="2"><p align="justify">Ragang volcano rises to 2815 m at the NE end of a series of young volcanic cones SE of Lake Lanao in central Mindanao.  A 3-km-long lava flow extends to the SE from the deep summit crater.  Ragang is the most frequently active volcano on the large southern Philippines island of Mindanao and is one of several dominantly basaltic volcanoes west of the cordillera in central Mindanao.  Historical eruptions, many of which were at one time attributed to neighboring Makaturing volcano, have been recorded since 1765 and consist of moderate explosive activity from the summit crater.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0701-06=&amp;volpage=photos&amp;photo=110047">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0701-06=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(7.7000000000000002,124.5)
465	Musuan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Musuan</b></font><br /><font size="5"><b>Mindanao</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119039.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava dome<br />&nbsp;&nbsp;&nbsp; Tuff cone</td><td width="50%" align="left"><b>Summit Elev:</b> 646 m<br /><b>Latitude:</b> 7.877&deg;N<br /><b>Longitude:</b> 125.068&deg;E</td></tr><tr><td colspan="2"><p align="justify">Musuan volcano, also known as Calayo, is an isolated, low grass-covered andesitic-to-dacitic lava dome and tuff cone that rises to 646 m above flat farmland in the province of Bukidnon in central Mindanao.   An eruption, consisting of a possible phreatic explosion that &quot;burned everything around it,&quot; was reported by a Jesuit priest to have occurred four years prior to his 1891 visit, at which time strong solfataric activity prevented closer examination.   PHIVOLCS reported eruptions in 1866 and 1867.  A strong earthquake swarm occurred near Musuan volcano in 1976.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0701-07=&amp;volpage=photos&amp;photo=119039">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0701-07=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(7.8769999999999998,125.068)
466	Malindang	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Malindang</b></font><br /><font size="5"><b>Mindanao</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111034.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 2404 m<br /><b>Latitude:</b> 8.22&deg;N<br /><b>Longitude:</b> 123.63&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Pleistocene-to-Holocene Malindang stratovolcano, located on the western margin of Iligan Bay in north-central Mindanao, contains a small summit caldera.  Legends record a large eruption from the 2404-m-high, dominantly basaltic-to-andesitic volcano in the past, although no historical eruptions are known (Salise et al., 1991).  Reports of increased activity in 1991 at the time of tectonic earthquakes prompted widespread evacuations, but an eruption did not occur, although a previously unknown geothermal area was discovered.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0701-071&amp;volpage=photos&amp;photo=111034">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0701-071">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(8.2200000000000006,123.63)
467	Camiguin	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Camiguin</b></font><br /><font size="5"><b>Camiguin I</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117015.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Cinder cone</td><td width="50%" align="left"><b>Summit Elev:</b> 1552 m<br /><b>Latitude:</b> 9.203&deg;N<br /><b>Longitude:</b> 124.673&deg;E</td></tr><tr><td colspan="2"><p align="justify">Oblate, 20-km-long Camiguin Island just off the coast of north-central Mindanao Island consists of four overlapping stratovolcanoes overlying older buried edifices.  Mt. Mambajao forms the high point of Camiguin Island at 1552 m.  It has a youthful morphology with summit and flank lava domes, one of which partially fills a crater breached to the NW, but has not had historical eruptions.  The eroded stratovolcanoes of Mt. Butay and Mt. Ginsiliban form the SE tip of the island and lie at one end of the NNW-SSE trending line of vents cutting across the island.  The Binone cinder cone lies along the SE coast.  The youngest volcano, and the only historically active one, is Hibok-Hibok (also known as Catarman).  It lies at the NW end of the island, about 6 km NW of Mt. Mambajao.  This andesitic-to-rhyolitic volcano contains several lava domes, including Mt. Vulcan on its NW flank.  Major eruptions during 1871-75 and 1948-53 formed flank lava domes at Hibok-Hibok and produced pyroclastic flows that devastated coastal villages.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0701-08=&amp;volpage=photos&amp;photo=117015">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0701-08=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(9.2029999999999994,124.673)
468	Paco	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Paco</b></font><br /><font size="5"><b>Mindanao</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111053.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 524 m<br /><b>Latitude:</b> 9.593&deg;N<br /><b>Longitude:</b> 125.520&deg;E</td></tr><tr><td colspan="2"><p align="justify">Located at the NE tip of Mindanao, Paco (also known as Manlayao) is truncated by two nested calderas, 2.5 and 5 km in diameter.  The basaltic-dacitic volcano is located east of the N-S-trending Philippine Fault that cuts across eastern Mindanao.  Andesitic lava domes rim a breached crater, and the youngest dated rock is an overlying basaltic lava flow dated at about 90,000 yrs +/- 40,000 yrs BP.  Legends record a major caldera collapse eruption (Wolfe 1982, pers. comm.).  The age of the last eruption is not known, although the volcano currently displays fumarolic activity.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0701-09-&amp;volpage=photos&amp;photo=111053">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0701-09-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(9.593,125.52)
469	Cuernos de Negros	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cuernos de Negros</b></font><br /><font size="5"><b>Negros I</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120015.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano<br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1862 m<br /><b>Latitude:</b> 9.25&deg;N<br /><b>Longitude:</b> 123.17&deg;E</td></tr><tr><td colspan="2"><p align="justify">Cuernos de Negros (also known as Magaso) is a large stratovolcano complex that anchors the SE tip of Negros Island.  The eastern side of the complex consists of two stratovolcanoes and a lava dome; two crater lakes up to 1.5 km in diameter are present.  The lower western part of the complex contains four volcanic centers.  The small summit crater of Magaso, the highest peak of the complex, rises above the city of Dumaguete and contains fumaroles.  Two Sulfuric springs are found on the ESE flank of Magaso, and hot springs occur on the NE flank.  The youngest radiocarbon date obtained was 14,000 yrs BP from a dacitic breccia, and a younger andesitic unit is present.  An increase in fumarolic activity took place after a major tectonic earthquake in 1902.  The Palinpinon geothermal field is located south of the Okoy River on the north side of the volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0702-01=&amp;volpage=photos&amp;photo=120015">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0702-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(9.25,123.17)
470	Kanlaon	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kanlaon</b></font><br /><font size="5"><b>Negros I</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119034.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2435 m<br /><b>Latitude:</b> 10.412&deg;N<br /><b>Longitude:</b> 123.132&deg;E</td></tr><tr><td colspan="2"><p align="justify">Kanlaon volcano (also spelled Canlaon), the most active of the central Philippines, forms the highest point on the island of Negros.  The massive 2435-m-high andesitic stratovolcano is dotted with fissure-controlled pyroclastic cones and craters, many of which are filled by lakes.  The largest debris avalanche known in the Philippines traveled 33 km to the SW from Kanlaon.  The summit of Kanlaon contains a 2-km-wide, elongated northern caldera with a crater lake and a smaller, but higher, historically active vent, Lugud crater, to the south.  Historical eruptions from Kanlaon, recorded since 1866, have typically consisted of phreatic explosions of small-to-moderate size that produce minor ashfalls near the volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0702-02=&amp;volpage=photos&amp;photo=119034">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0702-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(10.412000000000001,123.13200000000001)
471	Mandalagan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mandalagan</b></font><br /><font size="5"><b>Negros I</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111039.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano<br />&nbsp;&nbsp;&nbsp; Calderas</td><td width="50%" align="left"><b>Summit Elev:</b> 1885 m<br /><b>Latitude:</b> 10.65&deg;N<br /><b>Longitude:</b> 123.25&deg;E</td></tr><tr><td colspan="2"><p align="justify">The deeply dissected, dominantly andesitic-to-dacitic Mandalagan volcanic complex on northern Negros Island contains a vigorous solfataric area at a highly altered domed structure.  The complex consists of seven volcanic centers, including at least five craters and/or calderas up to 2 km in diameter.  One solfataric area emits a high-temperature (106 degrees C) plume to 30 m height with a roaring noise like a high-pressure geothermal borehole.   The age of the most recent eruptive activity at the 1885-m-high volcano, which produced a thin basaltic lava flow, is not known.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0702-03=&amp;volpage=photos&amp;photo=111039">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0702-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(10.65,123.25)
472	Silay	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Silay</b></font><br /><font size="5"><b>Negros I</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111040.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 1510 m<br /><b>Latitude:</b> 10.77&deg;N<br /><b>Longitude:</b> 123.23&deg;E</td></tr><tr><td colspan="2"><p align="justify">Silay, the northernmost volcano on Negros Island, lies 28 km east of Silay City.   The compound basaltic-andesite stratovolcano has a summit elevation of 1510 m and contains a partially breached, 3.5-km-wide caldera.  Silay was considered to be of Holocene age (IAVCEI, 1973), but the age of its most recent eruptions is not known.  The Malisbog solfatara field displays fumarolic activity and extensive sulfur deposits.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0702-04=&amp;volpage=photos&amp;photo=111040">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0702-04=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(10.77,123.23)
473	Cabalan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cabalan</b></font><br /><font size="5"><b>Leyte I</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111041.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 945 m<br /><b>Latitude:</b> 10.287&deg;N<br /><b>Longitude:</b> 125.221&deg;E</td></tr><tr><td colspan="2"><p align="justify">Mount Cabalan, at the SE tip of Leyte Island, is dissected by steep radial ridges that are moderately to thickly vegetated.  A lake fills the summit crater of the 945-m-high andesitic volcano, which has an irregular rim with two high peaks on the southern side.  A thermoluminescence date of about 510,000 yrs BP was obtained from Cantoloc stratovolcano immediately to the NW.  A radiocarbon date of about 135 +/- 30 yrs BP was obtained from a pyroclastic-flow deposit from Cabalan.  Hot springs are found on the east and west flanks of Cabalan.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0702-05=&amp;volpage=photos&amp;photo=111041">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0702-05=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(10.287000000000001,125.221)
474	Mahagnao	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mahagnao</b></font><br /><font size="5"><b>Leyte I</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111043.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 860 m<br /><b>Latitude:</b> 10.896&deg;N<br /><b>Longitude:</b> 125.87&deg;E</td></tr><tr><td colspan="2"><p align="justify">The forested volcano of Mahagnao in central Leyte Island is also known as Kasiboi or Casiboi.  The andesitic volcano contains a steep-walled forested summit crater open to the south.  Thermal areas with fumaroles and mud pots occur on the flanks.  Two lakes, Malagsom and Danao, are located on the south flank.  The former is a crater lake that is acidic and green in color, and the latter is a freshwater lake with an irregular shoreline and hot springs on its southern side.  An eruption was reported from Mahagnao in 1895, but no details are available.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0702-07=&amp;volpage=photos&amp;photo=111043">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0702-07=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(10.896000000000001,125.87)
475	Biliran	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Biliran</b></font><br /><font size="5"><b>Biliran I</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111042.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Compound volcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1301 m<br /><b>Latitude:</b> 11.523&deg;N<br /><b>Longitude:</b> 124.535&deg;E</td></tr><tr><td colspan="2"><p align="justify">The volcanic island of Biliran, located across the narrow Biliran Strait from the northern tip of Leyte Island, contains many prominent andesitic lava domes, the highest of which is 1301 m Surio.  Several Pleistocene K-Ar dates have been obtained from volcanic centers on northern Biliran Island.  Fumarole fields are scattered throughout the 20 x 35 km wide island.  The only known historical activity at Biliran was a phreatic explosive eruption and possible debris avalanche at a thermal area in 1939.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0702-08=&amp;volpage=photos&amp;photo=111042">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0702-08=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(11.523,124.535)
476	Bulusan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bulusan</b></font><br /><font size="5"><b>Luzon</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/017058.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1565 m<br /><b>Latitude:</b> 12.770&deg;N<br /><b>Longitude:</b> 124.05&deg;E</td></tr><tr><td colspan="2"><p align="justify">Luzon's southernmost volcano, Bulusan, was constructed along the rim of the 11-km-diameter dacitic-to-rhyolitic Irosin caldera, which was formed about 35,000-40,000 years ago.  Bulusan lies at the SE end of the Bicol volcanic arc occupying the peninsula of the same name that forms the elongated SE tip of Luzon.  A broad, flat moat is located below the topographically prominent SW rim of Irosin caldera; the NE rim is buried by the andesitic Bulusan complex.  Bulusan is flanked by several other large intracaldera lava domes and cones, including the prominent Mount Jormajan lava dome on the SW flank and Sharp Peak to the NE.  The summit of 1565-m-high Bulusan volcano is unvegetated and contains a 300-m-wide, 50-m-deep crater.  Three small craters are located on the SE flank.  Many moderate explosive eruptions have been recorded at Bulusan since the mid-19th century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-01=&amp;volpage=photos&amp;photo=017058">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(12.77,124.05)
477	Pocdol Mountains	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Pocdol Mountains</b></font><br /><font size="5"><b>Luzon</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/017076.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Compound volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1102 m<br /><b>Latitude:</b> 13.05&deg;N<br /><b>Longitude:</b> 123.958&deg;E</td></tr><tr><td colspan="2"><p align="justify">The triangular-shaped Pocdol Mountains volcanic range, also known as the Bacon-Manito complex, covers an area of about 225 sq km between Saragon Bay and Albay Gulf in southern Luzon, SE of Mayon volcano.  Volcanic cones in the western part of the complex are dissected, but those in the eastern part are morphologically youthful.  Several Pleistocene K-Ar dates have been obtained from the volcanic complex.  The age of its latest eruptions is not known, but a fumarole field that contains a geyser is located near the summit of the compound, dominantly andesitic volcanic complex.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-02=&amp;volpage=photos&amp;photo=017076">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(13.050000000000001,123.958)
478	Mayon	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mayon</b></font><br /><font size="5"><b>Luzon</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/017077.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 2462 m<br /><b>Latitude:</b> 13.257&deg;N<br /><b>Longitude:</b> 123.685&deg;E</td></tr><tr><td colspan="2"><p align="justify">Beautifully symmetrical Mayon volcano, which rises to 2462 m above the Albay Gulf, is the Philippines' most active volcano.  The structurally simple volcano has steep upper slopes averaging 35-40 degrees that are capped by a small summit crater.  The historical eruptions of this basaltic-andesitic volcano date back to 1616 and range from strombolian to basaltic plinian, with cyclical activity beginning with basaltic eruptions, followed by longer term andesitic lava flows.  Eruptions occur predominately from the central conduit and have also produced lava flows that travel far down the flanks.  Pyroclastic flows and mudflows have commonly swept down many of the approximately 40 ravines that radiate from the summit and have often devastated populated lowland areas.  Mayon's most violent eruption, in 1814, killed more than 1200 people and devastated several towns.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-03=&amp;volpage=photos&amp;photo=017077">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(13.257,123.685)
479	Masaraga	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Masaraga</b></font><br /><font size="5"><b>Luzon</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/018033.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1328 m<br /><b>Latitude:</b> 13.32&deg;N<br /><b>Longitude:</b> 123.60&deg;E</td></tr><tr><td colspan="2"><p align="justify">Masaraga is a sharp-topped, forested stratovolcano that rises to 1328 m NW of Mayon volcano.  Thick lava flows occur on the flanks of this andesitic-to-ryholitic volcano.  Masaraga was classified as Holocene by the International Association of Volcanology and Chemistry of the Earth's Interior (IAVCEI, 1973), and K-Ar dates of zero age were obtained from this volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-031&amp;volpage=photos&amp;photo=018033">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-031">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(13.32,123.59999999999999)
480	Iriga	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Iriga</b></font><br /><font size="5"><b>Luzon</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/018049.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1196 m<br /><b>Latitude:</b> 13.457&deg;N<br /><b>Longitude:</b> 123.457&deg;E</td></tr><tr><td colspan="2"><p align="justify">Mount Iriga is a small stratovolcano that rises to 1196 m immediately SW of Lake Buhi.  The dominantly andesitic stratovolcano has satellitic cinder cones of basaltic composition.  A large breached crater that opens to the SE was formed as a result of a major debris avalanche that buried several villages and formed a broad hummocky deposit that extends across the plain south of Lake Buhi.  This catastrophic event was at one time considered to have occurred during 1628 AD, but later work has shown that the collapse and eruption occurred earlier at some unknown date during the Holocene.  The avalanche was followed by phreatic explosions that created a small crater at the base of the scarp.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-041&amp;volpage=photos&amp;photo=018049">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-041">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(13.457000000000001,123.45699999999999)
481	Isarog	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Isarog</b></font><br /><font size="5"><b>Luzon</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/018062.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1966 m<br /><b>Latitude:</b> 13.658&deg;N<br /><b>Longitude:</b> 123.38&deg;E</td></tr><tr><td colspan="2"><p align="justify">The broad isthmus between Lagonoy Gulf and San Miguel Bay in SE Luzon is occupied by the isolated Mount Isarog volcano.  The 1966-m-high andesitic stratovolcano is truncated by a 2.5-km-wide crater that is breached to the east along a narrow valley drained by the Quinarag River.  The age of the most recent eruptions from Isarog are not known, but solfataric areas occur within the Maalsom vent, which displays gas seepages, warm springs, and steaming vents.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-042&amp;volpage=photos&amp;photo=018062">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-042">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(13.657999999999999,123.38)
482	Malindig	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Malindig</b></font><br /><font size="5"><b>Marinduque I</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1157 m<br /><b>Latitude:</b> 13.240&deg;N<br /><b>Longitude:</b> 122.018&deg;E</td></tr><tr><td colspan="2"><p align="justify">The forested volcano of Malindig, also known as Marlanga, is located at the southern tip of Marinduque Island, west of the Bondoc Peninsula on Luzon Island.  Sharp-topped peaks form the summit of the 1157-m-high andesitic stratovolcano.  The age of the most recent eruptions of Malindig volcano is not known, but hot springs are located at its western foot.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-044">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(13.24,122.018)
483	Banahaw	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Banahaw</b></font><br /><font size="5"><b>Luzon</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/018064.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano<br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2158 m<br /><b>Latitude:</b> 14.07&deg;N<br /><b>Longitude:</b> 121.48&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 2158-m-high Banahaw (also known as Banahao) is the highest of a group of volcanoes south and east of Manila.  Banahaw is flanked by San Cristobal volcano on the west and Banahaw de Lucban on the NE.  Andesitic-to-dacitic lava domes occur on the flanks of Banahaw and San Cristobal.  Two major Holocene debris avalanches have occurred at Banahaw volcano.  The deposit from one extends 13 km to the NE and the other 26 km to the SE, where it forms 10 km of the coastline of Tayabas Bay.  San Cristobal stratovolcano rises to 1480 m, 7 km west of Banahaw.  Its youthful morphology suggests that it postdates Banahaw.  Banahaw de Lucban is a 1875-m-high stratovolcano that was constructed within the 8-km-wide, horseshoe-shaped caldera related to the two debris avalanches, and is the youngest volcano of the Banahaw complex.  The 2-km-wide, 600-m-deep summit crater of Banahaw is open to the SSW and contained a crater lake until 1730, when it drained, forming mudflows.  Mudflows were also recorded in 1743?, 1843 and 1909, possibly also associated with explosive activity.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-05=&amp;volpage=photos&amp;photo=018064">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-05=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(14.07,121.48)
484	San Pablo Volcanic Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>San Pablo Volcanic Field</b></font><br /><font size="5"><b>Luzon</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/018068.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 1090 m<br /><b>Latitude:</b> 14.12&deg;N<br /><b>Longitude:</b> 121.30&deg;E</td></tr><tr><td colspan="2"><p align="justify">The San Pablo volcanic field, (also known as the Laguna volcanic field ) lies at the southern end of Laguna de Bay, the largest lake on Luzon Island.  The volcanic field contains dozens of scoria cones and maars.  Three generations of maars are present, with the oldest being sediment-filled and the youngest containing deep lakes.  Many of the maars are aligned along a NE-SW trend.  Local legends suggest that the youngest maar, 1.2-km-wide Sampaloc Lake, was formed about 500-700 years ago.  The high point of the volcanic field is the eroded Maquiling (Makiling) andesitic-to-rhyolitic stratovolcano, which has a deep crater whose floor is 480 m below its north rim.  Maquiling has several parasitic cones, maars, and numerous thermal areas at its northern base.  A geothermal project is located on the south flank of Maquiling.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-06=&amp;volpage=photos&amp;photo=018068">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-06=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(14.119999999999999,121.3)
485	Taal	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Taal</b></font><br /><font size="5"><b>Luzon</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/018088.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Tuff rings</td><td width="50%" align="left"><b>Summit Elev:</b> 311 m<br /><b>Latitude:</b> 14.002&deg;N<br /><b>Longitude:</b> 120.993&deg;E</td></tr><tr><td colspan="2"><p align="justify">Taal volcano is one of the most active volcanoes in the Philippines and has produced some of its most powerful historical eruptions.  In contrast to Mayon volcano, Taal is not topographically prominent, but its prehistorical eruptions have greatly changed the topography of SW Luzon.  The 15 x 20 km Talisay (Taal) caldera is largely filled by Lake Taal, whose 267 sq km surface lies only 3 m above sea level.  The maximum depth of the lake is 160 m, and several eruptive centers lie submerged beneath the lake.  The 5-km-wide Volcano Island in north-central Lake Taal is the location of all historical eruptions.  The island is a complex volcano composed of coalescing small stratovolcanoes, tuff rings, and scoria cones that has grown about 25% in area during historical time.  Powerful pyroclastic flows and surges from historical eruptions of Taal have caused many fatalities.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-07=&amp;volpage=photos&amp;photo=018088">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-07=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(14.002000000000001,120.99299999999999)
486	Laguna Caldera	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Laguna Caldera</b></font><br /><font size="5"><b>Luzon</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/091009.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 743 m<br /><b>Latitude:</b> 14.42&deg;N<br /><b>Longitude:</b> 121.27&deg;E</td></tr><tr><td colspan="2"><p align="justify">The elliptical, 10 x 20 km wide Laguna Caldera SE of Manila forms the middle lake-filled basin of the three-pronged, dinosaur-footprint-shaped Laguna de Bay, the largest lake on Luzon Island.  Pre-caldera Pleistocene volcanism formed basaltic to basaltic-andesitic volcanoes, including Talim Island and Mount Sembrano stratovolcanoes on opposite sides of the current caldera.  The caldera, whose lake surface is only 1 m above sea level, may have formed during at least two major explosive eruptions about 1 million and 27,000-29,000 years ago.  Post-caldera volcanism formed maars of young, but unknown age at the southern end of elongated Talim Island, which forms the SW rim of the caldera.  Jalajala is a solfataric field on the flank of Mount Sembrano on the Jalajala Peninsula, which forms the eastern rim of the caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-08=&amp;volpage=photos&amp;photo=091009">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-08=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(14.42,121.27)
487	Mariveles	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mariveles</b></font><br /><font size="5"><b>Luzon</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/091003.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 1388 m<br /><b>Latitude:</b> 14.52&deg;N<br /><b>Longitude:</b> 120.47&deg;E</td></tr><tr><td colspan="2"><p align="justify">The low, but massive Mariveles stratovolcano lies at the southern end of the Bataan Peninsula, on the west side of Manila Bay.  The morphologically youthful, dominantly andesitic volcano rises to 1388 m and is truncated by a 4-km-wide caldera that drains to the north.  Mount Slamet on the north and Mount Limay on the east are major, youthful-looking flank cones.  A mid-Holocene eruption has been radiocarbon dated at 4000 years before present.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-081&amp;volpage=photos&amp;photo=091003">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-081">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(14.52,120.47)
488	Pinatubo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Pinatubo</b></font><br /><font size="5"><b>Luzon</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/019014.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1486 m<br /><b>Latitude:</b> 15.13&deg;N<br /><b>Longitude:</b> 120.35&deg;E</td></tr><tr><td colspan="2"><p align="justify">Prior to 1991 Pinatubo volcano was a relatively unknown, heavily forested lava dome complex  located 100 km NW of Manila with no records of historical eruptions.  The 1991 eruption, one of the world's largest of the 20th century, ejected massive amounts of tephra and produced voluminous pyroclastic flows, forming a small, 2.5-km-wide summit caldera whose floor is now covered by a lake.  Caldera formation lowered the height of the summit from 1745 to 1486 m.  Although the eruption caused hundreds of fatalities and major damage with severe social and economic impact, successful monitoring efforts greatly reduced the number of fatalities.  Widespread lahars that redistributed products of the 1991 eruption have continued to cause severe disruption.  At least six major eruptive periods, interrupted by lengthy quiescent periods, have occurred from modern Pinatubo volcano during the past 35,000 years.  Most of these have produced major pyroclastic flows and lahars that were even more extensive than in 1991.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-083&amp;volpage=photos&amp;photo=019014">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-083">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(15.130000000000001,120.34999999999999)
489	Amorong	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Amorong</b></font><br /><font size="5"><b>Luzon</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 376 m<br /><b>Latitude:</b> 15.828&deg;N<br /><b>Longitude:</b> 120.805&deg;E</td></tr><tr><td colspan="2"><p align="justify">Mount Amorong is the only one of a cluster of small trachyandesitic lava domes and diatremes at the northern end of the Luzon Central Plain that displays solfataric activity (Wolfe 1982, pers. comm.).  A K-Ar date of about 1.14 million years was obtained from the Amorong complex, which lies along the Eastern Bataan volcanic lineament.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-085">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(15.827999999999999,120.80500000000001)
490	Patoc	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Patoc</b></font><br /><font size="5"><b>Luzon</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1865? m<br /><b>Latitude:</b> 17.147&deg;N<br /><b>Longitude:</b> 120.980&deg;E</td></tr><tr><td colspan="2"><p align="justify">Mount Patoc, an andesitic stratovolcano in the Cordillera Central of north-central Luzon, displays strong fumarolic activity.  A stream and village on the west side are named Mainit, which means hot.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-087">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(17.146999999999998,120.98)
491	Ambalatungan Group	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ambalatungan Group</b></font><br /><font size="5"><b>Luzon</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Compound volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 2329 m<br /><b>Latitude:</b> 17.32&deg;N<br /><b>Longitude:</b> 121.10&deg;E</td></tr><tr><td colspan="2"><p align="justify">A little-known cluster of volcanoes in the Cordillera Central of northern Luzon is known as Ambalatungan by Alvir (1956) and the Philippine Commission of Volcanology (1981) and as Mount Binuluan by Wolfe (1982, pers. comm.).  The dacitic Ambalatungan Group was described as consisting of three volcanoes constructed along a roughly E-W line.  Ambalatungan volcano proper contains a steep-walled crater with hot springs and vigorous sulfur-encrusted fumarolic vents that produce loud noises.  Bumabag volcano, 3 km east of Ambalatungan, has two craters that also show strong fumarolic activity.  Podakan volcano, 1 km SE of Bumabag, also has a large steam vent.  A possible steam eruption was reported from 2329-m-high Mount Binuluan (whose relationship to the previously mentioned volcanoes is unclear) in 1952, during which a sulfur-rich debris flow killed a dozen people.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-088">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(17.32,121.09999999999999)
492	Cagua	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cagua</b></font><br /><font size="5"><b>Luzon</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119042.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1133 m<br /><b>Latitude:</b> 18.222&deg;N<br /><b>Longitude:</b> 122.123&deg;E</td></tr><tr><td colspan="2"><p align="justify">Mount Cagua, a 1133-m-high stratovolcano, lies at the NE tip of Luzon.  The circular summit crater is 1.5 km in diameter, with steep, 60-m-high walls.  Basaltic-andesite and basaltic lava effusion characterized the initial stage of volcanism during the early Pleistocene.  From about 600,000 to 300,000 years ago thick pyroclastic flows covered the entire volcano.  Recent periods of phreatomagmatic activity have produced ash flows.  The forested volcano is locally known as the &quot;Mountain of Fire.&quot;  A phreatic explosion in 1860 may have been accompanied by a pyroclastic flow.  Strong solfataric activity occurred in 1907, and thermal areas are located near the summit crater and on the NW to NNE flanks.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-09=&amp;volpage=photos&amp;photo=119042">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0703-09=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(18.222000000000001,122.123)
493	Camiguin de Babuyanes	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Camiguin de Babuyanes</b></font><br /><font size="5"><b>Babuyan Archipelago (Philippines)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104011.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 712 m<br /><b>Latitude:</b> 18.83&deg;N<br /><b>Longitude:</b> 121.860&deg;E</td></tr><tr><td colspan="2"><p align="justify">Forested 712-m-high Mount Camiguin occupies the SW tip of 22-km-long Camiguin Island in the Babuyan archipelago, north of Luzon Island.  Following construction of an andesitic volcano during the Pliocene, the subsidiary cones of Minabul to the north and Caanoan to the east were constructed on the northern part of the island.  The southern part of the island consists of three volcanic centers located along a SSE-NNW line, the andesitic Mount Camiguin stratovolcano and the young andesitic lava domes of Mt. Malabsing and Pamoctan.  A phreatic eruption, possibly in part submarine, was reported from Camiguin de Babuyanes around 1857.  Fumaroles are found on the SW, west, and east flanks of the volcano, and a boiling spring is located near sea level on the western flank of the volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0704-01=&amp;volpage=photos&amp;photo=104011">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0704-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(18.829999999999998,121.86)
494	Didicas	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Didicas</b></font><br /><font size="5"><b>Didicas Island (Philippines)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119035.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Compound volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 228 m<br /><b>Latitude:</b> 19.077&deg;N<br /><b>Longitude:</b> 122.202&deg;E</td></tr><tr><td colspan="2"><p align="justify">Didicas volcano, 22 km NE of Camiguin Island, was a submarine volcano prior to 1952, when a permanent island was formed.  Didicas now consists of a small, 244-m-high andesitic lava dome about 1.4 km in longest exposed dimension.  A 400-m-wide crater was formed during the 1952 eruption.  The first recorded submarine eruption of Didicas was in 1773.  The first recorded subaerial cone reached a height of 213 m in 1860, after a four-year-long eruption, but soon was eroded beneath the sea.  Three rock masses up to 82 m high were left after an eruption in 1900.  Two eruptions have occurred since 1952 at an explosion crater on the northern side of the island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0704-02=&amp;volpage=photos&amp;photo=119035">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0704-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(19.077000000000002,122.202)
495	Babuyan Claro	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Babuyan Claro</b></font><br /><font size="5"><b>Babuyan Island (Philippines)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119032.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1080+ m<br /><b>Latitude:</b> 19.523&deg;N<br /><b>Longitude:</b> 121.940&deg;E</td></tr><tr><td colspan="2"><p align="justify">Five Pleistocene-to-Holocene volcanic centers occupy Babuyan de Claro Island north of Luzon.  The largest edifice is Mt. Pangasun (Babuyan Claro), an active stratovolcano with two summit craters 300 and 400 m in diameter.  The symmetrical basaltic andesite cinder cone of Smith Volcano (Mount Babuyan), located 4 km to the NW of Babuyan Claro, rises to 688 m and is the youngest volcano on the island.  Both Babuyan Claro and Smith volcanoes have apparently been active in historical time, although the identity of the erupting volcano is not always certain.  Askedna Hot Spring is located at the southern base of Babuyan Claro.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0704-03=&amp;volpage=photos&amp;photo=119032">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0704-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(19.523,121.94)
496	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>Batan Islands (Philippines)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -24 m<br /><b>Latitude:</b> 20.33&deg;N<br /><b>Longitude:</b> 121.75&deg;E</td></tr><tr><td colspan="2"><p align="justify">Submarine eruptions reported in 1773, 1850, and 1854 may have originated from a shallow submarine volcano 5 km west of Ibugos Island.  Ibugos is located at the southern end of the Batan Island chain, which occupies the Luzon Strait between Luzon and Taiwan.  The volcano rises to within 24 m of the sea surface.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0704-05=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(20.329999999999998,121.75)
497	Iraya	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Iraya</b></font><br /><font size="5"><b>Batan Islands (Philippines)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119037.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> 1009 m<br /><b>Latitude:</b> 20.469&deg;N<br /><b>Longitude:</b> 122.010&deg;E</td></tr><tr><td colspan="2"><p align="justify">The morphologically youthful Iraya volcano, at the north end of Batan Island, is the northernmost active volcano in the Philippines.  Iraya is the most prominent feature of the 20-km-long, dumbbell-shaped Batan island, located in the Luzon Strait between Luzon and Taiwan.  The 1009-m-high Quaternary stratovolcano has a 1.5-km-wide summit crater, which is largely filled by a younger cone that forms the summit of the volcano.  Observed late-Pleistocene and Holocene products of Iraya are exclusively explosive.  The youngest dated unit of Iraya is a pyroclastic-flow deposit radiocarbon dated at about 1500 years ago (Richard et al., 1986).  The Philippines Institute of Volcanology and Seismology (2004-) listed an eruption in 1454 AD of unspecified character.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0704-06-&amp;volpage=photos&amp;photo=119037">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0704-06-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.phivolcs.dost.gov.ph/">Philippine Institute of Volcanology and Seismology</a></td></tr></table>	(20.469000000000001,122.01000000000001)
498	Hainan Dao	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hainan Dao</b></font><br /><font size="5"><b>China-SE</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119043.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Latitude:</b> 19.70&deg;N<br /><b>Longitude:</b> 110.10&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Hainan Dao volcanic field consists of a group of 58 Pleistocene-Holocene tholeiitic cones that are part of the Qionglei volcano group, also known as the Leiqiong volcanic field.  The Hainan Dao volcanic field covers about 4100 sq km of the northern part of Hainan Island (also known as Qiong), across the Qiongzhou strait south of the Leizhou (Liuchow) Peninsula.   The Hainan Dao volcano field is of Pleistocene-Holocene age, but historical eruptions were reported in the Lingao and Chengmai areas in the 19th and 20th centuries.  Leihuling and Maanshan, two of the best preserved volcanic cones, are oriented along an E-W fracture and are part of a cluster of about 30 cones in the Shishan and Yongzing regions.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0705-001&amp;volpage=photos&amp;photo=119043">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0705-001">Smithsonian Volcano Information</a></td></tr></table>	(19.699999999999999,110.09999999999999)
499	Leizhou Bandao	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Leizhou Bandao</b></font><br /><font size="5"><b>Southeastern China</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119044.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 259 m<br /><b>Latitude:</b> 20.78&deg;N<br /><b>Longitude:</b> 110.17&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Leizhou Bandao volcanic field is a group of Pliocene-Holocene basaltic cones on the Leizhou (Liuchow) Peninsula in SE China, across the Qiongzhou strait north of Hainan Dao Island.  Leizhou Bandao is the northern part of the Qionglei volcano group (also known as the Leiqiong volcanic field), a 7300 sq km basaltic-to-basanitic plateau that covers the southern Leizhou (Liuchow) Peninsula and extends across a broad area of northern Hainan Dao.  Volcanism on the peninsula was controlled by E-W-trending extension related to the opening of the South China Sea Basin.   Yingfengling and Tianyang are Pleistocene stratovolcanoes that contain large amounts of mantle xenoliths.  Much of the southern part of the penisula is formed by Pleistocene-Holocene volcanic cones, but another area of Pleistocene-Holocene volcanism lies at the the northern end of the peninsula, west of Zhanjiang City.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0705-01-&amp;volpage=photos&amp;photo=119044">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0705-01-">Smithsonian Volcano Information</a></td></tr></table>	(20.780000000000001,110.17)
500	C-Lao R Group	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>C-Lao R Group</b></font><br /><font size="5"><b>Vietnam</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 181 m<br /><b>Latitude:</b> 15.38&deg;N<br /><b>Longitude:</b> 109.12&deg;E</td></tr><tr><td colspan="2"><p align="justify">C-Lao R volcanic field consists of four subaerial and nine submarine cones about 150 km off the coast of central Vietnam.  Three of the subaerial cones form C-Lao R Island, and the fourth forms C-Lao Bo Bai Island.  The basaltic volcanic field is of Holocene age (Whitford-Stark 1987, pers. comm.).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0705-02-">Smithsonian Volcano Information</a></td></tr></table>	(15.380000000000001,109.12)
501	Ile des Cendres	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ile des Cendres</b></font><br /><font size="5"><b>East of Vietnam</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcanoes</td><td width="50%" align="left"><b>Summit Elev:</b> -20 m<br /><b>Latitude:</b> 10.158&deg;N<br /><b>Longitude:</b> 109.014&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Ile des Cendres group of submarine volcanoes off the SE coast of Vietnam consists of two submarine cinder cones that formed ephemeral islands during an eruption in 1923 and two submarine lava cones of uncertain age.  The 1923 eruption produced two small islands, one about 30 m high and about 450 m long, and the other only 30 m wide and 30 cm high.  A third submarine cone reached to within 20 m of the surface.  Additional submarine cones occur between Ile des Cendres and the Vietnam mainland (Bondarenko and Nadezhnyi, 1989).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0705-06-">Smithsonian Volcano Information</a></td></tr></table>	(10.157999999999999,109.014)
502	Veteran	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Veteran</b></font><br /><font size="5"><b>East of Vietnam</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Latitude:</b> 9.83&deg;N<br /><b>Longitude:</b> 109.05&deg;E</td></tr><tr><td colspan="2"><p align="justify">A reef reported in 1880 at a location 34 km SSE of Grand Catwick Rock, off the SE coast of Vietnam, was not found in 1882.  This was attributed to a possible volcanic eruption (Catalog of Active Volcanoes of the World).  Discolored water, possibly from fumarolic activity, was reported in 1928.  This area lies along a regional N-S-trending lineament related to extension produced by collision of the Australian plate.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0705-07-">Smithsonian Volcano Information</a></td></tr></table>	(9.8300000000000001,109.05)
503	Popa	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Popa</b></font><br /><font size="5"><b>Burma</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/087026.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1518 m<br /><b>Latitude:</b> 20.92&deg;N<br /><b>Longitude:</b> 95.25&deg;E</td></tr><tr><td colspan="2"><p align="justify">Mount Popa, in central Burma (Myanmar), is a large, steep-sided composite cone that rises 1150 m above a surrounding lava plateau to a height of 1518 m.  The main edifice consists of overlapping basaltic and basaltic-andesite lava flows, pyroclastic deposits, and scoriaceous material originating from strombolian eruptions that may have dominated later stages of  the volcano's growth.  Mount Popa contains a 1.6-km-wide, 850-m-deep horseshoe-shaped caldera that is widely breached to the NW and formed as a result of slope failure.  A 3 cu km debris-avalanche deposit covers an area of 27 sq km north of the breach.  Local legends describe an eruption in 442 BC (Stephenson and Marshall, 1984).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0705-08-&amp;volpage=photos&amp;photo=087026">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0705-08-">Smithsonian Volcano Information</a></td></tr></table>	(20.920000000000002,95.25)
504	Singu Plateau	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Singu Plateau</b></font><br /><font size="5"><b>Burma</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 507 m<br /><b>Latitude:</b> 22.70&deg;N<br /><b>Longitude:</b> 95.98&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Singu Plateau volcanic field, also known as Letha Taung, is a Holocene basaltic trachyandesite lava plateau in north-central Burma, north of the city of Mandalay.  The lava flows originated from fissure vents and cover an area of about 62 sq km.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0705-10-">Smithsonian Volcano Information</a></td></tr></table>	(22.699999999999999,95.980000000000004)
505	Tengchong	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tengchong</b></font><br /><font size="5"><b>Southern China</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/067092.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2865 m<br /><b>Latitude:</b> 25.23&deg;N<br /><b>Longitude:</b> 98.50&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Tengchong volcanic district, located in southern China near the border with Burma (Myanmar), was active during five periods ranging from the early Pliocene to the Holocene.  Three main stages prroduced Pliocene to mid-Pleistocene basaltic rocks, mid- to late-Pleistocene silicic pyroclastic rocks, and Holocene basaltic andesites.  The youngest volcanism in the 600 sq km volcanic field occurred in two stages during the early and late Holocene.  Volcanic cones at the northern end of the field are sparsely vegetated and have clearly visible lava flows.  Three basaltic-andesite centers, Dayinshshan, Maanshan, and possibly Heikongshan, are of Holocene age.  An unconfirmed explosive eruption took place in 1609, and there are unconfirmed reports of eruptions in the Qing Dynasty (1644-1911).  The Tengchong district is the site of active geothermal fields, the largest and highest temperature of which is the Rehai geothermal field.  More than 20 hydrothermal eruptions have occurred at the Rehai geothermal field since 1993.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0705-11-&amp;volpage=photos&amp;photo=067092">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0705-11-">Smithsonian Volcano Information</a></td></tr></table>	(25.23,98.5)
506	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>East of Taiwan</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Latitude:</b> 24.00&deg;N<br /><b>Longitude:</b> 121.83&deg;E</td></tr><tr><td colspan="2"><p align="justify">A submarine eruption observed by the U.S. Navy boat &quot;Southampton&quot;  took place on October 29, 1853 in the Philippine Sea offshore from the city of Hualien about 18 km from the eastern coast of Taiwan.  Several days later another ship, the &quot;Macedonian,&quot; passed the same location and reported white ash covering its curtains.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0801-03=">Smithsonian Volcano Information</a></td></tr></table>	(24,121.83)
507	Kueishantao	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kueishantao</b></font><br /><font size="5"><b>East of Taiwan</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120006.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 401 m<br /><b>Latitude:</b> 24.85&deg;N<br /><b>Longitude:</b> 121.92&deg;E</td></tr><tr><td colspan="2"><p align="justify">Kueishantao Island, whose summit is 401 m above sea level, is the southernmost of five small volcanic islands off the NE coast of Taiwan.  Kueishantao, also known as Guieshan Island, consists of andesitic lava flows and volcaniclastic material.  Kueishantao is the southwesternmost volcano along the axis of the Okinawa Trough back-arc basin that extends to the NE from Taiwan to Unzen volcano in Kyushu.  The SW tip of the Okinawa Trough extends past Kueishantao onto the Ilao Plain on the island of Taiwan.  The island is known as &quot;Turtle Mountain Island&quot; due to its profile as seen from some points on the coast of Taiwan.  Historical accounts during the time of King Qianlong of the Qing Dynasty (1775-1795 AD) noted the Guieshan mountain split open with a blood-red lava flow.  Kueishantao displays vigorous active submarine fumaroles and solfataras that discolor seawater over wide areas.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0801-031&amp;volpage=photos&amp;photo=120006">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0801-031">Smithsonian Volcano Information</a></td></tr></table>	(24.850000000000001,121.92)
508	Tatun Group	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tatun Group</b></font><br /><font size="5"><b>Taiwan</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/121032.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Tuff cone<br />&nbsp;&nbsp;&nbsp; Tuff ring</td><td width="50%" align="left"><b>Summit Elev:</b> 1120 m<br /><b>Latitude:</b> 25.17&deg;N<br /><b>Longitude:</b> 121.52&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Tatun (Datun) volcano group consists predominately of a series of andesitic lava domes in the northernmost part of Taiwan.  About 20 volcanoes, the southernmost of which is only 15 km north of the capital city of Taipei, are included in the Tatun group, which was constructed along E-W and NE-SW trending ridges.  The highest and youngest volcano is the 1120-m-high Cising (Chisingshan) lava dome.  Several magmatic eruptions took place at the Tatun volcano group about 23,000 to 13,000 years ago, and a phreatic eruption assocciated with collapse of the lava dome, possibly closely following lava effusion, took place about 6000 years ago.  Hot springs, fumaroles, and solfataras are found over wide areas along a zone parallel to the SW-NE-trending Chinshan fault and extending to the NE coast of Taiwan, and extensive geothermal exploration has occurred at the Daiton geothermal area.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0801-032&amp;volpage=photos&amp;photo=121032">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0801-032">Smithsonian Volcano Information</a></td></tr></table>	(25.170000000000002,121.52)
509	Iriomote-jima	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Iriomote-jima</b></font><br /><font size="5"><b>Ryukyu Islands (Japan)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104018.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -200 m<br /><b>Latitude:</b> 24.558&deg;N<br /><b>Longitude:</b> 124.00&deg;E</td></tr><tr><td colspan="2"><p align="justify">The southernmost Ryukyu Islands volcano is a shallow submarine volcano north of Iriomote-jima island.  The submarine volcano is located 25 km NNE of the NE tip of Iriomote-jima and 35 km WSW of the northern tip of the island of Ishigaki-shima in an area with an estimated depth of 200-300 m.  A major submarine eruption took place at this volcano on October 31, 1924.  It produced rhyolitic pumice rafts with an estimated volume of about 1 cu km that were carried by currents along both coasts of Japan as far north as Hokkaido.  The largest pumice blocks exceeded 1 x 2 m in size, and the volume of ejecta places this poorly known eruption among the largest in historical time in Japan.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-01=&amp;volpage=photos&amp;photo=104018">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(24.558,124)
510	Iwo-Tori-shima	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Iwo-Tori-shima</b></font><br /><font size="5"><b>Ryukyu Islands (Japan)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/107078.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 212 m<br /><b>Latitude:</b> 27.877&deg;N<br /><b>Longitude:</b> 128.224&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 1 x 2.7 km island of Iwo-Tori-shima (also known as Okinawa-Tori-shima), located north of the largest island of the Ryukyus, Okinawa, is composed of two andesitic volcanoes.  Tori-shima (Bird Island) is a common name for offshore islands in Japan.  Kusuku lava dome occupies the center of the inner of two sommas on the SE-most volcano.  The summit crater of the NW-most volcano, Iwo-dake, contains a small lake, solfataras, and sulfur deposits that were mined in the past.  Historical eruptions dating back to 1664 have consisted of mild-to-moderate explosive activity.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-02=&amp;volpage=photos&amp;photo=107078">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(27.876999999999999,128.22399999999999)
511	Yokoate-jima	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Yokoate-jima</b></font><br /><font size="5"><b>Ryukyu Islands (Japan)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117093.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 495 m<br /><b>Latitude:</b> 28.797&deg;N<br /><b>Longitude:</b> 128.997&deg;E</td></tr><tr><td colspan="2"><p align="justify">Yokoate-jima is a small, 3.5-km-long, dumbbell-shaped island NW of Amami Oshima Island at the SW end of the Tokara island chain.  Two peaks, Higashimine on the east and Nishimine on the west, form the andesitic island.  The 495-m-high Higashimine, the high point of the island, has a steep-walled, well-preserved summit crater.  An arcuate ridge east of Yokoate-jima appears to be part of 7 x 10 km wide submarine caldera, with Yokoate-jima and Kannone-jima (NNE of Yokoate-jima) being post-caldera cones (Nakano et al., 2001-).  Yokoate-sho (Yokoate Reef) and Kannone Kaikyu (Kannone Knoll) lie to NNW and NE of Yokoate-jima, respectively.  Historical documents at the end of the Edo Period mention ash plumes from Yokoate-jima.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-021&amp;volpage=photos&amp;photo=117093">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-021">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(28.797000000000001,128.99700000000001)
512	Suwanose-jima	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Suwanose-jima</b></font><br /><font size="5"><b>Ryukyu Islands (Japan)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/064060.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 799 m<br /><b>Latitude:</b> 29.635&deg;N<br /><b>Longitude:</b> 129.716&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 8-km-long, spindle-shaped island of Suwanose-jima in the northern Ryukyu Islands consists of an andesitic stratovolcano with two historically active summit craters.  Only about 50 persons live on the sparsely populated island.  The summit of the volcano is truncated by a large breached crater extending to the sea on the east flank that was formed by edifice collapse.  Suwanose-jima, one of Japan's most frequently active volcanoes, was in a state of intermittent strombolian activity from On-take (Otake), the NE summit crater, that began in 1949 and lasted until 1996, after which periods of inactivity lengthened.  The largest historical eruption took place in 1813-14, when thick scoria deposits blanketed residential areas, and the SW crater produced two lava flows that reached the western coast.  At the end of the eruption the summit of On-take collapsed forming a large debris avalanche and creating the horseshoe-shaped Sakuchi caldera, which extends to the eastern coast.  The island remained uninhabited for about 70 years after the 1813-1814 eruption. Lava flows reached the eastern coast of the island in 1884.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-03=&amp;volpage=photos&amp;photo=064060">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(29.635000000000002,129.71600000000001)
513	Nakano-shima	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Nakano-shima</b></font><br /><font size="5"><b>Ryukyu Islands (Japan)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/118004.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes</td><td width="50%" align="left"><b>Summit Elev:</b> 979 m<br /><b>Latitude:</b> 29.856&deg;N<br /><b>Longitude:</b> 129.859&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 9 x 5 km island of Nakano-shima is surrounded by coral reefs.  A flat plateau separates an older dissected volcano on the south from the active andesitic cone of On-take, which forms the northern half of the island.  On-take contains a summit crater that is filled with water during the rainy season.  Sulfur deposits were mined at a SE-flank solfatara until 1944.  Only very minor activity has been reported in historical time.  A small mud eruption took place in 1914 at the summit crater, and &quot;smoking&quot; increased in 1949.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-04=&amp;volpage=photos&amp;photo=118004">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-04=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(29.856000000000002,129.85900000000001)
514	Kuchino-shima	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kuchino-shima</b></font><br /><font size="5"><b>Ryukyu Islands (Japan)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/118002.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 628 m<br /><b>Latitude:</b> 29.964&deg;N<br /><b>Longitude:</b> 129.927&deg;E</td></tr><tr><td colspan="2"><p align="justify">Kuchino-shima, lying in the northern Ryukyu Islands between the volcanic islands of Nakano-shima and Kuchinoerabu-jima, consists of two andesitic stratovolcanoes and a NW-SE-trending chain of lava domes.  Two small villages, Nishinohama and Kuchino-shima, lie at the northern end of the mostly uninhabited island.  The compound 628-m-high Mae-dake lava dome, forming the highest point on the 3 x 7 km wide island, was constructed east of the summit of 501-m-high Yoko-dake stratovolcano.  The last magmatic eruption at Kuchino-shima took place about 1200-1300 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-043&amp;volpage=photos&amp;photo=118002">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-043">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(29.963999999999999,129.92699999999999)
515	Kuchinoerabu-jima	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kuchinoerabu-jima</b></font><br /><font size="5"><b>Ryukyu Islands (Japan)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/105031.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 657 m<br /><b>Latitude:</b> 30.440&deg;N<br /><b>Longitude:</b> 130.219&deg;E</td></tr><tr><td colspan="2"><p align="justify">A group of young stratovolcanoes forms the eastern end of the irregularly shaped island of Kuchinoerabu-jima in the northern Ryukyus, 15 km west of Yaku-shima.  Furu-take, Shin-take, and Noike were erupted from south to north, respectively, to form a composite cone that is parallel to the trend of the Ryukyu Islands.  The highest peak, Furu-take, reaches only 657 m above sea level.  The youngest cone, 640-m-high Shin-take, was formed after the NW side of Furu-take was breached by an explosion.  All historical eruptions have occurred from Shin-take, although a lava flow from the south flank of Furu-take that reached the coast has a very fresh morphology.  Frequent explosive eruptions have taken place from Shin-take since 1840; the largest of these was in December 1933.  Several villages on the 4 x 12 km island are located within a few km of the active crater of Shin-take and have suffered damage from eruptions.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-05=&amp;volpage=photos&amp;photo=105031">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-05=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(30.440000000000001,130.21899999999999)
516	Kikai	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kikai</b></font><br /><font size="5"><b>Ryukyu Islands (Japan)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/087057.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 704 m<br /><b>Latitude:</b> 30.789&deg;N<br /><b>Longitude:</b> 130.308&deg;E</td></tr><tr><td colspan="2"><p align="justify">Kikai is a mostly submerged, 19-km-wide caldera near the northern end of the Ryukyu Islands south of Kyushu.  Kikai was the source of one of the world's largest Holocene eruptions about 6300 years ago. Rhyolitic pyroclastic flows traveled across the sea for a total distance of 100 km to southern Kyushu, and ashfall reached the northernmost Japanese island of Hokkaido. The eruption devastated southern and central Kyushu, which remained uninhabited for several centuries. Post-caldera eruptions formed Iwo-dake lava dome and Inamura-dake scoria cone, as well as submarine lava domes.  Historical eruptions have occurred in the 20th century at or near Tokara-Iwo-Jima (also known as Satsuma-Iwo-jima), a small 3 x 6 km island forming part of the NW caldera rim. Showa-Iwo-jima lava dome (also known as Iwo-jima-Shinto), a small island 2 km east of Tokara-Iwo-jima, was formed during submarine eruptions in 1934 and 1935.  Mild-to-moderate explosive eruptions have occurred during the past few decades from Iwo-dake, a rhyolitic lava dome at the eastern end of Tokara-Iwo-jima.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-06=&amp;volpage=photos&amp;photo=087057">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-06=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(30.789000000000001,130.30799999999999)
517	Ibusuki Volcanic Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ibusuki Volcanic Field</b></font><br /><font size="5"><b>Kyushu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/013022.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 922 m<br /><b>Latitude:</b> 31.22&deg;N<br /><b>Longitude:</b> 130.57&deg;E</td></tr><tr><td colspan="2"><p align="justify">Ibusuki volcanic field at the southern tip of Kyushu consists of numerous central cones and maars, the 4.5-km-wide Ikeda-ko caldera, and Kaimon-dake stratovolcano.  The symmetrical, 922-m-high andesitic Kaimon-dake is the most prominent feature of the volcanic field and is capped by a lava dome.  The large Pleistocene Ata caldera, once thought to partially underlie the Ibusuki volcanic field, is now considered to be located farther to the east beneath Kagoshima Bay.  Ibusuki Volcanic Field has been very active during the Holocene, forming the Ikeda-ko caldera about 4600 years ago, numerous maars and lava domes, and, during the last 4000 years, Kaimon-dake.  After about 2650 years ago, all eruptive activity has been restricted to Kaimon-dake.  Its last eruption took place in the 9th century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-07=&amp;volpage=photos&amp;photo=013022">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-07=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(31.219999999999999,130.56999999999999)
518	Sakura-jima	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sakura-jima</b></font><br /><font size="5"><b>Kyushu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/105067.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1117 m<br /><b>Latitude:</b> 31.585&deg;N<br /><b>Longitude:</b> 130.657&deg;E</td></tr><tr><td colspan="2"><p align="justify">Sakura-jima, one of Japan's most active volcanoes, is a post-caldera cone of the Aira caldera at the northern half of Kagoshima Bay.  Eruption of the voluminous Ito pyroclastic flow accompanied formation of the 17 x 23 km wide Aira caldera about 22,000 years ago.  The smaller Wakamiko caldera was formed during the early Holocene in the NE corner of the Aira caldera, along with several post-caldera cones.  The construction of Sakura-jima began about 13,000 years ago on the southern rim of Aira caldera and built an island that was finally joined to the Osumi Peninsula during the major explosive and effusive eruption of 1914.  Activity at the Kita-dake summit cone ended about 4850 years ago, after which eruptions took place at Minami-dake.   Frequent historical eruptions, recorded since the 8th century, have deposited ash on Kagoshima, one of Kyushu's largest cities, located across Kagoshima Bay only 8 km from the summit.  The largest historical eruption took place during 1471-76.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-08=&amp;volpage=photos&amp;photo=105067">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-08=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.dpri.kyoto-u.ac.jp/~kazan/default_e.html">Sakurajima Volcano Observatory</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(31.585000000000001,130.65700000000001)
519	Sumiyoshi-ike	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sumiyoshi-ike</b></font><br /><font size="5"><b>Kyushu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/105078.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 15 m<br /><b>Latitude:</b> 31.768&deg;N<br /><b>Longitude:</b> 130.594&deg;E</td></tr><tr><td colspan="2"><p align="justify">Sumiyoshi-ike and Yonemaru are two basaltic maars formed in coastal lowland deposits north of the Aira caldera.  The eruptions occurred during a period of rising sea level at the beginning of the Holocene.   The 500-m-wide Sumiyoshi-ike maar was created about 7000 years ago.  The larger, 1.2-km-wide Yonemaru maar erupted about 2 km west of Sumiyoshi-ike about 6500 years ago and produced pyroclastic surges that traveled 4 km from the vent.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-081&amp;volpage=photos&amp;photo=105078">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-081">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(31.768000000000001,130.59399999999999)
520	Kirishima	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kirishima</b></font><br /><font size="5"><b>Kyushu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/089054.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1700 m<br /><b>Latitude:</b> 31.931&deg;N<br /><b>Longitude:</b> 130.864&deg;E</td></tr><tr><td colspan="2"><p align="justify">Kirishima is a large group of more than 20 Quaternary volcanoes located north of Kagoshima Bay.  The late-Pleistocene to Holocene dominantly andesitic volcano group consists of stratovolcanoes, pyroclastic cones, maars, and underlying shield volcanoes located over an area of 20 x 30 km.  The larger stratovolcanoes are scattered throughout the field, with the centrally located, 1700-m-high Karakuni-dake being the highest.  Onami-ike and Mi-ike, the two largest maars, are located SW of Karakuni-dake and at its far eastern end, respectively.  Holocene eruptions have been concentrated along an E-W line of vents from Mi-ike to Ohachi, and at Shinmoe-dake to the NE.  Frequent small-to-moderate explosive eruptions have been recorded since the 8th century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-09=&amp;volpage=photos&amp;photo=089054">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-09=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://hakone.eri.u-tokyo.ac.jp/vrc/others/kiri.html">Kirishima Volcano Observatory</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(31.931000000000001,130.864)
521	Fukue-jima	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Fukue-jima</b></font><br /><font size="5"><b>Kyushu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110042.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 317 m<br /><b>Latitude:</b> 32.653&deg;N<br /><b>Longitude:</b> 128.851&deg;E</td></tr><tr><td colspan="2"><p align="justify">A group of small olivine basaltic shield volcanoes and cinder cones lies at the eastern end of Fukue-jima in the Goto Islands off the western coast of Kyushu.  Activity at the Fukue volcano group began about 900,000 years ago, and the latest activity took place about 2000-3000 years ago (Nakano et al., 2001-).  The volcano group is one of the active volcanoes monitored by the Japan Meteorological Agency.  The volcanic field, whose high point (On-dake cinder cone) is only 317 m above sea level, forms peninsulas at the eastern and SE tips of Fukue Island as well as several smaller islands SE of Fukue.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-091&amp;volpage=photos&amp;photo=110042">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-091">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(32.652999999999999,128.851)
522	Unzen	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unzen</b></font><br /><font size="5"><b>Kyushu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/013090.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1500 m<br /><b>Latitude:</b> 32.757&deg;N<br /><b>Longitude:</b> 130.294&deg;E</td></tr><tr><td colspan="2"><p align="justify">The massive Unzen volcanic complex comprises much of the Shimabara Peninsula east of the city of Nagasaki.  A 30-40-km-long, E-W-trending graben extends across the peninsula.  Three large stratovolcanoes with complex structures, Kinugasa on the north, Fugen-dake at the east-center, and Kusenbu on the south, form topographic highs on the broad peninsula.  Fugen-dake and Mayu-yama volcanoes in the east-central portion of the andesitic-to-dacitic Unzen volcanic complex have been active during the Holocene.  The Mayu-yama lava dome complex, located along the eastern coast west of Shimabara City, formed about 4000 years ago and was the source of a devastating 1792 AD debris avalanche and tsunami.  Historical eruptive activity has been restricted to the summit and flanks of Fugen-dake.  The latest activity during 1990-95 formed a lava dome at the summit, accompanied by pyroclastic flows that caused fatalities and damaged populated areas near Shimabara City.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-10=&amp;volpage=photos&amp;photo=013090">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-10=">Smithsonian Volcano Information</a></td><td width="33%"><a href="www.sevo.kyushu-u.ac.jp/index-e.html">Shimabara Earthquake and Volcano Observatory</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(32.756999999999998,130.29400000000001)
523	Aso	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Aso</b></font><br /><font size="5"><b>Kyushu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/019098.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1592 m<br /><b>Latitude:</b> 32.881&deg;N<br /><b>Longitude:</b> 131.106&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 24-km-wide Aso caldera was formed during four major explosive eruptions from 300,000 to 90,000 years ago.  These produced voluminous pyroclastic flows that covered much of Kyushu.  The last of these, the Aso-4 eruption, produced more than 600 cu km of airfall tephra and pyroclastic-flow deposits.  A group of 17 central cones was constructed in the middle of the caldera, one of which, Naka-dake, is one of Japan's most active volcanoes.  It was the location of Japan's first documented historical eruption in 553 AD.  The Naka-dake complex has remained active throughout the Holocene.  Several other cones have been active during the Holocene, including the Kometsuka scoria cone as recently as about 210 AD.   Historical eruptions have largely consisted of basaltic to basaltic-andesite ash emission with periodic strombolian and phreatomagmatic activity.  The summit crater of Naka-dake is accessible by toll road and cable car, and is one of Kyushu's most popular tourist destinations.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-11=&amp;volpage=photos&amp;photo=019098">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-11=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://w3.vgs.kyoto-u.ac.jp/menu/menujp.html">Aso Volcanological Laboratory</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(32.881,131.10599999999999)
524	Kuju	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kuju</b></font><br /><font size="5"><b>Kyushu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/087061.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1791 m<br /><b>Latitude:</b> 33.083&deg;N<br /><b>Longitude:</b> 131.251&deg;E</td></tr><tr><td colspan="2"><p align="justify">Kuju volcano is a complex of stratovolcanoes and lava domes lying NE of Aso caldera in north-central Kyushu.  The Kuju volcano group consists of 16 andesitic lava domes, five andesitic stratovolcanoes, and one basaltic cone.  Activity at the Kuju group dates back to about 150,000 years.  Six major andesitic-to-dacitic tephra deposits, many associated with the growth of lava domes, have been recorded during the Holocene.  Eruptive activity has migrated systematically eastward during the past 5000 years.  The latest magmatic activity occurred about 1600 years ago, when Kuro-dake lava dome at the eastern end of the complex was formed.  The first reports of historical eruptions were in the 17th and 18th centuries, when phreatic or hydrothermal activity occurred.   Many hot springs and hydrothermal fields are located at the Kuju complex.  A fumarole on Hosho lava dome was the site of a sulfur mine for at least 500 years.  Two geothermal power plants are in operation at Kuju.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-12=&amp;volpage=photos&amp;photo=087061">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-12=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(33.082999999999998,131.251)
525	Tsurumi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tsurumi</b></font><br /><font size="5"><b>Kyushu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/064050.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1584 m<br /><b>Latitude:</b> 33.28&deg;N<br /><b>Longitude:</b> 131.432&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Tsurumi lava dome complex rises above the noted hot spring resort city of Beppu on Japan's Inland Sea.  Two large lava domes, Tsurumi and Yufu, are located at the east and west sides of the complex, respectively.  Three smaller lava domes are located on the north flank of the Tsurumi dome.  The latest activity at both the andesitic-to-dacitic Tsurumi and Yufu groups postdates the 6300-years-old Akahoya ash from Kikai volcano.  Pyroclastic flows dominated during older eruptions, whereas lava domes and lava flows are most common in more recent eruptions.  An eruption about 2200 years ago from Yufu-dake volcano began with collapse of the northern flank that produced a debris avalanche and was followed by lava dome growth and associated pyroclastic flows.  Only a single eruption, from Tsurumi in 867 AD, is known in historical time.  The colorful hot spring pools and mudpots of Beppu along the coast form one of Japan's most noted thermal areas.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-13=&amp;volpage=photos&amp;photo=064050">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0802-13=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(33.280000000000001,131.43199999999999)
526	Abu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Abu</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/089052.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 641 m<br /><b>Latitude:</b> 34.50&deg;N<br /><b>Longitude:</b> 131.60&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Abu volcano group, located along the Japan Sea coast near the SW end of Honshu, consists of basaltic-to-dacitic lava flows, small shield volcanoes (some of which have associated cinder cones) and lava domes.  More than 40 monogenetic volcanoes are located in area of 400 sq km.  Irao-yama at 641 m forms the high point of this group of small volcanic edifices, some of which form offshore islands.  Volcanism here is considered to be related to subduction of the Philippine Sea Plate.  An earlier phase of activity at the dominantly Pleistocene Abu volcano group during the late-Pliocene to early Pleistocene was followed by renewed activity about 800,000 years ago that continued into the Holocene.  The latest dated eruption took place about 3400 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-001&amp;volpage=photos&amp;photo=089052">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-001">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(34.5,131.59999999999999)
527	Sanbe	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sanbe</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/086074.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> 1126 m<br /><b>Latitude:</b> 35.13&deg;N<br /><b>Longitude:</b> 132.62&deg;E</td></tr><tr><td colspan="2"><p align="justify">Sanbe stratovolcano in SW Honshu, along the Japan Sea coast, is also known as Sambe volcano.  The summit of Sanbe is cut by a small caldera about 1 km in diameter.  The highest point on the dacitic-to-andesitic volcano is 1126-m-high O-Sanbe, at the northern end of the complex.  Sanbe has had several large explosive eruptions during the Pleistocene and one strong Holocene eruption from Taihei-zan lava dome about 3700 years ago.  This eruption was accompanied by pyroclastic flows that swept down the NE-to-SE flanks and traveled 9 km down the Hayamizu River to the SW.  Younger, undated eruptions have also occurred (Machida and Arai, 1992).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-002&amp;volpage=photos&amp;photo=086074">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-002">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(35.130000000000003,132.62)
528	Oki-Dogo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Oki-Dogo</b></font><br /><font size="5"><b>West of Honshu (Japan)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/105056.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Cinder cone</td><td width="50%" align="left"><b>Summit Elev:</b> 151 m<br /><b>Latitude:</b> 36.176&deg;N<br /><b>Longitude:</b> 133.334&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Oki-Dogo islands, north of the SW Honshu city of Matsue, are one of several locations of Holocene volcanism on islands of the Japan Sea off the west coast of Japan.  The Oki-Dogo islands are largely Pleistocene in age, and dated rocks range from about 800,000 to 300,000 years old.  Tomita (1969) described a shield volcano and cinder cone that have produced Holocene basalts.  The alkaline basalts on Oki-Dogo are related to the opening of the Japan Sea and contain abundant mantle-derived xenoliths.  The Daimanji-san lava flow overlies alluvial gravel containing an ancient water-jar.  The name Takuhi-yama (&quot;Burning Mountain&quot;) may record a tradition of an eruption.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-003&amp;volpage=photos&amp;photo=105056">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-003">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(36.176000000000002,133.334)
529	Izu-Tobu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Izu-Tobu</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/105029.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Submarine volcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1406 m<br /><b>Latitude:</b> 34.900&deg;N<br /><b>Longitude:</b> 139.098&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Izu-Tobu volcano group (Higashi-Izu volcano group) is scattered over a broad, plateau-like area of more than 400 sq km on the east side of the Izu Peninsula.  Construction of several stratovolcanoes continued throughout much of the Pleistocene and overlapped with growth of smaller monogenetic volcanoes beginning about 300,000 years ago.  About 70 subaerial monogenetic volcanoes formed during the last 140,000 years, and chemically similar submarine cones are located offshore.  These volcanoes are located on a basement of late-Tertiary volcanic rocks and related sediments and on the flanks of three Quaternary stratovolcanoes: Amagi, Tenshi, and Usami.  Some eruptive vents are controlled by NW-SE- or NE-SW-trending fissure systems.  Thirteen eruptive episodes have been documented during the past 32,000 years.  Kawagodaira maar produced pyroclastic flows during the largest Holocene eruption about 3000 years ago.  The latest eruption occurred in 1989, when a small submarine crater was formed NE of Ito City.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-01=&amp;volpage=photos&amp;photo=105029">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(34.899999999999999,139.09800000000001)
530	Hakone	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hakone</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/014011.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1438 m<br /><b>Latitude:</b> 35.230&deg;N<br /><b>Longitude:</b> 139.024&deg;E</td></tr><tr><td colspan="2"><p align="justify">Hakone volcano is truncated by two overlapping calderas, the largest of which is 10 x 11 km wide.  The calderas were formed as a result of two major explosive eruptions about 180,000 and 49,000-60,000 years ago.  Scenic Lake Ashi lies between the SW caldera wall and a half dozen post-caldera lava domes that were constructed along a SW-NE trend cutting through the center of the calderas.  Dome growth occurred progressively to the south, and the largest and youngest of these, Kami-yama, forms the high point of Hakone.  The calderas are breached to the east by the Haya-kawa canyon.  A phreatic explosion about 3000 years ago was followed by collapse of the NW side of Kami-yama, damming the Haya-kawa valley and creating Lake Ashi.  The latest magmatic eruptive activity at Hakone about 2900 years ago produced a pyroclastic flow and a lava dome in the explosion crater, although phreatic eruptions took place as recently as the 12-13th centuries AD.  Seismic swarms have occurred at Hakone during the 20th century.   Lake Ashi, along with major thermal areas in the caldera, forms a popular resort area SW of Tokyo.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-02=&amp;volpage=photos&amp;photo=014011">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(35.229999999999997,139.024)
531	Fuji	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Fuji</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/020009.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3776 m<br /><b>Latitude:</b> 35.358&deg;N<br /><b>Longitude:</b> 138.731&deg;E</td></tr><tr><td colspan="2"><p align="justify">The conical form of Fuji-san, Japan's highest and most noted volcano, belies its complex origin.  The modern postglacial stratovolcano is constructed above a group of overlapping volcanoes, remnants of which form irregularities on Fuji's profile.  Growth of the Younger Fuji volcano began with a period of voluminous lava flows from 11,000 to 8000 years before present (BP), accounting for four-fifths of the volume of the Younger Fuji volcano.  Minor explosive eruptions dominated activity from 8000 to 4500 BP, with another period of major lava flows occurring from 4500 to 3000 BP.  Subsequently, intermittent major explosive eruptions occurred, with subordinate lava flows and small pyroclastic flows.  Summit eruptions dominated from 3000 to 2000 BP, after which flank vents were active.  The extensive basaltic lava flows from the summit and some of the more than 100 flank cones and vents blocked drainages against the Tertiary Misaka Mountains on the north side of the volcano, forming the Fuji Five Lakes, popular resort destinations.  The last confirmed eruption of this dominantly basaltic volcano in 1707 was Fuji's largest during historical time.  It deposited ash on Edo (Tokyo) and formed a large new crater on the east flank.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-03=&amp;volpage=photos&amp;photo=020009">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(35.357999999999997,138.73099999999999)
532	Kita Yatsuga-take	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kita Yatsuga-take</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/089031.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2530 m<br /><b>Latitude:</b> 36.10&deg;N<br /><b>Longitude:</b> 138.30&deg;E</td></tr><tr><td colspan="2"><p align="justify">Kita-Yatsuga-take (North Yatsuga-take) is a group of stratovolcanoes and lava domes at the NW end of the NNW-SSE-trending Yatsuga-take volcanic massif.  The basaltic-to-dacitic Kita Yatsuga-take volcanic group contains the Tateshina, Yoko-dake, Shimagare-yama, Chausu-yama and Futago-mine volcanoes.  Tateshina-yama is sometimes known as Suwa Fuji because of its conical profile.  A large lava flow forms the Tateshina-kogen plateau south of Tateshina and Yoko-dake volcanoes.  A debris avalanche from edifice collapse in 888 AD created Matsubara Lake on the east side of the massif.  Yoko-dake lava dome, capped by eight small craters, has been active into the Holocene.  The most recent eruption took place about 800 years ago, when ash emission accompanied emplacement of a small lava flow.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-031&amp;volpage=photos&amp;photo=089031">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-031">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(36.100000000000001,138.30000000000001)
533	On-take	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>On-take</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/105057.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 3063 m<br /><b>Latitude:</b> 35.890&deg;N<br /><b>Longitude:</b> 137.48&deg;E</td></tr><tr><td colspan="2"><p align="justify">The massive On-take stratovolcano, the second highest volcano in Japan, lies at the southern end of  the Northern Japan Alps.  On-take is constructed within a largely buried 4 x 5 km caldera and occupies the southern end of the Norikura volcanic zone, which extends northward through Norikura volcano to Yake-dake volcano.  The older volcanic complex consisted of at least four major stratovolcanoes constructed from about 680,000 to about 420,000 years ago, after which On-take was inactive for more than 300,000 years.  The broad, elongated summit of the younger edifice is cut by a series of small explosion craters along a NNE-trending line.  Several phreatic eruptions from On-take post-date the roughly 7300-year-old Akahoya tephra from Kikai caldera.  On-take's first historical eruption took place in 1979.  A non-eruptive landslide in 1984 produced a debris avalanche and lahar that swept down valleys south and east of the volcano.  Ascent of the 3063-m-high On-take is one of the major objects of religious pilgrimage in central Japan.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-04=&amp;volpage=photos&amp;photo=105057">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-04=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(35.890000000000001,137.47999999999999)
534	Haku-san	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Haku-san</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/058011.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2702 m<br /><b>Latitude:</b> 36.152&deg;N<br /><b>Longitude:</b> 136.774&deg;E</td></tr><tr><td colspan="2"><p align="justify">Haku-san, along with Fuji-san and On-take, is one of Japan's three most sacred mountains.  It is a complex andesitic-dacitic stratovolcano overlooking the Japan Sea.  The 2702-m-high Haku-san was constructed over a high basement of sedimentary rocks in a region of very heavy snowfall that has contributed to erosional dissection.   Holocene eruptions have consisted of phreatic or phreatomagmatic explosions from several summit craters.  Partial collapse of the summit produced a debris avalanche down the east flank during the mid-Holocene.  Historical eruptions were recorded over almost a thousand-year period until the 17th century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-05=&amp;volpage=photos&amp;photo=058011">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-05=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(36.152000000000001,136.774)
535	Norikura	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Norikura</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/014058.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 3026 m<br /><b>Latitude:</b> 36.103&deg;N<br /><b>Longitude:</b> 137.557&deg;E</td></tr><tr><td colspan="2"><p align="justify">Norikura volcano consists of an elongated group of small andesitic stratovolcanoes and craters arranged along a N-S line above a ridge crest in the southern part of the Northern Japan Alps.  The 3026-m-high andesitic-to-dacitic volcano is the third highest in Japan and lies at the center of the Norikura volcanic zone extending from Yake-dake on the north to On-take on the south.  Early eruptions occurred at both the northern and southern ends of the present-day volcano, forming stratovolcanoes that have been largely buried by later southward-migrating eruptions.  Norilura-ake was active during the early Holocene, and the last eruption took place about 2000 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-06=&amp;volpage=photos&amp;photo=014058">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-06=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(36.103000000000002,137.55699999999999)
536	Yake-dake	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Yake-dake</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/014056.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2455 m<br /><b>Latitude:</b> 36.224&deg;N<br /><b>Longitude:</b> 137.590&deg;E</td></tr><tr><td colspan="2"><p align="justify">Yake-dake rises above the popular resort of Kamikochi in the Northern Japan Alps.  The small dominantly andesitic stratovolcano, one of several Japanese volcanoes named Yake-dake or Yake-yama (&quot;Burning Peak&quot; or &quot;Burning Mountain&quot;), was constructed astride a N-S-trending ridge between the older volcanoes of Warudani-yama and Shiratani-yama.  Akandana-yama, about 4 km SSW of Yake-dake, is a stratovolcano with lava domes that was active into the Holocene.   A 300-m-wide crater is located the summit of Yake-dake, and explosion craters are found on the SE and northern flanks.  Frequent small-to-moderate phreatic eruptions have occurred during the 20th century.  On February 11, 1995, a hydrothermal explosion in a geothermal area killed two persons at a highway construction site.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-07=&amp;volpage=photos&amp;photo=014056">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-07=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(36.223999999999997,137.59)
537	Washiba-Kumonotaira	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Washiba-Kumonotaira</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/105036.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes ?</td><td width="50%" align="left"><b>Summit Elev:</b> 2924 m<br /><b>Latitude:</b> 36.408&deg;N<br /><b>Longitude:</b> 137.594&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Washiba-Kumonotaira volcano group consists of a cluster of small shield volcanoes with possible lava domes in a remote area in Chubu Sangaku National Park in the heart of the Northern Japan Alps.  Iwagokekodani, an older Kumonotaira volcano was active from about 1-0.9 million years (Ma) .  The younger Kumonotaira volcano was active about  0.3-0.1 Ma.  Washiba-ike volcano is younger than 0.12 Ma (Nakano et al., 2001-).  Hayakawa (2009 pers. comm.) indicated that the Washiba-ike explosion crater was formed in an area that post-dates the latest Pleistocene glaciation, and produced a tephra layer consisting of accretionary lapilli and fresh volcanic bombs.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-071&amp;volpage=photos&amp;photo=105036">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-071">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(36.408000000000001,137.59399999999999)
538	Tate-yama	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tate-yama</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/089048.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera (erosion)<br />&nbsp;&nbsp;&nbsp; Explosion craters</td><td width="50%" align="left"><b>Summit Elev:</b> 2621 m<br /><b>Latitude:</b> 36.568&deg;N<br /><b>Longitude:</b> 137.593&deg;E</td></tr><tr><td colspan="2"><p align="justify">Tate-yama volcano is a dissected andesitic-to-dacitic stratovolcano on a plateau surrounded by high peaks of the North Japan Alps.  Tate-yama is named for the granite-and-gneiss peak of Tate-yama, which lies immediately to the east.  Formation of a 4-km-wide erosional caldera was followed by repeated eruptions of lava and pyroclastics forming the Midagahara plateau that was later dissected by the Yu-kawa river.  Holocene eruptions have been restricted to small phreatic explosions that formed craters.  A minor historical eruption occurred in the 19th century.  An earthquake swarm took place in 1990.  Hot springs occur in seven locations on the floor of the poorly defined erosional caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-08=&amp;volpage=photos&amp;photo=089048">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-08=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(36.567999999999998,137.59299999999999)
539	Niigata-Yake-yama	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Niigata-Yake-yama</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/064058.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava dome<br />&nbsp;&nbsp;&nbsp; Explosion craters</td><td width="50%" align="left"><b>Summit Elev:</b> 2400 m<br /><b>Latitude:</b> 36.918&deg;N<br /><b>Longitude:</b> 138.039&deg;E</td></tr><tr><td colspan="2"><p align="justify">Niigata-Yake-yama, one of several Japanese volcanoes named Yake-yama (&quot;Burning Mountain&quot;), is a very young andesitic-to-dacitic lava dome in Niigata prefecture in central Honshu, near the Japan Sea.  The small volcano rises to 2400 m and was constructed on a base of Tertiary mountains 2000 m high beginning about  3100 years ago.  Three major magmatic eruptions took place in historical time, producing pyroclastic flows and surges and lava flows that traveled mainly down the Hayakawa river valley to the north and NW.  The first of these eruptions took place about 1000 years ago (in 887 and possibly 989 AD) and produced the Hayakawa pyroclastic flow, which traveled about 20 km to reach the Japan Sea, and the massive Mae-yama lava flow, which traveled about 6.5 km down the Hayakawa river valley.  The summit lava dome was emplaced during the 1361 eruption, and the last magmatic eruption took place in 1773 AD.  Eruptive activity since 1773 has consisted of relatively minor phreatic explosions from several radial fissures and explosion craters that cut the summit and flanks of the dome.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-09=&amp;volpage=photos&amp;photo=064058">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-09=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(36.917999999999999,138.03899999999999)
540	Myoko	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Myoko</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/064045.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 2446 m<br /><b>Latitude:</b> 36.888&deg;N<br /><b>Longitude:</b> 138.12&deg;E</td></tr><tr><td colspan="2"><p align="justify">Myoko is a steep-sided stratovolcano north of Nagano City that overlooks the popular resort of Lake Nojiri below its SE flank.   A  3-km-wide caldera breached widely to the east is filled by a flat-topped lava dome that forms the basaltic-to-dacitic volcano's summit.  Myoko volcano was constructed during four stages beginning about 300,000 years ago, each evolving from basaltic to andesitic and dacitic eruptions.  The latest eruptive stage began about 43,000 years ago.  Several episodes of edifice collapse at Myoko during the late Pleistocene to early Holocene have produced major debris avalanches that traveled to the east and NE.  Myoko produced pyroclastic flows down the eastern flanks of the volcano during the mid Holocene about 5800 and 4200 years ago, and the latest dated eruption produced pyroclastic surges about 2800-2500 years ago.   No historical eruptions are known at Myoko, but constant solfataric activity occurs between the dome and the south caldera wall at a place where sulfur was once mined.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-10=&amp;volpage=photos&amp;photo=064045">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-10=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(36.887999999999998,138.12)
541	Asama	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Asama</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/014065.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2568 m<br /><b>Latitude:</b> 36.403&deg;N<br /><b>Longitude:</b> 138.526&deg;E</td></tr><tr><td colspan="2"><p align="justify">Asama, Honshu's most active volcano, overlooks the resort town of Karuizawa, 140 km NW of Tokyo.  The volcano is located at the junction of the Izu-Marianas and NE Japan volcanic arcs.  The modern cone of Maekake-yama forms the summit of the volcano and is situated east of the horseshoe-shaped remnant of an older andesitic volcano, Kurofu-yama, which was destroyed by a late-Pleistocene landslide about 20,000 years before present (BP).  Growth of a dacitic shield volcano was accompanied by pumiceous pyroclastic flows, the largest of which occurred about 14,000-11,000 years BP, and by growth of the Ko-Asama-yama lava dome on the east flank.  Maekake-yama, capped by the Kama-yama pyroclastic cone that forms the present summit of the volcano, is probably only a few thousand years old and has an historical record dating back at least to the 11th century AD.  Maekake-yama has had several major plinian eruptions, the last two of which occurred in 1108 (Asama's largest Holocene eruption) and 1783 AD.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-11=&amp;volpage=photos&amp;photo=014065">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-11=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://hakone.eri.u-tokyo.ac.jp/vrc/others/asama.html">Asama Volcano Observatory</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(36.402999999999999,138.52600000000001)
542	Kusatsu-Shirane	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kusatsu-Shirane</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/014096.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 2171 m<br /><b>Latitude:</b> 36.620&deg;N<br /><b>Longitude:</b> 138.535&deg;E</td></tr><tr><td colspan="2"><p align="justify">The summit of Kusatsu-Shirane volcano, located immediately north of Asama volcano, consists of a series of overlapping pyroclastic cones and three crater lakes.  The andesitic-to-dacitic volcano was formed in three eruptive stages beginning in the early to mid Pleistocene.  The Pleistocene Oshi pyroclastic flow produced extensive welded tuffs and non-welded pumice that covers much of the east, south and SW flanks.  The latest eruptive stage began about 14,000 years ago.  All historical eruptions have consisted of phreatic explosions from the acidic crater lakes or their margins.  Fumaroles and hot springs that dot the volcano's flanks have strongly acidified many rivers draining from the volcano.  The crater was the site of active sulfur mining for many years during the 19th and 20th centuries.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-12=&amp;volpage=photos&amp;photo=014096">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-12=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(36.619999999999997,138.535)
543	Haruna	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Haruna</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/020021.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1449 m<br /><b>Latitude:</b> 36.474&deg;N<br /><b>Longitude:</b> 138.881&deg;E</td></tr><tr><td colspan="2"><p align="justify">Haruna volcano is truncated by a small summit caldera containing the symmetrical post-caldera pyroclastic cone of Haruna-Fuji.  Haruna-san volcano dates back prior to 300,000 years ago and had caldera-producing eruptions at about 200,000 and 40,000 years ago.  Viscous lava flows and lava domes were subsequently extruded within and around the caldera, the western side of which is currently partially filled by Lake Haruna.  The Futatsu-dake lava dome east of the caldera was the source of two large explosive eruptions during the 6th century AD.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-122&amp;volpage=photos&amp;photo=020021">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-122">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(36.473999999999997,138.881)
544	Hiuchi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hiuchi</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/105021.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2356 m<br /><b>Latitude:</b> 36.952&deg;N<br /><b>Longitude:</b> 139.289&deg;E</td></tr><tr><td colspan="2"><p align="justify">Hiuchi volcano lies in Nikko National Park and erupted the 8 cu km Hiuchigatake-Nanairi tephra and pyroclastic flow deposit about 170,00-160,000 years ago.  Two lava domes at the southern end of the summit of Hiuchi stratovolcano overlook Ozenuma lake, a popular hiking destination in the national park.  The southern of the two domes, Akanagure, produced a series of viscous lava flows about 3500 years ago that extend to the southern and western flanks the volcano.  The northern dome, Mi-ike, was the source of a tephra layer correlated with a report of historical activity in 1544 (Hayakawa, 1994b).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-131&amp;volpage=photos&amp;photo=105021">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-131">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(36.951999999999998,139.28899999999999)
545	Nikko-Shirane	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Nikko-Shirane</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/020026.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2578 m<br /><b>Latitude:</b> 36.796&deg;N<br /><b>Longitude:</b> 139.379&deg;E</td></tr><tr><td colspan="2"><p align="justify">Nikko-Shirane is a relatively small, 2578-m-high andesitic volcano consisting of a group of four lava domes resting on a shield volcano that rises to the NW of scenic Lake Chuzenji in Nikko National Park.  All historical eruptions, recorded during the 17th-20th centuries, have consisted of phreatic explosions from Shirane-san, the youngest lava dome.  Viscous lava flows with prominent levees from the underlying shield volcano Keizuka-yama were responsible for the formation of several scenic lakes north of the volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-14=&amp;volpage=photos&amp;photo=020026">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-14=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(36.795999999999999,139.37899999999999)
546	Omanago Group	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Omanago Group</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/020027.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2367 m<br /><b>Latitude:</b> 36.792&deg;N<br /><b>Longitude:</b> 139.510&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Omanago volcano group consists of a series of five closely spaced lava domes that were constructed north and NW of Nantai volcano in Nikko National Park.  The highest of the dacitic domes is 2367-m-high Omanago, which later erupted andesitic lavas.  Mitsu-dake lava dome, which overlooks the hot spring resort of Lake Yunoko, was radioarbon dated at about 5000 years ago.  Mitsu-dake was constructed on a southerly dipping slope, so that the southern of its two flat-topped domes is lower, and is overlapped by sediments of the Senjogahara plain.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-142&amp;volpage=photos&amp;photo=020027">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-142">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(36.792000000000002,139.50999999999999)
547	Takahara	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Takahara</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/089027.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1795 m<br /><b>Latitude:</b> 36.897&deg;N<br /><b>Longitude:</b> 139.780&deg;E</td></tr><tr><td colspan="2"><p align="justify">Takahara is a small stratovolcano with lava domes located SW of Nasu volcano and NNW of Utsunomiya city in central Honshu.  The basaltic-to-dacitic volcano lies within the Shiobara caldera, which was formed during the late Pleistocene at the time of the eruption of the Otawara pumice-flow deposit.  The latest dated eruption of Takahara took place about 6500 years ago along the NW-SE-trending Yumoto-Shiobara fissure system within the caldera.  Eruptions along this fissure initially produced the phreatic Takahara-Uenohara tephra deposit, which was distributed primarily to the east.  The symmetrical Fuji-san lava dome, one of many conical volcanoes named after Japan's renowned Mount Fuji, was extruded at the end of the eruption.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-143&amp;volpage=photos&amp;photo=089027">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-143">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(36.896999999999998,139.78)
548	Nasu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Nasu</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/064051.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1915 m<br /><b>Latitude:</b> 37.122&deg;N<br /><b>Longitude:</b> 139.966&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Nasu volcanic group consists of a N-S-trending cluster of stratovolcanoes and lava domes at the north end of the Kanto Plain.  Nasu volcanic activity dates back about 500,000 years.  Growth of three large basaltic-to-dacitic stratovolcanoes with life spans of about 200,000 years was followed by construction of three smaller andesitic stratovolcanoes, Asahi-dake, Futamata-yama, and Chausu-dake.  Activity during the last 55,000 years included the collapse of Asahi-dake volcano about 30-40,000 years ago producing the massive Ofuji-san debris-avalanche deposit, which blankets a broad area SE of the volcano.  The youngest volcano, Chausu-dake, began forming about 16,000 years ago.  Six magmatic eruptions took place since then, the latest in 1408-1410, when the youngest summit lava dome, Chausu-dake, was formed.  These eruptions produced block-and-ash flows and concluded with the extrusion of lava flows.  Smaller phreatic eruptions have occurred every few hundred years during the past 5000 years.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-15=&amp;volpage=photos&amp;photo=064051">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-15=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(37.122,139.96600000000001)
549	Numazawa	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Numazawa</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/105055.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1100 m<br /><b>Latitude:</b> 37.450&deg;N<br /><b>Longitude:</b> 139.579&deg;E</td></tr><tr><td colspan="2"><p align="justify">Numazawa is a small, 2-km-wide dominantly dacitic-to-rhyolitic caldera constructed within an older Pliocene caldera.  Eruptions of the 110,00 yrs Before Present (BP) rhyolitic Shibahara pyroclastic-fall deposit and the 71,000 BP dacitic Mukuresawa lava dome were followed by the dacitic plinian Mizunuma eruption about 45,000 years before present (BP), emplacement of the Sozan lava dome at 43,000 BP and the So-zan lava dome at about 20,000 BP.  The Numazawako pumice flow and plinian eruption about 4600 years BP resulted in formation of the 1.5 x 2 km Numazawako caldera, now largely filled by a caldera lake.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-151&amp;volpage=photos&amp;photo=105055">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-151">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(37.450000000000003,139.57900000000001)
550	Bandai	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bandai</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/020045.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 1819 m<br /><b>Latitude:</b> 37.598&deg;N<br /><b>Longitude:</b> 140.076&deg;E</td></tr><tr><td colspan="2"><p align="justify">One of Japan's most noted volcanoes, Bandai-san rises above the north shore of Lake Inawashiro.  The Bandai complex is formed of several overlapping andesitic stratovolcanoes, the largest of which is O-Bandai.  Ko-Bandai volcano, which collapsed in 1888, was formed about 50,000 years ago.  O-Bandai volcano was constructed within a horseshoe-shaped caldera that formed about 40,000 years when an older volcano collapsed, forming the Okinajima debris avalanche, which traveled to the SW and was accompanied by a plinian explosive eruption.  The last magmatic eruption at Bandai took place more than 25,000 years ago, but four major phreatic eruptions have occurred during the past 5000 years, two of them in historical time, in 806 and 1888.  Seen from the south, Bandai presents a conical profile, but much of the north side of the volcano is missing as a result of the collapse of Ko-Bandai volcano during the 1888 eruption, in which a debris avalanche buried several villages and formed several large lakes.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-16=&amp;volpage=photos&amp;photo=020045">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-16=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(37.597999999999999,140.07599999999999)
551	Adatara	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Adatara</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/020055.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1718 m<br /><b>Latitude:</b> 37.644&deg;N<br /><b>Longitude:</b> 140.286&deg;E</td></tr><tr><td colspan="2"><p align="justify">The broad forested massif of Adatara volcano is located east of Bandai volcano, about 15 km SW of Fukushima city.  Adatara consists of a group of dominantly andesitic stratovolcanoes and lava domes that rise above Tertiary rocks on the south and abut Azuma volcano on the north.  Adatara was constructed in three main stages that began about 550,000, 350,000, and 200,000 years ago.  The high point of the complex is 1718-m-high Minowa-yama, a dome-shaped stratovolcano north of Tetsu-zan, the currently active stratovolcano.  Numanotaira, the active summit crater, is surrounded by hot springs and fumaroles and is breached by the Io-gawa river (&quot;Sulfur River&quot;) on the west.  Seventy-two workers of a sulfur mine in the summit crater were killed during an eruption in 1900.  Historical eruptions have been restricted to the 1.2-km-wide, 350-m-deep Numonotaira crater.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-17=&amp;volpage=photos&amp;photo=020055">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-17=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(37.643999999999998,140.286)
552	Azuma	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Azuma</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/020056.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2035 m<br /><b>Latitude:</b> 37.732&deg;N<br /><b>Longitude:</b> 140.248&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Azuma volcanic group consists of a cluster of stratovolcanoes, shield volcanoes, lava domes, and pyroclastic cones.  The andesitic and basaltic complex was constructed in two E-W rows above a relatively high basement of Tertiary sedimentary rocks and granodiorites west of Fukushima city.  Volcanic activity has migrated to the east, with the Higashi-Azuma volcano group being the youngest.  The symmetrical Azuma-Kofuji crater and a nearby fumarolic area on the flank of Issaikyo volcano are popular tourist destinations.  The Azuma complex contains several crater lakes, including Goshiki-numa and Oke-numa.  Historical eruptions, mostly small phreatic explosions, have been restricted to Issaikyo volcano at the northern end of the Higashi-yama group.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-18=&amp;volpage=photos&amp;photo=020056">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-18=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(37.731999999999999,140.24799999999999)
553	Zao	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Zao</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/105088.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1841 m<br /><b>Latitude:</b> 38.141&deg;N<br /><b>Longitude:</b> 140.443&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Zao volcano group, the most active of northern Honshu, consists of a complex cluster of stratovolcanoes straddling the Pacific Ocean-Japan Sea divide.  The Pleistocene Ryuzan volcano forms the western Zao group (Nishi-Zao), and Byobu and Fubo volcanoes form the southern Zao group (Minami-Zao).  The complex was constructed over granitic basement rocks as high as 1500 m and thus has a relatively small volume.  The 7 cu km Zao volcano proper forms the central ao group (Chuo-Zao), a volcanic complex topped by several lava domes and the Goshiki-dake tuff cone, aligned along a NW-SE trend.  Several episodes of edifice collapse produced debris avalanches during the Pleistocene.  Goshiki-dake contains the active Okama crater, filled with a colorful, strongly acidic crater lake (pH 1.3).  It has been the source of most of the frequent historical eruptions of Zao volcano, which date back to the 8th century AD.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-19=&amp;volpage=photos&amp;photo=105088">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-19=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(38.140999999999998,140.44300000000001)
554	Hijiori	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hijiori</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/105020.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 516 m<br /><b>Latitude:</b> 38.606&deg;N<br /><b>Longitude:</b> 140.178&deg;E</td></tr><tr><td colspan="2"><p align="justify">Hijiori caldera is a small, inconspicuous caldera located NE of the massive Pleistocene Gassan volcano.  The low 2.5-km-wide caldera formed during a large eruption about 10,300 radiocarbon years ago.  This eruption was accompanied by dacitic pyroclastic flows and tephra fall that extended to the east and reached the Pacific coast and growth of a lava dome.  Small local tephra deposits overlie lacustrine deposits.  Hot springs occur at Hijiori, and caldera lake deposits have undergone extensive hydrothermal alteration.  Hijiori has been evaluated as a potential geothermal energy source using hot dry rock as a heat source.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-191&amp;volpage=photos&amp;photo=105020">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-191">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(38.606000000000002,140.178)
555	Narugo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Narugo</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/105049.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 470 m<br /><b>Latitude:</b> 38.733&deg;N<br /><b>Longitude:</b> 140.732&deg;E</td></tr><tr><td colspan="2"><p align="justify">Narugo (also known as Naruko) is a poorly defined, 5.5 x 7 km caldera NW of the city of Sendai.  The caldera, formed during eruptions about 73,000 and 45,000 years ago, contains a cluster of four dacitic lava domes of Holocene age surrounding the 400-m-wide lake-filled Katanuma crater.  The highest of the low, but steep-sided lava domes, Oga-dake, lies SE of the lake and reaches only 470 m above sea level.  Oga-dake and Kurumiga-dake domes are capped by conglomerates and mudstones uplifted during dome growth.  The only known eruption at Narugo in historical time occurred in 837 AD.  Water vapor and sulfur-dioxide gas emission occurs from Shurado crater on Toyagamori lava dome west of the lake and from the bottom of the crater lake, which is one of the most acidic in Japan, with a pH of 1.6.   Solfataras are found on the western shore of Katanuma, and sulfur is mined from sediments on the lake floor.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-20=&amp;volpage=photos&amp;photo=105049">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-20=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(38.732999999999997,140.732)
556	Kurikoma	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kurikoma</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/105037.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1628 m<br /><b>Latitude:</b> 38.958&deg;N<br /><b>Longitude:</b> 140.792&deg;E</td></tr><tr><td colspan="2"><p align="justify">The summit of Kurikoma volcano is cut by a 4-km-wide caldera breached to the north that is partially filled by the Tsurugi-dake central cone, once mined for sulfur.  The complex andesitic-to-dacitic stratovolcano was constructed over a relatively high basement of welded and unwelded Tertiary dacitic tuffs and sedimentary rocks and thus has a smaller volume than its height suggests.  Early stage eruptions beginning about 500,000 years ago produced lava flows to the north and south, followed by growth of the Higashi-Kurikoma (East Kurikoma) stratovolcano.  Magusa-dake volcano on the western side of the complex was active until about 100,000 years ago.  Construction of the main cone concluded with lava flows to the east, SE, and west.  Daichigamori lava dome and Aguroshi-yama pyroclastic cone are located on the southern flank.  Minor phreatic eruptions have occurred in historical time from the central cone.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-21=&amp;volpage=photos&amp;photo=105037">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-21=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(38.957999999999998,140.792)
557	Chokai	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Chokai</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/020059.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2233 m<br /><b>Latitude:</b> 39.096&deg;N<br /><b>Longitude:</b> 140.052&deg;E</td></tr><tr><td colspan="2"><p align="justify">Massive Chokai volcano, the largest of NE Honshu, overlooks the Japan Sea.  Chokai is composed of two overlapping stratovolcanoes with a conical profile that has given it the local names Akita-Fuji or Dewa-Fuji.  The summit of the gently sloping western volcano (Nishi-Chokai) is cut by a large horseshoe-shaped caldera  breached to the south, whose floor contains lava domes.  The younger eastern volcano (Higashi-Chokai) began forming about 20,000 years ago.  It was cut by another large horseshoe-shaped caldera, breached to the north.  During an eruption about 2600 years ago it was the source of  the voluminous Kisakata debris avalanche, which reached the Pacific coast.  Two post-caldera lava domes have been constructed at the upper SE end of the caldera.  Intermittent reports of historical eruptions at Chokai date back to the 6th century AD.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-22=&amp;volpage=photos&amp;photo=020059">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-22=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(39.095999999999997,140.05199999999999)
558	Akita-Komaga-take	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Akita-Komaga-take</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/089022.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1637 m<br /><b>Latitude:</b> 39.758&deg;N<br /><b>Longitude:</b> 140.803&deg;E</td></tr><tr><td colspan="2"><p align="justify">Two calderas partially filled by basaltic cones cut the summit of Akita-Komaga-take volcano.  The larger southern caldera is 1.5 x 3 km wide and has a shallow sloping floor that is drained through a narrow gap cutting the SW caldera rim.  On its northern side the southern caldera borders a smaller more circular 1.2-km-wide caldera, whose rim is breached widely to the NE.  The two calderas were formed following explosive eruptions at the end of the Pleistocene, between about 13,500 and 11,600 years ago.  Two cones, Me-dake and Ko-dake, occupy the NE corner of the southern caldera, whose long axis trends NE-SW.  The highest point of the volcano is a cone within the northern caldera, 1637-m-high Komaga-take (also known as Omae-dake or Oname-dake), which has produced lava flows to the north and east and has a 100-m-wide summit crater.  Small-scale historical eruptions have occurred from cones and fissure vents inside the southern caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-23=&amp;volpage=photos&amp;photo=089022">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-23=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(39.758000000000003,140.803)
559	Iwate	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Iwate</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/020063.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2041 m<br /><b>Latitude:</b> 39.850&deg;N<br /><b>Longitude:</b> 141.004&deg;E</td></tr><tr><td colspan="2"><p align="justify">Viewed from the east, Iwate volcano has a symmetrical profile that invites comparison with Fuji, but on the west an older cone is visible containing an oval-shaped, 1.8 x 3 km caldera.  After the growth of Nishi-Iwate volcano beginning about 700,000 years ago, activity migrated eastward to form Higashi-Iwate volcano.  Iwate has collapsed seven times during the past 230,000 years, most recently between 739 and 1615 AD.  The dominantly basaltic summit cone of Higashi-Iwate volcano, Yakushi-dake, is truncated by a 500-m-wide crater.  It rises well above and buries the eastern rim of the caldera, which is breached by a narrow gorge on the NW.  A central cone containing a 500-m-wide crater partially filled by a lake is located in the center of the oval-shaped caldera.  A young lava flow from Yakushi-dake descended into the caldera, and a fresh-looking lava flow from the 1732 eruption traveled down the NE flank.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-24=&amp;volpage=photos&amp;photo=020063">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-24=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(39.850000000000001,141.00399999999999)
560	Hachimantai	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hachimantai</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/089016.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1614 m<br /><b>Latitude:</b> 39.955&deg;N<br /><b>Longitude:</b> 140.857&deg;E</td></tr><tr><td colspan="2"><p align="justify">The summit of Hachimantai volcano forms an undulating plateau surrounded by steep slopes.  Hachimantai was constructed from widely scattered vents during the Pleistocene and is capped with andesitic lavas from vents in the center of the complex.  Circular craters are located near Komono-more and Mokko-dake in the center of the plateau.  The craters are youthful looking, but have not been dated.  Hayakawa (1996, pers. comm.) considered Hachimantai to be of possible Holocene age.  No historical eruptions have been recorded, but active solfataras are found on the western and southern flanks.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-25=&amp;volpage=photos&amp;photo=089016">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-25=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(39.954999999999998,140.857)
561	Akita-Yake-yama	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Akita-Yake-yama</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/105002.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1366 m<br /><b>Latitude:</b> 39.961&deg;N<br /><b>Longitude:</b> 140.761&deg;E</td></tr><tr><td colspan="2"><p align="justify">One of several Japanese volcanoes named Yake-yama (&quot;Burning Mountain&quot;), Akita-Yake-yama is the most recently active of a group of coalescing volcanoes in NW Honshu immediately west of Hachimantai volcano.  The main volcano, Yake-yama, contains a small lava dome in its 600-m-wide summit crater.  Tsugamori volcano to the east is a stratovolcano of roughly the same height as Yake-yama and has a 2-km-wide crater breached to the NE.  The flat-topped parasitic lava dome of Kuroshimori lies 4 km south of Yake-dake.  Tamagawa Spa at the western foot, one of several thermal areas, is strongly radioactive.  The last magmatic eruption at Akita-Yake-yama formed the Onigajo lava dome in the summit crater about 5000 years ago.  The only known historical activity has consisted of somewhat uncertain 19th-century eruptions and mild phreatic eruptions in the 20th century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-26=&amp;volpage=photos&amp;photo=105002">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-26=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(39.960999999999999,140.761)
562	Megata	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Megata</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/105044.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 291 m<br /><b>Latitude:</b> 39.95&deg;N<br /><b>Longitude:</b> 139.73&deg;E</td></tr><tr><td colspan="2"><p align="justify">Megata, a group of three small maars along the tip of the Oga Peninsula in NW Honshu, has been active during the Holocene (Ishikawa et al., 1957).   Lakes 300-600 m wide fill the basaltic-to-dacitic maars, which are a noted locality for mantle-derived xenoliths.  Ichinomegata, the easternmost, largest, and oldest of the three maars, is 600 m in diameter.  Ninomegata and Sannomegata are located immediately east and south of Toga Bay (Togowan), which itself is a maar.  The rim of the rhyolitic Toga (Togowan) maar, larger than the Megata maars, is breached by the sea on the western side and was formed about 450,000 years ago. The Megata maars are mostly late Pleistocene in age, but Murayama (1987) noted that pottery from roughly 4000 years before present (Jomon Period) has been found within tephra layers from the maars.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-262&amp;volpage=photos&amp;photo=105044">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-262">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(39.950000000000003,139.72999999999999)
563	Iwaki	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Iwaki</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/108045.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1625 m<br /><b>Latitude:</b> 40.653&deg;N<br /><b>Longitude:</b> 140.307&deg;E</td></tr><tr><td colspan="2"><p align="justify">Iwaki volcano, symmetrical on all but its western flanks, has been called the Fuji-san of the Tsugaru district.  The 2-km-wide summit crater is filled by a lava dome flanked by six explosion craters.  Three lava domes are found on the western and southern flanks of the andesitic volcano, the NW-most active volcano in Honshu.   Historical eruptions have been reported at Iwaki since 1600 AD and have consisted primarily of small-to-moderate phreatic explosions.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-27=&amp;volpage=photos&amp;photo=108045">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-27=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(40.652999999999999,140.30699999999999)
564	Towada	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Towada</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/064052.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1159 m<br /><b>Latitude:</b> 40.47&deg;N<br /><b>Longitude:</b> 140.92&deg;E</td></tr><tr><td colspan="2"><p align="justify">The dramatic, 11-km-wide, lake-filled Towada caldera formed during as many as six major explosive eruptions over a 40,000-year period ending about 13,000 years ago.  Pre-caldera eruptive activity at Towada dates back to about 2 million years ago and produced basaltic-to-dacitic lava cones.  Following late-Pleistocene andesitic-to-rhyolitic caldera-forming eruptions, the basaltic Ninokura stratovolcano grew in the SSE section of the caldera.  The successive dacitic-to-rhyolitic Goshikiiwa explosive eruptions led to the formation of the roughly 2-km-wide Nakanoumi caldera, whose SW and NE rims form dramatic peninsulas extending into Lake Towada.  The andesitic-to-dacitic Ogura-yama lava dome was built over the NE rim of Nakanoumi.  The latest eruption of Towada took place in 915 AD, when eruptions from Ogura-yama produced widespread ashfalls and pyroclastic flows.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-271&amp;volpage=photos&amp;photo=064052">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-271">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(40.469999999999999,140.91999999999999)
565	Hakkoda Group	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hakkoda Group</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/056077.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1585 m<br /><b>Latitude:</b> 40.656&deg;N<br /><b>Longitude:</b> 140.881&deg;E</td></tr><tr><td colspan="2"><p align="justify">The basaltic-to-rhyolitic Hakkoda volcano includes 14 stratovolcanoes and lava domes south of Mutsu Bay at the northern end of Honshu.  The NE rim of an 8-km-wide Pleistocene caldera forms an arcuate ridge across a flat caldera-floor moat NE of the Hakkoda group volcanoes, which bury the SE caldera wall.  A northern group of volcanoes, constructed within the caldera, appears to be younger than the southern group.  Hakkoda-Odake, Ido-dake, and Tsurugi-dake have well-preserved craters.  Akakura-dake has a 1-km-wide explosion crater breached to the north.  No historical eruptions are known of the Hakkoda group, although an active solfatara occurs at Ido-dake, and hot springs are found at several locations within the caldera.  Three minor phreatic eruptions were documented from Jigoku-numa on the SW flank of Odake volcano from the 13th-17th centuries.  Three soldiers on a training mission in July 1997 were killed by inhalation of volcanic gas.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-28=&amp;volpage=photos&amp;photo=056077">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-28=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(40.655999999999999,140.881)
566	Osore-yama	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Osore-yama</b></font><br /><font size="5"><b>Honshu</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/105066.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 879 m<br /><b>Latitude:</b> 41.276&deg;N<br /><b>Longitude:</b> 141.124&deg;E</td></tr><tr><td colspan="2"><p align="justify">Osore-yama, on the Shimokita Peninsula in northernmost Honshu, contains a 5-km-wide caldera partly occupied by a shallow lake that drains through the north caldera wall.  Dissected lava domes ring the caldera floor.  The andesitic-to-dacitic Osore-yama is largely Pleistocene in age, with activity dating back about 800,000 years.  The last identified distal tephra deposit was erupted during the late Pleistocene.  The only report of historical activity was in a Tohoku district travel document published in 1787, which stated that Yake-yama in Mutsu country (Osore-yama) had erupted.  Older residents reported that large fires and clouds were sometimes seen from the summit, accounting for the volcano's local name, Yake-yama, or &quot;Burning Mountain&quot; (Murayama, 1987).  Earthquake swarms have been documented at Osore-yama during the second half of the 20th century, and magma bodies have been detected beneath the volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-29=&amp;volpage=photos&amp;photo=105066">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0803-29=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(41.276000000000003,141.124)
567	Oshima	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Oshima</b></font><br /><font size="5"><b>Izu Islands (Japan)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/090077.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 764 m<br /><b>Latitude:</b> 34.721&deg;N<br /><b>Longitude:</b> 139.398&deg;E</td></tr><tr><td colspan="2"><p align="justify">Oshima volcano in Sagami Bay, east of the Izu Peninsula, is the northernmost of the Izu Islands.  The broad, low stratovolcano forms an 11 x 13 km island and was constructed over the remnants of three dissected stratovolcanoes.  It is capped by a 4-km-wide caldera with a central cone, Mihara-yama, that has been the site of numerous historical eruptions.  More than 40 parasitic cones are located within the caldera and along two parallel rift zones trending NNW-SSE.  Although Oshima is a dominantly basaltic volcano, strong explosive activity has occurred at intervals of 100-150 years throughout the past few thousand years.  Historical activity at Oshima dates back to the 7th century AD.  A major eruption in 1986 produced spectacular lava fountains up to 1600 m height and a 16-km-high subplinian eruption column; more than 12,000 persons were evacuated from the island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-01=&amp;volpage=photos&amp;photo=090077">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(34.720999999999997,139.398)
568	To-shima	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>To-shima</b></font><br /><font size="5"><b>Izu Islands (Japan)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/105083.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 508 m<br /><b>Latitude:</b> 34.517&deg;N<br /><b>Longitude:</b> 139.283&deg;E</td></tr><tr><td colspan="2"><p align="justify">The small 2 x 2.4 km island of To-shima is located in the northern Izu Islands south of Oshima Island and lies about 20 km west of the main volcanic front.  Steep cliffs up to 300 m high ring the basaltic-to-basaltic andesite island on three sides.  The 508-m-high summit of the island is asymmetrically located opposite the more gentle slopes of the northern side of the island, where the village of To-shima is located.  The latest known eruption of To-shima stratovolcano occurred sometime between about 9000 and 4000 years ago, producing a lava flow from Kajiana crater.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-011&amp;volpage=photos&amp;photo=105083">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-011">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(34.517000000000003,139.28299999999999)
569	Nii-jima	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Nii-jima</b></font><br /><font size="5"><b>Izu Islands (Japan)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/089042.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Pumice cone</td><td width="50%" align="left"><b>Summit Elev:</b> 432 m<br /><b>Latitude:</b> 34.393&deg;N<br /><b>Longitude:</b> 139.273&deg;E</td></tr><tr><td colspan="2"><p align="justify">The elongated island of Nii-jima, SSW of Oshima, is 11 km long and only 2.5 km wide.  It is comprised of eight low rhyolitic lava domes that are clustered in two groups at the northern and southern ends of the island, separated by a low, flat isthmus.  The flat-topped domes give the island the appearance of two large plateaus bounded by steep cliffs.  The Mukai-yama complex at the southern end of the island and Achi-yama lava dome at the northern end were formed during Nii-jima's only historical eruptions in the 9th century AD.  Shikine-yama and Zinai-to domes form small islands immediately to the SW and west of Nii-jima, respectively, during earlier stages of volcanism.  Earthquake swarms occurred at Nii-jima during the 20th century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-02=&amp;volpage=photos&amp;photo=089042">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(34.393000000000001,139.273)
570	Kozu-shima	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kozu-shima</b></font><br /><font size="5"><b>Izu Islands (Japan)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/089041.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 572 m<br /><b>Latitude:</b> 34.216&deg;N<br /><b>Longitude:</b> 139.156&deg;E</td></tr><tr><td colspan="2"><p align="justify">A cluster of rhyolitic lava domes and associated pyroclastic deposits form the small 4 x 6 km island of Kozu-shima in the northern Izu Islands.  Kozu-shima lies along the Zenisu Ridge, one of several en echelon ridges oriented NE-SW, transverse to the trend of the northern Izu arc.  The youngest and largest of the 18 lava domes, 574-m-high Tenjo-yama, occupies the central portion of the island.  Most of the older domes, some of which are Holocene in age, flank Tenjo-yama to the north, although late-Pleistocene domes are also found at the southern end of the island.  Only two possible historical eruptions, from the 9th century, are known.  A lava flow may have reached the sea during an eruption in 832 AD.  Tenjo-san lava dome was formed during a major eruption in 838 AD that also produced pyroclastic flows and surges.  Earthquake swarms took place at Kozu-shima during the 20th century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-03=&amp;volpage=photos&amp;photo=089041">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(34.216000000000001,139.15600000000001)
571	Miyake-jima	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Miyake-jima</b></font><br /><font size="5"><b>Izu Islands (Japan)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/089037.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 815 m<br /><b>Latitude:</b> 34.079&deg;N<br /><b>Longitude:</b> 139.529&deg;E</td></tr><tr><td colspan="2"><p align="justify">The circular, 8-km-wide island of Miyake-jima forms a low-angle stratovolcano that rises about 1100 m from the sea floor in the northern Izu Islands about 200 km SSW of Tokyo.  The basaltic volcano is truncated by small summit calderas, one of which, 3.5 km wide, was formed during a major eruption about 2500 years ago.  Parasitic craters and vents, including maars near the coast and radially oriented fissure vents, dot the flanks of the volcano.  Frequent historical eruptions have occurred since 1085 AD at vents ranging from the summit to below sea level, causing much damage on this small populated island.  After a three-century-long hiatus ending in 1469, activity has been dominated by flank fissure eruptions sometimes accompanied by minor summit eruptions.  A 1.6-km-wide summit caldera was slowly formed by subsidence during an eruption in 2000; by October of that year the crater floor had dropped to only 230 m above sea level.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-04=&amp;volpage=photos&amp;photo=089037">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-04=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(34.079000000000001,139.529)
572	Mikura-jima	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mikura-jima</b></font><br /><font size="5"><b>Izu Islands (Japan)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/105045.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 851 m<br /><b>Latitude:</b> 33.871&deg;N<br /><b>Longitude:</b> 139.605&deg;E</td></tr><tr><td colspan="2"><p align="justify">Mikura-jima is a small steep-sided island located between the more well-known Miyake-jima and Hachijo-jima volcanoes.   O-yama forms the 851-m-high summit of the basaltic-to-andesitic island, which is surrounded by cliffs up to about 500 m high and dissected on the southern-to-eastern sides.  The sparsely populated island consists of a large stratovolcano with lava domes on the SE side.  Several small sea stacks are located immediately offshore, including one 73 m high off the SE tip of the island.  Growth of the stratovolcano took place until about 7000 years ago, and the latest activity occurred about 6000 years ago, when explosive eruptions and pyroclastic surges accompanied lava dome growth.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-041&amp;volpage=photos&amp;photo=105045">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-041">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(33.871000000000002,139.60499999999999)
573	Hachijo-jima	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hachijo-jima</b></font><br /><font size="5"><b>Izu Islands (Japan)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/089044.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 854 m<br /><b>Latitude:</b> 33.13&deg;N<br /><b>Longitude:</b> 139.769&deg;E</td></tr><tr><td colspan="2"><p align="justify">Hachijo-jima, in the central Izu Islands about 300 km south of Tokyo, consists of two small Quaternary dominantly basaltic stratovolcanoes forming an elongated NW-SE-trending island.  The eroded Pleistocene-to-Holocene Higashi-yama volcano occupies the SE end of the 14-km-long island, and the symmetrical Holocene Nishi-yama volcano the NW end.  Parasitic cones occur on the SE flank of Nishi-yama.  The small volcanic island of Ko-jima lies several km to the west of Hachijo-jima.  Growth of Higashi-yama began several tens of thousands of years ago, and included the formation of two small calderas.  The initial submarine and early subaerial eruptions of Nishi-yama took place from 10,000 to 8000 years before present (BP).  Its latest major activity, from the early Holocene until about 4000 years BP, was restricted to flank eruptions.  Historical eruptions of Hachijo-jima, recorded since the 15th century, have been restricted to the summit of Nishi-yama and a submarine vent of unknown location.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-05=&amp;volpage=photos&amp;photo=089044">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-05=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(33.130000000000003,139.76900000000001)
574	Aoga-shima	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Aoga-shima</b></font><br /><font size="5"><b>Izu Islands (Japan)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/030001.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 423 m<br /><b>Latitude:</b> 32.454&deg;N<br /><b>Longitude:</b> 139.762&deg;E</td></tr><tr><td colspan="2"><p align="justify">The small 2.5 x 3.5 km dominantly basaltic island of Aoga-shima is surrounded by steep cliffs and contains a small 1.7 x 1.5-km-wide caldera.  Two pyroclastic cones were formed inside the caldera during the volcano's latest eruption from 1780 to 1785.  Growth of Aoga-shima volcano began with construction of the Kurosaki stratovolcano in the NW part of the island, after which the main stratovolcano began growing in the SE part of the island.  Both summit and flank vents produced pyroclastic surges and lava flows.  Late in the construction of the main cone a 1-1.5 km crater was formed on the SE flank.  About 3000 years ago pyroclastic surges swept over the entire island.  During about the next 600 years, lava flows and scoria deposits filled the SE crater, which also collapsed repeatedly.  The current Ikenosawa crater was considered by Takada et al. (1992) to have formed by ring collapse at the time of a debris avalanche, after which the volcano was quiescent until the eruptions of historical time.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-06=&amp;volpage=photos&amp;photo=030001">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-06=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(32.454000000000001,139.762)
575	Bayonnaise Rocks	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bayonnaise Rocks</b></font><br /><font size="5"><b>Izu Islands (Japan)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/046013.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 11 m<br /><b>Latitude:</b> 31.88&deg;N<br /><b>Longitude:</b> 139.92&deg;E</td></tr><tr><td colspan="2"><p align="justify">Bayonnaise Rocks represent part of the barely exposed rim of a largely submarine 8-9 km wide caldera.  Formation of the caldera was followed by construction of a large (2.6 cu km) lava dome and/or lava flow complex on the caldera floor, originally located at a depth of 1000-1100 m.  Most historical eruptions, recorded since the late-19th century, have occurred from Myojin-sho, a large post-caldera lava dome constructed on the NE rim of the caldera.  Deposits from submarine pyroclastic flows associated with growth of the dacitic lava dome mantle the conical dome and extend into the NE part of the caldera and down its outer slopes.  An explosive submarine eruption from Myojin-sho in 1952 destroyed a Japanese research vessel, killing all 31 on board.  Submarine eruptions have also been observed from other points on the caldera rim and outside of the caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-07=&amp;volpage=photos&amp;photo=046013">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-07=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(31.879999999999999,139.91999999999999)
576	Smith Rock	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Smith Rock</b></font><br /><font size="5"><b>Izu Islands (Japan)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/105075.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 136 m<br /><b>Latitude:</b> 31.436&deg;N<br /><b>Longitude:</b> 140.054&deg;E</td></tr><tr><td colspan="2"><p align="justify">Smith Rock is a steep-sided basaltic pinnacle that forms part of the outer southern flank of a 8-9 km wide submarine caldera that truncates a 20-km-wide seamount.  The caldera was formed between about 60,000 and 30,000 years ago.  The Shirane dacitic central cone, 3 km wide and 800 m high, rises to within 8 m of the sea surface in the eastern side of the caldera, whose 600-700 m high walls and outer flanks expose basaltic, andesitic, and rhyolitic rocks.  Two large submarine cones, Sumisu Knolls No. 1 and 2, lie west of the caldera.  Submarine eruptions have been reported from a number of locations near 136-m-high Smith Rock (also known as Sumisu-jima, or Smith Island), the last of which occurred in 1916.  Water discoloration has been frequently observed since the 1970s near Smith Rock.  In October 1992, a 6-km-long zone of discolored water was seen extending from the shallow Shirane rock mass near the eastern rim of the caldera, which rises to within 7 m of the sea surface and is the youngest feature of the volcanic complex.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-08=&amp;volpage=photos&amp;photo=105075">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-08=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(31.436,140.054)
577	Tori-shima	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tori-shima</b></font><br /><font size="5"><b>Izu Islands (Japan)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/101099.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 394 m<br /><b>Latitude:</b> 30.480&deg;N<br /><b>Longitude:</b> 140.306&deg;E</td></tr><tr><td colspan="2"><p align="justify">The circular, 2.7-km-wide island of Tori-shima in the southern Izu Islands is capped by an unvegetated summit cone formed during an eruption in 1939.  Fresh lava flows from this eruption form part of the northern coastline of the basaltic-to-dacitic edifice.  The volcano is also referred to as Izu-Tori-shima to distinguish it from the several other Japanese island volcanoes called Tori-shima (&quot;Bird Island&quot;).  The main cone is truncated by a 1.5-km-wide caldera that contains two central cones, of which 394-m-high Iwo-yama is the highest.  Historical eruptions have also occurred from flank vents near the north coast and offshore submarine vents.  A 6-8 km wide submarine caldera lies immediately to the north of Tori-shima.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-09=&amp;volpage=photos&amp;photo=101099">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-09=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(30.48,140.30600000000001)
578	Suiyo Seamount	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Suiyo Seamount</b></font><br /><font size="5"><b>Izu Islands (Japan)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> -1418 m<br /><b>Latitude:</b> 28.60&deg;N<br /><b>Longitude:</b> 140.63&deg;E</td></tr><tr><td colspan="2"><p align="justify">Suiyo Seamount, one of the Shichiyo Seamounts, named for the 7 days of the week, lies south of Sofugan volcano.  Suiyo (&quot;Wednesday&quot;) is an basaltic-to-dacitic submarine caldera and lava dome that rises abaout 1400 m from the sea floor to within 1418 m of the sea surface.  The summit caldera is 1.5 km wide and about 500 m deep.  Major hydrothermal activity was observed in July 1991, with temperatures reaching more the 290 degrees Centigrade, and the volcano was reclassified as active by the Japan Meteorological Agency.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-093">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(28.600000000000001,140.63)
579	Mokuyo Seamount	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mokuyo Seamount</b></font><br /><font size="5"><b>Izu Islands (Japan)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> -920 m<br /><b>Latitude:</b> 28.32&deg;N<br /><b>Longitude:</b> 140.57&deg;E</td></tr><tr><td colspan="2"><p align="justify">Mokuyo Seamount is one of the Shichiyo Seamounts, named for the 7 days of the week.  Mokuyo (&quot;Thursday&quot;) is a basaltic-andesite submarine caldera that rises 1780 m from the sea floor to within 920 m of the sea surface.  The summit caldera is 3 x 2.3 km wide and about 450 m deep and contains a 180-m-high lava dome in its center.  Major hydrothermal activity was observed in July 1990, and the volcano was reclassified as active by the Japan Meteorological Agency.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-094">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(28.32,140.56999999999999)
580	Doyo Seamount	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Doyo Seamount</b></font><br /><font size="5"><b>Izu Islands (Japan)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> -860 m<br /><b>Latitude:</b> 27.68&deg;N<br /><b>Longitude:</b> 140.80&deg;E</td></tr><tr><td colspan="2"><p align="justify">Doyo Seamount is the southernmost of the Shichiyo Seamounts, named for the 7 days of the week.  Doyo (&quot;Saturday&quot;) is a basaltic-andesite submarine caldera that rises 2340 m from the sea floor to within 860 m of the sea surface.  The large horseshoe-shaped summit caldera is 3 x 10 km wide.  Major hydrothermal activity was observed in July 1990, and the volcano was reclassified as active by the Japan Meteorological Agency.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-095">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(27.68,140.80000000000001)
581	Nishino-shima	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Nishino-shima</b></font><br /><font size="5"><b>Volcano Islands (Japan)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/020095.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 38 m<br /><b>Latitude:</b> 27.274&deg;N<br /><b>Longitude:</b> 140.882&deg;E</td></tr><tr><td colspan="2"><p align="justify">The small island of Nishino-shima was recently enlarged when it was joined to several new islands that formed during an eruption in 1973-74.  Water discoloration has been observed on several occasions since.  The 700-m-wide island is the summit of a massive submarine volcano that has prominent satellitic peaks to the south, west, and NE.  The summit of the southern cone rises to within 214 m of the sea surface 9 km SSE of Nishino-shima.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-096&amp;volpage=photos&amp;photo=020095">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-096">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(27.274000000000001,140.88200000000001)
582	Kaikata Seamount	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kaikata Seamount</b></font><br /><font size="5"><b>Volcano Is</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Lava dome ?</td><td width="50%" align="left"><b>Summit Elev:</b> -162 m<br /><b>Latitude:</b> 26.67&deg;N<br /><b>Longitude:</b> 141.00&deg;E</td></tr><tr><td colspan="2"><p align="justify">Kaikata Seamount is a basaltic-to-dacitic submarine volcano located north of Kaitoku Seamount.  The volcano rises 2350 m from the sea floor to within 162 m of the sea surface.  The seamount contains two major summit peaks oriented NE-SW, with the SW peak being the highest.  Hydrothermal activity was observed in 1988 at a depth of 460 m, and the volcano was reclassified as active by the Japan Meteorological Agency.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-097">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(26.670000000000002,141)
583	Kaitoku Seamount	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kaitoku Seamount</b></font><br /><font size="5"><b>Volcano Is</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -103 m<br /><b>Latitude:</b> 26.122&deg;N<br /><b>Longitude:</b> 141.102&deg;E</td></tr><tr><td colspan="2"><p align="justify">A submarine eruption was observed in 1984 from the SE peak of Kaitoku Seamount (Kaitoku Kaizan), a three-peaked submarine volcano 130 km NW of Iwo-jima.  The SE peak is also known as Higashi-Kaitokuba (East Kaitokuba).  A submarine eruption had previously been reported in 1543 from a point near the SW summit, the shallowest of the three, also known as Nishi-Kaitokuba (West Kaitokuba).  The Japan Meteorological Agency (1996) listed depths of 103, 353, and 506 m for the SW, SE, and northern summits, respectively.   The three volcanoes, whose summits are 13-18 km apart, are the highest features of a massive submarine volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-10=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(26.122,141.102)
584	Kita-Iwo-jima	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kita-Iwo-jima</b></font><br /><font size="5"><b>Volcano Islands (Japan)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/107077.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 792 m<br /><b>Latitude:</b> 25.424&deg;N<br /><b>Longitude:</b> 141.284&deg;E</td></tr><tr><td colspan="2"><p align="justify">No historical eruptions have occurred from the deeply eroded Kita-Iwo-jima stratovolcano, which forms a steep-sided basaltic cone rising 792 m above the sea.  However, eruptions have been recorded since the 18th century from Funka-Asane, a submarine vent about 2 km NW of the island.  Kita-Iwo-jima (&quot;North Sulfur Island&quot;) is the northernmost of the Kazan Retto (Volcano Islands), located in the middle of the Izu-Marianas arc.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-11=&amp;volpage=photos&amp;photo=107077">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-11=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(25.423999999999999,141.28399999999999)
585	Ioto [Iwo-jima]	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ioto [Iwo-jima]</b></font><br /><font size="5"><b>Volcano Islands (Japan)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/095054.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Tuff cone</td><td width="50%" align="left"><b>Summit Elev:</b> 161 m<br /><b>Latitude:</b> 24.754&deg;N<br /><b>Longitude:</b> 141.290&deg;E</td></tr><tr><td colspan="2"><p align="justify">Ioto (also known as Iwo-jima) in the central Volcano Islands portion of the Izu-Marianas arc lies within a 9-km-wide submarine caldera.  Ioto, Iwo-jima, and Io-jima are among many transliterations of the name, which means &quot;Sulfur Island;&quot; the volcano is also known as Ogasawara Io-jima to distinguish it from several other &quot;Sulfur Island&quot; volcanoes in Japan.  The triangular, low-elevation, 8-km-long island narrows toward its SW tip and has produced trachyandesitic and trachytic rocks that are more alkalic than those of other Izu-Marianas arc volcanoes.  The island has undergone dramatic uplift for at least the past 700 years accompanying resurgent doming of the caldera.  A shoreline landed upon by Captain Cook's surveying crew in 1779 is now 40 m above sea level.  The Moto-yama plateau on the NE half of the island consists of submarine tuffs overlain by coral deposits and forms the island's high point.  Many fumaroles are oriented along a NE-SW zone cutting through Moto-yama.  Numerous historical phreatic eruptions, many from vents on the west and NW sides of the island, have accompanied the remarkable uplift.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-12=&amp;volpage=photos&amp;photo=095054">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-12=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(24.754000000000001,141.28999999999999)
586	Kita-Fukutokutai	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kita-Fukutokutai</b></font><br /><font size="5"><b>Volcano Is</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/107083.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -73 m<br /><b>Latitude:</b> 24.414&deg;N<br /><b>Longitude:</b> 141.419&deg;E</td></tr><tr><td colspan="2"><p align="justify">Kita-Fukutokutai is a newly recognized submarine volcano halfway between Iwo-jima and Minami-Iwo-jima islands.  The volcano rises to within 73 m of the sea surface.  Water discoloration was reported several times beginning in 1937, and floating pumice was seen in 1953-54.  In 1988 a fishing boat reported an eruption column about 100 m high, although the report was not confirmed at the time.  The Japan Meteorological Agency, which has responsibility for the oversight of Japanese volcanoes, has classified Kita-Fukutokutai as an active volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-121&amp;volpage=photos&amp;photo=107083">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-121">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(24.414000000000001,141.41900000000001)
587	Fukutoku-Okanoba	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Fukutoku-Okanoba</b></font><br /><font size="5"><b>Volcano Is</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/020098.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> -14 m<br /><b>Latitude:</b> 24.28&deg;N<br /><b>Longitude:</b> 141.485&deg;E</td></tr><tr><td colspan="2"><p align="justify">Fukutoku-Okanoba is a submarine volcano located 5 km NE of the pyramidal island of Minami-Iwo-jima.  Water discoloration is frequently observed from the volcano, and several ephemeral islands have formed in the 20th century.  The first of these formed Shin-Iwo-jima (&quot;New Sulfur Island&quot;) in 1904, and the most recent island was formed in 1986.  Fukutoku-Okanoba is part of an elongated edifice with two major topographic highs trending NNW-SSE and is a trachyandesitic volcano geochemically similar to Iwo-jima.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-13=&amp;volpage=photos&amp;photo=020098">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-13=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cnmiemo.gov.mp/">CNMI Emergency Management Office</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(24.280000000000001,141.48500000000001)
588	Minami-Hiyoshi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Minami-Hiyoshi</b></font><br /><font size="5"><b>Volcano Islands (Japan)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/107084.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -30 m<br /><b>Latitude:</b> 23.497&deg;N<br /><b>Longitude:</b> 141.940&deg;E</td></tr><tr><td colspan="2"><p align="justify">Periodic water discoloration and water-spouting have been reported over this submarine volcano since 1975, when detonations and an explosion were also reported.  Minami-Hiyoshi lies near the SE end of a coalescing chain of youthful seamounts and is the only historically active vent.  The reported depth of the summit of the trachyandesitic volcano has varied between 274 and 30 m.  The morphologically youthful seamounts Kita-Hiyoshi and Naka-Hiyoshi lie to the NW, and Ko-Hiyoshi to the SE.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-131&amp;volpage=photos&amp;photo=107084">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-131">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(23.497,141.94)
589	Nikko	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Nikko</b></font><br /><font size="5"><b>Volcano Islands (Japan)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/107046.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -391 m<br /><b>Latitude:</b> 23.075&deg;N<br /><b>Longitude:</b> 142.308&deg;E</td></tr><tr><td colspan="2"><p align="justify">Nikko submarine volcano is a massive seamount that rises from nearly 3 km depth to within 391 m of the sea surface at the SE end of a submarine ridge segment extending from Minami-Iwo-jima island.  Two large cones at the basaltic-to-andesitic volcano have been constructed on the NW and NE rims of a roughly 3-km-wide, flat-floored submarine caldera, whose rim is prominently displayed on the southern side, but largely buried on the north.  A smaller cones lies on the SE caldera floor.  The larger NW cone lies within a partially buried crater and displays hydrothermal activity.  Discolored water was observed above Nikko seamount in July 1979, but no water discoloration has been observed during semi-regular seasonal reconnaissance flights since then.  Hydrothermal venting was documented during a recent NOAA expedition.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-132&amp;volpage=photos&amp;photo=107046">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-132">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(23.074999999999999,142.30799999999999)
590	Fukujin	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Fukujin</b></font><br /><font size="5"><b>Volcano Islands (Japan)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -217 m<br /><b>Latitude:</b> 21.93&deg;N<br /><b>Longitude:</b> 143.47&deg;E</td></tr><tr><td colspan="2"><p align="justify">One of the larger of the submarine volcanoes of the Marianas arc, Fukujin seamount has risen on occasion to just beneath the sea surface.  Intermittent periods of water discoloration have been observed since the mid-20th century, and eruptions producing floating pumice were noted on several occasions.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-133">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(21.93,143.47)
591	Kasuga	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kasuga</b></font><br /><font size="5"><b>Volcano Islands (Japan)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/105089.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -598 m<br /><b>Latitude:</b> 21.765&deg;N<br /><b>Longitude:</b> 143.710&deg;E</td></tr><tr><td colspan="2"><p align="justify">Kasuga seamount is a conical volcano that rises to within 598 m of the sea surface SE of Fukujin submarine volcano.  Kasuga is listed as an active volcano by the Japan Meteorological Agency, and floating pumice attributed to a submarine eruption of Kasuga was seen south of the volcano in the summer of 1959.  Water discoloration from a possible submarine eruption was reported from a location near Kasuga seamount in November 1975.  Kasuga, the northernmost of three seamounts in the the Kasuga seamount chain, rises from a depth of 3000 m.  A series of flank vents are located low on the southern side of the edifice.  The summit of Kasuga does not have a caldera or display hydrothermal activity, and the volcano is largely mantled by volcaniclastics.  Altered basaltic and andesitic rocks dredged from the summit suggest that Kasuga 1 is the oldest of the three seamounts, although delicately preserved lava flow lobes and toes from a flank eruption suggest a very youthful age.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-134&amp;volpage=photos&amp;photo=105089">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-134">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(21.765000000000001,143.71000000000001)
592	Minami Kasuga	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Minami Kasuga</b></font><br /><font size="5"><b>Volcano Islands (Japan)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/116096.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> -274 m<br /><b>Latitude:</b> 21.60&deg;N<br /><b>Longitude:</b> 143.637&deg;E</td></tr><tr><td colspan="2"><p align="justify">Minami Kasuga (South Kasuga) is the central of three NNE-SSW trending volcanoes forming the Kasuga seamount chain, which trends SSE from the volcanic front of the Izu-Marianas arc.  Minami Kasuga (also referred to as Kasuga 2) rises from about 3000 m depth to within 170 m of the sea surface and is the highest and largest volume of the three volcanoes.  Two subsidiary cones are located low on the eastern flank.  The morphology of Minami Kasuga is more complex than Kasuga 1 volcano to the north, and prominent ridges separate slopes of interspersed volcaniclastic and lava flow fields.  Radionuclide decay rates indicate an age for Minami Kasuga of less than 8000 years and probably less than 1000 years; radium/thorium disequilibrium ratios suggest the flows may be only a few centuries old (Fryer et al., 1997).  Active hydrothermal fields are located at the summit of Minami Kasuga, at the base of summit ridges, and on the lower flanks.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-135&amp;volpage=photos&amp;photo=116096">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-135">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(21.600000000000001,143.637)
593	NW Eifuku	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>NW Eifuku</b></font><br /><font size="5"><b>Volcano Islands (Japan)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/118056.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -1535 m<br /><b>Latitude:</b> 21.485&deg;N<br /><b>Longitude:</b> 144.043&deg;E</td></tr><tr><td colspan="2"><p align="justify">NW Eifuku is a small submarine volcano that pales in size in comparison to its larger neighbors, but displays vigorous thermal activity.  The summit of the basaltic-to-andesitic Northwest Eifuku volcano lies 1535 m below the sea surface; the seamount lies at the NW end of a chain of submarine volcanoes that includes Eifuku and Daikoko, at the SE end.  Hydrothermal fluid emission at NW Eifuku includes liquid carbon dioxide bubbles venting from &quot;white smokers,&quot; one of only two places where natural liquid carbon dioxide emission has been observed.  The hydrothermal field, named Champagne, was discovered during a 2003 NOAA expedition and lies in the steep headwall of a slope-failure scarp that cuts the summit and SW side of the volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-136&amp;volpage=photos&amp;photo=118056">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-136">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cnmiemo.gov.mp/">CNMI Emergency Management Office</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(21.484999999999999,144.04300000000001)
594	Daikoku	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Daikoku</b></font><br /><font size="5"><b>Volcano Islands (Japan)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/118058.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -323 m<br /><b>Latitude:</b> 21.324&deg;N<br /><b>Longitude:</b> 144.194&deg;E</td></tr><tr><td colspan="2"><p align="justify">The conical summit of Daikoku seamount lies along an elongated E-W-trending ridge SE of Eifuku submarine volcano and rises to within 323 m of the sea surface.   Daikoku submarine volcano is one of about a dozen displaying hydrothermal activity in the southern part of the Izu-Marianas chain.  A steep-walled, 50-m-wide cylindrical crater on the north flank, about 75 m below the summit, is at least 135 m deep and was observed to emit cloudy hydrothermal fluid.  During a NOAA expedition in 2006, scientists observed a convecting, black pool of liquid sulfur with a partly solidified, undulating sulfur crust at a depth of 420 m below the summit of Daikoku.  Gases, particulate with the appearance of smoke, and liquid sulfur were bubbling up from the back edge of the sulfur pool.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-137&amp;volpage=photos&amp;photo=118058">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-137">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cnmiemo.gov.mp/">CNMI Emergency Management Office</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(21.324000000000002,144.19399999999999)
595	Farallon de Pajaros	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Farallon de Pajaros</b></font><br /><font size="5"><b>Mariana Is</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/021002.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 360 m<br /><b>Latitude:</b> 20.538&deg;N<br /><b>Longitude:</b> 144.896&deg;E</td></tr><tr><td colspan="2"><p align="justify">The small 2-km-wide island of Farallon de Pajaros (also known as Uracas) is the northernmost and most active volcano of the Mariana Islands.  Its relatively frequent historical eruptions dating back to the mid-19th century have caused the andesitic volcano to be referred to as the &quot;Lighthouse of the western Pacific.&quot;   The symmetrical, sparsely vegetated summit is the central cone within a small caldera cutting an older edifice, remnants of which are seen on the SE and southern sides near the coast.  Flank fissures have fed lava flows during historical time that form platforms along the coast.  Both summit and flank vents have been active at Farallon de Pajaros during historical time.  Eruptions have also been observed from nearby submarine vents, and Makhahnas seamount, which rises to within 640 m of the sea surface, lies about 10 km to the SW.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-14=&amp;volpage=photos&amp;photo=021002">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-14=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cnmiemo.gov.mp/">CNMI Emergency Management Office</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(20.538,144.89599999999999)
596	Ahyi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ahyi</b></font><br /><font size="5"><b>Mariana Islands (Central Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/116097.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -137 m<br /><b>Latitude:</b> 20.42&deg;N<br /><b>Longitude:</b> 145.03&deg;E</td></tr><tr><td colspan="2"><p align="justify">Ahyi seamount is a large conical submarine volcano that rises to within 137 m of the sea surface about 18 km SE of the island of Farallon de Pajaros (Uracas) in the northern Marianas.  Water discoloration has been observed over the submarine volcano, and in 1979 the crew of a fishing boat felt shocks over the summit area of the seamount followed by upwelling of sulfur-bearing water.  On April 24-25, 2001 an explosive submarine eruption was detected seismically from a seismic station on Rangiroa Atoll, Tuamotu Archipelago.  The event was well constrained (+/- 15 km) at a location near the southern base of Ahyi; the summit of the seamount lies within the location uncertainty.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-141&amp;volpage=photos&amp;photo=116097">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-141">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cnmiemo.gov.mp/">CNMI Emergency Management Office</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(20.420000000000002,145.03)
597	Supply Reef	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Supply Reef</b></font><br /><font size="5"><b>Mariana Islands (Central Pacific)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -8 m<br /><b>Latitude:</b> 20.13&deg;N<br /><b>Longitude:</b> 145.10&deg;E</td></tr><tr><td colspan="2"><p align="justify">Supply Reef is a conical submarine volcano in the northern Mariana Islands that rises to within 8 m of the sea surface.  The andesitic seamount lies about 10 km NW of the Maug Islands, the emergent summit of a submarine volcano that is joined to Supply Reef by a low saddle at a depth of about 1800 m.  Supply Reef was mapped as Quaternary; living corals on the crater rim suggest that  the volcano is either dormant or extinct (Corwin, 1971).  Several submarine eruptions have been detected by sonar signals originating from points very approximately located at distances of 15-25 km NW of Supply Reef.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-142">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cnmiemo.gov.mp/">CNMI Emergency Management Office</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(20.129999999999999,145.09999999999999)
598	Maug Islands	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Maug Islands</b></font><br /><font size="5"><b>Mariana Islands (Central Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/095017.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 227 m<br /><b>Latitude:</b> 20.02&deg;N<br /><b>Longitude:</b> 145.22&deg;E</td></tr><tr><td colspan="2"><p align="justify">Three small elongated islands up to 2.3 km long mark the northern, western, and eastern rims of a largely submerged 2.5-km-wide caldera.  The highest point of the Maug Islands reach only 227 m above sea level; the submerged southern notch on the caldera rim lies about 140 m below sea level.  The caldera has an average submarine depth of about 200 m and contains a twin-peaked central lava dome that rises to within about 20 m of the sea surface.  The Maug Islands form a twin volcanic massif with Supply Reef, about 11 km to the north.  The truncated inner walls of the caldera on all three islands expose lava flows and pyroclastic deposits that are cut by radial dikes; bedded ash deposits overlie the outer flanks of the islands.  No eruptions are known since the discovery of the islands by Espinosa in 1522.  The presence of poorly developed coral reefs and coral on the central lava dome suggests a long period of general quiescence, although it does not exclude mild eruptions (Corwin, 1971).  A recent NOAA expedition detected possible evidence of submarine geothermal activity.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-143&amp;volpage=photos&amp;photo=095017">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-143">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cnmiemo.gov.mp/">CNMI Emergency Management Office</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(20.02,145.22)
599	Asuncion	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Asuncion</b></font><br /><font size="5"><b>Mariana Islands (Central Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/095018.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 857 m<br /><b>Latitude:</b> 19.671&deg;N<br /><b>Longitude:</b> 145.406&deg;E</td></tr><tr><td colspan="2"><p align="justify">A single large asymmetrical stratovolcano, steeper on the NE side, forms 3-km-wide Asuncion Island.  The steep NE flank of the 857-m-high volcano terminates in high sea cliffs.  The gentler SW flanks have low-angle slopes bounded by sea cliffs only a few meters high.  The southern flank of the volcano is cut by a large landslide scar.  The southern flanks and western flanks of the volcano are mantled by ash deposits that may have originated during eruptions in historical time.  An explosive eruption in 1906 also produced lava flows that descended about half way down the western and SE flanks, but several other historical eruption reports are of uncertain validity.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-15=&amp;volpage=photos&amp;photo=095018">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-15=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cnmiemo.gov.mp/">CNMI Emergency Management Office</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(19.670999999999999,145.40600000000001)
600	Agrigan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Agrigan</b></font><br /><font size="5"><b>Mariana Islands (Central Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/095020.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 965 m<br /><b>Latitude:</b> 18.77&deg;N<br /><b>Longitude:</b> 145.67&deg;E</td></tr><tr><td colspan="2"><p align="justify">The highest of the Marianas arc volcanoes, Agrigan contains a 500-m-deep, flat-floored caldera.  The elliptical island is 8 km long; its 965-m-high summit is the top of a massive 4000-m-high submarine volcano, the second largest in the Marianas Islands.  Deep radial valley dissect the flanks of the thickly vegetated stratovolcano.  The elongated caldera is 1 x 2 km wide and is breached to the NW, from where a prominent lava flow extends to the coast and forms a lava delta.  The caldera floor is surfaced by fresh-looking lava flows and also contains two cones that may have formed during the volcano's only historical eruption in 1917.  This eruption deposited large blocks and 3 m of ash and lapilli on a village on the SE coast, prompting its evacuation.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-16=&amp;volpage=photos&amp;photo=095020">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-16=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cnmiemo.gov.mp/">CNMI Emergency Management Office</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(18.77,145.66999999999999)
601	Pagan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Pagan</b></font><br /><font size="5"><b>Mariana Islands (Central Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/021027.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 570 m<br /><b>Latitude:</b> 18.13&deg;N<br /><b>Longitude:</b> 145.80&deg;E</td></tr><tr><td colspan="2"><p align="justify">Pagan Island, the largest and one of the most active of the Mariana Islands volcanoes, consists of two stratovolcanoes connected by a narrow isthmus.  Both North and South Pagan stratovolcanoes were constructed within calderas, 7 and 4 km in diameter, respectively.  The 570-m-high Mount Pagan at the NE end of the island rises above the flat floor of the northern caldera, which may have formed less than 1000 years ago.  South Pagan is a 548-m-high stratovolcano with an elongated summit containing four distinct craters.  Almost all of the historical eruptions of Pagan, which date back to the 17th century, have originated from North Pagan volcano.  The largest eruption of Pagan during historical time took place in 1981 and prompted the evacuation of the sparsely populated island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-17=&amp;volpage=photos&amp;photo=021027">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-17=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cnmiemo.gov.mp/">CNMI Emergency Management Office</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(18.129999999999999,145.80000000000001)
602	Alamagan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Alamagan</b></font><br /><font size="5"><b>Mariana Islands (Central Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/021038.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 744 m<br /><b>Latitude:</b> 17.60&deg;N<br /><b>Longitude:</b> 145.83&deg;E</td></tr><tr><td colspan="2"><p align="justify">Alamagan is the emergent summit of a large stratovolcano in the central Mariana Islands with a roughly 350-m-deep summit crater east of the center of the island.  The exposed cone is largely Holocene in age.  A 1.6 x 1 km graben cuts the SW flank.  An extensive basaltic-andesite lava flow has extended the northern coast of the island, and a lava platform also occurs on the south flank.  Pyroclastic-flow deposits erupted about 1000 years ago have been dated, but reports of historical eruptions were considered invalid (Moore and Trusdell, 1993).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-18=&amp;volpage=photos&amp;photo=021038">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-18=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cnmiemo.gov.mp/">CNMI Emergency Management Office</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(17.600000000000001,145.83000000000001)
603	Guguan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Guguan</b></font><br /><font size="5"><b>Mariana Islands (Central Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/099050.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 287 m<br /><b>Latitude:</b> 17.307&deg;N<br /><b>Longitude:</b> 145.845&deg;E</td></tr><tr><td colspan="2"><p align="justify">The small island of Guguan, only 2.8 km wide, is composed of an eroded volcano on the south, a caldera with a post-caldera cone, and a northern volcano.  The latter has three coalescing cones and a breached summit crater that fed lava flows to the west and NW.  The 287-m high point of the island is the south rim of the caldera.  Freycinet misidentifed Guguan with Alamagan; reported eruptions in 1819 and 1901 (Catalog of Active Volcanoes of the World) actually refer to solfataric activity on Alamagan (Corwin, 1971).  The only known historical eruption of Guguan took place between 1882 and 1884 and produced the northern volcano and lava flows that reached the coast.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-19=&amp;volpage=photos&amp;photo=099050">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-19=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cnmiemo.gov.mp/">CNMI Emergency Management Office</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(17.306999999999999,145.845)
604	Zealandia Bank	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Zealandia Bank</b></font><br /><font size="5"><b>Mariana Is</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/118055.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 0 m<br /><b>Latitude:</b> 16.88&deg;N<br /><b>Longitude:</b> 145.85&deg;E</td></tr><tr><td colspan="2"><p align="justify">Zealandia Bank consists of two pinnacles about 1 km apart rising from a submerged bank to near the sea surface between Guguan and Sarigan Islands.   One pinnacle reaches  &gt;1 m above water at low tide.  Andesitic rocks were dredged at the southern peak, which showed some evidence of coral growth.  Freshly broken pahoehoe basaltic rocks were recovered on the western flank of Zealandia Bank.  The age of the most recent eruptive activity at Zealandia Bank is not known, but a NOAA bathymetric survey in 2004 detected fumarolic activity.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-191&amp;volpage=photos&amp;photo=118055">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-191">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cnmiemo.gov.mp/">CNMI Emergency Management Office</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(16.879999999999999,145.84999999999999)
605	Sarigan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sarigan</b></font><br /><font size="5"><b>Mariana Islands (Central Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/105090.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 538 m<br /><b>Latitude:</b> 16.708&deg;N<br /><b>Longitude:</b> 145.78&deg;E</td></tr><tr><td colspan="2"><p align="justify">Sarigan volcano forms a 3-km-long, roughly triangular island.  A low truncated cone with a 750-m-wide summit crater contains a small ash cone.  The youngest eruptions produced two lava domes from vents above and near the south crater rim.  Lava flows from each dome reached the coast and extended out to sea, forming irregular shorelines.   The northern flow overtopped the crater rim on the north and NW sides.  The sparse vegetation on the flows indicates they are of Holocene age (Meijer and Reagan, 1981).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-192&amp;volpage=photos&amp;photo=105090">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-192">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cnmiemo.gov.mp/">CNMI Emergency Management Office</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(16.707999999999998,145.78)
606	Anatahan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Anatahan</b></font><br /><font size="5"><b>Mariana Islands (Central Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/108082.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 790 m<br /><b>Latitude:</b> 16.35&deg;N<br /><b>Longitude:</b> 145.67&deg;E</td></tr><tr><td colspan="2"><p align="justify">The elongate, 9-km-long island of Anatahan in the central Mariana Islands consists of a large stratovolcano with a 2.3 x 5 km, E-W-trending compound summit caldera.  The larger western portion of the caldera is 2.3 x 3 km wide, and its western rim forms the island's 790-m high point.  Ponded lava flows overlain by pyroclastic deposits fill the floor of the western caldera, whose SW side is cut by a fresh-looking smaller crater.  The 2-km-wide eastern portion of the caldera contained a steep-walled inner crater whose floor prior to the 2003 eruption was only 68 m above sea level.  A submarine volcano, named NE Anatahan, rises to within 460 m of the sea surface on the NE flank of the volcano, and numerous other submarine vents are found on the NE-to-SE flanks.  Sparseness of vegetation on the most recent lava flows on Anatahan had indicated that they were of Holocene age, but the first historical eruption of Anatahan did not occur until May 2003, when a large explosive eruption took place forming a new crater inside the eastern caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-20=&amp;volpage=photos&amp;photo=108082">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-20=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cnmiemo.gov.mp/">CNMI Emergency Management Office</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(16.350000000000001,145.66999999999999)
607	East Diamante	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>East Diamante</b></font><br /><font size="5"><b>Mariana Is</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/118062.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> -127 m<br /><b>Latitude:</b> 15.93&deg;N<br /><b>Longitude:</b> 145.67&deg;E</td></tr><tr><td colspan="2"><p align="justify">The dacitic East Diamante submarine volcano contains an elongated NE-SW-trending caldera with a pronounced rim on the NE side.  A large post-caldera cone lies on the SW caldera rim, and a complex of lava domes was constructed in the center of the caldera.  Several areas of hydrothermal activity including &quot;black smoker&quot; sulfide chimneys at the Black Forest site were detected on the central dome complex at depths of only a few hundred meters.  These marked the shallowest black smokers yet discovered.  The summit of the submarine volcano extends to within 127 m of the sea surface.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-201&amp;volpage=photos&amp;photo=118062">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-201">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cnmiemo.gov.mp/">CNMI Emergency Management Office</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(15.93,145.66999999999999)
608	Ruby	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ruby</b></font><br /><font size="5"><b>Mariana Islands (Central Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/116095.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -230 m<br /><b>Latitude:</b> 15.62&deg;N<br /><b>Longitude:</b> 145.57&deg;E</td></tr><tr><td colspan="2"><p align="justify">Ruby, a basaltic submarine volcano that rises to within 230 m of the sea surface near  the southern end of the Mariana arc NW of Saipan, was detected in eruption in 1966 by sonar signals (Norris and Johnson, 1969).  In 1995 submarine explosions were heard, accompanied by a fish kill, sulfurous odors, bubbling water, and the detection of volcanic tremor.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-202&amp;volpage=photos&amp;photo=116095">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-202">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cnmiemo.gov.mp/">CNMI Emergency Management Office</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(15.619999999999999,145.56999999999999)
609	Esmeralda Bank	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Esmeralda Bank</b></font><br /><font size="5"><b>Mariana Is</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/116094.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> -43 m<br /><b>Latitude:</b> 15.00&deg;N<br /><b>Longitude:</b> 145.25&deg;E</td></tr><tr><td colspan="2"><p align="justify">Esmeralda Bank is a massive submarine volcano with three summit cones oriented along a N-S line.  Their summits are from 43 to 140 m beneath the sea surface.  The highest, middle peak contains a 3-km-wide caldera open to the west and several parasitic cones.  Frequent sulfur boils and water discoloration have been observed, which have variously been attributed to eruptive events or solfataric activity.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-21=&amp;volpage=photos&amp;photo=116094">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-21=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cnmiemo.gov.mp/">CNMI Emergency Management Office</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(15,145.25)
610	NW Rota-1	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>NW Rota-1</b></font><br /><font size="5"><b>Mariana Islands (Central Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120035.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -517 m<br /><b>Latitude:</b> 14.601&deg;N<br /><b>Longitude:</b> 144.775&deg;E</td></tr><tr><td colspan="2"><p align="justify">A submarine volcano detected during a 2003 NOAA bathymetric survey of the Mariana Island arc was found to be hydrothermally active and named NW Rota-1.  The basaltic to basaltic-andesite seamount rises to within 517 m of the sea surface SW of Esmeralda Bank and lies 64 km NW of Rota Island and about 100 km north of Guam.  When Northwest Rota-1 was revisited in 2004, a minor submarine eruption from a vent named Brimstone Pit on the upper south flank about 40 m below the summit intermittently ejected a plume several hundred meters high containing ash, rock particles, and molten sulfur droplets that adhered to the surface of the remotely operated submersible vehicle.  The active vent was funnel-shaped, about 20 m wide and 12 m deep.  NW Rota-1 is a large submarine volcano with prominent structural lineaments about a kilometer apart cutting across the summit of the edifice and down the NE and SW flanks.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-211&amp;volpage=photos&amp;photo=120035">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-211">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.pmel.noaa.gov/vents/">NOAA Pacific Marine Environmental Laboratory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(14.601000000000001,144.77500000000001)
611	Forecast Seamount	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Forecast Seamount</b></font><br /><font size="5"><b>Mariana Is</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/118066.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Latitude:</b> 13.40&deg;N<br /><b>Longitude:</b> 143.92&deg;E</td></tr><tr><td colspan="2"><p align="justify">Forecast Seamount lies about 70 km west of the southern tip of Guam and about 19 km NW of Seamount X.   Hydrothermal fluid temperatures up to 200 degrees C, one of the highest temperature vent systems known in the Mariana arc, were measured during a 2006 NOAA expedition.   Vent community species that occur on Forecast Seamount include shrimp, snails, limpets, crabs, sulfide worms, and scale worms, and differ from those further to the north in the Marianas arc.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-22-&amp;volpage=photos&amp;photo=118066">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-22-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.pmel.noaa.gov/vents/">NOAA Pacific Marine Environmental Laboratory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(13.4,143.91999999999999)
612	Seamount X	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Seamount X</b></font><br /><font size="5"><b>Mariana Islands (Central Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/118064.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> -1230 m<br /><b>Latitude:</b> 13.25&deg;N<br /><b>Longitude:</b> 144.02&deg;E</td></tr><tr><td colspan="2"><p align="justify">Hydrothermal activity was detected during a 2003 NOAA expedition at a submarine volcano about 70 km WSW of Guam.  The summit of the volcano, referred to as Seamount X, lies 1230 m below the sea surface.  Diffuse sites of thermal venting colonized by shrimps, crabs, and scaleworms were detected near the summit during a 2006 NOAA expedition, and thick deposits of sulfur flows originating from the hydrothermal vent were observed that were covered with thousands of squat lobsters.  Basaltic rocks were recovered along with sulfur samples.  The summit of the volcano is cut by an elongated caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-23-&amp;volpage=photos&amp;photo=118064">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0804-23-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.pmel.noaa.gov/vents/">NOAA Pacific Marine Environmental Laboratory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(13.25,144.02000000000001)
613	Oshima-Oshima	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Oshima-Oshima</b></font><br /><font size="5"><b>Hokkaido</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/105062.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> 737 m<br /><b>Latitude:</b> 41.507&deg;N<br /><b>Longitude:</b> 139.371&deg;E</td></tr><tr><td colspan="2"><p align="justify">Oshima-Oshima, a small, 4-km-wide Japan Sea island 55 km west of the SW tip of Hokkaido, is the emergent summit of two coalescing basaltic-to-andesitic stratovolcanoes.  Higashi-yama, at the east end of the island, is cut by a 2-km-wide caldera covered on its west side by Nishi-yama volcano.  The western cone failed during an eruption in 1741, creating a large horseshoe-shaped caldera breached to the north that extends from the summit down to the sea floor at the base of the volcano and producing a mostly submarine debris avalanche that traveled 16 km.  A tsunami associated with the collapse swept the coasts of Hokkaido, western Honshu, and Korea, and caused nearly 1500 fatalities.  The 1741 eruption, the largest in historical time at Oshima-Oshima, concluded with the construction of a basaltic pyroclastic cone at the head of the breached caldera.  No eruptions have occurred since the late-18th century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-01=&amp;volpage=photos&amp;photo=105062">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(41.506999999999998,139.37100000000001)
614	E-san	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>E-san</b></font><br /><font size="5"><b>Hokkaido</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/056073.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 618 m<br /><b>Latitude:</b> 41.802&deg;N<br /><b>Longitude:</b> 141.170&deg;E</td></tr><tr><td colspan="2"><p align="justify">E-san, a small andesitic stratovolcano capped by a 618-m-high lava dome, is Hokkaido's southernmost active volcano.  E-san occupies the eastern tip of the double-pronged Oshima Peninsula across the Tsugaru Strait from Honshu.  Another lava dome is located to the NW.   Both the E-san lava dome, which formed about 9000 years ago, and the NW dome have been active during the Holocene.  A minor phreatic eruption in 1846 produced a mudflow that caused many fatalities.  The latest activity at E-san was a small eruption in 1874.  Active fumaroles occur at a thermal area on the upper NW flank.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-011&amp;volpage=photos&amp;photo=056073">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-011">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(41.802,141.16999999999999)
615	Komaga-take	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Komaga-take</b></font><br /><font size="5"><b>Hokkaido</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/021041.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1131 m<br /><b>Latitude:</b> 42.061&deg;N<br /><b>Longitude:</b> 140.681&deg;E</td></tr><tr><td colspan="2"><p align="justify">The truncated Komaga-take volcano on the Oshima Peninsula of southern Hokkaido is one of the most active volcanoes of Japan's northernmost island.  Komaga-take's sharp-topped 1131-m-high summit lies at the western side of a large breached crater that formed as a result of edifice collapse in 1640 AD.  Hummocky debris avalanche material occurs at the base of the volcano on three sides.  Much of the andesitic Komaga-take volcano is Pleistocene in age.  Two late-Pleistocene and two Holocene plinian eruptions occurred prior to the first historical eruption in 1640, which began a period of more frequent explosive activity.  The 1640 eruption, one of the largest in Japan during historical time, deposited ash as far away as central Honshu and produced a debris avalanche that reached the sea.  The resulting tsunami caused 700 fatalities.  Three plinian eruptions have occurred since 1640; in 1694, 1856, and 1929.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-02=&amp;volpage=photos&amp;photo=021041">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(42.061,140.68100000000001)
616	Usu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Usu</b></font><br /><font size="5"><b>Hokkaido</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/021060.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 737 m<br /><b>Latitude:</b> 42.541&deg;N<br /><b>Longitude:</b> 140.843&deg;E</td></tr><tr><td colspan="2"><p align="justify">Usu, one of Hokkaido's most well-known volcanoes, is a small stratovolcano located astride the southern topographic rim of the 110,000-year-old Toya caldera.  The center of the 10-km-wide, lake-filled caldera contains Naka-jima, a group of forested andesitic lava domes.  The summit of the basaltic-to-andesitic edifice of Usu is cut by a somma formed about 7-8,000 years ago when collapse of the volcano produced a debris avalanche that reached the sea.  Dacitic domes erupted along two NW-SE-trending lines fill and flank the summit caldera.  Three of these domes, O-Usu, Ko-Usu and Showa-Shinzan, along with seven crypto-domes, were erupted during historical time.  The 1663 eruption of Usu was one of the largest in Hokkaido during historical time.  The war-time growth of Showa-Shinzan from 1943-45 was painstakingly documented by the local postmaster, who created the first detailed record of growth of a lava dome.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-03=&amp;volpage=photos&amp;photo=021060">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(42.540999999999997,140.84299999999999)
617	Niseko	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Niseko</b></font><br /><font size="5"><b>Hokkaido</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/056039.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1154 m<br /><b>Latitude:</b> 42.88&deg;N<br /><b>Longitude:</b> 140.63&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Niseko volcano group in SW Hokkaido, WNW of Yotei volcano, contains a cluster of andesitic stratovolcanoes and lava domes.  The volcanic complex is located NW of Niseko City.  The latest dated activity at the Niseko group was a phreatic to magmatic eruption about 7000 years ago.  Fumarolic areas and hot springs are found at various locations in the Niseko volcano group.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-031&amp;volpage=photos&amp;photo=056039">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-031">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(42.880000000000003,140.63)
618	Yotei	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Yotei</b></font><br /><font size="5"><b>Hokkaido</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/022006.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1898 m<br /><b>Latitude:</b> 42.830&deg;N<br /><b>Longitude:</b> 140.815&deg;E</td></tr><tr><td colspan="2"><p align="justify">Yotei is a symmetrical andesitic-to-dacitic stratovolcano with a Fuji-like profile the forms a prominent landmark NW of Toya caldera.  Its 1898-m-high summit, rising about 1500 m above its base, is truncated by a 700-m-wide crater that is cut on its NW rim by overlapping smaller craters.  Deep radial gullies cut the flanks of Yotei.  The latest eruption from the main Yotei edifice took place about 5000-6000 years ago.  Hangetsu-ko (Half Moon Lake), a tuff cone on the lower NW flank of Yotei, was estimated from stratigraphic evidence to have erupted about 3000 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-032&amp;volpage=photos&amp;photo=022006">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-032">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(42.829999999999998,140.815)
619	Kuttara	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kuttara</b></font><br /><font size="5"><b>Hokkaido</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/056018.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 581 m<br /><b>Latitude:</b> 42.489&deg;N<br /><b>Longitude:</b> 141.163&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Kuttara volcanic group consists of a series of small stratovolcanoes, lava domes, pyroclastic cones, and a caldera near the Pacific coast SE of Toya caldera and SW of Shikotsu caldera.    The Kuttara group was constructed during five major eruptive stages, the first of which occurred more than 60,000 years ago.  A major dacitic pumice eruption at the end of the 4th stage about 40,000 years ago resulted in the formation of the 3-km-diameter Kuttara caldera.  The caldera cut a basaltic-to-andesitic stratovolcano complex, which late in its activity produced two major andesitic lava flows on its north side at Kita-yama.  Explosions, probably in early Holocene time, formed two large craters on the west flank of the caldera, and a dacitic lava dome was emplaced about 10,000 years ago.  Late-stage phreatic explosion products from Jigoku-dani, a 300-400 m wide crater south of the lava dome, overlie the 1663 tephra from Usu volcano.  Jigoku-dani and Noboribetsu Spa are the sites of intense thermal activity, including fumaroles, hot springs, and geysers.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-034&amp;volpage=photos&amp;photo=056018">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-034">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(42.488999999999997,141.16300000000001)
620	Shikotsu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Shikotsu</b></font><br /><font size="5"><b>Hokkaido</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/022025.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 1320 m<br /><b>Latitude:</b> 42.688&deg;N<br /><b>Longitude:</b> 141.380&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 13 x 15 km Shikotsu caldera, largely filled by the waters of Lake Shikotsu, was formed during one of Hokkaido's largest Quaternary eruptions about 31-34,000 years ago.  The small andesitic Tarumai stratovolcano was then constructed on its SE rim and has been Hokkaido's most active volcano in historical time.  Pyroclastic-flow deposits from Tarumai extend nearly to the Pacific coast.  Two other Holocene post-caldera volcanoes, Fuppushi (adjacent to Tarumai) and Eniwa (on the opposite side of the caldera), occur on a line trending NW from Tarumai, and were constructed just inside the caldera rim.  Minor eruptions took place from the summit of Eniwa volcano as late as the 17th century.  The summit of Tarumai contains a small 1.5-km-wide caldera formed during two of Hokkaido's largest historical eruptions, in 1667 and 1739.  Tarumai is now capped by a flat-topped summit lava dome that formed in 1909.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-04=&amp;volpage=photos&amp;photo=022025">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-04=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(42.688000000000002,141.38)
621	Rishiri	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Rishiri</b></font><br /><font size="5"><b>Hokkaido</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/056002.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1721 m<br /><b>Latitude:</b> 45.18&deg;N<br /><b>Longitude:</b> 141.25&deg;E</td></tr><tr><td colspan="2"><p align="justify">Rishiri is a highly dissected andesitic stratovolcano that forms a 20-km-wide island west of the northern tip of Hokkaido.  Extensive erosion has produced an extremely rugged topography, with a dramatic sharp-topped, 1719-m-high summit flanked by steep-sided radial ridges.  A stratovolcano and flank lava domes were constructed at Rishiri beginning less than 200,000 years ago.  Eruptions at the stratovolcano ceased about 37,000 years ago, after which only flank vents were active.  Late-stage eruptions took place from scoria cones and maars along a 15-km-long NW-SE trend that extends to the SE coast.  Flank eruptions were dominantly basaltic, but also included andesitic and rhyolitic activity.  Extensive late-stage lava flows during the late Pleistocene form much of the northern and western coasts and extend offshore.  The latest eruptions at Rishiri took place a few thousand years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-041&amp;volpage=photos&amp;photo=056002">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-041">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(45.18,141.25)
622	Tokachi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tokachi</b></font><br /><font size="5"><b>Hokkaido</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/022029.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2077 m<br /><b>Latitude:</b> 43.416&deg;N<br /><b>Longitude:</b> 142.690&deg;E</td></tr><tr><td colspan="2"><p align="justify">Tokachi volcano consists of a group of dominantly andesitic stratovolcanoes and lava domes arranged on a NE-SW line above a plateau of welded Pleistocene tuffs in central Hokkaido.  Numerous explosion craters and cinder cones are located on the upper flanks of the small stratovolcanoes, with the youngest Holocene centers located at the NW end of the chain.  Frequent historical eruptions, consisting mostly of mild-to-moderate phreatic explosions, have been recorded since the mid-19th century.  Two larger eruptions occurred in 1926 and 1962.  Partial cone collapse of the western flank of Tokachi-dake during the 1926 eruption produced a disastrous debris avalanche and mudflow.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-05=&amp;volpage=photos&amp;photo=022029">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-05=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(43.415999999999997,142.69)
623	Daisetsu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Daisetsu</b></font><br /><font size="5"><b>Hokkaido</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/089014.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2290 m<br /><b>Latitude:</b> 43.661&deg;N<br /><b>Longitude:</b> 142.858&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Daisetsu volcano group (also spelled Taisetsu) lies at the northern end of the Daisetsu-Tokachi graben in central Hokkaido.  It consists of a complex group of stratovolcanoes and lava domes associated with a small, 2-km-wide caldera.  The eight satellitic volcanoes are aligned along a ring fracture that is centered over the eastern rim of the caldera.  Asahi-dake, the highest peak of the complex, was constructed 3 km SW of the center of the caldera.  Other stratovolcanoes are located along a NE-SW line cutting through the caldera that trends toward the Tokachi volcano complex to the SW.  In contrast to the Tokachi group, no historical eruptions are known from Daisetsu, although the latest phreatic eruption took place sometime after 1739 AD.  Fumarolic areas are located on Asahi-dake, where at one time sulfur was mined, and in the caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-06=&amp;volpage=photos&amp;photo=089014">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-06=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(43.661000000000001,142.858)
624	Nipesotsu-Maruyama	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Nipesotsu-Maruyama</b></font><br /><font size="5"><b>Hokkaido</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/091059.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2013 m<br /><b>Latitude:</b> 43.453&deg;N<br /><b>Longitude:</b> 143.036&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Nipesotsu-Maruyama volcano group, located west of Nukabira lake about 20 km east of Tokachi-dake volcano, is composed of a number of overlapping andesitic-to-rhyolitic stratovolcanoes and lava domes constructed along a NW-SE trend.  These volcanoes overlap the SW rim and SW caldera floor of the Pleistocene Tokachimitsumata caldera.  The highest peak in the complex is 2013-m-high Nipesotsu-yama stratovolcano, which was active during the mid-Pleistocene, about 0.4-0.2 million years ago.  The Maruyama stratovolcano and lava dome at the southern end of the complex was discovered to be a Quaternary volcano only in 1989.  It is also referred to as Higashi-Tokachi-Maruyama to distinguish it from several other volcanoes named Maru-yama, which means &quot;Round Mountain.&quot;  A minor phreatic eruption took place at Maru-yama lava dome in 1898, and fumaroles are present on one of its summit craters.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-061&amp;volpage=photos&amp;photo=091059">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-061">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(43.453000000000003,143.036)
625	Akan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Akan</b></font><br /><font size="5"><b>Hokkaido</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/056010.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1499 m<br /><b>Latitude:</b> 43.384&deg;N<br /><b>Longitude:</b> 144.013&deg;E</td></tr><tr><td colspan="2"><p align="justify">Akan is a 13 x 24 km caldera located immediately SW of Kutcharo caldera.   The elongated, irregular outline of the Akan caldera rim reflects its incremental formation during major explosive eruptions from the early to mid-Pleistocene.   Growth of four post-caldera stratovolcanoes, three at the SW end of the caldera and the other at the NE side, has restricted the size of the caldera lake.  The 1-km-wide Nakamachineshiri crater was formed during a major pumice-and-scoria eruption about 13,500 years ago.  Of the Holocene volcanoes of the Akan volcanic complex, only the Me-Akan group, east of Lake Akan, has been historically active, producing mild phreatic eruptions since the beginning of the 19th century.   Me-Akan is composed of 9 overlapping cones.  The main cone of Me-Akan proper has a triple crater at its summit.  Historical eruptions at Me-Akan have consisted of minor phreatic explosions, but four major magmatic eruptions including pyroclastic flows have occurred during the Holocene.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-07=&amp;volpage=photos&amp;photo=056010">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-07=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(43.384,144.01300000000001)
626	Kutcharo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kutcharo</b></font><br /><font size="5"><b>Hokkaido</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/022037.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 999 m<br /><b>Latitude:</b> 43.608&deg;N<br /><b>Longitude:</b> 144.443&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 20 x 26 km Kutcharo caldera (also spelled Kussharo or Kuccharo), is the largest of a cluster of calderas in NE Hokkaido.  The caldera was formed in a series of major eruptions between about 340,000 and 30,000 years ago.  Naka-jima, a Holocene post-caldera dacitic-to-rhyolitic lava-dome complex, forms an island in the large lake that fills much of the western half of the caldera.  The Holocene Atosanupuri stratovolcano and lava-dome complex islocated near the center of the caldera, east of the crescent-shaped Lake Kutcharo.  Many lava domes were formed at Atosanupuri between about 10,000 and 1000 years ago.  No historical eruptions are known, although intense fumarolic activity occurs on and around Atosanupuri volcano and along the shores of Lake Kutcharo.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-08=&amp;volpage=photos&amp;photo=022037">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-08=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(43.607999999999997,144.44300000000001)
627	Mashu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mashu</b></font><br /><font size="5"><b>Hokkaido</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/105040.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 855 m<br /><b>Latitude:</b> 43.570&deg;N<br /><b>Longitude:</b> 144.565&deg;E</td></tr><tr><td colspan="2"><p align="justify">Mashu is a 6-km-wide Holocene caldera that truncates a stratovolcano constructed on the ESE rim of the large Kutcharo caldera.  The steep-walled caldera, filled by the remarkably transparent waters of Lake Mashu, is one of the scenic highlights of Hokkaido.  Following caldera collapse about 7000 years ago, a small andesitic stratovolcano, Kamuinupuri, was formed beginning about 4000 years ago, creating a reentrant into the SE side of the deep caldera lake.  A large explosive eruption about 1000 years ago, the latest dated eruption from Mashu volcano, created a 1.2 x 1.5 km crater at the summit of Kamuinupuri.  The small island of Kamuishu in the center of Lake Mashu represents the tip of a mostly submerged dacitic lava dome.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-081&amp;volpage=photos&amp;photo=105040">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-081">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(43.57,144.565)
628	Rausu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Rausu</b></font><br /><font size="5"><b>Hokkaido</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/096008.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1660 m<br /><b>Latitude:</b> 44.073&deg;N<br /><b>Longitude:</b> 145.126&deg;E</td></tr><tr><td colspan="2"><p align="justify">Rausu is an andesitic-to-dacitic stratovolcano with summit lava domes on the Shiretoko Peninsula in NE Hokkaido.  The  1660-m-high volcano is located along a ridge 5 km SW of Shiretoko-Iwo-san volcano, the NE-most Holocene volcano in Hokkaido.  Young lava flows descent the NW flank and broad areas along the SE flank of Rausu, and an older lava flow traveled about 9 km to the west, reaching the coast of the Sea of Okhotsk along a broad front.  Rausu-dake volcano produced eruptions of pumiceous tephras with associated pyroclastic flows about 2200, 1400, and 800  years ago.  Recent work has documented a pyroclastic-flow deposit that overlies the 1739 tephra from Tarumai volcano in SW Hokkaido.  Stratigraphic relationships place this eruption, the most recent known from Rausu, between about 1750 and 1850 AD.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-082&amp;volpage=photos&amp;photo=096008">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-082">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(44.073,145.126)
629	Shiretoko-Iwo-zan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Shiretoko-Iwo-zan</b></font><br /><font size="5"><b>Hokkaido</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/105072.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 1563 m<br /><b>Latitude:</b> 44.131&deg;N<br /><b>Longitude:</b> 145.165&deg;E</td></tr><tr><td colspan="2"><p align="justify">Shiretoko-Iwo-zan, one of many Japanese &quot;sulfur mountains,&quot; is noted for the extrusion of molten sulfur during eruptions in 1889 and 1936.  Located at the NE tip of Hokkaido on the Shiretoko Peninsula, the andesitic volcano contains two large craters at the summit that are breached to the NW.  The southern crater contains a small flat-topped lava dome.  The main cone, Naka-dake, was constructed NW of the headwalls of the two breached craters.  Historical eruptions have originated from the southernmost of three explosion craters along a NNE-SSW line on the NW flank of the main cone of Shiretoko-Iwo-san.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-09=&amp;volpage=photos&amp;photo=105072">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0805-09=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.jma.go.jp/en/volcano/">Japan Meteorological Agency</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(44.131,145.16499999999999)
630	Golovnin	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Golovnin</b></font><br /><font size="5"><b>Kunashir Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/022046.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 543 m<br /><b>Latitude:</b> 43.841&deg;N<br /><b>Longitude:</b> 145.509&deg;E</td></tr><tr><td colspan="2"><p align="justify">Golovnin volcano, the southernmost in the Kuril Islands, forms the southern end of Kunashir Island, across the Nemuro Strait from Hokkaido.  Explosive activity has dominated in the formation of andesitic-dacitic Golovnin volcano; no lava flows are exposed.  The gently sloping stratovolcano, also known as Tomari-yama, is truncated by a 4-5 km wide caldera that formed during a series of late-Pleistocene eruptions beginning about 43,00 years ago.  Several lava domes were subsequently emplaced on the caldera floor.  Topographic highs outside the caldera rim define a series of lava domes extruded along a ring structure or an outer caldera.  A 1 x 2.5 km caldera lake on the northern side of the inner caldera drains through a narrow breach in the western caldera wall.  Solfataric activity occurs at the northern lake shore and at explosion craters (one of which contains a hot crater lake with reported temperatures from 36-100 degrees Centigrade) that cut the caldera-floor lava domes.  The only known historical eruption of Golovnin was a minor explosion in 1848.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-01=&amp;volpage=photos&amp;photo=022046">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(43.841000000000001,145.50899999999999)
631	Mendeleev	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mendeleev</b></font><br /><font size="5"><b>Kunashir Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/108017.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 888 m<br /><b>Latitude:</b> 43.976&deg;N<br /><b>Longitude:</b> 145.736&deg;E</td></tr><tr><td colspan="2"><p align="justify">Mendeleev, also known as Rausu-dake, is a low compound stratovolcano located in the southern part of Kunashir island.  The dominantly andesitic-dacitic volcano is cut by two nested calderas, the larger 6-7 km in diameter and the smaller 3-3.5 km.  A central cone that formed inside the younger caldera was breached to the west by a large debris avalanche about 4200 years ago.  A lava dome that grew inside the avalanche scarp forms the 888 m high point of the volcano.  Additional lava domes in the northern part of the older caldera are considered to represent flank activity of the younger caldera.  The only unambiguous historical eruption was a small phreatic explosion in 1880.  Four solfatara fields lie at the eastern and northern flanks of the central cone, and the Goriachy Pliazh geothermal field is located outside the caldera along the eastern coast.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-02=&amp;volpage=photos&amp;photo=108017">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(43.975999999999999,145.73599999999999)
632	Smirnov	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Smirnov</b></font><br /><font size="5"><b>Kunashir Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/108043.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1189 m<br /><b>Latitude:</b> 44.420&deg;N<br /><b>Longitude:</b> 146.135&deg;E</td></tr><tr><td colspan="2"><p align="justify">Smirnov is a gently sloping 1189-m-high stratovolcano, located immediately west of Tiatia volcano at the NW tip of Kunashir Island in the southern Kuriles.  The northern flank of the andesitic volcano in part retains a constructional form, but the southern side has been heavily eroded by glaciers, exposing its Tertiary basement.  A wide glacial trough on the SE flank contains a pyroclastic cone at its head that fed a 4-km-long lava flow.  Another pyroclastic cone is located at the base of the trough near the terminus of the lava flow.  Two fresh-looking lava domes of Holocene age also lie within the glacial valley to the north.  On the NW side Smirnov overlaps the  late-Pleistocene andesitic-to-dacitic Rurui volcano, which has an active fumarole field on its western flank.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-021&amp;volpage=photos&amp;photo=108043">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-021">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(44.420000000000002,146.13499999999999)
633	Tiatia	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tiatia</b></font><br /><font size="5"><b>Kunashir Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/091056.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1819 m<br /><b>Latitude:</b> 44.351&deg;N<br /><b>Longitude:</b> 146.256&deg;E</td></tr><tr><td colspan="2"><p align="justify">Tiatia volcano, one of the most impressive of the Kuril Islands, consists of a beautifully symmetrical cone that rises above the broad rim of an erosionally furrowed, 2.1 x 2.4 km wide caldera.  The 1819-m-high Tiatia (also known as Chacha-dake) occupies the NE tip of Kunashir Island and morphologically resembles Mount Vesuvius.  The pristine-looking conical central cone, mostly formed by basaltic to basaltic-andesite strombolian eruptions, rises 400 m above the floor of the caldera and contains a 400 x 250 m wide crater with two explosion vents separated by a linear septum.  Fresh lava flows cover much of the SW caldera floor and have overflowed the rim, extending to the foot of the older somma, which formed during the late Pleistocene or early Holocene.  A lava flow from a flank cone on the northern caldera rim reached the Sea of Okhotsk.  A major explosive eruption in 1973 was the first since Tiatia's initial historical eruption in 1812.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-03=&amp;volpage=photos&amp;photo=091056">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(44.350999999999999,146.256)
634	Berutarube	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Berutarube</b></font><br /><font size="5"><b>Iturup Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/108010.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Shield volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1221 m<br /><b>Latitude:</b> 44.459&deg;N<br /><b>Longitude:</b> 146.936&deg;E</td></tr><tr><td colspan="2"><p align="justify">The gently sloping, 1220-m-high Berutarube stratovolcano forms the SW tip of Iturup Island.  The flanks of the andesitic-to-dacitic volcano are deeply dissected by wide glacial valleys; a low saddle on the NE side separates Berutarube from the slopes of Lvinaya Past caldera.  The only known Holocene activity at Berutarube produced a small pyroclastic cone that was superposed on the intersecting headwalls of U-shaped valleys and cirques on the volcano's broad eroded summit.  The hydrothermally altered summit cone was the source of two small lava flows.  Berutarube was estimated to have ceased erupting only a few hundred to at most 1000 years ago (Gorshkov, 1970).  No confirmed historical eruptions of Berutarube are known, although fumarolic areas on the walls of the summit crater are currently depositing sulfur.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-04=&amp;volpage=photos&amp;photo=108010">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-04=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(44.459000000000003,146.93600000000001)
635	Lvinaya Past	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Lvinaya Past</b></font><br /><font size="5"><b>Iturup Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/108016.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 528 m<br /><b>Latitude:</b> 44.608&deg;N<br /><b>Longitude:</b> 146.994&deg;E</td></tr><tr><td colspan="2"><p align="justify">The rim of the dramatic 7 x 9 km wide Lvinaya Past (Lion's Jaw) caldera on southern Iturup Island drops to 50 m below sea level on the NW side.  The volcano derives its name from a rock resembling a sleeping lion that breaches the surface at the center of the submerged caldera rim.  A shallow 5-km-wide passageway on the NW side allows access of the Sea of Okhotsk into the caldera basin, whose floor is 550 m below sea level and lies almost 1 km below the caldera rim.  The caldera, also referred to as Moikeshi, formed about 9400 years ago during one of the largest Holocene eruptions of the Kuril Islands.  Thick dacitic pumice deposits from this eruption form the 50-60 m high Yuzhny (Southern) isthmus, which joins the three southernmost volcanoes on Iturup Island, Rokko, Lvinaya Past, and Berutarube.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-041&amp;volpage=photos&amp;photo=108016">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-041">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(44.607999999999997,146.994)
636	Atsonupuri	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Atsonupuri</b></font><br /><font size="5"><b>Iturup Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/108007.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 1206 m<br /><b>Latitude:</b> 44.805&deg;N<br /><b>Longitude:</b> 147.135&deg;E</td></tr><tr><td colspan="2"><p align="justify">Conical Atsonupuri stratovolcano forms a prominent peninsula joined to the SW side of Iturup Island by a low isthmus only 30 m high.  A somma volcano whose caldera rim is exposed only at about 900 m elevation on the SE side was constructed during the late Pleistocene or early Holocene, forming an island up to about 1.5 km high that was later connected to Iturup Island by erosional material.   A fault with large displacement offsets the NW side of the somma of Atsonupuri (also known as Etorofu-Atosanupuri).  The 2-km-wide caldera was subsequently largely overtopped by a central cone that forms the present 1206-m-high summit.   Strombolian eruptions have dominated the history of this basaltic volcano; few lava flows are exposed.  Only two historical eruptions are known at Atsonupuri, during 1812 and 1932.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-05=&amp;volpage=photos&amp;photo=108007">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-05=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(44.805,147.13499999999999)
637	Bogatyr Ridge	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bogatyr Ridge</b></font><br /><font size="5"><b>Iturup Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/108008.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 1634 m<br /><b>Latitude:</b> 44.833&deg;N<br /><b>Longitude:</b> 147.342&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Bogatyr Ridge on Iturup Island in the southern Kuriles consists of a cluster of small NE-SW-trending late-Pleistocene to Holocene cones and craters, along with the larger Stokap stratovolcano at the SW end of the ridge.  The basaltic-andesite to andesitic Stokap volcano is capped by a complex of 8-10 cones and explosion craters, the largest of which contains a lake.  The volcanic chain was constructed over a high Pleistocene base, whose glaciated surface is covered by lava flows from Stokap volcano that reach to both the Pacific Ocean and the Sea of Okhotsk.  No historical eruptions are known from the volcanic chain.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-06-&amp;volpage=photos&amp;photo=108008">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-06-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(44.832999999999998,147.34200000000001)
638	Grozny Group	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Grozny Group</b></font><br /><font size="5"><b>Iturup Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/108014.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcanoes<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1211 m<br /><b>Latitude:</b> 45.026&deg;N<br /><b>Longitude:</b> 147.922&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Grozny volcano group in central Iturup Island contains the complex volcanoes of Ivan Grozny and Tebenkov.  The former has a 3-3.5 km diameter caldera that is open to the south, where the large, 1158-m-high andesitic Grozny extrusion dome (also known as Etorofu-Yake-yama) was emplaced.  Several other lava domes of Holocene age were constructed  to the NE; extrusion of these domes has constricted a former lake in the northern side of the caldera to an extremely sinuous shoreline.  The forested andesitic Tebenkov volcano, also known as Odamoi-san, lies immediately to the NE of the Grozny dome complex.  The large Machekh crater, which displays strong fumarolic activity, lies immediately south of Tebenkov.  Historical eruptions, the first of which took place in 1968, have been restricted to Ivan Grozny.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-07=&amp;volpage=photos&amp;photo=108014">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-07=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(45.026000000000003,147.922)
639	Baransky	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Baransky</b></font><br /><font size="5"><b>Iturup Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/108076.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 1132 m<br /><b>Latitude:</b> 45.097&deg;N<br /><b>Longitude:</b> 148.024&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Baransky volcanic complex along the Pacific coast in the central part of Iturup Island consists of an eroded Pleistocene volcano that is capped by a Holocene stratovolcano.   A young summit lava dome is cut by a NW-trending chain of small explosion craters.  A group of flank cones farther to the NW with a similar NW-SE orientation is partially surrounded by lava flows from the central crater of the andesitic-dacitic volcano.  Lava flows from Baransky (also known as Sashiusu-dake) descended 4-5 km SE to reach the Pacific Ocean along a broad front.  The only historical eruption occurred in 1951, when local inhabitants reported weak explosive activity at the summit.  Strong solfataric activity continues from the summit and several flank craters, and the SW flank geothermal field contains hot springs and geysers.  A small hydrothermal explosion took place in 1992 at an exploratory well in the SW-flank geothermal field.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-08=&amp;volpage=photos&amp;photo=108076">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-08=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(45.097000000000001,148.024)
640	Chirip	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Chirip</b></font><br /><font size="5"><b>Iturup Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/108012.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1587 m<br /><b>Latitude:</b> 45.338&deg;N<br /><b>Longitude:</b> 147.925&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Chirip Peninsula, jutting NW-ward into the Sea of Okhotsk from central Iturup Island, is constructed of twin overlapping Holocene stratovolcanoes.  Chirip volcano on the north and Bogdan Khmelnitskii on the south overlie a preglacial volcano, rising above a 1100-m-high saddle to 1561 and 1587 m, respectively.  Lava flows from both volcanoes are truncated by a large, 4-km-wide depression on the west side of the peninsula.  Basaltic rocks dominate at both volcanoes over basaltic-andesite and andesitic products.  Chirip volcano has a shallow summit crater, partially filled by a small lake, that has fed lava flows down all sides.  Satellitic cones are located on the northern flank of Chirip.  Lava flows from Bogdan Khmelnitskii (also known as Minami-Chirippu or South Chirippu) reach the coast on both the east and west sides.  Only two 19th-century eruptions are known in historical time, the last occurring in 1860 from a vent SE of the summit of Bogdan Khmelnitskii.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-09=&amp;volpage=photos&amp;photo=108012">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-09=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(45.338000000000001,147.92500000000001)
641	Medvezhia	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Medvezhia</b></font><br /><font size="5"><b>Iturup Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/022061.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Somma volcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1125 m<br /><b>Latitude:</b> 45.387&deg;N<br /><b>Longitude:</b> 148.843&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Medvezhia volcanic complex occupies the NE end of Iturup Island.  Two overlapping calderas, 14 x 18 and 10 x 12 km in diameter, were formed during the Pleistocene.   The caldera floor contains several lava domes, cinder cones and associated lava fields, and a small lake.  Four small closely spaced stratovolcanoes were constructed along an E-W line on the eastern side of the complex.  The easternmost and highest, Medvezhii, lies outside the western caldera, along the Pacific coast.  Srednii, Tukap, and Kudriavy volcanoes lie immediately to the west.  Historically active Kudriavy (also known as Moyoro-dake) is younger than 2000 years; it and Tukap remain fumarolically active.  The westernmost of the post-caldera cones, Menshoi Brat, is a large lava dome with flank scoria cones, one of which has produced a series of young lava flows up to 4.5 km long that reached Slavnoe Lake.  Eruptions of Kudriavy have been documented since the 18th century, although lava flows from cinder cones on the flanks of Menshoi Brat were also probably erupted within the past few centuries.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-10=&amp;volpage=photos&amp;photo=022061">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-10=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.aist.go.jp/RIODB/strata/VOL_JP/EN/index.htm">Geological Survey of Japan</a></td></tr></table>	(45.387,148.84299999999999)
642	Demon	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Demon</b></font><br /><font size="5"><b>Iturup Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/108015.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 1205 m<br /><b>Latitude:</b> 45.50&deg;N<br /><b>Longitude:</b> 148.85&deg;E</td></tr><tr><td colspan="2"><p align="justify">Demon volcano occupies the extreme northern tip of the largest island in the Kuriles, Iturup.  The 1205-m-high stratovolcano grew during the Holocene within a glacial trough 3 km east of the eroded Pleistocene Kamui volcano.  The summit of Demon contains a 1.5-km-wide crater open to the east.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-11-&amp;volpage=photos&amp;photo=108015">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-11-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(45.5,148.84999999999999)
643	Ivao Group	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ivao Group</b></font><br /><font size="5"><b>Urup Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110084.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1426 m<br /><b>Latitude:</b> 45.77&deg;N<br /><b>Longitude:</b> 149.68&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Ivao group of cones along the Krishtofovich Ridge of SW Urup Island contains several well-preserved cones of Holocene age.  The first of a group of three young cones that formed along a NW-SE line is 1426-m-high Ivao cone, which marks the high point of Urup Island at the NW end of the chain.  The SE-most cone bisects a glacial valley, forming Lake Ivao.  The elongated central cone, Krutaya Mountain, is the youngest, and produced a viscous lava flow that traveled to the east.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-111&amp;volpage=photos&amp;photo=110084">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-111">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(45.770000000000003,149.68000000000001)
644	Kolokol Group	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kolokol Group</b></font><br /><font size="5"><b>Urup Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/108020.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Somma volcanoes<br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1328 m<br /><b>Latitude:</b> 46.042&deg;N<br /><b>Longitude:</b> 150.05&deg;E</td></tr><tr><td colspan="2"><p align="justify">A group of Holocene volcanoes in central Urup Island is named after its most prominent volcano, Kolokol.  Berg and Trezubetz volcanoes, flanking Kolokol on the NW, have breached summit calderas partially filled by lava domes.  Trezubetz, whose name means &quot;trident,&quot; has an eroded crater rim with three large peaks when seen at sea from the north.  Kolokol volcano rises to 1328 m and is sometimes known as Urup-Fuji because of its symmetrical profile.  The crater of Kolokol is not well preserved, but the volcano displays no evidence of glacial erosion.  Several lava flows originate from Kolokol; one of these extends almost to the Sea of Okhotsk coast.  A viscous lava flow armoring the SE flank is probably the most recent from Kolokol.  Borzov volcano, the oldest of the group, lies to the SW of Kolokol.  Eruptions of the Kolokol volcano group have been observed in historical time since the late-18th century.  Berg volcano has been most active, but Trezubetz erupted in 1924.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-12=&amp;volpage=photos&amp;photo=108020">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-12=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(46.042000000000002,150.05000000000001)
645	Chirpoi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Chirpoi</b></font><br /><font size="5"><b>Kuril Islands (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/022064.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Stratovolcanoes</td><td width="50%" align="left"><b>Summit Elev:</b> 742 m<br /><b>Latitude:</b> 46.525&deg;N<br /><b>Longitude:</b> 150.875&deg;E</td></tr><tr><td colspan="2"><p align="justify">Chirpoi, a small island lying between the larger islands of Simushir and Urup, contains a half dozen volcanic edifices constructed within an 8-9 km wide, partially submerged caldera.  The southern rim of the caldera is exposed on nearby Brat Chirpoev Island.  Two volcanoes on Chirpoi Island have been historically active.  The symmetrical Cherny volcano, which forms the 691 m high point of the island, erupted twice during the 18th and 19th centuries.  The youngest volcano, Snow, originated between 1770 and 1810.  It is composed almost entirely of lava flows, many of which have reached the sea on the southern coast.  No historical eruptions are known from 742-m-high Brat Chirpoev, but its youthful morphology suggests recent strombolian activity.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-15=&amp;volpage=photos&amp;photo=022064">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-15=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(46.524999999999999,150.875)
646	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>Kuril Islands (Russia)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -502? m<br /><b>Latitude:</b> 46.47&deg;N<br /><b>Longitude:</b> 151.28&deg;E</td></tr><tr><td colspan="2"><p align="justify">Hydrophones detected signals in 1972 interpreted to be from a submarine eruption in the Kuriles, probably between Simushir and Urup Island (Smithsonian Institution Center for Short-Lived Phenomena).  Three seamounts have been located between Urup and Simushir Islands, east and NE of Chirpoi Island (Tsvetkov 1991, pers. comm.), but the hydrophone signal is not accurately enough located to determine its precise origin.  The location given here is arbitrarily that of the seamount most centrally located between Urup and Simushir Islands.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-16-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(46.469999999999999,151.28)
647	Milne	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Milne</b></font><br /><font size="5"><b>Simushir Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104069.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Somma volcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 1540 m<br /><b>Latitude:</b> 46.82&deg;N<br /><b>Longitude:</b> 151.78&deg;E</td></tr><tr><td colspan="2"><p align="justify">Milne volcano, the southernmost on Simushir Island in the central Kuriles, lies immediately SE of the somma of Goriaschaia volcano.  The outer flanks of the steep-sided 1540-m-high volcano are dissected by deep gullies.  A 3-km-wide caldera breached widely to the south was formed during the Pleistocene and became a center of glaciation.  A small central cone capped by an andesitic lava dome was constructed within the caldera during postglacial time and forms the highest point on Simushir Island.  Lava flows from the central cone descend 4-5 km to the sea.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-161&amp;volpage=photos&amp;photo=104069">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-161">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(46.82,151.78)
648	Goriaschaia Sopka	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Goriaschaia Sopka</b></font><br /><font size="5"><b>Simushir Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110085.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 891 m<br /><b>Latitude:</b> 46.83&deg;N<br /><b>Longitude:</b> 151.75&deg;E</td></tr><tr><td colspan="2"><p align="justify">Goriaschaia Sopka is a young, historically active lava dome at the SW end of Simushir Island in the central Kuriles.  The dome is located within a large horseshoe-shaped crater cutting the NW flank of the older Igla Mountain somma volcano.  A low saddle separates Igla Mountain from Milne, a large stratovolcano immediately to the SE.  Numerous fresh lava flows with prominent marginal levees extend from the Goriaschaia Sopka dome; some reached the sea, where they created an irregular shoreline.  The andesitic dome may have formed as recently as the late-19th century.  Historical activity, consisting dominantly of mild-to-moderate explosive eruptions, has occurred since 1842.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-17=&amp;volpage=photos&amp;photo=110085">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-17=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(46.829999999999998,151.75)
649	Zavaritzki Caldera	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Zavaritzki Caldera</b></font><br /><font size="5"><b>Simushir Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/103096.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Scoria cone</td><td width="50%" align="left"><b>Summit Elev:</b> 624 m<br /><b>Latitude:</b> 46.925&deg;N<br /><b>Longitude:</b> 151.95&deg;E</td></tr><tr><td colspan="2"><p align="justify">Zavaritzki volcano in central Simushir Island contains three nested calderas of 10-, 8-, and 3-km diameter.  The steep-walled youngest caldera was formed during the Holocene and contains a lake whose surface is about 40 m elevation and whose bottom lies about 30 m below sea level.  Several young cones and lava domes are located near the margins of Biryuzovoe caldera lake.  Lacustrine sediments overlying pumice deposits indicate that an earlier caldera lake lay at 200 m above sea level, well above the present lake surface.  Two eruptions have occurred at Zavaritzki during the 20th century.  A lava dome that was emplaced sometime between 1916 and 1931 forms a small island in the northern part of the caldera lake.  In 1957, a new 350-m-wide, 40-m-high dome was emplaced following explosive eruptions, decreasing the size of the caldera lake.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-18=&amp;volpage=photos&amp;photo=103096">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-18=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(46.924999999999997,151.94999999999999)
650	Prevo Peak	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Prevo Peak</b></font><br /><font size="5"><b>Simushir Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104071.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1360 m<br /><b>Latitude:</b> 47.02&deg;N<br /><b>Longitude:</b> 152.12&deg;E</td></tr><tr><td colspan="2"><p align="justify">Symmetrical Prevo Peak, also known as Simushiru-Fuji for its resemblance to Japan's noted volcano, is capped by a 450 x 600 m wide summit crater.  A nested inner cone whose rim approaches the height of portions of the outer cone is itself cut by a deep, 350-m-wide crater with a small lake on its floor.  Young-looking lava flows reach both coasts of central Simushir Island, and those on the south flank (Pacific Ocean side) have a particularly youthful appearance.  Two small pyroclastic cones on the western flank have produced lava flows that reach to or near the Sea of Okhotsk.  Only two eruptions are known from Prevo Peak in historical time.  The largest of these, during the 1760s, produced pyroclastic flows that destroyed all vegetation at the foot of the volcano.  Weak explosive activity occurred during the most recent eruption, which took place during the first half of the 19th century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-19=&amp;volpage=photos&amp;photo=104071">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-19=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(47.020000000000003,152.12)
651	Urataman	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Urataman</b></font><br /><font size="5"><b>Simushir Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/091053.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Somma volcano<br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 678 m<br /><b>Latitude:</b> 47.12&deg;N<br /><b>Longitude:</b> 152.25&deg;E</td></tr><tr><td colspan="2"><p align="justify">The northernmost of six Quaternary volcanoes on Simushir Island, Urataman consists of an impressive 7.5-km-wide Pleistocene caldera that forms the NE tip of the island.  Caldera walls rise 450 m above a 250-m-deep caldera bay.  A narrow gap in the northern caldera rim provides sea-water access into the half-moon-shaped Brouton Bay, which fills the NW half of the caldera.  A central cone, andesitic Urataman volcano, has grown to a height of 678 m during the Holocene in the SE part of the caldera.  Two cinder cones are located along the northern flank of Urataman, and a lava dome was formed on its NW flank along Brouton Bay.  No historical eruptions are known from Urataman.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-191&amp;volpage=photos&amp;photo=091053">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-191">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(47.119999999999997,152.25)
652	Ketoi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ketoi</b></font><br /><font size="5"><b>Kuril Islands (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104068.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1172 m<br /><b>Latitude:</b> 47.35&deg;N<br /><b>Longitude:</b> 152.475&deg;E</td></tr><tr><td colspan="2"><p align="justify">The circular, 10-km-wide Ketoi island, which rises across the 19-km-wide Diana Strait from Simushir Island, hosts of one of the most complex volcanic structures of the Kuril Islands.  The rim of a 5-km-wide Pleistocene caldera is exposed only on the NE side.  A younger 1172-m-high stratovolcano forming the NW part of the island is cut by a horst-and-graben structure containing two solfatara fields.  A 1.5-km-wide freshwater lake fills an explosion crater in the center of the island.  Pallas Peak, a large andesitic cone in the NE part of the caldera, is truncated by a 550-m-wide crater containing a brilliantly colored turquoise crater lake.  Lava flows from Pallas Peak overtop the caldera rim and descend nearly 5 km to the SE coast.  The first historical eruption of Pallas Peak, during 1843-46, was its largest.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-20=&amp;volpage=photos&amp;photo=104068">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-20=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(47.350000000000001,152.47499999999999)
653	Ushishur	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ushishur</b></font><br /><font size="5"><b>Kuril Islands (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/108021.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 401 m<br /><b>Latitude:</b> 47.52&deg;N<br /><b>Longitude:</b> 152.80&deg;E</td></tr><tr><td colspan="2"><p align="justify">The subaerial portion of Ushishur volcano in the central Kuriles is exposed in two small islands, the southern containing the summit caldera and the northern a portion of the volcano's flanks.  A small 1.6-km-wide caldera that formed about 9400 years ago is narrowly breached on the south, allowing sea water to fill the caldera.  Two andesitic lava domes occupy part of the caldera bay; two other older domes are joined by a sand bar to the SE caldera wall.  The two younger domes, erupted sometime after the 1769 visit of Captain Snow, form islands in the bay.  A cluster of strong fumaroles and hot springs along the SE caldera shoreline was a sacred place to 18th- and 19th-century Kurile Ainu peoples, and vigorous submarine hydrothermal activity has modified the geochemistry of sea water within the caldera bay.  Aside from growth of the two younger lava domes, only minor phreatic eruptions have occurred at Ushishur during historical time.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-21=&amp;volpage=photos&amp;photo=108021">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-21=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(47.520000000000003,152.80000000000001)
654	Srednii	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Srednii</b></font><br /><font size="5"><b>Northwest of Ushishur Island</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 36 m<br /><b>Latitude:</b> 47.60&deg;N<br /><b>Longitude:</b> 152.92&deg;E</td></tr><tr><td colspan="2"><p align="justify">Remnants of the Srednii submarine volcano form a hazardous obstruction in the strait between Rasshua and Ushishur Islands.  Flat-topped Khitraya Rock may be a young (Holocene) extrusion dome, and adjoining rocks may be the rim of an old caldera (Gorshkov 1970).  Sapper (1917), Neumann Van Padang (1938), and Gushchenko (1979) reported a submarine eruption between Rasshua and Ushishur Islands on July 12, possibly in 1880 (the year is uncertain).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-211">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(47.600000000000001,152.91999999999999)
655	Rasshua	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Rasshua</b></font><br /><font size="5"><b>Kuril Islands (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104072.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Somma volcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 956 m<br /><b>Latitude:</b> 47.77&deg;N<br /><b>Longitude:</b> 153.02&deg;E</td></tr><tr><td colspan="2"><p align="justify">The elongated 6 x 13 km island of Rasshua in the central Kuriles contains three overlapping central cones within a 6 km caldera whose eastern margin is beyond the shoreline.  An eroded central cone was constructed during the late Pleistocene, along with an isolated cone near the NW coast.  Two Holocene cones were built within the crater of the central cone.  The westernmost forms the 956 m high point of the island and is the source of lava flows that flooded the crater floor and descended to the coast.  The easternmost cone, active during historical time, is truncated by a 500-m-wide crater that is breached to the SE.  This crater may have formed during a violent eruption in 1846.  The only other known historical eruption produced weak explosions in 1957.  Fumarolic activity continues in the eastern crater and in the saddle between the two summit cones.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-22=&amp;volpage=photos&amp;photo=104072">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-22=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(47.770000000000003,153.02000000000001)
656	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>East of Matua Island</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -150 m<br /><b>Latitude:</b> 48.08&deg;N<br /><b>Longitude:</b> 153.33&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Catalog of Active Volcanoes of the World reported an eruption in 1924 from a submarine volcano east of Matua Island in the central Kuriles.  Gorshkov (1970) noted confusion in the literature about the location of this eruption and placed it, based on the original description, north of Toporkovyi islet (Banzio-Iwa).  A small ridge extending northward from Matua and Toporkovyi reaches to a shallow depth at this point.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-23=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(48.079999999999998,153.33000000000001)
657	Sarychev Peak	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sarychev Peak</b></font><br /><font size="5"><b>Matua Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/112021.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Somma volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1496 m<br /><b>Latitude:</b> 48.092&deg;N<br /><b>Longitude:</b> 153.20&deg;E</td></tr><tr><td colspan="2"><p align="justify">Sarychev Peak, one of the most active volcanoes of the Kuril Islands, occupies the NW end of Matua Island in the central Kuriles.  The andesitic central cone was constructed within a 3-3.5 km wide caldera, whose rim is exposed only on the SW side.  A dramatic 250-m-wide, very steep-walled crater with a jagged rim caps the volcano.  The substantially higher SE rim forms the 1496 m high point of the island.  Fresh-looking lava flows descend all sides of Sarychev Peak and often form capes along the coast.  Much of the lower-angle outer flanks of the volcano are overlain by pyroclastic-flow deposits.  Eruptions have been recorded since the 1760's and include both quiet lava effusion and violent explosions.  One of the largest historical eruptions of Sarychev Peak in 1946 produced pyroclastic flows that reached the sea.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-24=&amp;volpage=photos&amp;photo=112021">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-24=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(48.091999999999999,153.19999999999999)
658	Raikoke	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Raikoke</b></font><br /><font size="5"><b>Kuril Islands (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/091058.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 551 m<br /><b>Latitude:</b> 48.292&deg;N<br /><b>Longitude:</b> 153.25&deg;E</td></tr><tr><td colspan="2"><p align="justify">A low, 551-m-high truncated volcano forms the small barren Raikoke Island, which lies 16 km across the Golovnin Strait from Matua Island in the central Kuriles.  The oval-shaped basaltic island is only 2 x 2.5 km wide and rises above a submarine terrace with a depth of 130 m.  The steep-walled crater, highest on the SE side, is 700 m wide and 200 m deep.  Lava flows mantle the eastern side of the island.  A catastrophic eruption of Raikoke in 1778 during which the upper third of the island was said to have been destroyed prompted the first volcanological investigation in the Kuril Islands two years later.  Reports of eruptions in 1777 and 1780 are erroneous (Gorshkov, 1970).  Another powerful eruption in 1924 greatly deepened the crater and changed the outline of the island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-25=&amp;volpage=photos&amp;photo=091058">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-25=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(48.292000000000002,153.25)
659	Chirinkotan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Chirinkotan</b></font><br /><font size="5"><b>Kuril Islands (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/108006.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> 724 m<br /><b>Latitude:</b> 48.98&deg;N<br /><b>Longitude:</b> 153.48&deg;E</td></tr><tr><td colspan="2"><p align="justify">The small, mostly unvegetated 3-km-wide island of Chirinkotan occupies the far end of an E-W-trending volcanic chain that extends nearly 50 km west of the central part of the main Kuril Islands arc.  Chirinkotan is the emergent summit of a volcano that rises 3000 m from the floor of the Kuril Basin.  A small 1-km-wide caldera about 300-400 m deep is open to the SE.  Lava flows from a cone within the breached crater reached the north shore of the island.  Historical eruptions have been recorded at Chirinkotan since the 18th century.  Fresh lava flows also descended the SE flank of Chirinkotan during an eruption in the 1880s that was observed by the English fur trader Captain Snow.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-26=&amp;volpage=photos&amp;photo=108006">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-26=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(48.979999999999997,153.47999999999999)
660	Ekarma	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ekarma</b></font><br /><font size="5"><b>Kuril Islands (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/112020.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 1170 m<br /><b>Latitude:</b> 48.958&deg;N<br /><b>Longitude:</b> 153.93&deg;E</td></tr><tr><td colspan="2"><p align="justify">The small 5 x 7.5 km island of Ekarma lies 8.5 km north of Shiashkotan Island along an E-W-trending volcanic chain extending westward from the central part of the main Kuril Island arc.  Ekarma is composed of two overlapping basaltic-andesite to andesitic volcanoes, the western of which has been historically active.  Lava flows radiate 3 km in all directions from the summit of the younger cone to the sea, forming a lobate shoreline.  A lava dome that was emplaced during the first historical eruption, in 1776-79, forms the peaked, 1170-m-high summit of the island.  The only other historical eruption produced minor explosions in 1980.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-27=&amp;volpage=photos&amp;photo=112020">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-27=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(48.957999999999998,153.93000000000001)
661	Sinarka	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sinarka</b></font><br /><font size="5"><b>Shiashkotan Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104067.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome<br />&nbsp;&nbsp;&nbsp; Somma volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 934 m<br /><b>Latitude:</b> 48.875&deg;N<br /><b>Longitude:</b> 154.175&deg;E</td></tr><tr><td colspan="2"><p align="justify">Sinarka volcano, occupying the northern end of Shiashkotan Island in the central Kuriles, has a complex structure.  A small, 2-km-wide depression open to the NW has been largely filled and overtopped by an andesitic postglacial central cone that itself contains a lava dome that forms the 934 m high point of the island.  Another lava dome, Zheltokamennaya Mountain, lies 1.5 km to the SW along the buried SW rim of the caldera, and a smaller dome lies along the northern caldera rim.  Historical eruptions have occurred at Sinarka during the 17th and 18th centuries.  The last and largest of these, during 1872-78, was once thought to originate from Kuntomintar volcano at the southern end of the island, but is now attributed to Sinarka volcano (Gorshkov, 1970).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-29=&amp;volpage=photos&amp;photo=104067">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-29=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(48.875,154.17500000000001)
662	Kharimkotan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kharimkotan</b></font><br /><font size="5"><b>Kuril Islands (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/086035.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 1145 m<br /><b>Latitude:</b> 49.12&deg;N<br /><b>Longitude:</b> 154.508&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 8 x 12 km island of Kharimkotan (also spelled Harimkotan) in the northern Kuriles consists of a stratovolcano cut by two breached depressions on the east and NW sides.  These horseshoe-shaped craters were formed by slope failure, which produced debris-avalanche deposits that form large broad peninsulas on the east and NW coasts.  Evidence of additional slope failures followed by plinian eruptions are found in sea cliffs of the island.  Historical explosive eruptions have occurred since the early 18th century.  A central cone, Severgin, was largely destroyed during the 1933 eruption, one of the largest in the Kuril Islands during historical time.  Impact of a debris avalanche into the sea from the collapse of Severgin produced a tsunami that swept the island's coast and reached Onekotan and Paramushir Islands, killing two persons.  A large lava dome emplaced during the 1933 eruption now fills the head of the eastern crater.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-30=&amp;volpage=photos&amp;photo=086035">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-30=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(49.119999999999997,154.50800000000001)
663	Tao-Rusyr Caldera	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tao-Rusyr Caldera</b></font><br /><font size="5"><b>Onekotan Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/022068.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 1325 m<br /><b>Latitude:</b> 49.35&deg;N<br /><b>Longitude:</b> 154.70&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 7.5-km-wide Tao-Rusyr caldera on southern Onekotan Island is one of the most impressive volcanoes of the Kuril Islands.  The basaltic-to-andesitic caldera is filled by the deep-blue 7-km-wide Kal'tsevoe lake, whose surface is 400 m above sea level.  The caldera was formed about 7500 years ago during one of the largest Holocene eruptions in the Kuril Islands.  A large symmetrical post-caldera cone, 1325-m-high andesitic Krenitzyn Peak, forms a 4-km wide island that towers high above the caldera rim and fills the NW portion of the caldera lake.  A 350-m-wide, 100-m-deep crater truncates the peak and a large lateral crater is located on the upper NE side.  The only historical eruption of Krenitzyn Peak, in 1952, formed a small, mostly lacustral lava dome in an explosion crater along the east shore of the island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-31=&amp;volpage=photos&amp;photo=022068">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-31=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(49.350000000000001,154.69999999999999)
664	Nemo Peak	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Nemo Peak</b></font><br /><font size="5"><b>Onekotan Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/091060.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 1018 m<br /><b>Latitude:</b> 49.57&deg;N<br /><b>Longitude:</b> 154.808&deg;E</td></tr><tr><td colspan="2"><p align="justify">Nemo Peak volcano at the northern end of Onekotan Island in the northern Kuriles is truncated by two nested calderas of preglacial age, the largest of which is 10 km in diameter and extends to the northern coast.  A third 5-km-wide caldera formed about 25,000 years ago by collapse of an interglacial cone that was constructed over the glaciated surfaces of the earlier calderas.  The 1018-m-high central cone of Nemo Peak is composed of two coalescing andesitic cones that were constructed at the SW side of the youngest caldera and formed in four stages beginning in the early Holocene about 9500 years ago.  Construction of the central cone has left the crescent-shaped Chernoe Lake at the NE end of the youngest caldera; lava flows from Nemo Peak form the broad SW shoreline of the lake.  The final activity built a lava dome that completely overtops a 350-m-wide crater and has a 150-m-wide crater at its summit.  Historical eruptions of Nemo Peak date back to the early-18th century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-32=&amp;volpage=photos&amp;photo=091060">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-32=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(49.57,154.80799999999999)
665	Shirinki	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Shirinki</b></font><br /><font size="5"><b>Kuril Islands (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/022069.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 761 m<br /><b>Latitude:</b> 50.20&deg;N<br /><b>Longitude:</b> 154.98&deg;E</td></tr><tr><td colspan="2"><p align="justify">The small, 3-km-wide island of Shirinki, part of a chain of volcanoes west of the main Kuril Island arc, is located 15 km west of Fuss Peak on Paramushir Island.  The truncated andesitic cone is of Holocene age and rises to a height of 761 m.  The walls of the 750-m-wide breached summit crater extend to the southern coast.  Two lava domes were constructed near the headwall of the breached crater.  No historical eruptions are known from Shirinki, but the summit domes are very young and possibly formed in historical time (Gorshkov, 1970).  The remnants of an older volcano occupy the eastern side of the island, much of which is covered by pumiceous pyroclastic-fall deposits.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-331&amp;volpage=photos&amp;photo=022069">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-331">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(50.200000000000003,154.97999999999999)
666	Fuss Peak	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Fuss Peak</b></font><br /><font size="5"><b>Paramushir Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/091063.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1772 m<br /><b>Latitude:</b> 50.27&deg;N<br /><b>Longitude:</b> 155.25&deg;E</td></tr><tr><td colspan="2"><p align="justify">Fuss Peak in the northern Kuriles forms a peninsula that lies across a low isthmus on the SW coast of Paramushir Island.  The volcano rises 2800 m from the floor of the Sea of Okhotsk to a height of 1772 m.  This isolated symmetrical andesitic stratovolcano has a 700-m-wide, steep-walled crater that is 300 m deep.  A deep notch cuts the NW rim of the crater to the level of the crater floor, at the head of a canyon that reaches the coast.  Well-preserved lava flows occupy the middle and lower flanks, particularly on the east and SE sides.  Only one unambiguous historical eruption, in 1854, is known from Fuss Peak.  Reports of eruptions in 1737, 1793, 1857, and 1859 are false (Gorshkov, 1970).  Murayama (1987) also listed an eruption in 1742 (only earthquakes and a tsunami are cited by Sapper, 1917) and &quot;smoke&quot; emission in 1933.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-34=&amp;volpage=photos&amp;photo=091063">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-34=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(50.270000000000003,155.25)
667	Karpinsky Group	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Karpinsky Group</b></font><br /><font size="5"><b>Paramushir Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/091062.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cones<br />&nbsp;&nbsp;&nbsp; Maar</td><td width="50%" align="left"><b>Summit Elev:</b> 1345 m<br /><b>Latitude:</b> 50.13&deg;N<br /><b>Longitude:</b> 155.37&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Karpinsky group on southern Paramushir Island consists of three Holocene andesitic volcanic centers at the southern end of the Karpinsky Ridge.  A postulated caldera is thought to have been primarily excavated by glaciers (Gorshkov, 1970).  The NE cone has a crater breached to the NW that contains a small horseshoe-shaped cone and a vigorous fumarole along the NE crater wall.  A lava flow originating from the cone traveled 7 km to the SE.  The 1345-m southern cone forms the high point of the Karpinsky massif and fed lava flows to the SE and west.  The NW cone displays hot springs and sulfur cones containing liquid sulfur that is occasionally ejected outward.  A minor ash ejection following an earthquake in 1952 marked the only historical eruption of the Karpinsky group.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-35=&amp;volpage=photos&amp;photo=091062">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-35=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(50.130000000000003,155.37)
668	Lomonosov Group	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Lomonosov Group</b></font><br /><font size="5"><b>Paramushir Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104070.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 1681 m<br /><b>Latitude:</b> 50.25&deg;N<br /><b>Longitude:</b> 155.43&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Lomonosov volcano group, south of Tatarinov volcano on southern Paramushir Island, consists of four cinder cones and a lava dome of Holocene age that were constructed along a N-S line.  The northernmost cone was purely explosive; the second cone, Mount Boryask, produced a 3.5-km-long lava flow that traveled to the east.  The third cone was the source of a lava flow that traveled 5.5 km to the east and NE.  The 1681-m high point of the complex is Lomonosov proper, a lava dome located near the southern end of the volcano group.  It fed a 7-km-long lava flow extending westward nearly to the shore of the Sea of Okhotsk.  The southernmost vent was the source of a lava flow that traveled 4 km initially SE and then east.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-351&amp;volpage=photos&amp;photo=104070">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-351">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(50.25,155.43000000000001)
669	Chikurachki	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Chikurachki</b></font><br /><font size="5"><b>Paramushir Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/091068.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1816 m<br /><b>Latitude:</b> 50.325&deg;N<br /><b>Longitude:</b> 155.458&deg;E</td></tr><tr><td colspan="2"><p align="justify">Chikurachki, the highest volcano on Paramushir Island in the northern Kuriles, is actually a relatively small cone constructed on a high Pleistocene volcanic edifice.  Oxidized basaltic-to-andesitic scoria deposits covering the upper part of the young cone give it a distinctive red color.  Frequent basaltic plinian eruptions have occurred from Chikurachki during the Holocene.  Lava flows from 1816-m-high Chikurachki reached the sea and form capes on the NW coast; several young lava flows also emerge from beneath the scoria blanket on the eastern flank.  The Tatarinov group of six volcanic centers is located immediately to the south of Chikurachki.  In contrast to the frequently active Chikurachki, the Tatarinov volcanoes are extensively modified by erosion and have a more complex structure.  Tephrochronology gives evidence of only one eruption in historical time from Tatarinov, although its southern cone contains a sulfur-encrusted crater with fumaroles that were active along the margin of a crater lake until 1959.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-36=&amp;volpage=photos&amp;photo=091068">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-36=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(50.325000000000003,155.458)
670	Vernadskii Ridge	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Vernadskii Ridge</b></font><br /><font size="5"><b>Paramushir Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104076.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 1183 m<br /><b>Latitude:</b> 50.55&deg;N<br /><b>Longitude:</b> 155.97&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Vernadskii and Bogdanovich volcano groups on northern Paramushir island in the northern Kuriles comprise the two southernmost of three volcano groups on the Vernadskii Ridge, immediately south of the historically active Ebeko volcano group.  The Vernadskii group, at the southern end of the volcanic complex, contains three centers, one of which is topped by a lava dome.  The Bogdanovich group, 4-5 km to the north, is composed of five eruptive  centers that have produced small cones and lava flows.  Gorshkov (1970) considered that eruptive activity at both the Vernadskii and Bogdanovich volcano groups continued into the Holocene.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-37-&amp;volpage=photos&amp;photo=104076">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-37-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(50.549999999999997,155.97)
671	Ebeko	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ebeko</b></font><br /><font size="5"><b>Paramushir Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/022071.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Somma volcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1156 m<br /><b>Latitude:</b> 50.68&deg;N<br /><b>Longitude:</b> 156.02&deg;E</td></tr><tr><td colspan="2"><p align="justify">The flat-topped summit of the central cone of Ebeko volcano, one of the most active in the Kuril Islands, occupies the northern end of Paramushir Island.  Three summit craters located along a SSW-NNE line form Ebeko volcano proper, at the northern end of a complex of five volcanic cones.  Blocky lava flows extend west from Ebeko and SE from the neighboring Nezametnyi cone.  The eastern part of the southern crater of Ebeko contains strong solfataras and a large boiling spring.  The central crater of Ebeko is filled by a lake about 20 m deep whose shores are lined with steaming solfataras; the northern crater lies across a narrow, low barrier from the central crater and contains a small, cold crescentic lake.  Historical activity, recorded since the late-18th century, has been restricted to small-to-moderate explosive eruptions from the summit craters.  Intense fumarolic activity occurs in the summit craters of Ebeko, on the outer flanks of the cone, and in lateral explosion craters.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-38=&amp;volpage=photos&amp;photo=022071">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-38=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(50.68,156.02000000000001)
672	Alaid	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Alaid</b></font><br /><font size="5"><b>Kuril Islands (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/022080.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2339 m<br /><b>Latitude:</b> 50.858&deg;N<br /><b>Longitude:</b> 155.55&deg;E</td></tr><tr><td colspan="2"><p align="justify">The highest and northernmost volcano of the Kuril Islands, 2339-m-high Alaid is a symmetrical stratovolcano when viewed from the north, but has a 1.5-km-wide summit crater that is breached widely to the south.  Alaid is the northernmost of a chain of volcanoes constructed west of the main Kuril archipelago and rises 3000 m from the floor of the Sea of Okhotsk.  Numerous pyroclastic cones dot the lower flanks of basaltic to basaltic-andesite Alaid volcano, particularly on the NW and SE sides, including an offshore cone formed during the 1933-34 eruption.  Strong explosive eruptions have occurred from the summit crater beginning in the 18th century.  Reports of eruptions in 1770, 1789, 1821, 1829, 1843, 1848, and 1858 were considered incorrect by Gorshkov (1970).  Explosive eruptions at Alaid in 1790 and 1981 were among the largest in the Kuril Islands during historical time.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-39=&amp;volpage=photos&amp;photo=022080">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=0900-39=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td></tr></table>	(50.857999999999997,155.55000000000001)
673	Mashkovtsev	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mashkovtsev</b></font><br /><font size="5"><b>Kamchatka Peninsula (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104079.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 503 m<br /><b>Latitude:</b> 51.10&deg;N<br /><b>Longitude:</b> 156.72&deg;E</td></tr><tr><td colspan="2"><p align="justify">Mashkovtsev, the southernmost Holocene volcano of Kamchatka (Masurenkov 1980), forms a small peninsula on the Sea of Okhotsk near the southern tip of Kamchatka.  The small 503-m-high basaltic stratovolcano has a postglacial summit cone (Sviatlovsky 1959).  Two Holocene basaltic cones are located to the north.  The age assignments of southern Kamchatkan volcanoes primarily reflect the work of Kozhemyaka, Ogorodov, and Litasov.  In cases where radiometric ages are lacking, age assignments are based primarily on a geologic or sometimes strictly morphologic basis.  The complex volcanic history of this region reflects several cycles of volcanism, with frequent overprinting of young basaltic cinder cones and small stratovolcanoes on eroded Pleistocene volcanoes.  In general, when several Holocene cones are superimposed on an older edifice, the volcano is classified as Holocene; a single flank Holocene cone is listed separately and the older volcano is classified as Pleistocene.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-001&amp;volpage=photos&amp;photo=104079">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-001">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(51.100000000000001,156.72)
674	Kambalny	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kambalny</b></font><br /><font size="5"><b>Kamchatka Peninsula (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/059050.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Compound volcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2156 m<br /><b>Latitude:</b> 51.30&deg;N<br /><b>Longitude:</b> 156.87&deg;E</td></tr><tr><td colspan="2"><p align="justify">The southernmost major stratovolcano on the Kamchatka peninsula, 2156-m-high Kambalny has a summit crater that is breached to the SE.  There are no records of historical eruptions from Kambalny although its very youthful volcanic features suggest the possibility of very recent eruptions.  Five Holocene cinder cones on the west and SE flanks have produced fresh-looking lava flows.  Beginning about 6300 radiocarbon years ago, a series of major collapses of the edifice produced at least three debris-avalanche deposits.  The last major eruption took place about 600 years ago, although younger tephra layers have been found, an a historical eruption was reported in 1767.  Active fumarolic areas are found on the flanks of the volcano, which is located south of the massive Pauzhetka volcano-tectonic depression.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-01=&amp;volpage=photos&amp;photo=059050">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(51.299999999999997,156.87)
675	Koshelev	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Koshelev</b></font><br /><font size="5"><b>Southern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/059051.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Compound volcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1812 m<br /><b>Latitude:</b> 51.357&deg;N<br /><b>Longitude:</b> 156.75&deg;E</td></tr><tr><td colspan="2"><p align="justify">Koshelev is the southernmost historically active volcano on the Kamchatka Peninsula.  Located SW of the Pauzhetka volcano-tectonic depression and NW of Kambalny volcano, Koshelev is a complex group of four stratovolcanoes constructed along an E-W line over a Pleistocene shield volcano.  Central Koshelev stratovolcano, the highest peak of the volcanic massif, is Holocene in age; north- and SE-flank craters have also been active during the Holocene.   Gorely, a Holocene cinder cone related to regional basaltic monogenetic volcanicm, is located about 12 km NW of Koshelev.  The largest Holocene eruption at Koshelev took place from the eastern cone about 6500 years ago.  An explosive eruption was reported from Koshelev at the end of the 17th century.  Major thermal fields are located in the summit crater of Valentin volcano and on the western flanks of west Koshelev volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-02=&amp;volpage=photos&amp;photo=059051">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(51.356999999999999,156.75)
676	Yavinsky	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Yavinsky</b></font><br /><font size="5"><b>Southern Kamchatka</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Cinder cone</td><td width="50%" align="left"><b>Summit Elev:</b> 705 m<br /><b>Latitude:</b> 51.57&deg;N<br /><b>Longitude:</b> 156.60&deg;E</td></tr><tr><td colspan="2"><p align="justify">Yavinsky is a lower- to mid-Pleistocene basaltic volcano that forms an arcuate ridge (Yavinsky Khrebet) along the SW coast of Kamchatka overlooking the town of Ozernovsky and the mouth of the Ozernaya River.  A Holocene basaltic cinder cone named Ukho, related to regional basaltic monogenetic volcanism, was constructed on the NW flank of 705-m-high Yavinsky.  Ukho, whose name in Russian means &quot;Ear,&quot; was formed about 6000 years ago, based on stratigraphic evidence.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-021">Smithsonian Volcano Information</a></td></tr></table>	(51.57,156.59999999999999)
677	Diky Greben	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Diky Greben</b></font><br /><font size="5"><b>Southern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/057027.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 1070 m<br /><b>Latitude:</b> 51.45&deg;N<br /><b>Longitude:</b> 156.97&deg;E</td></tr><tr><td colspan="2"><p align="justify">Diky Greben is a late-stage Holocene lava-dome complex that formed in the center of the 20 x 25 km Pauzhetka caldera.  This large caldera was associated with eruption of the voluminous rhyolitic Golygin ignimbrite during the late Pleistocene, about 0.443 million years ago.  Both Diky Greben and the Kurile Lake caldera, immediately to the east, are Holocene volcanoes constructed within the Pauzhetka caldera.  The initial eruptions of Diky Greben took place about 7600-7700 years ago, immediately following the Kurile Lake eruption.  Most of the volcano, particularly the thick lava flows north and south of Nepriyatnaya Mountain, was formed during an eruption about 1600 years ago.   A total of 9-10 cu km of dacitic and 2-3 cu km of andesitic lavas and tephras were erupted at this time.  Two large craters and a few smaller vents were formed after this eruption.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-022&amp;volpage=photos&amp;photo=057027">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-022">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(51.450000000000003,156.97)
678	Kurile Lake	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kurile Lake</b></font><br /><font size="5"><b>Southern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/057029.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Tuff cones</td><td width="50%" align="left"><b>Summit Elev:</b> 81 m<br /><b>Latitude:</b> 51.45&deg;N<br /><b>Longitude:</b> 157.12&deg;E</td></tr><tr><td colspan="2"><p align="justify">Kurile Lake caldera is one of the most impressive volcanic features in Kamchatka.  It lies within the eastern part of the massive Pauzhetka caldera, but is considered as a separate volcanic system here.  The low-rimmed Kurile Lake caldera was formed in two stages during the late Pleistocene and early Holocene.  The first caldera-forming eruption took place about 41,500 radiocarbon years ago.  The second episode of caldera formation occurred about 7600 radiocarbon years ago during one of the world's largest Holocene eruptions.  A total of 140-170 cu km of material was ejected, and extensive thick pyroclastic-flow deposits from the caldera-forming eruptions blanket the countryside.  Ash from the eruption, one of the world's largest during the Holocene, fell more than 1000 km away on the Asia mainland.  The eruption resulted in the formation of an 8 x 14 km wide caldera, now largely filled by Kurile Lake.  The steep-sided Serdtze Alaida (Heart of Alaid), which forms a small island rising 300 m from the caldera floor in the center of the lake, is a rhyodacitic lava dome that formed at the end of the caldera-forming eruption.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-023&amp;volpage=photos&amp;photo=057029">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-023">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(51.450000000000003,157.12)
679	Ilyinsky	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ilyinsky</b></font><br /><font size="5"><b>Southern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/057054.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1578 m<br /><b>Latitude:</b> 51.490&deg;N<br /><b>Longitude:</b> 157.20&deg;E</td></tr><tr><td colspan="2"><p align="justify">The conical Ilyinsky volcano, rising dramatically to 1578 m above the NE shore of Kurile Lake, was constructed beginning about 7600 radiocarbon years ago at the NE margin of Kurile Lake caldera.  The modern edifice grew within a 4-km-wide caldera produced by collapse of an earlier volcano creating large debris avalanches at about the time of formation of the adjacent Kurile Lake caldera.  A period of strong silicic explosive volcanism during the mid-Holocene lasted about 800 years.  A series of youthful lava flows cover much of the northern flanks of Ilyinsky.  Growth of the modern cone was completed about 1900 years ago, after which a long quiescent period began.  The only recorded historical eruption, in 1901, produced a large 1-km-wide crater on the NE flank.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-03=&amp;volpage=photos&amp;photo=057054">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(51.490000000000002,157.19999999999999)
680	Zheltovsky	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Zheltovsky</b></font><br /><font size="5"><b>Southern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/022084.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1953 m<br /><b>Latitude:</b> 51.57&deg;N<br /><b>Longitude:</b> 157.323&deg;E</td></tr><tr><td colspan="2"><p align="justify">Zheltovsky volcano was constructed during the last 8000 years within a 4 x 5 km caldera truncating an earlier Pleistocene edifice.  A late-Holocene explosive eruption formed a 1.6-km-wide summit crater that was subsequently largely filled by four lava domes, the latest of which forms the present 1953-m-high summit.  Several of the lava domes were emplaced along the buried SE rim of the summit crater.  More than ten cinder cones and lava domes were constructed on the flanks, particularly on the NW side.  Only a few eruptions are known in historical time.  The largest, in 1923, produced explosive activity and a lava flow down the SE flank that also partly flowed into the summit crater.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-04=&amp;volpage=photos&amp;photo=022084">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-04=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(51.57,157.32300000000001)
681	Kell	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kell</b></font><br /><font size="5"><b>Southern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/105092.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 900+ m<br /><b>Latitude:</b> 51.65&deg;N<br /><b>Longitude:</b> 157.35&deg;E</td></tr><tr><td colspan="2"><p align="justify">Kell volcano is a small Holocene stratovolcano constructed within the Pizrak caldera, immediately north of Zheltovsky volcano (Masurenkov, 1980).  This remote volcanic complex consists of three partially nested 3-5 km wide calderas containing lava domes and several small stratovolcanoes, the largest of which is 900-m-high Kell volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-041&amp;volpage=photos&amp;photo=105092">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-041">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(51.649999999999999,157.34999999999999)
682	Belenkaya	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Belenkaya</b></font><br /><font size="5"><b>Southern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/113009.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 892 m<br /><b>Latitude:</b> 51.75&deg;N<br /><b>Longitude:</b> 157.27&deg;E</td></tr><tr><td colspan="2"><p align="justify">Belenkaya is a small Holocene basaltic volcano (Masurenkov, 1980) that lies SW of Ksudach volcano and NW of Kell volcano.  The conical, 892-m-high stratovolcano rises 700 m above a topographic low in the center of the southern Kamchatka Peninsula.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-042&amp;volpage=photos&amp;photo=113009">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-042">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(51.75,157.27000000000001)
683	Ksudach	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ksudach</b></font><br /><font size="5"><b>Southern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/057039.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1079 m<br /><b>Latitude:</b> 51.80&deg;N<br /><b>Longitude:</b> 157.53&deg;E</td></tr><tr><td colspan="2"><p align="justify">Ksudach is unique among Kamchatka volcanoes in its morphology and geologic history.  It is a large, low-angle stratovolcano, constructed of alternating basaltic-andesitic lavas and dacitic pyroclastics, and is truncated by an intricate complex of five calderas.  An array of post-caldera structures at Ksudach is truncated by later calderas, the last three of which formed during the Holocene, about 7900 and 5000 BC and about 240 AD.  The latter eruption was the second largest in Kamchatka during the Holocene, and produced about 20 cu km of rhyodacitic airfall tephra and 3-4 cu km of pyroclastic flows.  The eastern part of the caldera complex contains two lakes, the northern of which forms an embayment in Stubel Crater, a low-angle cone that began forming about 1600 years ago in the youngest caldera.  The only historical eruption of Ksudach, in 1907, originated from Stubel Crater and was one of Kamchatka's largest in historical time.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-05=&amp;volpage=photos&amp;photo=057039">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-05=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(51.799999999999997,157.53)
684	Ozernoy	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ozernoy</b></font><br /><font size="5"><b>Southern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/113011.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 562 m<br /><b>Latitude:</b> 51.88&deg;N<br /><b>Longitude:</b> 157.38&deg;E</td></tr><tr><td colspan="2"><p align="justify">Ozernoy is a small early Holocene basaltic shield volcano (Masurenkov, 1980) that is dwarfed by its neighbor to the SE, massive Ksudach volcano.  The 562-m-high Ozernoy has a volume of only 2 cu km and rises 300 m above the floor of a valley in the center of the southern Kamchatka Peninsula.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-051&amp;volpage=photos&amp;photo=113011">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-051">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(51.880000000000003,157.38)
685	Olkoviy Volcanic Group	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Olkoviy Volcanic Group</b></font><br /><font size="5"><b>Southern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/113012.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 681 m<br /><b>Latitude:</b> 52.02&deg;N<br /><b>Longitude:</b> 157.53&deg;E</td></tr><tr><td colspan="2"><p align="justify">A large group of Pleistocene-to-Holocene basaltic pyroclastic cones and associated lava flows (Masurenkov, 1980) fills a topographic low north of Ksudach volcano and SW of Khodutka volcano.  The Pleistocene Plosky volcano and the Holocene shield volcano Olkoviy lie near the north end of this group of NE-SW-trending cones.  The small 636-m-high Olkoviy shield volcano rises 350 m above the valley floor.  Growth of the cone diverted the headwaters of the Savan River in a broad arc to the east.  The eastern and southern margins of the volcanic field are bounded by the Pravaya Khodutka and Zapadnaya Khodutka Rivers, respectively.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-052&amp;volpage=photos&amp;photo=113012">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-052">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(52.020000000000003,157.53)
686	Khodutka	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Khodutka</b></font><br /><font size="5"><b>Southeastern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/057016.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2090 m<br /><b>Latitude:</b> 52.063&deg;N<br /><b>Longitude:</b> 157.703&deg;E</td></tr><tr><td colspan="2"><p align="justify">Khodutka stratovolcano was formed during the late-Pleistocene to early Holocene SE of an older stratovolcano, Priemysh.  At least 10 explosion craters, small lava cones, and lava domes are located along the flanks, and Holocene cinder cones produced by regional basaltic volcanism occur to the west.  The Khodutkinsky maar on the WNW flank was created about 2800 years ago during an eruption that deposited tephra across much of southern Kamchatka.  Formation of the twin maar was accompanied by small pyroclastic flows and followed by the emplacement of lava flows and domes.  The last dated eruption took place from the summit vent of Khodutka about 2000-2500 years ago.  The Khodutka Springs geothermal field occupies an explosion crater on the NW flank of Priemysh volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-053&amp;volpage=photos&amp;photo=057016">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-053">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(52.063000000000002,157.703)
687	Piratkovsky	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Piratkovsky</b></font><br /><font size="5"><b>Southeastern Kamchatka</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 1322 m<br /><b>Latitude:</b> 52.113&deg;N<br /><b>Longitude:</b> 157.849&deg;E</td></tr><tr><td colspan="2"><p align="justify">Piratkovsky, a mid-Pleistocene to Holocene stratovolcano with a small caldera (Masurenkov, 1980), was constructed NE of Khodutka volcano.  The 1322-m-high volcano partially overlaps Pleistocene volcanoes to the NW and lies at the eastern margin of the Quaternary volcanic chain of southern Kamchatka.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-054">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(52.113,157.84899999999999)
688	Ostanets	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ostanets</b></font><br /><font size="5"><b>Southern Kamchatka</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 719 m<br /><b>Latitude:</b> 52.146&deg;N<br /><b>Longitude:</b> 157.322&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Holocene Ostanets shield volcano (Masurenkov, 1980), located south of the Pleistocene Savan volcano, is surrounded by a large group of late-Pleistocene to Holocene cinder cones.  Small pyroclastic cone groups also occur north and east of Igolki volcano, which is located about 30 km SW of Savan volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-055">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(52.146000000000001,157.322)
689	Otdelniy	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Otdelniy</b></font><br /><font size="5"><b>Southern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/113013.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 791 m<br /><b>Latitude:</b> 52.220&deg;N<br /><b>Longitude:</b> 157.428&deg;E</td></tr><tr><td colspan="2"><p align="justify">The early Holocene Otdelniy shield volcano (Masurenkov, 1980) lies east of the Savan River, across from the Pleistocene Savan volcano.  The 719-m-high Otdelniy lies at the west end of a large group of late-Pleistocene to Holocene pyroclastic cones.  It, along with Tundroviy and adjacent unnamed shield volcanoes, is adjacent to a large group of late-Pleistocene to Holocene basaltic pyroclastic cones located about halfway between Khodutka and Opala volcanoes.  The cones and associated lava fields are located at the headwaters of the Savan and Asacha rivers, which drain to the Sea of Okhotsk and the Pacific Ocean, respectively.  Three groups of late-Pleistocene to Holocene pyroclastic cones and associated lava fields are also located along a roughly 20-km-wide area between the Opala and Savan rivers, SE, south, and SW of massive Opala volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-056&amp;volpage=photos&amp;photo=113013">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-056">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(52.219999999999999,157.428)
690	Golaya	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Golaya</b></font><br /><font size="5"><b>Southern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/113014.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 858 m<br /><b>Latitude:</b> 52.263&deg;N<br /><b>Longitude:</b> 157.787&deg;E</td></tr><tr><td colspan="2"><p align="justify">Golaya is a small basaltic stratovolcano of Pleistocene-to-Holocene age  (Masurenkov, 1980) south of Asacha volcano.  The 858-m-high volcano is elongated in a N-S direction and overlooks small shield volcanoes and cinder cones related to regional basaltic volcanism near the headwaters of the Asacha River.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-057&amp;volpage=photos&amp;photo=113014">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-057">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(52.262999999999998,157.78700000000001)
691	Asacha	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Asacha</b></font><br /><font size="5"><b>Southern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/058016.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1910 m<br /><b>Latitude:</b> 52.355&deg;N<br /><b>Longitude:</b> 157.827&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Asacha group is a complex massif of Pleistocene-to-Holocene volcanoes located within a distinctly fault-bounded crustal block WSW of Mutnovsky volcano.  An ancestral Asacha shield volcano, Zheltyi stratovolcano to the east, a younger Asacha stratovolcano, and the small Tumanov lava cone (the best-preserved major cone of the Asacha volcano group) were constructed during the late Pleistocene.  Ten lava domes dot the flanks of the Asacha volcanoes.  Most of these were formed during the Pleistocene, but some may be early Holocene in age.  Also during the Holocene, basaltic cinder cones and lava flows related to regional volcanism were erupted along the western and southern flanks of the Asacha complex.  A major volcano-tectonic earthquake swarm occurred near Zheltyi volcano in 1983, suggesting that the complex remains volcanically active.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-058&amp;volpage=photos&amp;photo=058016">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-058">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(52.354999999999997,157.827)
692	Visokiy	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Visokiy</b></font><br /><font size="5"><b>Southern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/022093.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1234 m<br /><b>Latitude:</b> 52.43&deg;N<br /><b>Longitude:</b> 157.93&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Holocene basaltic Visokiy stratovolcano is located between Asacha and Mutnovsky volcanoes.  Golyi shield volcano, also of Holocene age, lies immediately to the WSW (Masurenkov, 1980; Kozhemyaka et al., 1984).  Cinder cones related to regional basaltic volcanism surround 1234-m-high Visokiy volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-059&amp;volpage=photos&amp;photo=022093">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-059">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(52.43,157.93000000000001)
693	Mutnovsky	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mutnovsky</b></font><br /><font size="5"><b>Southern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/022094.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2322 m<br /><b>Latitude:</b> 52.453&deg;N<br /><b>Longitude:</b> 158.195&deg;E</td></tr><tr><td colspan="2"><p align="justify">Massive Mutnovsky, one of the most active volcanoes of southern Kamchatka, is formed of four coalescing stratovolcanoes of predominately basaltic composition.  Multiple summit craters cap the volcanic complex.  Growth of Mutnovsky IV, the youngest cone, began during the early Holocene.  An intracrater cone was constructed along the northern wall of the 1.3-km-wide summit crater.  Abundant flank cinder cones were concentrated on the SW side.  Holocene activity was characterized by mild-to-moderate phreatic and phreatomagmatic eruptions from the summit crater.  Historical eruptions have been explosive, with lava flows produced only during the 1904 eruption.  Geothermal development is planned at Mutnovsky, which has the highest heat capacity of any volcano in the Kuril-Kamchatka arc.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-06=&amp;volpage=photos&amp;photo=022094">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-06=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(52.453000000000003,158.19499999999999)
694	Gorely	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Gorely</b></font><br /><font size="5"><b>Southern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/023009.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Compound volcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1829 m<br /><b>Latitude:</b> 52.558&deg;N<br /><b>Longitude:</b> 158.03&deg;E</td></tr><tr><td colspan="2"><p align="justify">Gorely volcano, one of the most active in southern Kamchatka, consists of five small overlapping stratovolcanoes constructed along a WNW-ESE line within a large 9 x 13.5 km caldera.  The caldera formed about 38,000-40,000 years ago accompanied by the eruption of about 100 cu km of tephra.  The massive Gorely complex contains 11 summit and 30 flank craters, some of which contain acid or freshwater crater lakes; three major rift zones cut the complex.  Another Holocene stratovolcano (peak 1082) is located on the SW flank of Gorely.  Activity during the Holocene was characterized by frequent mild-to-moderate explosive eruptions along with a half dozen episodes of major lava extrusion.  Early Holocene explosive activity, along with lava flows filled in much of the caldera.  Quiescent periods became longer between 6000 and 2000 years ago, after which the activity was mainly explosive.  About 600-650 years ago intermittent strong explosions and lava flow effusion accompanied frequent mild eruptions.  Historical eruptions have consisted of vulcanian and phreatic explosions of moderate volume.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-07=&amp;volpage=photos&amp;photo=023009">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-07=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(52.558,158.03)
695	Opala	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Opala</b></font><br /><font size="5"><b>Southern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/023012.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2475 m<br /><b>Latitude:</b> 52.543&deg;N<br /><b>Longitude:</b> 157.335&deg;E</td></tr><tr><td colspan="2"><p align="justify">Steep-sided, conical Opala stratovolcano is one of the most dramatic volcanoes of southern Kamchatka.  The 2475-m-high volcano was constructed during the late-Pleistocene to Holocene at the northern end of the 12 x 14 km, 40,000-year-old Opala caldera.  The volcano has produced andesitic-dacitic lavas and tephras through most of the Holocene.  The latest major explosive eruption formed the prominent Barany Amphitheater on the SE flank about 1500 years ago, producing a voluminous 9-10 cu km regional tephra marker layer of rhyolitic composition.  The 2 x 2.5 km crater is filled by a lava dome 1 km wide.  Mild explosive eruptions have been reported from summit and flank vents at Opala in historical time, although no associated tephra deposits have been found.  Recent tephrochronological work has revealed evidence, however, for a large explosive eruption from the summit crater about 300 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-08=&amp;volpage=photos&amp;photo=023012">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-08=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(52.542999999999999,157.33500000000001)
696	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>Southern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/113015.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cone</td><td width="50%" align="left"><b>Summit Elev:</b> 610? m<br /><b>Latitude:</b> 52.57&deg;N<br /><b>Longitude:</b> 157.02&deg;E</td></tr><tr><td colspan="2"><p align="justify">A single unnamed Holocene cinder cone (Masurenkov, 1980) is located on the SE flank of the massive early Pleistocene Bolshaya Ipelka shield volcano, the largest volcanic structure of southern Kamchatka (Erlich 1985, pers. comm.).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-081&amp;volpage=photos&amp;photo=113015">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-081">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(52.57,157.02000000000001)
697	Tolmachev Dol	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tolmachev Dol</b></font><br /><font size="5"><b>Southern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/103051.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1021 m<br /><b>Latitude:</b> 52.63&deg;N<br /><b>Longitude:</b> 157.58&deg;E</td></tr><tr><td colspan="2"><p align="justify">Tolmachev Dol (Tomachev Plateau) is broad volcanic highland NE of Opala volcano that is dotted with numerous late-Pleistocene and Holocene cinder cones and associated lava flows.  The cones and lava fields cover a broad area on both sides of scenic Lake Tolmachev, which lies in large depression halfway between Opala and Gorely volcanoes.  The 1415-m-high Tolmachev stratovolcano of Pleistocene age lies on the SE side of the lake.  A major explosive eruption took place about 4600 years ago from Chasa crater in the northern part of the plateau, during which about 1 cu km of rhyolitic tephra was ejected.  The latest dated eruption at Tolmachev Dol occurred from a cinder cone in the NW part of the plateau about 1600-1700 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-082&amp;volpage=photos&amp;photo=103051">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-082">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(52.630000000000003,157.58000000000001)
698	Vilyuchik	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Vilyuchik</b></font><br /><font size="5"><b>Southern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/023014.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2173 m<br /><b>Latitude:</b> 52.70&deg;N<br /><b>Longitude:</b> 158.28&deg;E</td></tr><tr><td colspan="2"><p align="justify">Vilyuchik, also known as Viliuchinsky or Uilyuchinsky, is a steep-sided Pleistocene-to-Holocene stratovolcano that forms a prominent landmark south of Avachinsky Bay.  Deep erosional gullies dissect the flanks of the 2173-m-high volcano.  Lava domes and young basaltic cinder cones were constructed at its base.  Most of the growth of the volcano took place during the late Pleistocene.  The last significant eruption took place from the summit crater about 10,000 years ago, producing a moderate airfall deposit and a lava flow.  Landslides and rock avalanches from the steep-sided volcano have affected habited areas.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-083&amp;volpage=photos&amp;photo=023014">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-083">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(52.700000000000003,158.28)
699	Barkhatnaya Sopka	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Barkhatnaya Sopka</b></font><br /><font size="5"><b>Southeastern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/103063.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 870 m<br /><b>Latitude:</b> 52.823&deg;N<br /><b>Longitude:</b> 158.27&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Pleistocene Barkhatnaya Sopka ring complex of andesitic-to-rhyolitic lava domes, located along the Paratunka River NW of Vilyuchik volcano, also contains Holocene basaltic  pyroclastic cones.  Most of the younger cones lie on the south and SE sides of the dome complex.  The Barkhatnaya Sopka cinder cone formed after the middle Holocene (Ponomareva 1992, pers. comm.).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-084&amp;volpage=photos&amp;photo=103063">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-084">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(52.823,158.27000000000001)
700	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>Southeastern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/105091.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 450+ m<br /><b>Latitude:</b> 52.92&deg;N<br /><b>Longitude:</b> 158.52&deg;E</td></tr><tr><td colspan="2"><p align="justify">A group of four small basaltic shield volcanoes and cinder cones of late-Pleistocene to Holocene age is located along a 20-km-long NW-SE-trending line along the south side of Avacha Bay (Luchitsky, 1974).  One of the volcanoes forms a narrow peninsula extending NW into Avacha Bay NW of the town of Tar'ya, another lies south of Avacha Bay, and the SE-most of these volcanoes lies near the Pacific coast opposite Sarannay Bay.  A linear group of small dacitic-to-rhyolitic lava domes of Pleistocene age lies along a NE-SW trend near the shore of the bay.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-085&amp;volpage=photos&amp;photo=105091">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-085">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(52.920000000000002,158.52000000000001)
701	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>Southeastern Kamchatka</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 700? m<br /><b>Latitude:</b> 52.88&deg;N<br /><b>Longitude:</b> 158.30&deg;E</td></tr><tr><td colspan="2"><p align="justify">A group of small basaltic shield volcanoes and cinder cones of Holocene age is located east of the Paratunka River, SW of Petropavlovsk-Kamchatskiy (Luchitsky, 1974).  The shield volcanoes are located along a N-S-trending line, with most of the cinder cones being located to the SE.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-086">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(52.880000000000003,158.30000000000001)
702	Bolshe-Bannaya	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bolshe-Bannaya</b></font><br /><font size="5"><b>Southeastern Kamchatka</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 1200+ m<br /><b>Latitude:</b> 52.90&deg;N<br /><b>Longitude:</b> 157.78&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Bolshe-Bannaya ring complex, located north of the Bannaya River WSW of Petropavlovsk-Kamchatskiy, contains a group of Pleistocene andesitic-to-rhyolitic lava domes and late-Pleistocene to Holocene pyroclastic cones (Luchitsky, 1974).  It lies within the massive 17 x 32 km wide early Pleistocene Karymshina caldera, which produced about 800 cu km of rhyolitic ignimbrite about 1.78 million years ago. Two areas of late-Pleistocene to Holocene basaltic lava flows are located SE of the ring complex, and another group of younger cones and flows occurs to the NW.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-087">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(52.899999999999999,157.78)
703	Koryaksky	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Koryaksky</b></font><br /><font size="5"><b>Eastern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/023018.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3456 m<br /><b>Latitude:</b> 53.320&deg;N<br /><b>Longitude:</b> 158.688&deg;E</td></tr><tr><td colspan="2"><p align="justify">The large symmetrical Koryaksky stratovolcano is the most prominent landmark of the NW-trending Avachinskaya volcano group, which towers above Kamchatka's largest city, Petropavlovsk.  Erosion has produced a ribbed surface on the eastern flanks of the 3456-m-high volcano; the youngest lava flows are found on the upper western flank and below SE-flank cinder cones.  No strong explosive eruptions have been documented during the Holocene.  Extensive Holocene lava fields on the western flank were primarily fed by summit vents; those on the SW flank originated from flank vents.  Lahars associated with a period of lava effusion from south- and SW-flank fissure vents about 3900-3500 years ago reached Avacha Bay.  Only a few moderate explosive eruptions have occurred during historical time.  Koryaksky's first historical eruption, in 1895, also produced a lava flow.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-09=&amp;volpage=photos&amp;photo=023018">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-09=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(53.32,158.68799999999999)
704	Avachinsky	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Avachinsky</b></font><br /><font size="5"><b>Eastern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/023035.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2741 m<br /><b>Latitude:</b> 53.255&deg;N<br /><b>Longitude:</b> 158.830&deg;E</td></tr><tr><td colspan="2"><p align="justify">Avachinsky, one of Kamchatka's most active volcanoes, rises above Petropavlovsk, Kamchatka's largest city.  Avachinsky began to form during the middle or late Pleistocene and is flanked to the SE by the parasitic volcano Kozelsky, which has a large crater breached to the NE.  Avachinsky has a large horseshoe-shaped caldera, breached to the SW, that was formed when a major debris avalanche about 30,000-40,000 years ago buried an area of about 500 sq km to the south underlying the city of Petropavlovsk.  Reconstruction of the volcano took place in two stages, the first of which began about 18,000 years before present (BP), and the second 7000 years BP.  Most eruptive products have been explosive, with pyroclastic flows and hot lahars being directed primarily to the SW by the breached caldera, although relatively short lava flows have been emitted.  The frequent historical eruptions of Avachinsky have been similar in style and magnitude to previous Holocene eruptions.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-10=&amp;volpage=photos&amp;photo=023035">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-10=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(53.255000000000003,158.83000000000001)
705	Dzenzursky	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Dzenzursky</b></font><br /><font size="5"><b>Eastern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/058017.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Compound volcano<br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 2285 m<br /><b>Latitude:</b> 53.637&deg;N<br /><b>Longitude:</b> 158.922&deg;E</td></tr><tr><td colspan="2"><p align="justify">Dzenzursky is a strongly eroded stratovolcano of Pleistocene age that lies along a ridge extending NW from Zhupanovsky volcano.  After a long quiescence, eruptions resumed during the Holocene.  A series of cinder and lava cones along a ridge trending east and SE of the volcano produced extensive fresh-looking lava fields with flows that traveled primarily to the NE.  Two historical eruptions have been reported (Vlodavetz and Piip 1959, Firstov et al. 1979), however Fedotov and Masurenkov (1991) did not list historical eruptions, and Ponomareva (1992, pers. comm.) stated that these reports actually consisted of hydrothermal or fumarolic activity.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-11=&amp;volpage=photos&amp;photo=058017">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-11=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(53.637,158.922)
706	Zhupanovsky	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Zhupanovsky</b></font><br /><font size="5"><b>Eastern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/023038.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Compound volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2958 m<br /><b>Latitude:</b> 53.590&deg;N<br /><b>Longitude:</b> 159.147&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Zhupanovsky volcanic massif consists of four overlapping stratovolcanoes along a WNW-trending ridge.  The elongated volcanic complex was constructed within a Pliocene-early Pleistocene caldera whose rim is exposed only on the eastern side.  Three of the stratovolcanoes were built during the Pleistocene, the fourth is Holocene in age and was the source of all of Zhupanovsky's historical eruptions.  An early Holocene stage of frequent moderate and weak eruptions from 7000 to 5000 years before present (BP) was succeeded by a period of infrequent larger eruptions that produced pyroclastic flows.  The last major eruption of Zhupanovsky took place about 800-900 years BP.  Historical eruptions have consisted of relatively minor explosions from the third cone.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-12=&amp;volpage=photos&amp;photo=023038">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-12=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(53.590000000000003,159.14699999999999)
707	Veer	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Veer</b></font><br /><font size="5"><b>Eastern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/103061.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 520? m<br /><b>Latitude:</b> 53.75&deg;N<br /><b>Longitude:</b> 158.45&deg;E</td></tr><tr><td colspan="2"><p align="justify">Cinder cones along the Levaya Avacha River about 60 km north of Petropavlovsk-Kamchatskiy erupted lavas over young river terraces.  The basaltic Veer cone, located on the west side of the Levaya Avacha (Left Avacha River, produced a fresh-looking lava flow with prominent flow ridges that descended into the river valley.  Although Krijanovsky (1934) listed an 1856 eruption, stratigraphic studies have shown that the eruption of Veer occurred sometime between the 1500 years before present (BP) eruption from Barany Amphitheater of Opala volcano and a 1630 yr BP eruption from Avachinsky volcano (Dirksen 1999, pers. comm.).  Nearby andesitic Pravy volcano is also of postglacial age.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-121&amp;volpage=photos&amp;photo=103061">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-121">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(53.75,158.44999999999999)
708	Kostakan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kostakan</b></font><br /><font size="5"><b>Eastern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/103059.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Maar</td><td width="50%" align="left"><b>Summit Elev:</b> 1150 m<br /><b>Latitude:</b> 53.83&deg;N<br /><b>Longitude:</b> 158.05&deg;E</td></tr><tr><td colspan="2"><p align="justify">A N-S-trending chain of basaltic cinder cones lies south of Bakening volcano, west of the Srednaya Avacha (Middle Avacha) river valley.  The Kostakan cone group is part of a broad zone of regional basaltic volcanism affecting areas west of the Eastern volcanic zone of Kamchatka.  It extends from the Kostakan Lake area to the south and has been active from the late Pleistocene to Holocene.  Several of the cinder cones are breached by lava flows, some of which extend into the Srednaya Avacha valley.  The highest-elevation vent, 1150-m-high Zmeya crater, was constructed within a landslide scarp.  An unnamed maar is located about 2 km south of Kostakan Lake.  Eruptions have occurred during two time periods, between about 11,000 to 7000 years ago and between about 1200 and 600 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-122&amp;volpage=photos&amp;photo=103059">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-122">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(53.829999999999998,158.05000000000001)
709	Bakening	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bakening</b></font><br /><font size="5"><b>Eastern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/023040.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2278 m<br /><b>Latitude:</b> 53.905&deg;N<br /><b>Longitude:</b> 158.07&deg;E</td></tr><tr><td colspan="2"><p align="justify">Bakening volcano (also known as Bakenin) lies well west of the eastern volcanic range of Kamchatka, at the head of the Srednyaya Avacha River, about 100 km NNW of Petropavlovsk.  Most of the volcano is of Pleistocene age, and subglacial rhyodacitic tuyas are located on the NW flanks.  The 2278-m-high andesitic stratovolcano has dacitic lava domes at its north and NE base, the latest of which (Novo Bakening) formed about 9000-10,000 years ago.  A large horseshoe-shaped depression on the SE flank was the source of a large debris avalanche about 8000-8500 years ago that traveled 11 km to the east and south.  The avalanche, which dammed drainages forming two lakes NE and east of the volcano, was followed by an explosive eruption and a block-and-ash flow.  Several late-Pleistocene to Holocene cinder cones are located on the northern-to-southern flanks of the volcano.  The latest dated activity consisted of the construction of a cinder cone at the western foot of the volcano about 2500 year ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-123&amp;volpage=photos&amp;photo=023040">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-123">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(53.905000000000001,158.06999999999999)
710	Zavaritsky	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Zavaritsky</b></font><br /><font size="5"><b>Eastern Kamchatka</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1567 m<br /><b>Latitude:</b> 53.905&deg;N<br /><b>Longitude:</b> 158.385&deg;E</td></tr><tr><td colspan="2"><p align="justify">Zavaritsky volcano consists of a complex of six NW-SE-trending cinder cones and an explosion crater located near the headwaters of the Levaya Avacha River west of the Eastern volcanic zone of Kamchatka.  The highest cone, 1567-m-high Mount Peschanaya, lies near the southern end of the cone group.  The six cones of Zavaritsky were formed during an eruption about 2800 years ago during which associated lava flows blocked the Levaya Avacha and Ozernaya rivers, forming Lake Vulkanischeskoe along the Ozernaya drainage.  Other monogenetic cinder cones are located NW and NE of Zavaritsky volcano.  Berezovy cinder cone to the NW erupted about 11,000 to 10,000 radiocarbon years ago.  An unnamed cone near the crest of a range dividing the Srednaya Avacha and Kavicha river drainages about 14 km WNW of Zavaritsky volcano erupted about 3000-2500 years ago.  The cone is slightly closer to Bakening volcano, but the chemistry of its products are related to those of Zavaritsky.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-124">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(53.905000000000001,158.38499999999999)
711	Akademia Nauk	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Akademia Nauk</b></font><br /><font size="5"><b>Eastern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/023046.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 1180 m<br /><b>Latitude:</b> 53.98&deg;N<br /><b>Longitude:</b> 159.45&deg;E</td></tr><tr><td colspan="2"><p align="justify">The scenic lake-filled Akademia Nauk caldera is one of three volcanoes constructed within the mid-Pleistocene, 15-km-wide Polovinka caldera.  Beliankin stratovolcano, in the SW part of Polovinka caldera, is eroded, but has been active in postglacial time (Sviatlovsky, 1959).  Two nested calderas,  5 x 4 km Odnoboky and 3 x 5 km Akademia Nauk (also known as Karymsky Lake or Academii Nauk), were formed during the late Pleistocene, the latter about 30,000 years ago.  Eruptive products varied from initial basaltic-andesite lava flows to late-stage rhyodacitic lava domes.  Two maars, Akademia Nauk and Karymsky, subsequently formed at the southern and northern margins of the caldera lake, respectively.  The northern maar, Karymsky, erupted about 6500 radiocarbon years ago and formed a small bay.  The first historical eruption from Akademia Nauk did not take place until January 2, 1996, when a brief, day-long explosive eruption of unusual basaltic and rhyolitic composition occurred from vents beneath the NNW part of the caldera lake near Karymsky maar.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-125&amp;volpage=photos&amp;photo=023046">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-125">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(53.979999999999997,159.44999999999999)
712	Karymsky	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Karymsky</b></font><br /><font size="5"><b>Eastern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/057060.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 1536 m<br /><b>Latitude:</b> 54.05&deg;N<br /><b>Longitude:</b> 159.45&deg;E</td></tr><tr><td colspan="2"><p align="justify">Karymsky, the most active volcano of  Kamchatka's eastern volcanic zone, is a symmetrical stratovolcano constructed within a 5-km-wide caldera that formed during the early Holocene.  The caldera cuts the south side of the Pleistocene Dvor volcano and is located outside the north margin of the large mid-Pleistocene Polovinka caldera, which contains the smaller Akademia Nauk and Odnoboky calderas.  Most seismicity preceding Karymsky eruptions originated beneath Akademia Nauk caldera, which is located immediately south of Karymsky volcano.  The caldera enclosing Karymsky volcano formed about 7600-7700 radiocarbon years ago; construction of the Karymsky stratovolcano began about 2000 years later.  The latest eruptive period began about 500 years ago, following a 2300-year quiescence.  Much of the cone is mantled by lava flows less than 200 years old.  Historical eruptions have been vulcanian or vulcanian-strombolian with moderate explosive activity and occasional lava flows from the summit crater.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-13=&amp;volpage=photos&amp;photo=057060">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-13=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(54.049999999999997,159.44999999999999)
713	Maly Semiachik	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Maly Semiachik</b></font><br /><font size="5"><b>Eastern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/023068.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Stratovolcanoes</td><td width="50%" align="left"><b>Summit Elev:</b> 1560 m<br /><b>Latitude:</b> 54.13&deg;N<br /><b>Longitude:</b> 159.67&deg;E</td></tr><tr><td colspan="2"><p align="justify">Maly Semiachik is a compound stratovolcano located in a 10-km-wide caldera within the 15 x 20 km mid-Pleistocene Stena-Soboliny caldera.  Following construction during the late Pleistocene of the Paleo-Semiachik volcano beginning about 20,000 years before present (BP), activity migrated to the SW, forming Meso-Semiachik (about 11,000-9000 BP) and Ceno-Semiachik (about 8000 BP to the present).  An initial stage lasting about 3500 years was dominantly explosive, constructing the present cone.  A second stage beginning about 4400 years ago was marked by alternating constructive and destructive processes during which the volcano was destroyed by major explosions and then reconstructed.  A crater lake fills the historically active Troitsky Crater, which formed during a large explosive eruption about 400 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-14=&amp;volpage=photos&amp;photo=023068">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-14=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(54.130000000000003,159.66999999999999)
714	Bolshoi Semiachik	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bolshoi Semiachik</b></font><br /><font size="5"><b>Eastern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/103056.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1720 m<br /><b>Latitude:</b> 54.32&deg;N<br /><b>Longitude:</b> 160.02&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Bolshoi Semiachik volcanic complex was constructed within a 10-km-wide caldera whose rim is exposed only on the west.  The caldera occupies a large 20 x 30 km late-Pleistocene volcano-tectonic depression near the Pacific Coast of eastern Kamchatka.  Post-caldera volcanism includes resurgent doming and the construction of numerous stratovolcanoes and lava domes, several of which have been active during the Holocene.  Zubchatka (Bolshoi Semiachik), Zapadny Barany, Vostochny Barany, Zentralny Semiachik, Popkov, Plosky, and Burlyashchy volcanoes are the largest of  the volcanic complex.  The youngest volcanism and intense modern hydrothermal activity, which is among the most vigorous of Kamchatka, is located outside the caldera to the SE.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-15=&amp;volpage=photos&amp;photo=103056">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-15=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(54.32,160.02000000000001)
715	Taunshits	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Taunshits</b></font><br /><font size="5"><b>Eastern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/064095.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2353 m<br /><b>Latitude:</b> 54.53&deg;N<br /><b>Longitude:</b> 159.80&deg;E</td></tr><tr><td colspan="2"><p align="justify">Taunshits volcano, located west of the massive Uzon caldera, is an andesitic stratovolcano that was constructed beginning about 39,000 years Before Present (BP) on top of a large Pleistocene tuya pedestal.  The 2353-m-high summit of Taunshits is truncated by a horseshoe-shaped crater breached to the west that formed about 8000 years BP during an eruption producing a directed blast and a 3 cu km debris avalanche that traveled 19 km to the west.  Another strong explosive eruption took place about 2500 years BP.  Two satellitic cones occupy the southern flank, and a cluster of Holocene cinder cones farther to the south may also be related to Taunshits.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-16-&amp;volpage=photos&amp;photo=064095">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-16-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(54.530000000000001,159.80000000000001)
716	Uzon	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Uzon</b></font><br /><font size="5"><b>Eastern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/023074.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Maar</td><td width="50%" align="left"><b>Summit Elev:</b> 1617 m<br /><b>Latitude:</b> 54.50&deg;N<br /><b>Longitude:</b> 159.97&deg;E</td></tr><tr><td colspan="2"><p align="justify">The twin Uzon and Geysernaya calderas, containing Kamchatka's largest geothermal area, form a 7 x 18 km depression that originated during multiple eruptions during the mid-Pleistocene.  Widespread ignimbrite deposits associated with caldera formation have a volume of 20-25 cu km (exclusive of airfall deposits) and cover an area of 1700 sq km.  Post-caldera activity was largely Pleistocene in age and consisted of the extrusion of small silicic lava domes and flows and maar formation in the Geysernaya caldera.  The Lake Dal'ny maar in the NE part of the 9 x 12 km western caldera, Uzon, is early Holocene in age, and several Holocene phreatic eruptions have been documented in the Geysernaya caldera.  The extensive high-temperature hydrothermal system includes the many hot springs, mudpots, and geysers of the Valley of Geysers, a 4-km-long canyon on the SE margin of the Uzon-Geysernaya depression.  Hydrothermal explosions took place in the caldera in 1986 and 1989.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-17=&amp;volpage=photos&amp;photo=023074">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-17=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(54.5,159.97)
717	Kikhpinych	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kikhpinych</b></font><br /><font size="5"><b>Eastern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/106024.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 1552 m<br /><b>Latitude:</b> 54.487&deg;N<br /><b>Longitude:</b> 160.253&deg;E</td></tr><tr><td colspan="2"><p align="justify">Kikhpinych, the youngest stratovolcano of the eastern volcanic zone of Kamchatka and one of the smallest, contains three summits constructed along a roughly E-W line above the eroded Pleistocene Pik volcano, NE of the Uzon caldera.  Growth of the modern volcano began during the middle Holocene about 4800 years ago with construction of the Zapadny cone.  After a long quiescence, the younger Savich cone was born about 1400 years ago, following a strong explosive eruption that destroyed part of the Zapadny and Pik cones.  Numerous young lava flows mantle the flanks of 1552-m-high Savich cone, which has grown to slightly exceed Zapadny as the high point of Kikhpinych volcano.  Savich was last active about 400 years ago, when the Krab lava dome was formed on its eastern flank.  Numerous thermal fields are found throughout the complex, including two geysers (now the site of vigorous fumaroles) that were active in the summit crater of Stary Kikhpinych prior to burial by a rockfall avalanche that occurred sometime between September 1981 and July 1982.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-18=&amp;volpage=photos&amp;photo=106024">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-18=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(54.487000000000002,160.25299999999999)
718	Krasheninnikov	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Krasheninnikov</b></font><br /><font size="5"><b>Eastern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/023087.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1856 m<br /><b>Latitude:</b> 54.593&deg;N<br /><b>Longitude:</b> 160.273&deg;E</td></tr><tr><td colspan="2"><p align="justify">The late-Pleistocene to Holocene Krasheninnikov volcano is comprised of two overlapping stratovolcanoes that were constructed within a 9 x 11 km Pleistocene caldera.  Young lava flows from summit and flank vents descend into the caldera and down its outer flanks.  The summit cones are situated along a NE-SW-trending fissure that has also produced zones of Holocene cinder cones extending 15-20 km beyond the caldera.  Tephra deposits from the eruption forming Krasheninnikov caldera directly overlie a 39,000 before present (BP) tephra once thought to be related to the Krasheninnikov caldera-forming eruption but now thought to be associated with the formation of Uzon caldera (Florenskii 1988).  Both the Southern and Northern cones are topped by 800-m-wide craters; the younger Northern Cone was constructed within a 2-km-wide caldera.  Construction of the Southern Cone began about 11,000 years BP and lasted for about 4500 years.  The Northern Cone was constructed during a cycle of similar length that began about 6500 years ago.  The present eruptive cycle began about 600 years BP, but has included only two documented eruptions, the last about 400 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-19=&amp;volpage=photos&amp;photo=023087">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-19=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(54.593000000000004,160.273)
719	Kronotsky	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kronotsky</b></font><br /><font size="5"><b>Eastern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/023094.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3528 m<br /><b>Latitude:</b> 54.753&deg;N<br /><b>Longitude:</b> 160.527&deg;E</td></tr><tr><td colspan="2"><p align="justify">This symmetrical stratovolcano, one of the most scenic in Kamchatka, lies between the Pacific Ocean and Lake Kronotsky, Kamchatka's largest lake.  The lake formed at the end of the Pleistocene and the beginning of the Holocene when extensive lava flows on the south side of Kronotsky volcano dammed the Listvenichnaya River.  The flanks of the massive 3528-m-high volcano, one of the largest in Kamchatka, are dissected by radial valleys up to 200 m deep.  A volcanic neck plugs the summit crater.  Cinder cones are found on the north and primarily on the SE and SW flanks.  Kronotsky lavas have been dominantly basaltic, with the exception of the small basaltic-andesite summit lava extrusion and a flank lava flow.  Weak phreatic eruptions took place in the 20th century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-20=&amp;volpage=photos&amp;photo=023094">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-20=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(54.753,160.52699999999999)
720	Schmidt	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Schmidt</b></font><br /><font size="5"><b>Eastern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/106086.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2020 m<br /><b>Latitude:</b> 54.92&deg;N<br /><b>Longitude:</b> 160.63&deg;E</td></tr><tr><td colspan="2"><p align="justify">Schmidt volcano is a large 2020-m-high mid- to upper-Pleistocene shield-like volcano located north of Kronotsky volcano and SW of Gamchen volcano (Lutchitsky, 1974).  A dike complex is prominent on the eroded volcano, which was constructed along a NE-trending fault zone.  Following the cessation of activity at Schmidt volcano during the Pleistocene, regional basaltic volcanism produced some monogenetic cinder cones that were erupted through the eastern and NE flanks of the volcano during the Holocene (Andreev et al., 1988).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-201&amp;volpage=photos&amp;photo=106086">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-201">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(54.920000000000002,160.63)
721	Gamchen	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Gamchen</b></font><br /><font size="5"><b>Eastern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/103054.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 2576 m<br /><b>Latitude:</b> 54.973&deg;N<br /><b>Longitude:</b> 160.702&deg;E</td></tr><tr><td colspan="2"><p align="justify">Gamchen is a complex volcano composed of four stratovolcanoes, one of which is of Holocene age, atop a shield-like structure.  Yuzhny Gamchen and Severny Gamchen are two steep-sided eroded stratovolcanoes of Pleistocene age.  Edifice-collapse events at Gamchen during the early Holocene produced several large debris-avalanche deposits below the eastern flanks.  Molodoi, a small stratovolcano with a well-preserved, shallow crater, is located on the east flank of Severvy Gamchen.  Barany, a young stratovolcano with a youthful crater 500 m wide and 200 m deep, is located on the SE flank of Yuzhny Gamchen volcano.  Barany (also spelled Baranii) has been the source of a young lava field that extends to the east and NE and was active between about 3600 and 3000 years ago.  Lava domes are found on the flanks of the volcanoes; the youngest of these is Lukovitsa dome, which formed during the final stages of activity at Barany.  No historical eruptions are known from the Gamchen complex.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-21=&amp;volpage=photos&amp;photo=103054">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-21=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(54.972999999999999,160.702)
722	Komarov	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Komarov</b></font><br /><font size="5"><b>Eastern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/106023.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2070 m<br /><b>Latitude:</b> 55.032&deg;N<br /><b>Longitude:</b> 160.720&deg;E</td></tr><tr><td colspan="2"><p align="justify">Komarov volcano (also known as Komarova) is a complex structure situated at the northern half of the Gamchen ridge.  An eccentric 2.5 x 4 km caldera contains a young twin cone and flank explosive domes.  The youngest cone, 2070-m-high Komarov, was built at the western end of the caldera.  It is capped by two craters, one at the summit and the other on the upper east flank.  Lengthy Holocene lava flows extend beyond the caldera to the east and west.  Growth of Komarov volcano began about 1500 years ago following cessation of activity at Visokii volcano.  No historical eruptions are known, but the summit region has undergone extensive hydrothermal alteration, and fumarolic areas occur there and on the northern and southern flanks.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-22=&amp;volpage=photos&amp;photo=106023">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-22=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(55.031999999999996,160.72)
723	Vysoky	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Vysoky</b></font><br /><font size="5"><b>Eastern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/103055.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 2161 m<br /><b>Latitude:</b> 55.07&deg;N<br /><b>Longitude:</b> 160.77&deg;E</td></tr><tr><td colspan="2"><p align="justify">Visoky, at the northern end of a chain of small volcanoes trending NNW from Gamchen volcano, is a small Holocene stratovolcano with a youthful-looking summit crater constructed over the east flank of the Pleistocene Bogdanovich shield volcano.   Vysoky (also spelled Vysokii) lies only 4 km NE of Komarov volcano.  Another small Holocene volcano lies between Komarov and Vysoky.  These mark the northernmost Holocene volcanoes of the Gamchen volcanic ridge and the northernmost of the near-trench portion of the Eastern volcanic belt of Kamchatka related to subduction of the Pacific Plate.  Visoky was active throughout much of the Holocene until as recently as at least about 2000 years ago, when voluminous lava flows were traveled down the volcano's flanks.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-221&amp;volpage=photos&amp;photo=103055">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-221">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(55.07,160.77000000000001)
724	Kizimen	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kizimen</b></font><br /><font size="5"><b>Eastern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/103058.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 2376 m<br /><b>Latitude:</b> 55.130&deg;N<br /><b>Longitude:</b> 160.32&deg;E</td></tr><tr><td colspan="2"><p align="justify">Kizimen is an isolated, conical stratovolcano that is morphologically similar to Mount St. Helens prior to its 1980 eruption.  The summit of Kizimen consists of overlapping lava domes, and blocky lava flows descend the flanks of the volcano, which is the westernmost of a volcanic chain north of Kronotsky volcano.  The 2376-m-high Kizimen was formed during four eruptive cycles beginning about 12,000 years ago and lasting 2000-3500 years.  The largest eruptions took place about 10,000 and 8300-8400 years ago, and three periods of long-term lava dome growth have occurred.  The latest eruptive cycle began about 3000 years ago with a large explosion and was followed by lava dome growth lasting intermittently about 1000 years.  An explosive eruption about 1100 years ago produced a lateral blast and created a 1.0 x 0.7 km wide crater breached to the NE, inside which a small lava dome (the fourth at Kizimen) has grown.  A single explosive eruption, during 1927-28, has been recorded in historical time.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-23=&amp;volpage=photos&amp;photo=103058">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-23=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(55.130000000000003,160.31999999999999)
725	Tolbachik	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tolbachik</b></font><br /><font size="5"><b>Central Kamchatka (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/023097.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3682 m<br /><b>Latitude:</b> 55.830&deg;N<br /><b>Longitude:</b> 160.330&deg;E</td></tr><tr><td colspan="2"><p align="justify">The massive Tolbachik basaltic volcano is located at the southern end of the dominantly andesitic Kliuchevskaya volcano group.  The Tolbachik massif is composed of two overlapping, but morphologically dissimilar volcanoes.  The flat-topped Plosky Tolbachik shield volcano with its nested Holocene Hawaiian-type calderas up to 3 km in diameter is located east of the older and higher sharp-topped Ostry Tolbachik stratovolcano.  The summit caldera at Plosky Tolbachik was formed in association with major lava effusion about 6500 years ago and simultaneously with a major southward-directed sector collapse of Ostry Tolbachik volcano.  Lengthy rift zones extending NE and SSW of the volcano have erupted voluminous basaltic lava flows during the Holocene, with activity during the past two thousand years being confined to the narrow axial zone of the rifts.  The 1975-76 eruption originating from the SSW-flank fissure system and the summit was the largest historical basaltic eruption in Kamchatka.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-24=&amp;volpage=photos&amp;photo=023097">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-24=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(55.829999999999998,160.33000000000001)
726	Udina	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Udina</b></font><br /><font size="5"><b>Central Kamchatka (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/058018.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2923 m<br /><b>Latitude:</b> 55.755&deg;N<br /><b>Longitude:</b> 160.527&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Udina volcanic massif consists of two conical stratovolcanoes constructed along a WNW-ESE line at the south end of the Kliuchevskaya volcanic group, SE of Tolbachik volcano.  The western volcano, 2923-m-high andesitic Bolshaya Udina, has a prominent lava dome on its SW flank.  The 1945-m-high basaltic Malaya Udina rises above a low saddle at the eastern end of the Udina complex; small lava domes also occur on its flanks.  No historical eruptions have occurred from the Udina complex.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-241&amp;volpage=photos&amp;photo=058018">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-241">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(55.755000000000003,160.52699999999999)
727	Zimina	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Zimina</b></font><br /><font size="5"><b>Central Kamchatka (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/058020.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 3081 m<br /><b>Latitude:</b> 55.862&deg;N<br /><b>Longitude:</b> 160.603&deg;E</td></tr><tr><td colspan="2"><p align="justify">The eroded twin stratovolcanoes of Ostraya and Ovalnaya Zimina form a NW-SE-trending ridge north of the Udina complex at the SE end of the Kliuchevskaya volcano group.  The larger 3081-m-high Ovalnaya Zimina, at the NW end of the complex, is capped by a large icecap and contains two summits.  The extensively eroded Ostraya Zimina to the SE has a sharp-peaked summit spire.  A large debris avalanche from Ovalnaya Zimina traveled more than 10 km.  No historical eruptions have occurred from the Zimina volcanoes.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-242&amp;volpage=photos&amp;photo=058020">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-242">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(55.862000000000002,160.60300000000001)
728	Bezymianny	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bezymianny</b></font><br /><font size="5"><b>Central Kamchatka (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/024045.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 2882 m<br /><b>Latitude:</b> 55.978&deg;N<br /><b>Longitude:</b> 160.587&deg;E</td></tr><tr><td colspan="2"><p align="justify">Prior to its noted 1955-56 eruption, Bezymianny volcano had been considered extinct.  The modern Bezymianny volcano, much smaller in size than its massive neighbors Kamen and Kliuchevskoi, was formed about 4700 years ago over a late-Pleistocene lava-dome complex and an ancestral volcano that was built between about 11,000-7000 years ago.  Three periods of intensified activity have occurred during the past 3000 years.  The latest period, which was preceded by a 1000-year quiescence, began with the dramatic 1955-56 eruption.  This eruption, similar to that of Mount St. Helens in 1980, produced a large horseshoe-shaped crater that was formed by collapse of the summit and an associated lateral blast.  Subsequent episodic but ongoing lava-dome growth, accompanied by intermittent explosive activity and pyroclastic flows, has largely filled the 1956 crater.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-25=&amp;volpage=photos&amp;photo=024045">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-25=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(55.978000000000002,160.58699999999999)
729	Kamen	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kamen</b></font><br /><font size="5"><b>Central Kamchatka (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/057006.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 4585 m<br /><b>Latitude:</b> 56.02&deg;N<br /><b>Longitude:</b> 160.593&deg;E</td></tr><tr><td colspan="2"><p align="justify">The steep-sided Kamen stratovolcano lies at the center of a N-S-trending chain of volcanoes, flanked by Bezymianny and Kliuchevskoi.  The sharp-peaked, 4585-m-high Kamen is Kamchatka's second highest volcano, topped only by its neighbor Kliuchevskoi.  Kamen formed during the late Pleistocene, but activity continued into the Holocene (Melekestsev et al., 1990).  A major slope failure about 1200-1300 years ago removed much of the eastern side of the  volcano, producing a massive 4-6 cu km debris avalanche that traveled more than 30 km to the SE.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-251&amp;volpage=photos&amp;photo=057006">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-251">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(56.020000000000003,160.59299999999999)
730	Kliuchevskoi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kliuchevskoi</b></font><br /><font size="5"><b>Central Kamchatka (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/025004.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 4835 m<br /><b>Latitude:</b> 56.057&deg;N<br /><b>Longitude:</b> 160.638&deg;E</td></tr><tr><td colspan="2"><p align="justify">Kliuchevskoi is Kamchatka's highest and most active volcano.  Since its origin about 6000 years ago, the beautifully symmetrical, 4835-m-high basaltic stratovolcano has produced frequent moderate-volume explosive and effusive eruptions without major periods of inactivity.  Kliuchevskoi rises above a saddle NE of sharp-peaked Kamen volcano and lies SE of the broad Ushkovsky massif.  More than 100 flank eruptions have occurred at Kliuchevskoi during the past roughly 3000 years, with most lateral craters and cones occurring along radial fissures between the unconfined NE-to-SE flanks of the conical volcano between 500 m and 3600 m elevation.  The morphology of its 700-m-wide summit crater has been frequently modified by historical eruptions, which have been recorded since the late-17th century.  Historical eruptions have originated primarily from the summit crater, but have also included numerous major explosive and effusive eruptions from flank craters.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-26=&amp;volpage=photos&amp;photo=025004">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-26=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(56.057000000000002,160.63800000000001)
731	Ushkovsky	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ushkovsky</b></font><br /><font size="5"><b>Central Kamchatka (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/025005.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Compound volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3943 m<br /><b>Latitude:</b> 56.070&deg;N<br /><b>Longitude:</b> 160.470&deg;E</td></tr><tr><td colspan="2"><p align="justify">Ushkovsky volcano (formerly known as Plosky) is a large compound volcanic massif located at the NW end of the Kliuchevskaya volcano group.  It consists of the flat-topped 3943-m-high Ushkovsky volcano (Daljny Plosky), which is capped by an ice-filled 4.5 x 5.5 km caldera, and the adjacent slightly higher peak of 4108 m Krestovsky (Blizhny Plosky) volcano.  Two glacier-clad cinder cones with large summit craters form a high point within the Ushkovsky caldera.  Linear zones of cinder cones are found on the SW and NE flanks and on lowlands to the west.  The younger caldera at the summit of Plosky Daljny (Ushkovsky) was formed in association with the eruption of large lava flows and pyroclastic material from the Lavovy ShIsh cinder cones at the foot of the volcano about 8600 years ago. The only known historical activity at Ushkovsky was an explosive eruption from the summit cone in 1890.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-261&amp;volpage=photos&amp;photo=025005">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-261">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(56.07,160.47)
732	Shiveluch	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Shiveluch</b></font><br /><font size="5"><b>Central Kamchatka (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/025024.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 3283 m<br /><b>Latitude:</b> 56.653&deg;N<br /><b>Longitude:</b> 161.360&deg;E</td></tr><tr><td colspan="2"><p align="justify">The high, isolated massif of Shiveluch volcano (also spelled Sheveluch) rises above the lowlands NNE of the Kliuchevskaya volcano group.  The 1300 cu km Shiveluch is one of Kamchatka's largest and most active volcanic structures.  The summit of roughly 65,000-year-old Stary Shiveluch is truncated by a broad 9-km-wide late-Pleistocene caldera breached to the south.  Many lava domes dot its outer flanks.  The Molodoy Shiveluch lava dome complex was constructed during the Holocene within the large horseshoe-shaped caldera; Holocene lava dome extrusion also took place on the flanks of Stary Shiveluch.  At least 60 large eruptions of Shiveluch have occurred during the Holocene, making it the most vigorous andesitic volcano of the Kuril-Kamchatka arc.  Widespread tephra layers from these eruptions have provided valuable time markers for dating volcanic events in Kamchatka.  Frequent collapses of dome complexes, most recently in 1964, have produced debris avalanches whose deposits cover much of the floor of the breached caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-27=&amp;volpage=photos&amp;photo=025024">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-27=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(56.652999999999999,161.36000000000001)
733	Piip	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Piip</b></font><br /><font size="5"><b>East of Kamchatka</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -300 m<br /><b>Latitude:</b> 55.42&deg;N<br /><b>Longitude:</b> 167.33&deg;E</td></tr><tr><td colspan="2"><p align="justify">Dredged rocks from the summits of volcanic cones rising from 2500 m depth to within a few hundred meters of the surface yielded fresh dacitic lavas and pumice apparently of Holocene age (Fedotov et al., 1989; Seliverstov et al., 1986).  Tephrochronological studies on the Commander Islands suggest that the latest tephras from Piip volcano may be as young as a few centuries, and echograms indicate present-day gas emission from the volcano.  The three steep-sided volcanic cones were constructed along a N-S trend and lie about 140-150 km from the axis of the Aleutian trench, a similar distance as other Aleutian arc volcanoes.  The southern and northern cones exceed the central cone in size and have craters open to the SW about 500 and 300 m wide, respectively.   A lava dome occupies the southern crater, and other domes or parasitic cones are found on the summit cones and flanks of the edifice.  Vigorous gas emission from the northern cone rises about 300 m from &quot;black smoker&quot; vents on the crater floor.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-271">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(55.420000000000002,167.33000000000001)
734	Khangar	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Khangar</b></font><br /><font size="5"><b>Central Kamchatka (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/025026.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2000 m<br /><b>Latitude:</b> 54.75&deg;N<br /><b>Longitude:</b> 157.38&deg;E</td></tr><tr><td colspan="2"><p align="justify">Khangar volcano, also spelled Hangar, is the southernmost volcano of the N-S-trending Sredinny Range, which stretches across western Kamchaktka.  Khangar, which is the dominant feature within a larger volcano-tectonic depression, is composed of two parts--a stratovolcano with a 2-km-wide Holocene caldera and a large lava dome on its eastern flank.  The steep-walled caldera, now filled by a lake, was formed during a major explosive eruption about 7000 years ago.  An arcuate zone of pre-caldera flank lava domes nearly surrounds the volcano, and post-caldera domes form islands in the caldera lake.  Late-stage olivine basalts were erupted along a NE-trending line in the southern part of the Khangar volcano-tectonic depression.  The latest dated eruption from Khangar took place about 500 years ago and marks the youngest known eruption from the Sredinny Range volcanoes.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-272&amp;volpage=photos&amp;photo=025026">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-272">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(54.75,157.38)
735	Cherpuk Group	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cherpuk Group</b></font><br /><font size="5"><b>Central Kamchatka (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/103057.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1868 m<br /><b>Latitude:</b> 55.55&deg;N<br /><b>Longitude:</b> 157.47&deg;E</td></tr><tr><td colspan="2"><p align="justify">Severny Cherpuk (South Cherpuk) and Yuzhny Cherpuk (North Cherpuk) are two cinder cones SW of Ichinsky volcano that comprise the largest monogenetic volcanoes of the Sredinny Range.  Severny Cherpuk, 21 km SW of Ichinsky, is a double cone that was constructed along the crest of the Sredinny Range and fed massive 1.8 cu km lava flows down both sides of the range to the NW and SE.  A narrow tongue of the SE flow diverted an addition 10 km to the south, for a total distance of 22 km.  Yuzhny Cherpuk, 11 km SSW of Ichinsky volcano, produced a 1.7 cu km lava flow that traveled 18 km to the south and then SE.  The flow descended to 640 m elevation and dammed tributaries of the Ketachan River, producing three lakes.  The two cones are sometimes considered to be satellitic cones to Ichinsky, but Pevzner et al. (2000) noted petrological distinctions that suggest an origin independent of Ichinsky.  Unpublished radiocarbon ages revise those in Pevzner et al. (2000) and indicate that both cones were formed about 6500 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-273&amp;volpage=photos&amp;photo=103057">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-273">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(55.549999999999997,157.47)
736	Ichinsky	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ichinsky</b></font><br /><font size="5"><b>Central Kamchatka (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/025027.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 3621 m<br /><b>Latitude:</b> 55.68&deg;N<br /><b>Longitude:</b> 157.73&deg;E</td></tr><tr><td colspan="2"><p align="justify">Ichinsky, by far the highest peak in the Sredinny Range, is a massive, 450 cu km stratovolcano that is one of Kamchatka's largest.  The andesitic Pleistocene-to-Holocene stratovolcano, also known as Icha volcano, contains a 3 x 5 km-wide glacier-covered summit caldera filled by a large post-caldera edifice.  Two glacier-capped lava domes form the highest peaks of 3621-m-high Ichinsky.  A dozen late-Pleistocene to Holocene dacitic and rhyodacitic lava domes circle the peak below the caldera rim, at elevations of  1800-3000 m.  Fresh-looking basaltic-to-dacitic lava flows, some with prominent flow ridges, were erupted from flank vents and traveled up to 10-15 km.  The largest Holocene eruption of Ichinsky volcano took place about 6500 years ago, producing block-and-ash flows that traveled up to 15 km.  Fumarolic activity occurs within the caldera and on the lower northern flank.  In 1956 steam jets rose 250 m above the caldera fumarole field.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-28=&amp;volpage=photos&amp;photo=025027">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-28=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(55.68,157.72999999999999)
737	Bolshoi-Kekuknaysky	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bolshoi-Kekuknaysky</b></font><br /><font size="5"><b>Central Kamchatka (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117076.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1401 m<br /><b>Latitude:</b> 56.47&deg;N<br /><b>Longitude:</b> 157.80&deg;E</td></tr><tr><td colspan="2"><p align="justify">Bolshoi (Bolshoy) and Kekuknaysky are two large, partially overlapping basaltic shield volcanoes located NW and NNW, respectively, of Uksichan volcano.  The massive shield volcanoes are of Pleistocene age and were constructed west of the axis of the Sredinny Range.  Hawaiian-type calderas are located at the summit of the volcanoes, and numerous youthful cinder cones dot their flanks.  The summit caldera of Bolshoi is breached by four radial valleys, whereas the 6-km-wide caldera of Kekuknaysky (also known as Leningradets volcano) is breached to the north.  Young cinder cones and lava flows are particularly abundant on the NE flank of Kekuknaysky volcano.  Kekuk crater on the lower northern flank erupted about 7200 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-36-&amp;volpage=photos&amp;photo=117076">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-36-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(56.469999999999999,157.80000000000001)
738	Alney-Chashakondzha	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Alney-Chashakondzha</b></font><br /><font size="5"><b>Central Kamchatka (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117073.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2598 m<br /><b>Latitude:</b> 56.70&deg;N<br /><b>Longitude:</b> 159.65&deg;E</td></tr><tr><td colspan="2"><p align="justify">The glacier-capped Alney-Chashakondzha complex, one of the largest volcanoes of the Sredinny Range, consists of two large mostly Pleistocene andesitic stratovolcanoes constructed on a large Pliocene shield volcano.  Both 2598-m-high Alney on the north and 2526-m-high Chashakondzha on the south are capped with andesitic lava domes.  Three rhyodacitic-to-rhyolitic lava domes and associated lava flows were emplaced along ring faults enclosing a 15 x 20 km area.  Two cinder cones on the east flanks of Alney and Chashakondzha volcanoes erupted about 2600 years ago and produced lava flows, one of which traveled as far as 9 km down the eastern flanks of the complex.  Alney is one of the few large stratovolcanoes in the Sredinny Range known to have been active throughout the Holocene, with more than 30 documented pyroclastic deposits.  The last intense eruption took place about 350 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-45-&amp;volpage=photos&amp;photo=117073">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-45-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(56.700000000000003,159.65000000000001)
739	Shisheika	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Shisheika</b></font><br /><font size="5"><b>Central Kamchatka (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120060.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 379 m<br /><b>Latitude:</b> 57.15&deg;N<br /><b>Longitude:</b> 161.08&deg;E</td></tr><tr><td colspan="2"><p align="justify">The andesitic Shisheika lava dome lies far to the west of the crest of the Sredinny Range, near the mouth of the Shishei River.  The dome and associated lava flows were erupted about 4200 years ago during one of several Holocene eruptions on the lower flanks of the Sredinny Range.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-511&amp;volpage=photos&amp;photo=120060">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-511">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(57.149999999999999,161.08000000000001)
740	Terpuk	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Terpuk</b></font><br /><font size="5"><b>Central Kamchatka (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120058.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 765 m<br /><b>Latitude:</b> 57.20&deg;N<br /><b>Longitude:</b> 159.83&deg;E</td></tr><tr><td colspan="2"><p align="justify">Terpuk is a small Icelandic-type basaltic shield volcano located west of the crest of the Sredinny Range, south of Leutongey volcano and NW of Kebeney volcano.  The 765-m-high shield volcano is topped by small cinder cones aligned NE-SW, along the trend of the Sredinny Range.  Fresh-looking, sparsely vegetated lava flows radiate from the summit vents and blocked local drainages, forming several small lakes.   Topography constrains the flows to be longer toward the west, away from the crest of the range.  The flows are among the youngest in the Sedankinsky Dol region and were erupted about 2500-3000 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-512&amp;volpage=photos&amp;photo=120058">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-512">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(57.200000000000003,159.83000000000001)
741	Sedankinsky	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sedankinsky</b></font><br /><font size="5"><b>Central Kamchatka (Russia)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1241 m<br /><b>Latitude:</b> 57.27&deg;N<br /><b>Longitude:</b> 160.08&deg;E</td></tr><tr><td colspan="2"><p align="justify">Sedankinsky, a small Icelandic-type basaltic shield volcano, is the SE-most of a cluster of overlapping small shields along the crest of the central Sredinny Range north of Kebeney volcano.  Sedankinsky lies at the SE end of a major graben extending NE from Kebeney volcano.  Chains of cinder cones trending NE-SW were constructed on the southern and eastern flanks of Sedankinsky; lava flows from the latter cones bank up against the steep-walled eastern margin of the graben.  Eruptions at Sedankinsky Dol, also known as Sedanka Dol, took place about 8000-10,000 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-52-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(57.270000000000003,160.08000000000001)
742	Gorny Institute	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Gorny Institute</b></font><br /><font size="5"><b>Central Kamchatka (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117077.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2125 m<br /><b>Latitude:</b> 57.33&deg;N<br /><b>Longitude:</b> 160.20&deg;E</td></tr><tr><td colspan="2"><p align="justify">Gorny Institute volcano lies at the NE end of chain of small late-Quaternary volcanoes extending NE from Kebeney volcano in the central Sredinny Range.  Gorny Institute volcano was constructed near the steep-walled eastern margin of a major NE-SW-trending graben extending NE from Kebeney volcano.  A line of cinder cones with the same orientation is located on the NE and SW flanks of Gorny Institute.  Gorny Institute is one of the few large stratovolcanoes in the Sredinny Range that has been active throughout the Holocene.  More than 20 pyroclastic horizons have been documented, and the last major eruption took place about 700 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-55-&amp;volpage=photos&amp;photo=117077">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-55-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(57.329999999999998,160.19999999999999)
743	Kinenin	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kinenin</b></font><br /><font size="5"><b>Central Kamchatka (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117072.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Maar</td><td width="50%" align="left"><b>Summit Elev:</b> 583 m<br /><b>Latitude:</b> 57.35&deg;N<br /><b>Longitude:</b> 160.97&deg;E</td></tr><tr><td colspan="2"><p align="justify">Kinenin maar lies at the eastern foot of the Sredinny Range, about 80 km NNW of Shiveluch volcano.  The 2.5-km-wide, funnel-shaped maar was formed along the Kinenin River, a tributary of the Elovka River.  The maar is partially filled by a 1-km-wide lake whose surface is at 400 m elevation.  The eastern rim at 583 m is the high point of the crater.  The eruption of Kinenin maar took place about 1100 years ago, making it the youngest known maar in Kamchatka.  The eruption produced both silicic pyroclastic flows and mafic pyroclastic ejecta, which was distributed primarily to the ENE.   The unusual location of Kinenin maar lies north of the active subduction zone of Kamchatka.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-551&amp;volpage=photos&amp;photo=117072">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-551">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(57.350000000000001,160.97)
744	Bliznetsy	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bliznetsy</b></font><br /><font size="5"><b>Central Kamchatka (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117074.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava cone</td><td width="50%" align="left"><b>Summit Elev:</b> 265? m<br /><b>Latitude:</b> 57.35&deg;N<br /><b>Longitude:</b> 161.37&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Bliznetsy (&quot;Twins&quot;) lava flows occupy a low-lying area east of the Sredinny Range and north of the Eastern Volcanic Zone volcanoes.  The young flows lie south of the Ozernaya River about 80 km north of historically active Shiveluch volcano.  Effusion of about 0.5 cu km of lava forming the Bliznetsy flows about 3000 years ago was preceded by weak phreatomagmatic eruptions.  The unusual location of this recently studied young volcanic vent lies north of the margin of the subducting Pacific Plate.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-552&amp;volpage=photos&amp;photo=117074">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-552">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(57.350000000000001,161.37)
745	Titila	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Titila</b></font><br /><font size="5"><b>Central Kamchatka (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120057.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcanoes</td><td width="50%" align="left"><b>Summit Elev:</b> 1559 m<br /><b>Latitude:</b> 57.40&deg;N<br /><b>Longitude:</b> 160.10&deg;E</td></tr><tr><td colspan="2"><p align="justify">Titila is the youngest known small Icelandic-type shield volcano in the Sredinny Range.  The basaltic shield volcano overlooks the NW shore of Lake Glubokoye, west of the crest of the central Sredinny Range.  Lava flows radiate from two E-W-trending summit craters of Titila, and cinder cones are prominent on its southern flank.  Titila overlaps with another small shield volcano, Rassoshina, located immediately to the west.  A young lava flow traveled to the north from a vent on the NE flank of Rassoshina.  The latest known eruption from Titila took place about 2500 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-56-&amp;volpage=photos&amp;photo=120057">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-56-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(57.399999999999999,160.09999999999999)
746	Elovsky	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Elovsky</b></font><br /><font size="5"><b>Central Kamchatka (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117082.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcanoes</td><td width="50%" align="left"><b>Summit Elev:</b> 1381 m<br /><b>Latitude:</b> 57.55&deg;N<br /><b>Longitude:</b> 160.53&deg;E</td></tr><tr><td colspan="2"><p align="justify">A cluster of overlapping small Icelandic-type basaltic shield volcanoes is located east of the crest of the Sredinny Range, NE of Shishel volcano and SE of Alngey volcano.  The largest edifice is the 1381-m-high Elovsky shield volcano.  The smaller 1021-m-high Ozernoy shield volcano lies immediately to the SE of Elovsky.  The massive early Holocene Ozernovsky lava flow, located immediately NE of Elovsky, traveled to the ESE down a glacially dissected valley on the flanks of the Sredinny Range.  The flow is postglacial in age, but older than roughly 7000-year-old tephra layers from Khangar volcano.  The massive flow dammed tributary valleys, creating several lakes near the headwaters of the Levaya and Pravaya Ozeraya rivers and forming a lava field covering an area of 100 sq km.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-59-&amp;volpage=photos&amp;photo=117082">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-59-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(57.549999999999997,160.53)
747	Nylgimelkin	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Nylgimelkin</b></font><br /><font size="5"><b>Central Kamchatka (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117080.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1764 m<br /><b>Latitude:</b> 57.97&deg;N<br /><b>Longitude:</b> 160.65&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Icelandic-type basaltic shield volcano Nylgimelkin (also known as Atlasov) and the topographically higher but smaller shield of Novagrablenova are dwarfed by their neighbor, the glacier-clad Pleistocene Khuvkhoitun volcano, the highest Quaternary volcano of the northern Sredinny Range.  The two youthful shield volcanoes were constructed on the west and NW flanks of Khuvkhoitun.  Lava flows from Nylgimelkin and Novagrablenova extend primarily to the west.  Cinder cones and a lava flow were erupted along a fissure at Nylgimelkin about 5500 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-65-&amp;volpage=photos&amp;photo=117080">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-65-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(57.969999999999999,160.65000000000001)
748	Spokoiny	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Spokoiny</b></font><br /><font size="5"><b>Northern Kamchatka</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117084.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2171 m<br /><b>Latitude:</b> 58.13&deg;N<br /><b>Longitude:</b> 160.82&deg;E</td></tr><tr><td colspan="2"><p align="justify">The dacitic-to-rhyolitic Spokoiny stratovolcano lies immediately south of Ostry volcano and NE of Iktunup volcano in the northern Sredinny Range.  The 2171-m-high volcano, also known as Kutina, was active during the early and mid-Holocene.  Deposits from five eruptions during this interval have been documented, the last of which took place about 5400 years ago.  Cinder cones are located on the western flank of the volcano, and lava flows from the symmetrical summit cone extend down drainages to both the east and west.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-671&amp;volpage=photos&amp;photo=117084">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-671">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(58.130000000000003,160.81999999999999)
749	Ostry	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ostry</b></font><br /><font size="5"><b>Central Kamchatka (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117081.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Cinder cone</td><td width="50%" align="left"><b>Summit Elev:</b> 2552 m<br /><b>Latitude:</b> 58.18&deg;N<br /><b>Longitude:</b> 160.82&deg;E</td></tr><tr><td colspan="2"><p align="justify">Conical Ostry volcano, its slopes partially mantled by glaciers, is a late-Quaternary stratovolcano that rises to 2552 m, forming one of the highest peaks of the northern Sredinny Range.  Ostry, also known as Ostraya, is located on the western side of the major NE-trending graben along the axis of the northern Sredinny Range.  An unnamed 2127-m-high cinder cone on the SW flank of Ostry, informally referred to as &quot;Cone X,&quot; erupted about 4000 years ago, producing a basaltic lava flow.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-68-&amp;volpage=photos&amp;photo=117081">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-68-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(58.18,160.81999999999999)
750	Severny	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Severny</b></font><br /><font size="5"><b>Central Kamchatka (Russia)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117085.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1936 m<br /><b>Latitude:</b> 58.28&deg;N<br /><b>Longitude:</b> 160.87&deg;E</td></tr><tr><td colspan="2"><p align="justify">Severny is a late-Quaternary Icelandic-type shield volcano located at the NW end of a major NE-trending graben along the crest of the northern Sredinny Range.  The 1936-m-high Severny is capped by a small stratovolcano.  A small shield volcano was constructed on its SW flank, and an even smaller shield grew on the NE flank.  The basaltic Tobeltsen cinder cone on the WSW flank and associated lava flows were erupted about 3500 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-70-&amp;volpage=photos&amp;photo=117085">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1000-70-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/kvert/index_eng.php">Kamchatka Volcanic Eruption Response Team</a></td><td width="33%"><a href="http://www.kscnet.ru/ivs/volcanoes/holocene/index.htm">Institute of Volcanology and Seismology</a></td></tr></table>	(58.280000000000001,160.87)
751	Sikhote-Alin	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sikhote-Alin</b></font><br /><font size="5"><b>Southeastern Russia</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Latitude:</b> 47.00&deg;N<br /><b>Longitude:</b> 137.50&deg;E</td></tr><tr><td colspan="2"><p align="justify">A vast area of basaltic volcanism is located in the Sikhote-Alin region of SE Russia near the Sea of Japan, NE of Vladivostok.  Flat-lying basalts and basaltic-andesites of continental fissure eruptions dominated, producing a several thousand sq km area of both tholeiitic and alkaline lava flows; the location listed here is approximate.  Basaltic lava fields are present at the Sovgavan Plateau, the Nelma Plateau (also known as the Samarga Plateau) and the Bikin Plateau.  Tholeiitic basalts dominate along coastal fields near the Japan Sea, and alkaline fields are found further inland.  Whitford-Stark (1987) summarized earlier work noting Pliocene-to-Recent activity (referring to the area as Southern Sikhote-Alin).  Shilov (1997a) indicated that activity dates back to the Miocene and that the youngest Cenozoic volcanics in East Sikhote-Alin, those of the Vanino Complex, have been dated as late-Pleistocene, however Shilov (1997b) indicated that activity in East Sikhote-Alin continued into the Holocene.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1002-01-">Smithsonian Volcano Information</a></td></tr></table>	(47,137.5)
752	Udokan Plateau	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Udokan Plateau</b></font><br /><font size="5"><b>Southeastern Russia</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 2180 m<br /><b>Latitude:</b> 56.28&deg;N<br /><b>Longitude:</b> 117.77&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Udokan Plateau volcanic field occupies a broad area about 400 km ENE of the northern tip of Lake Baikal.  Quaternary volcanism here represents the latest manifestation of activity dating back to the Miocene covering an area of  3000 sq km at the eastern margin of the Baikal Rift System.  Late-Pleistocene to Holocene volcanic centers are concentrated along three major lineaments, and many eruptions were localized along fissures trending NW-SE and NE-SW.  Dated Holocene volcanic centers are located on a 20-km-long line at the SW side of the volcanic field, but Holocene cinder cones also occur in the NE Udokan Plateau.  Seismic activity has been recorded at depths of 15 to 20 km beneath some of the cones.  The Udokan volcanic field is dominated by basaltic cinder cones, but basal trachytic ignimbrites are also overlain by lava domes and flows, and trachytic maars were formed during the final stages of activity.  The latest dated eruption took place at Chepe volcano about 2200 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1002-03-">Smithsonian Volcano Information</a></td></tr></table>	(56.280000000000001,117.77)
753	Vitim Plateau	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Vitim Plateau</b></font><br /><font size="5"><b>Southeastern Russia</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1250 m<br /><b>Latitude:</b> 53.70&deg;N<br /><b>Longitude:</b> 113.30&deg;E</td></tr><tr><td colspan="2"><p align="justify">Volcanism in the Vitim Plateau dates back to the Miocene and covers an area of nearly 10,000 sq km east of the northern part of Lake Baikal.  The most voluminous activity at the Vitim volcanic field took place from the Miocene to Pleistocene, but a second phase occurred during the Pleistocene and Holocene.  The latest dated eruption was at about 810,000 years ago.  Most of the volcanic centers are located in the NW part of the volcanic field, parallel to the axial part of the Baikal Rift Zone, which lies about 200 km to the west.  Mantle zenoliths are found in several locations.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1002-04-">Smithsonian Volcano Information</a></td></tr></table>	(53.700000000000003,113.3)
754	Oka Plateau	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Oka Plateau</b></font><br /><font size="5"><b>Southeastern Russia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/064088.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2077 m<br /><b>Latitude:</b> 52.70&deg;N<br /><b>Longitude:</b> 98.98&deg;E</td></tr><tr><td colspan="2"><p align="justify">A group of small basaltic cinder cones on the Oka Plateau, about 200 km WNW of the SW tip of Lake Baikal, was the source of a postglacial alkalic-basalt lava flow that traveled 75 km down the Zhom-Bolok River.  The morphologically youthful flow bends around glacial moraines and fills an erosional valley in an older flow dated at 12,000 +/- 4000 yrs BP (Before Present).  Other young eruptions, such as those from the 90-m-high Kropotkin cinder cone and 120-m-high Peretolchin cone, produced voluminous lava flows not yet dated, and another Holocene cinder cone, Strariy, is located nearby.  This area is part of the East Sayan volcanic region; Holocene activity took place in the Todzha Basin, which is separated from the Oka Plateau by the Great Sayan Ridge.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1002-06-&amp;volpage=photos&amp;photo=064088">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1002-06-">Smithsonian Volcano Information</a></td></tr></table>	(52.700000000000003,98.980000000000004)
755	Azas Plateau	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Azas Plateau</b></font><br /><font size="5"><b>Southeastern Russia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/064083.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 2765 m<br /><b>Latitude:</b> 52.52&deg;N<br /><b>Longitude:</b> 98.60&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Azas Plateau is a large volcanic field located west of the SW tip of Lake Baikal and north of the Mongolian border.  The gently sloping plateau, also known as the East Tuva Plateau, the Northeast Tuva Plateau, or the Khamsara-Biykhem Plateau, covers an area of about 2000 sq km.  Its glacially dissected surface is cut by broad valleys and contains several table-like mountains composed of hyaloclastites and lava flows and dotted with small scoria cones.  The 2765-m-high Shivit-Tayga stratovolcano is one of the most prominent features of the Azas Plateau and is capped by two craters that once contained lava lakes.  Derbi-Tayga is a 2605-m-high glacially eroded shield volcano.  The surface of the Ulug-Arginsky cinder cone, initially considered to be Holocene in age, is dotted with large granitic erratics and was considered by Hasenaka et al. (1999) to be of late-Pleistocene age.  Some valley filling basaltic flows in the Azas Plateau are not glacially eroded and have a Holocene morphology.  Well-preserved lava flows near the Bii-Hem River may be of Holocene age.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1002-07-&amp;volpage=photos&amp;photo=064083">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1002-07-">Smithsonian Volcano Information</a></td></tr></table>	(52.520000000000003,98.599999999999994)
756	Taryatu-Chulutu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Taryatu-Chulutu</b></font><br /><font size="5"><b>Mongolia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110090.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 2400 m<br /><b>Latitude:</b> 48.17&deg;N<br /><b>Longitude:</b> 99.70&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Taryatu-Chulutu volcanic field lies in north-central Mongolia about 250 km west of Ulaanbaatar.   This area, also known as the Hangayn or Tariat volcanic field, is located in a broad region of Miocene-to-Holocene basaltic lavas in the Baikal Rift System SSW of Lake Baikal.  Lava flows of four Miocene-to-Holocene age groups form terraces along the Chulutu (Chuloot) River; Pleistocene basalts form the 40- to 60-m terrace of the Taryatu basin.  Six Holocene cinder cones, including Khorog (Horog) and Dzan Tologai, are concentrated along the Sumein and Gichgeniyn river valleys at the western end of the volcanic field.  The 180-m-wide crater of Khorog is breached to the south, in the direction of an associated lava flow.  The Holocene cones produced thin, freshly preserved lava flows remarkable for their large numbers of ultramafic xenoliths.  The lava flow from Khorog was radiocarbon dated at about 4930 years ago and dammed the Chulutu River, forming Lake Terkhin-Tsagan-Nur.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1003-01-&amp;volpage=photos&amp;photo=110090">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1003-01-">Smithsonian Volcano Information</a></td></tr></table>	(48.170000000000002,99.700000000000003)
757	Khanuy Gol	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Khanuy Gol</b></font><br /><font size="5"><b>Mongolia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/107076.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 1886 m<br /><b>Latitude:</b> 48.67&deg;N<br /><b>Longitude:</b> 102.75&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Khanuy Gol (also spelled Hanui or Hanuy Gol) volcanic field is also known as the Chanuj Gol or Bulgan volcanic field.  It consists of a group of 10 olivine-basaltic lava and cinder cones in west-central Mongolia about 150 km WNW of the capital city of Ulaanbaatar.  The volcanic field covers a 3500 sq km flat-lying plain along the Khanuy River and in drainages to the east.  The cones, including the well-preserved Togo cones about 50 km east of Khanuy, north of the settlement of Bulgan, range from about 30 to 190 m in height.  The Togo cones, rich in ilmenite megacrysts and altered peridotite xenoliths, include Ikh Togo Uul (&quot;Great Togo Mountain&quot;) and Baga Togo Uul &quot;Big Togo Mountain').  The volcanic field was considered to be of late-Pleistocene to Holocene age (IAVCEI, 1973), although no precise age dates are available.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1003-02-&amp;volpage=photos&amp;photo=107076">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1003-02-">Smithsonian Volcano Information</a></td></tr></table>	(48.670000000000002,102.75)
758	Dariganga Volcanic Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Dariganga Volcanic Field</b></font><br /><font size="5"><b>Mongolia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117021.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1778 m<br /><b>Latitude:</b> 45.33&deg;N<br /><b>Longitude:</b> 114.00&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Dariganga volcanic field, located in SE Mongolia near the China border, consists of more than 200 lava and cinder cones of Pleistocene and Holocene age that were erupted from NE-trending parallel fissures.  The cones range in height from 25 to 300 m, and vary from partially eroded to completely preserved.  Compositionally the volcanic rocks are more soda-rich than the potassium-rich rocks of northern and central Mongolia and consist of basaltic, trachybasaltic, and foiditic rocks.  The southern part of the volcanic field, which may be contiguous with the Dolon Nor volcanic field across the border in China, is rich in ultramafic xenoliths.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1003-04-&amp;volpage=photos&amp;photo=117021">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1003-04-">Smithsonian Volcano Information</a></td></tr></table>	(45.329999999999998,114)
759	Turfan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Turfan</b></font><br /><font size="5"><b>Western China</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cone</td><td width="50%" align="left"><b>Latitude:</b> 42.90&deg;N<br /><b>Longitude:</b> 89.25&deg;E</td></tr><tr><td colspan="2"><p align="justify">An isolated volcanic cone near the city of Turfan in Xinjiang Province of NW China has recorded eruptions during the Song Dynasty.  The History of the Song Dynasty recorded activity consisting of frequent smog from the volcano on cloudless days and a nighttime blaze like a torch.  The northern Song Dynasty ruled from 960-1127 AD and the southern Song Dynasty from 1127-1279 AD.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1004-01-">Smithsonian Volcano Information</a></td></tr></table>	(42.899999999999999,89.25)
760	Tianshan Volcanic Group	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tianshan Volcanic Group</b></font><br /><font size="5"><b>Western China</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Latitude:</b> 42.50&deg;N<br /><b>Longitude:</b> 82.50&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Tianshan volcano group in the Tianshan Mountains of Xinjiang Province in NW China contains the historically active cone of Pechan (Whitford-Stark, 1987).  The volcano was reported to have erupted during the first and seventh centuries.  Pechan is also known by a variety of other names, including Peishan, Baishan, Hochan, Aghie, Bichbalick, Khala, and Boschan.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1004-02-">Smithsonian Volcano Information</a></td></tr></table>	(42.5,82.5)
761	Kunlun Volcanic Group	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kunlun Volcanic Group</b></font><br /><font size="5"><b>Western China</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/114077.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 5808 m<br /><b>Latitude:</b> 35.52&deg;N<br /><b>Longitude:</b> 80.20&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Kunlun volcano group in NW Tibet contains 70 well-preserved pyroclastic cones.  The trachyandesitic Ashikule volcano group at the western end of the Kunlun Mountains is the site of at least 10 volcanoes of Pliocene-to-Holocene age, including Ashi Shan volcano, the youngest in China.  This and several other young cones lie in the area around Ashi (Aqqikkol) and Wuluke (Ulugkol) lakes.  China's most recent volcanic eruption was observed by a road-building crew on May 27, 1951, at Ashi Shan (also known as Ka-er-daxi or Vulkan) pyroclastic cone.  The eruption began with a loud detonation and ejected large blocks, emitting &quot;smoke&quot; for a number of days.  An unconfirmed eruption was reported in the 19th century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1004-03-&amp;volpage=photos&amp;photo=114077">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1004-03-">Smithsonian Volcano Information</a></td></tr></table>	(35.520000000000003,80.200000000000003)
762	Arshan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Arshan</b></font><br /><font size="5"><b>Eastern China</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Latitude:</b> 47.50&deg;N<br /><b>Longitude:</b> 120.70&deg;E</td></tr><tr><td colspan="2"><p align="justify">The recently discovered Arshan volcanic field in the central Da Hinggan Mountains of Inner Mongolia in NE China, contains more than 40 Cenozoic volcanoes.  The youngest cones, including Yanshan and Gaoshan, are perfectly preserved and produced basaltic lava flows that blocked drainages of the Halahale River and created six lava-dammed lakes.  Radiocarbon dates from scoria deposits document eruptions about 2000-1900 years ago.  Yanshan cone is about 362 m high, and the crater of Gaoshan is 140 m deep.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1005-011">Smithsonian Volcano Information</a></td></tr></table>	(47.5,120.7)
763	Keluo Group	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Keluo Group</b></font><br /><font size="5"><b>Eastern China</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 670 m<br /><b>Latitude:</b> 49.37&deg;N<br /><b>Longitude:</b> 125.92&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Keluo volcanic field in NE China is located near the Russian border, south of the Heilongjiang (Black Dragon) River.  The Keluo field, like its better known neighbor to the south, the Wudalianchi volcanic field, contains many high-potassium basaltic cinder cones.  Nanshan cone, located at the southern end of the field north of the Keluo River, may be of historical age based on its youthful lava topography, and Gushan may also be of Holocene age.  Other cones to the NE are of Pleistocene to Tertiary age.  Cinder cones of the Keluo volcanic field are located at the intersections of regional NE- and NW-trending lineaments and were erupted through basement volcanic and sedimentary rocks of Jurassic-Cretaceous age, granitic rocks, and pre-Permian metasediments.  There are unconformed reports of historical activity at Keluo.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1005-02-">Smithsonian Volcano Information</a></td></tr></table>	(49.369999999999997,125.92)
764	Wudalianchi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Wudalianchi</b></font><br /><font size="5"><b>Eastern China</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/025030.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 597 m<br /><b>Latitude:</b> 48.72&deg;N<br /><b>Longitude:</b> 126.12&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Wudalianchi volcanic field, named for a string of five scenic lava-dammed lakes, consists of 14 cinder cones capping a 500 sq km shield-like lava plateau in NE China.  The volcanic field, whose name means &quot;Five Connected Pools&quot; was formed during five eruptive cycles from the early Pleistocene to historical time.  Its ancient name was &quot;Nine Hills,&quot; which after the historical eruptions now number 14 hills.  The cinder cones were erupted through basement sedimentary and granitic rocks and show a preferred alignment along three chains at the intersection of NE- and NW-trending lineaments.  In addition to the historical cinder cones of Laoheishan and Huoshaoshan, Xilongmenshan and Donglongmenshan are Holocene in age.  The freshly preserved cones of Laoheishan and Huoshaoshan were formed during eruptions in 1720-21.  Fissures at the base of the two new cinder cones fed glassy pahoehoe and aa lava flows that covered 65 sq km and formed the five lakes of Wudalianchi at their eastern and northern margins.  Renewed eruptions took place in 1776.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1005-03-&amp;volpage=photos&amp;photo=025030">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1005-03-">Smithsonian Volcano Information</a></td></tr></table>	(48.719999999999999,126.12)
765	Jingbo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Jingbo</b></font><br /><font size="5"><b>Eastern China</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 1000? m<br /><b>Latitude:</b> 44.08&deg;N<br /><b>Longitude:</b> 128.83&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Jingbo volcanic field, also known as Ching-pe, Chingpohu, or Jingbohu, is a Pliocene-to-Holocene volcanic field in the Jingbo (or Jingpo) Lake area in Heilongjiang Province.  The scenic Jingbohu (&quot;Mirror Lake&quot;), a major tourist attraction in NE China, was formed when lava flows blocked the Mudan River (Mudanjiang).  The NE-striking Dunhua-Mishan fault controls the location of many vents.  One alkali basaltic lava flow traveled 100 km down a canyon NW of the lake.  Many Holocene trachybasaltic or basantic cones and lava flows lie atop plateaus along the Mudan River, which also contain basanitic and tephriphonolitic rocks.  Mantle xenoliths are common in Jingbo volcanic rocks.  A period of major activity about 5500-5200 years ago produced extensive lava flows that covered an area of about 500 sq km.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1005-04-">Smithsonian Volcano Information</a></td></tr></table>	(44.079999999999998,128.83000000000001)
766	Longgang Group	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Longgang Group</b></font><br /><font size="5"><b>Eastern China</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/067087.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Tuff rings</td><td width="50%" align="left"><b>Summit Elev:</b> 1000 m<br /><b>Latitude:</b> 42.33&deg;N<br /><b>Longitude:</b> 126.50&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Longgang volcanic field covers a 1700 sq km area in Jilin Province of NE China, west of Changbaishan volcano.  Basaltic and trachybasaltic lava flows cover a broad area dotted by more than 150 Quaternary cinder cones and 8 tuff rings.  There is only one known cinder cone of Holocene age, Jinlongdingzi (Gold Dragon Peak).  The eruption that formed the large Jinlongdingzi scoria cone and deposited tephra over a broad area to the east was radiocarbon dated at about 1600-1700 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1005-05-&amp;volpage=photos&amp;photo=067087">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1005-05-">Smithsonian Volcano Information</a></td></tr></table>	(42.329999999999998,126.5)
767	Changbaishan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Changbaishan</b></font><br /><font size="5"><b>China-Korea border</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/067080.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2744 m<br /><b>Latitude:</b> 41.98&deg;N<br /><b>Longitude:</b> 128.08&deg;E</td></tr><tr><td colspan="2"><p align="justify">Massive Changbaishan stratovolcano, also known as Baitoushan and by the Korean names of Baegdu or P'aektu-san, is a relatively poorly known, but volcanologically significant volcano straddling the China/Korea border.  A 5-km-wide, 850-m-deep summit caldera is filled by scenic Lake Tianchi (Sky Lake).  A large Korean-speaking population resides near the volcano on both sides of the border.  The 60-km-diameter dominantly trachytic and rhyolitic volcano was constructed over the Changbaishan (Laoheidingzi) shield volcano.  Satellitic cinder cones are aligned along a NNE trend.  One of the world's largest known Holocene explosive eruptions took place from Changbaishan about 1000 AD, depositing rhyolitic and trachytic tephra as far away as northern Japan and forming in part the present caldera.  Minor historical eruptions have been recorded since the 15th century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1005-06-&amp;volpage=photos&amp;photo=067080">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1005-06-">Smithsonian Volcano Information</a></td></tr></table>	(41.979999999999997,128.08000000000001)
768	Ulreung	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ulreung</b></font><br /><font size="5"><b>Korea</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/115015.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> 984 m<br /><b>Latitude:</b> 37.50&deg;N<br /><b>Longitude:</b> 130.87&deg;E</td></tr><tr><td colspan="2"><p align="justify">Ulreung volcano, also known as Ullung, forms a small 10-km-wide island about 100 km east of the coast of the central Korean Peninsula.  The high point on Ulreung-do (Ulreung Island) is 984-m-high Seonginbong Peak.  The trachyandesitic Ulreung stratovolcano is truncated by the Nari caldera.  Ulreung was the site of a major phonolitic explosive eruption at the beginning of the Holocene from Nari caldera that produced pyroclastic flows and deposited ash across the Sea of Japan (East Sea) in central Honshu.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1006-03-&amp;volpage=photos&amp;photo=115015">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1006-03-">Smithsonian Volcano Information</a></td></tr></table>	(37.5,130.87)
769	Halla	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Halla</b></font><br /><font size="5"><b>Korea</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/025037.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1950 m<br /><b>Latitude:</b> 33.37&deg;N<br /><b>Longitude:</b> 126.53&deg;E</td></tr><tr><td colspan="2"><p align="justify">The massive Halla shield volcano forms much of the 40 x 80 km Cheju (Jeju) Island, which lies 90 km south of the Korean Peninsula.  Eruptions during the Pliocene and Pleistocene built a lava plateau above the roughly 100-m-deep continental shelf on which the basaltic-to-trachytic Halla shield volcano was constructed.  A 400-m-wide crater truncates the 1950-m-high summit.  About 360 late-Pleistocene and Holocene basaltic parasitic cones dotting the flanks of the low-angle volcano were erupted primarily along the long axis of the ENE-WSW-trending island.  Most of these are scoria cones, but about 20 along the coast of the island or offshore are Pleistocene-to-Holocene tuff rings and tuff cones, and lava domes also occur.  Flank eruptions continued into historical time, with the final two taking place during the 11th century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1006-04-&amp;volpage=photos&amp;photo=025037">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1006-04-">Smithsonian Volcano Information</a></td></tr></table>	(33.369999999999997,126.53)
770	Kiska	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kiska</b></font><br /><font size="5"><b>Aleutian Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/085057.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1220 m<br /><b>Latitude:</b> 52.103&deg;N<br /><b>Longitude:</b> 177.602&deg;E</td></tr><tr><td colspan="2"><p align="justify">Conical Kiska volcano is the westernmost historically active volcano of the 2500-km-long Aleutian arc.  The volcano lies at the northern tip of the elongated Kiska Island, across a low isthmus containing East Kiska and West Kiska lakes.   A 400-m-wide elliptical crater, breached to the north, caps the 1220-m-high stratovolcano.  The volcano is surrounded on three sides by sea cliffs up to 450 m high and overlies an older volcanic center exposed to the south.  A massive submarine debris-avalanche deposit extends 40 km to the NNW.  The southern part of the NE-SW-trending island, the westernmost of the Rat Island group, has been glaciated, but all lava flows on Kiska volcano post-date the last major glaciation.  Young, steep-sided blocky lava flows, primarily on the northern and SW flanks, have originated from vents at locations ranging from the summit to near sea level.  A flank cinder cone and associated lava flows were erupted in 1962 at Sirius Point on the northern coast.  The island contains one of the best harbors in the Aleutian Islands, but is uninhabited.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-02-&amp;volpage=photos&amp;photo=085057">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-02-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(52.103000000000002,177.602)
771	Segula	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Segula</b></font><br /><font size="5"><b>Aleutian Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119096.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Fissure vent</td><td width="50%" align="left"><b>Summit Elev:</b> 1160 m<br /><b>Latitude:</b> 52.015&deg;N<br /><b>Longitude:</b> 178.136&deg;E</td></tr><tr><td colspan="2"><p align="justify">The 6 x 7 km island of Segula east of Kiska volcano consists of a conical stratovolcano cut by a prominent NNW-SSE-trending fissure that extends to sea level at both ends of the island.  The northern end of the fissure is flooded by the sea to produce a long, narrow cove.  Segula was constructed above a 100-m-deep submarine platform that extends eastward to Khvostof and Davidof islands.  A submarine debris-avalanche deposit extends up to 18 km offshore to the north.  The summit of Segula contains a small, poorly defined caldera that is partly overtopped on the south by a cinder cone that forms the 1153 m high point of the island and on the north by extensive lava flows that reach the NE coast along a broad front.  Another lava field on the SE coast originated from a cinder cone at 300 m altitude on the SE flank.  No historical eruptions are known from Segula, but Nelson (1959) considered fresh lava flows on the north flank to possibly be only a few hundred years old.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-03-&amp;volpage=photos&amp;photo=119096">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-03-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(52.015000000000001,178.136)
772	Little Sitkin	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Little Sitkin</b></font><br /><font size="5"><b>Aleutian Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/094082.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas</td><td width="50%" align="left"><b>Summit Elev:</b> 1174 m<br /><b>Latitude:</b> 51.95&deg;N<br /><b>Longitude:</b> 178.543&deg;E</td></tr><tr><td colspan="2"><p align="justify">Diamond-shaped Little Sitkin Island is bounded by steep cliffs on the east, north, and NE sides.  Little Sitkin volcano contains two nested calderas.   The older, nearly circular Pleistocene caldera is 4.8 km wide, may have once contained a caldera lake, and was partially filled by a younger cone formed mostly of andesitic and dacitic lava flows.  The elliptical younger caldera is 2.7 x 4 km wide; it lies within the eastern part of the older caldera and shares its eastern and southern rim.  The younger caldera partially destroyed the lava cone within the first caldera and is of possible early Holocene age.  Young-looking dacitic lava flows, erupted in 1828 (Kay, in Wood and Kienle 1990), issued from the central cone within the younger caldera and from a vent on the west flank outside the older caldera.  Fumarolic areas are found near the western coast, along the NW margin of the older caldera, and from the summit crater down the southern flank for a 1 km distance.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-05-&amp;volpage=photos&amp;photo=094082">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-05-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(51.950000000000003,178.54300000000001)
773	Semisopochnoi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Semisopochnoi</b></font><br /><font size="5"><b>Aleutian Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/094092.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1221 m<br /><b>Latitude:</b> 51.93&deg;N<br /><b>Longitude:</b> 179.58&deg;E</td></tr><tr><td colspan="2"><p align="justify">Semisopochnoi, the largest subaerial volcano of the western Aleutians, is 20 km wide at sea level and contains an 8-km-wide caldera.  It formed as a result of collapse of a low-angle, dominantly basaltic volcano following the eruption of a large volume of dacitic pumice.  The high point of the island is 1221-m-high Anvil Peak, a double-peaked late-Pleistocene cone that forms much of the island's northern part.  The three-peaked 774-m-high Mount Cerberus volcano was constructed during the Holocene within the caldera.  Each of the peaks contains a summit crater; lava flows on the northern flank of Cerberus appear younger than those on the southern side.  Other post-caldera volcanoes include the symmetrical 855-m-high Sugarloaf Peak SSE of the caldera and Lakeshore Cone, a small cinder cone at the edge of Fenner Lake in the NE part of the caldera.  Most documented historical eruptions have originated from Cerberus, although Coats (1950) considered that both Sugarloaf and Lakeshore Cone within the caldera could have been active during historical time.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-06-&amp;volpage=photos&amp;photo=094092">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-06-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(51.93,179.58000000000001)
774	Gareloi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Gareloi</b></font><br /><font size="5"><b>Aleutian Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119100.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 1573 m<br /><b>Latitude:</b> 51.790&deg;N<br /><b>Longitude:</b> 178.794&deg;W</td></tr><tr><td colspan="2"><p align="justify">The 8 x 10 km diameter Gareloi Island, the northernmost volcano of the Delarof Group at the western end of the Andreanof Islands, consists of a stratovolcano with two summits and a SE-trending fissure.  This prominent fissure was formed during an eruption in 1929 and extends from the southern summit to the sea.  Steep sea cliffs that are cut into rocks of an older, eroded center are found on the SW coast, and submarine deposits of three debris avalanches produced by edifice collapse are found offshore.  Young lava flows cover the older volcano from the 1573-m-high summit of Gareloi to the coast along three broad axes trending NW, ENE, and south.  The 1929 eruption originated from 13 craters along a 4-km-long fissure.  Phreatic explosions were followed by the ejection of glassy pumice, lapilli, scoria, and older blocks, as well as by the emission of four short, steep lava flows, one of which reached the SE coast.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-07-&amp;volpage=photos&amp;photo=119100">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-07-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(51.789999999999999,-178.79400000000001)
775	Tanaga	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tanaga</b></font><br /><font size="5"><b>Andreanof Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119098.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 1806 m<br /><b>Latitude:</b> 51.885&deg;N<br /><b>Longitude:</b> 178.146&deg;W</td></tr><tr><td colspan="2"><p align="justify">Tanaga volcano, the second largest volcanic center of the central Aleutians, is the central and highest of three youthful stratovolcanoes oriented along a roughly E-W line at the NW tip of Tanaga Island.  Arcuate ridges to the east and south represent the rim of an arcuate caldera formed by collapse of an ancestral Tanaga volcano during the Pleistocene.  Most Holocene eruptions originated from Tanaga volcano itself, which consists of two large cones, the western of which is the highest, constructed within a caldera whose 400-m-high rim is prominent to the SE.  At the westernmost end of the Tanaga complex is conical Sajaka, a 1304-m-high double cone that may be the youngest of the three volcanoes.  Sajaka One volcano collapsed during the late Holocene, producing a debris avalanche that swept into the sea, after which Sajaka Two cone was constructed within the collapse scarp.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-08-&amp;volpage=photos&amp;photo=119098">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-08-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(51.884999999999998,-178.14599999999999)
776	Takawangha	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Takawangha</b></font><br /><font size="5"><b>Andreanof Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119099.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1449 m<br /><b>Latitude:</b> 51.873&deg;N<br /><b>Longitude:</b> 178.006&deg;W</td></tr><tr><td colspan="2"><p align="justify">Takawangha is a 1449-m-high, youthful volcano with an ice-filled caldera on northern Tanaga Island, near the western end of the Andreanof Islands.  Takawangha lies across a saddle from historically active Tanaga volcano to the west; older, deeply eroded volcanoes lie adjacent to Takawangha on the east.  The summit of the dominantly basaltic to basaltic-andesite volcano is largely ice covered, with the exception of five Holocene craters that during the last few thousand years produced explosive eruptions and lava flows that reached the lower flanks of the volcano.  No historical eruptions are known from Takawangha, although radiocarbon dating indicates explosive eruptions have occurred within the past several hundred years.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-09-&amp;volpage=photos&amp;photo=119099">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-09-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(51.872999999999998,-178.006)
777	Kanaga	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kanaga</b></font><br /><font size="5"><b>Andreanof Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/095052.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1307 m<br /><b>Latitude:</b> 51.923&deg;N<br /><b>Longitude:</b> 177.168&deg;W</td></tr><tr><td colspan="2"><p align="justify">Symmetrical Kanaga stratovolcano is situated within the Kanaton caldera at the northern tip of Kanaga Island.  The rim of Kanaton caldera forms a 760-m-high arcuate ridge south and east of Kanaga; a lake occupies part of the SE caldera floor.  The volume of subaerial dacitic tuff is smaller than would typically be associated with caldera collapse, and deposits of a massive submarine debris avalanche associated with edifice collapse extend nearly 30 km to the NNW.  Several fresh lava flows from historical or late prehistorical time descend the flanks of Kanaga, in some cases to the sea.  Historical eruptions, most of which are poorly documented, have been recorded since 1763.   Kanaga is also noted petrologically for ultramafic inclusions within an outcrop of alkaline basalt SW of the volcano.  Fumarolic activity occurs in a circular, 200-m-wide, 60-m-deep summit crater and produces vapor plumes sometimes seen on clear days from Adak, 50 km to the east.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-11-&amp;volpage=photos&amp;photo=095052">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-11-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(51.923000000000002,-177.16800000000001)
778	Moffett	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Moffett</b></font><br /><font size="5"><b>Andreanof Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/085042.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1196 m<br /><b>Latitude:</b> 51.944&deg;N<br /><b>Longitude:</b> 176.747&deg;W</td></tr><tr><td colspan="2"><p align="justify">Rising above Adak, the largest town of the Aleutians, Mount Moffett is a modest-sized, eroded stratovolcano with several flank lava domes.   The summit cone has been largely destroyed by glacial erosion, and has been filled by an andesitic plug dome.  Five other lava domes are scattered over the flanks of the volcano.  The south flank lava dome is one of the youngest features of the northern Adak Island volcanoes.  The Heart Lake lava flow west of Sweeper Cove on the SE side of the volcano is another young volcanic feature.  Several Holocene ash layers on Adak Island have been attributed to Moffett volcano.  Its proximity to Adak Naval Air Station makes Mount Moffet one of the most accessible of the Aleutian volcanoes.  Kiguga Warm Springs are located at Cape Kiguga, west of Mount Moffet, and the northern part of Adak Island has been investigated for geothermal power production.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-111&amp;volpage=photos&amp;photo=085042">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-111">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(51.944000000000003,-176.74700000000001)
779	Great Sitkin	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Great Sitkin</b></font><br /><font size="5"><b>Andreanof Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/085062.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 1740+ m<br /><b>Latitude:</b> 52.076&deg;N<br /><b>Longitude:</b> 176.130&deg;W</td></tr><tr><td colspan="2"><p align="justify">Constructed within the caldera of an older shield volcano forming the northern half of Great Sitkin Island, 1740-m-high Great Sitkin volcano contains a small, 0.8 x 1.2 km ice-filled summit caldera.  Deep glacial valleys radiate from the summit, which lies at the eastern rim of the caldera, which was formed by massive edifice failure that produced a submarine debris avalanche that traveled more than 40 km to the north.  The entire island is blanketed with a light-brown to black pumice layer up to 6 m thick.  This deposit is overlain over much of the NW side of the island by ash deposits from a subsidiary vent NW of the caldera.  Hot springs, mud pots, and fumaroles occur near the head of Big Fox Creek, south of the volcano.  Historical eruptions have been recorded since the late-19th century.  In 1945, a 400-600 m wide, flat-topped lava dome was emplaced through a glacier filling the steep-sided, 180-m-deep summit caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-12-&amp;volpage=photos&amp;photo=085062">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-12-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(52.076000000000001,-176.13)
780	Kasatochi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kasatochi</b></font><br /><font size="5"><b>Andreanof Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/085063.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 314 m<br /><b>Latitude:</b> 52.177&deg;N<br /><b>Longitude:</b> 175.508&deg;W</td></tr><tr><td colspan="2"><p align="justify">Located at the northern end of a shallow submarine ridge trending perpendicular to the Aleutian arc, Kasatochi is small 2.7 x 3.3 km wide island volcano with a dramatic 750-m-wide summit crater lake.  The summit of Kasatochi reaches only 314 m above sea level, and the lake surface lies less than about 60 m above the sea.  A lava dome is located on the NW flank at about 150 m elevation.  The asymmetrical island is steeper on the northern side than the southern, and the volcano's crater lies north of the center of the island.  Reports of activity from the heavily eroded Koniuji volcano to the east probably refer to eruptions from Kasatochi.  A lava flow may have been emplaced during the first historical eruption in 1760.  A major explosive eruption in 2008 produced pyroclastic flows and surges that swept into the sea, extending the island's shoreline.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-13-&amp;volpage=photos&amp;photo=085063">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-13-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(52.177,-175.50800000000001)
781	Koniuji	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Koniuji</b></font><br /><font size="5"><b>Andreanof Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/095088.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 273 m<br /><b>Latitude:</b> 52.22&deg;N<br /><b>Longitude:</b> 175.13&deg;W</td></tr><tr><td colspan="2"><p align="justify">The very small, 1 x 1.5 km wide Koniuji Island, located between Atka and Kasatochi volcanoes, is the emergent top of a mostly submarine volcano.  The summit of the mostly submerged volcano reaches only 273 m above sea level.  The volcano, which lies about 20 km north of the western side of Atka Island, is deeply dissected, with a steep, arcuate cliff on the west.  New argon-argon dating indicates that the island emerged above sea level aout 15,000 years ago, and that several lava flows and domes were erupted during the Holocene.  The summit lava dome is younger than about 3000 years.  Reports of historical eruptive activity may be erroneous and are considered to refer to eruptions of the relatively undissected Kasatochi volcano to the west.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-14-&amp;volpage=photos&amp;photo=095088">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-14-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(52.219999999999999,-175.13)
782	Atka	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Atka</b></font><br /><font size="5"><b>Andreanof Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120046.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 1451 m<br /><b>Latitude:</b> 52.332&deg;N<br /><b>Longitude:</b> 174.137&deg;W</td></tr><tr><td colspan="2"><p align="justify">The largest volcanic center in the central Aleutians, Atka consists of a central shield and Pleistocene caldera with several post-caldera volcanoes.  A major dacitic explosive eruption accompanied formation of the caldera about 500,000 to 300,000 years ago.  The most prominent of the post-caldera stratovolcanoes are Kliuchef and Sarichef, both of which may have been active in historical time.  Sarichef has a symmetrical profile, but the less eroded Kliuchef is the source of most if not all historical eruptions.  Kliuchef may have been active on occasion simultaneously with Korovin volcano to the north.  Hot springs and fumaroles are located on the flanks of Mount Kliuchef and in a glacial valley SW of Kliuchef.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-16-&amp;volpage=photos&amp;photo=120046">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-16-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(52.332000000000001,-174.137)
783	Korovin	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Korovin</b></font><br /><font size="5"><b>Atka I</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/095027.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Cinder cone</td><td width="50%" align="left"><b>Summit Elev:</b> 1533 m<br /><b>Latitude:</b> 52.381&deg;N<br /><b>Longitude:</b> 174.154&deg;W</td></tr><tr><td colspan="2"><p align="justify">Korovin, the most frequently active volcano of the large volcanic complex at the NE tip of Atka Island, contains a 1533-m-high double summit with two craters located along a NW-SE line.  The NW summit has a small crater, but the 1-km-wide crater of the SE cone has an unusual, open cylindrical vent of widely variable depth that sometimes contains a crater lake or a high magma column.  A fresh-looking cinder cone lies on the flank of partially dissected Konia volcano, located on the SE flank of Korovin.  The volcano is dominantly basaltic in composition, although some late-stage dacitic lava flows are present on both Korovin and Konia.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-161&amp;volpage=photos&amp;photo=095027">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-161">Smithsonian Volcano Information</a></td></tr></table>	(52.381,-174.154)
784	Seguam	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Seguam</b></font><br /><font size="5"><b>Andreanof Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/094069.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Calderas</td><td width="50%" align="left"><b>Summit Elev:</b> 1054 m<br /><b>Latitude:</b> 52.315&deg;N<br /><b>Longitude:</b> 172.510&deg;W</td></tr><tr><td colspan="2"><p align="justify">The elliptical, 11.5 x 24 km island of Seguam, lying between Amlia and Amukta Islands in the central Aleutians, contains two calderas with Holocene post-caldera cones.  Growth of the basaltic-to-rhyolitic Wilcox volcano on the east side of the island during the late Pleistocene was followed by edifice collapse and an associated ignimbrite eruption about 9000 years ago, leaving a horseshoe-shaped caldera open to the west, inside which a rhyolitic cone was constructed.  The 3 x 4 km wide westernmost caldera has a central scoria cone, Pyre Peak, which rises above the caldera rim and is the source of most of the historical eruptions of Seguam volcano.  A very young basaltic field surrounds Pyre Peak, and lava flows partially fill the caldera and reach the southern coast.  Older Holocene lava flows were erupted from vents within the eastern caldera, and a monogenetic Holocene cone forms Moundhill volcano on the eastern tip of the island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-18-&amp;volpage=photos&amp;photo=094069">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-18-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(52.314999999999998,-172.50999999999999)
785	Amukta	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Amukta</b></font><br /><font size="5"><b>Islands of the Four Mountains</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/085053.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> 1066 m<br /><b>Latitude:</b> 52.50&deg;N<br /><b>Longitude:</b> 171.252&deg;W</td></tr><tr><td colspan="2"><p align="justify">The symmetrical Amukta stratovolcano lies in the central Aleutians SW of Chagulak Island and is the westernmost of the Islands of the Four Mountains group.  Amukta was constructed at the northern side of an arcuate caldera-like feature that is open to the sea along the southern coast of the 8-km-wide Amukta Island.  The 1066-m-high stratovolcano overlies a broad shield volcano and is topped by a 400-m-wide crater.  A cinder cone is located near the NE coast.   Amukta has had several eruptions in historical time from both summit and flank vents.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-19-&amp;volpage=photos&amp;photo=085053">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-19-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(52.5,-171.25200000000001)
786	Chagulak	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Chagulak</b></font><br /><font size="5"><b>Islands of the Four Mountains</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/095085.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1142 m<br /><b>Latitude:</b> 52.577&deg;N<br /><b>Longitude:</b> 171.13&deg;W</td></tr><tr><td colspan="2"><p align="justify">The 3-km-wide island of Chagulak in the Islands of the Four Mountains group is the summit of a small, unstudied stratovolcano NE of Amukta volcano.  The two volcanoes coalesce at depth although they are separated by 7 km of ocean.  Yunaska volcano lies about 20 km to the east.  Sharp-topped Chagulak volcano rises steeply to 1142 m and is ruggedly dissected on the east side.  No historical eruptions have been recorded from Chagulak volcano, and its age is not precisely known.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-20-&amp;volpage=photos&amp;photo=095085">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-20-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(52.576999999999998,-171.13)
787	Yunaska	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Yunaska</b></font><br /><font size="5"><b>Islands of the Four Mountains</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/095039.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 550 m<br /><b>Latitude:</b> 52.643&deg;N<br /><b>Longitude:</b> 170.629&deg;W</td></tr><tr><td colspan="2"><p align="justify">The elongated, 9 x 23 km island of Yunaska in the Islands of the Four Mountains group is comprised of two unnamed volcanic centers of greatly different morphology.  The older, 950-m-high western center consists of the eroded remnants of four overlapping stratovolcanoes that form a linear, NNE-trending ridge.  Cinder cones and fissure-fed lava flows extend from the western end of the complex.  The younger, 550-m-high eastern complex consists of a shield volcano capped by two nested calderas.  The 3.5-km-wide Coats caldera is located within an older 10 x 13 km caldera and contains cinder cones and a lava field.  Two areas of particularly youthful lava flows extend down the flank through a gap in the SW caldera rim and blanket the upper northern flank of the caldera.  Vents are found on the flanks of the caldera within a kilometer of its rim.   A post-caldera cone is capped by a small summit crater.  The eastern center is presumably the source of the island's historical eruptions, first recorded in 1817.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-21-&amp;volpage=photos&amp;photo=095039">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-21-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(52.643000000000001,-170.62899999999999)
788	Herbert	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Herbert</b></font><br /><font size="5"><b>Islands of the Four Mountains</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/045056.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 1280 m<br /><b>Latitude:</b> 52.742&deg;N<br /><b>Longitude:</b> 170.111&deg;W</td></tr><tr><td colspan="2"><p align="justify">The 10-km-wide Herbert Island, the SW-most of the Islands of the Four Mountains group, lies across a strait SW of Mount Cleveland.  Herbert is a classic, symmetrical stratovolcano whose summit is broadly truncated by a 2-km-wide caldera that is breached to NW.  No historical eruptions have been recorded from 1280-m-high Herbert volcano, which, like many other Aleutian volcanoes, has not been studied geologically.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-22-&amp;volpage=photos&amp;photo=045056">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-22-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(52.741999999999997,-170.11099999999999)
789	Carlisle	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Carlisle</b></font><br /><font size="5"><b>Islands of the Four Mountains</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/093064.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1620 m<br /><b>Latitude:</b> 52.894&deg;N<br /><b>Longitude:</b> 170.054&deg;W</td></tr><tr><td colspan="2"><p align="justify">Carlisle Island is a steep-sided, conical stratovolcano that rises to 1620 m across the Carlisle Pass strait from Mount Cleveland.  Radar images suggest that this uninhabited, 7-km-wide island may contain two closely spaced volcanic cones (Myers, in Wood and Kienle 1990).  Like nearby Herbert volcano, no geologic studies have been conducted on the volcano.  Eruptions from Carlisle have been reported since the 18th century, but are very poorly documented.  A variety of names was attached to Carlisle on early hydrographic maps, and Miller et al. (1998) noted that some 18th and 19th century eruptions reported at the closely spaced volcanoes of the &quot;Islands of the Four Mountains&quot; area could refer to Carlisle as well as Cleveland, Uliaga, or Kagamil volcanoes.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-23-&amp;volpage=photos&amp;photo=093064">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-23-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(52.893999999999998,-170.054)
790	Cleveland	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cleveland</b></font><br /><font size="5"><b>Chuginadak Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/053094.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1730 m<br /><b>Latitude:</b> 52.825&deg;N<br /><b>Longitude:</b> 169.944&deg;W</td></tr><tr><td colspan="2"><p align="justify">Beautifully symmetrical Mount Cleveland stratovolcano is situated at the western end of the uninhabited, dumbbell-shaped Chuginadak Island.  It lies SE across Carlisle Pass strait from Carlisle volcano and NE across Chuginadak Pass strait from Herbert volcano.  Cleveland is joined to the rest of Chuginadak Island by a low isthmus.  The 1730-m-high Mount Cleveland is the highest of the Islands of the Four Mountains group and is one of the most active of the Aleutian Islands.  The native name for Mount Cleveland, Chuginadak, refers to the Aleut goddess of fire, who was thought to reside on the volcano.  Numerous large lava flows descend the steep-sided flanks of the volcano.  It is possible that some 18th-to-19th century eruptions attributed to Carlisle should be ascribed to Cleveland (Miller et al., 1998).  In 1944 Cleveland produced the only known fatality from an Aleutian eruption.  Recent eruptions from Mount Cleveland have been characterized by short-lived explosive ash emissions, at times accompanied by lava fountaining and lava flows down the flanks.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-24-&amp;volpage=photos&amp;photo=053094">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-24-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(52.825000000000003,-169.94399999999999)
791	Tana	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tana</b></font><br /><font size="5"><b>Chuginadak Island</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/118060.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1170 m<br /><b>Latitude:</b> 52.83&deg;N<br /><b>Longitude:</b> 169.77&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Tana volcanic complex forming the eastern half of the dumbbell-shaped Chuginadak Island, opposite the dramatic conical Cleveland stratovolcano, is composed of two prominent E-W-trending volcanoes.  The complex shows evidence of glacial erosion, but the observation on satellite imagery of highly irregular coastlines forming peninsulas west of Applegate Cove on the NW side of the complex and Concord Point on the south side imply lava flows of mid- to late-Holocene age (Nye 2007, pers. comm.).  Prominent lava flow levees are visible near Concord Point, where a low-silica rhyolite sample was obtained.  The undissected cone and youthful crater forming the western summit also imply a post-glacial age, and youthful cinder cones also lie east of the isthmus between Cleveland and Tana volcanoes.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-241&amp;volpage=photos&amp;photo=118060">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-241">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(52.829999999999998,-169.77000000000001)
792	Uliaga	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Uliaga</b></font><br /><font size="5"><b>Islands of the Four Mountains</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/095036.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 888 m<br /><b>Latitude:</b> 53.065&deg;N<br /><b>Longitude:</b> 169.77&deg;W</td></tr><tr><td colspan="2"><p align="justify">The small, triangular, 3-km-wide island of Uliaga, located at the NE end of the Islands of the Four Mountains archipelago immediately NW of Kagamil Island, is composed of a small, eroded stratovolcano.  Uliaga volcano rises to only 888 m and is the smallest of the Islands of the Four Mountains volcanoes.  There are no reports of historical eruptions from Uliaga, but the volcano was considered to have been active during the Holocene (Nye et al., 1998).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-25-&amp;volpage=photos&amp;photo=095036">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-25-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(53.064999999999998,-169.77000000000001)
793	Kagamil	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kagamil</b></font><br /><font size="5"><b>Islands of the Four Mountains</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/085041.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 893 m<br /><b>Latitude:</b> 52.974&deg;N<br /><b>Longitude:</b> 169.72&deg;W</td></tr><tr><td colspan="2"><p align="justify">Kagamil Island lies near the NE end of the Islands of the Four Mountains archipelago in the central Aleutians, between Chuginadak and Uliaga Islands.  The southern half of 5 x 10 km Kagamil Island contains two undissected cones of postglacial age with small summit craters.  The larger, 893-m-high cone is located at the SE end of the NNW-SSE-trending volcano.  Arcuate ridges at the northern and southern ends of the island suggest a possible earlier caldera.  Hot springs and fumaroles occur along a steaming beach at the SE coast.  The early explorer Veniaminof (1840) indicated that Kagamil formerly &quot;flamed and smoked,&quot; but the only eruptive report is of unspecified activity in 1929 (Coats 1950).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-26-&amp;volpage=photos&amp;photo=085041">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-26-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(52.973999999999997,-169.72)
794	Vsevidof	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Vsevidof</b></font><br /><font size="5"><b>Fox Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/053092.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Fissure vents<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2149 m<br /><b>Latitude:</b> 53.130&deg;N<br /><b>Longitude:</b> 168.693&deg;W</td></tr><tr><td colspan="2"><p align="justify">The symmetrical Vsevidof stratovolcano, near the SW end of Umnak Island, is one of the most prominent volcanoes in the Aleutians.  Vsevidof contains a 1.2-km-wide, ice-filled summit crater that is breached by glaciers on the east and north sides.  An E-W-trending zone of scoria cones that extends from 1220 m down much of the western flank has been the source of historical eruptions.  The bulk of the 2149-m-high cone of Vsevidof was constructed during the Holocene.  Young andesitic and dacitic lava flows were extruded from vents on the north and south flanks and on the west-flank rift.  The largest lava flow traveled down the west flank to the coast, forming Cape Kigushimkada.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-27-&amp;volpage=photos&amp;photo=053092">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-27-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(53.130000000000003,-168.69300000000001)
795	Recheschnoi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Recheschnoi</b></font><br /><font size="5"><b>Fox Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/053088.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1984 m<br /><b>Latitude:</b> 53.157&deg;N<br /><b>Longitude:</b> 168.539&deg;W</td></tr><tr><td colspan="2"><p align="justify">The heavily glaciated, 1984-m-high Recheschnoi stratovolcano is located ENE of a roughly 900-m-high saddle across from Vsevidof volcano.  Recheschnoi consists of an elongated, NE-SW-trending ridge that is dissected by deep glacier-filled valleys.  Erosion is more extensive at the NE end.  Holocene andesitic pyroclastic cones and rhyolitic lava domes, the latter west of the head of Russian Bay, are situated on the east and west flanks of the volcano.  The Geyser Bight geothermal area on the NE flank of Recheschnoi is one of the hottest and most extensive thermal areas in Alaska.  It consists of six zones of thermal springs and two fumarolic areas along upper Geyser Creek and contains the only known geysers in the state.  Other thermal areas occur at Hot Springs Cove and Partov Cove on the rugged isthmus between Recheschnoi and Okmok volcanoes.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-28-&amp;volpage=photos&amp;photo=053088">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-28-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(53.156999999999996,-168.53899999999999)
796	Okmok	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Okmok</b></font><br /><font size="5"><b>Fox Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/053086.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1073 m<br /><b>Latitude:</b> 53.43&deg;N<br /><b>Longitude:</b> 168.13&deg;W</td></tr><tr><td colspan="2"><p align="justify">The broad, basaltic Okmok shield volcano, which forms the NE end of Umnak Island, has a dramatically different profile than most other Aleutian volcanoes.  The summit of the low, 35-km-wide volcano is cut by two overlapping 10-km-wide calderas formed during eruptions about 12,000 and 2050 years ago that produced dacitic pyroclastic flows that reached the coast.  More than 60 tephra layers from Okmok have been found overlying the 12,000-year-old caldera-forming tephra layer.  Numerous satellitic cones and lava domes dot the flanks of the volcano down to the coast, including 1253-m Mount Tulik on the SE flank, which is almost 200 m higher than the caldera rim.  Some of the post-caldera cones show evidence of wave-cut lake terraces; the more recent cones, some of which have been active historically, were formed after the caldera lake, once 150 m deep, disappeared.  Hot springs and fumaroles are found within the caldera.  Historical eruptions have occurred since 1805 from cinder cones within the caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-29-&amp;volpage=photos&amp;photo=053086">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-29-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(53.43,-168.13)
797	Bogoslof	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bogoslof</b></font><br /><font size="5"><b>Fox Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/053083.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 150 m<br /><b>Latitude:</b> 53.93&deg;N<br /><b>Longitude:</b> 168.03&deg;W</td></tr><tr><td colspan="2"><p align="justify">Bogoslof is the emergent summit of a submarine volcano that lies 40 km north of the main Aleutian arc.  It rises 1500 m above the Bering Sea floor.  Repeated construction and destruction of lava domes at different locations during historical time has greatly modified the appearance of this &quot;Jack-in-the-Box&quot; volcano and has introduced a confusing nomenclature applied during frequent visits of exploring expeditions.  The present triangular-shaped, 0.75 x 2 km island consists of remnants of lava domes emplaced from 1796 to 1992.  Castle Rock (Old Bogoslof) is a steep-sided pinnacle that is a remnant of a spine from the 1796 eruption.  Fire Island (New Bogoslof), a small island located about 600 m NW of Bogoslof Island, is a remnant of a lava dome that was formed in 1883.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-30-&amp;volpage=photos&amp;photo=053083">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-30-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(53.93,-168.03)
798	Makushin	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Makushin</b></font><br /><font size="5"><b>Fox Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/045055.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1800 m<br /><b>Latitude:</b> 53.891&deg;N<br /><b>Longitude:</b> 166.923&deg;W</td></tr><tr><td colspan="2"><p align="justify">The ice-covered, 1800-m-high Makushin volcano on northern Unalaska Island west of the town of Dutch Harbor is capped by a 2.5-km-wide caldera.  The broad, domical structure of Makushin contrasts with the steep-sided profiles of most other Aleutian stratovolcanoes.  Much of the volcano was formed during the Pleistocene, but the caldera (which formed about 8000 years ago), Sugarloaf cone on the ENE flank, and a cluster of about a dozen explosion pits and cinder cones at Point Kadin on the WNW flank, are of Holocene age.  A broad band of NE-SW-trending satellitic vents cuts across the volcano.  The composite Pakushin cone, with multiple summit craters, lies 8 km to the SW of Makushin.  Frequent explosive eruptions have occurred during the past 4000 years, sometimes accompanied by pyroclastic flows and surges.  Geothermal areas are found in the summit caldera of Makushin and on the SE and eastern flanks of the volcano.  They represent the largest and most investigated high-temperature geothermal resources in Alaska.  Small-to-moderate explosive eruptions have been recorded at Makushin since 1786.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-31-&amp;volpage=photos&amp;photo=045055">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-31-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(53.890999999999998,-166.923)
799	Akutan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Akutan</b></font><br /><font size="5"><b>Fox Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/045044.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1303 m<br /><b>Latitude:</b> 54.134&deg;N<br /><b>Longitude:</b> 165.986&deg;W</td></tr><tr><td colspan="2"><p align="justify">One of the most active volcanoes of the Aleutian arc, Akutan contains 2-km-wide caldera with an active intracaldera cone.  An older, largely buried caldera was formed during the late Pleistocene or early Holocene.  Two volcanic centers are located on the NW flank.  Lava Peak is of Pleistocene age, and a cinder cone lower on the flank produced a lava flow in 1852 that extended the shoreline of the island and forms Lava Point.  The 60-365 m deep younger caldera was formed during a major explosive eruption about 1600 years ago and contains at least three lakes.  The currently active large cinder cone in the NE part of the caldera has been the source of frequent explosive eruptions with occasional lava effusion that blankets the caldera floor.  A lava flow in 1978 traveled through a narrow breach in the north caldera rim almost to the coast.  Fumaroles occur at the base of the caldera cinder cone, and hot springs are located NE of the caldera at the head of Hot Springs Bay valley and along the shores of Hot Springs Bay.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-32-&amp;volpage=photos&amp;photo=045044">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-32-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(54.134,-165.98599999999999)
800	Westdahl	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Westdahl</b></font><br /><font size="5"><b>Fox Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/053072.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano ?<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1654 m<br /><b>Latitude:</b> 54.518&deg;N<br /><b>Longitude:</b> 164.65&deg;W</td></tr><tr><td colspan="2"><p align="justify">Westdahl is a broad, 1654-m-high glacier-covered volcano occupying the SW end of Unimak Island.  Two peaks protrude from the summit plateau, and a new crater formed in 1978 cuts the summit icecap.  The broad volcano has a somewhat of a shield-like morphology and forms one of the largest volcanoes of the Aleutian Islands.  The sharp-topped, conical Pogromni stratovolcano lies 5 km north of Westdahl.  Pogromni rises to 2002 m, several hundred meters higher than Westdahl, but is moderately glacially dissected and presumably older.  Many satellitic cones of postglacial age are located along a NW-SE line cutting across the summit of Westdahl.  Some of the historical eruptions attributed to the eroded Pogromni volcano may have originated instead from Westdahl (Miller et al. 1998).   The first historical eruption of Westdahl occurred in 1795.  An 8-km-long fissure extending east from the summit of Westdahl produced explosive eruptions and lava flows in 1991.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-34-&amp;volpage=photos&amp;photo=053072">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-34-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(54.518000000000001,-164.65000000000001)
801	Fisher	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Fisher</b></font><br /><font size="5"><b>Fox Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/053071.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1112 m<br /><b>Latitude:</b> 54.65&deg;N<br /><b>Longitude:</b> 164.43&deg;W</td></tr><tr><td colspan="2"><p align="justify">The 11 x 18 km Fisher caldera on western Unimak Island NE of Westdahl volcano is one of the largest calderas in the Aleutian arc.  The caldera, which is elongated in a NE direction, formed around 9400 years ago, accompanied by emission of large-volume, mobile pyroclastic flows that reached the Bering Sea and the Pacific Ocean.  Two satellitic cones are located below the north rim, NE of its 1112-m high point at Eickelberg Peak, which rises more than 900 m above three lakes on the caldera floor, one of which drains through a notch in the southern caldera rim.  A large composite cone, Mount Finch, is found at the center of the caldera, which also contains a small breached cinder cone.  Historical eruptions have occurred in the 18th and 19th centuries.  Low-temperature fumaroles are located at the western flank of Mount Finch, and Turquoise Lake, at the base of the cone, emits hydrogen sulfide gas.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-35-&amp;volpage=photos&amp;photo=053071">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-35-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(54.649999999999999,-164.43000000000001)
802	Shishaldin	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Shishaldin</b></font><br /><font size="5"><b>Fox Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/053069.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 2857 m<br /><b>Latitude:</b> 54.756&deg;N<br /><b>Longitude:</b> 163.97&deg;W</td></tr><tr><td colspan="2"><p align="justify">The beautifully symmetrical volcano of Shishaldin is the highest and one of the most active volcanoes of the Aleutian Islands.  The 2857-m-high, glacier-covered volcano is the westernmost of three large stratovolcanoes along an E-W line in the eastern half of Unimak Island.  The Aleuts named the volcano Sisquk, meaning &quot;mountain which points the way when I am lost.&quot;  A steady steam plume rises from its small summit crater.  Constructed atop an older glacially dissected volcano, Shishaldin is Holocene in age and largely basaltic in composition.  Remnants of an older ancestral volcano are exposed on the west and NE sides at 1500-1800 m elevation.  Shishaldin contains over two dozen pyroclastic cones on its NW flank, which is blanketed by massive aa lava flows.  Frequent explosive activity, primarily consisting of strombolian ash eruptions from the small summit crater, but sometimes producing lava flows, has been recorded since the 18th century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-36-&amp;volpage=photos&amp;photo=053069">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-36-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(54.756,-163.97)
803	Roundtop	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Roundtop</b></font><br /><font size="5"><b>Fox Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/085036.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 1871 m<br /><b>Latitude:</b> 54.80&deg;N<br /><b>Longitude:</b> 163.589&deg;W</td></tr><tr><td colspan="2"><p align="justify">The flat-topped, glacier-covered Roundtop volcano is the easternmost and lowest of an E-W-trending line of volcanoes on eastern Unimak Island.  Roundtop lies 13 km SW of the village of False Pass.  The snow and ice-covered edifice fills much of a 3-km-wide caldera that formed during the early Holocene.  The caldera-forming eruption produced pyroclastic flows and a rhyolitic tephra layer that is widespread throughout the southwestern end of the Alaska Peninsula.  A group of lava domes was constructed south of Roundtop volcano.  No historical eruptions are known from the 1871-m-high stratovolcano.  In the 1930s warm springs were found on its slopes.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-38-&amp;volpage=photos&amp;photo=085036">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-38-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(54.799999999999997,-163.589)
804	Amak	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Amak</b></font><br /><font size="5"><b>Fox Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/095059.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 488 m<br /><b>Latitude:</b> 55.424&deg;N<br /><b>Longitude:</b> 163.149&deg;W</td></tr><tr><td colspan="2"><p align="justify">Amak, the easternmost of the Aleutian Islands, is a small island stratovolcano that like Bogoslof, lies north of the main Aleutian volcanic front.  Amak is located about 50 km NW of Frosty volcano on the western tip of the Alaska Peninsula.  The summit of the small, roughly 1 cu km Amak volcano is only 488 m above sea level.  Blocky lava flows with prominent levees were emplaced during historical eruptions from 1700-1710 and in 1796 (Marsh, in Wood and Kienle 1990).  The flows radiate from a well-defined central crater and cover much of the central part of the island.  Earlier volcanism perhaps 4000-5000 years ago consisted of the emission of thin, platy andesitic lava flows.  A flat alluvial plain on the south flank contains a flat-bottomed crater that may be a maar.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-39-&amp;volpage=photos&amp;photo=095059">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1101-39-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(55.423999999999999,-163.149)
805	Frosty	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Frosty</b></font><br /><font size="5"><b>Alaska Peninsula</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/085039.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2012 m<br /><b>Latitude:</b> 55.082&deg;N<br /><b>Longitude:</b> 162.814&deg;W</td></tr><tr><td colspan="2"><p align="justify">Frosty volcano, the youngest of two large volcanic structures of the Cold Bay volcanic complex, is the westernmost Holocene volcano of the Alaska Peninsula.  The oldest products of the roughly 100 cu km Cold Bay complex, which lies SW of the village of Cold Bay, form the glacially dissected late-Pliocene to early Pleistocene Morzhovoi Volcanics at the southern end of the complex.  Frosty Peak to the north is a symmetrical late-Pleistocene to Recent stratovolcano constructed within the southernmost of two coalescing craters.  The western wall of the ice-filled northern crater is breached by a large valley glacier.  The symmetrical summit cone rises about 600 m above the floor of the southern crater.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-01-&amp;volpage=photos&amp;photo=085039">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-01-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(55.082000000000001,-162.81399999999999)
806	Dutton	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Dutton</b></font><br /><font size="5"><b>Alaska Peninsula</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/085058.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1506 m<br /><b>Latitude:</b> 55.168&deg;N<br /><b>Longitude:</b> 162.272&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Mount Dutton volcanic center east of Cold Bay near the tip of the Alaska Peninsula consists of a glacier-covered, 1506-m-high central lava dome complex.  Early andesitic lava flows and late-stage dacitic lava domes have been partially removed by one or more Holocene edifice collapses about 5100-6800 years ago.  This created debris avalanches that traveled to the west and to the south, reaching Belkofski Bay.  The important regional fishing center of King Cove lies less than 15 km from the volcano, and the village's airstrip is built on top of the southern avalanche deposit.  A steep-sided complex of lava domes forms the summit of the volcano, and young block-and-ash flow deposits extend to the east.  Two small unglaciated lava domes on the NE flank 3.5 km from the summit are also of Holocene age.  Major earthquake swarms near the volcano were recorded in 1984-85 and 1988.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-011&amp;volpage=photos&amp;photo=085058">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-011">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(55.167999999999999,-162.27199999999999)
807	Emmons Lake	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Emmons Lake</b></font><br /><font size="5"><b>Alaska Peninsula</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/053066.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1436 m<br /><b>Latitude:</b> 55.341&deg;N<br /><b>Longitude:</b> 162.079&deg;W</td></tr><tr><td colspan="2"><p align="justify">The massive Emmons Lake stratovolcano, located north of Volcano Bay and SW of Pavlof volcano, is truncated by one of the largest calderas of the Aleutian arc.  The 11 x 18 km caldera contains a narrow elongated lake at its SW end that drains through a breach in the SE caldera rim to the Pacific Ocean.  The compound caldera was formed during six voluminous dacitic-to-rhyolitic eruptions between about 294,000 and 26,000 years ago that produced extensive ashflow tuffs.  Mount Emmons, Mount Hague, and Double Crater are post-caldera cones of dominantly basaltic composition that were constructed along the SW-NE trend of the elongated caldera, which is up to 1150 m deep.  Some young Holocene flows have moved through a gap in the southern caldera rim to within 3 km of the Pacific Ocean.  A large fumarolic area is located on the south side of Mount Hague, and the only reported historical activity from Emmons Lake volcano was the emission of steam plumes from Hague in 1990 and 1991.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-02-&amp;volpage=photos&amp;photo=053066">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-02-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(55.341000000000001,-162.07900000000001)
808	Pavlof	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Pavlof</b></font><br /><font size="5"><b>Alaska Peninsula</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/053065.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2519 m<br /><b>Latitude:</b> 55.42&deg;N<br /><b>Longitude:</b> 161.887&deg;W</td></tr><tr><td colspan="2"><p align="justify">The most active volcano of the Aleutian arc, Pavlof is a 2519-m-high Holocene stratovolcano that was constructed along a line of vents extending NE from the Emmons Lake caldera.  Pavlof and its twin volcano to the NE, 2142-m-high Pavlof Sister, form a dramatic pair of symmetrical, glacier-covered stratovolcanoes that tower above Pavlof and Volcano bays.  A third cone, Little Pavlof, is a smaller volcano on the SW flank of Pavlof volcano, near the rim of Emmons Lake caldera.  Unlike Pavlof Sister, Pavlof has been frequently active in historical time, typically producing strombolian to vulcanian explosive eruptions from the summit vents and occasional lava flows.  The active vents lie near the summit on the north and east sides.  The largest historical eruption of Pavlof took place in 1911, at the end of a 5-year-long eruptive episode.  During this eruption a fissure opened on the northern flank of the volcano, ejecting large blocks and issuing lava flows.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-03-&amp;volpage=photos&amp;photo=053065">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-03-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(55.420000000000002,-161.887)
809	Pavlof Sister	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Pavlof Sister</b></font><br /><font size="5"><b>Alaska Peninsula</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/053063.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 2142 m<br /><b>Latitude:</b> 55.453&deg;N<br /><b>Longitude:</b> 161.843&deg;W</td></tr><tr><td colspan="2"><p align="justify">Located at the end of a chain of volcanoes trending NE from Emmons Lake caldera, the symmetrical Pavlof Sister stratovolcano is somewhat more eroded than its twin volcano to the SW, Pavlof.  Pavlof Sister, along with Pavlof and Little Pavlof is a stratovolcano that formed outside of the Emmons Lake caldera; these and other volcanoes inside Emmons Lake caldera are not glaciated and thus would have formed since the area was last glaciated about 15-20,000 years ago.  The 2142-m-high Pavlof Sister is almost 400 m lower than Pavlof and has a sharper-peaked summit.  Some sources attributed a period of intermittent eruptive activity from 1762 to 1786 AD to Pavlof Sister, but other sources consider this event to have been from Pavlof volcano.  The two symmetrical volcanoes form a dramatic backdrop to Pavlof Bay and Volcano Bay near the western end of the Alaska Peninsula.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-04-&amp;volpage=photos&amp;photo=053063">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-04-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(55.453000000000003,-161.84299999999999)
810	Dana	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Dana</b></font><br /><font size="5"><b>Alaska Peninsula</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/095038.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1354 m<br /><b>Latitude:</b> 55.641&deg;N<br /><b>Longitude:</b> 161.214&deg;W</td></tr><tr><td colspan="2"><p align="justify">Mount Dana is a small calc-alkaline volcano NE of Canoe Bay inlet at the head of Pavlof Bay consisting of an apron of volcaniclastic debris surrounding a central dome complex.  The 1354-m high point is located at the north rim of a 1.5 x 2 km crater, whose SW rim exposes Mesozoic sedimentary rocks.  Andesitic lava domes occur on the west crater rim and as a small mound east of Knutson Lake inside the crater.  Mount Dana is the source of a mid-Holocene block-and-ash flow that reached the sea at Canoe Bay.  No historical eruptions are known from Dana, but a 200-m-wide tufa mound and several cold springs are located on the SW flank of the volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-05-&amp;volpage=photos&amp;photo=095038">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-05-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(55.640999999999998,-161.214)
811	Stepovak Bay 2	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Stepovak Bay 2</b></font><br /><font size="5"><b>Alaska Peninsula</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/114085.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cone</td><td width="50%" align="left"><b>Summit Elev:</b> 1323 m<br /><b>Latitude:</b> 55.913&deg;N<br /><b>Longitude:</b> 160.041&deg;W</td></tr><tr><td colspan="2"><p align="justify">A group of four late-Pleistocene to Holocene volcanoes is located along a NE-trending line SW of Kupreanof volcano.  The SW-most of the 4 volcanoes, located NW of Stepovak Bay and 24 km SW of Kupreanof, is of late-Pleistocene age.  Stepovak Bay 2 is a 200-m-high cinder cone with a Holocene andesitic lava flow extending initially to the NE, then SE.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-051&amp;volpage=photos&amp;photo=114085">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-051">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(55.912999999999997,-160.041)
812	Kupreanof	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kupreanof</b></font><br /><font size="5"><b>Alaska Peninsula</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/095032.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1895 m<br /><b>Latitude:</b> 56.011&deg;N<br /><b>Longitude:</b> 159.797&deg;W</td></tr><tr><td colspan="2"><p align="justify">Kupreanof is the largest and NE-most of a group of five relatively closely spaced Quaternary volcanic centers opposite Stepovak Bay.  A debris flow or block-and-ash flow with possible juvenile fragments descended a late-Pleistocene valley south of the volcano.  The 1895-m-high stratovolcano displays vigorous fumarolic activity.  Its only known historical activity consisted of minor steam and ash emission that was reported from a SSW-flank solfatara field in 1987.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-06-&amp;volpage=photos&amp;photo=095032">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-06-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(56.011000000000003,-159.797)
813	Veniaminof	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Veniaminof</b></font><br /><font size="5"><b>Alaska Peninsula</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/025074.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2507 m<br /><b>Latitude:</b> 56.17&deg;N<br /><b>Longitude:</b> 159.38&deg;W</td></tr><tr><td colspan="2"><p align="justify">Massive Veniaminof volcano, one of the highest and largest volcanoes on the Alaska Peninsula, is truncated by a steep-walled, 8 x 11 km, glacier-filled caldera that formed around 3700 years ago.  The caldera rim is up to 520 m high on the north, is deeply notched on the west by Cone Glacier, and is covered by an ice sheet on the south.  Post-caldera vents are located along a NW-SE zone bisecting the caldera that extends 55 km from near the Bering Sea coast, across the caldera, and down the Pacific flank.  Historical eruptions probably all originated from the westernmost and most prominent of two intra-caldera cones, which reaches an elevation of 2156 m and rises about 300 m above the surrounding icefield.  The other cone is larger, and has a summit crater or caldera that may reach 2.5 km in diameter, but is more subdued and barely rises above the glacier surface.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-07-&amp;volpage=photos&amp;photo=025074">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-07-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(56.170000000000002,-159.38)
814	Black Peak	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Black Peak</b></font><br /><font size="5"><b>Alaska Peninsula</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/085056.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1032 m<br /><b>Latitude:</b> 56.552&deg;N<br /><b>Longitude:</b> 158.785&deg;W</td></tr><tr><td colspan="2"><p align="justify">The highly eroded stratovolcano and lava dome complex of Black Peak was constructed within an ice-free mid-Holocene caldera with two small caldera lakes on the northern and eastern sides.  The pre-caldera volcano consists of andesitic-dacitic lava domes, lava flows, and volcaniclastic rocks that were constructed over a basement of Pliocene volcanogenic sedimentary rocks.  Ash-flow tuffs and block-and-ash-flow deposits from the &gt;10 cu km caldera-forming eruption, which occurred less than about 4000 years ago, fill the Ash Creek and Bluff Creek valleys to the west and north to depths of as much as 100 m.  Most of the 3.5-km-wide caldera floor is occupied by a complex of nested dacitic lava domes and associated lava flows centered in the southern part of the caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-08-&amp;volpage=photos&amp;photo=085056">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-08-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(56.552,-158.785)
815	Aniakchak	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Aniakchak</b></font><br /><font size="5"><b>Alaska Peninsula</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/053039.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1341 m<br /><b>Latitude:</b> 56.88&deg;N<br /><b>Longitude:</b> 158.17&deg;W</td></tr><tr><td colspan="2"><p align="justify">One of the most dramatic calderas of the Aleutian arc, the 10-km-wide Aniakchak caldera was formed around 3400 years ago during a voluminous eruption in which pyroclastic flows traveled more than 50 km north to the Bering Sea and also reached the Pacific Ocean to the south.  At least 40 explosive eruptions have been documented from Aniakchak during the past 10,000 years, making it the most active volcano of the eastern Aleutian arc.  A dominantly andesitic pre-caldera volcano was constructed above basement Mesozoic and Tertiary sedimentary rocks that are exposed in the caldera walls to elevations of about 610 m.  The ice-free caldera floor contains many pyroclastic cones, tuff cones, maars, and lava domes.  Surprise Lake on the NE side drains through The Gates, a steep-walled breach on the east side of the 1-km-high caldera rim.  Vent Mountain and Half Cone are two long-lived vents on the south-central and NW caldera floor, respectively.  The first and only confirmed historical eruption took place in 1931 from vents on the west and SW caldera floor.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-09-&amp;volpage=photos&amp;photo=053039">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-09-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(56.880000000000003,-158.16999999999999)
816	Yantarni	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Yantarni</b></font><br /><font size="5"><b>Alaska Peninsula</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/053038.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 1345 m<br /><b>Latitude:</b> 57.019&deg;N<br /><b>Longitude:</b> 157.185&deg;W</td></tr><tr><td colspan="2"><p align="justify">Yantarni is a small andesitic stratovolcano located between Aniakchak caldera and Chiginadak volcanoes that was not discovered until 1979.  A large breached crater on the NE side, which was formed by collapse of the summit about 2000-3500 years ago, contains a lava dome that marks the volcano's 1345 m high point.  This eruption, which resembled that of Mount St. Helens in 1980, began with a debris avalanche produced by the edifice collapse that was accompanied by a possible lateral blast and followed by the emplacement of 1 cu km of pyroclastic flows related to growth of the summit lava dome.  No historical eruptions have been documented from Yantarni.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-10-&amp;volpage=photos&amp;photo=053038">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-10-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(57.018999999999998,-157.185)
817	Chiginagak	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Chiginagak</b></font><br /><font size="5"><b>Alaska Peninsula</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/053036.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2221 m<br /><b>Latitude:</b> 57.135&deg;N<br /><b>Longitude:</b> 156.990&deg;W</td></tr><tr><td colspan="2"><p align="justify">The symmetrical, calc-alkaline Chiginagak stratovolcano located about 15 km NW of Chiginagak Bay contains a small summit crater, which is breached to the south, and one or more summit lava domes.  Satellitic lava domes occur high on the NW and SE flanks of the glacier-mantled volcano.  An unglaciated lava flow and an overlying pyroclastic-flow deposit extending east from the summit are the most recent products of Chiginagak.  They most likely originated from a lava dome at 1687 m on the SE flank, 1 km from the summit of the volcano, which has variably been estimated to be from 2075 to 2221 m high.  Brief ash eruptions were reported in July 1971 and August 1998.  Fumarolic activity occurs at 1600 m elevation on the NE flank of the volcano, and two areas of hot-spring travertine deposition are located at the NW base of the volcano near Volcano Creek.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-11-&amp;volpage=photos&amp;photo=053036">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-11-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(57.134999999999998,-156.99000000000001)
818	Kialagvik	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kialagvik</b></font><br /><font size="5"><b>Alaska Peninsula</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/095033.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 1677 m<br /><b>Latitude:</b> 57.203&deg;N<br /><b>Longitude:</b> 156.745&deg;W</td></tr><tr><td colspan="2"><p align="justify">Kialagvik is a small, poorly known glacier-mantled stratovolcano NE of Chiginagak volcano with a Holocene central lava dome and associated pyroclastic-flow deposits (Riehle, in Wood and Kienle 1990).  The volcano draws its name from the Eskimo word for Wide Bay, which lies beyond the mouth of Kialagvik Creek, NE of the volcano.  The central dome rises 350 m above an ice field that mantles the upper part of the volcano.  Andesitic lava flows and overlying dacitic block-and-ash-flow deposits are exposed broadly on the SW flank and in a small area on the NE flank.  No historical activity is known from Kialagvik.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-12-&amp;volpage=photos&amp;photo=095033">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-12-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(57.203000000000003,-156.745)
819	Ugashik-Peulik	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ugashik-Peulik</b></font><br /><font size="5"><b>Alaska Peninsula</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/053035.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1474 m<br /><b>Latitude:</b> 57.751&deg;N<br /><b>Longitude:</b> 156.368&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Ugashik-Peulik volcanic complex lies south of Becharof Lake and east of Upper Ugashik Lake.  Late-Pleistocene caldera formation at Ugashik volcano was followed by the emplacement of at least 5 Holocene lava domes within the 4.5-km-wide caldera.  Most of the caldera walls consist of basement sandstones of Jurassic age.  Following caldera formation the small, 3 cu km Peulik stratovolcano grew 2.5 km to the north to a height of 1474 m, more than 500 m above that of Ugashik.  Lava flows from Peulik cover the caldera rim to the south and extend to Becharof Lake, 6 km to the north.  A small lava dome at 1200 m elevation on the east flank of Peulik was the source of a small block-and-ash flow.  The summit of Peulik volcano contains a 1.5-km-wide crater breached to the west that is partially filled by a lava dome.  Debris-avalanche deposits cover a 75 sq km area to the NW.  A single documented historical eruption took place from Peulik volcano in 1814.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-13-&amp;volpage=photos&amp;photo=053035">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-13-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(57.750999999999998,-156.36799999999999)
820	Ukinrek Maars	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ukinrek Maars</b></font><br /><font size="5"><b>Alaska Peninsula</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/053028.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Maars<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 91 m<br /><b>Latitude:</b> 57.832&deg;N<br /><b>Longitude:</b> 156.510&deg;W</td></tr><tr><td colspan="2"><p align="justify">Ukinrek Maars are two explosion craters that were created in an area without previous volcanic activity during a 10-day-long phreatomagmatic eruption March-April 1977.  The basaltic maars were erupted through glacial deposits in the Bering Sea lowlands 1.5 km south of Becharof Lake and 12 km west of Peulik volcano; their location is related to the regional Bruin Bay fault.   The elliptical West Maar, which was the first to form, is 105 x 170 m wide and 35 m deep.  The other maar, 600 m to the east, is 300 m wide and 70 m deep.  Both maars are now filled by crater lakes; the eastern lake encircles a 49-m-high lava dome that was emplaced at the end of the eruption.  Base surges were directed primarily to the NW.  Juvenile material from the Ukinrek eruptions was of mantle-derived olivine basaltic composition.  The dacitic Gas Rocks lava domes, of Quaternary age, are located on the shores of Becharof Lake, 3 km north of Ukinrek maars and were the site of a phreatic eruption about 2300 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-131&amp;volpage=photos&amp;photo=053028">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-131">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(57.832000000000001,-156.50999999999999)
821	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>Alaska Peninsula</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/114086.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 300? m<br /><b>Latitude:</b> 57.87&deg;N<br /><b>Longitude:</b> 155.42&deg;W</td></tr><tr><td colspan="2"><p align="justify">A small unnamed lava dome and an associated lava flow about 30 km east of Becharof Lake and 8 km NW of Alinchak Bay are not significantly modified by glacial erosion.  Detterman et al. (1987) suggested a Holocene age for the small dome, whose summit lies only about 300 m above sea level.  Lava flows traveled a short distance to the north.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-132&amp;volpage=photos&amp;photo=114086">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-132">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(57.869999999999997,-155.41999999999999)
822	Martin	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Martin</b></font><br /><font size="5"><b>Alaska Peninsula</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/053027.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1863 m<br /><b>Latitude:</b> 58.172&deg;N<br /><b>Longitude:</b> 155.361&deg;W</td></tr><tr><td colspan="2"><p align="justify">The mostly ice-covered Mount Martin stratovolcano lies at the SW end of the Katmai volcano cluster in Katmai National Park.  The volcano was named for George C. Martin, the first person to visit and describe the Katmai area after the 1912 eruption.  Mount Martin is capped by a 300-m-wide summit crater, which is ice-free because of an almost-constant steam plume and contains a shallow acidic lake.  The edifice of Martin volcano overlies glaciated lava flows of the adjacent mid- to late-Pleistocene Alagoshak volcano on the WSW and was constructed entirely during the Holocene.  Mount Martin consists of a small fragmental cone that was the source of  ten thick overlapping blocky dacitic lava flows, largely uneroded by glaciers, that descend 10 km to the NW, cover 31 sq km, and form about 95% of the eruptive volume of the volcano.  Two reports of historical eruptions that originated from uncertain sources were attributed by Muller et al. (1954) to Martin.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-14-&amp;volpage=photos&amp;photo=053027">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-14-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(58.171999999999997,-155.36099999999999)
823	Mageik	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mageik</b></font><br /><font size="5"><b>Alaska Peninsula</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/053025.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2165? m<br /><b>Latitude:</b> 58.195&deg;N<br /><b>Longitude:</b> 155.253&deg;W</td></tr><tr><td colspan="2"><p align="justify">Mount Mageik is a broad ice-capped stratovolcano at the head of the Valley of Ten Thousand Smokes across Katmai Pass from Trident volcano.  Four small overlapping peaks form the broad summit, three of which lie along a NE-SW trend south of the northern peak.  The central summit consists of a lava dome, while the east, SW, and north volcanoes are capped by fragmental cones with ice-filled craters.  The three westernmost summits are glaciated and of primarily Pleistocene age, but the East Mageik summit cone was the source of at least six Holocene eruptive episodes and fed Holocene lava flows that descended toward Katmai Pass and blanket the NE-to-SE flanks of the volcano.  A young, 300-m-wide explosion crater between the east and central summits that formed about 2400-2500 years ago contains a shallow, acidic lake and many superheated fumarole jets.  Three Holocene debris avalanches from south-flank failures descended into the Martin Creek drainages, one perhaps reaching the coast.  Reports of historical eruptions from Mageik were questioned by Miller et al. (1998) and Hildreth and Fierstein (2000).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-15-&amp;volpage=photos&amp;photo=053025">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-15-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(58.195,-155.25299999999999)
824	Trident	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Trident</b></font><br /><font size="5"><b>Alaska Peninsula</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/053013.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1864 m<br /><b>Latitude:</b> 58.236&deg;N<br /><b>Longitude:</b> 155.10&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Trident stratovolcano cluster was named for the three prominent peaks that were the most visible features at the summit prior to 1953.  The andesitic-dacitic Trident group consists of four overlapping stratovolcanoes and numerous flank lava domes, including Falling Mountain and Mt. Cerberus on the far west flank.  The summit complex of Trident is located 3-5 km SE of Novarupta volcano, and merges along a ridge to the NE with Katmai volcano.  The three oldest Trident volcanoes are glaciated and Pleistocene in age, while the youngest, Southwest Trident, was formed during historical time.  Eruptions at the Trident complex migrated stepwise with time from the NE to the SW.  In 1953 a new lava dome began growing on the SW flank of Trident I volcano.  A series of thick andesitic lava flows were erupted between 1953 and 1968, forming a cone with 400-800 m of local relief.  Periodic explosions took place until 1974, and the current summit contains a 350-m-wide crater.  Some of the distal lava flows from West Trident stratovolcano collapsed into the Novarupta vent during its 1912 eruption.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-16-&amp;volpage=photos&amp;photo=053013">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-16-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(58.235999999999997,-155.09999999999999)
825	Katmai	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Katmai</b></font><br /><font size="5"><b>Alaska Peninsula</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/053008.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 2047 m<br /><b>Latitude:</b> 58.280&deg;N<br /><b>Longitude:</b> 154.963&deg;W</td></tr><tr><td colspan="2"><p align="justify">Prior to 1912, Mount Katmai was a compound stratovolcano with four NE-SW-trending summits, most of which were truncated by caldera collapse in that year.   Two or more large explosive eruptions took place from Mount Katmai during the late Pleistocene.  Most of the two overlapping pre-1912 Katmai volcanoes are Pleistocene in age, but Holocene lava flows from a flank vent descend the SE flank of the SW stratovolcano into the Katmai River canyon.  Katmai was initially considered to be the source of the Valley of Ten Thousand Smokes ash flow in 1912.  However, the 3 x 4 km wide caldera of 1912 is now known to have formed as a result of the voluminous eruption at nearby Novarupta volcano.  The steep walled young caldera has a jagged rim that rises 500-1000 m above the caldera floor and contains a 250-m-deep, still-rising lake.   Lake waters have covered a small post-collapse lava dome (Horseshoe Island) that was seen on the caldera floor at the time of the initial ascent to the caldera rim in 1916.  Post-1912 glaciers have formed on a bench within Katmai caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-17-&amp;volpage=photos&amp;photo=053008">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-17-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(58.280000000000001,-154.96299999999999)
826	Novarupta	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Novarupta</b></font><br /><font size="5"><b>Alaska Peninsula</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/053015.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 841 m<br /><b>Latitude:</b> 58.27&deg;N<br /><b>Longitude:</b> 155.157&deg;W</td></tr><tr><td colspan="2"><p align="justify">Novarupta, the least topographically prominent volcano in the Katmai area, was formed during a major eruption in 1912.  This eruption was the world's largest during the 20th century and produced a voluminous rhyolitic airfall tephra and the renowned Valley of Ten Thousand Smokes (VTTS) ash flow.  At the end of the eruption a small, 65-m-high, 400-m-wide lava dome grew to an elevation of 841 m within the source vent of the VTTS ashflow, a 2-km-wide area of subsidence NW of Trident volcano.  The NE side of the Falling Mountain lava dome of the Trident volcanic cluster, as well as Broken Mountain and Baked Mountain, was removed by collapse of the Novarupta depression, which is marked by radial and scalloped arcuate fractures.  Much larger collapse took place at Katmai volcano, 10 km to the east, where a 3 x 4 km wide caldera formed in response to magma reservoir drainage toward Novarupta.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-18-&amp;volpage=photos&amp;photo=053015">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-18-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(58.270000000000003,-155.15700000000001)
827	Griggs	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Griggs</b></font><br /><font size="5"><b>Alaska Peninsula</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/053021.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2317 m<br /><b>Latitude:</b> 58.354&deg;N<br /><b>Longitude:</b> 155.092&deg;W</td></tr><tr><td colspan="2"><p align="justify">The summit of Mount Griggs towers above Knife Creek on the NE side of the Valley of Ten Thousand Smokes.  The volcano is uniquely offset west of the NE-trending alignment of volcanoes in the Katmai area.  The broad, 2317-m-high stratovolcano, formerly known as Knife Peak, consists of a late-Pleistocene volcano with glacial valleys on the north that was truncated on its SW side by an early Holocene edifice collapse.  A Holocene volcano was subsequently constructed within the 1.5-km-wide scarp left by the emplacement of a large SW-flank debris avalanche.  Nested cones with three concentric craters mostly fill the scarp, and thick, blocky lava flows blanket the SW flanks of the volcano below the collapse scarp.  In contrast to the more silicic centers of the Katmai area along the crest of the range, lava flows from Griggs are dominantly andesitic in composition, and dacitic lava flows are uncommon.  No historical eruptions have occurred from Griggs, but noisy fumarolic jets near the summit can be heard from the valley floor, 1750 m below.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-19-&amp;volpage=photos&amp;photo=053021">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-19-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(58.353999999999999,-155.09200000000001)
828	Snowy Mountain	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Snowy Mountain</b></font><br /><font size="5"><b>Alaska Peninsula</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/095009.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2162 m<br /><b>Latitude:</b> 58.336&deg;N<br /><b>Longitude:</b> 154.682&deg;W</td></tr><tr><td colspan="2"><p align="justify">Glacier-covered, 2161-m-high Snowy Mountain, located 15 km NE of Mount Katmai, is the SW-most of a chain of closely spaced volcanoes extending NE along the crest of the Alaska Range.  More than 90% of the compound Snowy volcano is mantled by glacial ice, which prompted the naming of the volcano by members of  the 1917 Katmai expedition.  Two small andesitic-dacitic stratovolcanoes, SW Snowy and NE Snowy, originated about 200,000 years ago.  Only NE Snowy has been active during the Holocene.   Late-Holocene collapse of this volcano produced a large debris avalanche that traveled to the north and left a large breached crater inside which a blocky lava dome was constructed.  Peat beneath an ash layer thought to be associated with the the lava dome was radiocarbon dated at about 250 +/- 70 years ago.  No historical eruptive activity has been documented, but fumarolic activity has been observed at NE Snowy.  A zone of persistent diffuse shallow seismicity is located on and NW of the volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-20-&amp;volpage=photos&amp;photo=095009">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-20-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(58.335999999999999,-154.68199999999999)
829	Steller	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Steller</b></font><br /><font size="5"><b>Alaska Peninsula</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/095065.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 2272 m<br /><b>Latitude:</b> 58.43&deg;N<br /><b>Longitude:</b> 154.40&deg;W</td></tr><tr><td colspan="2"><p align="justify">Mount Steller is part of a chain of closely spaced NE-SW-trending vents in Katmai National Park and lies between Mount Denision and Kukak volcanoes.  Uncertainty surrounds the number and location of volcanic vents in this heavily glaciated area.  The precise age of the most recent activity at Steller volcano is not known, but the volcano was considered to have been active during the Holocene (Nye et al., 1998).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-22-&amp;volpage=photos&amp;photo=095065">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-22-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(58.43,-154.40000000000001)
830	Kukak	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kukak</b></font><br /><font size="5"><b>Alaska Peninsula</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/085064.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 2043 m<br /><b>Latitude:</b> 58.453&deg;N<br /><b>Longitude:</b> 154.355&deg;W</td></tr><tr><td colspan="2"><p align="justify">The almost completely ice-covered Kukak volcano lies west of Hallo Bay near the NE end of a glacier-mantled range extending from Mount Katmai.  Kukak volcano contains a vigorous fumarole field at the southern base of the hydrothermally altered northern summit and is the only one of the Denison-Steller-Kukak chain of volcanoes to display geothermal activity.  Two reports of historical eruptions at Kukak from Hantke (1959) appear to be erroneous.  The report of a 1951 eruption is an apparent reference to a July 22, 1951 ashfall at Kukak Bay, which was attributed by Muller et al. (1954) to Martin volcano.  A 1953 explosive &quot;eruption&quot; was single large puff of steam followed by steaming from caverns in Hook Glacier (Muller et al., 1954).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-23-&amp;volpage=photos&amp;photo=085064">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-23-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(58.453000000000003,-154.35499999999999)
831	Kaguyak	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kaguyak</b></font><br /><font size="5"><b>Alaska Peninsula</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/053005.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 901 m<br /><b>Latitude:</b> 58.608&deg;N<br /><b>Longitude:</b> 154.028&deg;W</td></tr><tr><td colspan="2"><p align="justify">The small, but spectacular 2.5-km-wide Kaguyak caldera in the NE part of Katmai National Park is filled by a &gt;180-m-deep lake whose surface lies more than 550 m below the caldera rim.  Kaguyak volcano is only 901 m high, but rises directly from lowland areas near sea level south of the Big River.  Initially considered to be a typical stratovolcano truncated by a caldera, the pre-caldera edifice has been shown to consist of nine continuguous late-Pleistocene lava dome clusters, most of which lie east of the present caldera.  A large post-caldera lava dome extends into the lake on the SW side and another dome forms a small island in the center of the lake.  The youthful caldera is unglaciated, and distal tephras from the caldera-forming eruption have been radiocarbon dated at about 5800 years before present.  Voluminous dacitic pyroclastic-flow deposits surround the caldera and reached Shelikof Strait to the SE.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-25-&amp;volpage=photos&amp;photo=053005">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-25-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(58.607999999999997,-154.02799999999999)
832	Fourpeaked	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Fourpeaked</b></font><br /><font size="5"><b>Alaska Peninsula</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/118035.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 2105 m<br /><b>Latitude:</b> 58.770&deg;N<br /><b>Longitude:</b> 153.672&deg;W</td></tr><tr><td colspan="2"><p align="justify">Poorly known Fourpeaked volcano in NE Katmai National Park consists of isolated outcrops surrounded by the Fourpeaked Glacier, which descends eastward almost to the Shelikof Strait.  The orientation of andesitic lava flows and extensive hydrothermal alteration of rocks near the present 2105-m-high summit suggest that it probably marks the vent of Fourpeaked volcano.  Eruptive activity during the Holocene had not been confirmed prior to the first historical eruption of Fourpeaked in September 2006.  A N-trending fissure extending 1 km from the summit produced minor ashfall.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-26-&amp;volpage=photos&amp;photo=118035">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-26-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(58.770000000000003,-153.672)
833	Douglas	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Douglas</b></font><br /><font size="5"><b>Alaska Peninsula</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/053001.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 2140 m<br /><b>Latitude:</b> 58.855&deg;N<br /><b>Longitude:</b> 153.542&deg;W</td></tr><tr><td colspan="2"><p align="justify">Glacier-covered, dissected Mount Douglas stratovolcano is located at the northern end of the Alaska Peninsula south of Kamishak Bay.  The volcano, the NE-most in Katmai National Park, contains a small, ice-free summit crater lake and an active fumarole field.  The volcano was constructed above Cretaceous and Jurassic sedimentary rocks.  A lake temperature of 25 degrees Centigrade and a pH of 1 were measured in 1982.  The fumaroles, which are actively depositing sulfur, were all at the pressure boiling point in 1982 and heated up to 114-118 degrees in 1991.  The fumaroles are located on the NE wall of the 160 x 200 m wide crater lake; some fumaroles are subaqueous and produce turbulence on the surface of the blue-green lake.  Unglaciated and relatively uneroded lava flows are found on the NW flank of the volcano.  The age of the most recent eruptions from Douglas is not known, but Nye et al. (1998) considered activity to have occurred during the Holocene.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-27-&amp;volpage=photos&amp;photo=053001">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1102-27-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(58.854999999999997,-153.542)
834	Augustine	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Augustine</b></font><br /><font size="5"><b>Southwestern Alaska</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/026065.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1252 m<br /><b>Latitude:</b> 59.363&deg;N<br /><b>Longitude:</b> 153.43&deg;W</td></tr><tr><td colspan="2"><p align="justify">Augustine volcano, rising above Kamishak Bay in the southern Cook Inlet about 290 km SW of Anchorage, is the most active volcano of the eastern Aleutian arc.  It consists of a complex of overlapping summit lava domes surrounded by an apron of volcaniclastic debris that descends to the sea on all sides.  Few lava flows are exposed; the flanks consist mainly of debris-avalanche and pyroclastic-flow deposits formed by repeated collapse and regrowth of the volcano's summit.  The latest episode of edifice collapse occurred during Augustine's largest historical eruption in 1883; subsequent dome growth has restored the volcano to a height comparable to that prior to 1883.  The oldest dated volcanic rocks on Augustine are more than 40,000 years old.  At least 11 large debris avalanches have reached the sea during the past 1800-2000 years, and five major pumiceous tephras have been erupted during this interval.  Historical eruptions have typically consisted of explosive activity with emplacement of pumiceous pyroclastic-flow deposits followed by lava dome extrusion with associated block-and-ash flows.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1103-01-&amp;volpage=photos&amp;photo=026065">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1103-01-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(59.363,-153.43000000000001)
835	Iliamna	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Iliamna</b></font><br /><font size="5"><b>Southwestern Alaska</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/052095.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 3053 m<br /><b>Latitude:</b> 60.032&deg;N<br /><b>Longitude:</b> 153.090&deg;W</td></tr><tr><td colspan="2"><p align="justify">Iliamna is a prominent, 3053-m-high glacier-covered stratovolcano in Lake Clark National Park on the western side of Cook Inlet, about 225 km SW of Anchorage.  Its flat-topped summit is flanked on the south, along a 5-km-long ridge, by the prominent North and South Twin Peaks, satellitic lava dome complexes.  The Johnson Glacier dome complex lies on the NE flank.  Steep headwalls on the southern and eastern flanks expose an inaccessible cross-section of the volcano.  Major glaciers radiate from the summit, and valleys below the summit contain debris-avalanche and lahar deposits.  Only a few major Holocene explosive eruptions have occurred from the deeply dissected volcano, which lacks a distinct crater.  Most of the reports of historical eruptions may represent plumes from vigorous fumaroles east and SE of the summit, which are often mistaken for eruption columns (Miller et al., 1998).  Eruptions producing pyroclastic flows have been dated at as recent as about 300 and 140 years ago (into the historical period), and elevated seismicity accompanying dike emplacement beneath the volcano was recorded in 1996.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1103-02-&amp;volpage=photos&amp;photo=052095">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1103-02-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(60.031999999999996,-153.09)
836	Redoubt	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Redoubt</b></font><br /><font size="5"><b>Southwestern Alaska</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/052033.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 3108 m<br /><b>Latitude:</b> 60.485&deg;N<br /><b>Longitude:</b> 152.742&deg;W</td></tr><tr><td colspan="2"><p align="justify">Redoubt is a 3108-m-high glacier-covered stratovolcano with a breached summit crater in Lake Clark National Park about 170 km SW of Anchorage.  Next to Mount Spurr, Redoubt has been the most active Holocene volcano in the upper Cook Inlet.  The volcano was constructed beginning about 890,000 years ago over Mesozoic granitic rocks of the Alaska-Aleutian Range batholith.  Collapse of the summit of Redoubt 10,500-13,000 years ago produced a major debris avalanche that reached Cook Inlet.  Holocene activity has included the emplacement of a large debris avalanche and clay-rich lahars that dammed Lake Crescent on the south side and reached Cook Inlet about 3500 years ago.  Eruptions during the past few centuries have affected only the Drift River drainage on the north.  Historical eruptions have originated from a vent at the north end of the 1.8-km-wide breached summit crater.  The 1989-90 eruption of Redoubt had severe economic impact on the Cook Inlet region and affected air traffic far beyond the volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1103-03-&amp;volpage=photos&amp;photo=052033">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1103-03-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(60.484999999999999,-152.74199999999999)
837	Spurr	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Spurr</b></font><br /><font size="5"><b>Southwestern Alaska</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/052011.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 3374 m<br /><b>Latitude:</b> 61.299&deg;N<br /><b>Longitude:</b> 152.251&deg;W</td></tr><tr><td colspan="2"><p align="justify">The 3374-m-high summit of Mount Spurr, the highest volcano of the Aleutain arc, is a large lava dome constructed at the center of a roughly 5-km-wide horseshoe-shaped caldera that is open to the south.  The volcano lies 130 km west of Anchorage and NE of Chakachamna Lake.  The caldera was formed by a late-Pleistocene or early Holocene debris avalanche and associated pyroclastic flows that destroyed an ancestral Spurr volcano.  The debris avalanche traveled more than 25 km to the SE, and the resulting deposit contains blocks as large as 100 m in diameter.  Several ice-carved post-caldera cones or lava domes lie in the center of the caldera.  The youngest vent, 2309-m-high Crater Peak, formed at the breached southern end of the caldera and has been the source of about 40 identified Holocene tephra layers.  Spurr's two historical eruptions, from Crater Peak in 1953 and 1992, deposited ash on the city of Anchorage.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1103-04-&amp;volpage=photos&amp;photo=052011">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1103-04-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(61.298999999999999,-152.251)
838	Hayes	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hayes</b></font><br /><font size="5"><b>Southwestern Alaska</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/095040.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 3034 m<br /><b>Latitude:</b> 61.640&deg;N<br /><b>Longitude:</b> 152.411&deg;W</td></tr><tr><td colspan="2"><p align="justify">Hayes volcano, located in a remote and rugged part of the Alaska Range NW of Anchorage and north of Mount Gerdine, was not discovered until 1975.  It was named after nearby Hayes Glacier and consists of scattered remnants of a largely snow-and-ice covered volcano that has been destroyed by catastrophic eruptions.  The most widespread Holocene eruptions in the Cook Inlet area originated from Hayes volcano between about 3800 and 3400 years ago and produced six regional tephra layers with an average volume of 2.4 cu km.  The latest known eruption took place about 1000 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1103-05-&amp;volpage=photos&amp;photo=095040">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1103-05-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(61.640000000000001,-152.411)
839	St. Paul Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>St. Paul Island</b></font><br /><font size="5"><b>Western Alaska</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/095099.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Tuff cone</td><td width="50%" align="left"><b>Summit Elev:</b> 203 m<br /><b>Latitude:</b> 57.18&deg;N<br /><b>Longitude:</b> 170.30&deg;W</td></tr><tr><td colspan="2"><p align="justify">The largest of the Pribilof Islands, St. Paul contains numerous young cinder cones.  St. Paul Island consists of a 110 sq km area of coalescing small basaltic-to-trachybasaltic shield volcanoes capped by cinder cones, similar in style to the Snake Rive Plain volcanism in Idaho.  The most widely exposed lava flows originated from E-W-trending vents in the Bogoslof Hill area in the center of the island and a NE-trending row of cinder cones in the Rush Hill area at the west side of the island.  Subaerial activity at St. Paul began about 540,000 years ago and produced a basaltic lava platform.  Later eruptions produced a series of monogenetic vents and two small shield volcanoes.  Bogoslof Hill in the center of the island and Hutchinson Hill, forming isolated Northeast Point, which is connected by a low narrow isthmus to the rest of the island, were formed during the Pleistocene.  The youngest vent is the Fox Hill cinder cone on the western side of the island that produced a lava flow about 3200 years ago that traveled into the sea at Southwest Point.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1104-01-&amp;volpage=photos&amp;photo=095099">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1104-01-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(57.18,-170.30000000000001)
840	Nunivak Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Nunivak Island</b></font><br /><font size="5"><b>Western Alaska</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104037.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 511 m<br /><b>Latitude:</b> 60.02&deg;N<br /><b>Longitude:</b> 166.33&deg;W</td></tr><tr><td colspan="2"><p align="justify">Nunivak Island contains about 60 cinder cones and four maars; the surface of the island consists dominantly of thin pahoehoe lava flows that form a carapace over Cretaceous sedimentary rocks.  The 110-km-wide permafrost-covered island lies about 30 km off the coast of SW Alaska.  The widespread, thin pahoehoe lava flows originate from small shield volcanoes and cover much of the island, which is dotted throughout by cinder cones and other vents.  Two of the maars have about 200 m of relief, with floors near sea level.  Eruptions occurred during 5 broad periods of activity that began 6.1 million years ago and continued into the Holocene.  The bulk of the &gt;427 cu km volcanic field was formed during two Pleistocene eruptive periods that ended about 300,000 years ago.  The most recent eruptions at Nunivak produced a series of alkalic basalt lava flows and ash deposits from cinder cones and maars along an E-W zone in the southern part of the island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1104-02-&amp;volpage=photos&amp;photo=104037">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1104-02-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(60.020000000000003,-166.33000000000001)
841	Ingakslugwat Hills	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ingakslugwat Hills</b></font><br /><font size="5"><b>Western Alaska</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/114081.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 190 m<br /><b>Latitude:</b> 61.43&deg;N<br /><b>Longitude:</b> 164.47&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Ingakslugwat Hills consist of at least 32 small cinder cones and 8 larger craters covering an area of more than 500 sq km in the Yukon-Kuskokwin delta area of SW Alaska.  Numerous small spatter cones and cinder cones of the Ingakslugwat Hills range from 8 to 190 m in height; many are concentrated in the NW side of the volcanic field.  The latest activity was considered to have occurred during the Holocene (Moll-Stalcup, in Wood and Kienle 1990).  One low cone containing a 400-m-wide lake may be a maar.   This dominantly alkali olivine basaltic volcanic field also contains basanitic and nephelinitic rocks, some with inclusions of lherzolite and layered and granular gabbro.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1104-03-&amp;volpage=photos&amp;photo=114081">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1104-03-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(61.43,-164.47)
842	St. Michael	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>St. Michael</b></font><br /><font size="5"><b>Western Alaska</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/114080.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 715 m<br /><b>Latitude:</b> 63.45&deg;N<br /><b>Longitude:</b> 162.12&deg;W</td></tr><tr><td colspan="2"><p align="justify">The St. Michael volcanic field, at the south end of Norton Sound, covers all of St. Michael and Stuart Islands with more than 55 cones and craters.  Broad low shield volcanoes underlie the younger cones, and maar volcanoes are located at the SW part of the volcanic field, which covers &gt;3000 sq km and extends inland along the Golsovia and Kogok rivers.  The youngest activity is of Holocene age, and native tradition says that a village was submerged by lava three times.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1104-04-&amp;volpage=photos&amp;photo=114080">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1104-04-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(63.450000000000003,-162.12)
843	Kookooligit Mountains	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kookooligit Mountains</b></font><br /><font size="5"><b>Western Alaska</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/115012.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 673 m<br /><b>Latitude:</b> 63.60&deg;N<br /><b>Longitude:</b> 170.43&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Kookooligit Mountains are a 30 x 40 km wide shield volcano of Pleistocene-to-Holocene age in north-central St. Lawrence Island.  The 673-m basaltic shield is composed of massive columnar-jointed lava flows that are overlain by more than 100 small cones (20-60 m high).  Most of the cones are aligned E-W along the crest of the elongated shield volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1104-05-&amp;volpage=photos&amp;photo=115012">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1104-05-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(63.600000000000001,-170.43000000000001)
844	Imuruk Lake	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Imuruk Lake</b></font><br /><font size="5"><b>Western Alaska</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120016.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 610+ m<br /><b>Latitude:</b> 65.60&deg;N<br /><b>Longitude:</b> 163.92&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Oligocene-to-Holocene Imuruk monogenetic volcanic field in the central Seward Peninsula north of the Bendeleben Mountains contains around 75 small basaltic vents surrounded by voluminous lava flows.  The largest and most recent vent is the Lost Jim cone, a 30-m-high cinder cone near Imuruk Lake that produced the only Holocene lava flow of the Imuruk field.  The massive Lost Jim lava flow, erupted about 1655 years ago, extends 35 km west and 9 km north of the vent and covers about 230 sq km.  The next youngest flow, the late-Pleistocene Camille lava flow, traveled 39 km from its vent.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1104-06-&amp;volpage=photos&amp;photo=120016">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1104-06-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(65.599999999999994,-163.91999999999999)
845	Buzzard Creek	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Buzzard Creek</b></font><br /><font size="5"><b>Eastern Alaska</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111016.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Tuff rings</td><td width="50%" align="left"><b>Summit Elev:</b> 830 m<br /><b>Latitude:</b> 64.07&deg;N<br /><b>Longitude:</b> 148.42&deg;W</td></tr><tr><td colspan="2"><p align="justify">Two Holocene tuff rings form craters 300 and 66 m wide near the headwaters of Buzzard Creek at the northern foot of the central Alaska Range NE of the town of Healy along the Parks Highway.  The total volume of ejecta, most of which is accessory material, probably does not exceed 0.001 cu km.  The ejecta overlies young glacial terraces that correlate with a glacial stage that ended about 10,000 years ago, and radiocarbon dates give an age for the eruption that formed the tuff rings of about 3000 years.  This minor volcanic feature lies along trend with the Aleutian arc, but is located 320 km NE of its nearest Holocene neighbor, Hayes volcano and lies directly over the northernmost corner of the subducting Pacific Plate.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1105-001&amp;volpage=photos&amp;photo=111016">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1105-001">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(64.069999999999993,-148.41999999999999)
846	Wrangell	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Wrangell</b></font><br /><font size="5"><b>Eastern Alaska</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/052005.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 4317 m<br /><b>Latitude:</b> 62.00&deg;N<br /><b>Longitude:</b> 144.02&deg;W</td></tr><tr><td colspan="2"><p align="justify">With a diameter of 30 km at 2000 m elevation, 900 cu km Mount Wrangell is one of the world's largest continental-margin volcanoes.  The massive andesitic shield volcano has produced fluid lava flows as long as 58 km and contains an ice-filled 4-6 km diameter caldera located within a 15-km-wide ancestral caldera.  Most of he massive shield volcano was constructed during eruptions between about 600,000 and 200,000 years ago.  Formation of the summit caldera followed sometime between about 200,000 and 50,000 years ago.  Three post-caldera craters are located at the broad 4317-m-high summit of the volcano, along the northern and western rims of the 1-km-deep, ice-filled caldera.   A steep-sided flank cinder cone, Mount Zanetti, is located 6 km NW of the summit.  The westernmost cone has been the source of infrequent historical eruptions beginning in the 18th century.  Increased heat flux in recent years has melted large volumes of ice in the northern crater.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1105-02-&amp;volpage=photos&amp;photo=052005">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1105-02-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(62,-144.02000000000001)
847	Churchill	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Churchill</b></font><br /><font size="5"><b>Eastern Alaska</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/052008.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 5005 m<br /><b>Latitude:</b> 61.38&deg;N<br /><b>Longitude:</b> 141.75&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Bona-Churchill massif in the St. Elias Mountains forms the highest Quaternary volcano in the United States.  A 2.7 x 4.2 km wide caldera caps the summit of 4766-m-high Mount Churchill, which is now known to be the source of the White River Ash, produced during two of the largest explosive eruptions in North America during the past 2000 years (McGimsey et al. 1992).  The 5005-m-high summit of Mount Bona lies 4 km across a high saddle from the younger Mount Churchill.  The source vent of the widespread bilobate White River Ash deposit, which blankets more than 340,000 sq km of eastern Alaska and NW Canada, was initially thought to be a pumice mound that is mostly buried beneath the Klutlan Glacier NE of Churchill volcano.  More recent work has revealed thick young pumice deposits mineralogically and chemically similar to the White River Ash deposits along the rim of the Mount Churchill caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1105-03-&amp;volpage=photos&amp;photo=052008">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1105-03-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(61.380000000000003,-141.75)
848	Edgecumbe	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Edgecumbe</b></font><br /><font size="5"><b>Southeastern Alaska</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/096052.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 970 m<br /><b>Latitude:</b> 57.05&deg;N<br /><b>Longitude:</b> 135.75&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Pleistocene-to-Holocene Mount Edgecumbe volcanic field covers about 260 sq km of Kruzov Island west of Sitka in the SE panhandle of Alaska.  The basaltic-to-dacitic field is dominated by the large composite cones of Mount Edgecumbe, Crater Ridge, and Shell Mountain and has an unusual tectonic setting only 16 km east of the Queen Charlotte-Fairweather transform fault separating the North American and Pacific plates.  Mount Edgecumbe, a 970-m-high stratovolcano with a well-defined crater, is the largest volcano of the Edgecumbe field.  Crater Ridge is truncated by a 1.6-km-wide, 240-m-deep caldera.  These and other vents of the volcanic field are oriented along a SW-NE line.  Volcanic activity originated about 600,000 years ago along fissures cutting Kruzof Island.  A series of major silicic explosive eruptions took place about 9000-13,000 radiocarbon years ago.  The latest dated eruptions were phreatomagmatic explosions during the mid-Holocene, and all postglacial activity has been pyroclastic.  Reports of historical eruptions of Mount Edgecumbe are unsubstantiated.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1105-04-&amp;volpage=photos&amp;photo=096052">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1105-04-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(57.049999999999997,-135.75)
849	Duncan Canal	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Duncan Canal</b></font><br /><font size="5"><b>Southeastern Alaska</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/094051.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 15 m<br /><b>Latitude:</b> 56.50&deg;N<br /><b>Longitude:</b> 133.10&deg;W</td></tr><tr><td colspan="2"><p align="justify">Conspicuous fresh-looking pahoehoe and aa lava flows overlie glacial till at Kupreanof Island in the central panhandle of SE Alaska.  Quaternary basaltic lava flows of Holocene and/or Pleistocene age up to 10 m thick form several broad flat-lying peninsulas and scattered outcrops on the shores of Sumner Strait at the southern end of Kupreanof Island (Brew et al. 1985).  On a peninsula in Kah Sheets Bay a basaltic flow depositionally overlies till of the youngest glaciation, and youthful-looking flows are exposed along a broad 12-km-wide front westward toward Douglas Bay.  Two probable vents are found to the north within Mesozoic and Paleozoic rocks at the northern end of the Castle Islands in the Duncan Canal fault zone, and at Indian Point the flows contain inclusions of picrite.   At High Castle Island, the basaltic flows are columnar-jointed and overlie planar to cross-bedded coarse sandstone and poorly sorted volcaniclastic conglomerate.  Basaltic flows in the Duncan Canal area are both subaerial and submarine.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1105-05-&amp;volpage=photos&amp;photo=094051">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1105-05-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(56.5,-133.09999999999999)
850	Tlevak Strait-Suemez Is.	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tlevak Strait-Suemez Is.</b></font><br /><font size="5"><b>Southeastern Alaska</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/114084.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 50 m<br /><b>Latitude:</b> 55.25&deg;N<br /><b>Longitude:</b> 133.30&deg;W</td></tr><tr><td colspan="2"><p align="justify">Scattered flat-lying basaltic lava flows with fresh pahoehoe surfaces occur near Tlevak Strait and on the SW end of Suemez Island near the southern end of the panhandle of SE Alaska.  Outcrops are located on western Prince of Wales Island, along Bobs Bay on the NW side of Dall Island, and at Trocadero Bay on Suemez Island.  The flows overlie Paleozoic sedimentary rocks and are associated with Tertiary rhyolitic and dacitic lava flows on Suemez Island.  The younger alkaline olivine basaltic flows were considered by Brew (in Wood and Kienle 1990) to be of probable postglacial age.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1105-06-&amp;volpage=photos&amp;photo=114084">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1105-06-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.avo.alaska.edu/">Alaska Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(55.25,-133.30000000000001)
851	Alligator Lake	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Alligator Lake</b></font><br /><font size="5"><b>Yukon (Canada)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/115043.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 2217 m<br /><b>Latitude:</b> 60.42&deg;N<br /><b>Longitude:</b> 135.42&deg;W</td></tr><tr><td colspan="2"><p align="justify">A group of basaltic cones and lava flows (the Miles Canyon basalts) in south-central Yukon near the capital city of Whitehorse was considered to be of Pleistocene age (Wheeler, 1961).  The upper part of the Alligator Lake volcanic complex, consisting of two well-preserved cinder cones capping a small shield volcano, probably post-dates local Holocene glaciation (Eiche et al., 1987).  Lava flows from both cones traveled to the north and were erupted simultaneously.  Their compositions range from alkali olivine basalt to basanitic.  Flows from the NE cone are the largest, extending 6 km from the cone and expanding to a width of 10 km at the terminus.  Portions of the flows contain spinel lherzolite and granitoid xenoliths and megacrysts of olivine, pyroxene, and spinel.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-02-&amp;volpage=photos&amp;photo=115043">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-02-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://gsc.nrcan.gc.ca/volcanoes/">Natural Resources Canada</a></td></tr></table>	(60.420000000000002,-135.41999999999999)
852	Atlin Volcanic Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Atlin Volcanic Field</b></font><br /><font size="5"><b>British Columbia (Canada)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/096039.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1880 m<br /><b>Latitude:</b> 59.68&deg;N<br /><b>Longitude:</b> 133.32&deg;W</td></tr><tr><td colspan="2"><p align="justify">A group of late-Pleistocene to Holocene cinder cones lies on the Teslin Plateau in NW-most British Columbia, east of Atlin Lake.  The largest volcanic feature is 1880-m-high Ruby Mountain (named for the brilliantly colored tephra deposits at its summit and flanks), which has been partially dissected by Pleistocene and post-Wisconsin glaciation.  Two basaltic cinder cones at the heads of Cracker and Volcanic Creeks lie within glacially dissected U-shaped valleys and were considered to be of postglacial age (Edwards et al., 1996).  Placer miners working in the region at the end of the 19th century reported an eruption from the Ruby Mountain area about 80 km south of Gladys Lake (Hickson et al., 1994; Edwards et al., 1996) during which ashfall was reported for several days and the miners were able to work at nights due to incandescent glow from the eruption.  No field evidence has been found, however,  for a volcanic cone or lava flow in the Atlin area young enough to have been the product of an historical eruption, and the report is considered uncertain.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-03-&amp;volpage=photos&amp;photo=096039">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-03-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://gsc.nrcan.gc.ca/volcanoes/">Natural Resources Canada</a></td></tr></table>	(59.68,-133.31999999999999)
853	Tuya Volcanic Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tuya Volcanic Field</b></font><br /><font size="5"><b>British Columbia (Canada)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/109086.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 2123 m<br /><b>Latitude:</b> 59.37&deg;N<br /><b>Longitude:</b> 130.58&deg;W</td></tr><tr><td colspan="2"><p align="justify">A broad region dotted with formerly subglacial volcanic cones known as tuyas forms the Tuya volcanic field near Tuya Lake and a broad area to the north.  Although tuyas, the products of Pleistocene subglacial eruptions, are perhaps more well-known in Iceland, these predominantly flat-topped basaltic table mountains derive their name from the Tuya region in the Cassiar Mountains and Tanzilla Plateau area of northern British Columbia.  Tuya Butte itself, immediately north of Tuya Lake, has no summit crater or obvious vent, suggesting fissure-fed eruptions, although several indications suggest a vent location near a large cirque on the north face.   Other tuyas lie in the High Tuya Lake, Iverson Creek, Rancheria River, and Klinkit Lake areas.  Several small subaerial shield volcanoes, and postglacial lapilli cones and lava flows have been reported in this area.  At least one of these, Grabrielse Cone near the headwaters of Iverson Creek, is of Holocene age.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-031&amp;volpage=photos&amp;photo=109086">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-031">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://gsc.nrcan.gc.ca/volcanoes/">Natural Resources Canada</a></td></tr></table>	(59.369999999999997,-130.58000000000001)
854	Edziza	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Edziza</b></font><br /><font size="5"><b>British Columbia (Canada)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/101055.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2786 m<br /><b>Latitude:</b> 57.72&deg;N<br /><b>Longitude:</b> 130.63&deg;W</td></tr><tr><td colspan="2"><p align="justify">The composite felsic stratovolcano Mount Edziza and associated satellitic lava domes and pyroclastic cones were constructed over the past 7.5 million years during five magmatic cycles beginning with eruption of alkali basalts and ending with felsic and basaltic eruptions as late about 1000 years ago.  The 7.5 million-year-old (Ma) Armadillo Peak stratovolcano at the south end of the complex is overlapped by the Ice Peak central volcano, which was formed during the early Pleistocene, and contains a caldera largely destroyed by glaciers.  The Mount Edziza stratovolcano on the north was formed about 1.0-0.9 Ma.  A 2-km-wide, ice-filled caldera truncates its summit; lava domes were subsequently emplaced around its periphery and lava lakes ponded within the caldera and overflowed its rim.  Numerous ice-contact features and products of subglacial eruptions are found in the Mount Edziza complex.  More than 30 Holocene pyroclastic cones, primarily of basaltic composition, are located on Mount Edziza and the adjacent Spectrum Range, some of which are younger than about 1300 years before present.  Large areas of Holocene lava flows of the postglacial Big Raven Formation are located north of Mount Edziza, forming the Desolation Lava Field, and south and SW of Ice Peak, forming the Snowshoe Lava Field.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-06-&amp;volpage=photos&amp;photo=101055">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-06-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://gsc.nrcan.gc.ca/volcanoes/">Natural Resources Canada</a></td></tr></table>	(57.719999999999999,-130.63)
855	Spectrum Range	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Spectrum Range</b></font><br /><font size="5"><b>British Columbia (Canada)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/106085.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2430 m<br /><b>Latitude:</b> 57.43&deg;N<br /><b>Longitude:</b> 130.68&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Spectrum Range, south of Mount Edziza, is one of four large composite volcanoes that make up the Mount Edziza-Spectrum Range volcanic complex.  A predominately rhyolitic lava dome complex overlies a basal basaltic shield volcano in the Spectrum Range, named for its extensive colorful solfataric alteration.  The Pliocene Spectrum Range center contains Pleistocene subglacial and subaerial cones on the SW flank and Holocene pyroclastic cones and lava flows on the NW and SW sides.  The Mess Lake Lava Field on the NW consists of young lava flows and tephra from three pyroclastic cones, including The Ash Pit, which may be the youngest volcanic feature of the Mount Edziza-Spectrum Range complex.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-07-&amp;volpage=photos&amp;photo=106085">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-07-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://gsc.nrcan.gc.ca/volcanoes/">Natural Resources Canada</a></td></tr></table>	(57.43,-130.68000000000001)
856	Hoodoo Mountain	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hoodoo Mountain</b></font><br /><font size="5"><b>British Columbia (Canada)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/096042.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Subglacial volcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1850 m<br /><b>Latitude:</b> 56.78&deg;N<br /><b>Longitude:</b> 131.28&deg;W</td></tr><tr><td colspan="2"><p align="justify">Hoodoo Mountain is a flat-topped Pleistocene-to-Holocene volcano in the Boundary Ranges of NW British Columbia near the Alaska border that is composed of both subglacial and subaerial volcanic products.  Valley glaciers surround the volcano on all except the south side. The Pleistocene Little Bear Mountain basaltic tuya adjoins Hoodoo Mountain on the immediate north.  Most of the volcano formed beneath glacial ice; all flank flows appear to have originated from beneath the current 4-km-wide summit icecap.  More than 90% of the volcano, which dates back to at least 100,000 years, consists of interlayered peralkaline phonolitic and trachytic lava flows and hyaloclastites.  At least one subaerial explosive eruption produced a welded and unwelded ignimbrite sequence on the north side.  The most recent stage of volcanic activity produced subaerial unglaciated lava flows with well-preserved lava channels that originated from summit and flank vents about 9000 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-08-&amp;volpage=photos&amp;photo=096042">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-08-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://gsc.nrcan.gc.ca/volcanoes/">Natural Resources Canada</a></td></tr></table>	(56.780000000000001,-131.28)
857	Iskut-Unuk River Cones	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Iskut-Unuk River Cones</b></font><br /><font size="5"><b>British Columbia (Canada)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/096044.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1880 m<br /><b>Latitude:</b> 56.58&deg;N<br /><b>Longitude:</b> 130.55&deg;W</td></tr><tr><td colspan="2"><p align="justify">Eight small basaltic centers at the southern end of the Stikine volcanic belt near the Alaska border comprise the Iskut-Unuk River Cone Group, one of the youngest volcanic centers in Canada.  Lava flows date back 70,000 years, but the subaerial vents produced cinder cones and lava flows that were probably all active between about 9000 and a few hundred years ago.  Five of the centers produced lava flows that traveled up to about 20 km down the Iskut and Unuk River valleys and their tributaries.  The three remaining centers are products of ice-contact volcanism that formed pillow lava, hyaloclastite breccias, and scoria.  The Iskut-Unuk flows are similar in mineralogy and contain abundant crustal xenoliths.  Vents in the Iskut River Canyon area produced at least 10 lava flows and the Lava Fork vents at least three, the latest of which erupted within the past few hundred years.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-09-&amp;volpage=photos&amp;photo=096044">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-09-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://gsc.nrcan.gc.ca/volcanoes/">Natural Resources Canada</a></td></tr></table>	(56.579999999999998,-130.55000000000001)
858	Tseax River Cone	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tseax River Cone</b></font><br /><font size="5"><b>British Columbia (Canada)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/101045.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> 609 m<br /><b>Latitude:</b> 55.12&deg;N<br /><b>Longitude:</b> 128.90&deg;W</td></tr><tr><td colspan="2"><p align="justify">The basaltic Tseax River cinder cones (Aiyansh volcano) at the southern end of the Stikine volcanic belt have been the site of some of the youngest volcanic eruptions in Canada.  Nested cinder cones lying along a tributary of the Nass River were the source of a lava flow that traveled into the Tseax River, damming it and forming Lava Lake.  The flow subsequently traveled 11 km north to the Nass River, where it filled the flat valley floor for an additional 10 km.  Native legends of the Nisga'a People tell of a prolonged period of disruption by the volcano, including the destruction of their village on the Nass River and the death of some people from &quot;poison smoke.&quot;  The vent was active at least twice (625 and 220 radiocarbon years ago) and other remnants of lava flows exist in the area, which was designated the Nisga'a Memorial Lava Beds Provincial Park in 1993 (Hickson and Edwards, 2001).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-10-&amp;volpage=photos&amp;photo=101045">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-10-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://gsc.nrcan.gc.ca/volcanoes/">Natural Resources Canada</a></td></tr></table>	(55.119999999999997,-128.90000000000001)
859	Crow Lagoon	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Crow Lagoon</b></font><br /><font size="5"><b>British Columbia (Canada)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/101052.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> 335 m<br /><b>Latitude:</b> 54.70&deg;N<br /><b>Longitude:</b> 130.23&deg;W</td></tr><tr><td colspan="2"><p align="justify">Thick beds of basaltic tephra of Holocene age originating from an unknown Quaternary volcanic center have been found near Crow Lagoon, north of Prince Rupert near the southern tip of the Alaskan panhandle.  Ballistically emplaced bombs imply a nearby source, which remains unidentified (Souther and Weiland, 1993).   The tephra beds are located along the south side of the Khutzeymateen Inlet, about 40 km north Prince Rupert.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-11-&amp;volpage=photos&amp;photo=101052">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-11-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://gsc.nrcan.gc.ca/volcanoes/">Natural Resources Canada</a></td></tr></table>	(54.700000000000003,-130.22999999999999)
860	Milbanke Sound Group	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Milbanke Sound Group</b></font><br /><font size="5"><b>British Columbia (Canada)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/106082.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 335 m<br /><b>Latitude:</b> 52.50&deg;N<br /><b>Longitude:</b> 128.73&deg;W</td></tr><tr><td colspan="2"><p align="justify">Swindle, Lake, and Lady Douglas Islands in the Milbanke Sound area of the Fiord Ranges in west-central British Columbia contain cinder cones of Holocene age.  Kitasu Hill on the western side of Swindle Island is a young basaltic cone that produced lava flows that extend to the north.  Other postglacial vents identified by Dolmage (1921, 1924) are correlated by lithology only and may be as old as Tertiary (Baer, 1973; Holland, 1976).  Basaltic tuff breccias on Lake Island and Lady Douglas Island originated from Helmet Peak on Lady Island.  Basaltic lava flows from Price and Dufferin Islands overlie adjacent beach deposits (Souther; in Wood and Kienle, 1990).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-12-&amp;volpage=photos&amp;photo=106082">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-12-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://gsc.nrcan.gc.ca/volcanoes/">Natural Resources Canada</a></td></tr></table>	(52.5,-128.72999999999999)
861	Satah Mountain	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Satah Mountain</b></font><br /><font size="5"><b>British Columbia (Canada)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 1921 m<br /><b>Latitude:</b> 52.47&deg;N<br /><b>Longitude:</b> 124.70&deg;W</td></tr><tr><td colspan="2"><p align="justify">Satah Mountain on the Chilocotin-Nechako Plateau in central British Columbia and areas to the south form a N-S-trending chain of pyroclastic cones of Pleistocene and Holocene age (Hickson 1990, pers. comm.).  Satah Mountain occupies the high point of a long ridge of trachytic lava domes and flows and basaltic and trachybasaltic pyroclastic cones extending south from the felsic Itcha Range volcanic complex.  The youngest cone is well preserved and could be of comparable age to the 7200-year-old Nazko cone east of the Itcha Range (Charland et al., 1993).  Most late-stage lavas capping the Itcha volcanic complex were erupted from cinder cones, tuff rings, and fissures in the eastern half of the complex.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-13-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://gsc.nrcan.gc.ca/volcanoes/">Natural Resources Canada</a></td></tr></table>	(52.469999999999999,-124.7)
862	Nazko	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Nazko</b></font><br /><font size="5"><b>British Columbia (Canada)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/101054.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1230 m<br /><b>Latitude:</b> 52.90&deg;N<br /><b>Longitude:</b> 123.73&deg;W</td></tr><tr><td colspan="2"><p align="justify">Nazko Cone, the easternmost and youngest volcano of the Anahim volcanic belt in the Chilcotin-Nechako Plateau, central British Columbia, rests on glacial till.  It was formed in three episodes of activity, the first of which took place during a Pleistocene interglacial stage about 0.34 million years ago (Souther et al., 1987).  The second stage produced a large hyaloclastite scoria mound erupted beneath the Cordilleran ice sheet during the late Pleistocene.  The final activity occurred about 7200 years ago, forming a compound subaerial basanitic cinder cone that overtopped the hyaloclastite mound and produced two small lava flows that traveled about 1 km to the west.  An airfall tephra blanket extends several km to the north and east of the cone.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-14-&amp;volpage=photos&amp;photo=101054">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-14-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://gsc.nrcan.gc.ca/volcanoes/">Natural Resources Canada</a></td></tr></table>	(52.899999999999999,-123.73)
863	Wells Gray-Clearwater	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Wells Gray-Clearwater</b></font><br /><font size="5"><b>British Columbia (Canada)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/101048.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2015 m<br /><b>Latitude:</b> 52.33&deg;N<br /><b>Longitude:</b> 120.57&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Wells Gray-Clearwater volcanic field in the Quesnel Highland of east-central British Columbia contains basaltic cones and lava flows of early Pleistocene-to-Holocene age.  Pleistocene deposits include plateau-capping lava flows, subglacial mounds and tuyas, and hyaloclastites.  Buck Hill Cone was erupted during the latest Pleistocene during the waning stages of the Fraser glaciation.  Holocene eruptions took place in the Spanish Creek, Ray Lake and Kostal Lake areas (Hickson and Souther, 1984), forming cinder cones and producing lava flows that traveled up to 14 km.  A lava flow from Dragon cone is radiocarbon dated at about 7600 years ago, and flows from Flourmill, Kostal, and Spanish Lake Cones rest on glaciated bedrock without an intervening paleosol, suggesting an early Holocene age.  The latest eruption took place from Kostal cone about 400 years ago (Hickson and Edwards, 2001).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-15-&amp;volpage=photos&amp;photo=101048">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-15-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://gsc.nrcan.gc.ca/volcanoes/">Natural Resources Canada</a></td></tr></table>	(52.329999999999998,-120.56999999999999)
864	Silverthrone	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Silverthrone</b></font><br /><font size="5"><b>British Columbia (Canada)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3160 m<br /><b>Latitude:</b> 51.43&deg;N<br /><b>Longitude:</b> 126.30&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Silverthrone volcanic complex lies near the coast in SW British Columbia NW of the head of Knight Inlet.  Silverthrone is a roughly circular, 20-km-wide, deeply dissected caldera complex containing rhyolitic, dacitic and andesitic lava domes, flows and breccia.  The bulk of the complex appears to have been erupted between 0.1 and 0.5 million years ago (Ma), but postglacial andesitic and basaltic-andesite cones and lava flows are also present.  Anomalously old Potassium-Argon (K-Ar) dates of 1.0 and 1.1 Ma were obtained from a lava flow in the postglacial Pashleth and Machmel Creek valleys (Green et al., 1988).  This flow is clearly much younger than the K-Ar date, and high-energy glacial streams have only begun to etch a channel along the margin of the flow.  A radiocarbon date from barnacles 8.5 km upstream from the mouth of Machmel River and buried by the flow yielded an age of 12,200 +/- 140 years (Blake, 1985).  This is a maximum age for the flow, which could be much younger (Hickson and Edwards, 2001).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-16-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://gsc.nrcan.gc.ca/volcanoes/">Natural Resources Canada</a></td></tr></table>	(51.43,-126.3)
865	Bridge River Cones	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bridge River Cones</b></font><br /><font size="5"><b>British Columbia (Canada)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 2500 m<br /><b>Latitude:</b> 50.80&deg;N<br /><b>Longitude:</b> 123.40&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Bridge River Cones volcanic field consists of a group of small basaltic and trachybasaltic eruptive centers at the extreme northern end of the Garibaldi volcanic belt in SW British Columbia.  Pleistocene volcanic necks and cones were Potassium-Argon dated at 0.97 and 0.59 million years ago in the Salal Creek area and display ice-contact features (Lawrence et al., 1984).  Tuber Hill is a small subaerial 600,000-year-old basaltic stratovolcano to the north that was constructed on the Bridge River upland when neighboring valleys were filled with ice.   Lava flows that overlie poorly consolidated glacial till and appear to post-date the latest glaciation are found immediately north of Bridge River.  The youngest flow may be less than 1500 years old (Souther; in Wood and Kienle, 1990).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-17-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://gsc.nrcan.gc.ca/volcanoes/">Natural Resources Canada</a></td></tr></table>	(50.799999999999997,-123.40000000000001)
866	Meager	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Meager</b></font><br /><font size="5"><b>British Columbia (Canada)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/027001.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 2680 m<br /><b>Latitude:</b> 50.63&deg;N<br /><b>Longitude:</b> 123.50&deg;W</td></tr><tr><td colspan="2"><p align="justify">Mount Meager volcanic complex of Pliocene-to-Holocene age forms a dissected andesitic-to-rhyodacitic stratovolcano with multiple eroded summit lava domes and volcanic necks.  Mount Meager lies in the Garibaldi volcanic belt and is the northernmost volcano of the Cascade volcanic arc that extends down to northern California.  The summit of the complex consists of overlapping piles of andesitic lava flows and younger dacitic lava domes and flows.  Quaternary basalts underlying the uppermost 22 km of the Elaho valley originated at the 1375 m level in the South Fork Meager River.  The most recent activity from the Meager volcanic complex about 2350 years ago produced Canada's largest known Holocene explosive eruption and an associated welded block-and-ash flow and a lava flow from a vent on the NE flank of Plinth Peak.  Two clusters of hot springs occur within the complex, which has been investigated for potential geothermal power.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-18-&amp;volpage=photos&amp;photo=027001">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-18-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://gsc.nrcan.gc.ca/volcanoes/">Natural Resources Canada</a></td></tr></table>	(50.630000000000003,-123.5)
867	Garibaldi Lake	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Garibaldi Lake</b></font><br /><font size="5"><b>British Columbia (Canada)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/027014.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 2316 m<br /><b>Latitude:</b> 49.92&deg;N<br /><b>Longitude:</b> 123.03&deg;W</td></tr><tr><td colspan="2"><p align="justify">A group of nine small andesitic stratovolcanoes and basaltic-andesite vents in the scenic Garibaldi Lake area immediately north of Mount Garibaldi was formed during the late Pleistocene and early Holocene.  The oldest stratovolcano, The Black Tusk, formed between about 1.3 and 1.1 million years ago (Ma).  Following glacial dissection, renewed volcanism (0.21-0.17 Ma) produced the lava dome and flow forming its summit.  Other Pleistocene vents are located along and to the west of the Cheakamus River.  The Cinder Cone, to the east of The Black Tusk, produced a 9-km-long lava flow during the late Pleistocene or early Holocene (0.04 +/- 0.04 Ma).  Mount Price, west of Garibaldi Lake, was formed in three stages dating back to 1.1 million years, the latest of which produced two large lava flows from Clinker Peak during the early Holocene that ponded against the retreating continental ice sheet and formed the barrier containing Garibaldi Lake.  The Table, a steep-sided subglacial tuya south of Garibaldi Lake, was also formed during the early Holocene.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-19-&amp;volpage=photos&amp;photo=027014">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-19-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://gsc.nrcan.gc.ca/volcanoes/">Natural Resources Canada</a></td></tr></table>	(49.920000000000002,-123.03)
868	Garibaldi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Garibaldi</b></font><br /><font size="5"><b>British Columbia (Canada)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/027013.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2678 m<br /><b>Latitude:</b> 49.85&deg;N<br /><b>Longitude:</b> 123.00&deg;W</td></tr><tr><td colspan="2"><p align="justify">Mount Garibaldi at the head of Howe Sound north of Vancouver is a Pleistocene dacitic stratovolcano capped by a lava dome complex.  An initial period of volcanism 0.51-0.22 million years ago was followed after a period of quiescence by construction of a conical plug dome and breccia pile at the south summit, Atwell Peak.  Retreat of the ice cap left the west flank unsupported, and it collapsed in a series of landslides, exposing the core of the volcano.  Lava flows from Dalton Dome north of Atwell Peak subsequently flowed down the scarp.  Subglacial flank centers such as Eanastick (Enostuck) Meadow, Glacier Pike and Paul Ridge were also formed during the late Pleistocene.  The final activity of Mount Garibaldi formed the Opal Cone on the SE flank and the lengthy Ring Creek lava flow, which filled a glaciated valley on the south flank during the early Holocene (Mathews, 1958; Brooks and Friele, 1992).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-20-&amp;volpage=photos&amp;photo=027013">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1200-20-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://gsc.nrcan.gc.ca/volcanoes/">Natural Resources Canada</a></td></tr></table>	(49.850000000000001,-123)
869	Baker	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Baker</b></font><br /><font size="5"><b>Washington (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/027036.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> 3285 m<br /><b>Latitude:</b> 48.777&deg;N<br /><b>Longitude:</b> 121.813&deg;W</td></tr><tr><td colspan="2"><p align="justify">Mount Baker, the northernmost of Washington's volcanoes, is a 3285-m-high glacier-clad andesitic stratovolcano constructed above the east flank of the eroded mid-Pleistocene Black Buttes volcano and SW of the early Pleistocene 4.5 x 8 km rhyodacitic Kulshan caldera.   With the exception of the Schreibers Meadow cinder cone on the SE flank, which formed about 9800 years ago, Holocene volcanism has been confined to the central conduit.  A major magmatic eruption at Mount Baker about 6500 years ago was the largest eruptive event at the volcano during the Holocene and was accompanied by a major collapse event that produced a lahar that reached Bellingham Bay.  Mount Baker was observed in eruption by the crew of a Spanish exploring vessel in 1792.  Early settlers in the Puget Sound region as far away as Victoria, British Columbia observed 19th-century activity, all of which consisted of relatively minor phreatic eruptions.  Sherman Crater, the historically active crater immediately south of the summit, has been the site of increased steam emission since 1975.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1201-01=&amp;volpage=photos&amp;photo=027036">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1201-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(48.777000000000001,-121.813)
870	Glacier Peak	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Glacier Peak</b></font><br /><font size="5"><b>Washington (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/027062.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3213 m<br /><b>Latitude:</b> 48.112&deg;N<br /><b>Longitude:</b> 121.113&deg;W</td></tr><tr><td colspan="2"><p align="justify">Glacier Peak, the most isolated of the Cascade volcanoes, rises to 3213 m above the rugged forested terrain of the Glacier Peak Wilderness Area in the North Cascades.  Glacier Peak is a dacitic-andesitic stratovolcano with summit and flank lava domes; it resembles Mount St. Helens in its explosive vigor.  More than a dozen glaciers descend its flanks, prompting its name.  Although its summit towers 3000 m above surrounding valleys, the volcano was constructed above a high ridge and is itself less than 1000 m high.  Repeated major explosive eruptions associated with lava dome growth during the late Pleistocene and Holocene deposited tephra over wide distances to the east.  Voluminous pyroclastic flows and mudflows extended into the Puget Sound lowlands to the west and diverted several river courses into adjacent valleys.  The latest eruption of Glacier Peak only a few hundred years ago was noted by indigenous Pacific Northwest Indians, and hot springs occur on its flanks.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1201-02-&amp;volpage=photos&amp;photo=027062">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1201-02-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(48.112000000000002,-121.113)
871	Rainier	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Rainier</b></font><br /><font size="5"><b>Washington (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/045068.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 4392 m<br /><b>Latitude:</b> 46.853&deg;N<br /><b>Longitude:</b> 121.760&deg;W</td></tr><tr><td colspan="2"><p align="justify">Mount Rainier, at 4392 m the highest peak in the Cascade Range, forms a dramatic backdrop to the Puget Sound region.  Large Holocene mudflows from collapse of this massive, heavily glaciated andesitic volcano have reached as far as the Puget Sound lowlands.  The present summit was constructed within a large crater breached to the northeast formed by collapse of the volcano during a major explosive eruption about 5600 years that produced the widespread Osceola Mudflow.  Rainier has produced eruptions throughout the Holocene, including about a dozen during the past 2600 years; the largest of these occurred about 2200 years ago.  The present-day summit cone is capped by two overlapping craters.  Extensive hydrothermal alteration of the upper portion of the volcano has contributed to its structural weakness; an active thermal system has caused periodic melting on flank glaciers and produced an elaborate system of steam caves in the summit icecap.  Reported 19th-century eruptions have not left identifiable deposits, but a phreatic eruption may have taken place as recently as 1894.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1201-03-&amp;volpage=photos&amp;photo=045068">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1201-03-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(46.853000000000002,-121.76000000000001)
872	Adams	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Adams</b></font><br /><font size="5"><b>Washington (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/028010.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3742 m<br /><b>Latitude:</b> 46.206&deg;N<br /><b>Longitude:</b> 121.490&deg;W</td></tr><tr><td colspan="2"><p align="justify">Although lower in height than its neighbor to the north, Mount Rainier, massive Mount Adams rises above a lower topographic base and is second in volume only to Mount Shasta among volcanoes of the Cascade Range.  The Mount Adams volcanic field includes the 200 cu km Mount Adams complex andesitic-dacitic stratovolcano, elongated along a NNW-SSE line, and more than 60 flank vents.  Volcanism began about 940 thousand years ago (ka), with three main cone-building stages occurring at about 500, 450 and 30 ka.  Adams was active throughout the Holocene, producing two dozen minor explosive eruptions from summit and flank vents.  Six Holocene lava flows are located on the flanks between 2100 and 2600 m altitude.  The most voluminous Holocene lava flows, some of which traveled 10 km or more, were emplaced between about 7 and 4 ka.  The latest eruption about 1000 years ago produced a minor tephra layer and possibly a small lava flow down the east flank.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1201-04-&amp;volpage=photos&amp;photo=028010">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1201-04-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(46.206000000000003,-121.48999999999999)
873	St. Helens	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>St. Helens</b></font><br /><font size="5"><b>Washington (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/054091.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2549 m<br /><b>Latitude:</b> 46.20&deg;N<br /><b>Longitude:</b> 122.18&deg;W</td></tr><tr><td colspan="2"><p align="justify">Prior to 1980, Mount St. Helens formed a conical, youthful volcano sometimes known as the Fuji-san of America.  During the 1980 eruption the upper 400 m of the summit was removed by slope failure, leaving a 2 x 3.5 km horseshoe-shaped crater now partially filled by a lava dome.  Mount St. Helens was formed during nine eruptive periods beginning about 40-50,000 years ago and has been the most active volcano in the Cascade Range during the Holocene.  Prior to 2200 years ago, tephra, lava domes, and pyroclastic flows were erupted, forming the older St. Helens edifice, but few lava flows extended beyond the base of the volcano.  The modern edifice was constructed during the last 2200 years, when the volcano produced basaltic as well as andesitic and dacitic products from summit and flank vents.  Historical eruptions in the 19th century originated from the Goat Rocks area on the north flank, and were witnessed by early settlers.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1201-05-&amp;volpage=photos&amp;photo=054091">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1201-05-">Smithsonian Volcano Information</a></td></tr></table>	(46.200000000000003,-122.18000000000001)
874	West Crater	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>West Crater</b></font><br /><font size="5"><b>Washington (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/107020.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 1329 m<br /><b>Latitude:</b> 45.88&deg;N<br /><b>Longitude:</b> 122.08&deg;W</td></tr><tr><td colspan="2"><p align="justify">West Crater, a small andesitic lava dome with associated lava flows, is part of a Quaternary volcanic field in southern Washington consisting primarily of small basaltic and basaltic andesite cinder cones and shield volcanoes, oriented along a NW-SE zone SE of Mount St. Helens.  This 20-km-wide zone extends from Marble Mountain, north of Swift Reservoir, to south of Trout Creek Hill.  The Pleistocene basaltic Trout Creek Hill shield volcano produced a lava flow about 340,000 years ago that traveled 20 km SE, temporarily damming the Columbia River.  At least three vents in this field are of Holocene age--West Crater, a small cone at Hackamore Creek, and a phreatic crater at the summit of Bare Mountain.  The latest eruptions at these locations have been dated at about 8000 years before present, and have included emplacement of an andesitic lava dome and associated lava flow at West Crater and formation of a phreatic explosion crater at Bare Mountain.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1201-06-&amp;volpage=photos&amp;photo=107020">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1201-06-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(45.880000000000003,-122.08)
875	Indian Heaven	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Indian Heaven</b></font><br /><font size="5"><b>Washington (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/029053.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1806 m<br /><b>Latitude:</b> 45.93&deg;N<br /><b>Longitude:</b> 121.82&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Pleistocene-to-Holocene Indian Heaven volcanic field, located midway between Mount St. Helens and Mount Adams, is an area of low overlapping shield volcanoes with flank vents primarily oriented along a N-S line.  Small shield volcanoes topped by cinder and spatter cones dominate the volcanic field, which also contains subglacial vents.  The shield volcanoes extend from Sawtooth Mountain on the north to Red Mountain on the south; the high point of the field is 1806-m-high Lemei Rock shield volcano.  Basasltic-to-andesitic lava flows blanket much of the field; individual lava flows, many of which display extensive lava tubes, traveled up to 46 km.  The youngest eruption about 8200 years ago produced the voluminous Big Lava Bed, a 0.9 cu km basaltic lava flow that traveled nearly 25 km south of its source, an unnamed cinder cone SE of Red Mountain, to within 8 km of the Columbia River.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1201-07-&amp;volpage=photos&amp;photo=029053">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1201-07-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(45.93,-121.81999999999999)
876	Hood	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hood</b></font><br /><font size="5"><b>Oregon (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/029067.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> 3426 m<br /><b>Latitude:</b> 45.374&deg;N<br /><b>Longitude:</b> 121.695&deg;W</td></tr><tr><td colspan="2"><p align="justify">Mount Hood, Oregon's highest peak, forms a prominent backdrop to the state's largest city, Portland.  The eroded summit area of Mount Hood consists of several andesitic or dacitic lava domes.  Major Pleistocene edifice collapse produced a debris avalanche and lahar that traveled north down the Hood River valley and crossed the Columbia River.  The glacially eroded volcano has had at least four major eruptive periods during the past 15,000 years.  The last three occurred within the past 1800 years from vents high on the SW flank and produced deposits that were distributed primarily to the south and west along the Sandy and Zigzag rivers.  The last eruptive period took place around 170-220 years ago, when growth of the Crater Rock lava dome was accompanied by pyroclastic flows and lahars down the White and Sandy rivers.  The Sandy River lahar deposits extended to the west as far as the Columbia River and were observed by members of the 1804-1805 Lewis and Clark expedition within a few years of their emplacement.   Minor 19th-century eruptions were witnessed from Portland.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1202-01-&amp;volpage=photos&amp;photo=029067">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1202-01-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(45.374000000000002,-121.69499999999999)
877	Jefferson	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Jefferson</b></font><br /><font size="5"><b>Oregon (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/030011.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3199 m<br /><b>Latitude:</b> 44.674&deg;N<br /><b>Longitude:</b> 121.800&deg;W</td></tr><tr><td colspan="2"><p align="justify">Mount Jefferson, Oregon's second highest peak, is a deeply eroded stratovolcano that has been inactive since the late Pleistocene.  The glacier-clad landmark prominent from both sides of the Cascade Range was named by Lewis and Clark for the president that sponsored their expedition.  Jefferson was constructed in two episodes interrupted by extensive glacial erosion.  The first of these, beginning about 290,000 years ago, produced an andesitic-to-dacitic volcano possibly higher than the current summit.  Dacitic lava domes were emplaced during the 2nd cycle beginning about 70,000 years ago that produced ash flows that traveled 15 km to the east and west.  Several Holocene cinder cones near the Cascade crest south of Jefferson have produced lava flows that traveled down glacially carved valleys, including those from Forked Butte and North Cinder Peak.  The most recent eruption, from a cinder cone on the flank of  the South Cinder Peak cone, produced a lava flow that traveled west into Marion Lake about 1000 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1202-02-&amp;volpage=photos&amp;photo=030011">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1202-02-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(44.673999999999999,-121.8)
878	Blue Lake Crater	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Blue Lake Crater</b></font><br /><font size="5"><b>Oregon (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/081080.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Maar<br />&nbsp;&nbsp;&nbsp; Fissure vent</td><td width="50%" align="left"><b>Summit Elev:</b> 1230+ m<br /><b>Latitude:</b> 44.411&deg;N<br /><b>Longitude:</b> 121.774&deg;W</td></tr><tr><td colspan="2"><p align="justify">Blue Lake crater, one of the least known Holocene volcanoes of the Oregon Cascades, is a series of at least three overlapping explosion craters along a NE trend slightly east of the crest of the Cascade Range.  Explosions through pre-existing bedrock about 1300 years ago deposited basaltic bombs and cinders and spread a tephra blanket to the east and SE during perhaps the youngest eruption in the Santiam and McKenzie Passes region.  The eruption created an elongated, steep-walled crater with a low rim that rises about 50 m above adjacent topography.  The crater is now filled by the 0.3 x 0.8 km wide Blue Lake, immediately west of the popular recreation area of glacial moraine dammed Suttle Lake.  A chain of spatter cones 6 km to the SSW and about 4 km NE of Mount Washington, is aligned with Blue Lake crater and has ejecta that are petrographically similar to that from Blue Lake and may have been erupted at the same time.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1202-03-&amp;volpage=photos&amp;photo=081080">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1202-03-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(44.411000000000001,-121.774)
879	Sand Mountain Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sand Mountain Field</b></font><br /><font size="5"><b>Oregon (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/088068.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1664 m<br /><b>Latitude:</b> 44.38&deg;N<br /><b>Longitude:</b> 121.93&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Sand Mountain volcanic field consists of a group of 23 basaltic and basaltic-andesite cinder cones along a N-S line immediately west of the Cascade crest NW of Mount Washington.  Two cone alignments trending NNW and NNE intersect near the largest cinder cone, Sand Mountain.  A series of young, unvegetated lava flows originating from vents on the west side of the chain of cones were erupted primarily during a 1000-year period from about 3000-4000 years ago.  Lava flows traveled predominately to the west, blocking local drainages and forming several small lakes.  The Lost Lake cinder cone group at the north end of the chain was active about 2000 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1202-04-&amp;volpage=photos&amp;photo=088068">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1202-04-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(44.380000000000003,-121.93000000000001)
880	Belknap	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Belknap</b></font><br /><font size="5"><b>Oregon (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/030052.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2095 m<br /><b>Latitude:</b> 44.285&deg;N<br /><b>Longitude:</b> 121.841&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Belknap Crater area near McKenzie Pass, north of the Three Sisters volcanoes in the central Oregon Cascades, was the source of one of the largest concentrations of youthful volcanism in the Cascade Range.  The basaltic to basaltic-andesite Belknap shield volcano, topped by the Belknap Crater pyroclastic cone and the Little Belknap shield volcano immediately to the east, have produced widespread late-Holocene lava flows on all sides that form an impressive panorama of youthful volcanism in the McKenzie Pass area, much of which took place between about 3000 and 1500 years ago.  Late-stage eruptions from the NE base of Belknap crater produced lava flows that traveled 15 km west into the McKenzie River valley.  The narrow McKenzie Pass highway provides seasonal access across the barren lava fields with spectacular views toward Mt. Jefferson and the Three Sisters.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1202-06-&amp;volpage=photos&amp;photo=030052">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1202-06-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(44.284999999999997,-121.84099999999999)
881	North Sister Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>North Sister Field</b></font><br /><font size="5"><b>Oregon (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/030062.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Shield volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 3074 m<br /><b>Latitude:</b> 44.17&deg;N<br /><b>Longitude:</b> 121.77&deg;W</td></tr><tr><td colspan="2"><p align="justify">North and Middle Sister volcanoes anchor the northern end of the Three Sisters volcano group that dominates the landscape of the central Oregon Cascades.  Glaciers have deeply eroded the Pleistocene andesitic-dacitic North Sister stratovolcano, exposing the volcano's central plug.  North Sister was constructed over the remnants of the basaltic Little Brother shield volcano to the NW.  Construction of the main edifice ceased at about 55,000 yrs ago, but N-S-trending fissures north of the volcano were active until at least the latest Pleistocene.  Middle Sister volcano, also over 3000 m in elevation, is located only 2 km to the south.  The basaltic-to-rhyolitic Middle Sister and its flank vents is less-eroded, but Holocene activity in the North Sister area is restricted to a group of cinder cones north and NW of the North Sister that have produced a series of fresh-looking blocky lava flows on both sides of McKenzie Pass.  The youngest lava flow, from Collier Cone, which was erupted about 1600 years ago and traveled 13.5 km to the west, is a prominent feature of the McKenzie Pass area.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1202-07-&amp;volpage=photos&amp;photo=030062">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1202-07-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(44.170000000000002,-121.77)
882	South Sister	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>South Sister</b></font><br /><font size="5"><b>Oregon (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/031014.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3157 m<br /><b>Latitude:</b> 44.103&deg;N<br /><b>Longitude:</b> 121.768&deg;W</td></tr><tr><td colspan="2"><p align="justify">South Sister is the highest and youngest of the Three Sisters volcanoes that dominate the landscape of the central Oregon Cascades.  The main edifice of 3157-m-high South Sister is constructed of andesitic and dacitic lava flows capped by a symmetrical summit cinder cone of probable latest-Pleistocene age.  The late Pleistocene or early Holocene Cayuse Crater on the SW flank of Broken Top volcano and other flank vents such as Le Conte Crater on the SW flank of South Sister mark mafic vents that have erupted at considerable distances from South Sister itself.  Late-Holocene eruptions formed a chain of dike-fed rhyodacitic lava domes and flows on the volcano's SE-to-SW flanks about 2000 years ago.  Satellite radar interferometry (InSAR) data obtained by U S Geological Survey scientists detected continuing long-term slight uplift of the ground surface over a broad region centered 5 km west of South Sister volcano that began in 1997.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1202-08-&amp;volpage=photos&amp;photo=031014">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1202-08-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(44.103000000000002,-121.768)
883	Bachelor	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bachelor</b></font><br /><font size="5"><b>Oregon (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/031025.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2763 m<br /><b>Latitude:</b> 43.979&deg;N<br /><b>Longitude:</b> 121.688&deg;W</td></tr><tr><td colspan="2"><p align="justify">The 25-km-long Mount Bachelor volcanic chain consists of a symmetrical late-Pleistocene to Holocene stratovolcano SE of South Sister volcano and a roughly N-S-trending chain of scoria cones and small shield volcanoes.  The youthful basaltic-andesite and basaltic Mount Bachelor volcanic chain was formed in four eruptive episodes dating back to about 18,000-15,000 years before present (BP).  Construction of the NNW-SSE scoria cone chain south of Mount Bachelor was completed by about 12,000 years BP.  The 2763-m-high Mount Bachelor (formerly known as Bachelor Butte) on the north topographically dominates the chain and is one of its youngest features.  The latest activity from the chain produced early Holocene lava flows from Egan scoria cone on the north flank of Mount Bachelor that slightly preceded the eruption of the Mazama ash from Crater Lake about 6850 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1202-09-&amp;volpage=photos&amp;photo=031025">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1202-09-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(43.978999999999999,-121.688)
884	Davis Lake	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Davis Lake</b></font><br /><font size="5"><b>Oregon (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/031030.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 2163 m<br /><b>Latitude:</b> 43.57&deg;N<br /><b>Longitude:</b> 121.82&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Davis Lake area contains three andesitic Holocene cinder cones and associated fresh-looking lava flows along a N-S line at the feet of a group of Pleistocene basaltic-andesite shield volcanoes east of the crest of the Cascade Range, south of the Mount Bachelor volcanic chain.  The northernmost lava flow created a natural barrier forming Davis Lake and lies at the western base of the Pleistocene Davis Mountain shield volcano and at the SW end of Wickiup Reservoir.  The two southern flows are located in a flat-lying area straddling Crescent Creek between Hamner and Odell Buttes.  The middle lava flow was erupted from a small breached cinder cone on the lower southern flank of Hamner Butte and was radiocarbon dated at 4740 years before present.  The southernmost lava flow originated from a cone at the ENE base of Odell Butte.  All three lava flows were probably erupted at about the same time.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1202-10-&amp;volpage=photos&amp;photo=031030">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1202-10-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(43.57,-121.81999999999999)
885	Newberry	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Newberry</b></font><br /><font size="5"><b>Oregon (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/107005.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2434 m<br /><b>Latitude:</b> 43.722&deg;N<br /><b>Longitude:</b> 121.229&deg;W</td></tr><tr><td colspan="2"><p align="justify">Newberry volcano, situated east of the Cascade Range, is one of the largest volcanoes in the conterminous United States, covering an area of about 1600 sq km.  The low-angle basaltic to basaltic-andesite shield volcano is dotted with more than 400 cinder cones; however Newberry has also produced major silicic eruptions associated with formation of a 6 x 8 km wide summit caldera containing two caldera lakes.  The earliest eruptive products (&lt;0.73 million years ago) (Ma) consist of a sequence of ash-flow and airfall tuffs.  Caldera collapse is thought to be associated with major ash flows emplaced about 0.5 and 0.3-0.5 Ma.  these eruptions were preceded by the emplacement of numerous mafic cones and vents and silicic lava domes and flows, many of which are aligned NNW and NNE parallel to regional fault zones.  A rhyolitic magma chamber has been present throughout the Holocene.  Six major eruptive episodes from the early Holocene to about 1300 years ago have included both the eruption of basaltic lava flows from flank vents and the explosive ejection of rhyolitic pumice and pyroclastic flows and the extrusion of obsidian flows within the caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1202-11-&amp;volpage=photos&amp;photo=107005">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1202-11-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(43.722000000000001,-121.229)
886	Crater Lake	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Crater Lake</b></font><br /><font size="5"><b>Oregon (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/031089.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2487 m<br /><b>Latitude:</b> 42.93&deg;N<br /><b>Longitude:</b> 122.12&deg;W</td></tr><tr><td colspan="2"><p align="justify">The spectacular 8 x 10 km Crater Lake caldera in the southern Cascades of Oregon formed about 6850 years ago as a result of the collapse of a complex of overlapping shield and stratovolcanoes known as Mount Mazama.  The cone-building stage, during which at least five andesitic and dacitic shields and stratovolcanoes were constructed, took place between about 420 and 40 thousand years ago (ka).  A series of rhyodacitic lava domes and flows and associated pyroclastic rocks were erupted between about 30 ka and the climactic eruption.  The explosive eruptions triggering collapse of the 8-10 km wide caldera about 7500 years ago were among Earth's largest known Holocene eruptions, distributing tephra as far away as Canada and producing pyroclastic flows that traveled 40 km from the volcano.  A 5-km-wide ring fracture zone is thought to mark the original collapse diameter.  The deep blue waters of North America's second deepest lake, at 600 m, fill the caldera to within 150-600 m of its rim.  Post-caldera eruptions within a few hundred years of caldera formation constructed a series of small lava domes on the caldera floor, including the partially subaerial Wizard Island cinder cone, and the completely submerged Merriam Cone.  The latest eruptions produced a small rhyodacitic lava dome beneath the lake surface east of Wizard Island about 4200 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1202-16-&amp;volpage=photos&amp;photo=031089">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1202-16-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(42.93,-122.12)
887	Jordan Craters	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Jordan Craters</b></font><br /><font size="5"><b>Oregon (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/102095.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 1473 m<br /><b>Latitude:</b> 43.147&deg;N<br /><b>Longitude:</b> 117.460&deg;W</td></tr><tr><td colspan="2"><p align="justify">Jordan Craters volcanic field consists of well-preserved basaltic lava flows and scoria cones that are the youngest and northernmost of a group of three Quaternary lava fields covering an area of 250 sq km in SE Oregon.  The Pleistocene 1473-m-high Clarks Butte shield volcano and Rocky Butte (Lava Butte) lava fields lie to the south, along the trend of regional Basin and Range faulting.  Jordan Craters lie on the Owyhee-Oregon plateau at the SE end of a series of widely scattered young volcanic fields extending SE from Bend, Oregon.  Coffeepot Crater at the NW end of the lava field was the source about 3200 years ago of one of Oregon's youngest lava flows, which covered 75 sq km with 1.6 cu km of olivine-basaltic pahoehoe.  The flows dammed local drainages, forming the two small Upper and Lower Cow Lakes at the SE end of the lava field.  Jordan Craters is renowned for its excellent exposures of a wide variety of youthful lava-flow features and has similarities to Holocene basaltic flows of Idaho's Snake River Plain to the east.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1202-19-&amp;volpage=photos&amp;photo=102095">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1202-19-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(43.146999999999998,-117.45999999999999)
888	Shasta	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Shasta</b></font><br /><font size="5"><b>California (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/032010.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 4317 m<br /><b>Latitude:</b> 41.409&deg;N<br /><b>Longitude:</b> 122.193&deg;W</td></tr><tr><td colspan="2"><p align="justify">The most voluminous of the Cascade volcanoes, northern California's Mount Shasta is a massive compound stratovolcano composed of at least four main edifices constructed over a period of at least 590,000 years.  An ancestral Shasta volcano was destroyed by one of Earth's largest known Quaternary subaerial debris avalanches, which filled the Shasta River valley NW of the volcano.  The Hotlum cone, forming the present summit, and the Shastina lava dome complex were constructed during the early Holocene, as was the SW flank Black Butte lava dome.  Eruptions from these vents have produced pyroclastic flows and mudflows that affected areas as far as 20 km from the summit.  Eruptions from Hotlum cone continued throughout the Holocene.  Shasta's only historical eruption was observed from the ship of the explorer La Perouse off the California coast in 1786.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1203-01-&amp;volpage=photos&amp;photo=032010">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1203-01-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(41.408999999999999,-122.193)
889	Medicine Lake	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Medicine Lake</b></font><br /><font size="5"><b>California (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/032031.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2412 m<br /><b>Latitude:</b> 41.611&deg;N<br /><b>Longitude:</b> 121.554&deg;W</td></tr><tr><td colspan="2"><p align="justify">Medicine Lake is a large Pleistocene-to-Holocene, basaltic-to-rhyolitic shield volcano east of the main axis of the Cascade Range.  Medicine Lake volcanism, similar in style to that of Newberry volcano in Oregon, began less than one million years ago.  A roughly 7 x 12 km caldera truncating the summit contains a lake that gives the volcano its name.  A series of young eruptions lasting a few hundred years began about 10,500 years before present (BP) and produced 5 cu km of basaltic lava.  Eruptive activity resumed 6000 years later, producing a chemically varied group of basaltic lava flows from flank vents and silicic obsidian flows from vents within the caldera and on the upper flanks.  The last eruption produced the massive Glass Mountain obsidian flow on the east flank about 900 years BP.  Lava Beds National Monument on the northern flank of Medicine Lake shield volcano contains hundreds of lava-tube caves displaying a variety of spectacular lava-flow features, most of which are found in the voluminous Mammoth Crater lava flow, which extends in several lobes up to 24 km from the vent.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1203-02-&amp;volpage=photos&amp;photo=032031">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1203-02-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(41.610999999999997,-121.554)
890	Lassen Volcanic Center	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Lassen Volcanic Center</b></font><br /><font size="5"><b>California (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/032058.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 3187 m<br /><b>Latitude:</b> 40.492&deg;N<br /><b>Longitude:</b> 121.508&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Lassen volcanic center consists of the andesitic Brokeoff stratovolcano SW of Lassen  Peak, a dacitic lava dome field, and peripheral small andesitic shield volcanoes and large lava flows, primarily on the Central Plateau NE of Lassen Peak.  A series of eruptions from Lassen Peak from 1914 to 1917 marks the most recent eruptive activity in the southern Cascade Range.  Activity spanning 600,000 years began with construction of Brokeoff stratovolcano.  Beginning 400,000 years ago activity shifted to the north flank of Brokeoff, where episodic, more silicic eruptions produced a field of a dozen dacitic lava domes including Bumpass Mountain, Mount Helen, Ski Heil Peak, and Reading Peak.  At least 12 eruptive episodes took place during the past 100,000 years, with Lassen Peak being constructed about 28,000 years ago.  The Chaos Crags dome complex was constructed about 1100-1000 years ago north of Lassen Peak.  The Cinder Cone complex NE of Lassen Peak was erupted in a single episode several hundred years before present and is considered part of the Lassen volcanic center (Clynne et al., 2000).  The 1914-1917 eruptions of Lassen Peak began with phreatic eruptions and included emplacement of a small summit lava dome, subplinian explosions, mudflows, and pyroclastic flows.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1203-08-&amp;volpage=photos&amp;photo=032058">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1203-08-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(40.491999999999997,-121.508)
891	Clear Lake	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Clear Lake</b></font><br /><font size="5"><b>California (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/066058.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 1439 m<br /><b>Latitude:</b> 38.97&deg;N<br /><b>Longitude:</b> 122.77&deg;W</td></tr><tr><td colspan="2"><p align="justify">The late-Pliocene to early Holocene Clear Lake volcanic field in the northern Coast Ranges, contains lava dome complexes, cinder cones, and maars of basaltic-to-rhyolitic composition.  The westernmost site of Quaternary volcanism in California, the Clear Lake field is located far to the west of the Cascade Range in a complex geologic setting within the San Andreas transform fault system.  Mount Konocti, a composite dacitic lava dome on the south shore of Clear Lake, is the largest volcanic feature.  Volcanism has been largely non-explosive, with only one major airfall tuff and no ash flows.  The latest eruptive activity, forming maars and cinder cones along the shores of Clear Lake, continued until about 10,000 years ago.  A large silicic magma chamber provides the heat source for the Geysers, the world's largest producing geothermal field.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1203-10-&amp;volpage=photos&amp;photo=066058">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1203-10-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(38.969999999999999,-122.77)
892	Mono Lake Volcanic Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mono Lake Volcanic Field</b></font><br /><font size="5"><b>California (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/062098.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2121 m<br /><b>Latitude:</b> 38.00&deg;N<br /><b>Longitude:</b> 119.03&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Mono Lake volcanic field east of Yosemite National Park and north of the Mono Craters consists of vents within Mono Lake and on its north shore.  The most topographically prominent feature, Black Point, is an initially sublacustral basaltic cone that rises above the NW shore and was formed about 13,300 years ago when Mono Lake was higher.  Holocene rhyodacitic lava domes and flows form Negit and parts of Paoha islands off the northern shore and center of the lake, respectively.  The most recent eruptive activity in the Long Valley to Mono Lake region took place 100-230 years ago, when lake-bottom sediments forming much of Paoha Island were uplifted by intrusion of a rhyolitic cryptodome (Stine, in Bailey et al. 1989).   Spectacular tufa towers line the shores of Mono Lake.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1203-11-&amp;volpage=photos&amp;photo=062098">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1203-11-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://lvo.wr.usgs.gov/">Long Valley Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(38,-119.03)
893	Mono Craters	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mono Craters</b></font><br /><font size="5"><b>California (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/032079.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Tuff rings</td><td width="50%" align="left"><b>Summit Elev:</b> 2796 m<br /><b>Latitude:</b> 37.88&deg;N<br /><b>Longitude:</b> 119.00&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Mono Craters, lying on the eastern side of the Sierra Nevada between Mono Lake and Long Valley caldera, form an arcuate, 17-km-long group of 30 or more dominantly rhyolitic lava domes, lava flows, and tephra rings.  The partially overlapping dike-fed domes were erupted near the margin of a pull-apart basin on the east side of the Sierra Nevada.  Explosive eruptions began more than 50,000 years ago from now-buried vents, but almost all of the exposed domes and flows are of Holocene age.  Activity has propagated both north and south from the center of the chain during the late Holocene.  The latest eruptions occurred about 600 years ago, nearly contemporaneously with the eruptions from Inyo Craters to the south, producing a series of tephra rings and obsidian lava domes and flows at the northern end of the chain accompanied by eruption of locally extensive tephra layers.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1203-12-&amp;volpage=photos&amp;photo=032079">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1203-12-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://lvo.wr.usgs.gov/">Long Valley Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(37.880000000000003,-119)
894	Inyo Craters	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Inyo Craters</b></font><br /><font size="5"><b>California (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/032083.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Explosion craters</td><td width="50%" align="left"><b>Summit Elev:</b> 2629 m<br /><b>Latitude:</b> 37.692&deg;N<br /><b>Longitude:</b> 119.02&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Inyo Craters are a 12-km-long chain of silicic lava domes, lava flows, and explosion craters along the eastern margin of Sierra Nevada south of Mono Craters near the town of Mammoth.  Inyo Craters overtop the NW rim of the Pleistocene Long Valley caldera and extend onto the caldera floor, but are chemically and magmatically part of a different volcanic system.  Postglacial explosion pits of Mammoth Mountain to the south are an extension of Inyo Craters (Bailey 1980).  The latest eruptions at Inyo Craters took place about 600 years ago, when explosive eruptions accompanied formation of the South Deadman, Obsidian Flow, and Glass Creek rhyolitic lava domes and lava flows.  The Inyo Crater Lakes are small phreatic craters that formed during this eruption on the south flank of the Pleistocene Deer Mountain rhyolite dome of the Long Valley caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1203-13-&amp;volpage=photos&amp;photo=032083">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1203-13-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://lvo.wr.usgs.gov/">Long Valley Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(37.692,-119.02)
895	Mammoth Mountain	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mammoth Mountain</b></font><br /><font size="5"><b>California (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/067024.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3369 m<br /><b>Latitude:</b> 37.631&deg;N<br /><b>Longitude:</b> 119.032&deg;W</td></tr><tr><td colspan="2"><p align="justify">Mammoth Mountain, a trachydacitic lava-dome complex, lies on the SW topographic rim of Long Valley caldera.  The 3369-m-high volcano lies west of the structural rim of the caldera and is considered to represent a magmatic system distinct from Long Valley caldera and the Inyo Craters (Hildreth, 2004).  The latest magmatic eruptions at Mammoth Mountain took place about 57,000 years ago.  Mammoth Mountain is surrounded by at least 35 mafic vents that are part of the same magmatic system and include Red Cones, two closely spaced basaltic cinder cones located SW of Mammoth Mountain and SE of Devils Postpile National Monument.  The cones, whose name derives from colorful mantling scoria deposits, are unglaciated and were radiocarbon dated at about 8900 years ago.  Phreatic eruptions, distinct from those at South Inyo Craters, took place about 700 years ago from vents on the north side of Mammoth Mountain.  Recent unrest, including seismicity, gas emission, and tree kill, is thought to be related to dike intrusion beneath Mammoth Mountain in 1989.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1203-15-&amp;volpage=photos&amp;photo=067024">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1203-15-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://lvo.wr.usgs.gov/">Long Valley Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(37.631,-119.032)
896	Ubehebe Craters	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ubehebe Craters</b></font><br /><font size="5"><b>California (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/033005.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Maars<br />&nbsp;&nbsp;&nbsp; Tuff rings</td><td width="50%" align="left"><b>Summit Elev:</b> 752 m<br /><b>Latitude:</b> 37.02&deg;N<br /><b>Longitude:</b> 117.45&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Ubehebe Craters consist of an isolated group of overlapping maars formed during eruptions of alkali basalt along a fault cutting fanglomerate deposits on the flanks of Tin Mountain in Death Valley National Park.  Ubehebe Crater is a 0.8-km-wide, 235-m-deep maar surrounded by a tuff ring.  Little Hebe Crater, the second youngest vent, is located immediately south of Ubehebe Crater and is a small tuff cone with a 100-m-wide crater overlain by pyroclastic-surge deposits.  At least a dozen craters are located within an area of 3 sq km, and bedded pyroclastic-surge deposits cover an area of 15 sq km.  Early scoria cone formation was followed by hydrovolcanic explosions that formed two clusters of explosion craters and tuff rings.  The age of volcanism at Ubehebe is not dated precisely, but the lack of erosional modification of pyroclastic-surge deposits suggests that the youngest activity, from the largest crater, Ubehebe Crater, is Holocene in age.  Relationships between Ubehebe tephra and approximately dated archeological artifacts suggests an age of about 6000 years.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1203-16-&amp;volpage=photos&amp;photo=033005">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1203-16-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(37.020000000000003,-117.45)
897	Golden Trout Creek	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Golden Trout Creek</b></font><br /><font size="5"><b>California (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/102044.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 2886 m<br /><b>Latitude:</b> 36.358&deg;N<br /><b>Longitude:</b> 118.32&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Golden Trout Creek volcanic field consists of a group of Quaternary alkali olivine basaltic cinder cones and lava flows in the Toowa valley of the Sierra Nevada about 25 km south of Mount Whitney.  Lava flows from the Golden Trout Creek volcanic field erupted through Mesozoic granitic rocks of the Sierra Nevada batholith during several episodes dating back to about 743,000 years ago, when the Little Whitney cinder cone and lava flows were erupted.  The South Fork cone was erupted about 176,000 years ago and produced the largest lava flow of the volcanic field, which traveled 10 km to the west, possibly as far as the floor of Kern Canyon.  Tunnel cone to the north of South Fork (Red Hill) cone is undated, but its lava flow is overlain by glacial deposits and it is thought to be only slightly younger than South Fork cone.  The youngest lava flow, from Groundhog cone, is unglaciated and thought to be about 5-10,000 years old (Moore and Lanphere 1983).  The lava flow from Groundhog cone traveled 6 km west down Golden Trout Creek on top of the older flow from South Fork cone.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1203-17-&amp;volpage=photos&amp;photo=102044">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1203-17-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(36.357999999999997,-118.31999999999999)
898	Salton Buttes	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Salton Buttes</b></font><br /><font size="5"><b>California (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120100.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> -40 m<br /><b>Latitude:</b> 33.20&deg;N<br /><b>Longitude:</b> 115.62&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Salton Buttes consist of five small rhyolitic lava domes extruded onto Quaternary sediments of the Colorado River delta within the Salton Sea geothermal field at the SE margin of the Salton Sea.  The summit of The age of the Salton Buttes has variously been considered to be late Pleistocene or early Holocene based on different dating techniques.  Recent dating of young zircons (which typically crystallize prior to eruption) at 10,300 +/- 1000 years Before Present (BP) is consistent with early Holocene hydration rind dates from Obsidian Butte.  Wave-cut benches originating from Lake Cahuilla, which existed from about 20,500 to 3000 BP prior to the 20th century formation of the Salton Sea due to an accidental spill-over of the Colorado River, are found on all of the domes.  Older, sediment-buried Pleistocene rhyolitic lava domes have been found in geothermal drill holes.  The Salton Sea geothermal field produces saline geothermal brines.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1203-20-&amp;volpage=photos&amp;photo=120100">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1203-20-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(33.200000000000003,-115.62)
899	Shoshone Lava Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Shoshone Lava Field</b></font><br /><font size="5"><b>Idaho (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/102092.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1478 m<br /><b>Latitude:</b> 43.18&deg;N<br /><b>Longitude:</b> 114.35&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Shoshone lava field is the westernmost of the young lava fields of the Snake River Plain.  It lies north of Twin Falls, Idaho and created an L-shaped lava flow 2-to-5 km in width that extends 60 km south and then west.   A single radiocarbon age of 10,130 +/- 350 years obtained for lava flows from the Shoshone field straddles the Pleistocene-Holocene boundary (Kuntz et al. 1986).  Black Butte Crater caps a lava shield that lies at the NE end of the flow field.  The vent area contains a complex lava lake that  forms a 6-part flower-petal like depression with steep-sided walls up to 30 m high that covers an area of 2 sq km.  A lava tube and channel system extends 5 km SE of Black Butte Crater and displays both roofed and collapsed portions.  The Big Wood and Little Wood rivers follow the northern and southern margins of the distal part of the lava flow, respectively.  The voluminous flow diverted the river channels so that they now join 40 km west of their former confluence.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1204-01-&amp;volpage=photos&amp;photo=102092">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1204-01-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(43.18,-114.34999999999999)
900	Craters of the Moon	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Craters of the Moon</b></font><br /><font size="5"><b>Idaho (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/033019.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 2005 m<br /><b>Latitude:</b> 43.42&deg;N<br /><b>Longitude:</b> 113.50&deg;W</td></tr><tr><td colspan="2"><p align="justify">Craters of the Moon, the largest lava field of the Snake River Plain, covers about 1600 sq km with more than 60 mappable lava flows erupted from eight fissure systems.  About 25 cinder cones up to 250-m high formed primarily along a 45-km-long segment of the Great Rift, the principal 2-8 km wide fissure system that trends NW-SE through Craters of the Moon National Monument.  Craters of the Moon lies at the NW part of the eastern Snake River Plain, and the northern part of the field laps up against the White Knob and Pioneer Mountains.  The lava field was formed during eight eruptive episodes between about 15,000 and 2000 years ago separated by quiescent periods up to about 3000 years in duration.  This contrasts with other Snake River Plain lava fields, which were formed during single eruptive episodes of relatively short duration.  A complex assemblage of basaltic volcanic features is found at Craters of the Moon, and cinder cones are common, in contrast to other Snake River Plain lava fields.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1204-02-&amp;volpage=photos&amp;photo=033019">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1204-02-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(43.420000000000002,-113.5)
901	Wapi Lava Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Wapi Lava Field</b></font><br /><font size="5"><b>Idaho (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/102068.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 1604 m<br /><b>Latitude:</b> 42.88&deg;N<br /><b>Longitude:</b> 113.22&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Wapi lava field, SE of the Craters of the Moon, covers about 325 sq km, and consists of a low shield volcano formed during an eruption about 2250 years ago that produced about 6 cu km of fluid pahoehoe lava flows.  The small King's Bowl rift immediately to the north was also formed at about the same time along a central eruptive fissure flanked by two parallel non-eruptive fissures.  This eruption produced a phreatic explosion that created Kings Bowl, an 80-m-long, 30-m-deep explosion crater.  Eruptions of the Wapi lava field also overlapped with the last eruptive period of the Craters of the Moon lava field.  The vent area of the Wapi field lies along the Great Rift of the Craters of the Moon and consists of five major and a half dozen minor vents covering an area of 0.5 sq km.  The largest of the vents contains several pit craters that truncate lava lakes that filled the crater.  Pillar Butte, a mass of layered lava flows and agglutinates, forms the high point of the lava shield.  The Split Butte maar to the west is partially overlapped by flows of the Wapi lava field.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1204-03-&amp;volpage=photos&amp;photo=102068">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1204-03-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(42.880000000000003,-113.22)
902	Hell's Half Acre	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hell's Half Acre</b></font><br /><font size="5"><b>Idaho (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/102083.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 1631 m<br /><b>Latitude:</b> 43.50&deg;N<br /><b>Longitude:</b> 112.45&deg;W</td></tr><tr><td colspan="2"><p align="justify">Hell's Half Acre lava field, the easternmost of the young basaltic lava fields of the Snake River Plain, covers an area of about 400 sq km SW of Idaho Falls and is the 2nd largest of the Snake River Plain.   Basaltic lavas forming the broad, low shield volcano are dominantly pahoehoe flows that were erupted from a 3-km-long, NW-SE trending vent system at the NW part of the field during a brief eruptive episode about 5200 years ago.  The summit vent area contains an irregular, elongate 0.8 x 0.3 km wide central depression that was the site of a former lava lake that fed late-stage flows.  About 10 circular pit craters truncate the surface of the lava lake, and two prominent lava tube systems are located near the summit vent complex.  Two major lava flow lobes, each about 5 km wide and 10 km long, extend to the south and SW along the flood plain of the Snake River and surround Morgans Pasture, a large kipuka.  Interstate 15 highway crosses the SE margin of the lava field SW of the city of Idaho Falls.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1204-04-&amp;volpage=photos&amp;photo=102083">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1204-04-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(43.5,-112.45)
903	Yellowstone	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Yellowstone</b></font><br /><font size="5"><b>Wyoming (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/033039.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2805 m<br /><b>Latitude:</b> 44.43&deg;N<br /><b>Longitude:</b> 110.67&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Yellowstone Plateau volcanic field developed through three volcanic cycles spanning two million years that included some of the world's largest known eruptions.  Eruption of the &gt;2450 cu km Huckleberry Ridge Tuff about 2.1 million years ago created the more than 75-km-long Island Park caldera.  The second cycle concluded with the eruption of the Mesa Falls Tuff around 1.3 million years ago, forming the 16-km-wide Henrys Fork caldera at the western end of the first caldera.  Activity subsequently shifted to the present Yellowstone Plateau and culminated 640,000 years ago with the eruption of the &gt;1000 cu km Lava Creek Tuff and the formation of the present 45 x 85 km caldera.  Resurgent doming subsequently occurred at both the NE and SW sides of the caldera and voluminous (1000 cu km) intracaldera rhyolitic lava flows were erupted between 150,000 and 70,000 years ago.  No magmatic eruptions have occurred since the late Pleistocene, but large hydrothermal eruptions took place near Yellowstone Lake during the Holocene.  Yellowstone is presently the site of one of the world's largest hydrothermal systems including Earth's largest concentration of geysers.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1205-01-&amp;volpage=photos&amp;photo=033039">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1205-01-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/yvo/">Yellowstone Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(44.43,-110.67)
904	Soda Lakes	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Soda Lakes</b></font><br /><font size="5"><b>Nevada (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/118007.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Maars<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1251 m<br /><b>Latitude:</b> 39.53&deg;N<br /><b>Longitude:</b> 118.87&deg;W</td></tr><tr><td colspan="2"><p align="justify">Two lake-filled maars, Soda Lake and Little Soda Lake, lie NW of the town of Fallon.  The basaltic maars were formed subaerially, post-dating the Pleistocene glacial Lake Lahontan, and were estimated to be less than 10,000 years old and perhaps even less than 1500 years old (Garside and Schilling, 1979; Price and LaPointe, 1998).  The larger maar, Soda Lake, is about 1.3 x 2 km wide and is elongated in a NE-SW direction.  The 300-m-wide Little Soda Lake lies south of Soda Lake.  The late-Pleistocene Upsal Hogback cones lie to the NNE of Soda Lakes.  The maars are the site of a geothermal prospect that may have discharged hot springs through the end of the 19th century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1206-01-&amp;volpage=photos&amp;photo=118007">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1206-01-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(39.530000000000001,-118.87)
905	Bald Knoll	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bald Knoll</b></font><br /><font size="5"><b>Utah (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/102067.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2135 m<br /><b>Latitude:</b> 37.328&deg;N<br /><b>Longitude:</b> 112.408&deg;W</td></tr><tr><td colspan="2"><p align="justify">Bald Knoll is the youngest of a group of basaltic cinder cones on the SW part of the Paunsaugunt Plateau in southern Utah, between the southern end of Bryce Canyon National Park and the western margin of Grand Staircase-Escalante National Monument.  The 2135-m-high Bald Knoll has a well-preserved crater and produced a massive youthful-looking lava flow that traveled about 12 km to the SSE.  The olivine-basaltic flow fills the floor of Johnson Valley south of Bald Knoll and reaches beyond Ford Pasture into Johnson Canyon.  No precise age for the flow is available, but it was estimated to be several hundred to several thousand years old (Gregory, 1951; Davis and Pollock, 2003).  Buck Knoll and Black Knoll (also known as Corral Knoll) are cinder cones to the west that lie on the western side of Kanab Creek and produced lava flows that traveled as far as 22 km down the Kanab valley.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1207-03-&amp;volpage=photos&amp;photo=102067">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1207-03-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(37.328000000000003,-112.408)
906	Markagunt Plateau	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Markagunt Plateau</b></font><br /><font size="5"><b>Utah (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/055002.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 2840 m<br /><b>Latitude:</b> 37.58&deg;N<br /><b>Longitude:</b> 112.67&deg;W</td></tr><tr><td colspan="2"><p align="justify">A group of basaltic cinder cones and lava vents on the Markagunt Plateau east of Cedar Breaks National Monument in SW Utah has produced youthful, sparsely vegetated lava flows.  Products of an older episode of volcanism producing trachytic, andesitic and rhyolitic lavas were succeeded by basaltic lavas of two different ages.  Several lines of NE-SW-trending cinder cones occur within the volcanic field, with the youngest flows being located near Panguitch Lake on the north and Navajo Lake on the south.  Navajo Lake formed when a thick, blocky flow from a nearby vent dammed Duck Creek.  Young lava flows, many of which are fissure fed, have distinct margins and covered or diverted stream drainages, which have for the most part not been reestablished across the flows.  The oldest trees on the youngest flows are about 900 years old (Gregory, 1949).  Native American legends note &quot;smoking hills&quot; in the Panguitch Lake area.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1207-04-&amp;volpage=photos&amp;photo=055002">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1207-04-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(37.579999999999998,-112.67)
907	Black Rock Desert	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Black Rock Desert</b></font><br /><font size="5"><b>Utah (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/045092.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 1800 m<br /><b>Latitude:</b> 38.97&deg;N<br /><b>Longitude:</b> 112.50&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Black Rock Desert volcanic field consists of a group of closely spaced small volcanic fields of Pleistocene-to-Holocene age in the Black Rock and Sevier deserts of south-central Utah, at the eastern margin of the Great Basin.  The Black Rock Desert field contains both Utah's youngest known rhyolite dome (0.4 million years old) and its youngest eruptive vent, which produced the roughly 660-year-old Ice Springs lava flows.  The broader Black Rock Desert volcanic field includes the smaller Deseret, Pavant, Kanosh, Tabernacle, Ice Spring, and northern Black Rock Desert volcanic fields.  The Pavant Butte and Tabernacle Hill tuff cones were erupted about 16,000 and 14,000 years ago through the waters of glacial Lake Bonneville.   Lava flows from the Ice Springs crater complex traveled about 4 km to the west and north, overlapping late-Pleistocene flows from Pavant Butte.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1207-05-&amp;volpage=photos&amp;photo=045092">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1207-05-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(38.969999999999999,-112.5)
908	Dotsero	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Dotsero</b></font><br /><font size="5"><b>Colorado (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/081066.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Maar<br />&nbsp;&nbsp;&nbsp; Scoria cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2230 m<br /><b>Latitude:</b> 39.661&deg;N<br /><b>Longitude:</b> 107.035&deg;W</td></tr><tr><td colspan="2"><p align="justify">A small maar and scoria cone complex at Dotsero, near the junction of the Colorado and Eagle Rivers west of the Gore Range, is the only Holocene volcano in Colorado.  Although Interstate highway 70 cuts across a lava flow from Dotsero, this volcanic center is one of the least known in the western United States.  The most prominent feature of the Dotsero complex is a 700 m wide and 400 m deep maar that was erupted about 4150 radiocarbon years ago along a ridge consisting of evaporites and reddish oxidized sandstones of Pennsylvanian age.  Small scoria cones were constructed along a NNE-SSW line on either side of the maar.  Small lahars preceded eruption of a basaltic lava flow that traveled 3 km down two narrow V-shaped valleys and spread out onto the floodplain of the Eagle River, diverting the river to the south side of the valley.  Older Pleistocene basaltic lava flows occur nearby at Willow Peak, McCoy, and Triangle Peak.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1208-01-&amp;volpage=photos&amp;photo=081066">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1208-01-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(39.661000000000001,-107.035)
909	Uinkaret Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Uinkaret Field</b></font><br /><font size="5"><b>Arizona (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/087073.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 1555 m<br /><b>Latitude:</b> 36.38&deg;N<br /><b>Longitude:</b> 113.13&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Uinkaret volcanic field straddling the Grand Canyon contains cinder cones that have produced lava flows that repeatedly cascaded into the Grand Canyon, forming temporary lava dams up to 200 m high.  Two of the most prominent landmarks are Vulcan's Throne, a cinder cone on the north rim, and Vulcan's Forge, a small volcanic neck erupted within the Colorado River, 1000 m below.  Most of the Uinkaret field lies north of the Grand Canyon on the Uinkaret Plateau between the Toroweap and Hurricane faults.   The Uinkaret volcanic field is largely Pleistocene in age, and Vulcan's Throne has a cosmogenic helium age of about 73,000 years.  Volcanic activity has continued into the Holocene.  One lava flow, from Little Springs, south of Pliocene Mount Trumbull, has a cosmogenic helium age of 1300 +/- 500 years BP.  Pottery sherds dated at between 1050 and 1200 AD were found within the Little Springs lava flow, which occurred about the same time as the Sunset Crater eruption in the San Francisco volcanic field to the SE.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1209-01-&amp;volpage=photos&amp;photo=087073">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1209-01-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(36.380000000000003,-113.13)
910	Sunset Crater	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sunset Crater</b></font><br /><font size="5"><b>Arizona (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/033077.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cone<br />&nbsp;&nbsp;&nbsp; Fissure vent</td><td width="50%" align="left"><b>Summit Elev:</b> 2447 m<br /><b>Latitude:</b> 35.37&deg;N<br /><b>Longitude:</b> 111.50&deg;W</td></tr><tr><td colspan="2"><p align="justify">Sunset Crater, named for its brilliantly colored scoria deposits mantling the cone, is the youngest of the more than 550 vents of the vast San Francisco volcanic field in northern Arizona.  The eruptions forming the 340-m-high Sunset Crater cinder cone were initially considered from tree-ring dating to have begun between the growing seasons of 1064-1065 AD; however, more recent paleomagnetic evidence places the onset of the eruption sometime between about 1080 and 1150 AD.   The largest vent of the eruption, Sunset Crater itself, was the source of the Bonito and Kana-a lava flows that extended about 2.5 km NW and 9.6 km NE, respectively.  Additional vents along a 10-km-long fissure extending SE produced small spatter ramparts and a 6.4-km-long lava flow to the east.  The Sunset Crater eruption produced a blanket of ash and lapilli covering an area of more than 2100 sq km and forced the abandonment of settlements of the indigenous Sinagua Indians.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1209-02-&amp;volpage=photos&amp;photo=033077">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1209-02-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(35.369999999999997,-111.5)
911	Carrizozo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Carrizozo</b></font><br /><font size="5"><b>New Mexico (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/081088.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1731 m<br /><b>Latitude:</b> 33.78&deg;N<br /><b>Longitude:</b> 105.93&deg;W</td></tr><tr><td colspan="2"><p align="justify">The massive Carrizozo lava flow, which traveled 75 km down the Tularosa Basin of south-central New Mexico, is one of Earth's longest known Holocene lava flows.  The youthful-looking basaltic flow originated from a broad low basaltic shield on the floor of the Tularosa Basin, east of the Rio Grande Rift, topped by Little Black Peak, a small cinder cone.  The 4.2 cu km tube-fed pahoehoe flow covered 330 sq km and has a width that ranges from 1 km in the central neck region to 5 km in the proximal and distal portions.  The flow was inferred to have been emplaced during a single long-duration eruption estimated to have lasted 2-3 decades.  A surface exposure age of about 5200 years Before Present was obtained for the Carrizozo lava flow, the second youngest in New Mexico.  An older lava flow traveled 16 km south and 11 km east from Broken Back crater.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1210-01-&amp;volpage=photos&amp;photo=081088">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1210-01-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(33.780000000000001,-105.93000000000001)
912	Zuni-Bandera	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Zuni-Bandera</b></font><br /><font size="5"><b>New Mexico (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/033087.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 2550 m<br /><b>Latitude:</b> 34.80&deg;N<br /><b>Longitude:</b> 108.00&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Zuni-Bandera volcanic field covers an area of 2460 sq km along the Jemez lineament west of the Rio Grande Rift.  An older volcanic episode, mostly from vents along the Chain of Craters, took place from about 3.8-3.7 million years ago (Ma); the younger episode began about 1.7 Ma and has continued until the present, forming an extensive area of young lava flows known as El Malpais.  The youngest lava flow, the McCartys flow, traveled 60 km to the NE, fed by lava tubes up to 29 km long.  The McCartys flow was recorded in Indian legends and was thought to have been erupted about 1000 years ago, but radiocarbon dating indicates an age of about 3000 years Before Present.  The only other dated flow of Holocene age originated from Bandera Crater during the early Holocene about 9000-10,000 radiocarbon years ago.  An earlier flow, the massive Pleistocene Fence Lake lava flow, traveled as far as 90 km to the west.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1210-02-&amp;volpage=photos&amp;photo=033087">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1210-02-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://vulcan.wr.usgs.gov/">Cascades Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(34.799999999999997,-108)
913	Endeavour Ridge	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Endeavour Ridge</b></font><br /><font size="5"><b>Juan de Fuca Ridge</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/118084.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> -2050 m<br /><b>Latitude:</b> 47.95&deg;N<br /><b>Longitude:</b> 129.10&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Endeavour Ridge lies near the northern end of the Juan de Fuca Ridge, west of the coast of Washington and SW of Vancouver Island.  The northern end of Endeavour Ridge is offset to the east with respect to the West Valley Segment, which extends north to the triple junction with the Sovanco Fracture Zone and the Nootka Fault. The 90-km-long, NNE-SSW-trending Endeavour Ridge segment lies at a depth of more than 2000 m and is the site of  vigorous high-temperature hydrothermal vent systems that were first discovered by scientists in 1981.  Five major vent fields that include sulfide chimneys and black smoker vents, first seen from the submersible vehicle Alvin in 1984, are spaced at about 2-km intervals in a 1-km-wide axial valley at the center of the Endeavour Ridge.   Preliminary uranium-series dates of Holocene age were obtained on basaltic lava flows from Endeavour Ridge, and other younger &quot;zero-age&quot; flows were sampled.  Seismic swarms were detected at the Endeavour Ridge in 1991 and 2005.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1301-01-&amp;volpage=photos&amp;photo=118084">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1301-01-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.pmel.noaa.gov/vents/">NOAA Pacific Marine Environmental Laboratory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(47.950000000000003,-129.09999999999999)
914	Cobb Segment	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cobb Segment</b></font><br /><font size="5"><b>Juan de Fuca Ridge</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> -2100? m<br /><b>Latitude:</b> 46.88&deg;N<br /><b>Longitude:</b> 129.33&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Cobb Segment in the northern part of the Juan de Fuca Ridge, lies south of the Endeavour Ridge segment.  Also known as the Northern Symmetrical or NSymm Segment, the 150-km-long Cobb Segment is the longest of the Juan de Fuca Ridge.  It has a narrow, 1-2 km wide axial crest with a shallow graben that has a high point at a depth of about 2300 m.  A prominent seamount with hydrothermal deposits at its summit lies just west of the axis high and was the source of a broad area of young, mostly sediment-free lava flows.  As with other Juan de Fuca Ridge segments, a shallow magma chamber is thought to underlie the Cobb Segment, and a preliminary uranium-series date of Holocene age was obtained on a basaltic lava flow from the Cobb Segment.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1301-011">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.pmel.noaa.gov/vents/">NOAA Pacific Marine Environmental Laboratory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(46.880000000000003,-129.33000000000001)
915	CoAxial Segment	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>CoAxial Segment</b></font><br /><font size="5"><b>Juan de Fuca Ridge</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/103041.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> -2400 m<br /><b>Latitude:</b> 46.52&deg;N<br /><b>Longitude:</b> 129.58&deg;W</td></tr><tr><td colspan="2"><p align="justify">The CoAxial segment of the Juan de Fuca Ridge is located about 435 km west of the Oregon coast, NE of Axial volcano.  A submarine eruption along the CoAxial segment that produced thermal plumes and a new lava flow was detected by acoustic hydrophones in June 1993, just days after installation of the hydrophone system.  This marked the first deep-sea volcanic eruption that was detected as it was happening.  The location of the eruption was at a depth of about 2400 m, about 37 km NE of Axial volcano.  Bathymetric surveys indicated that one or more additional sea-floor lava extrusions took place immediately to the east of the 1993 lava flow sometime between 1981-82 and 1991.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1301-02-&amp;volpage=photos&amp;photo=103041">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1301-02-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.pmel.noaa.gov/vents/">NOAA Pacific Marine Environmental Laboratory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(46.520000000000003,-129.58000000000001)
916	Axial Seamount	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Axial Seamount</b></font><br /><font size="5"><b>Juan de Fuca Ridge</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/118087.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> -1410 m<br /><b>Latitude:</b> 45.95&deg;N<br /><b>Longitude:</b> 130.00&deg;W</td></tr><tr><td colspan="2"><p align="justify">Axial Seamount rises 700 m above the mean level of the central Juan de Fuca Ridge crest about 480 km west of Cannon Beach, Oregon to within about 1400 m of the sea surface.  The volcano is the most magmatically robust and seismically active site on the Juan de Fuca Ridge between the Blanco Fracture Zone and the Cobb offset.  The summit is marked by an unusual rectangular-shaped caldera (3 x 8 km) that lies between two rift zones.  The caldera is breached to the SE and is defined on three sides by boundary faults of up to 150 m relief.  Hydrothermal vents colonized with biological communities are located near the caldera fault or along the rift zones.  Following the discovery of hydrothermal venting north of the caldera in 1983, a concentrated mapping and sampling effort was made in the mid-late 1980s.  An eruption was detected seismically in January 1998; later mapping revealed a lava flow erupted from a 9-km-long fissure at the southern end of Axial caldera.  The new lava flows were seen to partially bury a seismometer/ pressure gauge and mooring line deployed in 1997.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1301-021&amp;volpage=photos&amp;photo=118087">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1301-021">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.pmel.noaa.gov/vents/">NOAA Pacific Marine Environmental Laboratory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(45.950000000000003,-130)
917	Cleft Segment	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cleft Segment</b></font><br /><font size="5"><b>Juan de Fuca Ridge</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/103037.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> -2140 m<br /><b>Latitude:</b> 44.83&deg;N<br /><b>Longitude:</b> 130.30&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Cleft Segment, the southernmost of the Juan de Fuca Ridge, lies immediately north of the Blanco Fracture Zone.  The 80-km-long segment is named for a nearly continuous 10-km-long, 30-50 m wide cleft at its southern end.  Two episodes of sea-floor spreading have been documented along the northern part of the Cleft Segment in the 1980's.  Bathymetric surveys indicated that a series of discontinuous pillow-lava mounds were extruded along a 17-km-long fissure between 1981 and 1987.  The eruption possibly took place at the time of emission of a large plume of hot mineral-laden water in 1986.  The location is at a depth of about 2300 m near the northern edge of the Cleft segment and the southern end of the Vance segment of the Juan de Fuca Ridge, about 500 km west of the central Oregon coast.  Youthful sheet-lava flows immediately south of the pillow lavas were estimated to be only a few years older.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1301-03-&amp;volpage=photos&amp;photo=103037">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1301-03-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.pmel.noaa.gov/vents/">NOAA Pacific Marine Environmental Laboratory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(44.829999999999998,-130.30000000000001)
918	North Gorda Ridge	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>North Gorda Ridge</b></font><br /><font size="5"><b>Gorda Ridge</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/103042.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> -3000 m<br /><b>Latitude:</b> 42.67&deg;N<br /><b>Longitude:</b> 126.78&deg;W</td></tr><tr><td colspan="2"><p align="justify">The northernmost of five segments of the Gorda Ridge lies immediately south of the Blanco Transform Fault that offsets the Gorda and Juan de Fuca oceanic spreading ridges.  The 65-km-long North Gorda Ridge segment is located about 200 km west of the southern Oregon coast and has deep 5- 10-km-wide valleys at either ends with a shallower narrow axial valley at the center.  This morphology, which in plan view resembles an hourglass, is typical of magmatically active spreading segments.  A submarine lava flow was erupted in late February and early March 1996, near the center of the North Gorda Ridge segment.  The eruption was initially detected through acoustic T-waves from a seismic swarm and the emission of large thermal plumes.  In April submarine cameras revealed new lava flows about 100-200 m wide along a fissure that was at least 3.5 km long.  A seismic swarm of uncertain origin also occurred at this location in January 1998.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1301-031&amp;volpage=photos&amp;photo=103042">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1301-031">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.pmel.noaa.gov/vents/">NOAA Pacific Marine Environmental Laboratory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(42.670000000000002,-126.78)
919	Escanaba Segment	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Escanaba Segment</b></font><br /><font size="5"><b>Gorda Ridge</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/118088.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> -1700? m<br /><b>Latitude:</b> 40.98&deg;N<br /><b>Longitude:</b> 127.50&deg;W</td></tr><tr><td colspan="2"><p align="justify">The linear, N-S-trending Escanaba Segment, the southernmost of the Gorda Ridge, lies immediately north of the Mendocino Francture Zone off the coast of northern California.  The axial crest of the 130-km-long segment, also known as the Escanaba Trough, is about 3-5 km wide at the northern end and increases to 18 km to the south near the junction with the Mendocino Fracture Zone.  The rift valley floor of the slow-spreading Escanaba rift segment lies at about 3200 m depth, bounded by faulted walls about 1500 m high with unusual gold-bearing massive sulfide deposits in sediment hills at the base of the scarps uplifted by volcanic sills or lacoliths.  Thick sediment deposits from the continental margin enter the axial trough from the fracture zone and thin to the north.  A preliminary uranium-series date of Holocene age was obtained from a basaltic lava flow in the axial valley in the less-sedimented northern part of the Escanaba Segment.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1301-04-&amp;volpage=photos&amp;photo=118088">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1301-04-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.pmel.noaa.gov/vents/">NOAA Pacific Marine Environmental Laboratory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(40.979999999999997,-127.5)
920	Loihi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Loihi</b></font><br /><font size="5"><b>Hawaii (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/033100.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava cones</td><td width="50%" align="left"><b>Summit Elev:</b> -975 m<br /><b>Latitude:</b> 18.92&deg;N<br /><b>Longitude:</b> 155.27&deg;W</td></tr><tr><td colspan="2"><p align="justify">Loihi seamount, the youngest volcano of the Hawaiian chain, lies about 35 km off the SE coast of the island of Hawaii.  Loihi (which is the Hawaiian word for &quot;long&quot;) has an elongated morphology dominated by two curving rift zones extending north and south of the summit.  The summit region contains a caldera about 3 x 4 km wide and is dotted with numerous lava cones, the highest of which is about 975 m below the sea surface.  The summit platform includes two well-defined pit craters, sediment-free glassy lava, and low-temperature hydrothermal venting.  An arcuate chain of small cones on the western edge of the summit extends north and south of the pit craters and merges into the crests of Loihi's prominent rift zones.  Deep and shallow seismicity indicate a magmatic plumbing system distinct from that of Kilauea volcano.  During 1996, a new pit crater was formed at the summit of the volcano, and lava flows were erupted.  Continued volcanism is expected to eventually build a new island at Loihi; time estimates for the summit to reach the sea surface range from roughly 10,000 to 100,000 years.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1302-00-&amp;volpage=photos&amp;photo=033100">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1302-00-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://hvo.wr.usgs.gov/">Hawaiian Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(18.920000000000002,-155.27000000000001)
921	Kilauea	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kilauea</b></font><br /><font size="5"><b>Hawaii (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/098069.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1222 m<br /><b>Latitude:</b> 19.421&deg;N<br /><b>Longitude:</b> 155.287&deg;W</td></tr><tr><td colspan="2"><p align="justify">Kilauea volcano, which overlaps the east flank of the massive Mauna Loa shield volcano, has been Hawaii's most active volcano during historical time.  Eruptions of Kilauea are prominent in Polynesian legends; written documentation extending back to only 1820 records frequent summit and flank lava flow eruptions that were interspersed with periods of long-term lava lake activity that lasted until 1924 at Halemaumau crater, within the summit caldera.  The 3 x 5 km caldera was formed in several stages about 1500 years ago and during the 18th century; eruptions have also originated from the lengthy East and SW rift zones, which extend to the sea on both sides of the volcano.  About 90% of the surface of the basaltic shield volcano is formed of lava flows less than about 1100 years old; 70% of the volcano's surface is younger than 600 years.  A long-term eruption from the East rift zone that began in 1983 has produced lava flows covering more than 100 sq km, destroying nearly 200 houses and adding new coastline to the island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1302-01-&amp;volpage=photos&amp;photo=098069">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1302-01-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://hvo.wr.usgs.gov/">Hawaiian Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(19.420999999999999,-155.28700000000001)
922	Mauna Loa	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mauna Loa</b></font><br /><font size="5"><b>Hawaii (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/035030.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 4170 m<br /><b>Latitude:</b> 19.475&deg;N<br /><b>Longitude:</b> 155.608&deg;W</td></tr><tr><td colspan="2"><p align="justify">Massive Mauna Loa shield volcano rises almost 9 km above the sea floor to form the world's largest active volcano.  Flank eruptions are predominately from the lengthy NE and SW rift zones, and the summit is cut by the Mokuaweoweo caldera, which sits within an older and larger 6 x 8 km caldera.  Two of the youngest large debris avalanches documented in Hawaii traveled nearly 100 km from Mauna Loa; the second of the Alika avalanches was emplaced about 105,000 years ago (Moore et al. 1989).  Almost 90% of the surface of the basaltic shield volcano is covered by lavas less than 4000 years old (Lockwood and Lipman, 1987).  During a 750-year eruptive period beginning about 1500 years ago, a series of voluminous overflows from a summit lava lake covered about one fourth of the volcano's surface.  The ensuing 750-year period, from shortly after the formation of Mokuaweoweo caldera until the present, saw an additional quarter of the volcano covered with lava flows predominately from summit and NW rift zone vents.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1302-02=&amp;volpage=photos&amp;photo=035030">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1302-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://hvo.wr.usgs.gov/">Hawaiian Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(19.475000000000001,-155.608)
923	Mauna Kea	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mauna Kea</b></font><br /><font size="5"><b>Hawaii (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/035075.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 4205 m<br /><b>Latitude:</b> 19.82&deg;N<br /><b>Longitude:</b> 155.47&deg;W</td></tr><tr><td colspan="2"><p align="justify">Mauna Kea, Hawaii's highest volcano, reaches 4205 m, only 35 m above its neighbor, Mauna Loa.  In contrast to Mauna Loa, Mauna Kea lacks a summit caldera and is capped by a profusion of cinder cones and pyroclastic deposits.  Mauna Kea's rift zones are less pronounced than on neighboring volcanoes, and the eruption of voluminous, late-stage pyroclastic material has buried much of the early basaltic shield volcano, giving the volcano a steeper and more irregular profile.  This transition took place about 250,000 to 200,000 years ago, and much of Mauna Kea, whose Hawaiian name means &quot;White Mountain,&quot; was constructed during the Pleistocene.  Its age and high altitude make it the only Hawaiian volcano with glacial moraines.  A road that reaches a cluster of astronomical observatories on the summit also provides access to seasonal tropical skiing.  The latest eruptions at Mauna Kea produced a series of cinder cones and lava flows from vents on the northern and southern flanks during the early to mid Holocene.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1302-03-&amp;volpage=photos&amp;photo=035075">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1302-03-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://hvo.wr.usgs.gov/">Hawaiian Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(19.82,-155.47)
924	Hualalai	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hualalai</b></font><br /><font size="5"><b>Hawaii (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/035088.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2523 m<br /><b>Latitude:</b> 19.692&deg;N<br /><b>Longitude:</b> 155.87&deg;W</td></tr><tr><td colspan="2"><p align="justify">Hualalai volcano, at the western end of the island, is the third youngest shield volcano on Hawaii.  At 2523 m, it is dwarfed by its massive neighbors, Mauna Loa and Mauna Kea.  Three rift zones, dotted with cinder cones and spatter cones, trend north, NW, and SE, and converge about 5 km east of the summit.  Detailed mapping has shown that 95% of the surface area of the basaltic shield volcano is of Holocene age, more than half is less than 3000 years old, and a quarter is less than 1000 years old.  The only historical eruptions of Hualalai took place during the end of the 18th century and in 1801, when lava flows from vents on the NW rift zone reached the sea and buried Hawaiian villages; the 1801 Huehue lava flow underlies part of the international airport at Kona.  The earlier of the two flows, the Kaupulehu lava flow, is notable for its large quantities of lava-encrusted mafic and ultramafic nodular xenoliths.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1302-04-&amp;volpage=photos&amp;photo=035088">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1302-04-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://hvo.wr.usgs.gov/">Hawaiian Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(19.692,-155.87)
925	Haleakala	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Haleakala</b></font><br /><font size="5"><b>Hawaii (USA)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/036003.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3055 m<br /><b>Latitude:</b> 20.708&deg;N<br /><b>Longitude:</b> 156.25&deg;W</td></tr><tr><td colspan="2"><p align="justify">The massive Haleakala shield volcano forms the eastern portion of the dumbbell-shaped island of Maui.  The summit of 3055-m Haleakala  contains a dramatic, 3.5 x 9.5 km summit crater that is widely breached on the north and SE sides.  The &quot;crater&quot; is not of volcanic origin, but formed as a result of the coalescence of headward erosion of the Koolau and Kaupo valleys.  Subsequently the crater has been partially filled by a chain of young cinder cones and lava flows erupted along a major rift zone that extends across the basaltic shield volcano from the SW to the east flanks.  Another less prominent rift zone trends north from the summit.  The most recent eruption of Haleakala was thought to have occurred between the exploring voyages of La Perouse in 1786 and Vancouver in 1793, but uncertainty surrounds the date of this event, which could have occurred in about 1750 AD (anthropological evidence) or several centuries earlier (radiocarbon dates).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1302-06-&amp;volpage=photos&amp;photo=036003">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1302-06-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://hvo.wr.usgs.gov/">Hawaiian Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(20.707999999999998,-156.25)
926	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>Hawaii (USA)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -4000 m<br /><b>Latitude:</b> 23.58&deg;N<br /><b>Longitude:</b> 163.83&deg;W</td></tr><tr><td colspan="2"><p align="justify">A &quot;smoke&quot; column rising several thousand meters from the sea, steaming turbulent water, water discoloration, and a probable raft of floating pumice were seen from the air at a point 90 km NE of Necker Island on August 20, 1953.  Despite a water depth at this point of approximately 4 km, Macdonald (1959) considered there to be little doubt that a submarine eruption, the westernmost historical volcanic eruption in the Hawaiian lsland chain, had occurred.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1302-09-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://hvo.wr.usgs.gov/">Hawaiian Volcano Observatory</a></td><td width="33%"><a href="http://volcanoes.usgs.gov/">USGS Volcano Hazards Program</a></td></tr></table>	(23.579999999999998,-163.83000000000001)
927	Teahitia	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Teahitia</b></font><br /><font size="5"><b>Society Islands (Central Pacific)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -1400 m<br /><b>Latitude:</b> 17.57&deg;S<br /><b>Longitude:</b> 148.85&deg;W</td></tr><tr><td colspan="2"><p align="justify">Teahitia is a submarine volcano in the Society Islands, whose summit reaches to within 1400 m of  the surface, 40 km NE of the SE tip of Tahiti Island.  Several seismic swarms in the 1980s included volcanic tremor that may have resulted from submarine eruptions (Talandier and Opal, 1984).  Rocks dredged from the volcano in 1986 &quot;exploded&quot; when they reached the surface, suggesting recent lava extrusion that had not yet had time to equilabrate with pressure and temperature conditions on the submerged flanks of the edifice.  Two hydrothermal fields each about 1km by 400 m in size that emitted low-temperature hydrothermal venting were discovered on the flanks of the volcano during submersible dives in 1986 and 1989.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1303-01-">Smithsonian Volcano Information</a></td></tr></table>	(-17.57,-148.84999999999999)
928	Rocard	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Rocard</b></font><br /><font size="5"><b>Society Islands (Central Pacific)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -2100 m<br /><b>Latitude:</b> 17.642&deg;S<br /><b>Longitude:</b> 148.60&deg;W</td></tr><tr><td colspan="2"><p align="justify">Rocard is a recently discovered submarine volcano about halfway between Tahiti and Mehetia islands.  It displayed seismicity in 1966, 1971, and 1972 that may have resulted from submarine eruptions (Talandier and Custer, 1976).  Rocks dredged from the volcano in 1986 &quot;exploded&quot; when they reached the surface, suggesting recent lava extrusion that had not yet had time to equilabrate with pressure and temperature conditions on the submerged flanks of the edifice.  The summit of Rocard lies 2100 m below sea level east of Teahitia seamount and north of Moua Pihaa seamount.  Rocard is much smaller than its neighboring seamounts.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1303-02-">Smithsonian Volcano Information</a></td></tr></table>	(-17.641999999999999,-148.59999999999999)
929	Moua Pihaa	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Moua Pihaa</b></font><br /><font size="5"><b>Society Islands (Central Pacific)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -160 m<br /><b>Latitude:</b> 18.32&deg;S<br /><b>Longitude:</b> 148.67&deg;W</td></tr><tr><td colspan="2"><p align="justify">Moua Pihaa is a massive, steep-sided submarine volcano that rises to within 160 m of the sea surface SW of Mehetia Island.  It is the largest of a group of seamounts along the Society Island hot spot chain near Mehetia and Tahiti Islands and towers 3500 m above the sea floor.  Moua Pihaa volcano displayed seismicity in 1969 and 1970 considered to have been related to submarine eruptions (Talandier and Custer, 1976).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1303-03-">Smithsonian Volcano Information</a></td></tr></table>	(-18.32,-148.66999999999999)
930	Mehetia	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mehetia</b></font><br /><font size="5"><b>Society Islands (Central Pacific)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/103044.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 435 m<br /><b>Latitude:</b> 17.87&deg;S<br /><b>Longitude:</b> 148.07&deg;W</td></tr><tr><td colspan="2"><p align="justify">The 1.5-km-wide, steep-sided island of Mehetia, the youngest and SE-most of the Society Islands, lacks a well-developed fringing coral reef.  The 435-m-high island (known as Meetia or Meketia in the Tahitian and Tuamotuan languages, respectively) is the summit of a large volcano that rises 4000 m from the sea floor.  An older edifice is formed of a lava flow sequence overlain by hydromagmatic deposits and strombolian ejecta.  A well-preserved Holocene crater, 150 m wide and 80 m deep, is located NW of the summit and has been the source of the youngest lava flows on the island (Binard et al., 1993).  Polynesian legends mention &quot;large fires,&quot; and the lack of vegetation on some lava flows suggests that the latest activity occurred within the last 2000 years (Talandier and Custer, 1976).  Other recent activity at Tehetia originated from a submarine crater at 2500-2700 m depth on the SE flank.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1303-04-&amp;volpage=photos&amp;photo=103044">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1303-04-">Smithsonian Volcano Information</a></td></tr></table>	(-17.870000000000001,-148.06999999999999)
931	Adams Seamount	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Adams Seamount</b></font><br /><font size="5"><b>Central Pacific Ocean</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> -39 m<br /><b>Latitude:</b> 25.37&deg;S<br /><b>Longitude:</b> 129.27&deg;W</td></tr><tr><td colspan="2"><p align="justify">Adams Seamount was constructed above the Pitcairn hot spot in the central Pacific, about 90 km WSW of Pitcairn Island.  The massive seamount rises about 3500 m to within 59 m of the sea surface about 25 km SW of another large submarine volcano within the Pitcairn hot spot, Bounty Seamount.  The Pitcairn hot spot was built over 30-million-year-old Pacific Ocean crust, and in addition to the two large volcanoes, Adams and Bounty seamounts, contains about 20 small volcanic hills about 500 m high.  Although Bounty Seamount, which rises to within 450 m of the sea surface, appears morphologically more youthful than Adams and water samples indicate continuing hydrothermal activity, two late-Pleistocene Potassium-Argon dates of about 338,000 and 350,000 years were obtained from the flanks of Bounty.   Alkali basaltic rocks were dredged from the flanks of Adams Seamount, whose summit appears to consist of a trachytic lava dome.  Several Potassium-Argon dates of Holocene age were obtained from dredges at Adams Seamount (Guillou et al., 1997), the youngest of which was 2000 +/- 1000 years.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1303-05-">Smithsonian Volcano Information</a></td></tr></table>	(-25.370000000000001,-129.27000000000001)
932	Macdonald	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Macdonald</b></font><br /><font size="5"><b>Austral Islands (Central Pacific)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -39 m<br /><b>Latitude:</b> 28.98&deg;S<br /><b>Longitude:</b> 140.25&deg;W</td></tr><tr><td colspan="2"><p align="justify">Discovered by the detection of teleseismic waves in 1967, Macdonald seamount (also known as Tamarii seamount) rises from a depth of about 1800 m to within 27 m of the sea surface at the eastern end of the Austral Islands.  The alkali-basaltic submarine volcano marks the site of a hotspot that was the source of the Austral-Cook island chain.  The summit of the seamount, named after volcanologist Gordon Macdonald, consists of a flat plateau about 100 x 150 m wide with an average depth of about 40 m.  The summit plateau is capped with spatter cones that form steep-sided pinnacles.  Most eruptions of Macdonald have been seismically detected, but in 1987 and 1989 pumice emission was observed from research vessels.  Pumice rafts observed in the South Pacific in 1928 and 1936 may also have originated from Macdonald seamount.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1303-06-">Smithsonian Volcano Information</a></td></tr></table>	(-28.98,-140.25)
933	Northern EPR-Segment RO2	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Northern EPR-Segment RO2</b></font><br /><font size="5"><b>East Pacific Rise</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> -2700? m<br /><b>Latitude:</b> 16.55&deg;N<br /><b>Longitude:</b> 105.32&deg;W</td></tr><tr><td colspan="2"><p align="justify">Segment RO2 of the Northern East Pacific Rise lies between the Orozco and Rivera transform faults, immediately south of the Rivera transform.  The segment displays a typical small rifted axial crest, about 2-3 km wide and about 20-50 m deep.  At some locations the summit trough almost disappears, suggesting high rates of volcanism.  A seamount lies just east of the axial crest at about 16 deg 33 min N.  Magnetic paleointensity measurements on basaltic glasses dated a lava flow at about 2000 +/- 1000 years and another at &quot;contemporary&quot; age, perhaps decades to a few hundred years old.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1304-02-">Smithsonian Volcano Information</a></td></tr></table>	(16.550000000000001,-105.31999999999999)
934	Northern EPR-Segment RO3	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Northern EPR-Segment RO3</b></font><br /><font size="5"><b>East Pacific Rise</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> -2300? m<br /><b>Latitude:</b> 15.83&deg;N<br /><b>Longitude:</b> 105.43&deg;W</td></tr><tr><td colspan="2"><p align="justify">Segment RO3 of the Northern East Pacific Rise lies between the Orozco and Rivera transform faults, immediately north of the Orozco transform.  Unlike segment RO2 to the north, the RO3 segment displays a broad, shallow profile that is the widest and shallowest of a 5000-km-long segment of the East Pacific Rise between 23 degrees south to 23 degrees north.  The flat axial crest ranges from 3-4 to about 10 km wide and is about 2300-2350 m deep; the axis morphology suggests a high magma supply rate.   Magnetic paleointensity measurements on basaltic glasses dated several lava flows along segment RO3 at about 2000 +/- 1000 years, suggesting a major volcanic episode that produced lava flows flooding much of the axial plateau and extended on to its flanks.  Several other lava flows were dated at &quot;contemporary&quot; ages, perhaps less than 100 years.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1304-021">Smithsonian Volcano Information</a></td></tr></table>	(15.83,-105.43000000000001)
935	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>East Pacific Rise</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119070.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Latitude:</b> 10.73&deg;N<br /><b>Longitude:</b> 103.58&deg;W</td></tr><tr><td colspan="2"><p align="justify">Divers in the submersible Alvin discovered an extremely fresh lava flow in an unexpected location at 10 degrees 44 minutes North on the East Pacific Rise during an expedition in November 2003.  The young flow was covered by bacterial mats, had large amounts of bacterial floc (&quot;snow-blowers&quot;) issuing from diffuse vents, and was sparsely populated by small animals. Uranium-series dating indicated that the eruption had taken place within a time window only a few months to weeks prior to the observations.  This segment of the East Pacific Rise, located just north of the Clipperton Transform Fault, is an area with an estimated low magma production rate.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1304-04-&amp;volpage=photos&amp;photo=119070">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1304-04-">Smithsonian Volcano Information</a></td></tr></table>	(10.73,-103.58)
936	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>East Pacific Rise</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/118078.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> -2500? m<br /><b>Latitude:</b> 9.83&deg;N<br /><b>Longitude:</b> 104.30&deg;W</td></tr><tr><td colspan="2"><p align="justify">Evidence for a very recent, possibly ongoing eruption was detected during a series of dives in the submersible vessel Alvin in 1991 on the East Pacific Rise at about 9 deg 50 min N.  Hot-vent animal communities that had been documented during November to December 1989 imaging were observed to have been buried by fresh basaltic lava flows, and the scorched soft tissues of partially buried biota had not yet attracted bottom scavengers.  Fresh black smoker chimneys were draped by new lava flows.  This position was at a depth of about 2500 m south of the Clipperton fracture zone, about 1000 km SW of Acapulco, Mxico.  It coincided with a location where fresh lava flows previously estimated as less than roughly 50 years in age had been found.   Later dating of very short half-life radionuclides from dredged samples confirmed the young age of the eruption and indicated that another eruptive event had taken place in late 1991 and early 1992.  An eruption in 2005-2006 produced lava flows that entrapped previously emplaced seismometers.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1304-05-&amp;volpage=photos&amp;photo=118078">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1304-05-">Smithsonian Volcano Information</a></td></tr></table>	(9.8300000000000001,-104.3)
937	Galpagos Rift	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Galpagos Rift</b></font><br /><font size="5"><b>Eastern Pacific Ocean</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/118083.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> -2430 m<br /><b>Latitude:</b> 0.792&deg;N<br /><b>Longitude:</b> 86.15&deg;W</td></tr><tr><td colspan="2"><p align="justify">The E-W-trending Galpagos Rift, an oceanic spreading ridge between the Cocos plate to the north and the Nazca plate to the south, is located north of the Galpagos Islands.  A large area of hydrothermal vents along the crest of the ridge ENE of the Galpagos Islands was discovered in 1977.  The location listed here is the position of Clambake vent, which was surrounded by very youthful sediment-free flows of basaltic sheet lava.  This position is at the northern limit of the location error circle for a 1972 earthquake swarm and only a few km south of a concurrent fish kill (Macdonald &amp; Mudie, 1974) that may have been associated with extrusion of these young flows.  Morphology of the flows suggested that they were less than 5 years old (Chadwick and Embley, 1994).  The Galpagos Rift at this point consists of a small rift valley 3-4 km wide with walls 200-250 m high.  A low axial ridge formed by the youngest sediment-free lava flows rises about 20 m above the valley floor, flanked by older marginal ridges.  A 2002 expedition discovered evidence for new lava flows covering markers emplaced in 1990.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1304-07-&amp;volpage=photos&amp;photo=118083">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1304-07-">Smithsonian Volcano Information</a></td></tr></table>	(0.79200000000000004,-86.150000000000006)
938	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>East Pacifc Rise</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> -2800 m<br /><b>Latitude:</b> 8.27&deg;S<br /><b>Longitude:</b> 107.95&deg;W</td></tr><tr><td colspan="2"><p align="justify">A massive 15 +/- 4 cu km lava flow field covers about 220 sq km of the East Pacific Rise (EPR) axis crest at about 8 degrees South.  The high reflectivity of the lava flow indicates a very youthful age.   This, coupled with teleseismically recorded earthquakes in 1964, 1965, and 1969 of an unusual magnitude along this segment of the EPR and the detection of a helium megaplume of a volume consistent with the eruption of a lava flow of this volume detected several years later at a distant location consistent with inferred circulation patterns at mid-ocean depths led Macdonald et al. (1989) to suggest that part or all of this lava field may have been emplaced in the past 25 years, during one or more eruptions coincident with the earthquakes and onset of the helium plume.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1304-10-">Smithsonian Volcano Information</a></td></tr></table>	(-8.2699999999999996,-107.95)
939	Southern EPR-Segment K	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Southern EPR-Segment K</b></font><br /><font size="5"><b>East Pacifc Rise</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/118082.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> -2566 m<br /><b>Latitude:</b> 17.436&deg;S<br /><b>Longitude:</b> 113.206&deg;W</td></tr><tr><td colspan="2"><p align="justify">Lava flows from a very recent volcanic eruption were observed in 1994 along segment K of the southern East Pacific Rise.  This segment of the mid-ocean ridge north of the Easter microplate displays the broadest cross-sectional area and the shallowest depth (2566 m) of the southern East Pacific Rise between 13 degrees 40 minutes and 18 degrees 30 minutes south.  Glassy, unsedimented lava flows on the 17.5 degrees S segment of the East Pacific Rise were considered from biological observations and chemical analyses of the plume and vent fluids to have been erupted within 2-3 years of a November-December 1993 plume survey.  Lava was erupted along two segments of the mid-ocean ridge, a 4-km-long flow at the southern site and a 5-10 km long flow at the northern site.  Numerous low- and high-temperature hydrothermal vents are active along this segment of the mid-ocean ridge.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1304-12-&amp;volpage=photos&amp;photo=118082">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1304-12-">Smithsonian Volcano Information</a></td></tr></table>	(-17.436,-113.206)
940	Southern EPR-Segment J	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Southern EPR-Segment J</b></font><br /><font size="5"><b>East Pacifc Rise</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/118080.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> -2650+ m<br /><b>Latitude:</b> 18.175&deg;S<br /><b>Longitude:</b> 113.35&deg;W</td></tr><tr><td colspan="2"><p align="justify">The axial crest of Segment J of the Southern East Pacific Rise consists of an asymmetrical shallow graben varying from 250 to 600 m wide with walls about 20 m high.  Horst and graben structures expose cooled lava lakes and both active and extinct hydrothermal chimneys.  Basaltic lava flow fields, lava pillars, and pillow mounds are found on the floor of the graben.  The largest lava flow field is the Moai lava flow at about 18 deg 12 min S.  Two lava flows in Segment J have been dated by paleomagnetic evidence at about 1820 and 1890 AD.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1304-13-&amp;volpage=photos&amp;photo=118080">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1304-13-">Smithsonian Volcano Information</a></td></tr></table>	(-18.175000000000001,-113.34999999999999)
941	Southern EPR-Segment I	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Southern EPR-Segment I</b></font><br /><font size="5"><b>East Pacifc Rise</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/118081.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> -2600? m<br /><b>Latitude:</b> 18.53&deg;S<br /><b>Longitude:</b> 113.42&deg;W</td></tr><tr><td colspan="2"><p align="justify">The narrow axial crest of Segment I of the Southern East Pacific Rise in some places is less than 50 m wide.  An axial dome is located along the southern part of the segment.  The largest lava flow field in this EPR segment is the Animal Farm flow, named after a thriving low-temperature hydrothermal site discovered during a submersible expedition in 1993.  The Animal Farm lava flow was dated by magnetic paleointensity measurements at about 1880-1950 AD, and older flows were dated by similar techniques to the 17th and 19th centuries.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1304-14-&amp;volpage=photos&amp;photo=118081">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1304-14-">Smithsonian Volcano Information</a></td></tr></table>	(-18.530000000000001,-113.42)
942	Pinacate	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Pinacate</b></font><br /><font size="5"><b>Northwestern Mxico</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/036006.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Maars<br />&nbsp;&nbsp;&nbsp; Tuff rings</td><td width="50%" align="left"><b>Summit Elev:</b> 1200+ m<br /><b>Latitude:</b> 31.772&deg;N<br /><b>Longitude:</b> 113.498&deg;W</td></tr><tr><td colspan="2"><p align="justify">Pinacate is a large, roughly 55 x 60 km volcanic field in the Sonoran desert of NW Mxico.  It contains numerous youthful maars, tuff rings, and cinder cones of late-Pleistocene to Holocene age.  The 2000 sq km volcanic field is prominent in satellite images of this arid, sparsely populated region between the Arizona border and the head of the Gulf of California.  An older volcanic episode constructed the 1200-m-high Santa Clara basaltic-to-trachytic shield volcano.  This was followed by the eruption of more than 500 basaltic cinder cones and lava flows that blanket the slopes of Santa Clara and the surrounding desert.  Among the principal features of the Pinacate volcanic field are Elegante crater, a 1.6-km-wide maar, and Cerro Colorado, a 110-m-high, 1.1-km-wide tuff ring.  Papago (Tohono O'odham) Indian legends tell of eruptions, however historical accounts of ash-and-steam eruptions in the 20th century are questionable.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-001&amp;volpage=photos&amp;photo=036006">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-001">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(31.771999999999998,-113.498)
943	Isla San Luis	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Isla San Luis</b></font><br /><font size="5"><b>Baja California (Mxico)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/102003.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Tuff cone<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Tuff rings</td><td width="50%" align="left"><b>Summit Elev:</b> 180? m<br /><b>Latitude:</b> 29.97&deg;N<br /><b>Longitude:</b> 114.40&deg;W</td></tr><tr><td colspan="2"><p align="justify">Isla San Luis is the largest of the seven Encantada islands at the NW end of the Guaymas lineament in the northern part of the Gulf of California.  The roughly 180-m-high island (also known as La Encantada Mayor, or Salvatierra) is located 3 km off the eastern shore of Baja California north of Punta Bufeo.  The small 4.5 sq km island has an irregular shoreline with a narrow peninsula forming its SW tip.  Initial basaltic-andesite and andesitic submarine surtseyan eruptions producing palagonite tuffs were followed by the effusion of subaerial dacitic lava flows and the formation of dacitic tuff rings.  The latest eruptions formed two rhyolitic obsidian domes, the younger in a tuff cone at the center of the island and at the older at the NW tip of the island.  Although the age of the domes is not known precisely, Medina et al. (1989) suggested that they could be less than a century old.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-003&amp;volpage=photos&amp;photo=102003">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-003">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(29.969999999999999,-114.40000000000001)
944	Jaraguay Volcanic Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Jaraguay Volcanic Field</b></font><br /><font size="5"><b>Baja California (Mxico)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/075061.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 960? m<br /><b>Latitude:</b> 29.33&deg;N<br /><b>Longitude:</b> 114.50&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Jaraguay volcanic field is the northernmost of a group of large young alkalic volcanic fields in Baja California.  Located primarily on the Pacific Ocean side of northern Baja between Jaraguay and Arroyo San Jos, the Jaraguay field contains numerous youthful-looking cinder cones and associated basaltic and basaltic-andesite lava flows.  Some lava flows are less vegetated than flows of the San Quintn volcanic field to the north that overlie 5000-6000 year-old midden deposits (Rogers et al., 1985).  Several Holocene lava flows were erupted near the south side of Arroyo San Jos at the SW end of the Jaraguay volcanic field.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-004&amp;volpage=photos&amp;photo=075061">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-004">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(29.329999999999998,-114.5)
945	Coronado	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Coronado</b></font><br /><font size="5"><b>Baja California (Mxico)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/102006.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 440+ m<br /><b>Latitude:</b> 29.08&deg;N<br /><b>Longitude:</b> 113.513&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn Coronado is a small stratovolcano at the northern tip of Coronado Island, 3 km off the eastern coast of Baja California in the Canal de los Ballenas.  The roughly 440-m-high volcano forms a 2-km-wide peninsula at the northern end of the elongated NNW-SSE-trending island and contains a 300 x 160 m wide crater.  The age of the most recent eruptive activity from Volcn Coronado is not known, although fumarolic activity was reported in September 1539 (Medina et al., 1989).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-005&amp;volpage=photos&amp;photo=102006">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-005">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(29.079999999999998,-113.51300000000001)
946	Guadalupe	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Guadalupe</b></font><br /><font size="5"><b>W of Baja California (Mxico)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/093074.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1100 m<br /><b>Latitude:</b> 29.07&deg;N<br /><b>Longitude:</b> 118.28&deg;W</td></tr><tr><td colspan="2"><p align="justify">Elongated Guadalupe Island lies atop a fossil oceanic ridge crest about 300 km west of Baja California.  The seamount, which rises above the Pacific Ocean surface to an elevation of 1100 m, contains two shield volcanoes, the northern of which is the youngest.  Chains of cinder cones constructed along fissures oriented both NW-SE and NE-SW and associated lava flows overlie both shield volcanoes.  The longest of these fissures cuts across the caldera of the northern volcano and extends beyond it to the SE.  Other pyroclastic cones were constructed along an arcuate fissure near the southern caldera rim.  The shield volcanoes and products of the fissure eruptions form a complete alkali basaltic-to-trachytic series reflecting a transition from submarine to subaerial volcanism.  The 1100-m-high northern basaltic shield volcano was considered to be of Holocene age (Medina et al. 1989).  Trachytic lava domes are found within the caldera of the northern shield volcano, and together with very fresh-looking alkali basalt lava flows, form the youngest volcanic rocks on the island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-006&amp;volpage=photos&amp;photo=093074">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-006">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(29.07,-118.28)
947	San Borja Volcanic Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>San Borja Volcanic Field</b></font><br /><font size="5"><b>Baja California (Mxico)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/075062.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1360+ m<br /><b>Latitude:</b> 28.50&deg;N<br /><b>Longitude:</b> 113.75&deg;W</td></tr><tr><td colspan="2"><p align="justify">The San Borja volcanic field, also known as the El Rosarito volcanic field, is located in central Baja California NE of the Vizcaino Peninsula.  Holocene lava flows occur at Rosarito and Morro San Domingo at the western end of the San Borja volcanic field along the coast north of the Vizcaino Peninsula.  Some lava flows of the San Borja volcanic field are less vegetated than flows of the San Quintn volcanic field to the north that overlie 5000-6000 year-old midden deposits (Rogers et al., 1985).  The Holocene lava flows in the western part of this alkalic volcanic field are of basaltic-andesite and andesitic composition.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-007&amp;volpage=photos&amp;photo=075062">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-007">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(28.5,-113.75)
948	Isla Tortuga	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Isla Tortuga</b></font><br /><font size="5"><b>Baja California (Mxico)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/036032.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 210+ m<br /><b>Latitude:</b> 27.43&deg;N<br /><b>Longitude:</b> 111.88&deg;W</td></tr><tr><td colspan="2"><p align="justify">A youthful shield volcano forms Isla Tortuga, which lies in the Gulf of California 40 km off the Baja coast.  A circular, 1-km-wide caldera, west of the center of the oval, 4-km-long island, truncates the small shield volcano, which reaches only about 210 m above sea level.  Circumferential faults cut the rim of the &gt;100-m-deep caldera, which is floored by a solidified lava lake and contains youthful-looking spatter cones.  The shield volcano was constructed during two north-migrating periods of activity that began with submarine eruptions and included formation of a circular tuff-ring complex enclosing the caldera.  The sides of a small volcanic horst in the center of the caldera display lava flows overlying a 2-m-thick halite bed, formed when sea water filled the caldera, creating an evaporite basin.  Recent lava flows cover most of the flanks of the volcano, and fumarolic activity has continued into historical time.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-011&amp;volpage=photos&amp;photo=036032">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-011">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(27.43,-111.88)
949	Brcena	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Brcena</b></font><br /><font size="5"><b>Revillagigedo Islands (Mxico)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/036038.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 332+ m<br /><b>Latitude:</b> 19.30&deg;N<br /><b>Longitude:</b> 110.82&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn Brcena, formed by eruptions during 1952-53, is the most prominent feature of Isla San Benedicto, the NE-most of the Revillagigedo Islands, 350 km south of the tip of Baja California.  San Benedicto island, elongated in a NE-SW direction, contains a series of Pleistocene trachytic lava domes at the north end.  The southern end of the 4.5-km-long island is formed by Brcena and Montculo Cinertico, a smaller tephra cone that preceded and was largely overtopped by Brcena.  Montculo Cinertico may also have been constructed during the past few hundred years and formed the high point of the island prior to the formation of Brcena.  Growth of the 300-m-high Brcena tephra cone beginning in August 1952 was accompanied by strong explosive eruptions and pyroclastic flows.  The eruption concluded the following year with the emplacement of two small lava domes in the crater and extrusion of a prominent coastal lava delta at the SE base of the cone.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-02=&amp;volpage=photos&amp;photo=036038">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(19.300000000000001,-110.81999999999999)
950	Socorro	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Socorro</b></font><br /><font size="5"><b>Revillagigedo Islands (Mxico)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/100009.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1050 m<br /><b>Latitude:</b> 18.78&deg;N<br /><b>Longitude:</b> 110.95&deg;W</td></tr><tr><td colspan="2"><p align="justify">Socorro, the SE-most of the Revillagigedo Islands south of Baja California, is the summit of a massive, predominately submarine basaltic shield volcano capped by a largely buried, 4.5 x 3.8-km-wide summit caldera.  A large tephra cone and lava dome complex, Cerro Evermann, forms the 1050-m-high summit of the volcano, and along with other cones and vents, fills much of the Pleistocene caldera.  Rhyolitic lava domes have been constructed along flank rifts oriented to the north, west, and SE, and silicic lava flows from summit and flank vents have reached the coast and created an extremely irregular shoreline.  Late-stage basaltic eruptions produced cones and flows near the coast.  Only minor explosive activity, some of which is of uncertain validity, has occurred from flank vents in historical time dating back to the 19th century.  In 1951 a brief phreatic eruption ejected blocks, and the gas column reached 1200 m elevation.   A submarine eruption occurred during 1993-94 from a vent 3 km west of the island during which large scoriaceous blocks up to 5 m in size floated to the surface without associated explosive activity.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-021&amp;volpage=photos&amp;photo=100009">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-021">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(18.780000000000001,-110.95)
951	Durango Volcanic Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Durango Volcanic Field</b></font><br /><font size="5"><b>Mxico</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/036048.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 2075 m<br /><b>Latitude:</b> 24.15&deg;N<br /><b>Longitude:</b> 104.45&deg;W</td></tr><tr><td colspan="2"><p align="justify">The broad Durango volcanic field covers 2100 sq km at the NW corner of the Meseta Central near the eastern edge of the Sierra Madre Occidental of north-central Mxico.  The expansive undissected lava plain lies within the Mexican Basin and Range province and is located NE of the city of Durango.  The Durango volcanic field is dotted with about 100 Quaternary basanitic cinder and lava cones as well as several important xenolith localities.  La Brea-El Jagey maar complex consists of two intersecting maars, the largest of which (La Brea) contains a series of nested cinder cones.  The maar complex is one of the youngest eruptive centers of the Durango volcanic field and was considered by Aranda-Gmez et al. (1992) to be only a few thousand years old.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-022&amp;volpage=photos&amp;photo=036048">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-022">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(24.149999999999999,-104.45)
952	Sangangey	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sangangey</b></font><br /><font size="5"><b>Mxico</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/055034.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2340+ m<br /><b>Latitude:</b> 21.45&deg;N<br /><b>Longitude:</b> 104.73&deg;W</td></tr><tr><td colspan="2"><p align="justify">Sangangey, the highest volcano of the NW-SE-trending Tepic-Zacoalco graben, is an eroded andesitic and dacitic stratovolcano that contains a prominent lava spine at its summit.  The NW and SE flanks of the Pleistocene edifice of Volcn Sangangey are dotted with 45 cinder cones that erupted during the past 300,000 years along 5 parallel lines.  Some of the cinder cones appear morphologically similar to cones on nearby Ceboruco volcano that are known to be less than 1000 years old.  There are no confirmed historical eruptions from Sangangey.  An incorrect report of an eruption in 1859 from San Juan (a synonym of Sangangey) refers to the nearby Pleistocene San Juan volcano.  An Indian tradition records an eruption of Sangangey in 1742 (Sapper, 1917).  If these legends are true, they may refer to an eruption from one of the young flank cinder cones of Sangangey.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-024&amp;volpage=photos&amp;photo=055034">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-024">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(21.449999999999999,-104.73)
953	Ceboruco	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ceboruco</b></font><br /><font size="5"><b>Mxico</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/036059.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2280+ m<br /><b>Latitude:</b> 21.125&deg;N<br /><b>Longitude:</b> 104.508&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn Ceboruco is the only historically active volcano in the NW part of the Mexican Volcanic Belt.  The complex stratovolcano rises above the floor of the Tepic graben and is truncated by two concentric summit calderas.  Eruption of the voluminous rhyodacitic Jala Pumice, the largest known in Mxico during the Holocene, formed the initial 4-km-wide caldera about 1000 years ago.  The second caldera, 1.5 km wide, was formed by collapse of part of the large Dos Equis dacitic lava dome, which partly filled the earlier caldera.  About 15 basaltic and andesitic cinder cones and lava flows have erupted along a NW-SE-trending line cutting across Ceboruco.  The massive, sparsely vegetated El Norte lava flow, probably erupted in the past few hundred years, blankets the entire northern flank of the volcano.  The last eruption of Ceboruco took place during 1870-75.  Explosive eruptions from a vent on the upper west flank accompanied extrusion of a 1.1 cu km dacitic lava flow that covers a large area on the lower western flank.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-03=&amp;volpage=photos&amp;photo=036059">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(21.125,-104.508)
954	Mascota Volcanic Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mascota Volcanic Field</b></font><br /><font size="5"><b>Mxico</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/075077.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2560 m<br /><b>Latitude:</b> 20.62&deg;N<br /><b>Longitude:</b> 104.83&deg;W</td></tr><tr><td colspan="2"><p align="justify">A group of calc-alkaline andesitic and minette cinder cones and lava domes, both with associated lava flows, is located near the town of Mascota, in the Jalisco tectonic block about 50 km east of Puerto Vallarta.  Mascota is the youngest of a group of potassic volcanic fields in extensional grabens of the Jalisco block south of the Ro Ameca.  Most volcanism in the Mascota volcanic field is confined to two NNW-SSE-trending grabens cutting Cretaceous ash-flow tuffs.  The youngest eruption, at Volcn Malpas, north of Mascota, produced a fresh-looking basaltic-andesite lava flow.  The lack of soil development and sparse vegetation suggest that it may be only a few thousand years old (Carmichael et al., 1996).  The volcanic field is noted for its unusual diversity of volcanic rocks, and Mascota contains Earth's youngest known minettes, with radiometric ages down to 0.07 +/- 0.08 million years.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-031&amp;volpage=photos&amp;photo=075077">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-031">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(20.620000000000001,-104.83)
955	Colima	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Colima</b></font><br /><font size="5"><b>Mxico</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/036073.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 3850 m<br /><b>Latitude:</b> 19.514&deg;N<br /><b>Longitude:</b> 103.62&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Colima volcanic complex is the most prominent volcanic center of the western Mexican Volcanic Belt.  It consists of two southward-younging volcanoes, Nevado de Colima (the 4320 m high point of the complex) on the north and the 3850-m-high historically active Volcn de Colima at the south.  A group of cinder cones of late-Pleistocene age is located on the floor of the Colima graben west and east of the Colima complex.  Volcn de Colima (also known as Volcn Fuego) is a youthful stratovolcano constructed within a 5-km-wide caldera, breached to the south, that has been the source of large debris avalanches.  Major slope failures have occurred repeatedly from both the Nevado and Colima cones, and have produced a thick apron of debris-avalanche deposits on three sides of the complex.  Frequent historical eruptions date back to the 16th century.  Occasional major explosive eruptions (most recently in 1913) have destroyed the summit and left a deep, steep-sided crater that was slowly refilled and then overtopped by lava dome growth.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-04=&amp;volpage=photos&amp;photo=036073">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-04=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ucol.mx/volcan/">Colima Volcano Observatory</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico (in Spanish)</a></td></tr></table>	(19.513999999999999,-103.62)
956	Michoacn-Guanajuato	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Michoacn-Guanajuato</b></font><br /><font size="5"><b>Mxico</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/058004.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 3860 m<br /><b>Latitude:</b> 19.85&deg;N<br /><b>Longitude:</b> 101.75&deg;W</td></tr><tr><td colspan="2"><p align="justify">The widespread Michoacn-Guanajuato volcanic field contains over 1400 vents, including the historically active cinder cones of Parcutin and Jorullo, covering a 200 x 250 km wide area of Michoacn and Guanajuato states in west-central Mxico.  Cinder cones are the predominant volcanic form, but small shield volcanoes, lava domes, maars and tuff rings (many in the Valle de Santiago area), and coneless lava flows are also present.  The shield volcanoes are mostly Pleistocene in age, and have morphologies similar to small Icelandic-type shield volcanoes, although the Michoacn-Guanajuato shields have higher slope angles and smaller basal diameters.  Jorullo, which was constructed in the 18th century, and Parcutin, which grew above a former cornfield during 1943-52, are the two best known of the roughly 1000 small volcanic centers scattered throughout the volcanic field.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-06=&amp;volpage=photos&amp;photo=058004">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-06=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(19.850000000000001,-101.75)
957	Zitcuaro-Valle de Bravo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Zitcuaro-Valle de Bravo</b></font><br /><font size="5"><b>Mxico</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/099078.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3500+ m<br /><b>Latitude:</b> 19.40&deg;N<br /><b>Longitude:</b> 100.25&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Zitcuaro-Valle de Bravo volcanic field in the central part of the Mexican Volcanic Belt consists of a broad region of shield volcanoes, lava domes, and cinder cones surrounding the city of Heroica de Zitcuaro.  The Zitcuaro volcanic complex itself, located SE of the city, was constructed within the 30-km-wide Las Tres Chicas caldera of Miocene age, which later underwent three post-caldera episodes of intra-caldera lava dome resurgence and included the intrusion of dacitic central lava domes, the emplacement of pyroclastic flows, and the eruption of andesitic lava flows.  The youngest dated activity at the complex produced La Dieta airfall deposit about 31,000 years ago, and persistent local seismicity continues at Zitcuaro.  The Valle de Bravo area to the south contains dominantly andesitic lava domes and flows, many of which were erupted along regional faults.  The youngest flows were erupted at the bottom of a fault-controlled canyon; the most recent of these, west of the Valle de Bravo lake, has been Argon-Argon dated at about 5200 +/- 2300 years, and morphology suggests a Holocene age for other cones.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-061&amp;volpage=photos&amp;photo=099078">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-061">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(19.399999999999999,-100.25)
958	Jocotitln	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Jocotitln</b></font><br /><font size="5"><b>Mxico</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/074045.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 3900+ m<br /><b>Latitude:</b> 19.73&deg;N<br /><b>Longitude:</b> 99.758&deg;W</td></tr><tr><td colspan="2"><p align="justify">Jocotitln is an isolated composite volcano that rises 1300 m above the Toluca basin 60 km WNW of Mexico City.  The 3900-m-high volcano was constructed during the Pleistocene of andesitic-to-dacitic lava flows.  A major obsidian-bearing dacitic plinian eruption was followed by the emplacement of a dacitic lava-dome complex, accompanied by lava effusion, pumice-fall eruptions, and pyroclastic surges.  The most prominent feature of the volcano is a horseshoe-shaped escarpment open to the NE that formed as a result of gravitational failure of the summit during the early Holocene.  The resulting debris-avalanche deposit covers an 80 sq km area to the NE.  Lava dome emplacement accompanied by pyroclastic flows and surges subsequently filled much of the avalanche scarp.  The latest known eruption occurred about 700 years ago and produced block-and-ash flows and pyroclastic surges.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-062&amp;volpage=photos&amp;photo=074045">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-062">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(19.73,-99.757999999999996)
959	Nevado de Toluca	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Nevado de Toluca</b></font><br /><font size="5"><b>Mxico</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/074043.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 4680+ m<br /><b>Latitude:</b> 19.108&deg;N<br /><b>Longitude:</b> 99.758&deg;W</td></tr><tr><td colspan="2"><p align="justify">Nevado de Toluca, Mxico's fourth highest peak, rises above the Toluca basin about 80 km west of Mexico City.  The broad, complex andesitic-dacitic stratovolcano, also known by the Nahuatl Indian name Xinantcatl, has a 1.5-km-wide summit crater that is open to the east.  A large dacitic lava dome in this crater separates two lakes, known as the lakes of the Sun and Moon.  At least three major edifice collapses during the Pleistocene produced large debris-avalanche and lahar deposits that affected broad areas below the volcano.  Four major explosive eruptions during the late Pleistocene produced widespread ashfall and pyroclastic-flow deposits at about 36,000, 21,700, 12,100, and 10,500 years ago, producing the Ochre and the Lower, Middle, and Upper Toluca Pumice deposits, respectively.   Recent work has revealed evidence for at least one Holocene eruption, about 3300 years ago, that produced pyroclastic flows and surges.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-07-&amp;volpage=photos&amp;photo=074043">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-07-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(19.108000000000001,-99.757999999999996)
960	Chichinautzin	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Chichinautzin</b></font><br /><font size="5"><b>Mxico</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/074065.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 3930+ m<br /><b>Latitude:</b> 19.08&deg;N<br /><b>Longitude:</b> 99.13&deg;W</td></tr><tr><td colspan="2"><p align="justify">The massive Chichinautzin volcanic field covers a 90-km-long, E-W-trending area immediately south of Mexico City.  The Sierra Chichinautzin, formed primarily of overlapping small cinder cones and shield volcanoes, creates a broad topographic barrier at the southern end of the Basin of Mexico that extends from the eastern flank of Nevado de Toluca to the western flank of Iztacchuatl volcano.  The volcanic field contains more than 220 Pleistocene-to-Holocene monogenetic vents.  The best-known eruption occurred about 1670 radiocarbon years ago from the Xitle scoria cone, NE of the Volcn Ajusco lava-dome complex, which at 3930 m forms the highest peak of the Sierra Chichinautzin.  The Xitle eruption produced a massive basaltic tube-fed lava flow that covered agricultural lands as well as pyramids and other structures of Cuicuilco and adjacent prehispanic urban centers.  The southern part of Mexico City and the National University of Mxico lie atop the distal end of the 13-km-long lava flow.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-08=&amp;volpage=photos&amp;photo=074065">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-08=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(19.079999999999998,-99.129999999999995)
961	Papayo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Papayo</b></font><br /><font size="5"><b>Mxico</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/076063.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 3600+ m<br /><b>Latitude:</b> 19.308&deg;N<br /><b>Longitude:</b> 98.70&deg;W</td></tr><tr><td colspan="2"><p align="justify">The 3600-m-high postglacial Papayo lava dome, constructed along the crest of the Sierra Nevada range, is dwarfed by its massive neighbor Iztacchuatl volcano, 15 km to the SW.  Papayo has been the source of voluminous dacitic lava flows that have traveled about 10 km from the vent both to the WSW and ENE.  The steep-sided Cerro Papayo dacitic lava dome, rising 230 m above the surrounding lava flows, marks the vent.  The 84 sq km compound lava field has a volume of about 21 cu km and includes flows that traveled long distances in opposite directions into the Valley of Mexico and toward the Puebla basin.  Papayo lavas overlie glacial moraines about 12,000 years old (Nixon 1989).  On the western side the flows surround the glaciated late-Pleistocene lava and pyroclastic cone of Iztaltetlac.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-081&amp;volpage=photos&amp;photo=076063">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-081">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(19.308,-98.700000000000003)
962	Iztacchuatl	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Iztacchuatl</b></font><br /><font size="5"><b>Mxico</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/074088.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 5230 m<br /><b>Latitude:</b> 19.179&deg;N<br /><b>Longitude:</b> 98.642&deg;W</td></tr><tr><td colspan="2"><p align="justify">Iztacchuatl, the &quot;Woman in White,&quot; presents the profile of a sleeping woman as seen from the Valley of Mexico.  A series of overlapping cones constructed along a NNW-SSE line to the south of the Pleistocene Llano Grande caldera forms the summit ridge of the massive 450 cu km volcano.  Andesitic and dacitic Pleistocene and Recent volcanism has taken place from vents at or near the summit of Volcn Iztacchuatl.  Valley headwalls near the summit vent (El Pecho) are draped with flows and tuff beds post-dating an 11,000 years before present glaciation.  The youngest vents are located at the summit and a depression at 5100 m along the summit ridge midway between El Pecho and Los Pies (White 1986).  Nixon (1989) considered all summit lavas to be Pleistocene in age, but noted a postglacial dacitic vent on the south flank of Iztacchuatl, north of the saddle between it and Popocatpetl.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-082&amp;volpage=photos&amp;photo=074088">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-082">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(19.178999999999998,-98.641999999999996)
963	Popocatpetl	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Popocatpetl</b></font><br /><font size="5"><b>Mxico</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/037089.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 5426 m<br /><b>Latitude:</b> 19.023&deg;N<br /><b>Longitude:</b> 98.622&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn Popocatpetl, whose name is the Aztec word for smoking mountain, towers to 5426 m 70 km SE of Mexico City to form North America's 2nd-highest volcano.  The glacier-clad stratovolcano contains a steep-walled, 400 x 600 m wide crater.  The generally symmetrical volcano is modified by the sharp-peaked Ventorrillo on the NW, a remnant of an earlier volcano.  At least three previous major cones were destroyed by gravitational failure during the Pleistocene, producing massive debris-avalanche deposits covering broad areas south of the volcano.  The modern volcano was constructed to the south of the late-Pleistocene to Holocene El Fraile cone.  Three major plinian eruptions, the most recent of which took place about 800 AD, have occurred from Popocatpetl since the mid Holocene, accompanied by pyroclastic flows and voluminous lahars that swept basins below the volcano.  Frequent historical eruptions, first recorded in Aztec codices, have occurred since precolumbian time.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-09=&amp;volpage=photos&amp;photo=037089">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-09=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(19.023,-98.622)
964	La Malinche	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>La Malinche</b></font><br /><font size="5"><b>Mxico</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/080004.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Tuff cones</td><td width="50%" align="left"><b>Summit Elev:</b> 4461 m<br /><b>Latitude:</b> 19.231&deg;N<br /><b>Longitude:</b> 98.032&deg;W</td></tr><tr><td colspan="2"><p align="justify">La Malinche is an eroded stratovolcano, cut by deep canyons, that rises to 4461 m NE of the city of Puebla.  Malinche occupies an isolated position between the Popocatpetl-Iztacchuatl and Orizaba-Cofre de Perote volcanic ranges.  Much of the andesitic-dacitic volcano was constructed during the Pleistocene, and the summit exhibits evidence of glacial erosion.  This volcano remains relatively unstudied, however, recent work has identified tephra layers of Holocene age that originated from Volcn la Malinche.  Several tuff cones and explosion craters, at least one of Holocene age, are found on the flanks of the volcano; one of the most prominent of these is the Xalapaxco tuff cone complex on the lower NE flank.  Holocene lahars from La Malinche associated with an eruption about 3100 years ago reached the Puebla basin and affected precolumbian settlements.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-091&amp;volpage=photos&amp;photo=080004">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-091">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(19.231000000000002,-98.031999999999996)
965	Serdn-Oriental	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Serdn-Oriental</b></font><br /><font size="5"><b>Mxico</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/076055.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Tuff cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 3485 m<br /><b>Latitude:</b> 19.27&deg;N<br /><b>Longitude:</b> 97.47&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Serdn-Oriental is a broad closed basin at the eastern end of the Mexican Altiplano dotted with rhyolitic lava domes, tuff cones, tuff rings, lava flows, and scoria cones of late-Pleistocene to Holocene age.  The basin, filled by extensive large lakes during the Pleistocene, is bounded by the Cofre de Perote-Orizaba range on the east and Los Humeros caldera to the north.  The most prominent features of the Serdn-Oriental volcanic field are the twin Las Derrumbadas lava domes, surrounded by an apron of debris-avalanche deposits, and the sharp-peaked Cerro Pizarro lava dome at the northern end of the basin.  Several of the tuff rings, such as Laguna Atexcac and Laguna Alchichica, are filled with scenic lakes.  A major explosive eruption from a vent inferred to be buried within the basin produced the Quetzalapa plinian pumice-fall deposit roughly 20,000 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-092&amp;volpage=photos&amp;photo=076055">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-092">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(19.27,-97.469999999999999)
966	Los Atlixcos	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Los Atlixcos</b></font><br /><font size="5"><b>Mxico</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/101085.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 800 m<br /><b>Latitude:</b> 19.809&deg;N<br /><b>Longitude:</b> 96.526&deg;W</td></tr><tr><td colspan="2"><p align="justify">Los Atlixcos, also known as Cerro el Abra, consists of a shield volcano topped by two large pyroclastic cones and associated lava fields at the eastern end of the Mexican Volcanic Belt along the Gulf of Mexico about 80 km NW of the city of Veracruz.  The two pyroclastic cones, both known as Cerro los Atlixcos, lie along an E-W line about 2 km apart; both cones are breached to the east.  A broad apron of basaltic lava flows extends primarily to the north and east, reaching as far as the coast.  The extent of the lava shield is defined by the Ro Santa Ana on the NE and the Ro El Tecun on the south.  The youthful morphology of the cones caused Negendank et al. (1985) to consider them to be of Holocene age.  Other pyroclastic cones of Quaternary age are located to the NW, and a group of cones and silicic lava domes of Tertiary-to-Quaternary age were constructed along the coast to the SE.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-094&amp;volpage=photos&amp;photo=101085">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-094">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(19.809000000000001,-96.525999999999996)
967	Naolinco Volcanic Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Naolinco Volcanic Field</b></font><br /><font size="5"><b>Mxico</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/075031.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2000+ m<br /><b>Latitude:</b> 19.67&deg;N<br /><b>Longitude:</b> 96.75&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Naolinco volcanic field in the Sierra de Chiconquiaco range north of Jalapa (Xalapa), the capital city of the state of Veracruz, consists of a broad area of scattered Quaternary pyroclastic cones and associated dominantly basaltic lava flows.   Late-Pleistocene to Holocene pyroclastic cones cover an E-W-trending area on both sides of  the town of Naolinco de Victoria.  The largest cone is 2000-m-high Cerro Acatln, located NE of Naolinco de Victoria.  This and other nearby cones have fed voluminous lava flows that traveled down regional gradients to the south and SE.   The Coacoatzintla lava flow from the Rincn de Chapultepec scoria cone in the western part of the field was erupted about 3000 years ago and is the youngest flow of the Naolinco volcanic field.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-095&amp;volpage=photos&amp;photo=075031">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-095">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(19.670000000000002,-96.75)
968	Cofre de Perote	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cofre de Perote</b></font><br /><font size="5"><b>Mxico</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/076081.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 4282 m<br /><b>Latitude:</b> 19.492&deg;N<br /><b>Longitude:</b> 97.15&deg;W</td></tr><tr><td colspan="2"><p align="justify">Cofre de Perote is a massive Quaternary andesitic-dacitic shield volcano that anchors the NNE end of a volcanic chain extending southward to Pico de Orizaba (Citlaltpetl) volcano.  Lava flows dominated in formation of the broad compound shield volcano, which is largely of Pleistocene age and is morphologically distinct from the steep-sided stratovolcanoes of the Mexican Volcanic Belt.  Glaciation at the summit has left a steep-sided, box-like peak, which is sometimes referred to as the &quot;Treasure Chest of Perote.&quot;  A large compound escarpment formed in part by multiple edifice collapses cuts the eastern side of the volcano.  Numerous monogenetic cinder cones, likely related to regional volcanism, were erupted through the flanks of Cofre de Perote volcano.  A cluster of very youthful basaltic cinder cones is located on the NE flank, and young lava flows have traveled eastward to beyond the major city of Xalapa (Jalapa), the capital of the state of Veracruz.  The youngest lava flow, from the compound El Volcancillo vent on the lower NE flank, was radiocarbon dated at about 900 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-096&amp;volpage=photos&amp;photo=076081">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-096">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(19.492000000000001,-97.150000000000006)
969	La Gloria	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>La Gloria</b></font><br /><font size="5"><b>Mxico</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/085082.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 3500+ m<br /><b>Latitude:</b> 19.33&deg;N<br /><b>Longitude:</b> 97.25&deg;W</td></tr><tr><td colspan="2"><p align="justify">A broad area of Quaternary volcanic rocks lies in a sparsely populated highland between Cofre de Perote and Las Cumbres volcanoes.  Two large arcuate east-facing scarps of uncertain origin are the most prominent features of the La Gloria volcanic field, whose name originates from the town at its NW base.   The complex is also known as the Desconocido-Tecomales volcanic field.  Numerous pyroclastic cones, some of which have a youthful morphology, are scattered throughout the complex on both sides of the escarpments.  The age of the most recent eruptions in this poorly studied region is not known, although some lava flows were classified by Negendank et al. (1985) as Holocene based on their youthful morphology.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-097&amp;volpage=photos&amp;photo=085082">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-097">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(19.329999999999998,-97.25)
970	Las Cumbres	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Las Cumbres</b></font><br /><font size="5"><b>Mxico</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/055023.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 3940+ m<br /><b>Latitude:</b> 19.15&deg;N<br /><b>Longitude:</b> 97.27&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Las Cumbres volcanic complex, a Quaternary center about 15 km NNE of Pico de Orizaba, contains a 3.5-4.5 km wide summit caldera narrowly breached on the east side.  A dacitic lava dome (Cerro Gordo or El Cumbre Grande) lies in the center of the caldera.  A group of monogenetic cones, explosion craters, and andesitic and rhyolitic lava domes is located north and south of Cerro las Cumbres.  Three of these, Xalista and El Rodeo to the north, and Ixetal to the south, are obsidian domes.  A major rhyolitic explosive eruption producing the Quetzalapa Pumice about 20,000 years ago originated from a vent on the lower NW flank of the Las Cumbres complex.  Eruptive activity at the main Las Cumbres complex ceased during the late Pleistocene, although activity on the flanks of the edifice continued into the Holocene.  The rhyolitic Yolotepec lava dome, north of Las Cumbres, has been radiocarbon dated at about 5900 years before present.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-098&amp;volpage=photos&amp;photo=055023">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-098">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(19.149999999999999,-97.269999999999996)
971	Pico de Orizaba	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Pico de Orizaba</b></font><br /><font size="5"><b>Mxico</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/055025.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 5675 m<br /><b>Latitude:</b> 19.030&deg;N<br /><b>Longitude:</b> 97.268&deg;W</td></tr><tr><td colspan="2"><p align="justify">Pico de Orizaba (Volcn Citlaltpetl), Mxico's highest peak and North America's highest volcano, was formed in three stages beginning during the mid-Pleistocene.  Orizaba lies at the southern end of a volcanic chain extending north to Cofre de Perote volcano and towers up to 4400 m above its eastern base.  Construction of the initial Torrecillas and Espoln de Oro volcanoes was contemporaneous with growth of Sierra Negra volcano on the SW flank and was followed by edifice collapses that produced voluminous debris avalanches and lahars.  The modern Citlaltpetl volcano was constructed during the late Pleistocene and Holocene of viscous andesitic and dacitic lavas, forming the current steep-sided cone.  Repetitive explosive eruptions beginning during the early Holocene accompanied lava dome growth and lava effusion.  Historical eruptions have consisted of moderate explosive activity and the effusion of dacitic lava flows.  The latest eruption of the volcano occurred during the 19th century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-10=&amp;volpage=photos&amp;photo=055025">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-10=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(19.030000000000001,-97.268000000000001)
972	San Martn	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>San Martn</b></font><br /><font size="5"><b>Mxico</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/038006.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 1650 m<br /><b>Latitude:</b> 18.57&deg;N<br /><b>Longitude:</b> 95.20&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn de San Martn, part of the Tuxtla volcanic field, is a broad alkaline shield volcano that rises above the Gulf of Mexico.  The massive volcano, also known as San Martn Tuxtla, is elongated in a NW-SE direction and is capped by a 1-km-wide summit crater.  The upper part of the 1650-m-high volcano is covered with dense tropical rain forests.  The summit and flanks of San Martn are dotted with more than 250 pyroclastic cones and maars.  Well-preserved cinder cones are abundant between the summit of the volcano and Laguna Catemaco on the SE flank.  Holocene cones in this area produced ash deposits that buried recently discovered stone pyramids.  The two largest historical eruptions of San Martn took place in 1664 and 1793.  The 1793 eruption occurred from two cinder cones in the summit crater and produced widespread ashfall and lava flows that extended 3.5 km down the NE flank.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-11=&amp;volpage=photos&amp;photo=038006">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-11=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(18.57,-95.200000000000003)
973	El Chichn	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>El Chichn</b></font><br /><font size="5"><b>Mxico</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/077092.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Tuff cones<br />&nbsp;&nbsp;&nbsp; Explosion crater</td><td width="50%" align="left"><b>Summit Elev:</b> 1150? m<br /><b>Latitude:</b> 17.360&deg;N<br /><b>Longitude:</b> 93.228&deg;W</td></tr><tr><td colspan="2"><p align="justify">El Chichn is a small, but powerful trachyandesitic tuff cone and lava dome complex that occupies an isolated part of the Chiapas region in SE Mxico far from other Holocene volcanoes.  Prior to 1982, this relatively unknown volcano was heavily forested and of no greater height than adjacent nonvolcanic peaks.  The largest dome, the former summit of the volcano, was constructed within a 1.6 x 2 km summit crater created about 220,000 years ago.  Two other large craters are located on the SW and SE flanks; a lava dome fills the SW crater, and an older dome is located on the NW flank.  More than ten large explosive eruptions have occurred since the mid-Holocene.  The powerful 1982 explosive eruptions of high-sulfur, anhydrite-bearing magma destroyed the summit lava dome and were accompanied by pyroclastic flows and surges that devastated an area extending about 8 km around the volcano.  The eruptions created a new 1-km-wide, 300-m-deep crater that now contains an acidic crater lake.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-12=&amp;volpage=photos&amp;photo=077092">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-12=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(17.359999999999999,-93.227999999999994)
974	Tacan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tacan</b></font><br /><font size="5"><b>Mxico-Guatemala border</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/077095.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 4060 m<br /><b>Latitude:</b> 15.130&deg;N<br /><b>Longitude:</b> 92.112&deg;W</td></tr><tr><td colspan="2"><p align="justify">Tacan is a 4060-m-high composite stratovolcano that straddles the Mxico/Guatemala border at the NW end of the Central American volcanic belt.  The volcano rises 1800 m above deeply dissected plutonic and metamorphic terrain.  Three large calderas breached to the south, and the elongated summit region is dominated by a series of lava domes intruded along a NE-SW trend.  Volcanism has migrated to the SW, and a small adventive lava dome is located in the crater of the youngest volcano, San Antonio, on the upper SW flank.  Viscous lava flow complexes are found on the north and south flanks, and lobate lahar deposits fill many valleys.  Radial drainages on the Guatemalan side are deflected by surrounding mountains into the Pacific coastal plain on the SW side of the volcano.  Historical activity at Tacan has been restricted to mild phreatic eruptions, but more powerful explosive activity, including the production of pyroclastic flows, has occurred as recently as about 1950 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-13=&amp;volpage=photos&amp;photo=077095">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1401-13=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.cenapred.unam.mx/es/Instrumentacion/InstVolcanica/MVolcan/">CENAPRED, Mxico</a></td></tr></table>	(15.130000000000001,-92.111999999999995)
975	Tajumulco	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tajumulco</b></font><br /><font size="5"><b>Guatemala</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/077099.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Compound volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 4220 m<br /><b>Latitude:</b> 15.034&deg;N<br /><b>Longitude:</b> 91.903&deg;W</td></tr><tr><td colspan="2"><p align="justify">Tajumulco is Guatemala's highest peak and the highest volcano in Central America.  Two summits, one with a 50-70 m wide crater, lie along a NW-SE line.   A lava flow from the 4220-m-high NW summit traveled down a deep valley on the NW flank.  The andesitic-dacitic volcano was constructed over the NW end of a large arcuate SW-facing escarpment of uncertain origin.  Tajumulco has had several unconfirmed reports of historical eruptions.  Sapper (1917) considered Tajumulco to have erupted during historical time, but without accurate dates.  The volcano was reported to eject many rocks, destroying houses on October 24, 1765, but this may have been a rock avalanche.  Juarros reported some eruptions before 1808, and there are unlikely reports of eruptions in 1821 (or 1822), 1863, and 1893 (Incer 1988, unpublished manuscript).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-02=&amp;volpage=photos&amp;photo=077099">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.insivumeh.gob.gt/geofisica/programa.htm">INSIVUMEH, Guatemala</a></td></tr></table>	(15.034000000000001,-91.903000000000006)
976	Santa Mara	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Santa Mara</b></font><br /><font size="5"><b>Guatemala</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/078011.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 3772 m<br /><b>Latitude:</b> 14.756&deg;N<br /><b>Longitude:</b> 91.552&deg;W</td></tr><tr><td colspan="2"><p align="justify">Symmetrical, forest-covered Santa Mara volcano is one of the most prominent of a chain of large stratovolcanoes that rises dramatically above the Pacific coastal plain of Guatemala.  The 3772-m-high stratovolcano has a sharp-topped, conical profile that is cut on the SW flank by a large, 1.5-km-wide crater.  The oval-shaped crater extends from just below the summit of Volcn Santa Mara to the lower flank and was formed during a catastrophic eruption in 1902.  The renowned plinian eruption of 1902 that devastated much of SW Guatemala followed a long repose period after construction of the large basaltic-andesite stratovolcano.  The massive dacitic Santiaguito lava-dome complex has been growing at the base of the 1902 crater since 1922.  Compound dome growth at Santiaguito has occurred episodically from four westward-younging vents, the most recent of which is Caliente.  Dome growth has been accompanied by almost continuous minor explosions, with periodic lava extrusion, larger explosions, pyroclastic flows, and lahars.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-03=&amp;volpage=photos&amp;photo=078011">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.insivumeh.gob.gt/geofisica/programa.htm">INSIVUMEH, Guatemala</a></td></tr></table>	(14.756,-91.552000000000007)
977	Almolonga	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Almolonga</b></font><br /><font size="5"><b>Guatemala</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/038077.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 3197 m<br /><b>Latitude:</b> 14.82&deg;N<br /><b>Longitude:</b> 91.48&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn de Almolonga is an andesitic stratovolcano with a 3.3-km-wide late-Pleistocene central caldera that is located along the Zunil fault zone.  The caldera is surrounded by a ring-dike configuration of dacitic and rhyolitic lava domes.  The youngest and only historically active dome complex is Cerro Quemado (whose name means Burned Peak), located immediately south of Guatemala's second largest city, Quezaltenango.  About 1200 radiocarbon years ago, part of the andesitic-to-dacitic Cerro Quemado dome collapsed, producing a debris avalanche and an associated lateral explosion that swept across the valley to the west as far as the flanks of Siete Orejas volcano.  The latest eruption in 1818 produced a blocky 2.5-km-long lava flow.  Hot springs are located on the northern and eastern flanks of Cerro Quemado, and the Zunl geothermal field, the site of a geothermal exploration project, lies on the SE flank of Cerro Quemado.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-04=&amp;volpage=photos&amp;photo=038077">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-04=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.insivumeh.gob.gt/geofisica/programa.htm">INSIVUMEH, Guatemala</a></td></tr></table>	(14.82,-91.480000000000004)
978	Atitln	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Atitln</b></font><br /><font size="5"><b>Guatemala</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/078053.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Twin volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 3535 m<br /><b>Latitude:</b> 14.583&deg;N<br /><b>Longitude:</b> 91.186&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn Atitln is one of several prominent conical stratovolcanoes in the Guatemalan highlands.  Along with its twin volcano Tolimn to the north, it forms a dramatic backdrop to Lake Atitln, one of the scenic highlights of the country.  The 3535-m-high summit of Atitln directly overlies the inferred margin of the Pleistocene Atitln III caldera and is the highest of three large post-caldera stratovolcanoes constructed near the southern caldera rim.  The volcano consequently post-dates the eruption of the voluminous, roughly 85,000-year-old rhyolitic Los Chocoyos tephra associated with formation of  the Atitln III caldera.  The historically active andesitic Volcn Atitln is younger than Tolimn, although their earlier activity overlapped.  In contrast to Tolimn, Atitln displays a thick pyroclastic cover.  The northern side of the volcano is wooded to near the summit, whereas the upper 1000 m of the southern slopes are unvegetated.  Predominantly explosive eruptions have been recorded from Volcn Atitln since the 15th century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-06=&amp;volpage=photos&amp;photo=078053">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-06=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.insivumeh.gob.gt/geofisica/programa.htm">INSIVUMEH, Guatemala</a></td></tr></table>	(14.583,-91.186000000000007)
979	Tolimn	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tolimn</b></font><br /><font size="5"><b>Guatemala</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/078052.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Twin volcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 3158 m<br /><b>Latitude:</b> 14.612&deg;N<br /><b>Longitude:</b> 91.189&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn Tolimn is a large andesitic stratovolcano that rises above the south shore of Lake Atitln.  Tolimn was constructed within the Pleistocene Atitln III caldera, near its inferred southern margin.  A shallow elliptical crater truncates the summit, and a minor subsidiary peak to the SSW also has a shallow crater.  In contrast to the tephra-covered surface of its twin volcano to the south, Volcn Atitln, the surface of Tolimn is draped by prominent thick lava flows.  Many of the flows were erupted from vents on the volcano's flanks and form a highly irregular shoreline on the south side of Lake Atitln.  No historical eruptions are known from Tolimn.  However, a lava flow that entered Lake Atitln from the parasitic lava dome of Cerro de Oro on the northern flank was considered by Newhall et al. (1987) to be less than a few thousand years old based on the thickness of sediment accumulated on the sublacustral part of the flow.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-07=&amp;volpage=photos&amp;photo=078052">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-07=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.insivumeh.gob.gt/geofisica/programa.htm">INSIVUMEH, Guatemala</a></td></tr></table>	(14.612,-91.188999999999993)
980	Acatenango	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Acatenango</b></font><br /><font size="5"><b>Guatemala</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/078080.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Twin volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 3976 m<br /><b>Latitude:</b> 14.501&deg;N<br /><b>Longitude:</b> 90.876&deg;W</td></tr><tr><td colspan="2"><p align="justify">Acatenango, along with its twin volcano  to the south, Volcn Fuego, overlooks the historic former capital city of Antigua, Guatemala.  Acatenango, which has two principal summits, was constructed during three eruptive periods post-dating the roughly 85,000-year-old Los Chocoyos tephra from Atitln caldera.  An ancestral Acatenango volcano collapsed to the south sometime prior to 43,000 years ago, forming La Democracia debris-avalanche deposit, which covers a wide area of the Pacific coastal plain.  Construction of Yepocapa, the northern summit of Acatenango, was completed about 20,000 years ago, after which growth of the southern and highest cone, Pico Central (also known as Pico Mayor), began.  The first well-documented eruptions of Acatenango took place from 1924 to 1927, although earlier historical eruptions may have occurred.  Francisco Vasquez, writing in 1690, noted that in 1661 a volcano that lay aside of Fuego &quot;opened a smoking mouth and still gives off smoke from another three, but without noise.&quot;</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-08=&amp;volpage=photos&amp;photo=078080">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-08=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.insivumeh.gob.gt/geofisica/programa.htm">INSIVUMEH, Guatemala</a></td></tr></table>	(14.500999999999999,-90.876000000000005)
981	Fuego	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Fuego</b></font><br /><font size="5"><b>Guatemala</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/039003.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Twin volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 3763 m<br /><b>Latitude:</b> 14.473&deg;N<br /><b>Longitude:</b> 90.880&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn Fuego, one of Central America's most active volcanoes, is one of three large stratovolcanoes overlooking Guatemala's former capital, Antigua.  The scarp of an older edifice, Meseta, lies between 3763-m-high Fuego and its twin volcano to the north, Acatenango.  Construction of Meseta volcano dates back to about 230,000 years and continued until the late Pleistocene or early Holocene.  Collapse of Meseta volcano may have produced the massive Escuintla debris-avalanche deposit, which extends about 50 km onto the Pacific coastal plain.  Growth of the modern Fuego volcano followed, continuing the southward migration of volcanism that began at Acatenango.  In contrast to the mostly andesitic Acatenango volcano, eruptions at Fuego have become more mafic with time, and most historical activity has produced basaltic rocks.  Frequent vigorous historical eruptions have been recorded at Fuego since the onset of the Spanish era in 1524, and have produced major ashfalls, along with occasional pyroclastic flows and lava flows.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-09=&amp;volpage=photos&amp;photo=039003">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-09=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.insivumeh.gob.gt/geofisica/programa.htm">INSIVUMEH, Guatemala</a></td></tr></table>	(14.473000000000001,-90.879999999999995)
982	Agua	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Agua</b></font><br /><font size="5"><b>Guatemala</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/046038.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 3760 m<br /><b>Latitude:</b> 14.465&deg;N<br /><b>Longitude:</b> 90.743&deg;W</td></tr><tr><td colspan="2"><p align="justify">The symmetrical, forested Volcn de Agua stratovolcano forms an impressive backdrop to the historic former capital city of Antigua Guatemala, opposite the twin volcanoes of Fuego and Acatenango.  The 3760-m-high basaltic-andesite to andesite Agua volcano has an isolated position that makes it a prominent landmark from all directions.  A small, 280-m-wide circular crater is breached on the NNE side.  Six small pit craters are located on the NW flank, and two small cones lie on the south flank.  Agua's symmetrical profile implies a relatively young age, although currently no dated Holocene tephra deposits are known.  Agua has had no historical eruptions, but its name (the water volcano) originates from a devastating mudflow on September 11, 1541.  The mudflow destroyed the first Guatemalan capital city established by the Spanish Conquistadors, which is now known as Ciudad Vieja.  The catastrophe prompted the establishment of a new capital city at nearby Antigua.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-10=&amp;volpage=photos&amp;photo=046038">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-10=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.insivumeh.gob.gt/geofisica/programa.htm">INSIVUMEH, Guatemala</a></td></tr></table>	(14.465,-90.742999999999995)
983	Pacaya	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Pacaya</b></font><br /><font size="5"><b>Guatemala</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/079002.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 2552 m<br /><b>Latitude:</b> 14.381&deg;N<br /><b>Longitude:</b> 90.601&deg;W</td></tr><tr><td colspan="2"><p align="justify">Eruptions from Pacaya, one of Guatemala's most active volcanoes, are frequently visible from Guatemala City, the nation's capital.  Pacaya is a complex basaltic volcano constructed just outside the southern topographic rim of the 14 x 16 km Pleistocene Amatitln caldera.  A cluster of dacitic lava domes occupies the southern caldera floor.  The post-caldera Pacaya massif includes the Cerro Grande lava dome and a younger volcano to the SW.  Collapse of Pacaya volcano about 1100 years ago produced a debris-avalanche deposit that extends 25 km onto the Pacific coastal plain and left an arcuate somma rim inside which the modern Pacaya volcano (MacKenney cone) grew.  A subsidiary crater, Cerro Chino, was constructed on the NW somma rim and was last active in the 19th century.  During the past several decades, activity at Pacaya has consisted of frequent strombolian eruptions with intermittent lava flow extrusion that has partially filled in the caldera moat and armored the flanks of MacKenney cone, punctuated by occasional larger explosive eruptions that partially destroy the summit of the cone.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-11=&amp;volpage=photos&amp;photo=079002">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-11=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.insivumeh.gob.gt/geofisica/programa.htm">INSIVUMEH, Guatemala</a></td></tr></table>	(14.381,-90.600999999999999)
984	Cuilapa-Barbarena	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cuilapa-Barbarena</b></font><br /><font size="5"><b>Guatemala</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/040023.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 1454 m<br /><b>Latitude:</b> 14.33&deg;N<br /><b>Longitude:</b> 90.40&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Cuilapa-Barbarena volcanic field contains approximately 70 Quaternary cinder cones, generally less than 100 m high.  Many of the mostly basaltic cones are located along the strike of the major regional Jalpatagua fault, which extends SE from Guatemala City, north of the chain of stratovolcanoes stretching across Guatemala.  The cones were erupted from fracture systems related to the intersection of the Jalpatagua fault with the southern and western margins of the Miocene Santa Rosa de Lima caldera and overlie pyroclastic-flow deposits from Amatitln caldera to the NW.  The age of the most recent eruptions is not known, although the youngest cones post-date the last phase of eruptive activity at Tecuamburro volcano and could be of Holocene age (Reynolds, 1987).  Williams (1960) considered the most recent eruptions from the Cuilapa-Barbarena volcanic field to have occurred within the last few thousand years.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-111&amp;volpage=photos&amp;photo=040023">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-111">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.insivumeh.gob.gt/geofisica/programa.htm">INSIVUMEH, Guatemala</a></td></tr></table>	(14.33,-90.400000000000006)
985	Tecuamburro	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tecuamburro</b></font><br /><font size="5"><b>Guatemala</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/040024.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Tuff ring</td><td width="50%" align="left"><b>Summit Elev:</b> 1845 m<br /><b>Latitude:</b> 14.156&deg;N<br /><b>Longitude:</b> 90.407&deg;W</td></tr><tr><td colspan="2"><p align="justify">Tecuamburro is a small, forested stratovolcano or large lava-dome complex of mostly Pleistocene age.  It is located about 50 km ESE of Guatemala City, about 20 km south of the main volcanic chain.  An ancestral andesitic stratovolcano, Miraflores, was formed about 100,000 years ago.  Tecuamburro and other lava domes were constructed during the late Pleistocene or early Holocene within a horseshoe-shaped, east-facing caldera produced by structural failure of the older Miraflores stratovolcano prior to about 38,000 years ago.  One of the largest of these domes, Pea Blanca, overtops the NW rim of the collapse scarp.  Two nested craters, the larger of which is Chupadero, lie at the NW end of the complex.  The smaller crater is a phreatic tuff ring, Laguna Ixpaco, that was formed about 2900 years ago during the latest dated eruption of the Tecuamburro complex.  Numerous fumaroles, hot springs, and boiling mud pots are found in the area around the acidic lake.  No historical eruptions are known from Tecuamburro.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-12=&amp;volpage=photos&amp;photo=040024">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-12=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.insivumeh.gob.gt/geofisica/programa.htm">INSIVUMEH, Guatemala</a></td></tr></table>	(14.156000000000001,-90.406999999999996)
986	Moyuta	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Moyuta</b></font><br /><font size="5"><b>Guatemala</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/040033.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1662 m<br /><b>Latitude:</b> 14.03&deg;N<br /><b>Longitude:</b> 90.10&deg;W</td></tr><tr><td colspan="2"><p align="justify">Moyuta is the easternmost of a chain of large stratovolcanoes extending along the volcanic front of Guatemala.  Like Tecuamburro volcano, Moyuta is offset about 20 km south of the main volcanic chain and lies south of the Jalpatagua Fault, overlying the southern boundary of the Jalpatagua Graben.  The 1662-m-high volcano is capped by a cluster of at least three forested, steep-sided, coalescing andesitic lava domes that from some distant perspectives give the summit a flat-topped appearance.  Numerous cinder cones in various stages of erosion are located on the flanks of the complex.  The age of the latest eruption of Moyuta volcano is not known, although the summit domes were considered to have been emplaced in relatively recent times (Williams et al., 1964).  Small fumaroles are found on the northern and southern flanks of the volcano, and hot springs are located near Azulco at the NE base and along rivers on the SE side of Moyuta.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-13-&amp;volpage=photos&amp;photo=040033">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-13-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.insivumeh.gob.gt/geofisica/programa.htm">INSIVUMEH, Guatemala</a></td></tr></table>	(14.029999999999999,-90.099999999999994)
987	Flores	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Flores</b></font><br /><font size="5"><b>Guatemala</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/077076.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 1600+ m<br /><b>Latitude:</b> 14.308&deg;N<br /><b>Longitude:</b> 89.992&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn de Flores is one of the largest of a cluster of small stratovolcanoes located in SE Guatemala behind the volcanic front.  Volcn de Flores, also known as Volcn Amayo, lies about 10 km west of the city of Jutiapa, at the SW end of the SE Guatemala volcanic platform.  The 1600-m-high summit rises up to 600 m above a basement of Cretaceous and Tertiary sedimentary rocks and contains a shallow crater breached on its eastern side.  Satellitic cones occur at the southern and eastern base of the dominantly basaltic Flores volcano.  Youthful lava flows occur at the NE base of the volcano, near El Aguacite.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-14-&amp;volpage=photos&amp;photo=077076">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-14-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.insivumeh.gob.gt/geofisica/programa.htm">INSIVUMEH, Guatemala</a></td></tr></table>	(14.308,-89.992000000000004)
988	Tahual	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tahual</b></font><br /><font size="5"><b>Guatemala</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/040038.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Cinder cone</td><td width="50%" align="left"><b>Summit Elev:</b> 1716 m<br /><b>Latitude:</b> 14.43&deg;N<br /><b>Longitude:</b> 89.90&deg;W</td></tr><tr><td colspan="2"><p align="justify">Deeply dissected Volcn Tahual rises about 700 m above plains south of the town of Monjas.  The summit of the 1716-m-high forested stratovolcano is cut by a broad erosional crater that extends to the base of the volcano and is narrowly breached to the NE.  A Holocene pyroclastic cone near the NE base of Volcn Tahual fed a short basaltic lava flow (Williams et al., 1964).  The scenic lake-filled Laguna de Hoyo lies north of the volcano.  This steep-walled crater and the NE-flank cinder cone lie along faults bordering a graben that extends across the eastern base of the volcano to neighboring Retana caldera on the SE.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-141&amp;volpage=photos&amp;photo=040038">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-141">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.insivumeh.gob.gt/geofisica/programa.htm">INSIVUMEH, Guatemala</a></td></tr></table>	(14.43,-89.900000000000006)
989	Cerro Santiago	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cerro Santiago</b></font><br /><font size="5"><b>Guatemala</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/077055.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 1192 m<br /><b>Latitude:</b> 14.33&deg;N<br /><b>Longitude:</b> 89.87&deg;W</td></tr><tr><td colspan="2"><p align="justify">A cluster of cinder cones and low shield volcanoes surrounds the city of Jutiapa in SE Guatemala.  The most prominent feature is Cerro Santiago, one of two coalescing cinder cones capping a low shield volcano SE of Jutiapa.  Youthful flows from the twin Los Cerritos cones NE of Jutiapa cross the Interamerican highway.  Volcn Culma forms a steep-sided basaltic lava mound immediately east of the city.  To the west lies Cerro Gordo (referred to by Williams et al., 1964 as Volcano Amayo), a craterless cinder cone surrounded by basaltic lava flows.  It is one of several cinder cones to have produced lava flows that blanket the landscape between Jutiapa and Tertiary volcanic hills to the south.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-15-&amp;volpage=photos&amp;photo=077055">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-15-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.insivumeh.gob.gt/geofisica/programa.htm">INSIVUMEH, Guatemala</a></td></tr></table>	(14.33,-89.870000000000005)
990	Suchitn	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Suchitn</b></font><br /><font size="5"><b>Guatemala</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/040035.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 2042 m<br /><b>Latitude:</b> 14.40&deg;N<br /><b>Longitude:</b> 89.78&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn Suchitn, NE of the city of Jutiapa, is one of the largest volcanoes in SE Guatemala.  The 2042-m-high summit of the andesitic-to-basaltic stratovolcano is elongated in a N-S direction.  Several large canyons cut the slopes of the dominantly andesitic edifice.  A large parasitic cone, Cerro Mataltepe, is located on the upper northern flank, and two smaller cones are located on the lower northern flank.  Two basaltic lava flows of Holocene age are located on the northern and NW flanks (Williams et al., 1964), and many flank vents are basaltic.  Suchitn was constructed immediately to the east of the 5-km-wide basaltic-to-dacitic Retana caldera, formed in part in association with the eruption of a dacitic pumice deposit.  Steep walls 60-250-m high rise above the flat caldera floor.  One of the latest basaltic lava flows from Suchitn flowed through a low notch in the eastern caldera rim.  Several lava cones and a maar are located along a N-S line north of Retana caldera.  A reported eruption of Suchitn in 1469 is considered to have actually been from Atitln volcano in the Guatemalan highlands.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-16-&amp;volpage=photos&amp;photo=040035">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-16-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.insivumeh.gob.gt/geofisica/programa.htm">INSIVUMEH, Guatemala</a></td></tr></table>	(14.4,-89.780000000000001)
991	Chingo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Chingo</b></font><br /><font size="5"><b>Guatemala</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/073086.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1775 m<br /><b>Latitude:</b> 14.12&deg;N<br /><b>Longitude:</b> 89.73&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn Chingo is a symmetrical stratovolcano that straddles the Guatemala/El Salvador border.  The 1775-m-high conical volcano rises 900 m above its surroundings and is the most prominent regional landmark.  A shallow, oval-shaped summit crater is breached on the western side.  No historical eruptions are known from the Volcn Chingo volcanic field.  Other small stratovolcanoes and cinder cones are located on both sides of the volcano along a major N-S-trending fault.  Other youthful cones, such as Cerro de Olla, lie across the Salvadorian border to the south.  To the north in Guatemala, Volcn las Viboras, a cinder cone that caps a basaltic shield volcano, is the most prominent of several fault-controlled cones near Laguna Atescatempo.  Flank fissures have fed many youthful lava flows, particularly on the western flank of Chingo and the northern flank of Volcn las Viboras.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-17-&amp;volpage=photos&amp;photo=073086">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-17-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.insivumeh.gob.gt/geofisica/programa.htm">INSIVUMEH, Guatemala</a></td></tr></table>	(14.119999999999999,-89.730000000000004)
992	Ixtepeque	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ixtepeque</b></font><br /><font size="5"><b>Guatemala</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/040039.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1292 m<br /><b>Latitude:</b> 14.42&deg;N<br /><b>Longitude:</b> 89.68&deg;W</td></tr><tr><td colspan="2"><p align="justify">Ixtepeque volcano, which takes its name from the Aztec word for obsidian, is perhaps the largest obsidian field in North America.  A 4 x 5 km wide rhyolitic obsidian lava field was erupted within the Ipala graben from a craterless vent along a NE-trending fissure that passes through adjacent rhyolitic lava domes and basaltic cinder cones.  Obsidian from Ixtepeque has shown up at archaeological sites across Central America.  Flat-lying pumice beds produced by explosive eruptions preceding lava effusion are found locally around the volcano.  Other obsidian flows originated from lava domes NE of Ixtepeque.  These rhyolitic vents are interspersed with basaltic cinder cones and lava flows.  Laguna de Obrajuelo is a complex cone cut by a large crater more than a km in diameter.  Initial basaltic eruptions were followed by the extrusion of obsidian flows and the eruption of rhyolitic pumice that were considered by Williams et al. (1964) to be only a few thousand years old.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-18-&amp;volpage=photos&amp;photo=040039">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-18-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.insivumeh.gob.gt/geofisica/programa.htm">INSIVUMEH, Guatemala</a></td></tr></table>	(14.42,-89.680000000000007)
993	Ipala	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ipala</b></font><br /><font size="5"><b>Guatemala</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/040040.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1650 m<br /><b>Latitude:</b> 14.55&deg;N<br /><b>Longitude:</b> 89.63&deg;W</td></tr><tr><td colspan="2"><p align="justify">Ipala is a small but prominent stratovolcano that extends nearly across the full width of the Ipala graben and rises 750 m above the graben floor.  The 1650-m-high summit of Volcn Ipala is truncated by a 1-km-wide crater whose steep, 150-m-high walls tower above a lake.  A prominent parasitic cone, Monte Rico, is located on the southern flank; it and other cones on the northern flank lie along a N-S-trending fracture that continues well beyond the southern flank of the volcano.  The eastern flank of Ipala is cut by a 17-km long, NNE-SSW fissure that produced a conspicuous line of Holocene cinder cones that fed basaltic lava flows covering about 20 sq km.  Diaz reported that in 1865 Ipala ejected ash from January 24 to June.  He listed no source and the report seems improbable (Incer 1988, unpublished manuscript).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-19-&amp;volpage=photos&amp;photo=040040">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-19-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.insivumeh.gob.gt/geofisica/programa.htm">INSIVUMEH, Guatemala</a></td></tr></table>	(14.550000000000001,-89.629999999999995)
994	Chiquimula Volcanic Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Chiquimula Volcanic Field</b></font><br /><font size="5"><b>Guatemala</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/077064.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Lava cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1192 m<br /><b>Latitude:</b> 14.83&deg;N<br /><b>Longitude:</b> 89.55&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Chiquimula volcanic field occupies a fault-bounded basin underlain by Cretaceous plutonic rocks in the Chiquimula Valley of SE Guatemala.  Initial eruptions during the Pleistocene produced mesa-forming basaltic lava flows along the N-S-trending fault forming the eastern edge of the Ipala graben.  These were followed by the eruption of widespread lava flows NW of Chiquimula town that covered about 12 sq km.  The most recent eruptions produced basaltic cinder cones and lava flows near the northern edge of Chiquimula town.  The cinder cones were constructed along a N-S-trending fracture, with Cerro Grande at the northern end being the largest and Cerro Chiquito at the southern end being the youngest.  The lava flows from Cerro Chiquito are so fresh and sparsely vegetated they were considered by Williams et al. (1964) to possibly be less than 1000 years old.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-20-&amp;volpage=photos&amp;photo=077064">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-20-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.insivumeh.gob.gt/geofisica/programa.htm">INSIVUMEH, Guatemala</a></td></tr></table>	(14.83,-89.549999999999997)
995	Quezaltepeque	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Quezaltepeque</b></font><br /><font size="5"><b>Guatemala</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/114071.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 1200 m<br /><b>Latitude:</b> 14.57&deg;N<br /><b>Longitude:</b> 89.45&deg;W</td></tr><tr><td colspan="2"><p align="justify">A series of youthful lava flows was erupted from vents cutting through Tertiary pyroclastic rocks WNW of Ipala volcano about 5 km south of the town of Quezaltepeque.  These basaltic flows issued passively from vents along a N-S-trending fault without accompanying explosive activity.  The vents are capped by low mounds of lava.  The flows were considered to be of Holocene age by Williams et al. (1964).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-21-&amp;volpage=photos&amp;photo=114071">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1402-21-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.insivumeh.gob.gt/geofisica/programa.htm">INSIVUMEH, Guatemala</a></td></tr></table>	(14.57,-89.450000000000003)
996	San Diego	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>San Diego</b></font><br /><font size="5"><b>El Salvador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/073078.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 781 m<br /><b>Latitude:</b> 14.27&deg;N<br /><b>Longitude:</b> 89.48&deg;W</td></tr><tr><td colspan="2"><p align="justify">An extensive volcanic field of fresh-looking basaltic cinder cones and barren lava flows near Lake Gija, which straddles the border between El Salvador and Guatemala, is named after its largest feature, 781-m-high Volcn de San Diego.  A large basaltic lava flow from the San Diego cinder cone dammed the drainage and was responsible for the formation of Lake Gija.  Volcanism is concentrated in two areas near Lake Gija--an area of volcanic cones including San Diego east of the lake, and an area of small cones north of the lake near the Guatemalan border, north of the Ro Ostua.  None of the eruptions in the San Diego volcanic field have been dated, but Williams and McBirney (1955) estimated that the latest eruption occurred within the past few thousand years.  Quaternary volcanic rocks are also located across Lake Gija in Guatemala.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-001&amp;volpage=photos&amp;photo=073078">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-001">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.snet.gob.sv/">Servicio Nacional de Estudios Territoriales</a></td></tr></table>	(14.27,-89.480000000000004)
997	Cerro Singil	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cerro Singil</b></font><br /><font size="5"><b>El Salvador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/073067.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Explosion craters</td><td width="50%" align="left"><b>Summit Elev:</b> 957 m<br /><b>Latitude:</b> 14.05&deg;N<br /><b>Longitude:</b> 89.65&deg;W</td></tr><tr><td colspan="2"><p align="justify">The most prominent feature of a volcanic field in the interior valley of El Salvador near the Guatemalan border SE of Volcn Chingo is Cerro Singil.  This 957-m-high scoria cone, also known as El Cerron, has a well-preserved summit crater and is part of a group of cinder cones and explosion craters mapped as Holocene in age by Weber and Wiesemann (1978).  A young basaltic lava flow extends to the NNE down the valley of the Quebada La Presa, the headwaters of the Ro Guajoyo.  The volcanic field includes a line of three NNE-trending explosion craters north of the city of Chalchuapa, the highest of which is 1035-m-high Cerro Tablas.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-002&amp;volpage=photos&amp;photo=073067">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-002">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.snet.gob.sv/">Servicio Nacional de Estudios Territoriales</a></td></tr></table>	(14.050000000000001,-89.650000000000006)
998	Apaneca Range	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Apaneca Range</b></font><br /><font size="5"><b>El Salvador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/077031.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2036 m<br /><b>Latitude:</b> 13.891&deg;N<br /><b>Longitude:</b> 89.786&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Apaneca Range (also known as the Cuyanausul Range) consists of an elongated group of roughly E-W-trending basaltic-to-andesitic Pleistocene and Holocene stratovolcanoes in western El Salvador between the Santa Ana complex and the Guatemala border.  The 5 x 3.5 km wide Pleistocene dacitic-rhyolitic Concepcin de Ataco caldera lies at the western end of the complex, along with post-caldera late-Pleistocene to Holocene andesitic-dacitic lava domes.  The post-caldera cones of Cerro el Aguila (at 2036 m the highest peak of the complex) and Cerro los Naranjos volcano at the eastern end of the chain were mapped as Holocene by Weber and Weisemann (1978).  Young craters on basaltic Laguna Verde stratovolcano may also have been active during the Holocene.  Numerous fumarole fields are located on the northern flank of the range, and the Ahuachapn geothermal field has been producing since 1975.  Several small hydrothermal explosions have occurred in historical time, including one in October 1990 at the Agua Shuca thermal area in which 26 persons were killed.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-01=&amp;volpage=photos&amp;photo=077031">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.snet.gob.sv/">Servicio Nacional de Estudios Territoriales</a></td></tr></table>	(13.891,-89.786000000000001)
999	Santa Ana	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Santa Ana</b></font><br /><font size="5"><b>El Salvador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/040042.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2381 m<br /><b>Latitude:</b> 13.853&deg;N<br /><b>Longitude:</b> 89.630&deg;W</td></tr><tr><td colspan="2"><p align="justify">Santa Ana, El Salvador's highest volcano, is a massive, 2381-m-high, dominantly andesitic-to-trachyandesitic stratovolcano that rises immediately west of Coatepeque caldera.  Collapse of Santa Ana (also known as Ilamatepec) during the late Pleistocene produced a voluminous debris avalanche that swept into the Pacific Ocean, forming the Acajutla Peninsula.  Reconstruction of the volcano subsequently filled most of the collapse scarp.  The broad summit of the volcano is cut by several crescentic craters, and a series of parasitic vents and cones have formed along a 20-km-long fissure system that extends from near the town of Chalchuapa NNW of the volcano to the San Marcelino and Cerro la Olla cinder cones on the SE flank.   Historical activity, largely consisting of small-to-moderate explosive eruptions from both summit and flank vents, has been documented since the 16th century.  The San Marcelino cinder cone on the SE flank produced a lava flow in 1722 that traveled 13 km to the east.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-02=&amp;volpage=photos&amp;photo=040042">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.snet.gob.sv/">Servicio Nacional de Estudios Territoriales</a></td></tr></table>	(13.853,-89.629999999999995)
1000	Izalco	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Izalco</b></font><br /><font size="5"><b>El Salvador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/046046.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1950 m<br /><b>Latitude:</b> 13.813&deg;N<br /><b>Longitude:</b> 89.633&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn de Izalco, El Salvador's youngest volcano, was born in in 1770 AD on the southern flank of Santa Ana volcano.  Frequent strombolian eruptions from Izalco provided a night-time beacon for ships, causing the volcano to be known as El Faro, the &quot;Lighthouse of the Pacific.&quot;  During the two centuries prior to the cessation of activity in 1966, Izalco built a steep-sided, 650-m-high stratovolcano truncated by a 250-m-wide summit crater.  Izalco has been one of the most frequently active volcanoes in North America, and its sparsely vegetated slopes contrast dramatically with neighboring forested volcanoes.  Izalco's dominantly basaltic-andesite pyroclasts and lava flows are geochemically distinct from those of both Santa Ana and its fissure-controlled flank vents.  Lava flows from Izalco were mostly erupted from flank vents and were deflected southward by the slopes of Santa Ana volcano, traveling as far as about 7 km from the summit of Izalco.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-03=&amp;volpage=photos&amp;photo=046046">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.snet.gob.sv/">Servicio Nacional de Estudios Territoriales</a></td></tr></table>	(13.813000000000001,-89.632999999999996)
1001	Coatepeque Caldera	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Coatepeque Caldera</b></font><br /><font size="5"><b>El Salvador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/100077.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 746 m<br /><b>Latitude:</b> 13.87&deg;N<br /><b>Longitude:</b> 89.55&deg;W</td></tr><tr><td colspan="2"><p align="justify">The 7 x 10 km Coatepeque caldera, its eastern side filled by a caldera lake, was formed by collapse of a group of stratovolcanoes immediately east of Santa Ana volcano.  The height of the caldera rim increases to 800 m on the west, where it partially truncates Santa Ana volcano.  The caldera was formed during a series of major rhyolitic explosive eruptions between about 72,000 and 51,000 years ago.  Post-caldera eruptions included the formation of basaltic cinder cones and lava flows near the western margin of the caldera and the extrusion of a half dozen rhyodacitic lava domes along a NE-SW line near the caldera lake margins.  The highest of the domes forms the wooded island of Isla de Cabra, or Cerro Grande.  The age of the domes is not known precisely, but the youngest dome, Cerro Pacho, was estimated to have formed less than 10,000 years ago.  Hot springs occur near the lake margins, but no verified historical eruptions have occurred from Coatepeque.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-041&amp;volpage=photos&amp;photo=100077">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-041">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.snet.gob.sv/">Servicio Nacional de Estudios Territoriales</a></td></tr></table>	(13.869999999999999,-89.549999999999997)
1002	San Salvador	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>San Salvador</b></font><br /><font size="5"><b>El Salvador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/073049.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1893 m<br /><b>Latitude:</b> 13.734&deg;N<br /><b>Longitude:</b> 89.294&deg;W</td></tr><tr><td colspan="2"><p align="justify">The massive compound San Salvador volcano dominates the landscape west of El Salvador's capital city of San Salvador.  The dominantly andesitic Boquern stratovolcano has grown within a 6-km-wide caldera, whose rim is partially exposed at Picacho and Jabal peaks, that formed by collapse of an older San Salvador volcano about 40,000 years ago.  The summit of Boquern is truncated by a steep-walled crater 1.5 km wide and about 500 m deep that formed during a major eruption about 800 years ago.  It contained a crater lake prior to an eruption during 1917 that formed a small cinder cone on the crater floor; a major north-flank lava flow  also erupted in this year.  Three fracture zones that extend beyond the base of San Salvador volcano have been the locus for numerous flank eruptions, including two that formed maars on the WNW and SE sides.  Most of the four historical eruptions recorded since the 16th century have originated from flank vents, including two in the 17th century from the NW-flank cone of El Playn, during which explosions and a lava flow damaged inhabited areas.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-05=&amp;volpage=photos&amp;photo=073049">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-05=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.snet.gob.sv/">Servicio Nacional de Estudios Territoriales</a></td></tr></table>	(13.734,-89.293999999999997)
1003	Cerro Cinotepeque	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cerro Cinotepeque</b></font><br /><font size="5"><b>El Salvador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/073093.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 665 m<br /><b>Latitude:</b> 14.02&deg;N<br /><b>Longitude:</b> 89.25&deg;W</td></tr><tr><td colspan="2"><p align="justify">Cerro Cinotepeque is the largest and most prominent of a group of four pyroclastic cones of Holocene age mapped by Weber and Weismann (1978) in low-lying areas on either side of the Ro Lempa, about 40 km north of San Salvador.  Cerro Cinotepeque (also spelled Cinotepec) lies south of the river; two other cones, Cerro Santiago and Cerro Mosquito, lie immediately north of the river.  A fourth cone is located along the Ro Gualchayo about 10 km farther north.  A large group of small Pleistocene stratovolcanoes and pyroclastic cones constructed along NW-SE-trending faults is located west and south of Cerro Cinotepeque and west of Guazapa volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-051&amp;volpage=photos&amp;photo=073093">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-051">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.snet.gob.sv/">Servicio Nacional de Estudios Territoriales</a></td></tr></table>	(14.02,-89.25)
1004	Ilopango	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ilopango</b></font><br /><font size="5"><b>El Salvador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/072013.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 450 m<br /><b>Latitude:</b> 13.672&deg;N<br /><b>Longitude:</b> 89.053&deg;W</td></tr><tr><td colspan="2"><p align="justify">The scenic 8 x 11 km Ilopango caldera, filled by one of El Salvador's largest lakes, has a scalloped 150-500 m high rim.  The caldera, which lies immediately east of the capital city of San Salvador, is strongly controlled by regional faults of the central Salvador graben.  Four major dacitic-rhyolitic explosive eruptions during the late Pleistocene and Holocene produced extensive pyroclastic-flow and pyroclastic-fall deposits that blanket much of El Salvador.  The latest collapse of Ilopango caldera resulted from the massive 5th century AD Terra Blanca Joven (TBJ) eruption, which produced widespread pyroclastic flows and devastated early Mayan cities.  Post-caldera eruptions formed a series of glassy dacitic and andesitic lava domes within the lake and near its shore.  The Islas Quemadas, a group of low islets in the center of the lake that mark the summit of a largely submerged lava dome, were formed in 1879-80 during the only historical eruption of Ilopango.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-06=&amp;volpage=photos&amp;photo=072013">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-06=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.snet.gob.sv/">Servicio Nacional de Estudios Territoriales</a></td></tr></table>	(13.672000000000001,-89.052999999999997)
1005	San Vicente	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>San Vicente</b></font><br /><font size="5"><b>El Salvador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/040059.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 2182 m<br /><b>Latitude:</b> 13.595&deg;N<br /><b>Longitude:</b> 88.837&deg;W</td></tr><tr><td colspan="2"><p align="justify">The twin peaks of San Vicente volcano, also known as Chichontepec, rise dramatically to the SE of Lake Ilopango.  The modern andesitic stratovolcano was constructed within the Pleistocene La Carbonera caldera, whose rim is visible only on its SW side.  San Vicente volcano, the second highest in El Salvador, grew within the caldera to form a paired volcano with summit craters oriented along a WSW-ENE line.  The northern and southern flanks are covered by lava flows from the central vent, but lava flows on the eastern side originated from a vent on the upper flank.  Volcanism has continued into the Holocene, but the latest lava flows are covered by deposits from the major ca. 260 AD eruption from neighboring Ilopango volcano.  Reports of historical eruptions in 1643 and 1835 are false (Catalog of Active Volcanoes of the World; Sapper, 1917), but numerous hot springs and fumaroles are found on the northern and western flanks of the volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-07=&amp;volpage=photos&amp;photo=040059">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-07=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.snet.gob.sv/">Servicio Nacional de Estudios Territoriales</a></td></tr></table>	(13.595000000000001,-88.837000000000003)
1006	Apastepeque Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Apastepeque Field</b></font><br /><font size="5"><b>El Salvador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/072069.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 700? m<br /><b>Latitude:</b> 13.72&deg;N<br /><b>Longitude:</b> 88.77&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Apastepeque volcanic field north of the city of San Vicente consists of a dense cluster of about two dozen chemically diverse Holocene volcanic vents, including lava domes, cinder cones, and maars.  Andesitic-to-dacitic lava domes were emplaced in some vents following dacitic pumice eruptions.  After the end of these more siliceous eruptions, a series of basaltic cinder cones was formed.  Some of the basaltic eruptions concluded with the formation of steep-walled maars up to 100 m deep, some now occupied by lakes, such as Laguna de Apastepeque and Laguna Chalchuapn.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-071&amp;volpage=photos&amp;photo=072069">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-071">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.snet.gob.sv/">Servicio Nacional de Estudios Territoriales</a></td></tr></table>	(13.720000000000001,-88.769999999999996)
1007	Tecapa	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tecapa</b></font><br /><font size="5"><b>El Salvador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/076028.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1593 m<br /><b>Latitude:</b> 13.494&deg;N<br /><b>Longitude:</b> 88.502&deg;W</td></tr><tr><td colspan="2"><p align="justify">Tecapa is a complex basaltic-to-andesitic stratovolcano at the NW end of a cluster of volcanoes east of the Ro Lempa between San Vicente and San Miguel volcanoes.  The Berln caldera, whose rim is visible on the west side of the complex, was formed during the eruption of the Blanca-Rosa dacitic pumice in the late Pleistocene.  Following caldera formation the cones of Cerro Las Palmas, Cerro Peln, Tecapa-Laguna de Alegria, and Cerro Alegria were constructed along a WSW-ENE line.  The crater of Tecapa-Laguna de Alegria contains a deep notch on the eastern rim and is filled by Laguna de Alegria crater lake.  The Tecapa volcanic complex currently displays fumarolic activity, and a producing geothermal plant is located at the Berln geothermal field.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-08=&amp;volpage=photos&amp;photo=076028">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-08=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.snet.gob.sv/">Servicio Nacional de Estudios Territoriales</a></td></tr></table>	(13.494,-88.501999999999995)
1008	Usulutn	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Usulutn</b></font><br /><font size="5"><b>El Salvador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/076035.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1449 m<br /><b>Latitude:</b> 13.419&deg;N<br /><b>Longitude:</b> 88.471&deg;W</td></tr><tr><td colspan="2"><p align="justify">Usulutn volcano anchors the SE end of a cluster of basaltic to basaltic-andesite stratovolcanoes between San Vicente and San Miguel volcanoes.  The flanks of the forested Usulutn volcano are dissected, but youthful lava flows are present on its southern flanks.  The younger summit rocks of 1449-m-high Usulutn and Cerro Nanzal pyroclastic cone on the lower SE flank were mapped as Holocene (Weber and Wiesemann, 1978).  A broad 1.3-km-wide crater is breached to the east from the summit of Usulutn to its lower flank.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-081&amp;volpage=photos&amp;photo=076035">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-081">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.snet.gob.sv/">Servicio Nacional de Estudios Territoriales</a></td></tr></table>	(13.419,-88.471000000000004)
1009	El Tigre	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>El Tigre</b></font><br /><font size="5"><b>El Salvador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/040066.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1640+ m<br /><b>Latitude:</b> 13.47&deg;N<br /><b>Longitude:</b> 88.43&deg;W</td></tr><tr><td colspan="2"><p align="justify">Cerro el Tigre is the highest, NE-most, and oldest of the cluster of coalescing basaltic to basaltic-andesite Quaternary volcanoes between the Ro Lempa and San Miguel volcano.  The summit crater of El Tigre has been destroyed by erosion, and the flanks of the volcano are deeply dissected.  Two large NNW-trending valleys, parallel to other regional fissures, cross the volcano, which lies about 7 km SE of Tecapa volcano and a similar distance NE of Usulutn volcano.  Although El Tigre itself is Pleistocene in age, two young cones on its flanks were mapped as Holocene by Weber and Wiesemann (1978). Cerro Oromontique and Cerro la Manita were erupted on the western and southern flanks of El Tigre, respectively, along a NW-SE-trending fissure extending towards Tecapa volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-082&amp;volpage=photos&amp;photo=040066">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-082">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.snet.gob.sv/">Servicio Nacional de Estudios Territoriales</a></td></tr></table>	(13.470000000000001,-88.430000000000007)
1010	Chinameca	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Chinameca</b></font><br /><font size="5"><b>El Salvador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/076037.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Cinder cone</td><td width="50%" align="left"><b>Summit Elev:</b> 1300 m<br /><b>Latitude:</b> 13.478&deg;N<br /><b>Longitude:</b> 88.330&deg;W</td></tr><tr><td colspan="2"><p align="justify">The small stratovolcano of Chinameca (also known as El Pacayal) is dwarfed by its towering neighbor San Miguel, which lies across a low saddle to the SE.  A 2-km-wide, steep-sided caldera, Laguna Seca el Pacayal, truncates the 1300-m-high summit of Chinameca volcano, whose flanks are draped with coffee plantations.  The Holocene cone of Cerro el Limbo on the western flank rises to 1380 m, above the level of the caldera rim, and a Holocene lava flow extends from a NNW-flank vent into the lowlands to the north beyond the town of Chinameca (Weber and Weisemann, 1978).  A group of fumarole fields is located on the north flank of the volcano surrounds the city of Chinameca, and the volcano has been the site of a geothermal exploration program.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-09=&amp;volpage=photos&amp;photo=076037">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-09=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.snet.gob.sv/">Servicio Nacional de Estudios Territoriales</a></td></tr></table>	(13.478,-88.329999999999998)
1011	San Miguel	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>San Miguel</b></font><br /><font size="5"><b>El Salvador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/072002.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 2130 m<br /><b>Latitude:</b> 13.434&deg;N<br /><b>Longitude:</b> 88.269&deg;W</td></tr><tr><td colspan="2"><p align="justify">The symmetrical cone of San Miguel volcano, one of the most active in El Salvador, rises from near sea level to form one of the country's most prominent landmarks.  The unvegetated summit of the 2130-m-high volcano rises above slopes draped with coffee plantations.  A broad, deep crater complex that has been frequently modified by historical eruptions (recorded since the early 16th century) caps the truncated summit of the towering volcano, which is also known locally as Chaparrastique.  Radial fissures on the flanks of the basaltic-andesitic volcano have fed a series of historical lava flows, including several erupted during the 17th-19th centuries that reached beyond the base of the volcano on the north, NE, and SE sides.  The SE-flank lava flows are the largest and form broad, sparsely vegetated lava fields crossed by highways and a railroad skirting the base of the volcano.  The location of flank vents has migrated higher on the edifice during historical time, and the most recent activity has consisted of minor ash eruptions from the summit crater.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-10=&amp;volpage=photos&amp;photo=072002">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-10=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.snet.gob.sv/">Servicio Nacional de Estudios Territoriales</a></td></tr></table>	(13.433999999999999,-88.269000000000005)
1012	Laguna Aramuaca	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Laguna Aramuaca</b></font><br /><font size="5"><b>El Salvador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/077026.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Maar</td><td width="50%" align="left"><b>Summit Elev:</b> 181 m<br /><b>Latitude:</b> 13.428&deg;N<br /><b>Longitude:</b> 88.105&deg;W</td></tr><tr><td colspan="2"><p align="justify">A solitary, 1-km-wide, lake-filled maar, Laguna Aramuaca, occupies a low-lying area about 10 km SE of the city of San Miguel.  The Pan-American highway swings around the south side of the maar immediately north of the Ro Grande de San Miguel.  Laguna Aramuaca was mapped as Holocene by Weber and Wiesemann (1978), but has not been studied in detail.  The low rim of the maar rises about 50-100 m above the countryside and reaches only 181 m above sea level.  Spectacular pyroclastic-surge deposits are exposed by quarries near the rim of the maar.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-101&amp;volpage=photos&amp;photo=077026">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-101">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.snet.gob.sv/">Servicio Nacional de Estudios Territoriales</a></td></tr></table>	(13.428000000000001,-88.105000000000004)
1013	Conchagita	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Conchagita</b></font><br /><font size="5"><b>El Salvador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/074016.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 505 m<br /><b>Latitude:</b> 13.229&deg;N<br /><b>Longitude:</b> 87.767&deg;W</td></tr><tr><td colspan="2"><p align="justify">Conchagita volcano occupies a small, 4-km-wide island in the Gulf of Fonseca across a narrow strait from Conchagua volcano.  Late-stage eruptions formed a small, sharp-topped cone with a 100-m-wide summit crater at the southern end of the low 505-m-high island, and a youthful peninsula also extends from the island's eastern side.  A crescent-shaped crater open to the west is located at the northern end of the island.  Minor ash emissions in 1892 marked the only historical eruption from Conchagita, the easternmost Holocene volcano in El Salvador.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-12=&amp;volpage=photos&amp;photo=074016">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-12=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.snet.gob.sv/">Servicio Nacional de Estudios Territoriales</a></td></tr></table>	(13.228999999999999,-87.766999999999996)
1014	Isla el Tigre	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Isla el Tigre</b></font><br /><font size="5"><b>Honduras</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/040079.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 783 m<br /><b>Latitude:</b> 13.272&deg;N<br /><b>Longitude:</b> 87.641&deg;W</td></tr><tr><td colspan="2"><p align="justify">Isla El Tigre is a small, 5-km-wide island located across a narrow 2-km-wide strait south of Isla Zacate Grande in the Gulf of Fonseca.  The conical, 783-m-high basaltic stratovolcano is the southernmost volcano of Honduras.  El Tigre is less dissected than neighboring Zacate Grande volcano on the mainland to the north and is of probable Holocene age (Carr 1992, pers. comm.).  A single satellitic cone, El Viga, overlooks the village of Amapala on the NW flank.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-13-&amp;volpage=photos&amp;photo=040079">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-13-">Smithsonian Volcano Information</a></td></tr></table>	(13.272,-87.641000000000005)
1015	Isla Zacate Grande	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Isla Zacate Grande</b></font><br /><font size="5"><b>Honduras</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/074013.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 640+ m<br /><b>Latitude:</b> 13.33&deg;N<br /><b>Longitude:</b> 87.63&deg;W</td></tr><tr><td colspan="2"><p align="justify">Zacate Grande volcano forms a low 7 x 10 km wide island across a narrow strait from the end of a peninsula surrounded on three sides by the Gulf of Fonseca and Chismuyo bay.  At least seven satellitic cones, some of which form small islands offshore, are located from the NE to SE base of the broad 640-m-high basaltic stratovolcano.  Some of these, including the symmetrical cone of Isla Gueguensi in the tidal flats about 3 km east of the base of Zacate Grande, are of probable Holocene age (Carr 1992, pers. comm.).  In contrast to neighboring Isla El Tigre volcano to the south, Zacate Grande itself is extensively eroded, and deep valleys extend from the summit ridges to the base of the volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-14-&amp;volpage=photos&amp;photo=074013">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-14-">Smithsonian Volcano Information</a></td></tr></table>	(13.33,-87.629999999999995)
1016	Lake Yojoa	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Lake Yojoa</b></font><br /><font size="5"><b>Honduras</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/081057.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 1090 m<br /><b>Latitude:</b> 14.98&deg;N<br /><b>Longitude:</b> 87.98&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Lake Yojoa volcanic field consists a group of Pleistocene-to-Holocene scoria cones and collapse pits at the northern end of the scenic north-central Honduras lake (Williams and McBirney, 1969).  The volcanic field has produced rocks ranging from tholeiitic basalts to trachybasalts, trachyandesites, and trachytes.  The principal NE-trending chain of cones cuts through Cerro Babilonia, the 1090 m high point of the volcanic field, along the same fault pattern that bounds the limestone mountains bordering arcuate Lake Yojoa.  Most of the pyroclastic cones, consisting of basaltic scoria and agglutinate, are 100-200 m in height and several contain well-preserved craters.  Lava flows radiate in all directions from the cones.  The longest flow traveled northward to the village of Ro Lindo, where a waterfall cascades down the terminus of the flow.  A few Quaternary lava flows occur in the Sulu graben along the Carretara del Norte north of Lake Yojoa.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-15-&amp;volpage=photos&amp;photo=081057">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-15-">Smithsonian Volcano Information</a></td></tr></table>	(14.98,-87.980000000000004)
1017	Utila Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Utila Island</b></font><br /><font size="5"><b>Honduras</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/081053.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 74 m<br /><b>Latitude:</b> 16.10&deg;N<br /><b>Longitude:</b> 86.90&deg;W</td></tr><tr><td colspan="2"><p align="justify">The island of Utila in the Carribean Sea off the northern coast of Honduras is the easternmost and lowest of the Bay Islands at the southern edge of the submarine Bartlett Trough.  Utila is capped by a thin veneer of Holocene basaltic rocks at its eastern end (McBirney and Bass, 1969).  Basaltic lavas and tuffs were erupted onto a coral-capped erosional surface.  Stuert Hill (also spelled Stuart Hill) is a pyroclastic cone that was constructed at the center of the volcanic terrain, and Pumpkin Hill is a small littoral cone located along the NE coast of the island.  The high point of the island is Pumpkin Hill, which rises only 74 m above sea level.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-16-&amp;volpage=photos&amp;photo=081053">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1403-16-">Smithsonian Volcano Information</a></td></tr></table>	(16.100000000000001,-86.900000000000006)
1018	Cosigina	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cosigina</b></font><br /><font size="5"><b>Nicaragua</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/040083.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 872 m<br /><b>Latitude:</b> 12.98&deg;N<br /><b>Longitude:</b> 87.57&deg;W</td></tr><tr><td colspan="2"><p align="justify">Cosigina is a low basaltic-to-andesitic composite volcano that is isolated from other eruptive centers in the Nicaraguan volcanic chain.  The 872-m-high stratovolcano forms a large peninsula extending into the Gulf of Fonseca at the western tip of the country.  Cosigina (also spelled Cosegina) has a pronounced somma rim on the northern side; a young summit cone of Cosigina rises 300 m above the northern somma rim and buries the rim on other sides.  The younger cone is truncated by a large elliptical prehistorical summit caldera, 2 x 2.4 km in diameter and 500 m deep, with a lake at its bottom.  Lava flows predominate in the caldera walls, although lahar and pyroclastic-flow deposits surround the volcano.  In 1835 Cosigina was the source of a brief, but powerful explosive eruption that was Nicaragua's largest during historical time.  Ash fell as far away as Mxico, Costa Rica, and Jamaica, and pyroclastic flows reached the Gulf of Fonseca.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-01=&amp;volpage=photos&amp;photo=040083">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ineter.gob.ni/">Instituto Nicaragense de Estudios Territoriales</a></td></tr></table>	(12.98,-87.569999999999993)
1019	San Cristbal	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>San Cristbal</b></font><br /><font size="5"><b>Nicaragua</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/040093.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1745 m<br /><b>Latitude:</b> 12.702&deg;N<br /><b>Longitude:</b> 87.004&deg;W</td></tr><tr><td colspan="2"><p align="justify">The San Cristbal volcanic complex, consisting of five principal volcanic edifices, forms the NW end of the Marrabios Range.  The symmetrical 1745-m-high youngest cone, named San Cristbal (also known as El Viejo), is Nicaragua's highest volcano and is capped by a 500 x 600 m wide crater.  El Chonco, with several flank lava domes, is located 4 km to the west of San Cristbal; it and the eroded Moyotepe volcano, 4 km to the NE of San Cristbal, are of Pleistocene age.  Volcn Casita, containing an elongated summit crater, lies immediately east of San Cristbal and was the site of a catastrophic landslide and lahar in 1998.  The Plio-Pleistocene La Pelona caldera is located at the eastern end of the San Cristbal complex.  Historical eruptions from San Cristbal, consisting of small-to-moderate explosive activity, have been reported since the 16th century.  Some other 16th-century eruptions attributed to Casita volcano are uncertain and may pertain to other Marrabios Range volcanoes.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-02=&amp;volpage=photos&amp;photo=040093">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ineter.gob.ni/">Instituto Nicaragense de Estudios Territoriales</a></td></tr></table>	(12.702,-87.004000000000005)
1020	Telica	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Telica</b></font><br /><font size="5"><b>Nicaragua</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/080082.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes</td><td width="50%" align="left"><b>Summit Elev:</b> 1061 m<br /><b>Latitude:</b> 12.602&deg;N<br /><b>Longitude:</b> 86.845&deg;W</td></tr><tr><td colspan="2"><p align="justify">Telica, one of Nicaragua's most active volcanoes, has erupted frequently since the beginning of the Spanish era.  The Telica volcano group consists of several interlocking cones and vents with a general NW alignment.  Sixteenth-century eruptions were reported at symmetrical Santa Clara volcano at the SW end of the Telica group.  However, its eroded and breached crater has been covered by forests throughout historical time, and these eruptions may have originated from Telica, whose upper slopes in contrast are unvegetated.  The steep-sided cone of 1061-m-high Telica is truncated by a 700-m-wide double crater; the southern crater, the source of recent eruptions, is 120 m deep.  El Liston, immediately SE of Telica, has several nested craters.  The fumaroles and boiling mudpots of Hervideros de San Jacinto, SE of Telica, form a prominent geothermal area frequented by tourists, and geothermal exploration has occurred nearby.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-04=&amp;volpage=photos&amp;photo=080082">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-04=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ineter.gob.ni/">Instituto Nicaragense de Estudios Territoriales</a></td></tr></table>	(12.602,-86.844999999999999)
1021	Rota	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Rota</b></font><br /><font size="5"><b>Nicaragua</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/082046.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 832 m<br /><b>Latitude:</b> 12.55&deg;N<br /><b>Longitude:</b> 86.75&deg;W</td></tr><tr><td colspan="2"><p align="justify">The deeply eroded, forested Rota stratovolcano of Holocene age occupies the area between Cerro Negro volcano and the Telica volcanic complex in the central Marrabios Range.  The 832-m-high volcano, also known as Orota, is truncated by a 1-km-wide circular crater whose rim is lowest on the southern side.  The latest eruption from Rota produced thick andesitic lava flows from a NE-trending fissure NW of the summit.  No historical eruptions are known from Volcn Rota, and Williams and McBirney (1965) considered the volcano to have been quiescent for many centuries.  Seismic swarms occurred in 1986, 1989, and 1992.  Two small NNW-SSE-trending lava domes, El Bosque (also known as Lomas San Ignacio del Bosque or Cerro Ojochal) are located on the plain 2 km north of the flank of Rota.  They were constructed along the same trend as other eruptive fissures that extend transverse to the Marrabios Range volcanoes.  An extensive lava field in this area was erupted from numerous small cones and maars.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-06-&amp;volpage=photos&amp;photo=082046">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-06-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ineter.gob.ni/">Instituto Nicaragense de Estudios Territoriales</a></td></tr></table>	(12.550000000000001,-86.75)
1022	Cerro Negro	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cerro Negro</b></font><br /><font size="5"><b>Nicaragua</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/041048.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 728 m<br /><b>Latitude:</b> 12.506&deg;N<br /><b>Longitude:</b> 86.702&deg;W</td></tr><tr><td colspan="2"><p align="justify">Central America's youngest volcano, Cerro Negro, was born in April 1850 and has since been one of the most active volcanoes in Nicaragua.  Cerro Negro is the largest, southernmost, and most recent of a group of four youthful cinder cones constructed along a NNW-SSE-trending line in the central Marrabios Range 5 km NW of Las Pilas volcano.  Strombolian-to-subplinian eruptions at Cerro Negro at intervals of a few years to several decades have constructed a roughly 250-m-high basaltic cone and an associated lava field that is constrained by topography to extend primarily to the NE and SW.  Cone and crater morphology at Cerro Negro have varied significantly during its eruptive history.  Although Cerro Negro lies in a relatively unpopulated area, its occasional heavy ashfalls have caused damage to crops and buildings in populated regions of the Nicaraguan depression.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-07=&amp;volpage=photos&amp;photo=041048">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-07=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ineter.gob.ni/">Instituto Nicaragense de Estudios Territoriales</a></td></tr></table>	(12.506,-86.701999999999998)
1023	Las Pilas	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Las Pilas</b></font><br /><font size="5"><b>Nicaragua</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/041056.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano<br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 1088 m<br /><b>Latitude:</b> 12.495&deg;N<br /><b>Longitude:</b> 86.688&deg;W</td></tr><tr><td colspan="2"><p align="justify">Las Pilas volcanic complex, overlooking Cerro Negro volcano to the NW, includes a diverse cluster of cones around the central vent, Las Pilas.  A N-S-trending fracture system cutting across 1088-m-high Las Pilas (El Hoyo) is marked by numerous well-preserved flank vents, including maars, that are part of a 30-km-long volcanic massif.  The Cerro Negro chain of cinder cones is listed separately in this compilation because of its extensive historical eruptions.  The lake-filled Asososca maar is located adjacent to the conical 818-m-high Cerro Asososca cone on the southern side of the fissure system, south of the axis of the Marrabios Range.  Two small maars west of Lake Managua are located at the southern end of the fissure.  Aside from a possible eruption in the 16th century, the only historical eruptions of Las Pilas took place in the 1950s from a fissure that cuts the eastern side of the 700-m-wide summit crater and extends down the north flank.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-08=&amp;volpage=photos&amp;photo=041056">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-08=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ineter.gob.ni/">Instituto Nicaragense de Estudios Territoriales</a></td></tr></table>	(12.494999999999999,-86.688000000000002)
1024	Momotombo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Momotombo</b></font><br /><font size="5"><b>Nicaragua</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/041064.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1297 m<br /><b>Latitude:</b> 12.422&deg;N<br /><b>Longitude:</b> 86.540&deg;W</td></tr><tr><td colspan="2"><p align="justify">Momotombo is a young, 1297-m-high stratovolcano that rises prominently above the NW shore of Lake Managua, forming one of Nicaragua's most familiar landmarks.  Momotombo began growing about 4500 years ago at the SE end of the Marrabios Range and consists of a somma from an older edifice that is surmounted by a symmetrical younger cone with a 150 x 250 m wide summit crater.  Young lava flows from Momotombo have flowed down the NW flank into the 4-km-wide Monte Galn caldera.  The youthful cone of Momotombito forms a 391-m-high island offshore in Lake Managua.  Momotombo has a long record of strombolian eruptions, punctuated by occasional larger explosive activity.  The latest eruption, in 1905, produced a lava flow that traveled from the summit to the lower NE base.  A small black plume was seen above the crater after an April 10, 1996 earthquake, but later observations noted no significant changes in the crater.  A major geothermal field is located on the southern flank of the volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-09=&amp;volpage=photos&amp;photo=041064">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-09=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ineter.gob.ni/">Instituto Nicaragense de Estudios Territoriales</a></td></tr></table>	(12.422000000000001,-86.540000000000006)
1025	Apoyeque	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Apoyeque</b></font><br /><font size="5"><b>Nicaragua</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/041074.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic shield<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Maar</td><td width="50%" align="left"><b>Summit Elev:</b> 518 m<br /><b>Latitude:</b> 12.242&deg;N<br /><b>Longitude:</b> 86.342&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Apoyeque volcanic complex occupies the broad Chiltepe Peninsula, which extends into south-central Lake Managua.  The peninsula is part of the Chiltepe pyroclastic shield volcano, one of three large ignimbrite shields on the Nicaraguan volcanic front.  A 2.8-km wide, 400-m-deep, lake-filled caldera whose floor lies near sea level truncates the low Apoyeque volcano, which rises only about 500 m above the lake shore.  The caldera was the source of a thick mantle of dacitic pumice that blankets the surrounding area.  The 2.5 x 3 km wide lake-filled Xilo (Jilo) maar, is located immediately SE of Apoyeque.  The Talpetatl lava dome was constructed between Laguna Xilo and Lake Managua.  Pumiceous pyroclastic flows from Laguna Xilo were erupted about 6100 years ago and overlie deposits of comparable age from the Masaya plinian eruption.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-091&amp;volpage=photos&amp;photo=041074">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-091">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ineter.gob.ni/">Instituto Nicaragense de Estudios Territoriales</a></td></tr></table>	(12.242000000000001,-86.341999999999999)
1026	Nejapa-Miraflores	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Nejapa-Miraflores</b></font><br /><font size="5"><b>Nicaragua</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/080058.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Fissure vents<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 360 m<br /><b>Latitude:</b> 12.12&deg;N<br /><b>Longitude:</b> 86.32&deg;W</td></tr><tr><td colspan="2"><p align="justify">The N-S-trending Nejapa-Miraflores alignment, located near the western margin of the Nicaraguan graben, cuts through the western part of Nicaragua's capital city, Managua.  This alignment, which has erupted tholeiitic basaltic rocks similar to those from mid-ocean ridges, marks the right-lateral offset of the Nicaraguan volcanic chain.  A series of pit craters and fissure vents extends into Lake Managua and is continuous with the volcanic vents on the Chiltepe peninsula.  An area of maars and tuff cones perpendicular to the N-S trend of the lineament forms the scalloped shoreline of Lake Managua.  Laguna Tiscapa crater is located several kilometers to the east near the central part of the city of Managua.  The elongated Nejapa and Ticoma pit craters are surrounded by small basaltic cinder cones and tuff cones.  The Nejapa-Miraflores alignment (also known as Nejapa-Ticoma) has been the site of about 40 eruptions during the past 30,000 years, the most recent of which (from Asososca maar) occurred about 1250 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-092&amp;volpage=photos&amp;photo=080058">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-092">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ineter.gob.ni/">Instituto Nicaragense de Estudios Territoriales</a></td></tr></table>	(12.119999999999999,-86.319999999999993)
1027	Masaya	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Masaya</b></font><br /><font size="5"><b>Nicaragua</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/041077.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 635 m<br /><b>Latitude:</b> 11.984&deg;N<br /><b>Longitude:</b> 86.161&deg;W</td></tr><tr><td colspan="2"><p align="justify">Masaya is one of Nicaragua's most unusual and most active volcanoes.  Masaya lies within the massive Pleistocene Las Sierras pyroclastic shield volcano and is a broad, 6 x 11 km basaltic caldera with steep-sided walls up to 300 m high.  The caldera is filled on its NW end by more than a dozen vents that erupted along a circular, 4-km-diameter fracture system.  The twin volcanoes of Nindir and Masaya, the source of historical eruptions, were constructed at the southern end of the fracture system and contain multiple summit craters, including the currently active Santiago crater.  A major basaltic plinian tephra was erupted from Masaya about 6500 years ago.  Historical lava flows cover much of the caldera floor and have confined a lake to the far eastern end of the caldera.  A lava flow from the 1670 eruption overtopped the north caldera rim.  Masaya has been frequently active since the time of the Spanish Conquistadors, when an active lava lake prompted attempts to extract the volcano's molten &quot;gold.&quot;  Periods of long-term vigorous gas emission at roughly quarter-century intervals cause health hazards and crop damage.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-10=&amp;volpage=photos&amp;photo=041077">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-10=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ineter.gob.ni/">Instituto Nicaragense de Estudios Territoriales</a></td></tr></table>	(11.984,-86.161000000000001)
1028	Granada	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Granada</b></font><br /><font size="5"><b>Nicaragua</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/082033.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Fissure vents<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 300+ m<br /><b>Latitude:</b> 11.92&deg;N<br /><b>Longitude:</b> 85.98&deg;W</td></tr><tr><td colspan="2"><p align="justify">A semi-arcuate, N-S-trending fissure located between the city of Granada and the eastern rim of Apoyo caldera was the source of the Granada alignment of small cinder cones and craters.  The lineament (also known as the La Joya alignment after La Joya explosions craters SW of Granada) cuts across the flanks of Apoyo caldera only 2 km from its rim.  However, the Granada alignment is structurally distinct from the caldera and is analogous to the Nejapa-Miraflores alignment north of Masaya volcano.    The lineament extends from north of Granada to the northern flanks of Mombacho volcano and is characterized by the eruption of basaltic lavas and tephras compositionally similar to mid-ocean ridge basalts.  A series of interconnecting collapse-explosion pits similar to those at Nejapa-Miraflores lies immediately east of the Granada cinder cone alignment.  The Granada lineament originated about 12,000 years ago, and the latest eruptions may have occurred as recently as about 2000 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-101&amp;volpage=photos&amp;photo=082033">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-101">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ineter.gob.ni/">Instituto Nicaragense de Estudios Territoriales</a></td></tr></table>	(11.92,-85.980000000000004)
1029	Mombacho	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mombacho</b></font><br /><font size="5"><b>Nicaragua</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/042001.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1344 m<br /><b>Latitude:</b> 11.826&deg;N<br /><b>Longitude:</b> 85.968&deg;W</td></tr><tr><td colspan="2"><p align="justify">Mombacho is an andesitic and basaltic stratovolcano on the shores of Lake Nicaragua south of the city of Granada that has undergone edifice collapse on several occasions.  Two large horseshoe-shaped craters formed by edifice failure cut the summit on the NE and southern flanks.  The NE-flank scarp was the source of a large debris avalanche that produced an arcuate peninsula and a cluster of small islands (Las Isletas) in Lake Nicaragua.  Two small, well-preserved cinder cones are located on the volcano's lower northern flank.  The only reported historical activity was in 1570, when a debris avalanche destroyed a village on the south side of the volcano.  Although there were contemporary reports of an explosion, there is no direct evidence that the avalanche was accompanied by an eruption.  Fumarolic fields and hot springs are found within the two collapse scarps and on the upper northern flank.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-11=&amp;volpage=photos&amp;photo=042001">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-11=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ineter.gob.ni/">Instituto Nicaragense de Estudios Territoriales</a></td></tr></table>	(11.826000000000001,-85.968000000000004)
1030	Zapatera	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Zapatera</b></font><br /><font size="5"><b>Nicaragua</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/080070.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Tuff rings</td><td width="50%" align="left"><b>Summit Elev:</b> 629 m<br /><b>Latitude:</b> 11.73&deg;N<br /><b>Longitude:</b> 85.82&deg;W</td></tr><tr><td colspan="2"><p align="justify">Zapatera is a small low shield volcano that forms a 7 x 10 km wide island on the western side of Lake Nicaragua just offshore from Mombacho volcano.  The island contains some of the most significant archaeological sites in Nicaragua.  The small, roughly circular 2-km-wide El Llano caldera is located near the center of the island, which is cut by a series of NE-trending faults that continue into Lake Nicaragua.  The conical 305-m-high Cerro El Llano lava dome occupies the center of the caldera, and other lava domes are found on the southern and NE flanks.  Numerous low-rimmed tuff rings and maars, of which Laguna de Zapatera on the NW flank is the best-preserved, are found on the northern and western sides of the densely forested 629-m-high island and across a narrow strait on the adjacent mainland.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-111&amp;volpage=photos&amp;photo=080070">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-111">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ineter.gob.ni/">Instituto Nicaragense de Estudios Territoriales</a></td></tr></table>	(11.73,-85.819999999999993)
1031	Concepcin	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Concepcin</b></font><br /><font size="5"><b>Nicaragua</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/042010.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1700? m<br /><b>Latitude:</b> 11.538&deg;N<br /><b>Longitude:</b> 85.622&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn Concepcin is one of Nicaragua's highest and most active volcanoes.  The symmetrical basaltic-to-dacitic stratovolcano forms the NW half of the dumbbell-shaped island of Ometepe in Lake Nicaragua and is connected to neighboring Madera volcano by a narrow isthmus.  A steep-walled summit crater is 250 m deep and has a higher western rim.  N-S-trending fractures on the flanks of the volcano have produced chains of spatter cones, cinder cones, lava domes, and maars located on the NW, NE, SE, and southern sides extending in some cases down to Lake Nicaragua.  Concepcin was constructed above a basement of lake sediments, and the modern cone grew above a largely buried caldera, a small remnant of which forms a break in slope about halfway up the north flank.  Frequent explosive eruptions during the past half century have increased the height of the summit significantly above that shown on current topographic maps and have kept the upper part of the volcano unvegetated.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-12=&amp;volpage=photos&amp;photo=042010">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-12=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ineter.gob.ni/">Instituto Nicaragense de Estudios Territoriales</a></td></tr></table>	(11.538,-85.622)
1032	Maderas	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Maderas</b></font><br /><font size="5"><b>Nicaragua</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/042014.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1394 m<br /><b>Latitude:</b> 11.446&deg;N<br /><b>Longitude:</b> 85.515&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn Maderas is a roughly conical, 1394-m-high stratovolcano that forms the SE end of the dumbbell-shaped Ometepe island in Lake Nicaragua.  The basaltic-to-dacitic volcano is cut by numerous faults and grabens, the largest of which is a NW-SE-oriented graben that cuts the summit and has at least 140 m of vertical displacement.  The small Laguna de Maderas lake occupies the bottom of the 800-m-wide summit crater, which is located at the western side of the central graben.  The SW side of the edifice has been affected by large-scale slumping.  Many pyroclastic cones are situated on the lower NE flank down to the level of Lake Nicaragua.  The latest period of major growth of Maderas took place more than 3000 years ago.  No confirmed historical eruptions are known from the volcano.  A lahar in September 1996 killed six persons in an east-flank village, but associated volcanic activity was not confirmed.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-13-&amp;volpage=photos&amp;photo=042014">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-13-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ineter.gob.ni/">Instituto Nicaragense de Estudios Territoriales</a></td></tr></table>	(11.446,-85.515000000000001)
1033	Volcn Azul	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Volcn Azul</b></font><br /><font size="5"><b>Nicaragua</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/114068.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 201 m<br /><b>Latitude:</b> 12.53&deg;N<br /><b>Longitude:</b> 83.87&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn Azul (Volcn Blue) consists of three youthful cinder cones on the jungle-covered Atlantic coastal plain of Nicaragua that were first noted by geologists during an aerial overflight in the 1960s.  The three cones, located south of the Ro Curinhus and west of Pearl Lagoon, each have well-defined, steep-walled craters about 50-60 m across.  In contrast to the circular rims of the other two cones, the rim of the easternmost cone is breached to the west.  The well-defined craters and unusually low vegetation in an area of heavy rainfall and rapid weathering led Williams and McBirney (1965) to estimate that the cones were probably no more than a few thousand years old.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-14-&amp;volpage=photos&amp;photo=114068">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1404-14-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ineter.gob.ni/">Instituto Nicaragense de Estudios Territoriales</a></td></tr></table>	(12.529999999999999,-83.870000000000005)
1034	Rincn de la Vieja	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Rincn de la Vieja</b></font><br /><font size="5"><b>Costa Rica</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/096030.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano<br />&nbsp;&nbsp;&nbsp; Calderas</td><td width="50%" align="left"><b>Summit Elev:</b> 1916 m<br /><b>Latitude:</b> 10.830&deg;N<br /><b>Longitude:</b> 85.324&deg;W</td></tr><tr><td colspan="2"><p align="justify">Rincn de la Vieja, the largest volcano in NW Costa Rica, is a remote volcanic complex in the Guanacaste Range.  The volcano consists of an elongated, arcuate NW-SE-trending ridge that was constructed within the 15-km-wide early Pleistocene Guachipeln caldera, whose rim is exposed on the south side.  Rincn de la Vieja, sometimes known as the &quot;Colossus of Guanacaste,&quot; has an estimated volume of 130 cu km and contains at least 9 major eruptive centers.  Activity has migrated to the SE, where the youngest-looking craters are located.  The twin cone of 1916-m-high Santa Mara volcano, the highest peak of the Rincn complex, is located at the eastern end of a smaller, 5-km-wide caldera and has a 500-m-wide crater.  A plinian eruption producing the 0.25 cu km Ro Blanca tephra about 3500 years ago was the last major magmatic eruption from the volcano.  All subsequent eruptions, including numerous historical eruptions possibly dating back to the 16th century, have been from the prominent crater containing a 500-m-wide acid lake (known as the Active Crater) located ENE of Von Seebach crater.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1405-02=&amp;volpage=photos&amp;photo=096030">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1405-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ovsicori.una.ac.cr/">OVSICORI-UNA, Costa Rica</a></td><td width="33%"><a href="http://www.rsn.geologia.ucr.ac.cr/">OSIVAM-ICE, Costa Rica</a></td></tr></table>	(10.83,-85.323999999999998)
1035	Miravalles	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Miravalles</b></font><br /><font size="5"><b>Costa Rica</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/042031.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 2028 m<br /><b>Latitude:</b> 10.748&deg;N<br /><b>Longitude:</b> 85.153&deg;W</td></tr><tr><td colspan="2"><p align="justify">Miravalles is a 2028-m-high andesitic stratovolcano that is one of five post-caldera cones along a NE-trending line within the broad 15 x 20 km Guayabo (Miravalles) caldera.  The caldera was formed during several major explosive eruptions that produced voluminous dacitic-rhyolitic pyroclastic flows between about 1.5 and 0.6 million years ago.  Growth of post-caldera volcanoes in the eastern part of the caldera that overtopped much of the eastern and southern caldera rims was interrupted by edifice collapse that produced a major debris avalanche to the SW.  Morphologically youthful lava flows cover the western and SW flanks of the post-caldera Miravalles complex, which rises above the town of Guayabo on the flat western caldera floor.  The only reported historical eruptive activity was a small steam explosion on the SW flank in 1946.  High heat flow remains, and Miravalles is the site of the largest developed geothermal field in Costa Rica.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1405-03=&amp;volpage=photos&amp;photo=042031">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1405-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ovsicori.una.ac.cr/">OVSICORI-UNA, Costa Rica</a></td><td width="33%"><a href="http://www.rsn.geologia.ucr.ac.cr/">OSIVAM-ICE, Costa Rica</a></td></tr></table>	(10.747999999999999,-85.153000000000006)
1036	Tenorio	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tenorio</b></font><br /><font size="5"><b>Costa Rica</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/042035.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1916 m<br /><b>Latitude:</b> 10.673&deg;N<br /><b>Longitude:</b> 85.015&deg;W</td></tr><tr><td colspan="2"><p align="justify">The 225 sq km dominantly andesitic Tenorio volcanic massif anchors the SE end of the Guanacaste Range and consists of a cluster of densely forested NNW-SSE-trending volcanic cones.  Overlapping lava flows from the principal peak, Tenorio, blanket the NW-to-SW flanks and descend the NE flank.  The NW-most of three craters of the central cone is sparsely vegetated and appears to be the most recently active.  Volcn Montezuma to the north has twin craters, the northern of which fed a lava flow to the NE.  Additional pyroclastic cones are found to the NE and SW of the central complex, and the Bijagua lava domes were constructed on the northern flank.  A major debris avalanche covered about 100 sq km below the southern flank  of the volcano.  A legend exists of an eruption in 1816, but the volcano was densely forested at the time of an 1864 visit by Seebach and is not considered to have erupted in historical time.  Fumarolic activity is present on the NE flank.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1405-031&amp;volpage=photos&amp;photo=042035">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1405-031">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ovsicori.una.ac.cr/">OVSICORI-UNA, Costa Rica</a></td><td width="33%"><a href="http://www.rsn.geologia.ucr.ac.cr/">OSIVAM-ICE, Costa Rica</a></td></tr></table>	(10.673,-85.015000000000001)
1037	Arenal	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Arenal</b></font><br /><font size="5"><b>Costa Rica</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/081029.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1670 m<br /><b>Latitude:</b> 10.463&deg;N<br /><b>Longitude:</b> 84.703&deg;W</td></tr><tr><td colspan="2"><p align="justify">Conical Volcn Arenal is the youngest stratovolcano in Costa Rica and one of its most active.  The 1670-m-high andesitic volcano towers above the eastern shores of Lake Arenal, which has been enlarged by a hydroelectric project.  Arenal lies along a volcanic chain that has migrated to the NW from the late-Pleistocene Los Perdidos lava domes through the Pleistocene-to-Holocene Chato volcano, which contains a 500-m-wide, lake-filled summit crater.  The earliest known eruptions of Arenal took place about 7000 years ago, and it was active concurrently with Cerro Chato until the activity of Chato ended about 3500 years ago.  Growth of Arenal has been characterized by periodic major explosive eruptions at several-hundred-year intervals and periods of lava effusion that armor the cone.  Arenal's most recent eruptive period began with a major explosive eruption in 1968.  Continuous explosive activity accompanied by slow lava effusion and the occasional emission of pyroclastic flows has occurred since then from vents at the summit and on the upper western flank.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1405-033&amp;volpage=photos&amp;photo=081029">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1405-033">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ovsicori.una.ac.cr/">OVSICORI-UNA, Costa Rica</a></td><td width="33%"><a href="http://www.rsn.geologia.ucr.ac.cr/">OSIVAM-ICE, Costa Rica</a></td></tr></table>	(10.462999999999999,-84.703000000000003)
1038	Platanar	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Platanar</b></font><br /><font size="5"><b>Costa Rica</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/042100.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2267 m<br /><b>Latitude:</b> 10.30&deg;N<br /><b>Longitude:</b> 84.366&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Platanar volcanic center is the NW-most volcano in the Cordillera Central of Costa Rica.  The massive complex covers about 900 sq km and is dominated by two largely Pleistocene stratovolcanoes, Platanar and Porvenir.  These volcanoes were constructed within the Pleistocene Chocosuela caldera, which may have formed during a major slope failure.  The 2183-m-high Cerro Platanar volcano (known locally as Volcn Congo) on the north side of the complex has prehistorical lava flows on its western flanks and is the youngest volcanic center.  The highest peak of the complex is 2267-m-high Porvenir volcano, whose summit crater lies 3 km south of Platanar.  A thin layer of phreatic ash suggested that an eruption from Platanar occurred within the past few thousand years (Stine and Banks, 1991).  The Aguas Zarcas group of nine basaltic cinder cones, located on the north flank of the Platanar-Porvenir complex to as low as 160 m altitude, is in part Holocene in age.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1405-034&amp;volpage=photos&amp;photo=042100">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1405-034">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ovsicori.una.ac.cr/">OVSICORI-UNA, Costa Rica</a></td><td width="33%"><a href="http://www.rsn.geologia.ucr.ac.cr/">OSIVAM-ICE, Costa Rica</a></td></tr></table>	(10.300000000000001,-84.366)
1039	Pos	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Pos</b></font><br /><font size="5"><b>Costa Rica</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/042099.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2708 m<br /><b>Latitude:</b> 10.20&deg;N<br /><b>Longitude:</b> 84.233&deg;W</td></tr><tr><td colspan="2"><p align="justify">The broad, well-vegetated edifice of Pos, one of the most active volcanoes of Costa Rica, contains three craters along a N-S line.  The frequently visited multi-hued summit crater lakes of the basaltic-to-dacitic volcano, which is one of Costa Rica's most prominent natural landmarks, are easily accessible by vehicle from the nearby capital city of San Jos.  A N-S-trending fissure cutting the 2708-m-high complex stratovolcano extends to the lower northern flank, where it has produced the Congo stratovolcano and several lake-filled maars.  The southernmost of the two summit crater lakes, Botos, is cold and clear and last erupted about 7500 years ago.  The more prominent geothermally heated northern lake, Laguna Caliente, is one of the world's most acidic natural lakes, with a pH of near zero.  It has been the site of frequent phreatic and phreatomagmatic eruptions since the first historical eruption was reported in 1828.  Pos eruptions often include geyser-like ejections of crater-lake water.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1405-04=&amp;volpage=photos&amp;photo=042099">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1405-04=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ovsicori.una.ac.cr/">OVSICORI-UNA, Costa Rica</a></td><td width="33%"><a href="http://www.rsn.geologia.ucr.ac.cr/">OSIVAM-ICE, Costa Rica</a></td></tr></table>	(10.199999999999999,-84.233000000000004)
1040	Barva	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Barva</b></font><br /><font size="5"><b>Costa Rica</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/042086.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2906 m<br /><b>Latitude:</b> 10.135&deg;N<br /><b>Longitude:</b> 84.10&deg;W</td></tr><tr><td colspan="2"><p align="justify">The central and least known of three massive volcanoes towering over the capital city of San Jos, Volcn Barva (Barba) is a complex volcano with multiple summit and flank vents.  Its three principal summits visible from the Central Valley give it the common local name of Las Tres Maras.  The voluminous andesitic-to-dacitic Tirib Tuff, exposed in the Central Valley of Costa Rica, was erupted about 322,000 years ago from the Barva summit caldera.  Four pyroclastic cones are constructed within the 2 x 3 km caldera at the central and NW part of the summit.  The SW peak contains four cones, one of which has a crater lake.  Satellitic cones are found on the northern and southern flanks.  Lava flows blanket the south side of Barva volcano.  The Los Angeles flow, one of the most recent, descends nearly to the city of Heredia.  A large plinian eruption occurred at Barva during the early Holocene.  Eruptions were reported in 1760 or 1766, 1776? (also a mudflow), and 1867, but later visits to the summit did not provide evidence of eruptions during historical time.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1405-05=&amp;volpage=photos&amp;photo=042086">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1405-05=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ovsicori.una.ac.cr/">OVSICORI-UNA, Costa Rica</a></td><td width="33%"><a href="http://www.rsn.geologia.ucr.ac.cr/">OSIVAM-ICE, Costa Rica</a></td></tr></table>	(10.135,-84.099999999999994)
1041	Iraz	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Iraz</b></font><br /><font size="5"><b>Costa Rica</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/086025.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3432 m<br /><b>Latitude:</b> 9.979&deg;N<br /><b>Longitude:</b> 83.852&deg;W</td></tr><tr><td colspan="2"><p align="justify">Iraz, Costa Rica's highest volcano and one of its most active, rises to 3432 m immediately east of the capital city of San Jos.  The massive volcano covers an area of 500 sq km and is vegetated to within a few hundred meters of its broad flat-topped summit crater complex.  At least 10 satellitic cones are located on the southern flank of Iraz.  No lava flows have been identified from Iraz since the eruption of the massive Cervantes lava flows from south-flank vents about 14,000 years ago, and all known Holocene eruptions have been explosive.  The focus of eruptions at the summit crater complex has migrated to the west towards the historically active crater, which contains a small lake of variable size and color.  Although eruptions may have occurred around the time of the Spanish conquest, the first well-documented historical eruption occurred in 1723, and frequent explosive eruptions have occurred since.  Ashfall from the last major eruption of Iraz during 1963-65 caused significant disruption to San Jos and surrounding areas.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1405-06=&amp;volpage=photos&amp;photo=086025">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1405-06=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ovsicori.una.ac.cr/">OVSICORI-UNA, Costa Rica</a></td><td width="33%"><a href="http://www.rsn.geologia.ucr.ac.cr/">OSIVAM-ICE, Costa Rica</a></td></tr></table>	(9.9789999999999992,-83.852000000000004)
1042	Turrialba	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Turrialba</b></font><br /><font size="5"><b>Costa Rica</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/096036.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3340 m<br /><b>Latitude:</b> 10.025&deg;N<br /><b>Longitude:</b> 83.767&deg;W</td></tr><tr><td colspan="2"><p align="justify">Turrialba, the easternmost of Costa Rica's Holocene volcanoes, is a large vegetated basaltic-to-dacitic stratovolcano located across a broad saddle NE of Iraz volcano overlooking the city of Cartago.  The massive 3340-m-high Turrialba is exceeded in height only by Iraz, covers an area of 500 sq km, and is one of Costa Rica's most voluminous volcanoes.  Three well-defined craters occur at the upper SW end of a broad 800 x 2200 m wide summit depression that is breached to the NE.  Most activity at Turrialba originated from the summit vent complex, but two pyroclastic cones are located on the SW flank.  Five major explosive eruptions have occurred at Turrialba during the past 3500 years.  Turrialba has been quiescent since a series of explosive eruptions during the 19th century that were sometimes accompanied by pyroclastic flows.  Fumarolic activity continues at the central and SW summit craters.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1405-07=&amp;volpage=photos&amp;photo=096036">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1405-07=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ovsicori.una.ac.cr/">OVSICORI-UNA, Costa Rica</a></td><td width="33%"><a href="http://www.rsn.geologia.ucr.ac.cr/">OSIVAM-ICE, Costa Rica</a></td></tr></table>	(10.025,-83.766999999999996)
1043	Bar	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bar</b></font><br /><font size="5"><b>Panam</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/083075.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 3474 m<br /><b>Latitude:</b> 8.808&deg;N<br /><b>Longitude:</b> 82.543&deg;W</td></tr><tr><td colspan="2"><p align="justify">The westernmost volcano in Panam, Bar, is a complex dominantly andesitic stratovolcano in the Talamanca Range near the Costa Rica border.  The forested 3474-m-high Volcn Bar (also referred to as Volcn de Chiriqui) is the highest peak in Panam, and the summit now bristles with communication towers.  A large 6-km-wide summit caldera breached widely to the west was formed by a large volcanic landslide, which created a massive debris-avalanche deposit that extends onto the Pacific coastal plain.  Post-collapse eruptions have constructed lava domes inside the caldera that have grown to a height exceeding that of  the caldera rim.  A strong explosive eruption at about 700 AD ended human occupation at the Cerro Punta archaeological site NW of the volcano.  Montessus de Ballore (1884) reported a strong eruption at Bar in the mid-16th century.   Sapper (1917) considered this report to be uncertain, but radiocarbon dates subsequently imply tephra deposits younger than about 500 years.  Volcn Bar is the youngest major volcano in Panam, and geothermal exploration projects have been undertaken to determine its energy potential.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1406-01-&amp;volpage=photos&amp;photo=083075">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1406-01-">Smithsonian Volcano Information</a></td></tr></table>	(8.8079999999999998,-82.543000000000006)
1044	La Yeguada	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>La Yeguada</b></font><br /><font size="5"><b>Panam</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/070053.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1297 m<br /><b>Latitude:</b> 8.47&deg;N<br /><b>Longitude:</b> 80.82&deg;W</td></tr><tr><td colspan="2"><p align="justify">La Yeguada, also known as Chitra-Calobre, is a massive volcanic complex in west-central Panam north of the Azuero Peninsula that was active from the Miocene into the Quaternary.  The youngest major feature of La Yeguada is located within a large fault-bounded horst that forms the high point of the volcanic complex east of Laguna La Yeguada.  The latest eruptions took place from the northern part of the horst about 220,000 years ago at Cerro Corero lava dome (also known as Cerro de la Charca), north of El Castillo.  The youngest feature of the La Yeguada complex is the Media Luna cinder cone, which was erupted through Tertiary ignimbrite deposits at the NW side of the complex.  The oldest peat layer within a small lake dammed by a basaltic lava flow originating from the cone was radiocarbon dated at about 300-350 years ago.  Warm springs are scattered throughout the complex, and the Chitra-Calobre geothermal field is one of three areas in Panam that have been the object of intensive geothermal exploration.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1406-02-&amp;volpage=photos&amp;photo=070053">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1406-02-">Smithsonian Volcano Information</a></td></tr></table>	(8.4700000000000006,-80.819999999999993)
1045	Romeral	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Romeral</b></font><br /><font size="5"><b>Colombia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117087.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 3858 m<br /><b>Latitude:</b> 5.206&deg;N<br /><b>Longitude:</b> 75.364&deg;W</td></tr><tr><td colspan="2"><p align="justify">Recent work has documented the northernmost Holocene volcano in South America.  The andesitic-to-dacitic Romeral stratovolcano lies at the northern end of the Ruiz-Tolima volcanic chain, NW of Cerro Bravo volcano, and lies east of the towns of Neira and Aranzazu.  It has produced two young plinian pumice deposits that blanket areas NW of the volcano.  The pumice deposits are separated by a soil layer radiocarbon dated at about 8460 and 7340 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1501-011&amp;volpage=photos&amp;photo=117087">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1501-011">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ingeominas.gov.co/">INGEOMINAS, Colombia</a></td></tr></table>	(5.2060000000000004,-75.364000000000004)
1046	Cerro Bravo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cerro Bravo</b></font><br /><font size="5"><b>Colombia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/100084.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 4000+ m<br /><b>Latitude:</b> 5.092&deg;N<br /><b>Longitude:</b> 75.30&deg;W</td></tr><tr><td colspan="2"><p align="justify">Cerro Bravo is a relatively low dominantly dacitic lava-dome complex north of Nevado del Ruiz volcano that was constructed within the Pleistocene Quebrada Seca caldera.  A series of moderate plinian eruptions during the Holocene has been accompanied by pyroclastic flows and lava dome growth.  Although historical records of the roughly 4000-m-high Cerro Bravo eruptions have not been found, stratigraphic evidence indicates that the volcano last erupted sometime between the 1595 and 1845 eruptions of Ruiz volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1501-012&amp;volpage=photos&amp;photo=100084">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1501-012">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ingeominas.gov.co/">INGEOMINAS, Colombia</a></td></tr></table>	(5.0919999999999996,-75.299999999999997)
1047	Nevado del Ruiz	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Nevado del Ruiz</b></font><br /><font size="5"><b>Colombia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/043059.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 5321 m<br /><b>Latitude:</b> 4.895&deg;N<br /><b>Longitude:</b> 75.322&deg;W</td></tr><tr><td colspan="2"><p align="justify">Nevado del Ruiz is a broad, glacier-covered volcano in central Colombia that covers &gt;200 sq km.  Three major edifices, composed of andesitic and dacitic lavas and andesitic pyroclastics, have been constructed since the beginning of the Pleistocene.  The modern cone consists of a broad cluster of lava domes built within the summit caldera of an older Ruiz volcano.  The 1-km-wide, 240-m-deep Arenas crater occupies the summit.  The prominent La Olleta pyroclastic cone is located on the SW flank, and may also have been active in historical time.  Steep headwalls of massive landslides cut the flanks of Nevado del Ruiz.  Melting of its summit icecap during historical eruptions, which date back to the 16th century, has resulted in devastating lahars, including one in 1985 that was South America's deadliest eruption.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1501-02=&amp;volpage=photos&amp;photo=043059">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1501-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ingeominas.gov.co/">INGEOMINAS, Colombia</a></td></tr></table>	(4.8949999999999996,-75.322000000000003)
1048	Santa Isabel	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Santa Isabel</b></font><br /><font size="5"><b>Colombia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/043066.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 4950 m<br /><b>Latitude:</b> 4.82&deg;N<br /><b>Longitude:</b> 75.37&deg;W</td></tr><tr><td colspan="2"><p align="justify">Santa Isabel is a small andesitic shield volcano that is dwarfed by its neighbors to the NE (Nevado del Ruiz) and SE (Tolima).  Three lava domes occupy the elongated, N-S-trending glaciated summit region, which has two main peaks.  Holocene lava flows fill valleys SW and SE of Santa Isabel.  A small Holocene lava dome was emplaced at the center of a circular depression about 10 km SW of the volcano.  No historical eruptions have occurred from Santa Isabel.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1501-021&amp;volpage=photos&amp;photo=043066">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1501-021">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ingeominas.gov.co/">INGEOMINAS, Colombia</a></td></tr></table>	(4.8200000000000003,-75.370000000000005)
1049	Nevado del Tolima	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Nevado del Tolima</b></font><br /><font size="5"><b>Colombia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/043069.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 5200+ m<br /><b>Latitude:</b> 4.67&deg;N<br /><b>Longitude:</b> 75.33&deg;W</td></tr><tr><td colspan="2"><p align="justify">The steep-sided, glacier-clad Nevado del Tolima volcano contrasts with the broad profile of Nevado del Ruiz volcano to the north.  The andesitic-dacitic younger Tolima volcano formed during the past 40,000 years, rising above and largely obscuring a 3-km-wide late-Pleistocene caldera.  The summit consists of a cluster of late-Pleistocene to Holocene lava domes that were associated with thick block-lava flows on the northern and eastern flanks and extensive pyroclastic-flow deposits.  The summit contains a funnel-shaped crater 200-300 m deep.  Holocene activity has included explosive eruptions ranging in size from moderate to plinian.  The last major eruption took place about 3600 years ago.  Lava dome growth has produced block-and-ash flows that traveled primarily to the NE and SE.  Minor explosive eruptions have been recorded from Tolima in the 19th and 20th centuries.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1501-03=&amp;volpage=photos&amp;photo=043069">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1501-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ingeominas.gov.co/">INGEOMINAS, Colombia</a></td></tr></table>	(4.6699999999999999,-75.329999999999998)
1050	Machn	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Machn</b></font><br /><font size="5"><b>Colombia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/075060.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2650+ m<br /><b>Latitude:</b> 4.48&deg;N<br /><b>Longitude:</b> 75.392&deg;W</td></tr><tr><td colspan="2"><p align="justify">The small Cerro Machn stratovolcano lies at the southern end of the Ruiz-Tolima massif about 20 km WNW of the city of Ibagu.  A 3-km-wide caldera is breached to the south and contains three forested dacitic lava domes.  Voluminous pyroclastic flows traveled up to 40 km from the volcano during eruptions in the mid-to-late Holocene perhaps associated with formation of the caldera.  Late-Holocene eruptions produced dacitic block-and-ash flows that traveled through the breach in the caldera rim to the west and south.  The latest known eruption of Volcn Cerro Machn took place about 800 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1501-04=&amp;volpage=photos&amp;photo=075060">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1501-04=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ingeominas.gov.co/">INGEOMINAS, Colombia</a></td></tr></table>	(4.4800000000000004,-75.391999999999996)
1051	Nevado del Huila	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Nevado del Huila</b></font><br /><font size="5"><b>Colombia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/068002.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 5364 m<br /><b>Latitude:</b> 2.93&deg;N<br /><b>Longitude:</b> 76.03&deg;W</td></tr><tr><td colspan="2"><p align="justify">Nevado del Huila, the highest active volcano in Colombia, is an elongated N-S-trending volcanic chain mantled by a glacier icecap.  The 5364-m-high andesitic-dacitic volcano was constructed within a 10-km-wide caldera.  Volcanism at Nevado del Huila has produced six volcanic cones whose ages in general migrated from south to north.  The high point of the complex is Pico Central.  Two glacier-free lava domes lie at the southern end of the Huila volcanic complex.  The first historical eruption from this little known volcano was an explosive eruption in the mid-16th century.  Long-term, persistent steam columns had risen from Pico Central prior to the next eruption in 2007, when explosive activity was accompanied by damaging mudflows.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1501-05=&amp;volpage=photos&amp;photo=068002">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1501-05=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ingeominas.gov.co/">INGEOMINAS, Colombia</a></td></tr></table>	(2.9300000000000002,-76.030000000000001)
1052	Purac	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Purac</b></font><br /><font size="5"><b>Colombia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117086.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 4650+ m<br /><b>Latitude:</b> 2.32&deg;N<br /><b>Longitude:</b> 76.40&deg;W</td></tr><tr><td colspan="2"><p align="justify">One of the most active volcanoes of Colombia, Purac consists of an andesitic stratovolcano with a 500-m-wide summit crater that was constructed over a dacitic shield volcano.  Purac lies at the NW end of a volcanic massif opposite Pan de Azcar stratovolcano, 6 km to the SE.  A NW-SE-trending group of seven cones and craters, Los Coconucos, lies between the two larger edifices.  Frequent explosive eruptions in the 19th and 20th centuries have modified the morphology of the summit crater.  The largest eruptions occurred in 1849, 1869, and 1885.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1501-06=&amp;volpage=photos&amp;photo=117086">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1501-06=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ingeominas.gov.co/">INGEOMINAS, Colombia</a></td></tr></table>	(2.3199999999999998,-76.400000000000006)
1053	Sotar	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sotar</b></font><br /><font size="5"><b>Colombia</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas</td><td width="50%" align="left"><b>Summit Elev:</b> 4400+ m<br /><b>Latitude:</b> 2.108&deg;N<br /><b>Longitude:</b> 76.592&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn Sotar, also known as Cerro Azafatudo, is a little-known andesitic-dacitic stratovolcano located about 25 km SSE of Popayn city in southern Colombia, SW of Purac volcano.  Three calderas, 4.5, 2.5, and 1 km in diameter, are found on Sotar, giving the summit an irregular profile.  No historical eruptions are known from Sotar, however the volcano currently displays fumarolic and hot spring activity.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1501-061">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ingeominas.gov.co/">INGEOMINAS, Colombia</a></td></tr></table>	(2.1080000000000001,-76.591999999999999)
1054	Doa Juana	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Doa Juana</b></font><br /><font size="5"><b>Colombia</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 4150+ m<br /><b>Latitude:</b> 1.47&deg;N<br /><b>Longitude:</b> 76.92&deg;W</td></tr><tr><td colspan="2"><p align="justify">The forested Doa Juana stratovolcano contains two calderas, breached to the NE and SW.  The summit of the andesitic-dacitic volcano is comprised of a series of post-caldera lava domes.  The older caldera, open to the NE, formed during the mid-Holocene, accompanied by voluminous pyroclastic flows.  The younger caldera contains the active central cone.  The only historical activity of Doa Juana took place during a long-term eruption from 1897-1906, when growth of a summit lava dome was accompanied by major pyroclastic flows.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1501-07=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ingeominas.gov.co/">INGEOMINAS, Colombia</a></td></tr></table>	(1.47,-76.920000000000002)
1055	Galeras	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Galeras</b></font><br /><font size="5"><b>Colombia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/043076.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 4276 m<br /><b>Latitude:</b> 1.22&deg;N<br /><b>Longitude:</b> 77.37&deg;W</td></tr><tr><td colspan="2"><p align="justify">Galeras, a stratovolcano with a large breached caldera located immediately west of the city of Pasto, is one of Colombia's most frequently active volcanoes.  The dominantly andesitic Galeras volcanic complex has been active for more than 1 million years, and two major caldera collapse eruptions took place during the late Pleistocene.  Long-term extensive hydrothermal alteration has affected the volcano.  This has contributed to large-scale edifice collapse that has occurred on at least three occasions, producing debris avalanches that swept to the west and left a large horseshoe-shaped caldera inside which the modern cone has been constructed.  Major explosive eruptions since the mid Holocene have produced widespread tephra deposits and pyroclastic flows that swept all but the southern flanks.  A central cone slightly lower than the caldera rim has been the site of numerous small-to-moderate historical eruptions since the time of the Spanish conquistadors.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1501-08=&amp;volpage=photos&amp;photo=043076">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1501-08=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ingeominas.gov.co/">INGEOMINAS, Colombia</a></td></tr></table>	(1.22,-77.370000000000005)
1056	Azufral	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Azufral</b></font><br /><font size="5"><b>Colombia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/043091.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 4070 m<br /><b>Latitude:</b> 1.08&deg;N<br /><b>Longitude:</b> 77.68&deg;W</td></tr><tr><td colspan="2"><p align="justify">Azufral stratovolcano in southern Colombia, also known as Azufral de Tquerres, is truncated by a 2.5 x 3 km caldera containing a Holocene rhyodacitic lava-dome complex.  A crescent-shaped lake, Laguna Verde, occupies the NW side of the caldera.  Nearly a dozen lava domes are present, the latest of which were formed about 3600 years ago and have active fumaroles.  Azufral rocks are more silicic than those of nearby Colombian volcanoes; an apron of rhyodacitic pyroclastic-flow deposits rings the volcano.  The last known eruption of Volcn Azufral took place about 1000 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1501-09=&amp;volpage=photos&amp;photo=043091">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1501-09=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ingeominas.gov.co/">INGEOMINAS, Colombia</a></td></tr></table>	(1.0800000000000001,-77.680000000000007)
1057	Cumbal	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cumbal</b></font><br /><font size="5"><b>Colombia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/043090.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 4764 m<br /><b>Latitude:</b> 0.95&deg;N<br /><b>Longitude:</b> 77.87&deg;W</td></tr><tr><td colspan="2"><p align="justify">Many youthful lava flows extend from the glacier-capped Cumbal volcano, the southernmost historically active volcano of Colombia.  The volcano is elongated in a NE-SW direction and is composed primarily of andesitic-dacitic lava flows.  Two fumarolically active craters occupy the summit ridge; the main crater on the NE side and Mundo Nuevo crater on the SW side.  A young lava dome occupies the 250-m-wide summit crater, and eruptions from the upper east flank produced a 6-km-long lava field.  The oldest crater lies NNE of the summit crater, suggesting SW-ward migration of activity.  Explosive eruptions in 1877 and 1926 are the only known historical activity from Cumbal.  Fumarole fields are found in the two summit craters, and thermal springs are located on the SE flanks.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1501-10=&amp;volpage=photos&amp;photo=043090">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1501-10=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ingeominas.gov.co/">INGEOMINAS, Colombia</a></td></tr></table>	(0.94999999999999996,-77.870000000000005)
1058	Soche	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Soche</b></font><br /><font size="5"><b>Ecuador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/114090.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 3955 m<br /><b>Latitude:</b> 0.552&deg;N<br /><b>Longitude:</b> 77.580&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn el Soche, a small stratovolcano near the Colombia border, is the northernmost of a chain of Ecuadorian volcanoes east of the principal volcanic axis.  The dominantly dacitic Soche volcano was constructed over Paleozoic rocks and has a summit caldera that opens towards the east.  A major explosive eruption took place during the early Holocene at about 8600 years BP, depositing tephra NW into Colombia.  The ejection of voluminous dacitic airfall pumice and pyroclastic flows was followed by the formation of two lava domes in the caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-001&amp;volpage=photos&amp;photo=114090">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-001">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(0.55200000000000005,-77.579999999999998)
1059	Chachimbiro	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Chachimbiro</b></font><br /><font size="5"><b>Ecuador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120064.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 4106 m<br /><b>Latitude:</b> 0.468&deg;N<br /><b>Longitude:</b> 78.287&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Chachimbiro volcanic complex lies about 25 km NW of the city of Ibarra.  Late Pleistocene collapse of the andesitic Huanguillaro stratovolcano produced a 6.8 cu km debris-avalanche deposit and a 4-km-wide avalanche caldera open to the east that has largely been filled by lava domes, including the rhyodacitic Hug lava dome.  The avalanche deposit is overlain by three large ignimbrites and pyroclastic-flow deposits related to dome growth.  The late Pleistocene-to-Holocene, NNE-trending dacitic Chachimbiro-Pucar line of lava domes includes the Pitzantzi lava dome, which erupted about 5700 years ago, producing an ash deposit that extends to the NW.   Hot springs and thermal areas are present at the Chachimbiro complex.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-002&amp;volpage=photos&amp;photo=120064">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-002">Smithsonian Volcano Information</a></td></tr></table>	(0.46800000000000003,-78.287000000000006)
1060	Cuicocha	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cuicocha</b></font><br /><font size="5"><b>Ecuador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/116045.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 3246 m<br /><b>Latitude:</b> 0.308&deg;N<br /><b>Longitude:</b> 78.364&deg;W</td></tr><tr><td colspan="2"><p align="justify">The scenic lake-filled Cuicocha caldera is located at the southern foot of the sharp-peaked Pleistocene Cotacachi stratovolcano about 100 km north of Quito.  Both Cotacachi and Cuicocha were constructed along the Otavalo-Umpal fracture zone.  Eruptive activity at Cuicocha began about 4500 years ago and continued until about 1300 years ago.  The 3-km-wide, steep-walled caldera was created during a major explosive eruption about 3100 years ago that produced nearly 5 cu km of pyroclastic-flow and -fall deposits.  Cuicocha contains four intra-caldera lava domes that form two steep-sided forested islands in the 148-m-deep lake.  A pre-caldera Cuicocha lava dome is situated on the outer east side of the caldera.  Pyroclastic-flow deposits cover wide areas around the low-rimmed caldera, primarily to the east.  Gas emission continues from several locations in the caldera lake.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-003&amp;volpage=photos&amp;photo=116045">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-003">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(0.308,-78.364000000000004)
1061	Imbabura	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Imbabura</b></font><br /><font size="5"><b>Ecuador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/116099.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Compound volcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 4609 m<br /><b>Latitude:</b> 0.258&deg;N<br /><b>Longitude:</b> 78.183&deg;W</td></tr><tr><td colspan="2"><p align="justify">Imbabura volcano rises to the north above scenic Laguna de San Pablo in the Interandean valley about 60 km north of Quito.  The main edifice, Taita Imbabura (&quot;Father Imbabura&quot;) forms the summit, with Huarmi Imbabura (&quot;Imbabura's Son&quot;) forming a lateral lava-dome complex on the SW flank.   Activity at the Pleistocene Imbabura I edifice constructed a large andesitic stratovolcano and ended prior to about 43,000 years ago with a major collapse that produced a debris avalanche that traveled 16 km to the north.  Subsequent growth of the Imbabura II stratovolcano continued at least into the early Holocene and typically consisted of growth and collapse of large-volume dacitic lava domes.  A major eruption about 25,000 years ago produced a debris avalanche and possible lateral blast and was followed by growth of the Huarmi Imbabura lava dome.  Historical reports of eruptions consisted of only mudflows and rock slides.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-004&amp;volpage=photos&amp;photo=116099">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-004">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(0.25800000000000001,-78.183000000000007)
1062	Cayambe	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cayambe</b></font><br /><font size="5"><b>Ecuador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/044006.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Compound volcano<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> 5790 m<br /><b>Latitude:</b> 0.029&deg;N<br /><b>Longitude:</b> 77.986&deg;W</td></tr><tr><td colspan="2"><p align="justify">The massive compound andesitic-dacitic Cayambe stratovolcano is located on the isolated western edge of the Cordillera Real, east of the Inter-Andean Valley.  The 5790-m-high volcano, whose southern flank lies astride the equator, is capped by extensive glaciers, which descend to 4200 m on the eastern Amazonian side.  The modern Nevado Cayambe volcano, constructed to the east of older Pleistocene volcanic complexes, contains two summit lava domes located about 1.5 km apart, the western of which is the highest.  Several other lava domes on the upper flanks have been the source of pyroclastic flows that reached the lower flanks of the volcano.  A prominent Holocene pyroclastic cone on the lower eastern flank, La Virgen, fed thick andesitic lava flows that traveled about 10 km to the east.  Nevado Cayambe was recently discovered to have produced frequent explosive eruptions during the Holocene beginning about 4000 years ago, and to have had a single historical eruption, during 1785-86.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-006&amp;volpage=photos&amp;photo=044006">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-006">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(0.029000000000000001,-77.986000000000004)
1063	Reventador	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Reventador</b></font><br /><font size="5"><b>Ecuador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/116071.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 3562 m<br /><b>Latitude:</b> 0.077&deg;S<br /><b>Longitude:</b> 77.656&deg;W</td></tr><tr><td colspan="2"><p align="justify">Reventador is the most frequently active of a chain of Ecuadorian volcanoes in the Cordillera Real, well east of the principal volcanic axis.  The forested, dominantly andesitic Volcn El Reventador stratovolcano rises to 3562 m above the jungles of the western Amazon basin.  A 4-km-wide caldera widely breached to the east was formed by edifice collapse and is partially filled by a young, unvegetated stratovolcano that rises about 1300 m above the caldera floor to a height comparable to the caldera rim.  Reventador has been the source of numerous lava flows as well as explosive eruptions that were visible from Quito in historical time.  Frequent lahars in this region of heavy rainfall have constructed a debris plain on the eastern floor of the caldera.  The largest historical eruption at Reventador took place in 2002, producing a 17-km-high eruption column, pyroclastic flows that traveled up to 8 km, and lava flows from summit and flank vents.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-01=&amp;volpage=photos&amp;photo=116071">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(-0.076999999999999999,-77.656000000000006)
1064	Pululagua	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Pululagua</b></font><br /><font size="5"><b>Ecuador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/044018.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 3356 m<br /><b>Latitude:</b> 0.038&deg;N<br /><b>Longitude:</b> 78.463&deg;W</td></tr><tr><td colspan="2"><p align="justify">Pululagua is a relatively low, forested volcano immediately north of the equator, about 15 km north of Quito.  The volcano contains a 5-km-wide summit caldera narrowly breached to the west and partially filled by a group of dacitic lava domes.  Older pre-caldera lava domes are found on the eastern, SE, and southern sides of the caldera, with a group of younger pre-caldera lava domes primarily on the eastern side.  Four post-caldera domes rises up to 480 m above the caldera floor.  Large explosive eruptions producing pyroclastic flows took place during the late Pleistocene and Holocene.  Caldera formation took place during a series of eruptions lasting 150-200 years beginning about 2650 radiocarbon years ago.  The latest dated eruption occurred from post-caldera lava domes about 1670 years ago and produced lava flows and pyroclastic flows.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-011&amp;volpage=photos&amp;photo=044018">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-011">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(0.037999999999999999,-78.462999999999994)
1065	Guagua Pichincha	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Guagua Pichincha</b></font><br /><font size="5"><b>Ecuador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/116065.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 4784 m<br /><b>Latitude:</b> 0.171&deg;S<br /><b>Longitude:</b> 78.598&deg;W</td></tr><tr><td colspan="2"><p align="justify">Guagua Pichincha and the older Pleistocene Rucu Pichincha stratovolcanoes form a broad volcanic massif that rises immediately to the west of Ecuador's capital city, Quito.  A lava dome is located at the head of a 6-km-wide breached caldera that formed during a late-Pleistocene slope failure of Guagua Pichincha about 50,000 years ago.  Subsequent late-Pleistocene and Holocene eruptions from the central vent in the breached caldera consisted of explosive activity with pyroclastic flows accompanied by periodic growth and destruction of the central lava dome.  Many minor eruptions have occurred since the beginning of the Spanish era at Guagua Pichincha, which is one of Ecuador's most active volcanoes.  The largest historical eruption took place in 1660, when ash fell over a 1000 km radius, accumulating to 30 cm depth in Quito.  Pyroclastic flows and surges also occurred, primarily to the west, and affected agricultural activity, causing great economic losses.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-02=&amp;volpage=photos&amp;photo=116065">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(-0.17100000000000001,-78.597999999999999)
1066	Atacazo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Atacazo</b></font><br /><font size="5"><b>Ecuador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/044032.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 4463 m<br /><b>Latitude:</b> 0.353&deg;S<br /><b>Longitude:</b> 78.617&deg;W</td></tr><tr><td colspan="2"><p align="justify">Atacazo stratovolcano, located about 25 km SW of the capital city of Quito, consists of a large Pleistocene andesitic stratovolcanoes truncated by a late-Pleistocene to Holocene caldera.  Growth of La Carcacha stratovolcano was followed by construction of Atacazo, a stratovolcano with flank lava domes.  The 6-km-wide caldera, which is breached to the SW, is partially filled by three dacitic lava-dome complexes of Holocene age.  Two andesitic lava domes are also found on the SE flank.  Several plinian eruptions have occurred at the Atacazo-Ninahuilca complex during the Holocene, accompanied by growth of lava domes.  The latest dated eruption took place about 2300 years ago, forming the Ninahuilca Chico lava domes within the summit caldera.  Dome formation was accompanied by plinian explosive eruptions and pyroclastic flows that traveled 35 km down valleys to the west.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-021&amp;volpage=photos&amp;photo=044032">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-021">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(-0.35299999999999998,-78.617000000000004)
1067	Chacana	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Chacana</b></font><br /><font size="5"><b>Ecuador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/044035.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 4643 m<br /><b>Latitude:</b> 0.375&deg;S<br /><b>Longitude:</b> 78.25&deg;W</td></tr><tr><td colspan="2"><p align="justify">Chacana is a massive, eroded caldera complex of Pliocene-Holocene age that forms one of the largest rhyolitic centers of the northern Andes.  The caldera is 32-km long in the N-S direction and 18-24 km wide in the E-W direction.  Chacana was constructed during three cycles of andesitic-to-rhyolitic volcanism, with major eruptions about 240,000, 180,00, and 160,000 years ago.  Dacitic lava flows were erupted from caldera-floor fissures between about 30,000 and 21,000 years ago.  Numerous lava domes were constructed within the caldera, which has been the source of frequent explosive eruptions throughout the Holocene as well as historical lava flows during the 18th century.  The massive Antisana stratovolcano was constructed immediately to the SE.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-022&amp;volpage=photos&amp;photo=044035">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-022">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(-0.375,-78.25)
1068	Antisana	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Antisana</b></font><br /><font size="5"><b>Ecuador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/044037.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas</td><td width="50%" align="left"><b>Summit Elev:</b> 5753 m<br /><b>Latitude:</b> 0.481&deg;S<br /><b>Longitude:</b> 78.141&deg;W</td></tr><tr><td colspan="2"><p align="justify">Antisana is a massive, glacier-covered stratovolcano NE of Cotopaxi, along the western margin of the Cordillera Real, 50 km SE of Quito.  An older edifice forming the east side of the volcano was constructed over granitic and metasedimentary rocks and is itself overtopped on its NW side by the modern edifice.  Two small calderas, one breached to the south and the other to the NE, truncate the older edifice.  Viscous, youthful block lava flows have issued from radial fissures on the flanks of 5753-m-high Antisana, one of the highest peaks in Ecuador.  The only unequivocal historical eruption took place from 1801 to 1802, when a lava flow was erupted from a vent NNE of the summit.  Eighteenth-century eruptions occurred SW of Antisana, in the Chacana caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-03=&amp;volpage=photos&amp;photo=044037">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(-0.48099999999999998,-78.141000000000005)
1069	Sumaco	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sumaco</b></font><br /><font size="5"><b>Ecuador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/112100.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 3990 m<br /><b>Latitude:</b> 0.538&deg;S<br /><b>Longitude:</b> 77.626&deg;W</td></tr><tr><td colspan="2"><p align="justify">The forested Sumaco stratovolcano rises 2800 m above the jungles of the western Amazon basin, east of Antisana volcano, and occupies an isolated position far to the east of the main Andes volcanic axis.  Constructed over Cretaceous sedimentary rocks, 3990-m-high Sumaco forms a relatively symmetrical cone in an area of heavy rainfall and erosion.  Sumaco has produced alkaline tephritic, basanitic, and phonolitic rocks distinct from those of the main Andean chain.  The volcano has a broad summit crater, 300 x 400 m wide, containing a central cone.  Reports of historical eruptions are somewhat ambiguous; an eruption is inferred in the 18th or early-19th century on the basis of changes in crater morphology.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-04=&amp;volpage=photos&amp;photo=112100">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-04=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(-0.53800000000000003,-77.626000000000005)
1070	Illiniza	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Illiniza</b></font><br /><font size="5"><b>Ecuador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/044040.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 5248 m<br /><b>Latitude:</b> 0.659&deg;S<br /><b>Longitude:</b> 78.714&deg;W</td></tr><tr><td colspan="2"><p align="justify">The twin glacier-covered peaks of Iliniza volcano form prominent landmarks west of the Interandean valley.  Iliniza Norte lies 1.8 km NNW of the higher peak, 5248-m Iliniza Sur.  The dominantly andesitic-to-dacitic Iliniza is largely, if not entirely Pleistocene in age.  However, the Tishigcuchi (Rasuyacu) lava dome on the south flank was active during the Holocene.  Recent work suggests that Iliniza itself, which is substantially eroded, may have had relatively young eruptions (Hall 1987, pers. comm.).  Iliniza Norte is a remnant of the main volcanic edifice, and the younger Iliniza Sur is an andesitic-dacitic stratovolcano surrounded by thick pyroclastic-flow deposits.  An explosive eruption formed a small caldera, which is partially filled by a lava dome forming the summit of Iliniza Sur.  Two lava domes are found on the southern and NE flanks of the complex.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-041&amp;volpage=photos&amp;photo=044040">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-041">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(-0.65900000000000003,-78.713999999999999)
1071	Cotopaxi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cotopaxi</b></font><br /><font size="5"><b>Ecuador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/044050.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 5911 m<br /><b>Latitude:</b> 0.677&deg;S<br /><b>Longitude:</b> 78.436&deg;W</td></tr><tr><td colspan="2"><p align="justify">Symmetrical, glacier-clad Cotopaxi stratovolcano is Ecuador's most well-known volcano and one of its most active.  The steep-sided cone is capped by nested summit craters, the largest of which is about 550 x 800 m in diameter.  Deep valleys scoured by lahars radiate from the summit of the andesitic volcano, and large andesitic lava flows extend as far as the base of Cotopaxi.  The modern conical volcano has been constructed since a major edifice collapse sometime prior to about 5000 years ago.  Pyroclastic flows (often confused in historical accounts with lava flows) have accompanied many explosive eruptions of Cotopaxi, and lahars have frequently devastated adjacent valleys.  The most violent historical eruptions took place in 1744, 1768, and 1877.  Pyroclastic flows descended all sides of the volcano in 1877, and lahars traveled more than 100 km into the Pacific Ocean and western Amazon basin.  The last significant eruption of Cotopaxi took place in 1904.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-05=&amp;volpage=photos&amp;photo=044050">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-05=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(-0.67700000000000005,-78.436000000000007)
1072	Quilotoa	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Quilotoa</b></font><br /><font size="5"><b>Ecuador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/044076.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 3914 m<br /><b>Latitude:</b> 0.85&deg;S<br /><b>Longitude:</b> 78.90&deg;W</td></tr><tr><td colspan="2"><p align="justify">Quilotoa is a truncated, dacitic cone that is the westernmost of Ecuador's Andean volcanoes.  It is located at the margin of the Western Cordillera, 35 km WNW of the city of Latacunga and contains a 3-km-wide caldera with steep-sided walls that rise 400 m above the surface of 240-m-deep caldera lake.  More than a half dozen lava domes form an circular array along the caldera's perimeter.  This small volcano has produced eight major explosive eruptions during the past 200,000 years.  Its most recent major eruption about 800 radiocarbon years ago produced voluminous pyroclastic flows, lahars that reached the Pacific Ocean, and one of the largest airfall-tephra deposits of the northern Andes.  Formation of the caldera was followed by extrusion of a small lava dome.  Reports of historical eruptions from the caldera lake are somewhat ambiguous.  Fumaroles are present on the lake floor and hot springs occur on the eastern flank.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-06=&amp;volpage=photos&amp;photo=044076">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-06=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(-0.84999999999999998,-78.900000000000006)
1073	Chimborazo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Chimborazo</b></font><br /><font size="5"><b>Ecuador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/116041.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 6310 m<br /><b>Latitude:</b> 1.464&deg;S<br /><b>Longitude:</b> 78.815&deg;W</td></tr><tr><td colspan="2"><p align="justify">Glacier-clad, 6310-m-high Chimborazo, Ecuador's highest volcano, anchors the southern end of the country's &quot;Avenue of Volcanoes&quot; 30 km NW of the city of Riobamba.  The dominantly andesitic-to-dacitic Chimborazo volcano is mostly of Pliocene-to-Pleistocene age.  The volcano collapsed about 35,000 years ago, producing a major debris avalanche, whose deposits underlie Riobamba and temporarily dammed the Ro Chambo, producing an ephemeral lake.  Subsequent eruptions have been dominantly andesitic and constructed three edifices along an east-west line, the youngest and westernmost of which forms the current summit of Chimborazo.  Although activity was at one time thought to have ceased during the very latest Pleistocene, recent work indicates that Chimborazo erupted more than a half dozen times during the Holocene, producing pyroclastic surges that reached down to 3800 m elevation.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-071&amp;volpage=photos&amp;photo=116041">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-071">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(-1.464,-78.814999999999998)
1074	Tungurahua	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tungurahua</b></font><br /><font size="5"><b>Ecuador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/044078.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Somma volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 5023 m<br /><b>Latitude:</b> 1.467&deg;S<br /><b>Longitude:</b> 78.442&deg;W</td></tr><tr><td colspan="2"><p align="justify">Tungurahua, a steep-sided andesitic-dacitic stratovolcano that towers more than 3 km above its northern base, is one of Ecuador's most active volcanoes.  Three major volcanic edifices have been sequentially constructed since the mid-Pleistocene over a basement of metamorphic rocks.  Tungurahua II was built within the past 14,000 years following the collapse of the initial edifice.  Tungurahua II itself collapsed about 3000 years ago and produced a large debris-avalanche deposit and a horseshoe-shaped caldera open to the west, inside which the modern glacier-capped stratovolcano (Tungurahua III) was constructed.  Historical eruptions have all originated from the summit crater.  They have been accompanied by strong explosions and sometimes by pyroclastic flows and lava flows that reached populated areas at the volcano's base.  Prior to a long-term eruption beginning in 1999 that caused the temporary evacuation of the city of Baos at the foot of the volcano, the last major eruption had occurred from 1916 to 1918, although minor activity continued until 1925.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-08=&amp;volpage=photos&amp;photo=044078">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-08=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(-1.4670000000000001,-78.441999999999993)
1075	Sangay	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sangay</b></font><br /><font size="5"><b>Ecuador</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/044090.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas</td><td width="50%" align="left"><b>Summit Elev:</b> 5230 m<br /><b>Latitude:</b> 2.002&deg;S<br /><b>Longitude:</b> 78.341&deg;W</td></tr><tr><td colspan="2"><p align="justify">The isolated Sangay volcano, located east of the Andean crest, is the southernmost of Ecuador's volcanoes, and its most active.  The dominantly andesitic volcano has been in frequent eruption for the past several centuries.  The steep-sided, 5230-m-high glacier-covered volcano grew within horseshoe-shaped calderas of two previous edifices, which were destroyed by collapse to the east, producing large debris avalanches that reached the Amazonian lowlands.  The modern edifice dates back to at least 14,000 years ago.  Sangay towers above the tropical jungle on the east side; on the other sides flat plains of ash from the volcano have been sculpted by heavy rains into steep-walled canyons up to 600 m deep.  The earliest report of a historical eruption was in 1628.  More or less continuous eruptions were reported from 1728 until 1916, and again from 1934 to the present.  The more or less constant eruptive activity has caused frequent changes to the morphology of the summit crater complex.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-09=&amp;volpage=photos&amp;photo=044090">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1502-09=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(-2.0019999999999998,-78.340999999999994)
1076	Fernandina	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Fernandina</b></font><br /><font size="5"><b>Galpagos Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/062078.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1476 m<br /><b>Latitude:</b> 0.37&deg;S<br /><b>Longitude:</b> 91.55&deg;W</td></tr><tr><td colspan="2"><p align="justify">Fernandina, the most active of Galpagos volcanoes and the one closest to the Galpagos mantle plume, is a basaltic shield volcano with a deep 5 x 6.5 km summit caldera.  The volcano displays the classic &quot;overturned soup bowl&quot; profile of Galpagos shield volcanoes.  Its caldera is elongated in a NW-SE direction and formed during several episodes of collapse.  Circumferential fissures surround the caldera and were instrumental in growth of the volcano.  Reporting has been poor in this uninhabited western end of the archipelago, and even a 1981 eruption was not witnessed at the time.  In 1968 the caldera floor dropped 350 m following a major explosive eruption.  Subsequent eruptions, mostly from vents located on or near the caldera boundary faults, have produced lava flows inside the caldera as well as those in 1995 that reached the coast from a SW-flank vent.  Collapse of a nearly 1 cu km section of the east caldera wall during an eruption in 1988 produced a debris-avalanche deposit that covered much of the caldera floor and absorbed the caldera lake.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1503-01=&amp;volpage=photos&amp;photo=062078">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1503-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(-0.37,-91.549999999999997)
1077	Ecuador	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ecuador</b></font><br /><font size="5"><b>Isabela I</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/116052.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 790+ m<br /><b>Latitude:</b> 0.02&deg;S<br /><b>Longitude:</b> 91.546&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn Ecuador straddles the equator at the NW end of Isabela Island.  The western side of the volcano, the smallest of the six large shield volcanoes on Isabela, is broadly breached by edifice collapse, and youthful lava flows cover much of the caldera floor.  Two large pyroclastic cones were constructed along the coast, and several chains of spatter cones and small scoria cones cross the caldera floor, which has a prominent bench on its southern side.  A single dark-colored aa lava flow covers about half of the caldera floor.  A number of young lava flows reach the coast to form Cape Berkeley, west of a large youthful-looking tuff cone.  Extending from the outer eastern flanks of the main edifice is a line of NE-trending fissure-fed vents that connect Volcn Ecuador (also known as Cape Berkeley volcano) with Volcn Wolf.  Volcn Ecuador is the only Isabela Island volcano without historical eruptions.  However, the youthful morphology of its most recent lava flows resembles those of very recent flows on other Isabela Island volcanoes.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1503-011&amp;volpage=photos&amp;photo=116052">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1503-011">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(-0.02,-91.546000000000006)
1078	Wolf	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Wolf</b></font><br /><font size="5"><b>Isabela I</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/047027.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1710 m<br /><b>Latitude:</b> 0.02&deg;N<br /><b>Longitude:</b> 91.35&deg;W</td></tr><tr><td colspan="2"><p align="justify">Wolf, the highest volcano of the Galpagos Islands, straddles the equator at the north end of the archipelago's largest island, Isabela.  The 1710-m-high Volcn Wolf has steeper slopes than most other Isabela volcanoes, reaching angles up to 35 degrees.  A 6 x 7 km caldera, at 700 m one of the deepest of the Galpagos Islands, is located at the volcano's summit.  A prominent bench on the west side of the caldera rises 450 above the caldera floor, much of which is covered by a lava flow erupted in 1982.  Radial fissures concentrated along diffuse rift zones extend down the north, NW, and SE flanks, and submarine vents lie beyond the north and NW fissures.  Similar unvegetated flows originating from a circumferential chain of spatter and scoria cones on the eastern caldera rim drape the forested flanks of the volcano to the sea.  The proportion of aa lava flows at Volcn Wolf exceeds that of other Galpagos volcanoes.  Wolf's 1797 eruption was the first documented historical eruption in the Galpagos Islands.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1503-02=&amp;volpage=photos&amp;photo=047027">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1503-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(0.02,-91.349999999999994)
1079	Darwin	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Darwin</b></font><br /><font size="5"><b>Isabela I</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/047030.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1330 m<br /><b>Latitude:</b> 0.18&deg;S<br /><b>Longitude:</b> 91.28&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn Darwin, named after the renowned naturalist, contains a symmetrical 5-km-wide, 200-m-deep summit caldera whose floor is nearly covered by youthful lava flows.  A broad terrace occupies the SW part of the caldera.  Fresh-looking, unvegetated lava flows descend all flanks of the volcano and reach both the eastern and western coasts.  The most recent summit activity produced several small lava flows from vents on the east caldera floor and NE and SE caldera rims.  Radial fissures descend the volcano's flanks, and one reaches beyond its base to the the SW coast and cuts Tagus tuff cone.  The sheltered anchorage of Tagus Cove breaches the southern side of the cone and was visited by Darwin and other noted visitors.  This prominent tuff cone and its neighbor Beagle (also breached to the south) are located on the SW-flank coastline and were a prominent part of Darwin's geological studies in the Galpagos Islands.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1503-03=&amp;volpage=photos&amp;photo=047030">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1503-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(-0.17999999999999999,-91.280000000000001)
1080	Alcedo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Alcedo</b></font><br /><font size="5"><b>Isabela I</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/047037.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1130 m<br /><b>Latitude:</b> 0.43&deg;S<br /><b>Longitude:</b> 91.12&deg;W</td></tr><tr><td colspan="2"><p align="justify">Alcedo is one of the lowest and smallest of six shield volcanoes on Isabela Island.  Much of the flanks and summit caldera are vegetated, but young lava flows are prominent on the northern flank near the saddle with Darwin volcano.  Alcedo is the only Galpagos volcano known to have erupted rhyolite as well as basalt, producing about 1 cu km of late-Pleistocene rhyolitic tephra and lava flows from several vents late in its history.  Recent faulting has produced a moat around part of the 7-8 km caldera floor, which is elongated N-S and appears to be migrating to the south.  Fewer circumferential fissures occur on Alcedo than on other western Galpagos volcanoes.  An eruption attributed to Alcedo in 1954 (Richards, 1957) is more likely to have been from neighboring Sierra Negra (Simkin 1980, pers. comm.).  Photo-geologic mapping of Alcedo by K. A. Howard (pers. comm.) revealed only one flow on October 30, 1960 photographs that does not appear on May 30, 1946 photos.  That is near Cartago Bay, low on the SE flank, rather than the 610-m, NE-flank elevation listed for the 1954 eruption.  An active hydrothermal system is located within the caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1503-04=&amp;volpage=photos&amp;photo=047037">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1503-04=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(-0.42999999999999999,-91.120000000000005)
1081	Sierra Negra	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sierra Negra</b></font><br /><font size="5"><b>Isabela I</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/116056.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1124 m<br /><b>Latitude:</b> 0.83&deg;S<br /><b>Longitude:</b> 91.17&deg;W</td></tr><tr><td colspan="2"><p align="justify">The broad shield volcano of Sierra Negra at the southern end of Isabela Island contains a shallow 7 x 10.5 km caldera that is the largest in the Galpagos Islands.  Flank vents abound, including cinder cones and spatter cones concentrated along an ENE-trending rift system and tuff cones along the coast and forming offshore islands.  The 1124-m-high volcano is elongated in a NE direction.  Although Sierra Negra is the largest of the five major Isabela volcanoes, it has the flattest slopes, averaging less than 5 degrees and diminishing to 2 degrees near the coast.  A sinuous 14-km-long, N-S-trending ridge occupies the west part of the caldera floor, which lies only about 100 m below its rim.  Volcn de Azufre, the largest fumarolic area in the Galpagos Islands, lies within a graben between this ridge and the west caldera wall.  Lava flows from a major eruption in 1979 extend all the way to the north coast from circumferential fissure vents on the upper northern flank.   Sierra Negra, along with Cerro Azul and Volcn Wolf, is one of the most active of Isabela Island volcanoes.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1503-05=&amp;volpage=photos&amp;photo=116056">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1503-05=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(-0.82999999999999996,-91.170000000000002)
1082	Cerro Azul	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cerro Azul</b></font><br /><font size="5"><b>Isabela I</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/092042.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1640 m<br /><b>Latitude:</b> 0.92&deg;S<br /><b>Longitude:</b> 91.408&deg;W</td></tr><tr><td colspan="2"><p align="justify">Located at the SW tip of the J-shaped Isabela Island, Cerro Azul contains a steep-walled 4 x 5 km nested summit caldera complex that is one of the smallest diameter, but at 650 m one of the deepest in the Galpagos Islands.  The 1640-m-high shield volcano is the second highest of the archipelago.  A conspicuous bench occupies the SW and west sides of the caldera, which formed during several episodes of collapse.  Youthful lava flows cover much of the caldera floor, which has also contained ephemeral lakes.  A prominent tuff cone located at the ENE side of the caldera is evidence of episodic hydrovolcanism at Cerro Azul.  Numerous spatter cones dot the western flanks of the volcano.  Fresh-looking lava flows, many erupted from circumferential fissures, descend the NE and NW flanks of the volcano.  Historical eruptions date back only to 1932, but Cerro Azul has been one of the most active Galpagos volcanoes since that time.  Solfataric activity continues within the caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1503-06=&amp;volpage=photos&amp;photo=092042">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1503-06=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(-0.92000000000000004,-91.408000000000001)
1083	Pinta	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Pinta</b></font><br /><font size="5"><b>Galpagos Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/087027.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 780 m<br /><b>Latitude:</b> 0.58&deg;N<br /><b>Longitude:</b> 90.75&deg;W</td></tr><tr><td colspan="2"><p align="justify">The elongated island of Pinta is the northernmost of the active Galpagos volcanoes.  Pinta is a shield volcano with numerous young cones and lava flows originating from NNW-trending fissures.  A steep sea cliff truncates the western side of the volcano, which lacks the prominent summit caldera of Fernandina and Isabela Island volcanoes.  The fresh, unvegetated lava flows that cover the SE and northern flanks appear to have been erupted during the past few thousand or few hundred years (McBirney and Williams 1969).  An eruption of uncertain nature was reported in 1928 (Catalog of Active Volcanoes of the World).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1503-07=&amp;volpage=photos&amp;photo=087027">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1503-07=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(0.57999999999999996,-90.75)
1084	Marchena	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Marchena</b></font><br /><font size="5"><b>Galpagos Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/101080.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 343 m<br /><b>Latitude:</b> 0.33&deg;N<br /><b>Longitude:</b> 90.47&deg;W</td></tr><tr><td colspan="2"><p align="justify">The low shield volcano forming Marchena Island contains one of the largest calderas of the Galpagos Islands.  In contrast to other Galpagos volcanoes, the 6 x 7 km caldera and its outer flanks have been largely buried by a cluster of pyroclastic cones and associated lava flows.  Its first historical eruption occurred in 1991.  Other young lava flows, some of which may be only a few thousand, or even a few hundred years old, filled the caldera and flowed down its outer forested flanks, in some cases to the sea.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1503-08=&amp;volpage=photos&amp;photo=101080">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1503-08=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(0.33000000000000002,-90.469999999999999)
1085	Genovesa	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Genovesa</b></font><br /><font size="5"><b>Galpagos Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110032.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 64 m<br /><b>Latitude:</b> 0.32&deg;N<br /><b>Longitude:</b> 89.958&deg;W</td></tr><tr><td colspan="2"><p align="justify">The small, very low island of Genovesa is the top of a shield volcano, whose summit is only 64 m high.  The surface of a summit crater lake is near sea level.  A larger, 2-km-wide excentric caldera on the south side forms an embayment that is filled by Darwin Bay.  Sediment filling Arctulus Lake, a crater in the center of the island, is less than 6000 years old.  Youthful flows erupted from flank fissures cover much of the island and very fresh, glassy spatter is found on the volcano's flank (Simkin 1976, pers. comm.).  No historical eruptions are known from Genovesa, although the fresh-looking lava flows suggest a very youthful age.  Basaltic rocks on the island are noted for their abundant coarse plagioclases.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1503-081&amp;volpage=photos&amp;photo=110032">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1503-081">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(0.32000000000000001,-89.957999999999998)
1086	Santiago	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Santiago</b></font><br /><font size="5"><b>Galpagos Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/047049.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 920 m<br /><b>Latitude:</b> 0.22&deg;S<br /><b>Longitude:</b> 90.77&deg;W</td></tr><tr><td colspan="2"><p align="justify">The elongated shield volcano of Santiago Island, also known as San Salvador Island or James Island, is dotted with Holocene pyroclastic cones.  Fresh-looking lava flows from these cones blanket the flanks of the volcano.  The 920-m-high summit ridge, lined with a chain of NW-trending cinder and spatter cones, is located at the NW end of the island.  Prominent flank tuff cones occur at the western and eastern coasts of Santiago.  The most recent activity at Santiago has been concentrated at the NW and SE ends of the island.  The spectacular pahoehoe lava flows at James and Sullivan Bays, on opposite ends of the island, were erupted during historical time.  The James Bay flows were dated by fragments of marmalade pots left by buccaneers in 1684 that were subsequently embedded in the lava flows described by Charles Darwin in 1835.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1503-09=&amp;volpage=photos&amp;photo=047049">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1503-09=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(-0.22,-90.769999999999996)
1087	Santa Cruz	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Santa Cruz</b></font><br /><font size="5"><b>Galpagos Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/116098.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 864 m<br /><b>Latitude:</b> 0.62&deg;S<br /><b>Longitude:</b> 90.33&deg;W</td></tr><tr><td colspan="2"><p align="justify">The highlands of the broad Santa Cruz shield volcano rise to the north above the renowned Charles Darwin Research Station at Academy Bay.  The oval-shaped, 32 x 40 km wide island is capped by youthful pit craters and cinder cones with well-preserved craters that largely bury a shallow summit caldera.  Older uplifted submarine lava flows are found on the NE part of the island and at the fault-delimited offshore island of Baltra.  The highland scoria cones are grouped along an E-W belt parallel to recent fault scarps that border Academy Bay.  The youngest lava flows were erupted from vents along the summit fissure and on the northern flank.  Their fresh morphology and sparsely vegetated surfaces suggest they may be only a few thousand years old, although their ages are not known precisely.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1503-091&amp;volpage=photos&amp;photo=116098">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1503-091">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(-0.62,-90.329999999999998)
1088	San Cristbal	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>San Cristbal</b></font><br /><font size="5"><b>Galpagos Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/101077.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 759 m<br /><b>Latitude:</b> 0.88&deg;S<br /><b>Longitude:</b> 89.50&deg;W</td></tr><tr><td colspan="2"><p align="justify">San Cristbal Island consists of a densely vegetated western part and a lower, younger eastern part with many extremely youthful lava flows.  The SW-side shield volcano morphologically resembles low-angle Hawaiian shields more than the steep-sided shields of Fernandina and Isabela Island.  Most lava flows on the NE part of the island originated from SW-NE-trending fissures.  Young lava flows have reached the sea, where some littoral cones formed.  The latest eruptions were prehistorical in age, but are probably less than 1000 years old.  Kicker Rock, two paired, steep-cliffed islands separated by a narrow cleft, is an enroded remnant of a tuff cone that forms one of the scenic highlights of the Galpagos, 5 km off the west coast of San Cristbal.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1503-12-&amp;volpage=photos&amp;photo=101077">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1503-12-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igepn.edu.ec/">Escuela Politecnica Nacional, Instituto Geofsico</a></td></tr></table>	(-0.88,-89.5)
1089	Quimsachata	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Quimsachata</b></font><br /><font size="5"><b>Per</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117036.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava dome<br />&nbsp;&nbsp;&nbsp; Scoria cone</td><td width="50%" align="left"><b>Summit Elev:</b> 3923 m<br /><b>Latitude:</b> 14.20&deg;S<br /><b>Longitude:</b> 71.33&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Quimsachata (Kimsachata) volcano group, the northernmost young volcanoes in Peru, consist of two late-Pleistocene and Holocene monogenetic volcanoes lie at the foot of the Cordillera Oriental in an isolated area far east of the main volcanic front.  Quimsachata is a high-potassium andesitic scoria cone surrounded by a compound lava shield that was erupted in flat terrain along  the Vilcanota River about 11,500 years ago.  Oroscocha is a rhyolitic lava dome with a short, thick lava flow erupted from a N-S-trending fissure about 6400 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1504-00-&amp;volpage=photos&amp;photo=117036">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1504-00-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igp.gob.pe/">Instituto Geofisico del Per</a></td></tr></table>	(-14.199999999999999,-71.329999999999998)
1090	Sara Sara	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sara Sara</b></font><br /><font size="5"><b>Per</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117038.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 5522 m<br /><b>Latitude:</b> 15.33&deg;S<br /><b>Longitude:</b> 73.45&deg;W</td></tr><tr><td colspan="2"><p align="justify">Glacier-covered Sara Sara volcano lying between Laguna Parinacocha and the Ro Ocona is the westernmost young volcano in Per.  The 5522-m-high andesitic stratovolcano was the source of youthful-looking lava flows with prominent levees that traveled about 10 km eastward into the Ro Ocona valley.  Pristine lava flows on the upper slopes of the volcano and ash layers in peat deposits at its base suggest a very young, probably Holocene age.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1504-002&amp;volpage=photos&amp;photo=117038">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1504-002">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igp.gob.pe/">Instituto Geofisico del Per</a></td></tr></table>	(-15.33,-73.450000000000003)
1091	Coropuna	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Coropuna</b></font><br /><font size="5"><b>Per</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/047060.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 6377 m<br /><b>Latitude:</b> 15.52&deg;S<br /><b>Longitude:</b> 72.65&deg;W</td></tr><tr><td colspan="2"><p align="justify">Nevado Coropuna, Peru's highest and largest volcano, is a massive ice-covered volcanic complex with at least a half dozen summit cones scattered over a 12 x 20 km area.  The 6377-m-high summit of the andesitic-to-dacitic complex is a cone at the NW end, north of a line of E-W-trending cones.  Deep, steep-walled canyons surrounding the volcano give it an impressive topographic relief of more than 4000 m over a horizontal distance of 15 km.  Several young Holocene lava flows descend the NE, SE, and western flanks.  The age of its latest eruption is not known, but solfataric activity has been reported.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1504-003&amp;volpage=photos&amp;photo=047060">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1504-003">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igp.gob.pe/">Instituto Geofisico del Per</a></td></tr></table>	(-15.52,-72.650000000000006)
1092	Andahua-Orcopampa	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Andahua-Orcopampa</b></font><br /><font size="5"><b>Per</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/047063.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 4713 m<br /><b>Latitude:</b> 15.42&deg;S<br /><b>Longitude:</b> 72.33&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Andahua-Orcopampa volcanic field in the Andahua valley area, 20 km ENE of Nevados de Coropuna, is a large 60 x 60 km scoria cone and lava field.  Known locally as the &quot;Valley of the Volcanoes,&quot; the volcanic field lies in a series of deep NNW-SSE-trending, on echelon valleys: Orcopampa, Andahua and Ayo.  The volcanic field contains extremely youthful dominantly trachyandesitic cinder cones and lava flows that have destroyed buildings and may be only a few hundred years old.  The area was reported to have been active during the time of the Incas and to have &quot;become active again&quot; in 1913.  Lava flows have repeatedly dammed the Ro Andagua valley, and an existing small lake was impounded by the youngest lavas.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1504-004&amp;volpage=photos&amp;photo=047063">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1504-004">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igp.gob.pe/">Instituto Geofisico del Per</a></td></tr></table>	(-15.42,-72.329999999999998)
1093	Huambo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Huambo</b></font><br /><font size="5"><b>Per</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/118092.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Summit Elev:</b> 4550? m<br /><b>Latitude:</b> 15.83&deg;S<br /><b>Longitude:</b> 72.13&deg;W</td></tr><tr><td colspan="2"><p align="justify">The monogenetic Huambo volcanic field lies SSE of the Andahua-Orcocampo volcanic field, west of Sabancaya volcano.  The Huambo volcanic field is divided into two segments.  The southern area contains several cinder cones and associated lava flows, some of which are inferred to be of early to late-Holocene age on the basis of morphological criteria.  The northern part contains a single vent, the Cerro Keyocc cinder cone, which produced an extensive lava field that blanketed a plateau to the west during an eruption radiocarbon dated at about 2650 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1504-005&amp;volpage=photos&amp;photo=118092">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1504-005">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igp.gob.pe/">Instituto Geofisico del Per</a></td></tr></table>	(-15.83,-72.129999999999995)
1094	Sabancaya	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sabancaya</b></font><br /><font size="5"><b>Per</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/047068.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 5967 m<br /><b>Latitude:</b> 15.78&deg;S<br /><b>Longitude:</b> 71.85&deg;W</td></tr><tr><td colspan="2"><p align="justify">Sabancaya, located on the saddle between 6288-m-high Ampato and 6025-m-high Hualca Hualca volcanoes, is the youngest of these volcanic centers and the only one to have erupted in historical time.  The oldest of the three volcanoes, Nevado Hualca Hualca, is of probable late-Pliocene to early Pleistocene age.  Both Nevado Ampato and Nevado Sabancaya are only slightly affected by glacial erosion and consist of a series of lava domes aligned along a NW-SW trend.  The name of 5967-m-high Sabancaya (meaning &quot;tongue of fire&quot; in the Quechua Indian language) first appeared in records in 1595 AD, suggesting activity prior to that date.  Holocene activity has consisted of plinian eruptions followed by emission of voluminous andesitic and dacitic lava flows, which form an extensive apron around the volcano on all sides but the south.  Records of historical eruptions of Sabancaya date back to 1750.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1504-006&amp;volpage=photos&amp;photo=047068">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1504-006">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igp.gob.pe/">Instituto Geofisico del Per</a></td></tr></table>	(-15.779999999999999,-71.849999999999994)
1095	Cerro Nicholson	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cerro Nicholson</b></font><br /><font size="5"><b>Per</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cone</td><td width="50%" align="left"><b>Summit Elev:</b> 2520? m<br /><b>Latitude:</b> 16.258&deg;S<br /><b>Longitude:</b> 71.753&deg;W</td></tr><tr><td colspan="2"><p align="justify">Cerro Nicholson, a small isolated scoria cone, was constructed on a plain WSW of Chachani volcano and WNW of El Misti volcano.  Andesitic bombs surround the crater of this relatively young volcanic feature that displays a well-preserved crater at the summit of the scoria cone and has a morphology similar to the Holocene Andahua scoria cones farther to the north.  Cerro Nicholson was erupted through a 1.65-million-year-old Arequipa Airport Ignimbrite deposit erupted from a now-buried site beneath the Chachani volcanic complex.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1504-008">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igp.gob.pe/">Instituto Geofisico del Per</a></td></tr></table>	(-16.257999999999999,-71.753)
1096	El Misti	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>El Misti</b></font><br /><font size="5"><b>Per</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/047087.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Cinder cone</td><td width="50%" align="left"><b>Summit Elev:</b> 5822 m<br /><b>Latitude:</b> 16.294&deg;S<br /><b>Longitude:</b> 71.409&deg;W</td></tr><tr><td colspan="2"><p align="justify">El Misti, Peru's most well-known volcano, is a symmetrical andesitic stratovolcano with nested summit craters that towers above the city of Arequipa.  The modern symmetrical cone, constructed within a small 1.5 x 2 km wide summit caldera that formed between about 13,700 and 11,300 years ago, caps older Pleistocene volcanoes that underwent caldera collapse about 50,000 years ago.  A large scoria cone has grown with the 830-m-wide outer summit crater of El Misti.  At least 20 tephra-fall deposits and numerous pyroclastic-flow deposits have been documented during the past 50,000 years, including a pyroclastic flow that traveled 12 km to the south about 2000 years ago.  El Misti's most recent activity has been dominantly pyroclastic, and strong winds have formed a parabolic dune field of volcanic ash extending up to 20 km downwind.  An eruption in the 15th century affected Inca inhabitants living near the volcano.  Some reports of historical eruptions may represent increased fumarolic activity.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1504-01=&amp;volpage=photos&amp;photo=047087">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1504-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igp.gob.pe/">Instituto Geofisico del Per</a></td></tr></table>	(-16.294,-71.409000000000006)
1097	Ubinas	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ubinas</b></font><br /><font size="5"><b>Per</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/047092.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 5672 m<br /><b>Latitude:</b> 16.355&deg;S<br /><b>Longitude:</b> 70.903&deg;W</td></tr><tr><td colspan="2"><p align="justify">A small, 1.4-km-wide caldera cuts the top of Ubinas, Peru's most active volcano, giving it a truncated appearance.  Ubinas is the northernmost of three young volcanoes located along a regional structural lineament about 50 km behind the main volcanic front of Per.  The growth and destruction of Ubinas I volcano was followed by construction of Ubinas II volcano beginning  in the mid-Pleistocene.  The upper slopes of the andesitic-to-rhyolitic Ubinas II stratovolcano are composed primarily of andesitic and trachyandesitic lava flows and steepen to nearly 45 degrees.  The steep-walled, 150-m-deep summit caldera contains an ash cone with a 500-m-wide funnel-shaped vent that is 200 m deep.  Debris-avalanche deposits from the collapse of the SE flank of Ubinas about 3700 years ago extend 10 km from the volcano.  Widespread plinian pumice-fall deposits from Ubinas include one of Holocene age about 1000 years ago.  Holocene lava flows are visible on the volcano's flanks, but historical activity, documented since the 16th century, has consisted of intermittent minor-to-moderate explosive eruptions.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1504-02=&amp;volpage=photos&amp;photo=047092">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1504-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igp.gob.pe/">Instituto Geofisico del Per</a></td></tr></table>	(-16.355,-70.903000000000006)
1098	Huaynaputina	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Huaynaputina</b></font><br /><font size="5"><b>Per</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/068068.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Maar<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 4850 m<br /><b>Latitude:</b> 16.608&deg;S<br /><b>Longitude:</b> 70.85&deg;W</td></tr><tr><td colspan="2"><p align="justify">Huaynaputina (whose name means &quot;new volcano&quot;) is a relatively inconspicuous volcano that was the source of the largest historical eruption of South America in 1600 AD.  The volcano has no prominent topographic expression and lies within a 2.5-km-wide depression formed by edifice collapse and further excavated by glaciers within an older edifice of Tertiary-to-Pleistocene age.  Three overlapping ash cones with craters up to 100 m deep were constructed during the 1600 AD eruption on the floor of the ancestral crater, whose outer flanks are heavily mantled by ash deposits from the 1600 eruption.  This powerful fissure-fed eruption may have produced nearly 30 cu km of dacitic tephra, including pyroclastic flows and surges that traveled 13 km to the east and SE.  Lahars reached the Pacific Ocean, 120 km away.  The eruption caused substantial damage to the major cities of Arequipa and Moquengua, and regional economies took 150 years to fully recover.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1504-03=&amp;volpage=photos&amp;photo=068068">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1504-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igp.gob.pe/">Instituto Geofisico del Per</a></td></tr></table>	(-16.608000000000001,-70.849999999999994)
1099	Ticsani	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ticsani</b></font><br /><font size="5"><b>Per</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/114099.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 5408 m<br /><b>Latitude:</b> 16.755&deg;S<br /><b>Longitude:</b> 70.595&deg;W</td></tr><tr><td colspan="2"><p align="justify">Ticsani is a 5408-m-high dacitic lava dome complex in the Ichuna district across the Ro Tambo about 30 km SE of Huaynaputina volcano.  Volcn Ticsani resembles Huaynaputina in its dacitic composition and explosive eruptive style.  Both volcanoes lie about 50 km behind the main volcanic front of the Peruvian Andes.  A fresh-looking lava field lies at the NW base of the youthful-looking, unglaciated volcano.  A major debris avalanche produced by collapse of the volcano partially filled the Ro Tambor to the south.  Emplacement of three lava domes since the end of the Pleistocene was accompanied by explosive eruptions.  No historical eruptions are known from Ticsani, but fumarolic activity continues, and pumice from the crater containing the youngest lava dome overlies tephra from the 1600 AD Huaynaputina eruption.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1504-031&amp;volpage=photos&amp;photo=114099">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1504-031">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igp.gob.pe/">Instituto Geofisico del Per</a></td></tr></table>	(-16.754999999999999,-70.594999999999999)
1100	Tutupaca	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tutupaca</b></font><br /><font size="5"><b>Per</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/114098.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 5815 m<br /><b>Latitude:</b> 17.025&deg;S<br /><b>Longitude:</b> 70.358&deg;W</td></tr><tr><td colspan="2"><p align="justify">Tutupaca consists of two dissected volcanic edifices, of which the southern appears more youthful.  Collapse of the northern edifice produced a debris avalanche that traveled 7 km to the north.  Postglacial lava flows are present, the largest of which originated from the saddle between the two edifices.  Solfataric activity at Tutupaca was noted in the Catalog of Active Volcanoes of the World.  Based on morphological evidence, de Silva and Francis (1990) suggested that reported historical eruptions of this volcano in the 18th and 19th centuries (listed in the Catalog of Active Volcanoes of the World) more likely originated from the more youthful-looking Yucamane volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1504-04=&amp;volpage=photos&amp;photo=114098">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1504-04=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igp.gob.pe/">Instituto Geofisico del Per</a></td></tr></table>	(-17.024999999999999,-70.358000000000004)
1101	Yucamane	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Yucamane</b></font><br /><font size="5"><b>Per</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/114096.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 5550 m<br /><b>Latitude:</b> 17.18&deg;S<br /><b>Longitude:</b> 70.20&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn Yucamane lies at the south end of a group of three volcanoes; both it and Cerro Caliente to the north display evidence of postglacial lava flows, which overlie thick moraines.  The andesitic Yucamane volcano has a youthful, well-preserved summit crater.  Late-Pleistocene and Holocene eruptions have produced airfall deposits, pyroclastic flows and surges, and block-and-ash flows produced by growth and collapse of lava domes.  The most recent plinian eruption took place from Yucamane about 3300 radiocarbon years ago.  A single historical eruption of uncertain character was reported in 1787 (Volcanological Society of Japan, 1971).  Historical eruptions attributed to the more dissected Tutupaca volcano during the 18th-20th centuries (Catalog of Active Volcanoes of the World), were considered by de Silva and Francis (1990) to have more likely originated from Yucamane volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1504-05-&amp;volpage=photos&amp;photo=114096">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1504-05-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igp.gob.pe/">Instituto Geofisico del Per</a></td></tr></table>	(-17.18,-70.200000000000003)
1102	Nevados Casiri	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Nevados Casiri</b></font><br /><font size="5"><b>Per</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/114097.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 5650 m<br /><b>Latitude:</b> 17.47&deg;S<br /><b>Longitude:</b> 69.813&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Nevados Casiri complex, the southernmost Holocene volcano in Per, lies near the Chilean border, about 25 km north of Tacora volcano.  Nevados Casiri consists of four volcanic edifices, with the youngest cone on the SE side.  This compound  trachytic and trachyandesitic volcano reaches an elevation of 5650 m and is also known as Paugarani.  Two fresh Holocene lava flows are located south of the youngest cone, which has a well-defined summit crater.  An older lava dome is located to the west.  Two sulfur mines have been opened on the NW and SE flanks.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1504-06-&amp;volpage=photos&amp;photo=114097">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1504-06-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.igp.gob.pe/">Instituto Geofisico del Per</a></td></tr></table>	(-17.469999999999999,-69.813000000000002)
1103	Tacora	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tacora</b></font><br /><font size="5"><b>Northern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/112001.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Twin volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 5980 m<br /><b>Latitude:</b> 17.72&deg;S<br /><b>Longitude:</b> 69.77&deg;W</td></tr><tr><td colspan="2"><p align="justify">Tacora, the northernmost volcano of Chile, is a twin volcano with Chupiquia to the north and lies near the Peruvian border.  The volcano overlies a flat-lying platform of ignimbrites at about 4200 m elevation forming the Arica Altiplano.  The roughly conical volcano is covered by glaciers down to about 5500 m elevation, and an explosion crater lies on the NW side 300 m below the summit.  Solfataric and fumarolic activity has been reported on the east side of the andesitic volcano (Catalog of Active Volcanoes of the World), but Moreno (1985 pers. comm.) indicated there may not have been Holocene eruptions.  Young lava flows on south flank appear to overlie glacial valleys (de Silva 2007, pers. comm.).  Hantke (1939b) cited a report of eruptions in 1930 and 1937 that are not listed in other sources.  Numerous sulfur mines occupy the saddle between Tacora and Chupiquia, and hot springs are located on the eastern side of Tacora.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-01=&amp;volpage=photos&amp;photo=112001">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-01=">Smithsonian Volcano Information</a></td></tr></table>	(-17.719999999999999,-69.769999999999996)
1104	Taapaca	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Taapaca</b></font><br /><font size="5"><b>Northern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/112025.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 5860 m<br /><b>Latitude:</b> 18.10&deg;S<br /><b>Longitude:</b> 69.50&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Taapaca volcanic complex, lying west of the main Andean chain, rises NE of the small town of Putre in northern Chile.  The elongated volcanic massif, known locally as Nevados de Putre, consists of an initial andesitic stratovolcano and a long-term dacitic lava-dome complex.  Taapaca overlies Pleistocene ignimbrite deposits and trends roughly E-W, with activity in general migrating to the SW during four principal periods of activity dating back at least 1.5 million years.  At least three major edifice collapse events have produced debris-avalanche deposits, the youngest of which underlies Putre, the principal settlement of the northern Chilean Altiplano.  Recent geological studies have shown that explosive activity at Taapaca with dome growth and associated block-and-ash flows and lahars has continued into the late Holocene.  The youngest volcanic stage beginning about 9000 years ago produced the 5860-m-high summit lava dome of the Putre Unit at the eastern and southern ends of the complex.  The latest documented activity produced an ash layer dated at about 2000 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-011&amp;volpage=photos&amp;photo=112025">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-011">Smithsonian Volcano Information</a></td></tr></table>	(-18.100000000000001,-69.5)
1105	Parinacota	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Parinacota</b></font><br /><font size="5"><b>Northern Chile-Bolivia border</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/112028.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 6348 m<br /><b>Latitude:</b> 18.17&deg;S<br /><b>Longitude:</b> 69.15&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn Parinacota is the southernmost and youngest of a pair of volcanoes forming the Nevados de Payachata volcanic group along the Chile-Bolivia border.  The symmetrical, 6348-m-high Parinacota volcano forms a twin volcano with the dominantly Pleistocene, 6222-m-high Pomerape volcano, which towers above a low saddle to the NE.  Collapse of Parinacota about 8000 years ago produced a 6 cu km debris avalanche that traveled 22 km to the west and blocked drainages, forming Lake Chungar.  Holocene eruptive activity has subsequently reconstructed the Parinacota stratovolcano, which contains a pristine, 300-m-wide summit crater and youthful lava flows on the western flanks.  Although no historical eruptions are known from Parinacota, Helium surface-exposure dates have been obtained for eruptions during the past two thousand years both from the main cone and the Ajata group of satellite cones and lava flows on the south and SW flanks.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-012&amp;volpage=photos&amp;photo=112028">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-012">Smithsonian Volcano Information</a></td></tr></table>	(-18.170000000000002,-69.150000000000006)
1106	Guallatiri	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Guallatiri</b></font><br /><font size="5"><b>Northern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/112029.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 6071 m<br /><b>Latitude:</b> 18.42&deg;S<br /><b>Longitude:</b> 69.092&deg;W</td></tr><tr><td colspan="2"><p align="justify">One of northern Chile's most active volcanoes, Volcn Guallatiri is a symmetrical ice-clad stratovolcano at the SW end of the Nevados de Quimsachata volcano group.  The 6071-m-high Guallatiri lies just west of the border with Bolivia and is capped by a central dacitic dome or lava complex, with the active vent situated at its southern side.  Thick lava flows are prominent on the lower northern and western flanks of the andesitic-to-rhyolitic volcano.  Minor explosive eruptions have been reported from Guallatiri since the beginning of the 19th century.  Intense fumarolic activity with &quot;jet-like&quot; noises continues, and numerous solfataras extend more than 300 m down the west flank.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-02=&amp;volpage=photos&amp;photo=112029">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-02=">Smithsonian Volcano Information</a></td></tr></table>	(-18.420000000000002,-69.091999999999999)
1107	Tambo Quemado	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tambo Quemado</b></font><br /><font size="5"><b>Bolivia</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic shield<br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 4215 m<br /><b>Latitude:</b> 18.62&deg;S<br /><b>Longitude:</b> 68.75&deg;W</td></tr><tr><td colspan="2"><p align="justify">A low pyroclastic shield near the Rio Lauca forms Cerro Volcn Tambo Quemado on the Bolivian Altiplano.  The extremely youthful-looking volcanic complex (also known as Cerro Quemado or Volcn Sacabaya) displays fumarolic activity and is estimated to be of Holocene age.  Tambo Quemado consists of a broad ignimbrite shield  capped by an elongated NNE-SSW-trending vent area about 2 x 3.5 km in diameter formed by three large overlapping craters.  The youngest crater lies at the southern end of the 4215-m-high summit region and contains a blocky lava dome.  Wind has redistributed tephra deposits to the east and south, forming aeolian sand dunes.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-021">Smithsonian Volcano Information</a></td></tr></table>	(-18.620000000000001,-68.75)
1108	Isluga	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Isluga</b></font><br /><font size="5"><b>Northern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/112048.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 5550+ m<br /><b>Latitude:</b> 19.15&deg;S<br /><b>Longitude:</b> 68.83&deg;W</td></tr><tr><td colspan="2"><p align="justify">The broad Isluga volcano lies 7 km west of the Chile/Bolivia border at the west end of a group of volcanoes extending to Tata Sabaya volcano in Bolivia.  The 5550-m-high Isluga stratovolcano contains a well-preserved, 400-m-wide summit crater at the western end of the elongated, snow-covered summit region.  Numerous postglacial lava flows, many showing distinct levees, are most prominent along a broad front on the lower southern flank.  Activity from the summit crater was reported in the 19th and 20th centuries.  A lava flow in 1878 destroyed several towns.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-03=&amp;volpage=photos&amp;photo=112048">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-03=">Smithsonian Volcano Information</a></td></tr></table>	(-19.149999999999999,-68.829999999999998)
1109	Tata Sabaya	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tata Sabaya</b></font><br /><font size="5"><b>Bolivia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111098.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 5430 m<br /><b>Latitude:</b> 19.13&deg;S<br /><b>Longitude:</b> 68.53&deg;W</td></tr><tr><td colspan="2"><p align="justify">The symmetrical Tata Sabaya stratovolcano towers above the northern end of the Salar de Coipasa in the Altiplano of Bolivia.  A pyroclastic shield capped by lava domes was topped by effusive eruptions that formed an unglaciated andesitic stratovolcano.  Collapse of this edifice produced a large late-Pleistocene debris avalanche that swept into the Salar de Coipasa and covered an area of more than 300 sq km south of the volcano, traveling up to 30 km.  Tufa deposits on avalanche hummocks in the Salar de Coipasa correspond to a ca. 12,000 year old high stand of the lake.  Renewed eruptions during the Holocene constructed lava domes and flows that have restored much of the original edifice, producing the present-day stratovolcano, whose summit is formed by a 5430-m-high lava dome.  Youthful lava flows extend down the NW and western flanks of the volcano, and pyroclastic-flow deposits from partial collapse of the summit dome extend to the lower SW flank.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-032&amp;volpage=photos&amp;photo=111098">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-032">Smithsonian Volcano Information</a></td></tr></table>	(-19.129999999999999,-68.530000000000001)
1110	Laguna Jayu Khota	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Laguna Jayu Khota</b></font><br /><font size="5"><b>Bolivia</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Maars<br />&nbsp;&nbsp;&nbsp; Cinder cone</td><td width="50%" align="left"><b>Summit Elev:</b> 3650? m<br /><b>Latitude:</b> 19.45&deg;S<br /><b>Longitude:</b> 67.42&deg;W</td></tr><tr><td colspan="2"><p align="justify">Two small youthful-looking maars are located in the Central Altiplano of Bolivia, north of Salar de Uyuni and east of Salar de Coipasa.  Laguna Jayu Khota, initially considered to be a meteorite impact crater, was formed by basaltic-trachyandesite explosive volcanism.  Nekhe Khota maar lies to the SW of Jayu Khota; both were considered by de Silva and Francis (1991) to be of probable Holocene age.  Phreatomagmatic eruptions produced basaltic-trachyandesite pyroclastic deposits containing granitic xenoliths.  The maars lie along a transverse lineament;  the alkali basaltic cone of Chiar Kkollu is located nearby where this lineament intersects the regional trend.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-035">Smithsonian Volcano Information</a></td></tr></table>	(-19.449999999999999,-67.420000000000002)
1111	Irruputuncu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Irruputuncu</b></font><br /><font size="5"><b>Northern Chile-Bolivia border</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/109077.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 5163 m<br /><b>Latitude:</b> 20.73&deg;S<br /><b>Longitude:</b> 68.55&deg;W</td></tr><tr><td colspan="2"><p align="justify">Irruputuncu is a small stratovolcano that straddles the Chile/Bolivia border.  It is the youngest and most southerly of a NE-SW-trending chain of volcanoes.  Irruputuncu was constructed within the collapse scarp of a Holocene debris avalanche whose deposit extends to the SW.   Subsequent eruptions filled much of this scarp and produced thick, viscous lava flows down the western flank.  The summit complex contains two craters, the southernmost of which is fumarolically active.  The first unambiguous historical eruption from Irruputuncu took place in November 1995, when phreatic explosions produced dark ash clouds.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-04=&amp;volpage=photos&amp;photo=109077">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-04=">Smithsonian Volcano Information</a></td></tr></table>	(-20.73,-68.549999999999997)
1112	Olca-Paruma	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Olca-Paruma</b></font><br /><font size="5"><b>Northern Chile-Bolivia border</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/109079.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes</td><td width="50%" align="left"><b>Summit Elev:</b> 5407 m<br /><b>Latitude:</b> 20.93&deg;S<br /><b>Longitude:</b> 68.48&deg;W</td></tr><tr><td colspan="2"><p align="justify">A 15-km-long E-W ridge forming the border between Chile and Bolivia is comprised of several stratovolcanoes with Holocene lava flows.  Andesitic-dacitic lava flows extend as far as 5 km north from the active crater of Volcn Olca and to the north and west from vents farther to the west.  Olca is flanked on the west by Cerro Michincha and on the east by Volcn Paruma, which is immediately west of the higher pre-Holocene Cerro Paruma volcano.  Volcn Paruma has been the source of conspicuous fresh lava flows, one of which extends 7 km to the SE.  Volcn Paruma has displayed persistent fumarolic activity in recent years.  The only known historical activity from the Olca-Paruma complex was a flank eruption of unspecified character between 1865 and 1867.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-05=&amp;volpage=photos&amp;photo=109079">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-05=">Smithsonian Volcano Information</a></td></tr></table>	(-20.93,-68.480000000000004)
1113	San Pedro	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>San Pedro</b></font><br /><font size="5"><b>Northern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/068079.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> 6145 m<br /><b>Latitude:</b> 21.88&deg;S<br /><b>Longitude:</b> 68.40&deg;W</td></tr><tr><td colspan="2"><p align="justify">The composite volcano of San Pedro in the arid Atacama desert of northern Chile is one of the world's highest historically active volcanoes.  The 6145-m-high basaltic andesite-to-dacitic San Pedro is located to the west of its older twin volcano, 6092-m-high San Pablo.  The youngest cone of San Pedro was constructed within a large horseshoe-shaped escarpment left by the collapse of an older edifice, which produced a large debris avalanche to the west, perhaps accompanied by a major pumice eruption.  Thick dacitic lava flows with steep-sided fronts mantle the upper portion of the younger cone.  The youthful-looking La Porua scoria cone on the western flank produced an 8-km-long lava flow, but Worner et al. (2000) obtained a surprisingly old Helium surface-exposure age of 103,000 years from a juvenile block of the lava flow.  Reports of variable reliability mention historical eruptions of San Pedro in the 19th and 20th centuries.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-07=&amp;volpage=photos&amp;photo=068079">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-07=">Smithsonian Volcano Information</a></td></tr></table>	(-21.879999999999999,-68.400000000000006)
1114	Putana	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Putana</b></font><br /><font size="5"><b>Northern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117055.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 5890 m<br /><b>Latitude:</b> 22.55&deg;S<br /><b>Longitude:</b> 67.85&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn Putana, also known as Jorgencal or Machuca, is part of a large, roughly N-S-trending volcanic complex that covers an area of 600 sq km.  Vigorous fumarolic activity is visible at the 5890-m-high summit of Putana volcano from long distances.  The main edifice, which formed primarily by lava effusion, consists of accumulated postglacial dacitic lava domes and flows mantling an older pre-Holocene volcano.  The youngest basaltic andesite lava flows are viscous and rarely extend more than 3 km.  A major eruption of unspecified character was reported in the early 19th century (Rudolph, 1955; Guest 1981, pers. comm.), although Gonzlez-Ferrn (1995) indicated that no historical eruptions had occurred.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-09=&amp;volpage=photos&amp;photo=117055">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-09=">Smithsonian Volcano Information</a></td></tr></table>	(-22.550000000000001,-67.849999999999994)
1115	Sairecabur	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sairecabur</b></font><br /><font size="5"><b>Northern Chile-Bolivia border</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111097.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 5971 m<br /><b>Latitude:</b> 22.72&deg;S<br /><b>Longitude:</b> 67.892&deg;W</td></tr><tr><td colspan="2"><p align="justify">This chain of andesitic-dacitic volcanoes along the Chile-Bolivia border contains at least 10 postglacial centers and stretches from Escalante volcano on the north to Sairecbur volcano on the south.  Nomenclature reflecting local usage results in conflicting names applied to these features on Chilean and Bolivian topographic maps.  The highest peak, Sairecbur, is located on the northern margin of a 4.5-km-wide caldera.  Postglacial activity began south of the summit, but most recently produced a pristine lava flow to the NW.  An active sulfur mine is located north of the volcano.  Escalante, slightly older than Sairecbur, has a crater lake at its summit and youthful lava flows on its flanks, and other eruptive centers have also produced Holocene lava flows.  Curinquinca volcano of Pleistocene-Holocene age lies at the NE end of the complex and Cerro Colorado volcano at the NW end.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-091&amp;volpage=photos&amp;photo=111097">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-091">Smithsonian Volcano Information</a></td></tr></table>	(-22.719999999999999,-67.891999999999996)
1116	Licancabur	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Licancabur</b></font><br /><font size="5"><b>Northern Chile-Bolivia border</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/068085.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 5916 m<br /><b>Latitude:</b> 22.83&deg;S<br /><b>Longitude:</b> 67.88&deg;W</td></tr><tr><td colspan="2"><p align="justify">The symmetrical Licancabur stratovolcano was constructed primarily during the Holocene and contains one of the world's highest lakes in its 400-m-wide summit crater.  The Pleistocene Juriques volcano is located immediately to the SE and is capped by a 1.5-km-wide summit crater.  Archaeological ruins were found on the 5916-m-high crater rim of the steep-sided Volcn Licancabur, which maintains constant 30 degree slopes.  The shallow freshwater summit lake is 90 m by 70 m wide and has a measured temperature of 6 degrees C, supporting growth of planktonic fauna at nearly 6000 m altitude.  Young blocky andesitic lava flows with prominent levees extend up to 6 km down the NW-to-SW flanks; older flows reach up to 15 km from the summit crater and are covered by pyroclastic-flow deposits that extend 12 km.  The most recent activity from Licancabur produced flank lava flows.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-092&amp;volpage=photos&amp;photo=068085">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-092">Smithsonian Volcano Information</a></td></tr></table>	(-22.829999999999998,-67.879999999999995)
1117	Guayaques	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Guayaques</b></font><br /><font size="5"><b>Northern Chile-Bolivia border</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111024.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 5598 m<br /><b>Latitude:</b> 22.895&deg;S<br /><b>Longitude:</b> 67.566&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Cerros de Guayaques group of N-S-trending rhyodacitic lava domes straddles the Chile-Bolivia border.  The 10-km-long chain is located immediately east of the Purico pyroclastic shield.  There is some evidence for Holocene activity, and the youngest domes appear to be north of the summit crater of the dome complex (de Silva and Francis, 1991).  A well-defined summit crater was the source of  the largest lava flows, which traveled 3 km to the SW.  There are no records of historical activity from Guayaques volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-093&amp;volpage=photos&amp;photo=111024">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-093">Smithsonian Volcano Information</a></td></tr></table>	(-22.895,-67.566000000000003)
1118	Purico Complex	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Purico Complex</b></font><br /><font size="5"><b>Northern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111025.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic shield<br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 5703 m<br /><b>Latitude:</b> 23.00&deg;S<br /><b>Longitude:</b> 67.75&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Purico volcanic complex consists of two ignimbrite sheets, separated by a short erosional interval, that were erupted about 1.3 million years ago, along with several stratovolcanoes and lava domes that define a postulated 10 x 20 km ring fracture.  Cerro Toco volcano overlies the vent area of the Cajn Ignimbrite and a sulfur mine on its SE flank was mined until the early 1990s.  The youngest lava domes, Cerro Chascn de Purico and Cerro Aspero are of Holocene age (de Silva and Francis, 1991).   Both domes differ morphologically from many other flat-topped silicic Andean volcanic domes and have 300-400 m high conical profiles.  Cerro Chascn was formed by a series of viscous lava flows, whereas Cerro Aspero appears to be a single Pelean-type dome.  The Chascn de Purico dacitic dome rising 1200 m above the ignimbrite shield has a well-preserved summit crater and lava flows that show no evidence of glacial modification.  The dacitic-to-andesitic Macon stratovolcano of Holocene age lies at the southern end of the complex, and the Alitar maar at the SE end displays constant solfataric activity.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-094&amp;volpage=photos&amp;photo=111025">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-094">Smithsonian Volcano Information</a></td></tr></table>	(-23,-67.75)
1119	Colachi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Colachi</b></font><br /><font size="5"><b>Northern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/068086.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 5631 m<br /><b>Latitude:</b> 23.236&deg;S<br /><b>Longitude:</b> 67.645&deg;W</td></tr><tr><td colspan="2"><p align="justify">Colachi is a 5631-m-high andesitic-dacitic stratovolcano that was constructed on an uplifted block of welded ignimbrites.  The most recent activity produced pristine silicic lava flows of probable Holocene age, the largest of which covers a 7 sq km area on the saddle between Colachi and the neighboring volcano of Acamarachi (de Silva and Francis, 1991).  A smaller flow was erupted on the western flank of Colachi.  The closely spaced Colachi and Acamarachi volcanoes represent different magmatic systems (Gardeweg 1993, pers. comm.).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-095&amp;volpage=photos&amp;photo=068086">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-095">Smithsonian Volcano Information</a></td></tr></table>	(-23.236000000000001,-67.644999999999996)
1120	Acamarachi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Acamarachi</b></font><br /><font size="5"><b>Northern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/068087.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 6046 m<br /><b>Latitude:</b> 23.30&deg;S<br /><b>Longitude:</b> 67.62&deg;W</td></tr><tr><td colspan="2"><p align="justify">Acamarachi, a steep-sided andesitic-dacitic volcano with slopes that reach about 45 degrees, forms the highest peak in this part of the northern Andes.  Acamarachi, also known as Cerro Pili, is at the SSE end of a small volcanic complex that extends from the neighboring volcano Colachi to the NNW.  A large lava dome is located on the north flank of the 6046-m-high volcano.  A poorly preserved summit crater and the absence of youthful flank lava flows suggest that Acamarachi was largely constructed in pre-Holocene times, although the summit lava flows draping the upper cone were considered to be of Holocene age (Gonzlez-Ferrn, 1995).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-096&amp;volpage=photos&amp;photo=068087">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-096">Smithsonian Volcano Information</a></td></tr></table>	(-23.300000000000001,-67.620000000000005)
1121	Lscar	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Lscar</b></font><br /><font size="5"><b>Northern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/048035.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 5592 m<br /><b>Latitude:</b> 23.37&deg;S<br /><b>Longitude:</b> 67.73&deg;W</td></tr><tr><td colspan="2"><p align="justify">Lscar is the most active volcano of the northern Chilean Andes.  The andesitic-to-dacitic stratovolcano contains six overlapping summit craters.  Prominent lava flows descend its NW flanks.  An older, higher stratovolcano 5 km to the east, Volcn Aguas Calientes, displays a well-developed summit crater and a probable Holocene lava flow near its summit (de Silva and Francis, 1991).  Lscar consists of two major edifices; activity began at the eastern volcano and then shifted to the western cone.  The largest eruption of Lascar took place about 26,500 years ago, and following the eruption of the Tumbres scoria flow about 9000 years ago, activity shifted back to the eastern edifice, where three overlapping craters were formed.  Frequent small-to-moderate explosive eruptions have been recorded from Lscar in historical time since the mid-19th century, along with periodic larger eruptions that produced ashfall hundreds of kilometers away from the volcano.  The largest historical eruption of Lscar took place in 1993, producing pyroclastic flows to 8.5 km NW of the summit and ashfall in Buenos Aires.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-10=&amp;volpage=photos&amp;photo=048035">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-10=">Smithsonian Volcano Information</a></td></tr></table>	(-23.370000000000001,-67.730000000000004)
1122	Cordn de Puntas Negras	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cordn de Puntas Negras</b></font><br /><font size="5"><b>Northern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/068090.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 5852 m<br /><b>Latitude:</b> 23.743&deg;S<br /><b>Longitude:</b> 67.534&deg;W</td></tr><tr><td colspan="2"><p align="justify">Two intersecting volcanic chains, the Cordn de Puntas Negras and Cordn Chalviri, trend roughly SE from Chiliques volcano to Volcn Puntas Negras stratovolcano and SW from there to Cerro Tuyajto, respectively.  The chain of small cones, lava domes, lava flows, and maars covers an area of about 500 sq km and contains at least 25 different vents.  The Cordn de Puntas Negras is situated along the southern margin of the 35 x 70 km Pliocene La Pacana caldera.  The pristine morphology of many of the volcanic features indicates a Holocene (de Silva and Francis, 1991) or historical (Gonzlez-Ferrn, 1995) age.  Small cones such as Cerros Cenizas, Aguas Calientes, Laguna Escondida, and Chinchilla have well-preserved summit craters and produced short lava flows.  A distinct maar-type vent is present, as well as a 13 sq km silicic lava flow and dome complex.  A volcanic center immediately SE of Cerro Laguna Escondida appears to be the youngest vent of the complex.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-101&amp;volpage=photos&amp;photo=068090">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-101">Smithsonian Volcano Information</a></td></tr></table>	(-23.742999999999999,-67.534000000000006)
1123	Cerro Tujle	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cerro Tujle</b></font><br /><font size="5"><b>Northern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111028.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Maar</td><td width="50%" align="left"><b>Summit Elev:</b> 3550+ m<br /><b>Latitude:</b> 23.83&deg;S<br /><b>Longitude:</b> 67.95&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Holocene Cerro Tujle maar (also known as Cerro Tucle or Cerro Tugle) in the Cordn de Tujle has a 60-m-deep crater (de Silva and Francis, 1991).  The maar is located SE of the Salar de Atacama, north of Cerro Toloncha.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-103&amp;volpage=photos&amp;photo=111028">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-103">Smithsonian Volcano Information</a></td></tr></table>	(-23.829999999999998,-67.950000000000003)
1124	El Negrillar	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>El Negrillar</b></font><br /><font size="5"><b>Northern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/115037.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3500 m<br /><b>Latitude:</b> 24.18&deg;S<br /><b>Longitude:</b> 68.25&deg;W</td></tr><tr><td colspan="2"><p align="justify">El Negrillar is a group of cinder cones and compound andesitic lava flows in what was interpreted to be a Holocene volcanic field west of the Cordn de Plar (Moreno 1985, pers. comm.; de Silva and Francis, 1991).  Gardeweg (1993, pers. comm.), however, did not consider El Negrillar to be of Holocene age.  This volcanic field, also known as Negros de Aras, lies about 20 km north of Socompa volcano.  The major Holocene debris avalanche from Socompa overlies some youthful-looking lava flows at the western margin of El Negrillar lava-flow complex.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-106&amp;volpage=photos&amp;photo=115037">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-106">Smithsonian Volcano Information</a></td></tr></table>	(-24.18,-68.25)
1125	Socompa	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Socompa</b></font><br /><font size="5"><b>Northern Chile-Argentina border</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/068091.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 6051 m<br /><b>Latitude:</b> 24.40&deg;S<br /><b>Longitude:</b> 68.25&deg;W</td></tr><tr><td colspan="2"><p align="justify">Straddling the Chile-Argentina border, Volcn Socompa is a massive, 6051-m-high dacitic stratovolcano that lies immediately north of the only railway line between the two countries.  Socompa is the youngest and southernmost of a 6000-m-high NE-SW-trending chain of volcanoes including Pular and Pajonales.  In contrast to the latter two volcanoes, no glacial moraines have been observed on the youthful and relatively uneroded Socompa volcano.  Collapse of the NW portion of Socompa volcano about 7200 years ago, during an eruption similar to that at Mount St. Helens in 1980, produced a 600 sq km debris-avalanche deposit that extends about 40 km from the summit and is one of the world's largest and best exposed.  Post-collapse eruptions have constructed dacitic lava domes that have filled much of the head of the collapse scarp.  No historical eruptions are known from Socompa.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-109&amp;volpage=photos&amp;photo=068091">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-109">Smithsonian Volcano Information</a></td></tr></table>	(-24.399999999999999,-68.25)
1126	Llullaillaco	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Llullaillaco</b></font><br /><font size="5"><b>Northern Chile-Argentina border</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/068100.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 6739 m<br /><b>Latitude:</b> 24.72&deg;S<br /><b>Longitude:</b> 68.53&deg;W</td></tr><tr><td colspan="2"><p align="justify">The world's highest historically active volcano, 6739-m-high Llullaillaco, sits astride the Chile-Argentina border.  The summit is formed by a smaller well-preserved cone that was constructed on an older Pleistocene edifice.  A major debris-avalanche deposit produced by collapse of the older volcano about 150,000 years ago extends eastward into Argentina and diverges around the north and south sides of the older Cerro Rosado stratovolcano 17 km east of Llullaillaco.  Construction of several lava domes and flows was associated with growth of the modern cone.  The two most prominent flows contain distinct flow levees and ridges and extend down the northern and southern flanks.  These two extremely youthful-looking dacitic flows were initially considered to be of Holocene age, but more recent Ar/Ar dating indicates that they are of late Pleistocene age (Richards and Villeneuve, 2001).  Two explosive eruptions and another that may have included lava effusion were reported from Llullaillaco in the 19th century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-11=&amp;volpage=photos&amp;photo=068100">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-11=">Smithsonian Volcano Information</a></td></tr></table>	(-24.719999999999999,-68.530000000000001)
1127	Lastarria	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Lastarria</b></font><br /><font size="5"><b>Northern Chile-Argentina border</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/069001.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Compound volcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 5697 m<br /><b>Latitude:</b> 25.17&deg;S<br /><b>Longitude:</b> 68.50&deg;W</td></tr><tr><td colspan="2"><p align="justify">The NNW-trending edifice of 5697-m-high Lastarria volcano along the Chile-Argentina border contains five nested summit craters.  The youngest feature is a lava dome that overlaps the northern crater rim.  The large andesitic-dacitic Negriales lava field on the western flanks was erupted from a single SW-flank vent.  A large debris-avalanche deposit is found on the SE flank.  Recent pyroclastic-flow deposits form an extensive apron below the northern flanks of the volcano.  Although no historical eruptions have been recorded, the youthful morphology of deposits suggest that Lastarria has been active during historical time.  Persistent fumarolic activity occurs at the summit and NW flank, and sulfur flows have been produced by melting of extensive sulfur deposits in the summit region.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-12=&amp;volpage=photos&amp;photo=069001">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-12=">Smithsonian Volcano Information</a></td></tr></table>	(-25.170000000000002,-68.5)
1128	Cordn del Azufre	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cordn del Azufre</b></font><br /><font size="5"><b>Northern Chile-Argentina border</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/115040.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 5463 m<br /><b>Latitude:</b> 25.33&deg;S<br /><b>Longitude:</b> 68.52&deg;W</td></tr><tr><td colspan="2"><p align="justify">Cordn del Azufre is a small volcanic complex straddling the Chile-Argentina border.  The complex consists of a cluster of lava flows from vents on the NE side, wholly within Argentina, and a 5-km-long chain of vents along the border with Chile.  An older andesitic-dacitic edifice with a 1.3-km-wide crater was mostly covered by younger Holocene andesitic lava flows.  The youngest cone, 300-m-high Volcn la Moyra, was the source of fresh-looking blocky andesitic lava flows that descended 6 km into Chile and 3 km into Argentina.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-121&amp;volpage=photos&amp;photo=115040">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-121">Smithsonian Volcano Information</a></td></tr></table>	(-25.329999999999998,-68.519999999999996)
1129	Cerro Bayo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cerro Bayo</b></font><br /><font size="5"><b>Northern Chile-Argentina border</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/115041.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 5401 m<br /><b>Latitude:</b> 25.42&deg;S<br /><b>Longitude:</b> 68.58&deg;W</td></tr><tr><td colspan="2"><p align="justify">Cerro Bayo is a complex volcano of partial Holocene age located along the Chile-Argentina border.  An older center to the south contains a poorly preserved, 800-m-wide crater.  A younger northern center along the national border has a well-preserved 400-m-wide crater and produced lava flows to the north and NE.  The 5401-m-high summit of the Cerro Bayo complex, located west of the border in Chile, is the source of two viscous dacitic lava flows that traveled to the north and represent the most recent activity of the complex.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-122&amp;volpage=photos&amp;photo=115041">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-122">Smithsonian Volcano Information</a></td></tr></table>	(-25.420000000000002,-68.579999999999998)
1130	Sierra Nevada	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sierra Nevada</b></font><br /><font size="5"><b>Northern Chile-Argentina border</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/114048.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 6127 m<br /><b>Latitude:</b> 26.48&deg;S<br /><b>Longitude:</b> 68.58&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Sierra Nevada volcanic complex, located in one of the most inaccessible parts of the Central Andes, covers an area of about 225 sq km astride the Chile-Argentina border.  The complex is of partial Holocene age and includes at least 12 volcanic vents with associated lava flows (de Silva and Francis, 1991).  Craters up to 400-m in diameter and large andesitic lava flows that extend up to 7 km and have well-developed flow ridges are present.  The oldest part of the complex, at its eastern end in Argentina, includes two stratovolcanoes, one with a 1-km-wide summit crater.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-123&amp;volpage=photos&amp;photo=114048">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-123">Smithsonian Volcano Information</a></td></tr></table>	(-26.48,-68.579999999999998)
1131	Nevados Ojos del Salado	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Nevados Ojos del Salado</b></font><br /><font size="5"><b>Northern Chile-Argentina border</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/069007.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 6887 m<br /><b>Latitude:</b> 27.12&deg;S<br /><b>Longitude:</b> 68.55&deg;W</td></tr><tr><td colspan="2"><p align="justify">The world's highest active volcano, Nevados Ojos del Salado, rises to 6887 m along the Chile-Argentina border.  The volcano lies about 20 km south of the road that crosses the international border at Paso de San Francisco.  The summit complex, which is elongated in a NE-SW direction and overlies a largely buried caldera, contains numerous craters, pyroclastic cones and andesitic-to-rhyolitic lava domes and has been the source of Holocene lava flows.  A major rhyodacitic explosive eruption took place about 1000-1500 years ago, producing pumiceous pyroclastic flows.  The most recent eruptive activity of Ojos del Salado appears to have originated along a NNE-trending rift along the summit complex.  It involved formation of a thick, viscous lava flow and at least a dozen small cones, lava domes, and explosion craters.  No confirmed historical eruptions of Ojos del Salado have been recorded, but the volcano has displayed persistent fumarolic activity, and there was an unconfirmed report of minor gas-and-ash emission in 1993.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-13=&amp;volpage=photos&amp;photo=069007">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-13=">Smithsonian Volcano Information</a></td></tr></table>	(-27.120000000000001,-68.549999999999997)
1132	El Solo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>El Solo</b></font><br /><font size="5"><b>Northern Chile-Argentina border</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/069002.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 6190 m<br /><b>Latitude:</b> 27.108&deg;S<br /><b>Longitude:</b> 68.72&deg;W</td></tr><tr><td colspan="2"><p align="justify">El Solo is large stratovolcano composed of nine eruptive centers located west of Nevados del Ojos de Salado and SE of Tres Cruces volcano.  The 6190-m-high volcano was the source of major rhyodacitic pyroclastic-flow deposits erupted during the Holocene that thickly fill adjacent valleys (Gonzlez-Ferrn, 1995).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-131&amp;volpage=photos&amp;photo=069002">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-131">Smithsonian Volcano Information</a></td></tr></table>	(-27.108000000000001,-68.719999999999999)
1133	Antofagasta de la Sierra	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Antofagasta de la Sierra</b></font><br /><font size="5"><b>Argentina</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/096014.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Scoria cones</td><td width="50%" align="left"><b>Summit Elev:</b> 4000? m<br /><b>Latitude:</b> 26.08&deg;S<br /><b>Longitude:</b> 67.50&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Antofagasta de la Sierra volcanic field contains some of the youngest volcanic vents of the Argentinian Puna region.  The volcanic field is located SW of Beltran volcano and between the Salar de Antofalla on the west and the massive Cerro Galn caldera on the east.  The Antofagasta de la Sierra volcanic field contains several very youthful looking basaltic-andesite scoria cones and fresh-looking lava flows, which may only be a few thousand years old (Francis, 1982; de Silva and Francis, 1991).   A concentration of scoria cones and lava flows east of the NE-SW-trending Salar de Antofalla, known as the Salar de Antofalla volcanic field, also have a youthful appearance, although precise ages are not knownf.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-18-&amp;volpage=photos&amp;photo=096014">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-18-">Smithsonian Volcano Information</a></td></tr></table>	(-26.079999999999998,-67.5)
1134	Cerro el Cndor	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cerro el Cndor</b></font><br /><font size="5"><b>Argentina</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/096013.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 6532 m<br /><b>Latitude:</b> 26.62&deg;S<br /><b>Longitude:</b> 68.35&deg;W</td></tr><tr><td colspan="2"><p align="justify">The compound volcano of Cerro el Cndor, one of the few large stratovolcanoes located wholly in Argentina, lies within a 2.5-km-wide caldera.  The complex lies to the north of Falso Azufre volcano, which straddles the Chile/Argentina border.  The summit of Cerro el Cndor contains several ash cones and craters that have been the source of a number of pristine lava flows, one of which traveled 10 km to the west.  Satellitic centers also abound; one on the east flank produced a fresh-looking lava flow that traveled 8 km to the east.  The morphologically youthful lava flows and pristine summit crater imply a Holocene age (de Silva and Francis, 1991).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-19-&amp;volpage=photos&amp;photo=096013">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-19-">Smithsonian Volcano Information</a></td></tr></table>	(-26.620000000000001,-68.349999999999994)
1135	Peinado	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Peinado</b></font><br /><font size="5"><b>Argentina</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/096012.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 5740 m<br /><b>Latitude:</b> 26.62&deg;S<br /><b>Longitude:</b> 68.15&deg;W</td></tr><tr><td colspan="2"><p align="justify">This symmetrical Argentinian stratovolcano is the source of well-preserved lava flows of Holocene age from summit and flank vents (de Silva and Francis, 1991).  Cerro Peinado is one of the youngest volcanoes in the region.  The upper part of the 5740-m-high cone is blanketed by pyroclastic material.  Two possible pyroclastic-flow lobes extend to the NW and north.  Cerro Peinado contains an apron of pristine lava flows extending to 6 km.  These were erupted from the main cone and from vents on the flank, including a prominent ESE-flank vent.  Cerro Peinado is surrounded by small fields of cinder cones, maars, and pristine lava flows, located along N-S-trending faults, which are related to the Salar de Antofalla volcanic field.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-20-&amp;volpage=photos&amp;photo=096012">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-20-">Smithsonian Volcano Information</a></td></tr></table>	(-26.620000000000001,-68.150000000000006)
1136	Robledo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Robledo</b></font><br /><font size="5"><b>Argentina</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/107086.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 4400 m<br /><b>Latitude:</b> 26.77&deg;S<br /><b>Longitude:</b> 67.72&deg;W</td></tr><tr><td colspan="2"><p align="justify">The 6-km-wide Robledo caldera in NW Argentina is located 80 km SW of the much larger and better known Cerro Galn caldera.  The Holocene Cerro Blanco del Robledo lava dome is located on the southern rim of the Robledo caldera (de Silva and Francis, 1991).  Extensive rhyolitic pumice-fall deposits surround the dome.  Well-preserved pyroclastic-flow deposits erupted prior to extrusion of Cerro Blanco are exposed on the floor of the caldera and on its NW flanks.  Satellite geodetic surveys in the central Andes (Pritchard and Simons, 2002) showed subsidence of Robledo caldera in the 1990s.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-21-&amp;volpage=photos&amp;photo=107086">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-21-">Smithsonian Volcano Information</a></td></tr></table>	(-26.77,-67.719999999999999)
1137	Tipas	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tipas</b></font><br /><font size="5"><b>Argentina</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 6660 m<br /><b>Latitude:</b> 27.20&deg;S<br /><b>Longitude:</b> 68.55&deg;W</td></tr><tr><td colspan="2"><p align="justify">This massive volcanic complex is the world's third highest active volcano, but remains largely unknown.  Cerro Tipas, also known as Cerro Walter Penk, is located immediately SSW of its better known neighbor, 6887-m-high Nevados Ojos del Salado, Earth's highest volcano.  The 6660-m-high summit of Cerro Tipas lies within Argentina, immediately south of the Chilean border.  The Tipas volcanic complex of craters, cones, lava domes and lava flows covers an area of 25 sq km.  It displays a youthful morphology, and its latest eruptions were considered by de Silva and Francis (1991) to be of Holocene age.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1505-22-">Smithsonian Volcano Information</a></td></tr></table>	(-27.199999999999999,-68.549999999999997)
1138	San Flix	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>San Flix</b></font><br /><font size="5"><b>Chilean Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/085022.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Tuff cones</td><td width="50%" align="left"><b>Summit Elev:</b> 193 m<br /><b>Latitude:</b> 26.28&deg;S<br /><b>Longitude:</b> 80.12&deg;W</td></tr><tr><td colspan="2"><p align="justify">San Flix Island, 800 km west of the Chilean coast, consists largely of a low, cliff-bounded lava platform separating two tuff cones.  The Islota Gonzles cone to the SW is separated from the main island by a shallow submerged platform.  Cerro Amarillo at the western end forms the high point of the island and is the source of fresh-looking hawaiite lava flows that reached the sea and formed the low lava platform at the SW tip of the island.  A ship captain reported a dull red glow at the summit in 1923.  However, Willis and Washington (1924) considered the youthful lava flows to predate discovery of the island in the 16th century, but not be more than a few centuries old.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1506-01=&amp;volpage=photos&amp;photo=085022">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1506-01=">Smithsonian Volcano Information</a></td></tr></table>	(-26.280000000000001,-80.120000000000005)
1139	Easter Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Easter Island</b></font><br /><font size="5"><b>Chilean Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/085024.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 511 m<br /><b>Latitude:</b> 27.15&deg;S<br /><b>Longitude:</b> 109.38&deg;W</td></tr><tr><td colspan="2"><p align="justify">The triangular-shaped Easter Island, renowned for its dramatic megalithic statues of hand-carved basalt, sits atop the Sala y Gomez submarine ridge, which trends eastward from the East Pacific Rise.  Easter Island, also known as Isla de Pascua or Rapa Nui, forms the westernmost territory of Chile.  The island is composed of three principal volcanoes and more than 70 subsidiary vents.  Rano Kau, which contains a flat-bottomed, 1-km-wide crater, and Poike volcano form the SW and east tips of the island, respectively, and are of Pleistocene age.  The youngest and largest volcano, Terevaka, is a broad shield volcano of Pliocene-to-Pleistocene age at the northern leg of the triangular island, which is capped by many pyroclastic cones.  The last stage of activity consisted of eruptions from multiple rift zones extending along the axes of the island and radially from them.  The latest lava flows, at Hiva-Hiva near the west-central coast, are thought to be less than 2000 years old.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1506-011&amp;volpage=photos&amp;photo=085024">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1506-011">Smithsonian Volcano Information</a></td></tr></table>	(-27.149999999999999,-109.38)
1140	Robinson Crusoe	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Robinson Crusoe</b></font><br /><font size="5"><b>Chilean Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/109059.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Calderas</td><td width="50%" align="left"><b>Summit Elev:</b> 922 m<br /><b>Latitude:</b> 33.658&deg;S<br /><b>Longitude:</b> 78.85&deg;W</td></tr><tr><td colspan="2"><p align="justify">The main part of Robinson Crusoe (Mas a Tierra) Island, in the central part of the Juan Fernandez Island group, is composed of four overlapping shield volcanoes with calderas breached to the NE.  The SW part of the basaltic island consists of smaller altered cones.  Potassium-Argon dates for the island range from 5.8 to 3.8 million years ago (Steussy et al., 1984) and the island is more dissected than Alexander Selkirk (Mas a Fuera) Island to the west.  An eruption at El Yunque was reported in 1743, but is considered uncertain (Catalog of Active Volcanoes of the World).  Several reports exist of a submarine eruption about 1.5 km north of the island in 1835 that produced an explosion and flames that lit up the island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1506-02=&amp;volpage=photos&amp;photo=109059">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1506-02=">Smithsonian Volcano Information</a></td></tr></table>	(-33.658000000000001,-78.849999999999994)
1141	Tupungatito	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tupungatito</b></font><br /><font size="5"><b>Central Chile-Argentina border</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/069018.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> 6000 m<br /><b>Latitude:</b> 33.40&deg;S<br /><b>Longitude:</b> 69.80&deg;W</td></tr><tr><td colspan="2"><p align="justify">Tupungatito volcano, the northernmost historically active volcano of the central Chilean Andes, is located along the Chile-Argentina border about 90 km east of Santiago and immediately SW of the Pleistocene Tupungato volcano.  Tupungatito consists of a group of 12 Holocene andesitic and basaltic andesite craters and a pyroclastic cone at the NW end of the 4-km-wide, Pleistocene dacitic Nevado Sin Nombre caldera, which is filled by glaciers at its southern end and is breached to the NW.  Lava flows from the northernmost vent have traveled down the NW flank breach.  Tupungatito has produced frequent mild explosive eruptions during the 19th and 20th centuries.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-01=&amp;volpage=photos&amp;photo=069018">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-33.399999999999999,-69.799999999999997)
1142	San Jos	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>San Jos</b></font><br /><font size="5"><b>Central Chile-Argentina border</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/069024.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Twin volcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 5856 m<br /><b>Latitude:</b> 33.782&deg;S<br /><b>Longitude:</b> 69.897&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn San Jos lies along the Chile-Argentina border at the southern end of a volcano group that includes the Pleistocene volcanoes of Marmolejo and Espritu Santo.  The glaciated 6109-m-high Marmolejo stratovolcano is truncated by a 4-km-wide caldera, breached to the NW, that has been the source of a massive debris avalanche.  San Jos is a 5856-m-high stratovolcano of Pleistocene-Holocene age with a broad 2 km x 0.5 km summit region containing overlapping and nested craters, pyroclastic cones, and blocky lava flows.  Volcn la Engorda and Volcn Plantat, located SW of Marmolejo and NW of San Jose, have also been active during the Holocene.  An 8-km-long lava flow traveled to the SW from the 1-km-wide summit crater of Espritu Santo volcano, which overlaps the southern slope of Marmolejo.  Mild phreatomagmatic eruptions were recorded from San Jos in the 19th and 20th centuries.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-02=&amp;volpage=photos&amp;photo=069024">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-33.781999999999996,-69.897000000000006)
1143	Maipo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Maipo</b></font><br /><font size="5"><b>Central Chile-Argentina border</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/069021.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 5264 m<br /><b>Latitude:</b> 34.161&deg;S<br /><b>Longitude:</b> 69.833&deg;W</td></tr><tr><td colspan="2"><p align="justify">Maipo, a conical stratovolcano that straddles the Chile-Argentina border SE of Santiago, partially fills the 16 x 20 km Pleistocene Diamante caldera, which formed about 0.45 million years ago during an eruption that produced an about 350 cu km rhyolitic ignimbrite.  The Pleistocene cones of Volcn Don Casimiro and Cerro Listado were formed on the SW rim and SW flank of the caldera, respectively.  The post-caldera Maipo stratovolcano rises about 1900 m above the caldera floor and was constructed by strombolian-vulcanian explosions.  It has a youthful appearance, and ashfall deposits overlie glacial ice.  Several parasitic cones were constructed on the east flank of Maipo along a series on en chelon NE-trending fractures.  Lava flows from one of these cones blocked drainages in 1826 inside the caldera, forming Lake Diamante on the eastern caldera floor.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-021&amp;volpage=photos&amp;photo=069021">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-021">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-34.161000000000001,-69.832999999999998)
1144	Palomo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Palomo</b></font><br /><font size="5"><b>Central Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/069023.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas</td><td width="50%" align="left"><b>Summit Elev:</b> 4860 m<br /><b>Latitude:</b> 34.608&deg;S<br /><b>Longitude:</b> 70.295&deg;W</td></tr><tr><td colspan="2"><p align="justify">Palomo is a small, 4850-m-high stratovolcano that is somewhat dissected by glaciers.  A NE-flank cone, Andres, is postglacial in age and has produced andesitic lava flows.  Palomo lies west of the massive Caldera del Atuel and was constructed within double calderas 3 and 5 km in diameter.  The largely ice-covered Palomo has erupted basaltic-andesite to dacitic lava flows; a double crater indicates migration of activity to the NE.  The youthful morphology of Palomo suggests a very recent, perhaps prehispanic, age.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-022&amp;volpage=photos&amp;photo=069023">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-022">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-34.607999999999997,-70.295000000000002)
1145	Caldera del Atuel	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Caldera del Atuel</b></font><br /><font size="5"><b>Argentina</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/114050.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 5189 m<br /><b>Latitude:</b> 34.65&deg;S<br /><b>Longitude:</b> 70.05&deg;W</td></tr><tr><td colspan="2"><p align="justify">The 30 x 45 km wide Caldera del Atuel lies just east of the Argentina-Chile border and 18 km SSW of the rim of Diamante caldera.  The western rim of Caldera del Atuel in part follows the international border, and the headwaters of the Ro del Atuel drain to the SE through a wide breach in the caldera rim.  The broad floor of the caldera is dotted with 15 dacitic lava domes and 25 basaltic-andesite to andesitic stratovolcanoes and cinder cones.  A group of cones known as Las Lgrimas overlies the SW rim of the caldera, and Volcn Guanaqueros on the NE flank of the caldera is a group of young basaltic-to-andesitic cinder cones of possible historical age.  The Volcn Overo complex in the NE part of the caldera and the Volcn Sosneado complex in the SE part of the caldera contain numerous very youthful basaltic-to-andesitic pyroclastic cones and lava flows.  The Overo complex contains 20 centers, and lava flows of the Sosneado complex cover an area of 200 sq km.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-023&amp;volpage=photos&amp;photo=114050">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-023">Smithsonian Volcano Information</a></td></tr></table>	(-34.649999999999999,-70.049999999999997)
1146	Tinguiririca	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tinguiririca</b></font><br /><font size="5"><b>Central Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/069026.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 4280 m<br /><b>Latitude:</b> 34.814&deg;S<br /><b>Longitude:</b> 70.352&deg;W</td></tr><tr><td colspan="2"><p align="justify">Tinguiririca is composed of at least seven Holocene scoria cones west of the Chile-Argentina border constructed along a NNE-SSW fissure over an eroded Pleistocene stratovolcano.  The complex was constructed during three eruptive cycles dating back to the middle Pleistocene.  The latest activity produced a series of youthful small stratovolcanoes and craters, of which the youngest appear to be Tinguiririca and Fray Carlos.  Constant fumarolic activity occurs within and on the NW wall of the summit crater of Tinguiririca, and hot springs and fumaroles with sulfur deposits are found on the western flanks of the summit cones.  A single historical eruption from Tinguiririca was recorded in 1917.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-03=&amp;volpage=photos&amp;photo=069026">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-34.814,-70.352000000000004)
1147	Planchn-Peteroa	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Planchn-Peteroa</b></font><br /><font size="5"><b>Central Chile-Argentina border</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/069030.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 4107 m<br /><b>Latitude:</b> 35.240&deg;S<br /><b>Longitude:</b> 70.570&deg;W</td></tr><tr><td colspan="2"><p align="justify">Planchn-Peteroa is an elongated complex volcano along the Chile-Argentina border with several overlapping calderas.  Activity began in the Pleistocene with construction of the basaltic-andesite to dacitic Volcn Azufre, followed by formation of basaltic and basaltic-andesite Volcn Planchn, 6 km to the north.  About 11,500 years ago, much of Azufre and part of Planchn  collapsed, forming the massive Ro Teno debris avalanche, which traveled 95 km to reach Chile's Central Valley.  Subsequently, Volcn Planchn II was formed.  The youngest volcano, andesitic and basaltic-andesite Volcn Peteroa, consists of scattered vents between Azufre and Planchn.  Peteroa has been active into historical time and contains a small steaming crater lake.  Historical eruptions from the Planchn-Peteroa complex have been dominantly explosive, although lava flows were erupted in 1837 and 1937.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-04=&amp;volpage=photos&amp;photo=069030">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-04=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-35.240000000000002,-70.569999999999993)
1148	Infiernillo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Infiernillo</b></font><br /><font size="5"><b>Argentina</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Volcanic field</td><td width="50%" align="left"><b>Latitude:</b> 35.142&deg;S<br /><b>Longitude:</b> 69.83&deg;W</td></tr><tr><td colspan="2"><p align="justify">Infiernillo, a late-Pleistocene to Holocene basaltic-andesite volcanic field along the Ro Salado in Argentina lies about 70 km east of the crest of the Andes and NW of the town of Malarge.  Several vents controlled by extensional tectonics produced lava flows with prominent flow features that reached to the river.  A radiocarbon date of about 8840 yrs Before Present was obtained from Volcn Hoyo Colorado.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-041">Smithsonian Volcano Information</a></td></tr></table>	(-35.142000000000003,-69.829999999999998)
1149	Calabozos	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Calabozos</b></font><br /><font size="5"><b>Central Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/048042.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 3508 m<br /><b>Latitude:</b> 35.558&deg;S<br /><b>Longitude:</b> 70.496&deg;W</td></tr><tr><td colspan="2"><p align="justify">The 26 x 14 km composite late-Pleistocene Calabozos caldera produced major rhyodacitic-to-dacitic ashflow sheets of ~200-500 cu km magma each, collectively referred to as the Loma Seca Tuff, at 0.8, 0.3, and 0.15 million years ago.  Eruptive activity has continued into the Holocene, forming the 20-25 cu km dacitic-to-andesitic Cerro del Medio complex at the southern end of the caldera and the four clustered vents of Descabezado Chico near the western caldera rim.  The late-Holocene 2.5 cu km Escorias dacitic lava flow from Descabezado Chico traveled &gt;30 km to the south.  Several hot-spring clusters are present along the margin of the central resurgent uplift within the caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-042&amp;volpage=photos&amp;photo=048042">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-042">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-35.558,-70.495999999999995)
1150	Descabezado Grande	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Descabezado Grande</b></font><br /><font size="5"><b>Central Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/048044.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Fissure vents<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3953 m<br /><b>Latitude:</b> 35.58&deg;S<br /><b>Longitude:</b> 70.75&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn Descabezado Grande is a late-Pleistocene to Holocene andesitic-to-rhyodacitic stratovolcano with a 1.4-km-wide ice-filled summit crater.  Along with 3788-m-high Cerro Azul, only 7 km to the south, 3953-m-high Descabezado Grande lies at the center of a 20 x 30 km volcanic field.  A lateral crater that formed on the upper NNE flank in 1932, shortly after the end of the major 1932 eruption from nearby Quizapu volcano on the north flank of Cerro Azul, was the site of the only historical eruption of Descabezado Grande.  The Holocene Alto de las Mulas fissure on the lower NW flank of Descabezado Grande produced young rhyodacitic lava flows.  Numerous small late-Pleistocene to Holocene volcanic centers are located north of the volcano.  The northernmost of these, Lengua de Vulcano (or Mondaca) produced a very youthful rhyodacitic lava flow that dammed the Ro Lentu.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-05=&amp;volpage=photos&amp;photo=048044">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-05=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-35.579999999999998,-70.75)
1151	Cerro Azul	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cerro Azul</b></font><br /><font size="5"><b>Central Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/069040.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pumice cones<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 3788 m<br /><b>Latitude:</b> 35.653&deg;S<br /><b>Longitude:</b> 70.761&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Cerro Azul stratovolcano is at the southern end of the Descabezado Grande-Cerro Azul eruptive system.  Steep-sided 3788-m-high Cerro Azul has a 500-m-wide summit crater that is open to the north. The three basaltic-andesite &quot;La Resoloma Craters&quot; scoria vents are located below the west flank and the two &quot;Los Hornitos&quot; scoria cones on the lower SW flank.  Quizapu, a major vent on the northern flank of Cerro Azul, formed in 1846 during the first historical eruption at Cerro Azul, accompanied by the emission of voluminous dacitic lava flows that traveled both east into the Estero Barroso valley and west into the Ro Blanquillo valley.  Quizapu was later the source of one of the world's largest explosive eruptions of the 20th century in 1932, which created a 600-700 m wide, 150-m-deep crater and ejected 9.5 cu km of dacitic tephra.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-06=&amp;volpage=photos&amp;photo=069040">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-06=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-35.652999999999999,-70.760999999999996)
1152	Laguna del Maule	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Laguna del Maule</b></font><br /><font size="5"><b>Central Chile-Argentina border</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/069037.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 3092 m<br /><b>Latitude:</b> 36.02&deg;S<br /><b>Longitude:</b> 70.58&deg;W</td></tr><tr><td colspan="2"><p align="justify">The 15 x 25 km wide Laguna del Maule caldera contains a cluster of small stratovolcanoes, lava domes, and pyroclastic cones of Pleistocene-to-Holocene age.  The caldera lies mostly on the Chilean side of the border, but partially extends into Argentina.  Fourteen Pleistocene basaltic lava flows were erupted down the upper part of the Maule river valley.  A cluster of Pleistocene cinder cones was constructed on the NW side of the Maule lake, which occupies part of the northern portion of the caldera.  The latest activity produced an explosion crater on the east side of the lake and a series of Holocene rhyolitic lava domes and blocky lava flows that surround Laguna del Maule.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-061&amp;volpage=photos&amp;photo=069037">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-061">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-36.020000000000003,-70.579999999999998)
1153	San Pedro-Pellado	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>San Pedro-Pellado</b></font><br /><font size="5"><b>Central Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/068080.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3621 m<br /><b>Latitude:</b> 35.989&deg;S<br /><b>Longitude:</b> 70.849&deg;W</td></tr><tr><td colspan="2"><p align="justify">The San Pedro-Pellado volcanic complex (also known as San Pedro-Tatara) has been active from the Pliocene to the Holocene.  The Tatara-San Pedro edifice overlies the deeply eroded Pellado stratovolcano; both were constructed within the 6 x 12 km Ro Colorado caldera, which formed during an eruption about 0.5 million years ago.  The Tatara basaltic-andesite shield volcano at the western end of the complex contains stacked sequences of up to 100 or more lava flows forming up to 1500 m of relief.  The glacier-filled summit crater of the 3621-m-high dominantly andesitic San Pedro stratovolcano, which overlies the Tatara edifice, contains a young scoria cone that was the site of the most recent eruptions from the volcano.  A  major Holocene east-flank debris avalanche filled the Ro de la Puente valley to the south and was followed by eruptions originating within the avalanche scarp low on the east flank that produced lava flows down the Estero Pellado drainage.  No historical eruptions have been recorded, but fumaroles are found SE of Pellado.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-062&amp;volpage=photos&amp;photo=068080">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-062">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-35.988999999999997,-70.849000000000004)
1154	Nevado de Longav	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Nevado de Longav</b></font><br /><font size="5"><b>Central Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/109078.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 3242 m<br /><b>Latitude:</b> 36.193&deg;S<br /><b>Longitude:</b> 71.161&deg;W</td></tr><tr><td colspan="2"><p align="justify">The conical, glacier-clad Nevado de Longav volcano is a late-Pleistocene to Holocene, dominantly andesitic stratovolcano constructed over a basement of Tertiary volcaniclastic and granitic rocks.  Two edifice-collapse events modified the eastern and SW flank of a pre-Holocene volcano, and Holocene activity has been concentrated at the summit region and on the eastern flanks of the volcano.  Andesitic-to-dacitic lava domes occupy the summit region, and a Holocene dome forms the 3242-m-high summit of Longav.  The last eruptions produced a lava dome in the upper part of the collapse scarp and summit region that partially collapsed to the east, forming block-and-ash flow deposits.  No historical eruptions are known, although fumarolic activity continues.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-063&amp;volpage=photos&amp;photo=109078">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-063">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-36.192999999999998,-71.161000000000001)
1155	Lomas Blancas	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Lomas Blancas</b></font><br /><font size="5"><b>Central Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/114056.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 2268 m<br /><b>Latitude:</b> 36.286&deg;S<br /><b>Longitude:</b> 71.009&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn Lomas Blancas is a small shield-like stratovolcano of late-Pleistocene to Holocene age (Moreno and Naranjo, 1991) located about 15 km SE of Nevado de Longav volcano.  A 2.3-km-wide caldera, possibly formed by edifice collapse, is open to the SE.  Basaltic-andesite aa lava flows extend 7 km from the collapse scarp.  The basaltic central cone rises about 500 m to an elevation of 2268 m.  Much of the volcano is covered by pumice deposits that probably originated from Nevado de Longav.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-064&amp;volpage=photos&amp;photo=114056">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-064">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-36.286000000000001,-71.009)
1156	Resago	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Resago</b></font><br /><font size="5"><b>Central Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/114055.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cone</td><td width="50%" align="left"><b>Summit Elev:</b> 1890 m<br /><b>Latitude:</b> 36.45&deg;S<br /><b>Longitude:</b> 70.92&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn Resago, in Linares province, is a cinder cone with a double crater.  It produced a basaltic-andesite lava flow that traveled about 3 km to the WNW into Laguna Dial.  The youthful cone may have been formed during an undocumented eruption during historical time (Gonzlez-Ferrn, 1995).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-065&amp;volpage=photos&amp;photo=114055">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-065">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-36.450000000000003,-70.920000000000002)
1157	Payn Matru	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Payn Matru</b></font><br /><font size="5"><b>Argentina</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110052.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 3680 m<br /><b>Latitude:</b> 36.42&deg;S<br /><b>Longitude:</b> 69.20&deg;W</td></tr><tr><td colspan="2"><p align="justify">Cerro Payn Matru is a massive hawaiian-style shield volcano in Argentina that lies 530 km from the oceanic trench.  The 8 x 10 km alkaline caldera of Cerro Payn Matru was formed after about 168,000 years ago.  The high point of the massif is 3680-m-high Cerro Payn stratovolcano, constructed over the SW flank of the shield.  The Pleistocene Pampas Onduladas pahoehoe lava flow traveled 181 km, Earth's longest known Quaternary lava flow.  Post-caldera basaltic eruptions produced more than 300 eruptive centers, mostly along E-W-trending fissures that extend across the entire shield volcano.  Fluid aa lava flows from a youthful concentration of vents on the west flank known as Los Volcanes traveled more than 10 km.  Other vent clusters of the 5200 sq km Payn Matru volcanic field are found on the lower NE and southern flanks, and a lava flow from Volcn Santa Mara on the NW flank traveled 15 km to the NE.  At least 30 trachyandesitic lava domes and basaltic lava flows were erupted contemporaneously with the basaltic fissure eruptions.  Oral traditions note that native tribes were present at the time of the latest eruption.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-066&amp;volpage=photos&amp;photo=110052">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-066">Smithsonian Volcano Information</a></td></tr></table>	(-36.420000000000002,-69.200000000000003)
1158	Nevados de Chilln	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Nevados de Chilln</b></font><br /><font size="5"><b>Central Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/048047.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Compound volcano<br />&nbsp;&nbsp;&nbsp; Calderas</td><td width="50%" align="left"><b>Summit Elev:</b> 3212 m<br /><b>Latitude:</b> 36.863&deg;S<br /><b>Longitude:</b> 71.377&deg;W</td></tr><tr><td colspan="2"><p align="justify">The compound volcano of Nevados de Chilln is one of the most active of the Central Andes of Chile.  Three late-Pleistocene to Holocene stratovolcanoes were constructed along a NNW-SSE line within three nested Pleistocene calderas, which produced ignimbrite sheets extending more than 100 km into the Central Depression of Chile.  The largest stratovolcano, dominantly andesitic, 3212-m-high Cerro Blanco (Volcn Nevado), is located at the NW end of the group, and 3089-m-high Volcn Viejo (Volcn Chilln), which was the main active vent during the 17th-19th centuries, occupies the SE end.  The new Volcn Nuevo lava-dome complex formed between 1906 and 1945 between the two volcanoes and grew to exceed Volcn Viejo in altitude.  The Volcn Arrau dome complex was constructed SE of Volcn Nuevo between 1973 and 1986, eventually exceeding its height by 20 m.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-07=&amp;volpage=photos&amp;photo=048047">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-07=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-36.863,-71.376999999999995)
1159	Cochiquito Volcanic Group	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cochiquito Volcanic Group</b></font><br /><font size="5"><b>Argentina</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/114067.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1435 m<br /><b>Latitude:</b> 36.77&deg;S<br /><b>Longitude:</b> 69.82&deg;W</td></tr><tr><td colspan="2"><p align="justify">A small group of young Argentinian volcanoes lies north of the town of Buta Ranquil, near where the Ro Grande and Ro Barrancas join to form the Ro Colorado.  Volcn Cochiquito is an alkaline basaltic stratovolcano of estimated Pleistocene-Holocene age north of the junction and has eight satellitic cones.  Volcn Sillanegra (or Malal) is pyroclastic cone complex with two craters and basaltic aa lava flows located east of the Ro Grande.  Its age was estimated to be Holocene (Gonzlez-Ferrn, 1995).  Volcn Ranquil del Sur is a small stratovolcano south of the Ro Barranca with an estimated Pleistocene-Holocene age that contains a 600-m-wide crater and produced andesitic pyroclastic material and lava flows.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-071&amp;volpage=photos&amp;photo=114067">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-071">Smithsonian Volcano Information</a></td></tr></table>	(-36.770000000000003,-69.819999999999993)
1160	Tromen	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tromen</b></font><br /><font size="5"><b>Argentina</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/121002.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3978 m<br /><b>Latitude:</b> 37.142&deg;S<br /><b>Longitude:</b> 70.03&deg;W</td></tr><tr><td colspan="2"><p align="justify">Tromen is a 3978-m-high Argentinian stratovolcano that lies at the northern end of an elongated volcanic massif.  The summit of Tromen is cut by two overlapping 3.5-km-wide calderas.  The Pleistocene Volcn Cerro Negro del Tromen, with a 5-km-wide caldera, lies immediately north of Tromen, and lava flows from Tromen have partially overtopped the northern caldera rim.  At the SSW end of this N-S-trending chain is Cerro Tilhue, of Pleistocene-Holocene age.  Post-caldera vents at Tromen were constructed inside both calderas and on the flanks of the NE-most caldera.  The youngest lava flows at Tromen originated from flank vents and descended the north and NE sides of the andesitic-to-rhyolitic volcanic complex.  Holocene vents are also located in the Cerro Michico area on the lower NE flank.  Historical eruptions of Tromen were reported in the mid-18th century and in 1822.  Von Wolff (1929) attributed purported eruptions of Pomahuida in 1820, 1823, 1827, 1828 as being from Tromen, but these are not confirmed.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-072&amp;volpage=photos&amp;photo=121002">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-072">Smithsonian Volcano Information</a></td></tr></table>	(-37.142000000000003,-70.030000000000001)
1161	Puesto Cortaderas	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Puesto Cortaderas</b></font><br /><font size="5"><b>Argentina</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> 970 m<br /><b>Latitude:</b> 37.57&deg;S<br /><b>Longitude:</b> 69.62&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Puesto Cortaderas formation in Argentina was mapped as an isolated basaltic pyroclastic cone of Holocene age SE of the Sierra Huantraico range, NE of Puesta Cortaderas (Ramos, 1981).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-073">Smithsonian Volcano Information</a></td></tr></table>	(-37.57,-69.620000000000005)
1162	Antuco	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Antuco</b></font><br /><font size="5"><b>Central Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/048053.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Somma volcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> 2979 m<br /><b>Latitude:</b> 37.406&deg;S<br /><b>Longitude:</b> 71.349&deg;W</td></tr><tr><td colspan="2"><p align="justify">Antuco volcano, constructed to the NE of the Pleistocene Sierra Velluda stratovolcano, rises dramatically above the SW shore of Laguna de la Laja.  Antuco has a complicated history beginning with construction of the basaltic-to-andesitic Sierra Veluda and Cerro Condor stratovolcanoes of Pliocene-Pleistocene age.  Construction of the Antuco I volcano was followed by edifice failure at the beginning of the Holocene that produced a large debris avalanche which traveled down the Ro Laja to the west and left a large 5-km-wide horseshoe-shaped caldera breached to the west.  The steep-sided modern basaltic-to-andesitic cone of  has grown 1000 m since then; flank fissures and cones have also been active.  Moderate explosive eruptions were recorded in the 18th and 19th centuries from both summit and flank vents, and historical lava flows have traveled into the Ro Laja drainage.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-08=&amp;volpage=photos&amp;photo=048053">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-08=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-37.405999999999999,-71.349000000000004)
1163	Copahue	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Copahue</b></font><br /><font size="5"><b>Central Chile-Argentina border</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/069052.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas</td><td width="50%" align="left"><b>Summit Elev:</b> 2997 m<br /><b>Latitude:</b> 37.85&deg;S<br /><b>Longitude:</b> 71.17&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn Copahue is an elongated composite cone constructed along the Chile-Argentina border within the 6.5 x 8.5 km wide Trapa-Trapa caldera that formed between 0.6 and 0.4 million years ago near the NW margin of the 20 x 15 km Pliocene Caviahue (Del Agrio) caldera.  The eastern summit crater, part of a 2-km-long, ENE-WSW line of nine craters, contains a briny, acidic 300-m-wide crater lake (also referred to as El Agrio or Del Agrio) and displays intense fumarolic activity.  Acidic hot springs occur below the eastern outlet of the crater lake, contributing to the acidity of the Ro Agrio, and another geothermal zone is located within Caviahue caldera about 7 km NE of the summit.  Infrequent mild-to-moderate explosive eruptions have been recorded at Copahue since the 18th century.  Twentieth-century eruptions from the crater lake have ejected pyroclastic rocks and chilled liquid sulfur fragments.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-09=&amp;volpage=photos&amp;photo=069052">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-09=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-37.850000000000001,-71.170000000000002)
1164	Callaqui	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Callaqui</b></font><br /><font size="5"><b>Central Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/069046.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Scoria cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3164 m<br /><b>Latitude:</b> 37.92&deg;S<br /><b>Longitude:</b> 71.45&deg;W</td></tr><tr><td colspan="2"><p align="justify">The late-Pleistocene to Holocene Callaqui stratovolcano has a profile of an overturned canoe due to its construction along an 11-km-long, SW-NE fissure above a 1.2-0.3 million year old Pleistocene edifice.  The ice-capped, 3164-m-high basaltic-andesite Callaqui volcano contains well-preserved volcanic cones and lava flows, which have traveled up to 14 km.  Small craters 100-500 m in diameter are primarily found along a fissure extending down the SW flank.  Intense solfataric activity occurs at the southern part of the summit; in 1966 and 1978, red glow was observed in fumarolic areas (Moreno 1985, pers. comm.).  Periods of intense fumarolic activity have dominated at Callaqui, and few historical eruptions are known.  An explosive eruption was reported in 1751, there were uncertain accounts of eruptions in 1864 and 1937, and a small phreatic ash emission was noted in 1980.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-091&amp;volpage=photos&amp;photo=069046">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-091">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-37.920000000000002,-71.450000000000003)
1165	Laguna Mariaqui	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Laguna Mariaqui</b></font><br /><font size="5"><b>Central Chile</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2143 m<br /><b>Latitude:</b> 38.27&deg;S<br /><b>Longitude:</b> 71.10&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn Laguna Mariaqui is a minor volcanic center that lies SSE of Copahu volcano and ENE of Tolguaca volcano.  It consists of two craters of Holocene age (Gonzlez-Ferrn, 1995) 2 km apart along a NE-trending fault that produced andesitic pyroclastic material and lava flows with columnar jointing.  Cerro Chapulul is a 2143-m-high Holocene cinder cone in this area of the Malleco province of central Chile (Moreno 1985, pers. comm.).  The cone occupies a plateau ranging from 2000-2300 m in altitude.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-092">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-38.270000000000003,-71.099999999999994)
1166	Tolguaca	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tolguaca</b></font><br /><font size="5"><b>Central Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/048063.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2806 m<br /><b>Latitude:</b> 38.310&deg;S<br /><b>Longitude:</b> 71.645&deg;W</td></tr><tr><td colspan="2"><p align="justify">Tolguaca is a late-Pleistocene to Holocene stratovolcano located immediately NW of Lonquimay volcano.  Only fumarolic activity has occurred from basaltic-andesitic Tolguaca during historical time.  A NW-SE zone of aligned summit craters is youngest to the NW.  Another group of vents cutting the south and east flanks is oriented SW-NE, parallel to the zone of flank vents on nearby Lonquimay volcano, and is of postglacial age (Moreno and Gardeweg 1989).  Reports of eruptions in 1876 and on January 7, 1933, have not been confirmed.  The latter date probably refers to an eruption of Lonquimay or Llaima volcanoes (Petit-Breuilh 1994, pers. comm.).  The glacially eroded surface of Tolguaca contrasts with its neighbor of similar height, Lonquimay, and attests to its older age.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-093&amp;volpage=photos&amp;photo=048063">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-093">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-38.310000000000002,-71.644999999999996)
1167	Lonquimay	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Lonquimay</b></font><br /><font size="5"><b>Central Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/048060.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2865 m<br /><b>Latitude:</b> 38.377&deg;S<br /><b>Longitude:</b> 71.58&deg;W</td></tr><tr><td colspan="2"><p align="justify">Lonquimay is a small, flat-topped, symmetrical stratovolcano of late-Pleistocene to dominantly Holocene age immediately SE of Tolguaca volcano.  A glacier fills its summit crater and spills down the south flank.  The volcano is dominantly andesitic, but basaltic and dacitic rocks are also present.  An E-W-trending fissure is present, but a prominent NE-SW fissure cuts across the entire volcano.  The Cordn Fissural Oriental fissure zone extends 10 km to the NE and has produced a series of NE-flank vents and cinder cones, some of which have been the source of voluminous lava flows in historical time.  Major lava flows erupted during 1887-90 and 1988-90 traveled up to 10 km from their NE-flank vents.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-10=&amp;volpage=photos&amp;photo=048060">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-10=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-38.377000000000002,-71.579999999999998)
1168	Tralihue	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tralihue</b></font><br /><font size="5"><b>Argentina</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Latitude:</b> 38.52&deg;S<br /><b>Longitude:</b> 70.90&deg;W</td></tr><tr><td colspan="2"><p align="justify">The dominantly Pleistocene Tralihue and Pino Solo volcanic complexes lie NW of the Pleistocene Pino Hachado caldera in the Nequn Andes of Argentina, east of the main Andes drainage divide.  Initial trachyandesitic eruptions were followed by the eruption of small lava domes and basaltic pyroclastics along a NW-trending fracture during postglacial time.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-101">Smithsonian Volcano Information</a></td></tr></table>	(-38.520000000000003,-70.900000000000006)
1169	Llaima	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Llaima</b></font><br /><font size="5"><b>Central Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/048085.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3125 m<br /><b>Latitude:</b> 38.692&deg;S<br /><b>Longitude:</b> 71.729&deg;W</td></tr><tr><td colspan="2"><p align="justify">Llaima, one of Chile's largest and most active volcanoes, contains two main historically active craters, one at the summit and the other, Pichillaima, to the SE.  The massive 3125-m-high, dominantly basaltic-to-andesitic stratovolcano has a volume of 400 cu km.  A Holocene edifice built primarily of accumulated lava flows was constructed over an 8-km-wide caldera that formed about 13,200 years ago, following the eruption of the 24 cu km Curacautn Ignimbrite.  More than 40 scoria cones dot the volcano's flanks.  Following the end of an explosive stage about 7200 years ago, construction of the present edifice began, characterized by strombolian, hawaiian, and infrequent subplinian eruptions.  Frequent moderate explosive eruptions with occasional lava flows have been recorded since the 17th century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-11=&amp;volpage=photos&amp;photo=048085">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-11=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-38.692,-71.728999999999999)
1170	Sollipulli	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sollipulli</b></font><br /><font size="5"><b>Central Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/112051.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2282 m<br /><b>Latitude:</b> 38.97&deg;S<br /><b>Longitude:</b> 71.52&deg;W</td></tr><tr><td colspan="2"><p align="justify">The 4-km-wide, glacier-filled Sollipulli caldera lies to the east of the Pleistocene Nevados de Sollipulli complex.  Major silicic pyroclastic rocks associated with caldera formation have not been found, and the caldera may have a non-explosive origin.  Post-caldera eruptions have been focused along the caldera walls and have increased its height.  A series of dacitic lava domes lines the eastern and southern caldera rims.  The 1-km-wide Alpehu crater, which cuts the SW rim, was the source of a large plinian eruption 2900 years before present (BP).  Explosion craters and scoria cones are found on the outer flanks of the caldera.  Two north-flank cones produced lava flows during the latest documented activity about 700 years BP (Naranjo et al., 1993).  This low-profile volcano is less prominent than its neighbors Llaima and Villarrica, but its explosive history makes it a potentially hazardous volcanic center.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-111&amp;volpage=photos&amp;photo=112051">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-111">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-38.969999999999999,-71.519999999999996)
1171	Caburgua-Huelemolle	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Caburgua-Huelemolle</b></font><br /><font size="5"><b>Central Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/112053.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1496 m<br /><b>Latitude:</b> 39.25&deg;S<br /><b>Longitude:</b> 71.70&deg;W</td></tr><tr><td colspan="2"><p align="justify">Four groups of basaltic cinder cones lie east of Lago Villarrica and NE of Villarrica volcano.  The northernmost and southernmost groups, the Volcanes de Caburgua and Volcn Huelemolle, respectively, lie along the major regional Liquine-Ofqui fault zone.  Volcanes de Caburgua lies at the south end of Lago Caburgua and consists of six early Holocene basaltic cinder cones.  Lava flows from these cones contributed to blockage of river drainages that formed the lake.  The southernmost group, Volcn Huelemolle, consists of three early Holocene basaltic cinder cones between the Liucura and Pucn (or Minetu) rivers.  The two other cone groups, Volcn Redondo and Pichares, lie to the east of Caburgua and Huelemolle.  Stratigraphic evidence indicates that these basaltic cone groups were active between about 6000 and 8000 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-112&amp;volpage=photos&amp;photo=112053">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-112">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-39.25,-71.700000000000003)
1172	Villarrica	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Villarrica</b></font><br /><font size="5"><b>Central Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/112003.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2847 m<br /><b>Latitude:</b> 39.42&deg;S<br /><b>Longitude:</b> 71.93&deg;W</td></tr><tr><td colspan="2"><p align="justify">Glacier-clad Villarrica, one of Chile's most active volcanoes, rises above the lake and town of the same name.  It is the westernmost of three large stratovolcanoes that trend perpendicular to the Andean chain.  A 6-km wide caldera formed during the late Pleistocene.  A 2-km-wide caldera that formed about 3500 years ago is located at the base of the presently active, dominantly basaltic to basaltic-andesitic cone at the NW margin of the Pleistocene caldera.  More than 30 scoria cones and fissure vents dot Villarrica's flanks.  Plinian eruptions and pyroclastic flows that have extended up to 20 km from the volcano have been produced during the Holocene.  Lava flows up to 18 km long have issued from summit and flank vents.  Historical eruptions, documented since 1558, have consisted largely of mild-to-moderate explosive activity with occasional lava effusion.  Glaciers cover 40 sq km of the volcano, and lahars have damaged towns on its flanks.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-12=&amp;volpage=photos&amp;photo=112003">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-12=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-39.420000000000002,-71.930000000000007)
1173	Quetrupillan	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Quetrupillan</b></font><br /><font size="5"><b>Central Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111096.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2360 m<br /><b>Latitude:</b> 39.50&deg;S<br /><b>Longitude:</b> 71.70&deg;W</td></tr><tr><td colspan="2"><p align="justify">The late-Pleistocene to Holocene Quetrupillan stratovolcano is at the center of a group of three volcanoes trending transverse to the Andean chain.  Constructed within a large 7 x 10 km wide caldera, 2360-m-high, glacier-covered Quetrupillan contains a 3.5-km-wide caldera and has more silicic lavas than its more prominent neighbors Villarrica and Lann.  The basaltic scoria cone Huililco lies 12 km NE of Quetrupillan, a rhyolitic lava dome lies on the south flank of the caldera, and the Volcanes de Reyehueico produced basaltic-andesite lava flows 15 km south of the summit caldera.  Some of the most recent activity produced the Volcanes de Llancahue pyroclastic cones near the SW margin of the older caldera.  Petit-Breuilh (1994 pers. comm.) reported a single historical eruption from Quetrupillan in 1872.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-121&amp;volpage=photos&amp;photo=111096">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-121">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-39.5,-71.700000000000003)
1174	Lann	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Lann</b></font><br /><font size="5"><b>Central Chile-Argentina border</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/049014.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3747 m<br /><b>Latitude:</b> 39.633&deg;S<br /><b>Longitude:</b> 71.500&deg;W</td></tr><tr><td colspan="2"><p align="justify">Lann is a large conical late-Pleistocene to Holocene stratovolcano along the Chile-Argentina border.  The dominantly effusive basaltic-to-trachydacitic volcano lies at the eastern end of a NW-SE-trending volcanic group beginning with Villarrica that is transverse to the Andean chain.  The beautifully symmetrical, 3737-m-high Lann rises 2500 m above its base; shoulder areas on the upper flanks hint at a buried caldera.  The volcano was formed in four eruptive stages dating back to the early Pleistocene or late Pliocene.  The last two stages occurred during the late-Pleistocene and Holocene.  A small lava dome at the summit fed blocky lava flows to the north about 2200 years ago.  Lann was reported active after an earthquake in 1906, but Sapper (1917) stated that newspaper accounts are strongly disputed, and no historical eruptions are known.  A postglacial tuff ring (Volcn Arenal) is located below the SW flank of Lann in Argentina.  A younger lava flow from Lann covers deposits of Volcn Arenal and extends south into Lago Paimn.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-122&amp;volpage=photos&amp;photo=049014">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-122">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-39.633000000000003,-71.5)
1175	Huanquihue Group	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Huanquihue Group</b></font><br /><font size="5"><b>Argentina</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/118052.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cone<br />&nbsp;&nbsp;&nbsp; Tuff ring</td><td width="50%" align="left"><b>Summit Elev:</b> 2139 m<br /><b>Latitude:</b> 39.88&deg;S<br /><b>Longitude:</b> 71.58&deg;W</td></tr><tr><td colspan="2"><p align="justify">A group of young basaltic volcanoes lies in Argentina near the Chilean border, south of Lann volcano.  The Huanquihu volcano group consists of a NNE-SSW-trending chain of stratovolcanoes of Pleistocene age, some of which lie along the border.  A Holocene compound cinder cone with three nested craters up to 400 m in diameter that occupied a valley NE of Cerro Huanquihu and a tuff cone constructed within glacial Lake Epulafquen lies at the northern end of the chain.  Growth of this Holocene tuff cone, La Angostura (&quot;The Narrowing&quot;), created a peninsula that formed a narrow channel connecting Lake Epulafquen and Lake Huechulafquen.  A very recent lava flow from the base of the Achn-Niellu cinder cone (also known as Cerro Escorial) traveled north into glacial Lago Epulafquen, forming a prominent lava delta.  The Escorial lava flow is an extremely youthful flow that diverted local drainages and formed new  lakes.  A radiocarbon date of about 200 years before present was obtained from this flow, and local residents recount oral histories of the eruption, which was observed by their grandparents.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-123&amp;volpage=photos&amp;photo=118052">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-123">Smithsonian Volcano Information</a></td></tr></table>	(-39.880000000000003,-71.579999999999998)
1176	Mocho-Choshuenco	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mocho-Choshuenco</b></font><br /><font size="5"><b>Central Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/069079.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2422 m<br /><b>Latitude:</b> 39.927&deg;S<br /><b>Longitude:</b> 72.027&deg;W</td></tr><tr><td colspan="2"><p align="justify">The compound Mocho-Choshuenco volcano is composed of twin glacier-covered stratovolcanoes, located east of Lago Rinihu and SE of Lago Panguipulli and post-dating a 4-km-wide basaltic caldera.  The small 2415-m-high Choshuenco stratovolcano, constructed on the NW rim of the caldera, is late-glacial in age.  A major plinian eruption produced the Neltume Pumice about 10,300 years ago.  The larger andesitic-to-dacitic, 2422-m-high  El Mocho volcano, constructed within the caldera, is postglacial and has been historically active.  Parasitic craters and basaltic scoria cones are located on the flanks of Mocho-Choshuenco, primarily on the NE and SW sides.  Two historical eruptions have been reported, one in 1864 and the other in 1937.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-13=&amp;volpage=photos&amp;photo=069079">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-13=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-39.927,-72.027000000000001)
1177	Carrn-Los Venados	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Carrn-Los Venados</b></font><br /><font size="5"><b>Central Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/049016.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Maars<br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1114 m<br /><b>Latitude:</b> 40.35&deg;S<br /><b>Longitude:</b> 72.07&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Carrn-Los Venados volcano group includes a group of about 50 basaltic to basaltic-andesite scoria cones, maars, and a small stratovolcano that are broadly aligned along a 17-km-long ENE-WSW trend ESE of Lago Ranco.  The volcano group occupies a low-lying area north of the more topographically prominent Cordn Caulle-Puyehue volcanic chain, and many of the vents are postglacial in age.  The Mirador scoria cone and two maars, Riinahue and Carrn, were formed during eruptions in the 20th century.  These historical eruptions were concentrated where the regional Liquine-Ofqui fault zone intersects the alignment of volcanic vents.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-14=&amp;volpage=photos&amp;photo=049016">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-14=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-40.350000000000001,-72.069999999999993)
1178	Puyehue-Cordn Caulle	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Puyehue-Cordn Caulle</b></font><br /><font size="5"><b>Central Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/102060.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 2236 m<br /><b>Latitude:</b> 40.590&deg;S<br /><b>Longitude:</b> 72.117&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Puyehue-Cordn Caulle volcanic complex (PCCVC) is a large NW-SE-trending late-Pleistocene to Holocene basaltic-to-rhyolitic transverse volcanic chain SE of Lago Ranco.  The 1799-m-high Pleistocene Cordillera Nevada caldera lies at the NW end, separated from Puyehue stratovolcano at the SE end by the Cordn Caulle fissure complex.  The Pleistocene Mencheca volcano with Holocene flank cones lies NE of Puyehue.  The basaltic-to-rhyolitic Puyehue volcano is the most geochemically diverse of the PCCVC.  The flat-topped, 2236-m-high Puyehue volcano was constructed above a 5-km-wide caldera and is capped by a 2.4-km-wide summit caldera of Holocene age.  Lava flows and domes of mostly rhyolitic composition are found on the eastern flank of Puyehue.  Historical eruptions originally attributed to Puyehue, including major eruptions in 1921-22 and 1960, are now known to be from the Cordn Caulle rift zone.   The Cordn Caulle geothermal area, occupying a 6 x 13 km wide volcano-tectonic depression, is the largest active geothermal area of the southern Andes volcanic zone.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-15=&amp;volpage=photos&amp;photo=102060">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-15=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-40.590000000000003,-72.117000000000004)
1179	Cerro Pantoja	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cerro Pantoja</b></font><br /><font size="5"><b>Central Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/114054.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Cinder cone</td><td width="50%" align="left"><b>Summit Elev:</b> 2024 m<br /><b>Latitude:</b> 40.77&deg;S<br /><b>Longitude:</b> 71.95&deg;W</td></tr><tr><td colspan="2"><p align="justify">Cerro Pantoja is an eroded 2024-m-high dominantly basaltic volcano of Pleistocene age along the Chile-Argentina border with a Holocene cinder cone on the Argentinian side (Moreno 1985, pers. comm).  Cerro Pantoja lies SSW of Lake Constancia, which is located immediately west of the Argentinian border, and has a dramatic steep-sided summit pinnacle.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-152&amp;volpage=photos&amp;photo=114054">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-152">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-40.770000000000003,-71.950000000000003)
1180	Antillanca Group	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Antillanca Group</b></font><br /><font size="5"><b>Central Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/102061.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 1990 m<br /><b>Latitude:</b> 40.771&deg;S<br /><b>Longitude:</b> 72.153&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Antillanca Group is a cluster of late-Pleistocene to Holocene basaltic-to-andesitic scoria cones, maars and small stratovolcanoes covering an area of 380 sq km SE of Lago Puyehue and NE of Lago Rupanco.  The most prominent edifice is the small 1990-m-high Casablanca stratovolcano of Holocene age, which has a truncated conical profile and produced major explosive eruptions about 2910 and 2260 radiocarbon years ago.  Older late-Pleistocene stratovolcanoes, such as Sarnoso on the SW side and Fiuch on the NW side, are extensively dissected by glaciers.  Fissures oriented in four major directions influence the orientation of the cones of the Antillanca complex.  Thermal areas are found in scattered locations on the NW side of the complex.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-153&amp;volpage=photos&amp;photo=102061">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-153">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-40.771000000000001,-72.153000000000006)
1181	Puntiagudo-Cordn Cenizos	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Puntiagudo-Cordn Cenizos</b></font><br /><font size="5"><b>Central Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/085019.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Fissure vents<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2493 m<br /><b>Latitude:</b> 40.969&deg;S<br /><b>Longitude:</b> 72.264&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Puntiagudo-Cordn Cenizos volcanic chain lies between Lago Rupanco and Lago Todos Los Santos in the Chilean lake district.  Volcn Puntiagudo is a late-Pleistocene andesitic stratovolcano with a prominent 2493-m-high sharp-peaked summit that results from glacial dissection.  An 18-km-long fissure system with more than 40 late-Pleistocene to Holocene basaltic scoria cones and small stratovolcanoes extends to the NE.  Lava flows from these centers descend to the NW and SE, in some cases reaching to the shores of the two lakes, forming irregular peninsulas.  The only historical eruption occurred in 1850, when ashfall was reported from the Cordn Cenizos chain.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-16-&amp;volpage=photos&amp;photo=085019">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1507-16-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-40.969000000000001,-72.263999999999996)
1182	Osorno	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Osorno</b></font><br /><font size="5"><b>Southern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/049019.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Scoria cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2652 m<br /><b>Latitude:</b> 41.10&deg;S<br /><b>Longitude:</b> 72.493&deg;W</td></tr><tr><td colspan="2"><p align="justify">The symmetrical, glacier-clad Osorno volcano forms a renowned landmark that towers over Todos los Santos and Llanquihu lakes.  Osorno was constructed over a roughly 250,000-year-old eroded stratovolcano, La Picada, that has a mostly buried 6-km-wide caldera.  La Picada underlies Osorno on the NE and has postglacial maars and scoria cones.  The 2652-m-high dominantly basaltic to basaltic-andesite Osorno is one of the most active volcanoes of the southern Chilean Andes.  The conical volcano contains two small dacitic lava domes on the NW and SSE flanks.  Flank scoria cones and fissure vents, primarily on the west and SW sides, have produced lava flows that reached Lago Llanquihu.  Frequent explosive eruptions including pyroclastic flows and surges have occurred during the past 14,000 years.  Historical eruptions at Osorno have originated from both summit and flank vents and have produced basaltic and andesitic lava flows that have entered both Llanquihu and Todos los Santos lakes.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-01=&amp;volpage=photos&amp;photo=049019">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-41.100000000000001,-72.492999999999995)
1183	Cayutu-La Viguera	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cayutu-La Viguera</b></font><br /><font size="5"><b>Southern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110059.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 506 m<br /><b>Latitude:</b> 41.25&deg;S<br /><b>Longitude:</b> 72.27&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Cayutu-La Viguera volcanic field consists of about 20 basaltic maars and cinder cones of Holocene age on a NNE-SSW alignment.  The volcanic field occupies a low-lying area between the southern end of Ensenada Cayutu, the southern extension of Lake Todos los Santos, and the northern end of the Estuario Reloncav, where the Ro Petrohu, which drains lake Todos los Santos, reaches the sea.  The volcanic field lies along the major regional N-S-trending Liquie-Ofqui fault zone.  La Viguera and Volcn Cayutu are the principal cones.  Formation of La Viguera cone and associated lava flows temporarily dammed the Ro Petrohu about 3000 years ago, forming an ephemeral lake that was filled with deposits from Calbuco and Osorno volcanoes.  Pyroclastic cones and lava flows of Volcn Cayutu filled the Ensenada de Cayutu depression, separating Lake Todos los Santos from Raln Bay.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-012&amp;volpage=photos&amp;photo=110059">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-012">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-41.25,-72.269999999999996)
1184	Calbuco	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Calbuco</b></font><br /><font size="5"><b>Southern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/049023.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2003 m<br /><b>Latitude:</b> 41.326&deg;S<br /><b>Longitude:</b> 72.614&deg;W</td></tr><tr><td colspan="2"><p align="justify">Along with its neighbor Osorno, Calbuco is one of the most active volcanoes of the southern Chilean Andes.  The isolated late-Pleistocene to Holocene andesitic volcano rises to 2003 m south of Lake Llanquihu in the Chilean lake district.  Guanahuca, Guenauca, Huanauca, and Huanaque, all listed as synonyms of Calbuco (Catalog of Active Volcanoes of the World), are actually synonyms of nearby Osorno volcano (Moreno 1985, pers. comm.).  The 2003-m-high Calbuco is elongated in a SW-NE direction and is capped by a 400-500 m wide summit crater.  The complex evolution of Calbuco included edifice collapse of an intermediate edifice during the late Pleistocene that produced a 3 cu km debris avalanche that reached the lake.  One of the largest historical eruptions in southern Chile took place from Calbuco in 1893-1894 and concluded with lava dome emplacement.  Subsequent eruptions have enlarged the lava-dome complex in the summit crater.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-02=&amp;volpage=photos&amp;photo=049023">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-41.326000000000001,-72.614000000000004)
1185	Cuernos del Diablo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cuernos del Diablo</b></font><br /><font size="5"><b>Southern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/115042.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1862 m<br /><b>Latitude:</b> 41.40&deg;S<br /><b>Longitude:</b> 72.00&deg;W</td></tr><tr><td colspan="2"><p align="justify">Cuernos del Diablo is a 1862-m-high partially glacially eroded basaltic stratovolcano.  Numerous satellitic pyroclastic cones and associated basaltic lava flows were formed during the Holocene, principally on the SW flank and from the summit to the NW base of the volcano.  Although no historical eruptions are known from Cuernos del Diablo, some of these cones may have formed during historical time (Gonzlez-Ferrn, 1995).  Fumaroles were observed on a flank cone in 1931.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-021&amp;volpage=photos&amp;photo=115042">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-021">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-41.399999999999999,-72)
1186	Yate	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Yate</b></font><br /><font size="5"><b>Southern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/049026.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2187 m<br /><b>Latitude:</b> 41.755&deg;S<br /><b>Longitude:</b> 72.396&deg;W</td></tr><tr><td colspan="2"><p align="justify">Yate volcano is a late-Pleistocene, glacially dissected basaltic-andesite stratovolcano with Holocene parasitic vents.  One of these flank vents is labeled Volcn Yate on the Volcn Hornopirn 1:50,000 quadrangle map.  Little is known of the geologic history of this isolated volcano, located NNE of Volcn Hornopirn, south of the Relancav strait, although stratigraphic studies show evidence of Holocene eruptions.  The elongated volcano contains six eruptive centers localized along a NW-trending fissure about 7.5 km long.  The most recent activity originated from basaltic-andesite pyroclastic cones on the NW and western flanks.  No historical eruptions are known from Volcn Yate, although the fresh morphology of its satellitic cones suggests an historical age (Gonzlez-Ferrn, 1995).  A non-eruptive volcanic landslide in 1965 produced a debris flow that reached Lake Cabrera, causing a tsunami that destroyed a settlement and caused 27 fatalities.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-022&amp;volpage=photos&amp;photo=049026">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-022">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-41.755000000000003,-72.396000000000001)
1187	Hornopirn	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hornopirn</b></font><br /><font size="5"><b>Southern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110060.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1572 m<br /><b>Latitude:</b> 41.874&deg;S<br /><b>Longitude:</b> 72.431&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn Hornopirn, located SSW of Yate volcano, is a morphologically youthful basaltic-andesite stratovolcano that is mostly forested.  The 1572-m-high volcano lies along a graben defined by the major regional Liquie-Ofqui fault zone, north of the Hornopirn strait and immediately south of Lago Cabrera.  Prominent lava flows descend beyond the SW base of the volcano and overlie the graben floor.  The volcano was said to be in eruption in 1835, although no details are known.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-023&amp;volpage=photos&amp;photo=110060">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-023">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-41.874000000000002,-72.430999999999997)
1188	Apagado	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Apagado</b></font><br /><font size="5"><b>Southern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110061.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cone</td><td width="50%" align="left"><b>Summit Elev:</b> 1210 m<br /><b>Latitude:</b> 41.88&deg;S<br /><b>Longitude:</b> 72.58&deg;W</td></tr><tr><td colspan="2"><p align="justify">A sparsely vegetated pyroclastic cone, Volcn Apagado, lies in the center of the peninsula between the Gulf of Ancud and the Reloncav estuary.  The volcano, also known as Hualiaque, is located west of Hornopirn volcano and SW of Yate volcano.   The symmetrical cone contains a well-preserved summit crater.   A 6-km-wide depression breached to the SW mentioned by Gonzlez-Ferrn (1995) and a small lava flow from a second pyroclastic cone that was said to travel to the SW through a breach in the SW side of the depression are not prominent on satellite imagery.   Volcn Apagado was estimated to be of Holocene age by Gonzlez-Ferrn (1995), consistent with its youthful appearance.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-024&amp;volpage=photos&amp;photo=110061">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-024">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-41.880000000000003,-72.579999999999998)
1189	Crater Basalt Volcanic Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Crater Basalt Volcanic Field</b></font><br /><font size="5"><b>Argentina</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1359 m<br /><b>Latitude:</b> 42.02&deg;S<br /><b>Longitude:</b> 70.18&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Crater Basalt volcanic field in the northern Patagonia region of Argentina covers an area of about 700 sq km.  The volcanic field lies about 400 km east of the Per-Chile trench along the broad regional, NW-SE-trending Gastre fault system.  Nine cinder cones and spatter cones produced blocky lava flows of alkali basaltic, basanitic, and trachybasaltic composition.  One of the largest features of the volcanic field is Cerro Fermn, a cinder cone that produced a half dozen lava flows.  The highest cone, 1359-m Cerro Negro, fed lava flows that traveled to the west, east, and then NE, where its distal margin is cut by a provincial road.  Some of the lava flows, such as those from Cerro Ventana and Cerro Contreras, cover Holocene shorelines of playa lakes.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-025">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">dSouthern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-42.020000000000003,-70.180000000000007)
1190	Huequi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Huequi</b></font><br /><font size="5"><b>Southern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110062.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1318 m<br /><b>Latitude:</b> 42.377&deg;S<br /><b>Longitude:</b> 72.578&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn Huequi is a small, glacier-free volcano in the center of the Huequi Peninsula in Ancud Bay.  A parasitic cone is located on the west side of the 1318-m-high basaltic-andesite volcano, which has an 800-m-wide crater.  Explosive eruptions were recorded during the 19th and 20th centuries, initially in 1890 and most recently in about 1920.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-03=&amp;volpage=photos&amp;photo=110062">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-42.377000000000002,-72.578000000000003)
1191	Minchinmvida	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Minchinmvida</b></font><br /><font size="5"><b>Southern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110053.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2404 m<br /><b>Latitude:</b> 42.793&deg;S<br /><b>Longitude:</b> 72.439&deg;W</td></tr><tr><td colspan="2"><p align="justify">The glacier-covered Volcn Minchinmvida, located west of Lago Reihue, has a saddle-shaped summit with an elongated 3-km-wide caldera.  The massive edifice is elongated in a NE-SW direction, and a youthful eruptive center is located on the ENE side of the complex.  Two major explosive eruptions during the Holocene produced tephra deposits extending to the east.  An eruption from Minchinmvida was reported in 1742.  Darwin observed the volcano in activity in 1834 on his renowned voyage that took him to the Galpagos Islands.  The latest known eruption of basaltic-to-andesitic Minchinmvida, from February to March 1835, produced a lava flow from a flank crater and lahars that reached the coast at Punta Chana.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-04=&amp;volpage=photos&amp;photo=110053">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-04=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-42.792999999999999,-72.438999999999993)
1192	Chaitn	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Chaitn</b></font><br /><font size="5"><b>Southern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120045.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 1122 m<br /><b>Latitude:</b> 42.833&deg;S<br /><b>Longitude:</b> 72.646&deg;W</td></tr><tr><td colspan="2"><p align="justify">Chaitn is a small, glacier-free caldera with a Holocene lava dome located 10 km NE of the town of Chaitn on the Gulf of Corcovado.  A pyroclastic-surge and pumice layer that was considered to originate from the eruption that formed the elliptical 2.5 x 4 km wide summit caldera was dated at about 9400 years ago.  A rhyolitic, 962-m-high obsidian lava dome occupies much of the caldera floor.  Obsidian cobbles from this dome found in the Blanco River are the source of prehistorical artifacts from archaeological sites along the Pacific coast as far as 400 km away from the volcano to the north and south.  The caldera is breached on the SW side by a river that drains to the bay of Chaitn, and the high point on its southern rim reaches 1122 m.  Two small lakes occupy the caldera floor on the west and north sides of the lava dome.  The first historical eruption of Chaitn volcano in 2008 produced major rhyolitic explosive activity and growth of a lava dome that filled much of the caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-041&amp;volpage=photos&amp;photo=120045">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-041">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-42.832999999999998,-72.646000000000001)
1193	Corcovado	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Corcovado</b></font><br /><font size="5"><b>Southern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/069097.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2300 m<br /><b>Latitude:</b> 43.18&deg;S<br /><b>Longitude:</b> 72.80&deg;W</td></tr><tr><td colspan="2"><p align="justify">Little is known of this isolated volcano that was seen in eruption by Darwin.  Corcovado, probably of late-Pleistocene age, is eroded by glaciers and surrounded by Holocene cinder cones.  A series of lakes flank the eastern side of the basaltic to basaltic-andesite volcano.  Eruptions in historical time were considered likely from these postglacial volcanoes (Moreno 1985, pers. comm.).  Darwin observed activity from the Corcovado area in 1834, and an eruption was reported to have occurred in November 1835.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-05=&amp;volpage=photos&amp;photo=069097">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-05=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-43.18,-72.799999999999997)
1194	Yanteles	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Yanteles</b></font><br /><font size="5"><b>Southern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110064.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes</td><td width="50%" align="left"><b>Summit Elev:</b> 2042 m<br /><b>Latitude:</b> 43.50&deg;S<br /><b>Longitude:</b> 72.80&deg;W</td></tr><tr><td colspan="2"><p align="justify">Little-known Yanteles volcano in southern Chile is composed of five glacier-capped peaks along an 8-km-long NE-trending ridge.  Several Holocene tephra layers have been documented from Yanteles volcano.  Historical activity from this 2042-m-high, andesitic volcanic complex is uncertain.  Although there were reports of an eruption from Yanteles at the time of the February 20, 1835 Chile earthquake, and Sapper (1917) reported that previously unseen black areas were seen near the crater after the 1835 earthquake, the nature of this activity is not clear.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-050&amp;volpage=photos&amp;photo=110064">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-050">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-43.5,-72.799999999999997)
1195	Palena Volcanic Group	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Palena Volcanic Group</b></font><br /><font size="5"><b>Southern Chile</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Latitude:</b> 43.78&deg;S<br /><b>Longitude:</b> 72.47&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Palena volcano group consists of five cinder cones oriented along a NNE trend NE of Melimoyu volcano.  The youthful volcanoes, which are named after the middle cone, are Holocene in age (Moreno 1985, pers. comm.).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-051">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-43.780000000000001,-72.469999999999999)
1196	Melimoyu	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Melimoyu</b></font><br /><font size="5"><b>Southern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/118096.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2400 m<br /><b>Latitude:</b> 44.08&deg;S<br /><b>Longitude:</b> 72.88&deg;W</td></tr><tr><td colspan="2"><p align="justify">Melimoyu is a stratovolcano with an 8-km-wide, largely buried caldera located about 40 km NW of the town of Puyuhuapi.  The ice-filled caldera is drained by a glacier through a notch in the NE caldera rim.  The basaltic-andesite volcano is elongated 10 km in an E-W direction and has several cinder cones.  A 1-km-wide crater is located at the summit of the volcano.  Two late-Holocene tephra layers have been documented from Melimoyu.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-052&amp;volpage=photos&amp;photo=118096">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-052">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-44.079999999999998,-72.879999999999995)
1197	Puyuhuapi	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Puyuhuapi</b></font><br /><font size="5"><b>Southern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/114039.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 524 m<br /><b>Latitude:</b> 44.30&deg;S<br /><b>Longitude:</b> 72.53&deg;W</td></tr><tr><td colspan="2"><p align="justify">A chain of dominantly basaltic cinder cones erupted along two NE-SW-trending fissures at the head of Puyuhuapi fjord comprise the Volcanes de Puyuhuapi.  The larger group of four cones lies on the western side of Puyuhuapi fjord and fed lava flows that traveled SE to the sea.  The second lineament formed a chain of four smaller cones between the head of the fjord and Lake Risopatrn to the north.  The two fractures are related to the regional Liquie-Ofqui fault zone.  The Puyuhuapi cinder cones are extremely well preserved, suggesting a very young age.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-053&amp;volpage=photos&amp;photo=114039">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-053">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-44.299999999999997,-72.530000000000001)
1198	Mentolat	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Mentolat</b></font><br /><font size="5"><b>Southern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/069091.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 1660 m<br /><b>Latitude:</b> 44.70&deg;S<br /><b>Longitude:</b> 73.08&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn Mentolat is an ice-filled 6-km-wide caldera in the central part of Magdalena Island across the Puyuhuapi strait from Puerto Cisnes.  An eruption about 7000 years ago produced a pumice and scoria layer that extends to the SE.  A young-looking andesitic lava flow on the west side of the volcano may be its most recent product.  Historical reports by Serrano describe an eruption at the beginning of the 18th century that could refer to this lava flow.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-054&amp;volpage=photos&amp;photo=069091">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-054">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-44.700000000000003,-73.079999999999998)
1199	Maca	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Maca</b></font><br /><font size="5"><b>Southern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/109070.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2960 m<br /><b>Latitude:</b> 45.10&deg;S<br /><b>Longitude:</b> 73.17&deg;W</td></tr><tr><td colspan="2"><p align="justify">Volcn Mac rises to 2960 m NW of Puerto Aisn and is the highest volcano between Lann and Lautaro.  This glacier-covered, basaltic-to-dacitic stratovolcano lies within a caldera and contains a summit lava dome.  Five flank cinder cones and lava domes lie along a NE-trending fissure that extends 15 km from the summit.  The volcano lies along the regional Liquie-Ofqui fault zone, and tephra layer of late-Holocene age was documented.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-056&amp;volpage=photos&amp;photo=109070">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-056">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-45.100000000000001,-73.170000000000002)
1200	Cerro Hudson	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Cerro Hudson</b></font><br /><font size="5"><b>Southern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/049033.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1905 m<br /><b>Latitude:</b> 45.90&deg;S<br /><b>Longitude:</b> 72.97&deg;W</td></tr><tr><td colspan="2"><p align="justify">The ice-filled, 10-km-wide caldera of the remote Cerro Hudson volcano was not recognized until its first 20th-century eruption in 1971.  Cerro Hudson is the southernmost volcano in the Chilean Andes related to subduction of the Nazca plate beneath the South American plate.  The massive, 1905-m-high Cerro Hudson covers an area of 300 sq km.  The compound caldera is drained through a breach on its NW rim, which has been the source of mudflows down the Ro de Los Huemeles.  Two cinder cones occur north of the volcano and others occupy the SW and SE flanks.  Hudson has been the source of several major Holocene explosive eruptions.  An eruption about 6700 years ago was one of the largest known in the southern Andes during the Holocene; another eruption about 3600 years ago also produced more than 10 cu km of tephra.  An eruption in 1991 was Chile's second largest of the 20th century and formed a new 800-m-wide crater in the SW part of the caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-057&amp;volpage=photos&amp;photo=049033">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-057">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-45.899999999999999,-72.969999999999999)
1201	Arenales	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Arenales</b></font><br /><font size="5"><b>Southern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117052.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 3437 m<br /><b>Latitude:</b> 47.20&deg;S<br /><b>Longitude:</b> 73.48&deg;W</td></tr><tr><td colspan="2"><p align="justify">Cerro Arenales lies on the Northern Patagonian Ice Field SSW of Hudson volcano.  Cerro (or Volcn) Arenales was recognized to be a volcano during a 1963 expedition traversing the Northern Patagonian Ice Field led by Eric Shipton, but it was considered to be extinct.  However a small tephra deposit was observed blanketing the icecap on the SW flank of 3437-m-high Cerro Arenales on a March 8, 1979 Landsat image (Lliboutry, 1999).  The same satellite image showed a larger tephra layer on the icecap south of Lautaro volcano, 205 km to the south.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-059&amp;volpage=photos&amp;photo=117052">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-059">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-47.200000000000003,-73.480000000000004)
1202	Lautaro	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Lautaro</b></font><br /><font size="5"><b>Southern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/109080.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Explosion craters<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 3607 m<br /><b>Latitude:</b> 49.02&deg;S<br /><b>Longitude:</b> 73.55&deg;W</td></tr><tr><td colspan="2"><p align="justify">Lautaro is the northernmost of five volcanoes comprising the Australandean volcanic zone of the southernmost Chilean Andes and is the closest volcano to the Chile Triple Junction plate boundary.  Volcanoes of the Australandean volcanic zone originated from subduction of the Antarctic plate beneath the South American plate.  The Catalog of Active Volcanoes of the World synonyms for Lautaro (Cerro Pirmide, Chalten, and Chaltel) are actually synonyms of the dramatic Patagonian granitic peak of Cerro Fitz Roy (Moreno 1985, pers. comm.).  Glacier-covered, 3607-m-high Lautaro volcano, the highest Chilean volcano below 40 degrees south, rises above the Southern Patagonian Ice Field.  It has a crater just below its summit on the NW side, and a 1-km-wide crater is located on the NE flank.  Ash deposits from eruptions of this dominantly dacitic volcano were visible on aerial photos taken during several occasions during the 20th century, and older ash layers form prominent markers on outflow glaciers of the Patagonian icecap.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-06=&amp;volpage=photos&amp;photo=109080">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-06=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-49.020000000000003,-73.549999999999997)
1203	Viedma	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Viedma</b></font><br /><font size="5"><b>Argentina</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117051.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Subglacial volcano<br />&nbsp;&nbsp;&nbsp; Calderas</td><td width="50%" align="left"><b>Summit Elev:</b> 1500 m<br /><b>Latitude:</b> 49.358&deg;S<br /><b>Longitude:</b> 73.28&deg;W</td></tr><tr><td colspan="2"><p align="justify">An eruption in 1988 confirmed the presence of a postulated subglacial vent in the Patagonian Icefield NW of Viedma Lake (Kilian, 1991).  A previously suggested vent location (Shipton, 1960) turned out to be a glacial nunatak of metamorphic and sedimentary rocks.  The Volcn Viedma eruptive center is a subglacial dacitic volcano beneath the Patagonian Icecap west of the spectacular granitic spires of the Cerro Torre, Cerro Fitz Roy area.  Only part of the older edifice rises above the surface of the icecap.  Four large craters or calderas between 1.5 and 4 km in diameter are located along a N-S line.  The 1988 eruption deposited ash and pumice on the Patagonian Icecap and produced a mudflow that reached Viedma Lake.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-061&amp;volpage=photos&amp;photo=117051">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-061">Smithsonian Volcano Information</a></td></tr></table>	(-49.357999999999997,-73.280000000000001)
1204	Aguilera	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Aguilera</b></font><br /><font size="5"><b>Southern Chile</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 2546 m<br /><b>Latitude:</b> 50.33&deg;S<br /><b>Longitude:</b> 73.75&deg;W</td></tr><tr><td colspan="2"><p align="justify">Aguilera volcano, located west of Lake Argentina and NE of Peel Fjiord, is one of a chain of poorly known volcanoes in the southernmost Chilean Andes.  Geochemical evidence indicated that the dacitic Aguilera volcano was the source of a major late-Holocene Patagonian tephra layer that was erupted less than about 3600 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-062">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-50.329999999999998,-73.75)
1205	Reclus	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Reclus</b></font><br /><font size="5"><b>Southern Chile</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cone</td><td width="50%" align="left"><b>Summit Elev:</b> 1000 m<br /><b>Latitude:</b> 50.964&deg;S<br /><b>Longitude:</b> 73.585&deg;W</td></tr><tr><td colspan="2"><p align="justify">Reclus volcano, the source of several Holocene Patagonian tephra layers, was recognized to be an independent volcanic edifice only in 1987.  The 1000-m-high volcano consists of a large dacitic pyroclastic cone with a crater about 1 km in diameter.  As many as a half dozen tephra layers overlie a peat layer dated at 3780 years before present.  The volcano is being actively eroded by the Amalia Glacier, which drains off the Patagonian Icecap.  Later work revealed evidence for historical eruptions in the 19th and early 20th centuries.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-063">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-50.963999999999999,-73.584999999999994)
1206	Monte Burney	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Monte Burney</b></font><br /><font size="5"><b>Southern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110065.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 1758 m<br /><b>Latitude:</b> 52.33&deg;S<br /><b>Longitude:</b> 73.40&deg;W</td></tr><tr><td colspan="2"><p align="justify">Monte Burney, a large volcano in the Patagonian region of Chile, is the southernmost of a chain of stratovolcanoes of the Australandean arc.  The 1758-m-high, ice-covered volcano lies about 200 km NW of the town of Punta Arenas.  Monte Burney was constructed on the western rim of a 6-km-wide caldera, which is partially filled with and surrounded by an unglaciated pyroclastic-flow deposit.  Flank vents produced andesitic-dacitic lava flows and pyroclastic material.  Collapse of the edifice produced a major debris avalanche that traveled to the SSW.  Two large plinian eruptions have been documented from Monte Burney during the Holocene.  The only known historical eruption of Monte Burney took place in 1910.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-07=&amp;volpage=photos&amp;photo=110065">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-07=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-52.329999999999998,-73.400000000000006)
1207	Palei-Aike Volcanic Field	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Palei-Aike Volcanic Field</b></font><br /><font size="5"><b>Southern Chile-Argentina border</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/085026.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 282 m<br /><b>Latitude:</b> 52.00&deg;S<br /><b>Longitude:</b> 70.00&deg;W</td></tr><tr><td colspan="2"><p align="justify">The 3000 sq km Pleistocene-to-Holocene Palei-Aike volcanic field straddles the Chile-Argentina border north of the Straits of Magellan, about 150 km NE of the town of Punta Arenas.  The southernmost of the Patagonian basaltic plateau lavas, Palei-Aike contains lake-filled maars and basaltic scoria and spatter cones with associated fresh-looking lava flows.  The distribution of maars and cones indicates that eruptions occurred along regional fissures oriented E-W and NW-SE.  The earliest eruptions produced maars and associated lava flows that are now exposed only in river valleys.  A second stage formed now-eroded spatter cones and soil-covered lava flows.  The youngest cones and lava flows are found in the SE part of the volcanic field.  The most recent volcanic event produced scoria and spatter cones and fresh lava flows not covered by soil.  Ejecta covers prehistorical artifacts (Skewes and Stern, 1979).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-08-&amp;volpage=photos&amp;photo=085026">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-08-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-52,-70)
1208	Fueguino	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Fueguino</b></font><br /><font size="5"><b>Southern Chile</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/115099.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 150? m<br /><b>Latitude:</b> 54.95&deg;S<br /><b>Longitude:</b> 70.25&deg;W</td></tr><tr><td colspan="2"><p align="justify">A group of andesitic, columnar-jointed lava domes and pyroclastic cones up to 150 m high on Isla Cook mark the southernmost Holocene volcanoes of the Andes.  The nearest Holocene volcanism occurs 400 km NW, at Monte Burney.  The volcanoes, known as Volcn Cook or Volcn Fueguino, occupy a broad peninsula forming the SE end of Isla Cook.  One of the cones, south of Baha del Volcn, contains a 150-m-wide crater with a small lake.  The lava domes and pyroclastic cones, possibly emplaced along N-S-trending faults, are unaffected by glacial erosion that scoured the underlying plutonic rocks.  Passing navigators observed possible eruptive activity in the direction of Cook in 1712 and the eruption of incandescent ejecta in 1820.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-09-&amp;volpage=photos&amp;photo=115099">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1508-09-">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www2.sernageomin.cl/ovdas/ovdas7/ovdas66.php">Southern Andes Volcano Observatory</a></td><td width="33%"><a href="http://www.sernageomin.cl/">Servicio Nacional de Geologia y Mineria (SERNAGEOMIN)</a></td></tr></table>	(-54.950000000000003,-70.25)
1209	Saba	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Saba</b></font><br /><font size="5"><b>Saba</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/094035.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 887 m<br /><b>Latitude:</b> 17.63&deg;N<br /><b>Longitude:</b> 63.23&deg;W</td></tr><tr><td colspan="2"><p align="justify">Saba, the northernmost active volcano of the West Indies, is a small 5-km-diameter island forming the upper half of a large stratovolcano that rises 1500 m above the sea  floor.  Its eruptive history is characterized by the emplacement of lava domes and associated pyroclastic flows.  The summit of the volcano, known as Mount Scenery (or The Mountain), is a Holocene lava dome that overtops a major collapse scarp that formed about 100,000 years ago.  Flank domes were constructed on the SW, SE, east, and NE sides of the island near the coast.  A large andesitic lava flow entered the sea on the NE flank, forming the Flat Point Peninsula, the only site level enough on which to locate the island's airport.  The village of The Bottom overlies pyroclastic-surge deposits that contain European pottery fragments and were radiocarbon dated at 280 +/- 80 years before present.  The village was settled in 1640 on grassy meadows on the volcano's flanks reflecting initial vegetation recovery following destruction of tropical rainforests by pyroclastic flows and surges.  Lava dome growth may also have occurred during this SW-flank eruption.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1600-01=&amp;volpage=photos&amp;photo=094035">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1600-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.uwiseismic.com/">Seismic Research Unit, Univ. West Indies</a></td></tr></table>	(17.629999999999999,-63.229999999999997)
1210	The Quill	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>The Quill</b></font><br /><font size="5"><b>Statia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/094040.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 601 m<br /><b>Latitude:</b> 17.478&deg;N<br /><b>Longitude:</b> 62.960&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Quill is a large dominantly andesitic stratovolcano that forms the SE end of St. Eustatius (Statia) Island.  The 601-m-high volcano was formed about 32,000-22,000 years ago by rhyolitic eruptions on a shallow-water limestone bank 3 km offshore of an older 0.2 million years old volcanic center exposed at the NW end of the island.  The interaction of rhyolitic magma with sea water produced pyroclastic-surge deposits, rich in limestone fragments, that joined the two islands and blanket the entire slopes of The Quill.  The surges also swept across the older island and incorporated carbonized plant remains, shell fragments, and remains of fossil hermit crabs.  A likely cryptodome tilted up limestones at Sugarloaf on the southern coast.  A steep-sided crater, 760 m wide and more than 300 m deep caps The Quill; a notch on the western rim of the crater has directed the youngest pyroclastic flows towards the island's capital, Orangestad.  The last dated eruption of The Quill produced pyroclastic flows about 1600 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1600-02=&amp;volpage=photos&amp;photo=094040">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1600-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.uwiseismic.com/">Seismic Research Unit, Univ. West Indies</a></td></tr></table>	(17.478000000000002,-62.960000000000001)
1211	Liamuiga	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Liamuiga</b></font><br /><font size="5"><b>St. Kitts</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/094030.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1156 m<br /><b>Latitude:</b> 17.37&deg;N<br /><b>Longitude:</b> 62.80&deg;W</td></tr><tr><td colspan="2"><p align="justify">Mount Liamuiga volcano, comprising the NW end of St. Kitts Island, contains a steep-walled, 1-km-wide summit crater, which contained a shallow lake until 1959.  Two lava domes are located on the upper western flank, and intrusion of a 3rd dome, Brimstone Hill, on the lower SW flank uplifted a Pleistocene limestone block.  Liamuiga volcano (sometimes referred to as Mount Misery) is the youngest of 3 NW-migrating volcanic centers on St. Kitts.  Its most recent major eruptions less than 2000 years ago produced pyroclastic flows and mudflows whose deposits underlie populated coastal areas.  Reports of possible historical eruptions in 1692 and 1843 are considered uncertain.  An earthquake swarm occurred from late 1988 to early 1989, causing small landslides in the summit crater; another earthquake swarm took place in 1999-2000.  Active fumaroles are found in the summit crater of Liamuiga.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1600-03=&amp;volpage=photos&amp;photo=094030">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1600-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.uwiseismic.com/">Seismic Research Unit, Univ. West Indies</a></td></tr></table>	(17.370000000000001,-62.799999999999997)
1212	Soufrire Hills	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Soufrire Hills</b></font><br /><font size="5"><b>Montserrat</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/049066.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 915 m<br /><b>Latitude:</b> 16.72&deg;N<br /><b>Longitude:</b> 62.18&deg;W</td></tr><tr><td colspan="2"><p align="justify">The complex, dominantly andesitic Soufrire Hills volcano occupies the southern half of the island of Montserrat.  The summit area consists primarily of a series of lava domes emplaced along an ESE-trending zone.  English's Crater, a 1-km-wide crater breached widely to the east, was formed during an eruption about 4000 years ago in which the summit collapsed, producing a large submarine debris avalanche.  Block-and-ash flow and surge deposits associated with dome growth predominate in flank deposits at Soufrire Hills.  Non-eruptive seismic swarms occurred at 30-year intervals in the 20th century, but with the exception of a 17th-century eruption that produced the Castle Peak lava dome, no historical eruptions were recorded on Montserrat until 1995.  Long-term small-to-moderate ash eruptions beginning in that year were later accompanied by lava-dome growth and pyroclastic flows that forced evacuation of the southern half of the island and ultimately destroyed the capital city of Plymouth, causing major social and economic disruption.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1600-05=&amp;volpage=photos&amp;photo=049066">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1600-05=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.mvo.ms/">Montserrat Volcano Observatory</a></td></tr></table>	(16.719999999999999,-62.18)
1213	Soufrire Guadeloupe	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Soufrire Guadeloupe</b></font><br /><font size="5"><b>Guadeloupe</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/049082.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1467 m<br /><b>Latitude:</b> 16.05&deg;N<br /><b>Longitude:</b> 61.67&deg;W</td></tr><tr><td colspan="2"><p align="justify">La Soufrire de la Guadeloupe volcano occupies the southern end of Basse-Terre, the western half of the butterfly-shaped island of Guadeloupe.  Construction of the Grand Dcouverte volcano about 0.2 million years ago (Ma) was followed by caldera formation after a plinian eruption about 0.1 Ma, and then by construction of the Carmichal volcano within the caldera.  Two episodes of edifice collapse and associated large debris avalanches formed the Carmichal and Amic craters about 11,500 and 3100 years ago, respectively.  The presently active La Soufrire volcano subsequently grew within the Amic crater.  The summit consists of a flat-topped lava dome, and several other domes occur on the southern flanks.  Most historical eruptions have originated from NW-SE-trending fissure systems that cut across the summit and upper flanks.  A relatively minor phreatic eruption in 1976-77 caused severe economic disruption when Basse-Terre, the island's capital city, which lies immediately below the volcano, was evacuated.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1600-06=&amp;volpage=photos&amp;photo=049082">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1600-06=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://volcano.ipgp.jussieu.fr/guadeloupe/stationgua.html">IPGP Observatoire Volcanologique et Sismologique de Guadeloupe</a></td></tr></table>	(16.050000000000001,-61.670000000000002)
1214	Morne aux Diables	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Morne aux Diables</b></font><br /><font size="5"><b>Dominica</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/094033.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 861 m<br /><b>Latitude:</b> 15.612&deg;N<br /><b>Longitude:</b> 61.43&deg;W</td></tr><tr><td colspan="2"><p align="justify">The relatively unknown 861-m-high Morne aux Diables (Devils' Peak) stratovolcano forms the northern tip of the island of Dominica.  Several nested craters and a 90-m-high, 335-m-wide lava dome are located within a larger 1.2-km-wide crater.  A chain of lava domes, two of which form a peninsula on the SW flank, form an E-W belt across the southern flank of the volcano.  Bathymetry shows a double-peaked lava dome (known informally as Twin Peaks) off the northern coast, which is truncated by a 4-km-long fault-bounded cliff.  No eruptions are known from Morne aux Diables in historical time, although the volcano has a youthful appearance and activity at flank domes likely continued into the late-Pleistocene and Holocene.  The youngest (NW) summit crater contains an active thermal area with bubbling springs.  Severe earthquake swarms in 1841 and 1893 were associated with either Morne aux Diables or Morne Diablotins to the south.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1600-08=&amp;volpage=photos&amp;photo=094033">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1600-08=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.uwiseismic.com/">Seismic Research Unit, Univ. West Indies</a></td></tr></table>	(15.612,-61.43)
1215	Morne Trois Pitons	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Morne Trois Pitons</b></font><br /><font size="5"><b>Dominica</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/094042.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Complex volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1387 m<br /><b>Latitude:</b> 15.37&deg;N<br /><b>Longitude:</b> 61.33&deg;W</td></tr><tr><td colspan="2"><p align="justify">Two large lava-domes complexes, Morne Trois Pitons and Micotrin, rise NE of the capital city of Roseau in central Dominica.  Micotrin (Morne Macaque) dome lies immediately south of the larger 1387-m-high Morne Trois Pitons; small lakes are located in the saddle between the two domes and on the eastern flank of Micotrin.  The domes are located along the margin of a large semi-circular depression on the western coast of central Dominica, whose origin has been variously attributed to caldera collapse, gravity sliding, or the juxtaposition of several independent volcanic centers.  The area is the source of the voluminous, mostly submarine Roseau Tuff, a thick sequence of pyroclastic flows erupted between about 40,000 and 25,000 years ago.  It is considered to have originated from calderas at Morne Trois Piton and Wotten Waven, the latter an elliptical NE-SW-trending caldera containing Microtin at its NE end.  Explosive eruptions at the Trois Piton-Microtin complex producing pyroclastic flows continued into the late Pleistocene and Holocene.  The youngest dated eruption took place about 800 AD, but other smaller eruptions may have occurred since.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1600-10=&amp;volpage=photos&amp;photo=094042">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1600-10=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.uwiseismic.com/">Seismic Research Unit, Univ. West Indies</a></td></tr></table>	(15.369999999999999,-61.329999999999998)
1216	Morne Watt	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Morne Watt</b></font><br /><font size="5"><b>Dominica</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/094043.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1224 m<br /><b>Latitude:</b> 15.307&deg;N<br /><b>Longitude:</b> 61.305&deg;W</td></tr><tr><td colspan="2"><p align="justify">Morne Watt (Watt Mountain) volcano lies SE of the Trois Piton/Micotrin lava-dome complex in SE Dominica, east of the capital city of Roseau.  The two best-known volcanic features on Dominica, the Valley of Desolation and the Boiling Lake thermal areas, lie on the flank of Morne Watt; both are major tourist attractions within the national park on Dominica.  Morne Anglais stratovolcano lies 4 km SW of Morne Watt and Grand Soufrire Hills volcano, with dated pyroclastic-flow producing eruptions about 10,000 years ago, lies 3 km to the east.  A major eruption from Morne Watt producing pyroclastic flows took place about 1300 years ago.  A moderately large phreatic explosion took place at the Valley of Desolation thermal area NE of Morne Watt in 1880, when ash fell over a 4-km-wide sector at the coast, 10 km from the vent.   A smaller phreatic explosion occurred in July 1997, when ashfall was confined to the Valley of Desolation area.   These mark the only known historical eruptions on the island of Dominica.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1600-101&amp;volpage=photos&amp;photo=094043">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1600-101">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.uwiseismic.com/">Seismic Research Unit, Univ. West Indies</a></td></tr></table>	(15.307,-61.305)
1217	Morne Plat Pays	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Morne Plat Pays</b></font><br /><font size="5"><b>Dominica</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/094038.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 940 m<br /><b>Latitude:</b> 15.255&deg;N<br /><b>Longitude:</b> 61.341&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Morne Plat Pays volcanic complex occupies the southern tip of the island of Dominica and has been active throughout the Holocene.  An arcuate caldera that formed about 39,000 years ago as a result of a major explosive eruption and flank collapse is open to Soufrire Bay on the west.  This depression cuts the SW side of Morne Plat Pays stratovolcano and extends to the southern tip of Dominica.  At least a dozen small post-caldera lava domes were emplaced within and outside this depression, including one submarine dome south of Scotts Head.  The latest dated eruptions at the Morne Plat Pays complex occurred from the Morne Patates lava dome about 1270 AD, although younger deposits have not yet been dated.  The Morne Plat Pays complex is the site of extensive fumarolic activity, and at least ten swarms of small-magnitude earthquakes, none associated with eruptive activity, have occurred since 1765 at Morne Patates.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1600-11=&amp;volpage=photos&amp;photo=094038">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1600-11=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.uwiseismic.com/">Seismic Research Unit, Univ. West Indies</a></td></tr></table>	(15.255000000000001,-61.341000000000001)
1218	Pele	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Pele</b></font><br /><font size="5"><b>Martinique</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/106068.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1397 m<br /><b>Latitude:</b> 14.82&deg;N<br /><b>Longitude:</b> 61.17&deg;W</td></tr><tr><td colspan="2"><p align="justify">Renowned Montagne Pele, forming the northern end of the island of Martinique, is the most active volcano of the Lesser Antilles arc.  Three major edifice failures since the late Pleistocene, the last about 9000 years ago, have left large horseshoe-shaped calderas breached to the SW inside which the modern volcano has been constructed.  More than 20 major eruptions have occurred at Pele during the past 5000 years.  Extensive pyroclastic-flow deposits, incised by steep-walled ravines, mantle the slopes of the volcano.  The l'Etang Sec summit crater is filled by two lava domes emplaced during the 1902 and 1929 eruptions.  Historical eruptions date back to the 18th century; only two modest phreatic or phreatomagmatic eruptions took place prior to 1902.  The catastrophic 1902 eruption, which destroyed the city of St. Pierre, the &quot;Pearl of the Lesser Antilles,&quot; became the type-example of pelean eruptions and marked the onset of modern volcanological studies of the behavior of pyroclastic flows.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1600-12=&amp;volpage=photos&amp;photo=106068">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1600-12=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://volcano.ipgp.jussieu.fr/martinique/stationmar.html">IPGP Observatoire Volcanologique de la Montagne Pele</a></td></tr></table>	(14.82,-61.170000000000002)
1219	Qualibou	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Qualibou</b></font><br /><font size="5"><b>St. Lucia</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/055027.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Tuff rings</td><td width="50%" align="left"><b>Summit Elev:</b> 777 m<br /><b>Latitude:</b> 13.83&deg;N<br /><b>Longitude:</b> 61.05&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Qualibou caldera on the SW side of St. Lucia provides the setting for the Pitons, two steep-sided pre-caldera lava domes that form one of the scenic highlights of the West Indies.  The 3.5 x 5-km-wide Qualibou caldera formed about 32-39,000 years ago in conjunction with the eruption of the Choiseul Tuff.  A larger depression has been interpreted to have formed by edifice collapse, and bathymetry has identified large submarine debris-avalanche deposits off the west coast of the island.  This depression and associated volcanic vents and geothermal areas is also known as the Soufrire volcanic centre.  Numerous resurgent post-caldera lava domes fill the caldera floor.  The latest dated magmatic eruptions took place about 20,000 years ago, but younger undated lava domes and explosion craters are present.  The only known Holocene eruptive activity was a minor phreatic eruption in the Sulfur Springs geothermal area in 1766 AD that ejected a thin ash layer over a wide area.  A volcanic earthquake swarm centered 6 km ESE of the caldera occurred in 1990.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1600-14=&amp;volpage=photos&amp;photo=055027">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1600-14=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.uwiseismic.com/">Seismic Research Unit, Univ. West Indies</a></td></tr></table>	(13.83,-61.049999999999997)
1220	Soufrire St. Vincent	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Soufrire St. Vincent</b></font><br /><font size="5"><b>St. Vincent</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/051030.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 1220 m<br /><b>Latitude:</b> 13.33&deg;N<br /><b>Longitude:</b> 61.18&deg;W</td></tr><tr><td colspan="2"><p align="justify">Soufrire St. Vincent is the northernmost and youngest volcano on St. Vincent Island.  The 1.6-km wide summit crater, whose NE rim is cut by a crater formed in 1812, lies on the SW margin of the 2.2-km-wide Somma crater, which is breached widely to the SW as a result of slope failure.  Frequent explosive eruptions since about 4300 years ago produced pyroclastic deposits of  the Yellow Tephra Formation, which blanket much of the island.  The first historical eruption of the volcano took place during 1718; it and the 1812 eruption produced major explosions.  Much of the northern end of the island was devastated by a major eruption in 1902 that coincided with the catastrophic Mont Pele eruption on Martinique.  A lava dome was emplaced in the summit crater in 1971 during a strictly effusive eruption, forming an island in a lake that filled the crater prior to an eruption in 1979.  The lake was then largely ejected during a series of explosive eruptions, and the dome was replaced with another.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1600-15=&amp;volpage=photos&amp;photo=051030">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1600-15=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.uwiseismic.com/">Seismic Research Unit, Univ. West Indies</a></td></tr></table>	(13.33,-61.18)
1221	Kick 'em Jenny	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kick 'em Jenny</b></font><br /><font size="5"><b>Grenada-N of</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/118089.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Tuff cones</td><td width="50%" align="left"><b>Summit Elev:</b> -185 m<br /><b>Latitude:</b> 12.300&deg;N<br /><b>Longitude:</b> 61.640&deg;W</td></tr><tr><td colspan="2"><p align="justify">Kick 'em Jenny, a historically active submarine volcano 8 km off the north shore of Grenada, rises 1300 m from the sea floor.   Recent bathymetric surveys have shown evidence for a major arcuate collapse structure that was the source of a submarine debris avalanche that traveled more than 15 km to the west.  Bathymetry also revealed another submarine cone to the SE, Kick 'em Jack, and submarine lava domes to its south.  These and subaerial tuff rings and lava flows at Ile de Caille and other nearby islands may represent a single large volcanic complex.  Numerous historical eruptions, mostly documented by acoustic signals, have occurred at Kick 'em Jenny since 1939, when an eruption cloud rose 275 m above the sea surface.  Prior to the 1939 eruption, which was witnessed by a large number of people in northern Grenada, there had been no written mention of Kick 'em Jenny.  Eruptions have involved both explosive activity and the quiet extrusion of lava flows and lava domes in the summit crater; deep rumbling noises have sometimes been heard onshore.  Historical eruptions have modified the morphology of the summit crater.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1600-16=&amp;volpage=photos&amp;photo=118089">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1600-16=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.uwiseismic.com/">Seismic Research Unit, Univ. West Indies</a></td></tr></table>	(12.300000000000001,-61.640000000000001)
1222	St. Catherine	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>St. Catherine</b></font><br /><font size="5"><b>Grenada</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/095064.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Explosion craters</td><td width="50%" align="left"><b>Summit Elev:</b> 840 m<br /><b>Latitude:</b> 12.15&deg;N<br /><b>Longitude:</b> 61.67&deg;W</td></tr><tr><td colspan="2"><p align="justify">The island of Grenada is composed of five Pliocene-to-Pleistocene volcanic centers, the youngest and highest of which is Mount St. Catherine on the northern end of the island.  A complex of lava domes is located within a horseshoe-shaped crater breached to the east at the summit of 840-m-high Mount St. Catherine.  Pyroclastic-flow deposits extend to the NW from the extensively weathered volcano.  The most recent activity on Grenada originated from a group of young maars, tuff rings, and scoria cones that extend SSW-NNE across the length of the 30-km-long island.  Kick 'em Jenny, the historically active submarine volcano 8 km north of Grenada, is listed separately in this compilation along with adjacent submarine and subaerial cones that may represent a single volcanic complex.   No eruptions of St. Catherine are known in historical time, although the most recent eruption along a NE-SW-trending fault cutting across the island produced a scoria cone near Radix village that could be less than 1000 years old.  Hot springs and fumaroles are present at several locations on Mount St. Catherine.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1600-17=&amp;volpage=photos&amp;photo=095064">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1600-17=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.uwiseismic.com/">Seismic Research Unit, Univ. West Indies</a></td></tr></table>	(12.15,-61.670000000000002)
1223	Snaefellsjkull	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Snaefellsjkull</b></font><br /><font size="5"><b>Western Iceland</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/057067.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1448 m<br /><b>Latitude:</b> 64.80&deg;N<br /><b>Longitude:</b> 23.78&deg;W</td></tr><tr><td colspan="2"><p align="justify">Ice-clad Snaefellsjkull volcano anchors the western tip of the isolated Snaefellsnes Peninsula in western Iceland.  Numerous pyroclastic cones dot the flanks of the 1448-m-high stratovolcano, the only large central volcano in this part of Iceland.   Lower-flank craters produced basaltic lava flows and upper-flank craters intermediate-to-silicic material.  Holocene lava flows extend to the sea over the entire western half of the volcano.  Several Holocene silicic eruptions have originated from the summit crater.  The latest dated eruption took place about 1750 years ago; several lava flows may be even younger.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1700-01=&amp;volpage=photos&amp;photo=057067">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1700-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.earthice.hi.is/page/ies_volcanoes">Inst of Earth Sciences, Univ of Iceland</a></td></tr></table>	(64.799999999999997,-23.780000000000001)
1224	Helgrindur	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Helgrindur</b></font><br /><font size="5"><b>Western Iceland</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/077043.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 647 m<br /><b>Latitude:</b> 64.87&deg;N<br /><b>Longitude:</b> 23.25&deg;W</td></tr><tr><td colspan="2"><p align="justify">Helgrindur (also known as Lysuhll or Lysukard) is one of Iceland's smallest volcanic systems.  It consists of a chain of small alkali olivine basaltic cinder cones and vents along a WNW-ESE line cutting across the central Snaefellsnes Peninsula in western Iceland.  The slightly arcuate line of Quaternary vents extends to the northern coast of the peninsula.  Helgrindur is the central of three volcanic systems occupying the peninsula.  The latest eruption from Helgrindur is undated, but the volcanic field has been active during the Holocene.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1700-02=&amp;volpage=photos&amp;photo=077043">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1700-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.earthice.hi.is/page/ies_volcanoes">Inst of Earth Sciences, Univ of Iceland</a></td></tr></table>	(64.870000000000005,-23.25)
1225	Ljsufjll	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ljsufjll</b></font><br /><font size="5"><b>Western Iceland</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/075035.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Fissure vents<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1063 m<br /><b>Latitude:</b> 64.87&deg;N<br /><b>Longitude:</b> 22.23&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Ljsufjll volcanic system at the eastern end of the Snaefellsnes Peninsula is composed of a group of alkali olivine basaltic cinder cones and lava flows along short fissures on a roughly 90-km-long WNW-ESE line.  The volcanic field is about 20-km wide at the eastern end and narrows to about 10-km width on the west.  The Ljsufjll volcanic field contains the largest outcrops of silicic rhyolitic and trachytic rocks in the Snaefellsnes volcanic zone, erupted during the mid-to-late Pleistocene.  Youthful-looking cinder cones and lava flows with morphologically pristine surfaces as evidence of numerous eruptions during the Holocene.  The latest eruption at Ljsufjll post-dated the settlement of Iceland, and took place about 1000 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1700-03=&amp;volpage=photos&amp;photo=075035">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1700-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.earthice.hi.is/page/ies_volcanoes">Inst of Earth Sciences, Univ of Iceland</a></td></tr></table>	(64.870000000000005,-22.23)
1226	Reykjanes	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Reykjanes</b></font><br /><font size="5"><b>Southwestern Iceland</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/075048.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Crater rows<br />&nbsp;&nbsp;&nbsp; Shield volcanoes</td><td width="50%" align="left"><b>Summit Elev:</b> 230 m<br /><b>Latitude:</b> 63.88&deg;N<br /><b>Longitude:</b> 22.50&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Reykjanes volcanic system at the SW tip of the Reykjanes Peninsula, where the Mid-Atlantic Ridge rises above sea level, comprises a broad area of postglacial basaltic crater rows and small shield volcanoes.  The submarine Reykjaneshryggur volcanic system is contiguous with and is considered part of the Reykjanes volcanic system, which is the westernmost of a series of four closely-spaced en-echelon fissure systems that extend diagonally across the Reykjanes Peninsula.  Most of the subaerial part of the volcanic system (also known as the Reykjanes/Svartsengi volcanic system) is covered by Holocene lavas. Subaerial eruptions have occurred in historical time during the 13th century at several locations on the NE-SW-trending fissure system, and numerous submarine eruptions at Reykjaneshryggur dating back to the 12th century have been observed during historical time, some of which have formed ephemeral islands.  Basaltic rocks of probable Holocene age have been recovered during dredging operations, and tephra deposits from earlier Holocene eruptions are preserved on the nearby Reykjanes Peninsula.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1701-02=&amp;volpage=photos&amp;photo=075048">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1701-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.earthice.hi.is/page/ies_volcanoes">Inst of Earth Sciences, Univ of Iceland</a></td></tr></table>	(63.880000000000003,-22.5)
1227	Krsuvk	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Krsuvk</b></font><br /><font size="5"><b>Southwestern Iceland</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/075050.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Crater rows<br />&nbsp;&nbsp;&nbsp; Shield volcanoes</td><td width="50%" align="left"><b>Summit Elev:</b> 379 m<br /><b>Latitude:</b> 63.93&deg;N<br /><b>Longitude:</b> 22.10&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Krsuvk volcanic system (also spelled Krysuvik) consists of a group of NE-SW-trending basaltic crater rows and small shield volcanoes cutting the central Reykjanes Peninsula west of Kleifarvatn lake.  Several eruptions have taken place since the settlement of Iceland, including the eruption of a large lava flow from the Ogmundargigar crater row around the 12th century.  The latest eruption at Krsuvk took place during the 14th century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1701-03=&amp;volpage=photos&amp;photo=075050">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1701-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.earthice.hi.is/page/ies_volcanoes">Inst of Earth Sciences, Univ of Iceland</a></td></tr></table>	(63.93,-22.100000000000001)
1228	Brennisteinsfjll	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Brennisteinsfjll</b></font><br /><font size="5"><b>Southwestern Iceland</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/075088.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Crater rows<br />&nbsp;&nbsp;&nbsp; Shield volcanoes</td><td width="50%" align="left"><b>Summit Elev:</b> 621 m<br /><b>Latitude:</b> 63.92&deg;N<br /><b>Longitude:</b> 21.83&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Brennisteinsfjll volcanic system, located east of Kleifarvatn lake, consists of a series of NE-SW-trending crater rows and small shield volcanoes.  Postglacial and historical basaltic lavas cover a wide area.  An eruption in 1000 AD was dated by its occurrence at the time of a meeting of the Icelandic outdoor parliament at Thingvellier.  The most recent eruption at Brennisteinsfjll took place in the 14th century.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1701-04=&amp;volpage=photos&amp;photo=075088">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1701-04=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.earthice.hi.is/page/ies_volcanoes">Inst of Earth Sciences, Univ of Iceland</a></td></tr></table>	(63.920000000000002,-21.829999999999998)
1229	Hengill	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hengill</b></font><br /><font size="5"><b>Southwestern Iceland</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/075087.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Crater rows<br />&nbsp;&nbsp;&nbsp; Shield volcanoes</td><td width="50%" align="left"><b>Summit Elev:</b> 803 m<br /><b>Latitude:</b> 64.08&deg;N<br /><b>Longitude:</b> 21.32&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Hengill volcanic system, cutting through Thingvallavatn lake, consists of a series of NE-SW-trending fissure vents, crater rows, and small shield volcanoes occupying a strongly faulted graben.  Hengill is the easternmost of a series of four closely spaced basaltic fissure systems that cut diagonally across the Reykjanes Peninsula and lies at the triple junction of the Reykjanes Peninsula volcanic zone, the Western volcanic zone, and the South Iceland seismic zone.  Postglacial lava flows surface much of the volcanic system.  The latest eruption was radiocarbon dated about 1900 years before present.  An eruption in the Hellisheidi area once thought to have occurred around 1000 AD at the time of a meeting of the Icelandic parliament at Thingvellir is now known to have occurred at a vent about 5 km away in the Brennisteinsfjll volcanic system.  The high-temperature Nesjavellir geothermal area NE of the uplifted hyaloclastite ridge forming the Hengill central volcano and the Helllisheidi geothermal field SW of Hengill are major producers of geothermal energy for Reykjavik.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1701-05=&amp;volpage=photos&amp;photo=075087">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1701-05=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.earthice.hi.is/page/ies_volcanoes">Inst of Earth Sciences, Univ of Iceland</a></td></tr></table>	(64.079999999999998,-21.32)
1230	Grmsnes	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Grmsnes</b></font><br /><font size="5"><b>Southwestern Iceland</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120065.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Crater rows<br />&nbsp;&nbsp;&nbsp; Maar</td><td width="50%" align="left"><b>Summit Elev:</b> 214 m<br /><b>Latitude:</b> 64.03&deg;N<br /><b>Longitude:</b> 20.87&deg;W</td></tr><tr><td colspan="2"><p align="justify">Grmsnes is a relatively small volcanic system located SE of Thingvallavatn lake.  The Grmsnes volcanic system is displaced about 15-20 km to the east of the other en echelon group of volcanic fields of the Western Volcanic Zone extending across the Reykjanes Peninsula.  Grmsnes lava flows cover 54 sq km and were erupted from a group of 11 fissures that produced a series of NE-SW-trending crater rows.  The eruptions of the basaltic Grmsnes lavas were considered to have been restricted to a relatively short interval between about 6500 and 5500 years ago, but later work showed that some of the lava flows were radiocarbon dated at between about 7400 and 8900 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1701-06=&amp;volpage=photos&amp;photo=120065">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1701-06=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.earthice.hi.is/page/ies_volcanoes">Inst of Earth Sciences, Univ of Iceland</a></td></tr></table>	(64.030000000000001,-20.870000000000001)
1231	Prestahnukur	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Prestahnukur</b></font><br /><font size="5"><b>Southwestern Iceland</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/051001.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Subglacial volcano<br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 1400 m<br /><b>Latitude:</b> 64.60&deg;N<br /><b>Longitude:</b> 20.58&deg;W</td></tr><tr><td colspan="2"><p align="justify">The massive subglacial Prestahnukur volcano at the SW end of the Langjkull icecap has associated rift zones to the north and SW that have erupted during the Holocene.  Hot springs are associated with the rhyolitic Prestahnukur central volcano.  The classic Icelandic shield volcano Skjaldbreidur was formed at the southern end of the Prestahnukur volcanic system, between Thorsjkull glacier and Thingvallavatn lake.  The broad, low-angle shield volcano produced more than 13 cu km of basaltic lava flows during the early Holocene.   The smaller mid-Holocene Skflungur lava shield lies immediately NE of Skjaldbreidur.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1701-07=&amp;volpage=photos&amp;photo=051001">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1701-07=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.earthice.hi.is/page/ies_volcanoes">Inst of Earth Sciences, Univ of Iceland</a></td></tr></table>	(64.599999999999994,-20.579999999999998)
1232	Hveravellir	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hveravellir</b></font><br /><font size="5"><b>Southwestern Iceland</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/075034.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Subglacial volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Shield volcanoes</td><td width="50%" align="left"><b>Summit Elev:</b> 1360 m<br /><b>Latitude:</b> 64.75&deg;N<br /><b>Longitude:</b> 19.98&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Hveravellir central volcano lies at the northern end of an active volcanic zone that extends to the NE from the Reykjanes Peninsula.  Hveravellir central volcano occupies the NE half of the massive Langjkull icecap, east of the prominent Pleistocene table mountain, Erikskkull.  A summit caldera lies beneath the ice.  The Kjalhraun shield volcano east of Langjkull produced about 11 cu km of lava about 7800 years ago.  Several small shield volcanoes have been constructed along flank fissure zones, producing postglacial lava flows that flank Langjkull on the northern, western, and eastern sides.  One of the most prominent of these is a small shield volcano that was formed at the site of the massive Hallmundahraun lava flow, which covers about 240 sq km and was erupted about 950 AD.    The Geysir thermal area, containing Iceland's largest geysers, lies in the Haukadalur basin, near the southern end of the lengthy fissure system extending from the Hveravellir central volcano.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1701-08=&amp;volpage=photos&amp;photo=075034">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1701-08=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.earthice.hi.is/page/ies_volcanoes">Inst of Earth Sciences, Univ of Iceland</a></td></tr></table>	(64.75,-19.98)
1233	Hofsjkull	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hofsjkull</b></font><br /><font size="5"><b>Southwestern Iceland</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/075039.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Subglacial volcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1782 m<br /><b>Latitude:</b> 64.78&deg;N<br /><b>Longitude:</b> 18.92&deg;W</td></tr><tr><td colspan="2"><p align="justify">Hofsjkull volcano lies along an east-west-trending area connecting the two principal rift zones of Iceland.  It bridges the gap between the Reykjanes-Langjkull rift on the west, which terminates at Langjkull, and the eastern zone, which extends NE-ward across east-central Iceland.  The roughly 7 x 11 km central caldera of Hofsjkull volcano lies beneath the western part of the massive Hofsjkull icecap.  A small Holocene shield volcano is located at the SW margin of the icecap.  Flank fissures north and east of the icecap have produced basaltic lava flows during the Holocene.  Kerlingarfjll, a glacially dissected, largely Pleistocene rhyolitic central volcano located SW of the Hofsjkull icecap, is considered part of the Hofsjkull volcanic system.  Steep-sided Pleistocene rhyolitic lava domes and numerous hot springs occupy two calderas at the center of the 5 x 7 km wide complex.  Fumarolic activity at Kerlingarfjll, mostly concentrated in the center of the complex, is the most vigorous in Iceland.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1701-09=&amp;volpage=photos&amp;photo=075039">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1701-09=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.earthice.hi.is/page/ies_volcanoes">Inst of Earth Sciences, Univ of Iceland</a></td></tr></table>	(64.780000000000001,-18.920000000000002)
1234	Vestmannaeyjar	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Vestmannaeyjar</b></font><br /><font size="5"><b>Southern Iceland</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/058075.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcanoes<br />&nbsp;&nbsp;&nbsp; Fissure vents<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 279 m<br /><b>Latitude:</b> 63.43&deg;N<br /><b>Longitude:</b> 20.28&deg;W</td></tr><tr><td colspan="2"><p align="justify">The mostly submarine Vestmannaeyjar volcanic system is the southernmost and youngest volcanic center of the eastern volcanic zone that cuts across east-central Iceland.  It consists of a roughly 30 x 40 km group of basaltic volcanic islands and submarine cones occupying a shallow shelf off the south coast of Iceland.  Vestmannaeyjar was the site of two of Iceland's most noted 20th-century eruptions.  The new island of Surtsey grew from the ocean floor during 1963-67.  The island of Heimaey, 20 km to the NE, was the site of dramatic eruptions in 1973 during which lava flows partially overran the town of Vestmannaeyjar and threatened its harbor.  Several other volcanoes have erupted during historical time.  Twenty-two postglacial eruption sites are known in the Vestmannaeyjar system, and all ten subaerial vents on Heimaey are of Holocene age.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1702-01=&amp;volpage=photos&amp;photo=058075">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1702-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.earthice.hi.is/page/ies_volcanoes">Inst of Earth Sciences, Univ of Iceland</a></td></tr></table>	(63.43,-20.280000000000001)
1235	Eyjafjll	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Eyjafjll</b></font><br /><font size="5"><b>Southern Iceland</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/075045.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 1666 m<br /><b>Latitude:</b> 63.63&deg;N<br /><b>Longitude:</b> 19.62&deg;W</td></tr><tr><td colspan="2"><p align="justify">Eyjafjll (also known as Eyjafjallajkull) is located immediately west of Katla volcano.  Eyjafjll consists of an E-W-trending, elongated ice-covered basaltic-andesite stratovolcano with a 2.5-km-wide summit caldera.  Fissure-fed lava flows occur on both the eastern and western flanks of the volcano, but are more prominent on the western side.  Although the 1666-m-high volcano has erupted during historical time, it has been less active than other volcanoes of Iceland's eastern volcanic zone, and relatively few Holocene lava flows are known.  The sole historical eruption of Eyjafjll, during December 1821 to January 1823, produced intermediate-to-silicic tephra from the central caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1702-02=&amp;volpage=photos&amp;photo=075045">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1702-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.earthice.hi.is/page/ies_volcanoes">Inst of Earth Sciences, Univ of Iceland</a></td></tr></table>	(63.630000000000003,-19.620000000000001)
1236	Katla	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Katla</b></font><br /><font size="5"><b>Southern Iceland</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/075042.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Subglacial volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 1512 m<br /><b>Latitude:</b> 63.63&deg;N<br /><b>Longitude:</b> 19.05&deg;W</td></tr><tr><td colspan="2"><p align="justify">Katla volcano, located near the southern end of Iceland's eastern volcanic zone, is hidden beneath the Myrdalsjkull icecap.  The subglacial basaltic-to-rhyolitic volcano is one of Iceland's most active and is a frequent producer of damaging jkulhlaups, or glacier-outburst floods.  A large 10 x 14 km subglacial caldera with a long axis in a NW-SE direction is up to 750 m deep.  Its high point reaches 1380 m, and three major outlet glaciers have breached its rim.  Although most historical eruptions have taken place from fissures inside the caldera, the Eldgj fissure system, which extends about 60 km to the NE from the current ice margin towards Grmsvtn volcano, has been the source of major Holocene eruptions.  An eruption from the Eldgj fissure system about 934 AD produced a voluminous lava flow of about 18 cu km, one of the world's largest known Holocene lava flows.  Katla has been the source of frequent subglacial basaltic explosive eruptions that have been among the largest tephra-producers in Iceland during historical time and has also produced numerous dacitic explosive eruptions during the Holocene.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1702-03=&amp;volpage=photos&amp;photo=075042">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1702-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.earthice.hi.is/page/ies_volcanoes">Inst of Earth Sciences, Univ of Iceland</a></td></tr></table>	(63.630000000000003,-19.050000000000001)
1237	Torfajkull	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Torfajkull</b></font><br /><font size="5"><b>Southern Iceland</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/060067.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 1259 m<br /><b>Latitude:</b> 63.92&deg;N<br /><b>Longitude:</b> 19.17&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Torfajkull central volcano, located north of Myrdalsjkull and south of Thorisvatn lake, is cut by a 12-km-wide caldera that formed during the Pleistocene.  Torjajkull consists of the largest area of silicic and intermediate volcanism in Iceland; about 225 cu km of silicic extrusive rocks are exposed.  The dominantly rhyolitic complex rises about 500 m above surrounding basaltic plains and is elongated in a WNW-ESE direction.  Most rhyolitic lava flows were erupted subglacially, forming silicic hyaloclastites that form ridge and dome-shaped breccias.  During postglacial times only a narrow fissure zone at the western end has been active, producing mostly silicic lava flows, lava domes, and tephras.  The most recent silicic eruption produced the Hrafntinnuhraun lava flow about 900 AD.  The fissure system is along trend with and was active at the same time as the basaltic Veidivtn fissure system of Brdarbunga central volcano in 1477 AD.  The small Torfajkull icecap lies mostly outside the SE rim of the caldera, which is the site of vigorous thermal activity over a broad area of 130-140 sq km.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1702-05=&amp;volpage=photos&amp;photo=060067">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1702-05=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.earthice.hi.is/page/ies_volcanoes">Inst of Earth Sciences, Univ of Iceland</a></td></tr></table>	(63.920000000000002,-19.170000000000002)
1238	Hekla	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hekla</b></font><br /><font size="5"><b>Southern Iceland</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/060068.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 1491 m<br /><b>Latitude:</b> 63.98&deg;N<br /><b>Longitude:</b> 19.70&deg;W</td></tr><tr><td colspan="2"><p align="justify">One of Iceland's most prominent and active volcanoes, Hekla lies near the southern end of the eastern rift zone.  Hekla occupies a rift-transform junction, and has produced basaltic andesites, in contrast to the tholeiitic basalts typical of Icelandic rift zone volcanoes.  Vatnafjll, a 40-km-long, 9-km-wide group of basaltic fissures and crater rows immediately SE of Hekla forms a part of the Hekla-Vatnafjll volcanic system.   A 5.5-km-long fissure, Heklugj, cuts across the 1491-m-high Hekla volcano and is often active along its full length during major eruptions.  Repeated eruptions along this rift, which is oblique to most rifting structures in the eastern volcanic zone, are responsible for Hekla's elongated ENE-WSW profile.  Frequent large silicic explosive eruptions during historical time have deposited tephra throughout Iceland, providing valuable time markers used to date eruptions from other Icelandic volcanoes.  Hekla tephras are generally rich in fluorine and are consequently very hazardous to grazing animals.  Extensive lava flows from Hekla's historical eruptions, which date back to 1104 AD, cover much of the volcano's flanks.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1702-07=&amp;volpage=photos&amp;photo=060068">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1702-07=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.earthice.hi.is/page/ies_volcanoes">Inst of Earth Sciences, Univ of Iceland</a></td></tr></table>	(63.979999999999997,-19.699999999999999)
1239	Grmsvtn	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Grmsvtn</b></font><br /><font size="5"><b>Northeastern Iceland</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111095.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Subglacial volcano<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 1725 m<br /><b>Latitude:</b> 64.42&deg;N<br /><b>Longitude:</b> 17.33&deg;W</td></tr><tr><td colspan="2"><p align="justify">Grmsvtn, Iceland's most frequently active volcano in historical time, lies largely beneath the vast Vatnajkull icecap.  The caldera lake is covered by a 200-m-thick ice shelf, and only the southern rim of the 6 x 8 km caldera is exposed.  The geothermal area in the caldera causes frequent jkulhlaups (glacier outburst floods) when melting raises the water level high enough to lift its ice dam.  Long NE-SW-trending fissure systems extend from the central volcano.  The most prominent of these is the noted Laki (Skaftar) fissure, which extends to the SW and produced the world's largest known historical lava flow during an eruption in 1783.  The 15-cu-km basaltic Laki lavas were erupted over a 7-month period from a 27-km-long fissure system.  Extensive crop damage and livestock losses caused a severe famine that resulted in the loss of one-fifth of the population of Iceland.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1703-01=&amp;volpage=photos&amp;photo=111095">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1703-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.earthice.hi.is/page/ies_volcanoes">Inst of Earth Sciences, Univ of Iceland</a></td></tr></table>	(64.420000000000002,-17.329999999999998)
1240	Brdarbunga	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Brdarbunga</b></font><br /><font size="5"><b>Northeastern Iceland</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/060074.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 2009 m<br /><b>Latitude:</b> 64.63&deg;N<br /><b>Longitude:</b> 17.53&deg;W</td></tr><tr><td colspan="2"><p align="justify">The large central volcano of Brdarbunga lies beneath the NW part of the Vatnajkull icecap, NW of Grmsvtn volcano, and contains a subglacial 700-m-deep caldera.  Related fissure systems include the Veidivtn and Trollagigar fissures, which extend about 100 km SW to near Torfajkull volcano and 50 km NE to near Askja volcano, respectively.  Voluminous fissure eruptions, including one at Thjorsarhraun, which produced the largest known Holocene lava flow on Earth with a volume of more than 21 cu km, have occurred throughout the Holocene into historical time from the Veidivtn fissure system.  The last major eruption of Veidivtn, in 1477, also produced a large tephra deposit.  The subglacial Loki-Fgrufjll volcanic system located SW of Brdarbunga volcano is also part of the Brdarbunga volcanic system and contains two subglacial ridges extending from the largely subglacial Hamarinn central volcano; the Loki ridge trends to the NE and the Fgrufjll ridge to the SW.  Jkulhlaups (glacier-outburst floods) from eruptions at Brdarbunga potentially affect drainages in all directions.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1703-03=&amp;volpage=photos&amp;photo=060074">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1703-03=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.earthice.hi.is/page/ies_volcanoes">Inst of Earth Sciences, Univ of Iceland</a></td></tr></table>	(64.629999999999995,-17.530000000000001)
1241	Tungnafellsjkull	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tungnafellsjkull</b></font><br /><font size="5"><b>Northeastern Iceland</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/075100.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 1535 m<br /><b>Latitude:</b> 64.73&deg;N<br /><b>Longitude:</b> 17.92&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Tungnafellsjkull central volcano, located immediately NW of the massive Vatnajkull icecap, contains two calderas.  One is largely filled by the Tungnafellsjkull glacier, and the other ice-free caldera located to the SE contains Pleistocene rhyolitic lavas.  The 1535-m-high Tungnafellsjkull volcano is largely of Pleistocene age, but postglacial flank fissures on the NE side have produced young basalts.  The Hgngur central volcano to the SW is part of the Tungnafellsjkull volcanic system.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1703-04=&amp;volpage=photos&amp;photo=075100">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1703-04=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.earthice.hi.is/page/ies_volcanoes">Inst of Earth Sciences, Univ of Iceland</a></td></tr></table>	(64.730000000000004,-17.920000000000002)
1242	Kverkfjll	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kverkfjll</b></font><br /><font size="5"><b>Northeastern Iceland</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/060061.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Subglacial volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1929 m<br /><b>Latitude:</b> 64.65&deg;N<br /><b>Longitude:</b> 16.72&deg;W</td></tr><tr><td colspan="2"><p align="justify">Kverkfjll is a large subglacial volcano at the NE end of the Vatnajkull icecap.  Two elliptical ice-filled calderas, 8 x 5 km in diameter, have been identified.  An associated fissure swarm can be traced 60 km to the NE.  A half dozen ridges of  subglacially erupted pillow lavas are now exposed and extend beyond the glacial icecap to the NE.  Subglacial historical eruptions have been recorded since the mid-17th century.  Several other historical eruptions once attributed to Kverkfjll are now thought to have originated from Brdarbunga volcano to the west.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1703-05=&amp;volpage=photos&amp;photo=060061">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1703-05=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.earthice.hi.is/page/ies_volcanoes">Inst of Earth Sciences, Univ of Iceland</a></td></tr></table>	(64.650000000000006,-16.719999999999999)
1243	Askja	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Askja</b></font><br /><font size="5"><b>Northeastern Iceland</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/060001.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 1516 m<br /><b>Latitude:</b> 65.03&deg;N<br /><b>Longitude:</b> 16.75&deg;W</td></tr><tr><td colspan="2"><p align="justify">Askja is a large basaltic central volcano that forms the Dyngjufjll massif.  It is truncated by three overlapping calderas, the largest of which is 8 km wide and may have been produced primarily from subglacial ring-fracture eruptions rather than by subsidence.  A major rhyolitic explosive eruption from Dyngjufjll about 10,000 years ago was in part associated with the formation of Askja caldera.  Many postglacial eruptions also occurred along the ring-fracture.  A major explosive eruption on the SE caldera margin in 1875 was one of Iceland's largest during historical time.  It resulted in the formation of a smaller 4.5-km-wide caldera, now filled by skjuvatn lake, that truncates the rim of the larger central caldera.  The 100-km-long Askja fissure swarm, which includes the Sveinagja graben, is also related to the Askja volcanic system, as are several small shield volcanoes such as Kollatadyngja.  Twentieth-century eruptions at Askja have produced lava flows from vents located mostly near skjuvatn lake.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1703-06=&amp;volpage=photos&amp;photo=060001">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1703-06=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.earthice.hi.is/page/ies_volcanoes">Inst of Earth Sciences, Univ of Iceland</a></td></tr></table>	(65.030000000000001,-16.75)
1244	Fremrinamur	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Fremrinamur</b></font><br /><font size="5"><b>Northeastern Iceland</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/051080.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 939 m<br /><b>Latitude:</b> 65.43&deg;N<br /><b>Longitude:</b> 16.65&deg;W</td></tr><tr><td colspan="2"><p align="justify">Fremrinamur central volcano, NNE of Askja and SE of Myvatn lake, is a volcanic system that is being constructed over the basaltic Ketildyngja shield volcano.  Associated fissure systems, including the Sveinar fissure, extend 130 km to the northern coast of Iceland.  The Kerlingardyngja shield volcano to the south is also part of the Fremrinamur volcanic system.  Iceland's renowned Myvatn lake formed as a result of the eruption of the massive 70-km-long older Laxarhraun lava flow from Ketildyngja shield volcano about 3800 years ago.  The latest eruption from Fremrinamur produced the Burfellshraun lava flow about 2500-3000 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1703-07=&amp;volpage=photos&amp;photo=051080">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1703-07=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.earthice.hi.is/page/ies_volcanoes">Inst of Earth Sciences, Univ of Iceland</a></td></tr></table>	(65.430000000000007,-16.649999999999999)
1245	Krafla	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Krafla</b></font><br /><font size="5"><b>Northeastern Iceland</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/060038.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Fissure vents<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 818 m<br /><b>Latitude:</b> 65.73&deg;N<br /><b>Longitude:</b> 16.78&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Krafla central volcano, located NE of Myvatn lake, is a topographically indistinct 10-km-wide caldera that is cut by a N-S-trending fissure system.  Eruption of a rhyolitic welded tuff about 100,000 years ago was associated with formation of the caldera.  Krafla has been the source of many rifting and eruptive events during the Holocene, including two in historical time, during 1724-29 and 1975-84.  The prominent Hverfjall and Ludent tuff rings east of Myvatn were erupted along the 100-km-long fissure system, which extends as far as the north coast of Iceland.  Iceland's renowned Myvatn lake formed during the eruption of the older Laxarhraun lava flow from the Ketildyngja shield volcano of the Fremrinamur volcanic system about 3800 years before present (BP); its present shape is constrained by the roughly 2000 years BP younger Laxarhraun lava flow from the Krafla volcanic system.  The abundant pseudocraters that form a prominent part of the Myvatn landscape were created when the younger Laxarhraun lava flow entered the lake.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1703-08=&amp;volpage=photos&amp;photo=060038">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1703-08=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.earthice.hi.is/page/ies_volcanoes">Inst of Earth Sciences, Univ of Iceland</a></td></tr></table>	(65.730000000000004,-16.780000000000001)
1246	Theistareykjarbunga	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Theistareykjarbunga</b></font><br /><font size="5"><b>Northeastern Iceland</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/060007.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 564 m<br /><b>Latitude:</b> 65.88&deg;N<br /><b>Longitude:</b> 16.83&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Holocene Theistareykjarbunga basaltic shield volcano (also known as Theistareykir) and its associated N-S fissure system extends from north of Myvatn lake to the northern coast of Iceland.  The low, 564-m-high Theistareykjarbunga shield volcano is the northernmost subaerial volcanic system along the eastern volcanic zone of Iceland.  The Theistareykjarbunga segment is dominated by the 30 cu km Storaviti shield volcano, which was formed slightly after deglaciation.  The youngest dated eruption produced the Theistareykjahraun lava flow about 3000-2700 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1703-09=&amp;volpage=photos&amp;photo=060007">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1703-09=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.earthice.hi.is/page/ies_volcanoes">Inst of Earth Sciences, Univ of Iceland</a></td></tr></table>	(65.879999999999995,-16.829999999999998)
1247	Tjrnes Fracture Zone	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tjrnes Fracture Zone</b></font><br /><font size="5"><b>North of Iceland</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Latitude:</b> 66.30&deg;N<br /><b>Longitude:</b> 17.10&deg;W</td></tr><tr><td colspan="2"><p align="justify">The offshore Tjrnes Fracture Zone is an oblique transform zone that separates the northern volcanic zone of Iceland from the Kolbeinsey Ridge, part of the Mid-Atlantic Ridge north of Iceland.   A submarine eruption was reported during 1867-1868 at the SE part of the fissure system off the northern coast of Iceland along the Manareyjar Ridge immediately north of Manareyjar Island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1703-10=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.earthice.hi.is/page/ies_volcanoes">Inst of Earth Sciences, Univ of Iceland</a></td></tr></table>	(66.299999999999997,-17.100000000000001)
1248	raefajkull	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>raefajkull</b></font><br /><font size="5"><b>Southeastern Iceland</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/075041.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Subglacial volcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2119 m<br /><b>Latitude:</b> 64.00&deg;N<br /><b>Longitude:</b> 16.65&deg;W</td></tr><tr><td colspan="2"><p align="justify">raefajkull, Iceland's highest peak, is a broad glacier-clad central volcano at the SE end of the Vatnajkull icecap.  A 4 x 5 km subglacial caldera truncates the summit of the dominantly basaltic and rhyolitic volcano.  The extensive summit icecap is drained through deep glacial valleys dissecting the SW-to-SE flanks of the volcano.  The largest-volume volcano in Iceland, 2119-m-high raefajkull was mostly constructed during Pleistocene glacial and interglacial periods.  Holocene activity has been dominated by explosive summit eruptions, although flank lava effusions have also occurred.  A major silicic eruption in 1362 AD was Iceland's largest historical explosive eruption.  It and another eruption during 1727-28 were accompanied by major jkulhlaups (glacier outburst floods) that caused property damage and fatalities.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1704-01=&amp;volpage=photos&amp;photo=075041">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1704-01=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.earthice.hi.is/page/ies_volcanoes">Inst of Earth Sciences, Univ of Iceland</a></td></tr></table>	(64,-16.649999999999999)
1249	Kolbeinsey Ridge	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Kolbeinsey Ridge</b></font><br /><font size="5"><b>North of Iceland</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 5 m<br /><b>Latitude:</b> 66.67&deg;N<br /><b>Longitude:</b> 18.50&deg;W</td></tr><tr><td colspan="2"><p align="justify">A submarine eruption was reported in 1372 near the Kolbeinsey Ridge NW of Grimsey Island.  Kolbeinsey Island, the only subaerial expression of this portion of the Mid-Atlantic Ridge, is a small, rapidly eroding island that formed during the late-Pleistocene or Holocene.  Dredged glass shards indicate submarine eruptive activity during the late-Pleistocene until at least 11,800 radiocarbon years ago.  The island was 700 m long in 1616 AD, but had shrunk to 42 m long and 5 m high by 1985 and could be eroded below sea level in the early part of the 21st century.  The Kolbeinsey Hydrothermal Field lies south of the island.  Thorarinsson (1965) roughly plotted the location of the 1372 eruption at about 66 degrees 40 minutes North.  Reidel et al. (2003) note that the location is uncertain, but could lie between the Kolbeinsey Ridge and Hll Seamount.  Other reports of submarine eruptions north of Iceland have an even more uncertain location (1755) or have been discredited (1783 and 1838).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1705-01=">Smithsonian Volcano Information</a></td></tr></table>	(66.670000000000002,-18.5)
1250	Jan Mayen	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Jan Mayen</b></font><br /><font size="5"><b>Jan Mayen Island (Northern Atlantic)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119090.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2277 m<br /><b>Latitude:</b> 71.08&deg;N<br /><b>Longitude:</b> 8.17&deg;W</td></tr><tr><td colspan="2"><p align="justify">Remote Jan Mayen Island, located in the Norwegian Sea along the Mid-Atlantic Ridge about 650 km NE of Iceland, consists of two volcanic complexes separated by a narrow isthmus.  The large Beerenberg basaltic stratovolcano (Nord-Jan) forms the NE end of the 40-km-long island, which is ringed by high cliffs.  Beerenberg is a large 2277-m-high glacier-covered stratovolcano with a 1-km-wide summit crater and numerous cinder cones that were erupted along flank fissures.  It is composed primarily of basaltic lava flows with minor amounts of tephra.  Historical eruptions at Beerenberg date back to the 18th century.   The Sor-Jan group of pyroclastic cones and lava domes occupies the SW tip of Jan Mayen. The Holocene Sor-Jan cinder cones, tephra rings, and trachytic lava domes were erupted from short fissures with a NE-SW trend.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1706-01=&amp;volpage=photos&amp;photo=119090">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1706-01=">Smithsonian Volcano Information</a></td></tr></table>	(71.079999999999998,-8.1699999999999999)
1251	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>East Gakkel Ridge</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -3800 m<br /><b>Latitude:</b> 85.58&deg;N<br /><b>Longitude:</b> 85.00&deg;E</td></tr><tr><td colspan="2"><p align="justify">Two young volcanoes were discovered along the eastern part of the slow-spreading Gakkel Ridge during a bathymetric survey from a submarine in 1999.  The westernmost volcano showed evidence of highly reflective, sediment-free surfaces and young faults overprinted by lava flows.  During January-September 1999 global seismic networks detected an earthquake swarm corresponding to the approximate location of this volcano.  The correlation between the locations of the earthquake epicenter locations and the strongly reflective, untectonized western volcano together with the volcanic character of the seismic record provided evidence that lava erupted on the East Gakkel Ridge within days to months prior to a May 1999 submarine survey (Edwards et al., 2001).  Because 12-kHz sonars can penetrate through thin sediments covering acoustically reflective lavas, it is possible that no eruption occurred on Gakkel Ridge in 1999.  Historical global seismic records indicate that this was the only earthquake swarm detected on the Gakkel Ridge in about 100 years.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1707-02-">Smithsonian Volcano Information</a></td></tr></table>	(85.579999999999998,85)
1252	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>Northern Atlantic Ocean</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -1650 m<br /><b>Latitude:</b> 49.00&deg;N<br /><b>Longitude:</b> 34.50&deg;W</td></tr><tr><td colspan="2"><p align="justify">A ship captain reported that on December 29, 1884, during calm conditions, the sea surface suddenly became boiling and seething over an area of 8 x 10 km.  It was considered that this event may have originated from a volcanic eruption because of the proximity of a large seamount that rises to within 1650 m of the surface (Catalog of Active Volcanoes of the World).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1801-02=">Smithsonian Volcano Information</a></td></tr></table>	(49,-34.5)
1253	Unnamed	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Unnamed</b></font><br /><font size="5"><b>Northern Atlantic Ocean</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -4200 m<br /><b>Latitude:</b> 38.75&deg;N<br /><b>Longitude:</b> 38.08&deg;W</td></tr><tr><td colspan="2"><p align="justify">On July 9, 1865, the crew of a whaling ship observed a submarine eruption.  Floating pumice reached the sea surface, where it formed a large &quot;floating mountain.&quot;  A strong odor of sulfur was noticed, and dull rumblings were heard at intervals of one hour.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1801-04=">Smithsonian Volcano Information</a></td></tr></table>	(38.75,-38.079999999999998)
1254	Flores	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Flores</b></font><br /><font size="5"><b>Azores and Madeira (Portugal)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120001.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 914 m<br /><b>Latitude:</b> 39.462&deg;N<br /><b>Longitude:</b> 31.216&deg;W</td></tr><tr><td colspan="2"><p align="justify">Flores Island and Corvo Island to its north are located far west of the rest of the Azores islands and are the only two Azorean volcanoes lying west of the Mid-Atlantic Ridge.  Growth of an initially submarine volcano included Pleistocene explosive activity associated with formation of small calderas.  The 10 x 15 km island of Flores is dotted by numerous pyroclastic cones and craters.  Following a long period of quiescence beginning about 200,000 years ago, several young phreatomagmatic craters and associated lava flows were erupted during the Holocene, including two about 3000 years ago.  The Caldeira Funda de Lajes tuff ring formed about 3150 years ago, accompanied by a lava flow that traveled to the SE, reaching the coast at Lajes.  The Caldeira Comprida tuff ring in Caldeira Seca, west-central Flores, erupted about 2900 years ago.  It produced a lava flow that traveled NW-ward and reached the coast at Faja Grande.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1802-001&amp;volpage=photos&amp;photo=120001">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1802-001">Smithsonian Volcano Information</a></td></tr></table>	(39.462000000000003,-31.216000000000001)
1255	Corvo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Corvo</b></font><br /><font size="5"><b>Azores and Madeira (Portugal)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120005.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 718 m<br /><b>Latitude:</b> 39.699&deg;N<br /><b>Longitude:</b> 31.111&deg;W</td></tr><tr><td colspan="2"><p align="justify">The small 3.5 x 6 km island of Corvo is located at the NW end of the Azores archipelago.  Corvo and its neighbor to the south, Flores, are the only two Azorean volcanoes located west of the Mid-Atlantic Ridge.  A 2-km-wide caldera centered on the north side of the island is the most prominent feature of Corvo.  The caldera floor contains several small cinder cones and two shallow lakes.  Two southward-breached pyroclastic cones erupted along a N-S-trending fissure and fed lava flows that formed a platform that underlies the village of Corvo at the southern end of the island.  The youngest eruption on Corvo produced a fissure-fed lava flow that reached the sea near Punta Negra.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1802-002&amp;volpage=photos&amp;photo=120005">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1802-002">Smithsonian Volcano Information</a></td></tr></table>	(39.698999999999998,-31.111000000000001)
1256	Fayal	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Fayal</b></font><br /><font size="5"><b>Azores and Madeira (Portugal)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/061004.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1043 m<br /><b>Latitude:</b> 38.60&deg;N<br /><b>Longitude:</b> 28.73&deg;W</td></tr><tr><td colspan="2"><p align="justify">The island of Fayal, also spelled Faial, is the nearest of the central Azorean islands to the Mid-Atlantic Ridge.  The island is composed of a complex large andesitic-to-trachytic stratovolcano that contains a 2-km-wide summit caldera.  Thick deposits of trachytic airfall pumice, pyroclastic flows, and lahars related to formation of the caldera blanket the island.  Formation of the steep-walled 500-m-deep caldera was followed by construction of fissure-fed basaltic lava fields and small volcanoes that form a peninsula extending to the west.  This area is covered by the youngest volcanic products on the island and has been the source of all historical eruptions.  A dramatic submarine eruption at Capelinhos during 1957-58, the best-studied of historical eruptions in the Azores, created a new island that soon merged with the western peninsula.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1802-01=&amp;volpage=photos&amp;photo=061004">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1802-01=">Smithsonian Volcano Information</a></td></tr></table>	(38.600000000000001,-28.73)
1257	Pico	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Pico</b></font><br /><font size="5"><b>Azores and Madeira (Portugal)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/061002.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Fissure vent<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2351 m<br /><b>Latitude:</b> 38.47&deg;N<br /><b>Longitude:</b> 28.40&deg;W</td></tr><tr><td colspan="2"><p align="justify">A prominent 2351-m-high stratovolcano occupying the western end of Pico Island is the highest volcano in the Azores.  Pico volcano lies west of on an older linear volcano with numerous flank cones that forms most of the 48-km-long island.  The conical, dominantly basaltic Pico volcano was constructed over the Montanha volcanic complex on the eastern side of the island and is capped by a 500-m-wide summit crater that is overtopped by a small steep-sided cone.  Historical eruptions have been restricted to the flanks of Pico volcano and to the SE-trending rift zone, the Sao Roque Piedade volcanic complex, which is dotted by pyroclastic cones.  An eruption during 1562-64 from the SE rift zone produced lava flows that reached the northern coast.  An eruption from a nearby vent issued lava flows that traveled into the sea on the southern side of the island.  A flank eruption from Pico in 1718 fed lava flows that reached both coasts.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1802-02=&amp;volpage=photos&amp;photo=061002">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1802-02=">Smithsonian Volcano Information</a></td></tr></table>	(38.469999999999999,-28.399999999999999)
1258	San Jorge	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>San Jorge</b></font><br /><font size="5"><b>Azores and Madeira (Portugal)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120004.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Fissure vent</td><td width="50%" align="left"><b>Summit Elev:</b> 1053 m<br /><b>Latitude:</b> 38.65&deg;N<br /><b>Longitude:</b> 28.08&deg;W</td></tr><tr><td colspan="2"><p align="justify">The remarkably linear island of San Jorge (Sao Jorge) is 54 km long and only 5 km wide.  It was formed by fissure-fed eruptions beginning in the eastern part of the island.  The western two-thirds of dominantly basaltic San Jorge contains youthful, fissure-fed lava flows resembling those on neighboring Pico Island.  Subaerial lava flows issued from three locations above the south-central coast during 1580, producing lava flows that reached the sea.  In 1808 a series of explosions took place from vents along the south-central crest of the island; one of these fed a lava flow that also reached the southern coast.  Submarine eruptions were reported on several occasions from vents off the southern and SW coasts.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1802-03=&amp;volpage=photos&amp;photo=120004">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1802-03=">Smithsonian Volcano Information</a></td></tr></table>	(38.649999999999999,-28.079999999999998)
1259	Graciosa	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Graciosa</b></font><br /><font size="5"><b>Azores and Madeira (Portugal)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120002.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Scoria cones</td><td width="50%" align="left"><b>Summit Elev:</b> 402 m<br /><b>Latitude:</b> 39.02&deg;N<br /><b>Longitude:</b> 27.97&deg;W</td></tr><tr><td colspan="2"><p align="justify">The SE end of Graciosa, the northernmost of the central Azorean islands, contains a small 0.9 x 1.6 km caldera with active fumaroles.  The 402-m-high SE caldera rim is the high point of the small 4 x 8 km island.  The caldera has been the source of eruptions producing significant tephra falls, pyroclastic flows, lahars, and lava flows.  An important fumarole field is located in a volcanic cave inside the caldera, and a submarine fumarole occurs off the NW coast of Graciosa.  Scoria cones erupted along several widely spaced NE-SW-trending fissures fed a youthful lava field that forms the NW end of the island.  The most recent eruption from Pico Tomao, NW of the caldera, produced a lava flow that reached the eastern coast NW of  the village of Praia.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1802-04=&amp;volpage=photos&amp;photo=120002">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1802-04=">Smithsonian Volcano Information</a></td></tr></table>	(39.020000000000003,-27.969999999999999)
1260	Terceira	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Terceira</b></font><br /><font size="5"><b>Azores and Madeira (Portugal)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/120003.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 1023 m<br /><b>Latitude:</b> 38.73&deg;N<br /><b>Longitude:</b> 27.32&deg;W</td></tr><tr><td colspan="2"><p align="justify">Terceira Island contains four stratovolcanoes constructed along a prominent ESE-WNW-trending fissure zone that cuts across the island.  Historically active Santa Barbara volcano at the western end of the island is truncated by two calderas.  The youngest of these formed about 15,000 years ago.  Comenditic lava domes fill and surround the caldera.  Pico Alto lies north of the fissure zone in the north-central part of the island and contains a Pleistocene caldera largely filled by lava domes and lava flows.  Guilherme Moniz caldera lies along the fissure zone immediately to the south, and 7-km-wide Cinquio Picos caldera at the SE end of the island is the largest in the Azores.  Historical eruptions have occurred from Pico Alto, the fissure zone between Pico Alto and Santa Barbara, and from submarine vents west of Santa Barbara.  Most Holocene eruptions have produced basaltic-to-rhyolitic lava flows from the fissure zone transecting the island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1802-05=&amp;volpage=photos&amp;photo=120003">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1802-05=">Smithsonian Volcano Information</a></td></tr></table>	(38.729999999999997,-27.32)
1261	Don Joao de Castro Bank	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Don Joao de Castro Bank</b></font><br /><font size="5"><b>Azores and Madeira (Portugal)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111006.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -13 m<br /><b>Latitude:</b> 38.23&deg;N<br /><b>Longitude:</b> 26.63&deg;W</td></tr><tr><td colspan="2"><p align="justify">Don Joao de Castro Bank is a large submarine volcano that rises to within 13 m of the sea surface roughly halfway between Terceira and San Miguel Islands.  Pillow lavas form the base of the volcano, which is capped by basaltic hyaloclastites.  A submarine eruption during December 1720 produced an ephemeral island that attained a length of 1.5 km and an altitude of about 250 m before it was eroded beneath the sea surface two years later.  The volcano (also spelled Dom Joao de Castro) was named after the Portuguese hydrographic survey vessel that surveyed the bank in 1941.  Two youthful parasitic craters, one tephra covered and the other sediment free, are located on the NW flank.  The submarine volcano has an impressive shallow fumarole field and remains seismically active.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1802-07=&amp;volpage=photos&amp;photo=111006">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1802-07=">Smithsonian Volcano Information</a></td></tr></table>	(38.229999999999997,-26.629999999999999)
1262	Sete Cidades	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sete Cidades</b></font><br /><font size="5"><b>Azores and Madeira (Portugal)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/112087.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 856 m<br /><b>Latitude:</b> 37.87&deg;N<br /><b>Longitude:</b> 25.78&deg;W</td></tr><tr><td colspan="2"><p align="justify">Sete Cidades volcano at the western end of Sao Miguel Island contains a 5-km-wide summit caldera, occupied by two caldera lakes, that is one of the scenic highlights of the Azores.  The steep-walled, 500-m-deep caldera was formed about 22,000 years ago, and at least 22 post-caldera eruptions have occurred.  A large group of Pleistocene post-caldera trachytic lava domes, lava flows, and pyroclastic-flow deposits is found on the western-to-northern flanks.  A nearly circular ring of six Holocene pyroclastic cones occupies the caldera floor.  These have been the source of a dozen trachytic pumice-fall deposits erupted during the past 5000 years.  Sete Cidades is one of the most active Azorean volcanoes.  Historical eruptions date back to the 15th century and have occurred from within the caldera and from submarine vents off the west coast.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1802-08=&amp;volpage=photos&amp;photo=112087">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1802-08=">Smithsonian Volcano Information</a></td></tr></table>	(37.869999999999997,-25.780000000000001)
1263	Picos Volcanic System	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Picos Volcanic System</b></font><br /><font size="5"><b>Azores and Madeira (Portugal)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/101040.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 350 m<br /><b>Latitude:</b> 37.78&deg;N<br /><b>Longitude:</b> 25.67&deg;W</td></tr><tr><td colspan="2"><p align="justify">Nearly 200 scoria cones of the Picos volcanic system dot the &quot;waist&quot; of Sao Miguel Island between Sete Cidades and Agua de Pau volcanoes.  This monogenetic fissure-controlled, dominantly basaltic volcanism, much of which post-dates the roughly 5000-year-old Fogo eruption, cannot be assigned to either volcano and appears related to en-echelon fissures overlying a fracture zone.  Thick pumice deposits thought to originate from the Picos volcanic system may have originated from vents or a caldera destroyed and now buried by young basaltic volcanism.  The most noteworthy of the young vents is 485-m-high Serra Gorda, SE of Siete Cidades, and the cone that produced a lava delta south of Agua de Paul village.  The majority of the inhabitants of Sao Miguel Island occupy both coasts below this volcanic zone.  At least 18 eruptions have occurred during the past 2800 years, although the only historical eruption occurred in 1652.  The most recent activity has been basaltic, however two more-explosive trachytic eruptions occurred during the past 1100 years.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1802-081&amp;volpage=photos&amp;photo=101040">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1802-081">Smithsonian Volcano Information</a></td></tr></table>	(37.780000000000001,-25.670000000000002)
1264	Agua de Pau	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Agua de Pau</b></font><br /><font size="5"><b>Azores and Madeira (Portugal)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/061010.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 947 m<br /><b>Latitude:</b> 37.77&deg;N<br /><b>Longitude:</b> 25.47&deg;W</td></tr><tr><td colspan="2"><p align="justify">Agua de Pau stratovolcano in central Sao Miguel Island contains an outer 4 x 7 km caldera formed about 30,000 to 45,000 years ago and an inner 2.5 x 3 km caldera that was created about 15,000 years ago.  The younger caldera is partially filled by the Lagoa do Fogo caldera lake.  Several post-caldera lava domes were emplaced on the northern and western flanks of the volcano, but activity in the caldera did not resume until about 5000 years ago.  The 3-cu-km Fogo-A plinian pumice-fall deposit, the product of the largest-known Holocene eruption in the Azores, was emplaced at this time.  Numerous flank cinder cones mark radial and concentric fissures, some of which have been active during historical time.  The latest trachytic explosive eruption took place during 1563.  Prominent hot springs are located on the NW flank.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1802-09=&amp;volpage=photos&amp;photo=061010">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1802-09=">Smithsonian Volcano Information</a></td></tr></table>	(37.770000000000003,-25.469999999999999)
1265	Furnas	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Furnas</b></font><br /><font size="5"><b>Azores and Madeira (Portugal)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/062027.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 805 m<br /><b>Latitude:</b> 37.77&deg;N<br /><b>Longitude:</b> 25.32&deg;W</td></tr><tr><td colspan="2"><p align="justify">Furnas volcano lies at the eastern end of Sao Miguel Island, immediately west of the older Nordeste shield volcano and its Povoaao caldera.  Furnas contains at least two calderas, a younger one that is 6-km wide and a larger older one that is less topographically distinct.  The eastern wall of the 500-m-deep caldera of Furnas overlaps the western wall of the Povoaao caldera of Nordeste volcano.  Volcanic activity at Furnas dates back about 100,000 years.  At least 11 trachytic pumice layers, all erupted during the past 5000 years, post-date the caldera.  The most prominent post-caldera feature is the Pico do Gaspar lava dome, east of the Lagoa das Furnas caldera lake.  A zone of late-Pleistocene to Holocene basaltic-to-trachytic cinder cones and lava domes is located between Furnas and Agua de Pau volcanoes.  Two historical eruptions have occurred at Furnas, one sometime between 1439 and 1443 and the other in 1630.  The latter was one of the largest Holocene explosive eruptions in the Azores and caused significant damage and fatalities.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1802-10=&amp;volpage=photos&amp;photo=062027">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1802-10=">Smithsonian Volcano Information</a></td></tr></table>	(37.770000000000003,-25.32)
1266	Monaco Bank	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Monaco Bank</b></font><br /><font size="5"><b>Azores and Madeira (Portugal)</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -197 m<br /><b>Latitude:</b> 37.60&deg;N<br /><b>Longitude:</b> 25.88&deg;W</td></tr><tr><td colspan="2"><p align="justify">Monaco Bank is a submarine volcano constructed along a NW-SE-trending fissure 20-km south of the western tip of Sao Miguel Island.  The linear volcano is located along regional tectonic trends connecting Sete Cidades volcano with Santa Mara Island, SE of Monaco Bank.  The summit of the volcano rises to within 197 m of the sea surface.  Submarine eruptions took place during 1907, when a submarine cable was ruptured, and 1911.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1802-11=">Smithsonian Volcano Information</a></td></tr></table>	(37.600000000000001,-25.879999999999999)
1267	Madeira	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Madeira</b></font><br /><font size="5"><b>Madeira</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117035.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Scoria cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1862 m<br /><b>Latitude:</b> 32.73&deg;N<br /><b>Longitude:</b> 16.97&deg;W</td></tr><tr><td colspan="2"><p align="justify">Madeira Island is the emergent top of a massive shield volcano that rises about 6 km from the floor of the Atlantic Ocean and forms the largest island of the Madeira Archipelago, about 90 km in length.  Construction of the volcano along E-W-trending rift zones from the Miocene to about 700,000 years ago was followed by a period of extensive erosion and possible edifice collapse.  Two steep-walled amphitheaters open to south in the central part of the island.  Late-stage eruptions are scattered throughout the island and lasted until the Holocene, producing scoria cones and intracanyon lava flows mantling rocks of the older eroded edifice.  The youngest activity at Madeira lies in the west-central part of the island, and consists of cinder cones in the upper Sao Vicente valley, a series of intracanyon flows, and a tephra layer on top of the Paul da Serra plateau dated at about 6500 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1802-12-&amp;volpage=photos&amp;photo=117035">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1802-12-">Smithsonian Volcano Information</a></td></tr></table>	(32.729999999999997,-16.969999999999999)
1268	La Palma	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>La Palma</b></font><br /><font size="5"><b>Canary Islands (Spain)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/087052.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Fissure vents</td><td width="50%" align="left"><b>Summit Elev:</b> 2426 m<br /><b>Latitude:</b> 28.57&deg;N<br /><b>Longitude:</b> 17.83&deg;W</td></tr><tr><td colspan="2"><p align="justify">The 47-km-long wedge-shaped island of La Palma, the NW-most of the Canary Islands, is composed of two large volcanic centers.  The older 2426-m-high northern one is cut by the massive steep-walled Caldera Taburiente, one of several massive collapse scarps produced by edifice failure to the SW.  The younger 1949-m-high Cumbre Vieja, the southern volcano, is one of the most active in the Canaries.  The elongated volcano dates back to about 125,000 years ago and is oriented N-S.  Eruptions during the past 7000 years have originated from the abundant cinder cones and craters along the axis of Cumbre Vieja, producing fissure-fed lava flows that descend steeply to the sea.  Historical eruptions at La Palma, recorded since the 15th century, have produced mild explosive activity and lava flows that damaged populated areas.  The southern tip of the island is mantled by a broad lava field produced during the 1677-1678 eruption.  Lava flows also reached the sea in 1585, 1646, 1712, 1949, and 1971.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1803-01-&amp;volpage=photos&amp;photo=087052">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1803-01-">Smithsonian Volcano Information</a></td></tr></table>	(28.57,-17.829999999999998)
1269	Hierro	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hierro</b></font><br /><font size="5"><b>Canary Islands (Spain)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/087055.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Tuff rings</td><td width="50%" align="left"><b>Summit Elev:</b> 1500 m<br /><b>Latitude:</b> 27.73&deg;N<br /><b>Longitude:</b> 18.03&deg;W</td></tr><tr><td colspan="2"><p align="justify">The triangular island of Hierro is the SW-most and least studied of the Canary Islands.  The massive Hierro shield volcano is truncated by a large NW-facing escarpment formed as a result of gravitational collapse of El Golfo volcano about 130,000 years ago.  The steep-sided 1500-m-high scarp towers above a low lava platform bordering 12-km-wide El Golfo Bay, and three other large submarine landslide deposits occur to the SW and SE.  Three prominent rifts oriented NW, NE, and south at 120 degree angles form prominent topographic ridges.  The subaerial portion of the volcano consists of flat-lying Quaternary basaltic and trachybasaltic lava flows and tuffs capped by numerous young cinder cones and lava flows.  Holocene cones and flows are found both on the outer flanks and in the El Golfo depression.  Hierro contains the greatest concentration of young vents in the Canary Islands.  Uncertainty surrounds the report of an historical eruption in 1793.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1803-02-&amp;volpage=photos&amp;photo=087055">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1803-02-">Smithsonian Volcano Information</a></td></tr></table>	(27.73,-18.030000000000001)
1270	Tenerife	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tenerife</b></font><br /><font size="5"><b>Canary Islands (Spain)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/088097.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3715 m<br /><b>Latitude:</b> 28.271&deg;N<br /><b>Longitude:</b> 16.641&deg;W</td></tr><tr><td colspan="2"><p align="justify">The large triangular island of Tenerife is composed of a complex of overlapping Miocene-to-Quaternary stratovolcanoes that have remained active into historical time.  The NE-trending Cordillera Dorsal volcanic massif joins the Las Caadas volcano on the SW side of Tenerife with older volcanoes, creating the largest volcanic complex of the Canary Islands.  Controversy surrounds the formation of the dramatic 10 x 17 km Las Caadas caldera, which is partially filled by 3715-m-high Teide stratovolcano, the highest peak in the Atlantic Ocean.  The origin of the caldera has been variably considered to be due to collapse following multiple major explosive eruptions or as a result of a massive landslide (in a manner similar to the earlier formation of the massive La Orotava and Guimar valleys), or a combination of the two processes.  The most recent stage of activity beginning in the late Pleistocene included the construction of the Pico Viejo and Teide edifices.  Tenerife was perhaps observed in eruption by Christopher Columbus, and several flank vents on the Canary Island's most active volcano have been active during historical time.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1803-03-&amp;volpage=photos&amp;photo=088097">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1803-03-">Smithsonian Volcano Information</a></td></tr></table>	(28.271000000000001,-16.640999999999998)
1271	Gran Canaria	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Gran Canaria</b></font><br /><font size="5"><b>Canary Islands (Spain)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/088098.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Fissure vents<br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 1950 m<br /><b>Latitude:</b> 28.00&deg;N<br /><b>Longitude:</b> 15.58&deg;W</td></tr><tr><td colspan="2"><p align="justify">The largely Miocene-to-Pliocene island of Gran Canaria in the middle of the Canary archipelago has been strongly eroded into steep-walled radial gorges called barrancos.  Three major volcanic structures form the circular 60-km-wide island, which has been modified by caldera collapse, gravitational edifice failure, and extensive erosion.  Middle Quaternary scoria cones and lava flows are found in the northern and eastern parts of the massive shield volcano, which is cut by a major NW-SE-trending rift zone that extends across the island and fed flows primarily to the NE.  Very young basaltic cones and lava flows of Holocene age are situated within a NW-trending zone from Berrazales to Bandama and at Las Isletas, a peninsula on the NE coast.  One cinder cone was radiocarbon dated at about 3000 years before present, and other cones and flows may be less than 1000 years old.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1803-04-&amp;volpage=photos&amp;photo=088098">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1803-04-">Smithsonian Volcano Information</a></td></tr></table>	(28,-15.58)
1272	Fuerteventura	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Fuerteventura</b></font><br /><font size="5"><b>Canary Islands (Spain)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104016.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Fissure vents<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 529 m<br /><b>Latitude:</b> 28.358&deg;N<br /><b>Longitude:</b> 14.02&deg;W</td></tr><tr><td colspan="2"><p align="justify">Pleistocene and Holocene cinder cones and lava flows cover large portions of elongated Fuerteventura Island at the SE end of the Canary Islands.  The youngest lavas are found at the northern and central portions of the arid, sparsely vegetated island.  Malpais de la Arena, the Northern Malpais, and the Lobos Island areas at the northern tip of Fuerteventura are the sites of broad fields of youthful cinder cones and lava flows.  The Malpais Chico, Malpais Grande, and Malpais de Jacomar areas on the south-central part of the island represent smaller zones of youthful volcanism, as do the volcanoes of Pajara, which were constructed on the older plutonic massif west of the axis of the island.  No historical eruptions have occurred on Fuerteventura.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1803-05-&amp;volpage=photos&amp;photo=104016">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1803-05-">Smithsonian Volcano Information</a></td></tr></table>	(28.358000000000001,-14.02)
1273	Lanzarote	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Lanzarote</b></font><br /><font size="5"><b>Canary Islands (Spain)</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/087038.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Fissure vents<br />&nbsp;&nbsp;&nbsp; Cinder cones</td><td width="50%" align="left"><b>Summit Elev:</b> 670 m<br /><b>Latitude:</b> 29.03&deg;N<br /><b>Longitude:</b> 13.63&deg;W</td></tr><tr><td colspan="2"><p align="justify">The 60-km-long island of Lanzarote at the NE end of the Canary Islands contains the largest concentration of youthful volcanism in the Canaries.  Pleistocene-and-Holocene cinder cones and lava flows erupted along NE-SW-trending fissures are found throughout the low-altitude arid island and on smaller islands to the north.  The largest historical eruption of the Canary Islands took place during 1730-36, when long-term eruptions from a NE-SW-trending fissure formed the Montaas del Fuego and produced voluminous lava flows that covered about 200 sq km.  The lava flows reached the western coast along a broad, 20-km-wide front.  The villages of Maretas and Santa Catalina were destroyed, along with the most fertile valleys and estates of the arid island.  An eruption during 1824 produced a much smaller lava flow that reached the SW coast.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1803-06-&amp;volpage=photos&amp;photo=087038">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1803-06-">Smithsonian Volcano Information</a></td></tr></table>	(29.030000000000001,-13.630000000000001)
1274	Fogo	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Fogo</b></font><br /><font size="5"><b>Cape Verde Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/095016.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 2829 m<br /><b>Latitude:</b> 14.95&deg;N<br /><b>Longitude:</b> 24.35&deg;W</td></tr><tr><td colspan="2"><p align="justify">The island of Fogo consists of a single massive stratovolcano that is the most prominent of the Cape Verde Islands.  The roughly circular 25-km-wide island is truncated by a large 9-km-wide caldera that is breached to the east and has a headwall 1 km high.  The caldera is located asymmetrically NE of the center of the island and was formed as a result of massive lateral collapse of the ancestral Monte Armarelo edifice.  A very youthful steep-sided central cone, Pico, rises more than 1 km above the caldera floor to about 100 m above the caldera rim, forming the 2829 m high point of the island.  Pico, which is capped by a 500-m-wide, 150-m-deep summit crater, was apparently in almost continuous activity from the time of Portuguese settlement in 1500 AD until around 1760.  Later historical lava flows, some from vents on the caldera floor, reached the eastern coast below the breached caldera.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1804-01=&amp;volpage=photos&amp;photo=095016">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1804-01=">Smithsonian Volcano Information</a></td></tr></table>	(14.949999999999999,-24.350000000000001)
1275	Brava	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Brava</b></font><br /><font size="5"><b>Cape Verde Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104009.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 900 m<br /><b>Latitude:</b> 14.85&deg;N<br /><b>Longitude:</b> 24.72&deg;W</td></tr><tr><td colspan="2"><p align="justify">Brava Island, 20 km west of Fogo, is the westernmost of the southern Cape Verde islands.  The 10-km-wide island contains 15 morphologically youthful craters located along two or three lineaments intersecting along the crest of the island.  The youthfulness of the craters and numerous minor earthquakes in recent years indicate that a significant volcanic hazard still exists (Wolff and Turbeville, 1985).  Most of the younger eruptions originated from the interaction of phonolitic magmas with a large groundwater reservoir contained within an older volcanic series characterized by thick welded ignimbrites and block-and-ash flow deposits.  Carbonatitic lavas are also found on Brava.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1804-02-&amp;volpage=photos&amp;photo=104009">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1804-02-">Smithsonian Volcano Information</a></td></tr></table>	(14.85,-24.719999999999999)
1276	Sao Vicente	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Sao Vicente</b></font><br /><font size="5"><b>Cape Verde Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/104044.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 725 m<br /><b>Latitude:</b> 16.85&deg;N<br /><b>Longitude:</b> 24.97&deg;W</td></tr><tr><td colspan="2"><p align="justify">The 15 x 25 km island of Sao Vicente contains mafic Holocene lavas covering prominent peninsulas on the eastern and NE sides (Mitchell-Thome, 1976).  The island has an irregular shoreline.  The largest indentation is formed by a caldera on the NW coast that is breached by the sea and forms the setting for the port of Mindelo, the island's largest village.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1804-03-&amp;volpage=photos&amp;photo=104044">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1804-03-">Smithsonian Volcano Information</a></td></tr></table>	(16.850000000000001,-24.969999999999999)
1277	Ascensin	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Ascensin</b></font><br /><font size="5"><b>Central Atlantic Ocean</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/111099.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Cinder cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 858 m<br /><b>Latitude:</b> 7.95&deg;S<br /><b>Longitude:</b> 14.37&deg;W</td></tr><tr><td colspan="2"><p align="justify">Ascensin Island, located just west of the Mid-Atlantic Ridge, was discovered on Ascensin Day, 1501, by the Portuguese navigator Joao da Nova.  Ascensin is the broad emergent summit of a massive stratovolcano that rises 3000 m above the sea floor.  The isolated island, 1130 km from the nearest land, is dotted with more than 100 youthful parasitic cones and lava domes, many aligned along two fissures.  Basaltic rocks dominate on the 858-m-high island, although trachytic lava domes are also present, mostly on the eastern side.   Although no eruptive activity has occurred since its discovery during the 16th century, many volcanic features on Ascensin have a very youthful appearance.  Two of the youngest lava flows were erupted from flank vents and reached the sea on the northern and southern coasts.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1805-05-&amp;volpage=photos&amp;photo=111099">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1805-05-">Smithsonian Volcano Information</a></td></tr></table>	(-7.9500000000000002,-14.369999999999999)
1278	Trindade	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Trindade</b></font><br /><font size="5"><b>Central Atlantic Ocean</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119030.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 600+ m<br /><b>Latitude:</b> 20.514&deg;S<br /><b>Longitude:</b> 29.331&deg;W</td></tr><tr><td colspan="2"><p align="justify">The small island of Trindade lies at the eastern end of an E-W-trending chain of submarine volcanoes and guyots extending about 1100 km from the continental shelf off the Brazilian coast.  The island lies more than halfway between Brazil and the Mid-Atlantic Ridge near the eastern end of the submarine Vitria-Trindade Ridge.  Trindade is a dissected volcanic island with numerous phonolitic lava domes and steep-sided volcanic plugs. The youngest volcanism, at Vulcao de Paredao on the SE tip of the island, constructed a pyroclastic cone with lava flows that are no older than Holocene (Almeida, 1961).   Remnants of the crater of the 200-m-high cinder cone are still preserved.  Lava flows traveled from the cone to the north, where they form an irregular shoreline and offshore islands.  Smaller volcanic centers of the latest volcanic stage are found in the Morro Vermelho area in the south-central part of the island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1805-051&amp;volpage=photos&amp;photo=119030">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1805-051">Smithsonian Volcano Information</a></td></tr></table>	(-20.513999999999999,-29.331)
1279	Tristan da Cunha	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Tristan da Cunha</b></font><br /><font size="5"><b>Southern Atlantic Ocean</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/112075.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2060 m<br /><b>Latitude:</b> 37.092&deg;S<br /><b>Longitude:</b> 12.28&deg;W</td></tr><tr><td colspan="2"><p align="justify">Tristan da Cunha is a 13-km-wide island volcano lying about 500 km east of the crest of the Mid-Atlantic Ridge just south of the latitudes of Buenos Aires and Cape Town.  The 2060-m-high shield volcano is bounded on most sides by high cliffs.  Lava flows dominate both the low-angle base and the steep upper flanks, although pyroclastic cones ringing the central cone are scattered around the lower flanks.  Eruptions have occurred from the 300-m-wide summit crater, Queen Mary's Peak, which contains a small lake, and from numerous flank vents, some of which occurred from radial fissures.  Radial dike swarms are prominently exposed on all sides of the island.  Numerous strombolian cinder cones occur on the flanks of the volcano along both concentric ring structures and NNW- and ENE-trending radial fissures.  The only historical eruption on Tristan da Cunha occurred during 1961 from a northshore vent and forced the evacuation of the island's only settlement.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1806-01=&amp;volpage=photos&amp;photo=112075">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1806-01=">Smithsonian Volcano Information</a></td></tr></table>	(-37.091999999999999,-12.279999999999999)
1280	Nightingale Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Nightingale Island</b></font><br /><font size="5"><b>Southern Atlantic Ocean</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 365 m<br /><b>Latitude:</b> 37.42&deg;S<br /><b>Longitude:</b> 12.48&deg;W</td></tr><tr><td colspan="2"><p align="justify">Nightingale Island and the adjacent smaller Middle (or Alex) and Stoltenhoff Islands and associated small islets are the southernmost of the Tristan da Cunha island group.  The heavily eroded Nightingale Island consists of early and late stage ash and agglomerate units with intervening massive trachytic intrusions and lava flows.  Volcanic rocks were K-Ar dated at between 0.4 and 0.15 million years, and a radiocarbon date of about 39,000 yrs BP was obtained from an ash layer overlain by a lava flow.  An earthquake swarm lasting 6 hours beginning on July 29, 2004 was followed by observation of large blocks of floating phonolitic pumice that washed up on Tristan da Cunha.  The event was considered to have originated from an eruption associated with an earthquake swarm 37-53 km SSE of Tristan da Cunha on the submarine SE flank of Nightingale Island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1806-011">Smithsonian Volcano Information</a></td></tr></table>	(-37.420000000000002,-12.48)
1281	Bouvet	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bouvet</b></font><br /><font size="5"><b>Southern Atlantic Ocean</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110073.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava dome</td><td width="50%" align="left"><b>Summit Elev:</b> 780 m<br /><b>Latitude:</b> 54.42&deg;S<br /><b>Longitude:</b> 3.35&deg;E</td></tr><tr><td colspan="2"><p align="justify">The solitary ice-covered shield volcano of Bouvet Island is located just off the Southwest Indian Ridge, east of the triple junction between the African, South American, and Antarctic plates.  The 780-m-high basaltic-to-rhyolitic island, also referred to as Bouvetoya, was discovered by and later named for Captain Lozier-Bouvet during his 1739 search for the &quot;great southern continent.&quot;  About 95% of the uninhabited 10-km-wide island is covered by glaciers.  The most prominent feature is the 3.5-km-wide Wilhelmplataet caldera, which is breached to the sea on the NW side.  A late-stage rhyolitic lava dome forms the Cape Valdivia peninsula on the northern flank.  The latest dated eruption produced a lava flow at Cape Meteor on the eastern flank about 2000 years ago.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1806-02-&amp;volpage=photos&amp;photo=110073">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1806-02-">Smithsonian Volcano Information</a></td></tr></table>	(-54.420000000000002,3.3500000000000001)
1282	Buckle Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Buckle Island</b></font><br /><font size="5"><b>Balleny Islands</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1239 m<br /><b>Latitude:</b> 66.78&deg;S<br /><b>Longitude:</b> 163.25&deg;E</td></tr><tr><td colspan="2"><p align="justify">Buckle Island is in the center of a 160-km-long chain of volcanic islands forming the Balleny Islands off the coast of Antarctica's Victoria Land.  The islands are located at the southern end of a submarine ridge system that extends north to New Zealand, but is offset by the Indian-Antarctic ridge system.  The elongated, 21-km-long island is capped by an gently sloping icecap that descends steeply to the sea between rocky cliffs.  Dark eruption columns were reported during 1839 and 1899, but no detailed geological studies exist for Balleny Islands volcanoes.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-01=">Smithsonian Volcano Information</a></td></tr></table>	(-66.780000000000001,163.25)
1283	Young Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Young Island</b></font><br /><font size="5"><b>Balleny Islands</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1340 m<br /><b>Latitude:</b> 66.42&deg;S<br /><b>Longitude:</b> 162.47&deg;E</td></tr><tr><td colspan="2"><p align="justify">Young Island is the northernmost and second largest of the Balleny Islands off the coast of Antarctica's Victoria Land.  Captain Balleny, the discoverer of the islands, reported &quot;smoke&quot; issuing from Freeman Peak on Young Island on February 12, 1839.  The initial report of a 12,000 foot volcano on Young Island proved incorrect--the island has a broad plateau-like summit reaching 1340 m.  The island is almost completely mantled by ice.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-011">Smithsonian Volcano Information</a></td></tr></table>	(-66.420000000000002,162.47)
1284	The Pleiades	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>The Pleiades</b></font><br /><font size="5"><b>Antarctica</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Lava domes<br />&nbsp;&nbsp;&nbsp; Scoria cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3040 m<br /><b>Latitude:</b> 72.67&deg;S<br /><b>Longitude:</b> 165.50&deg;E</td></tr><tr><td colspan="2"><p align="justify">The Pleiades volcano consists of a small trachytic stratovolcano, Mount Pleiones, which along with several lava domes and cinder cones with well-preserved craters, rises 500-m above the broad Evans Neve plateau.  The Pleiades are located in the Melbourne volcanic province of Antarctica's northern Victoria Land near the western coast of the Ross Sea.  Three nested cones containing distinct craters cap Mount Pleiones.  A Potassium-Argon age of 3000 years was obtained from the Taygete cone NNE of Mount Pleiones, and the Pleiades appear to be among the youngest volcanic centers in Antarctica.  Other dates of 12-40,000 years support a youthful age despite the large analytical uncertainties.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-013">Smithsonian Volcano Information</a></td></tr></table>	(-72.670000000000002,165.5)
1285	Melbourne	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Melbourne</b></font><br /><font size="5"><b>Antarctica</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/091001.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Lava domes</td><td width="50%" align="left"><b>Summit Elev:</b> 2732 m<br /><b>Latitude:</b> 74.35&deg;S<br /><b>Longitude:</b> 164.70&deg;E</td></tr><tr><td colspan="2"><p align="justify">Mount Melbourne is a large undissected stratovolcano along the western coast of the Ross Sea in Antarctica's northern Victoria Land.  The 2732-m-high glacier-clad stratovolcano lies at the center of a volcanic field containing both subglacial and subaerial vents that are situated along a dominantly N-S trend.  A large number of scoria cones, lava domes, viscous lava flows, and lava fields are exposed at the summit and upper flanks.  A number of very young-looking cones are located at the summit and on the flanks.  Tephra layers are found within and on top of ice layers, and the most recent eruption may have been only a few hundred years ago.  The volcano displays fumarolic activity that is concentrated along a NNE-SSW line cutting through the summit area and along a line of phreatomagmatic craters on the southern rim of the summit crater.  Prominent ice towers and pinnacles were formed from steam condensation around fumarolic vents.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-015&amp;volpage=photos&amp;photo=091001">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-015">Smithsonian Volcano Information</a></td></tr></table>	(-74.349999999999994,164.69999999999999)
1286	Erebus	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Erebus</b></font><br /><font size="5"><b>Antarctica</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/061066.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3794 m<br /><b>Latitude:</b> 77.53&deg;S<br /><b>Longitude:</b> 167.17&deg;E</td></tr><tr><td colspan="2"><p align="justify">Mount Erebus, the world's southernmost historically active volcano, overlooks the McMurdo research station on Ross Island.  The 3794-m-high Erebus is the largest of three major volcanoes forming the crudely triangular Ross Island.  The summit of the dominantly phonolitic Mount Erebus has been modified by one or two generations of caldera formation.  A summit plateau at about 3200-m altitude marks the rim of the youngest caldera, which formed during the late-Pleistocene and within which the modern cone was constructed.  An elliptical 500 x 600 m wide, 110-m-deep crater truncates the summit and contains an active lava lake within  a 250-m-wide, 100-m-deep inner crater.  The glacier-covered volcano was erupting when first sighted by Captain James Ross in 1841.  Continuous lava-lake activity with minor explosions, punctuated by occasional larger strombolian explosions that eject bombs onto the crater rim, has been documented since 1972, but has probably been occurring for much of the volcano's recent history.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-02=&amp;volpage=photos&amp;photo=061066">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-02=">Smithsonian Volcano Information</a></td><td width="33%"><a href="http://www.ees.nmt.edu/Geop/mevo/mevo.html">Mt. Erebus Volcano Observatory</a></td></tr></table>	(-77.530000000000001,167.16999999999999)
1287	Berlin	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Berlin</b></font><br /><font size="5"><b>Antarctica</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/062018.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcanoes<br />&nbsp;&nbsp;&nbsp; Calderas</td><td width="50%" align="left"><b>Summit Elev:</b> 3478 m<br /><b>Latitude:</b> 76.05&deg;S<br /><b>Longitude:</b> 136.00&deg;W</td></tr><tr><td colspan="2"><p align="justify">Mount Berlin consists of two coalescing shield volcanoes, Berlin Crater and Merrem Peak, each with a 2-km-wide summit caldera.  Mount Berlin is located in the Flood Range of Marie Byrd Land, near the eastern coast of the Ross Sea.  The two calderas are oriented along an east-west line, characteristic of Flood Range volcanoes.  The westernmost and highest volcano, Berlin Crater, reaches 3478 m and is located 3.5 km ESE of Merrem Peak caldera.  Berlin Crater displays active fumaroles along its western and northern caldera rims, producing the characteristic Antarctic fumarolic ice towers.  The youngest dated tephra of a series of tephra layers in glacial ice at Mount Moulton that was attributed to Mount Berlin had an age of about 14.5 +/- 3.8 thousand years (ka), and a younger undated tephra layer was present.  A lava flow at the base of an ice cave below a fumarolic ice tower was dated at about 10.3 +/- 2.7 ka.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-022&amp;volpage=photos&amp;photo=062018">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-022">Smithsonian Volcano Information</a></td></tr></table>	(-76.049999999999997,-136)
1288	Takahe	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Takahe</b></font><br /><font size="5"><b>Antarctica</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110094.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 3460 m<br /><b>Latitude:</b> 76.28&deg;S<br /><b>Longitude:</b> 112.08&deg;W</td></tr><tr><td colspan="2"><p align="justify">Mount Takahe is an isolated shield volcano in eastern Marie Byrd Land with an 8-km-wide summit caldera.  The massive 780 cu km volcano displays a conical, youthful morphology, and the oldest dated rocks are only 0.31 million years old.  Three samples were too young to date by Potassium-Argon, and some tephra layers younger than 30,000 years in the Byrd Station ice core are thought to have originated from Mount Takahe.  Two early Holocene phreatomagmatic tephra layers in the Antarctic ice core were attributed to Mount Takahe (Palais et al., 1988).  The latest stage of activity at Mount Takahe constructed cinder cones on the upper southern flanks and tuff cones and cinder cones on the lower SW and NE flanks.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-027&amp;volpage=photos&amp;photo=110094">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-027">Smithsonian Volcano Information</a></td></tr></table>	(-76.280000000000001,-112.08)
1289	Hudson Mountains	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hudson Mountains</b></font><br /><font size="5"><b>Antarctica</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110095.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Subglacial volcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 749 m<br /><b>Latitude:</b> 74.33&deg;S<br /><b>Longitude:</b> 99.42&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Hudson Mountains, located along the Walgreen Coast in Antarctica's western Ellsworth Land, contain many only slightly eroded parasitic cones forming nunataks protruding above the Antarctic icecap.  The cinder cones apparently rest on three extensively eroded Miocene stratovolcanoes, Teeters Nunatak, Mount Moses, and Mount Manthe.  Subaerial basaltic lava flows dominate, but subglacial or subaqueous tuffs and lava flows are also present.  A tephra layer from an eruption of a subglacial volcano in the Hudson Mountains was dated from ice thickness at about 200 BC.  The possible presence of steam was reported at one of the Hudson volcanoes during 1974.  Satellite data suggested that an eruption of Webber Nunatak took place during 1985, although this has not been confirmed (LeMasurier and Thomson, 1990).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-028&amp;volpage=photos&amp;photo=110095">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-028">Smithsonian Volcano Information</a></td></tr></table>	(-74.329999999999998,-99.420000000000002)
1290	Peter I Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Peter I Island</b></font><br /><font size="5"><b>Antarctica</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/117071.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1640 m<br /><b>Latitude:</b> 68.85&deg;S<br /><b>Longitude:</b> 90.58&deg;W</td></tr><tr><td colspan="2"><p align="justify">The 11 x 19 km Peter I Island in the Bellingshausen Sea opposite Ellsworth Land is a morphologically youthful shield-like volcano.  A 100-m-wide circular crater is found at the summit of the 1750-m-high volcano.  The island was discovered by the Russian explorer Bellingshausen in 1821, and extensive summer pack ice and its isolated location far from regular shipping lanes have restricted visits to the island.  Dated samples from Peter I Island range from 0.35 to 0.1 million years old (Prestvik et al. 1990).  The unmodified volcanic form of the upper part of the volcano argues that parts of it may be Holocene or even historical in age (LeMasurier and Thomson 1990).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-029&amp;volpage=photos&amp;photo=117071">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-029">Smithsonian Volcano Information</a></td></tr></table>	(-68.849999999999994,-90.579999999999998)
1291	Deception Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Deception Island</b></font><br /><font size="5"><b>Antarctica</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/062001.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Caldera<br />&nbsp;&nbsp;&nbsp; Tuff cones<br />&nbsp;&nbsp;&nbsp; Maars</td><td width="50%" align="left"><b>Summit Elev:</b> 576 m<br /><b>Latitude:</b> 62.97&deg;S<br /><b>Longitude:</b> 60.65&deg;W</td></tr><tr><td colspan="2"><p align="justify">Ring-shaped Deception Island, one of Antarctica's most well known volcanoes, contains a 7-km-wide caldera flooded by the sea.  Deception Island is located at the SW end of the Shetland Islands, NE of Graham Land Peninsula, and was constructed along the axis of the Bransfield Rift spreading center.  A narrow passageway named Neptunes Bellows provides entrance to a natural harbor that was utilized as an Antarctic whaling station.  Numerous vents located along ring fractures circling the low, 14-km-wide island have been active during historical time.  Maars line the shores of 190-m-deep Port Foster, the caldera bay.  Among the largest of these maars is 1-km-wide Whalers Bay, at the entrance to the harbor.  Eruptions from Deception Island during the past 8700 years have been dated from ash layers in lake sediments on the Antarctic Peninsula and neighboring islands.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-03=&amp;volpage=photos&amp;photo=062001">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-03=">Smithsonian Volcano Information</a></td></tr></table>	(-62.969999999999999,-60.649999999999999)
1292	Penguin Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Penguin Island</b></font><br /><font size="5"><b>Antarctica</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/062005.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Maar</td><td width="50%" align="left"><b>Summit Elev:</b> 180 m<br /><b>Latitude:</b> 62.10&deg;S<br /><b>Longitude:</b> 57.93&deg;W</td></tr><tr><td colspan="2"><p align="justify">The small 1.4 x 1.7 km Penguin Island is located off the SE coast of King George Island in Antarctica's Shetland Islands, west of the axis of the Bransfield Rift.  The most prominent feature on Penguin Island is Deacon Peak, a basaltic scoria cone with a 350-m-wide well-preserved summit crater that forms the 180-m-high summit on the SW side of the island.  A small plug of basaltic lava occupies the 75-m-deep crater.  Petrel Crater, a 300-m-wide maar, is located near the east coast.  The formation of Deacon Peak scoria cone was dated by lichenometry at about 300 years ago, and the younger Petrel Crater maar was dated at about 100 years (Birkenmajer 1979).  Some of the historical reports of fumarolic activity on nearby Bridgeman Island are attributed to the more youthful Penguin Island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-031&amp;volpage=photos&amp;photo=062005">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-031">Smithsonian Volcano Information</a></td></tr></table>	(-62.100000000000001,-57.93)
1293	Paulet	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Paulet</b></font><br /><font size="5"><b>Antarctica</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/062011.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Cinder cone</td><td width="50%" align="left"><b>Summit Elev:</b> 353 m<br /><b>Latitude:</b> 63.58&deg;S<br /><b>Longitude:</b> 55.77&deg;W</td></tr><tr><td colspan="2"><p align="justify">Paulet is a small 2.5 x 3.5 km island located east of the tip of Graham Land Peninsula.  The pear-shaped 353-m-high island is composed of lava flows capped by a well-preserved cinder cone with a small summit crater.  The youthful morphology of the volcano was thought to indicate activity during the last 1000 years (LeMasurier and Thomson 1990).  Residual heat keeps the island largely ice free throughout the year.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-041&amp;volpage=photos&amp;photo=062011">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-041">Smithsonian Volcano Information</a></td></tr></table>	(-63.579999999999998,-55.770000000000003)
1294	Thule Islands	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Thule Islands</b></font><br /><font size="5"><b>South Sandwich Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/109093.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcanoes<br />&nbsp;&nbsp;&nbsp; Calderas<br />&nbsp;&nbsp;&nbsp; Explosion craters</td><td width="50%" align="left"><b>Summit Elev:</b> 1075 m<br /><b>Latitude:</b> 59.45&deg;S<br /><b>Longitude:</b> 27.37&deg;W</td></tr><tr><td colspan="2"><p align="justify">The Thule Islands, at the southern end of the South Sandwich island arc bordering the Scotia Sea, consist of three stratovolcanoes constructed along an E-W-trending line.  An ice-filled 1.5-2 km wide caldera truncates the summit of andesitic-dacitic Thule, the westernmost island, and a 4.3 x 4.8 km submarine caldera forms Douglas Strait between Thule and basaltic-to-dacitic Cook Island.  Another possible submarine caldera lies east of Cook Island and south of basaltic-andesite Bellingshausen, the easternmost island.  The age of Cook Island is uncertain, but steam was observed at the summit crater of Thule Island in 1962, and ash was seen on the surface of the ice there and on Bellingshausen Island, indicating possible 20th-century eruptions (Baker, 1968).  Bellingshausen Island has a youthful, relatively ice-free profile and an extensive well-preserved lava field on its southern flank.  A small explosion crater formed on the southern flank of Bellinghausen Island sometime between 1964 and 1986.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-07=&amp;volpage=photos&amp;photo=109093">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-07=">Smithsonian Volcano Information</a></td></tr></table>	(-59.450000000000003,-27.370000000000001)
1295	Bristol Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Bristol Island</b></font><br /><font size="5"><b>South Sandwich Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/109098.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 1100 m<br /><b>Latitude:</b> 59.03&deg;S<br /><b>Longitude:</b> 26.58&deg;W</td></tr><tr><td colspan="2"><p align="justify">The 9 x 10 km Bristol Island near the southern end of the South Sandwich arc lies across Fortser's Passage from the Southern Thule Islands and forms one of the largest islands of the chain.  Largely glacier-covered, it contains a horseshoe-shaped ridge at the interior extending northward from the highest peak, 1100-m-high Mount Darnley.  A steep-sided flank cone or lava dome, Havfruen Peak, is located on the east side, and a young crater and fissure are on the west flank.  Three large sea stacks lying off Turmoil Point at the western tip of the island may be remnants of an older now-eroded volcanic center.  Both summit and flank vents on Bristol Island have been active during historical time.  The latest eruption, during 1956, originated from the west-flank crater, and deposited cinder over the icecap.  The extensive icecap on Bristol Island and the difficulty of landing make it the least explored of the South Sandwich Islands.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-08=&amp;volpage=photos&amp;photo=109098">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-08=">Smithsonian Volcano Information</a></td></tr></table>	(-59.030000000000001,-26.579999999999998)
1296	Montagu Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Montagu Island</b></font><br /><font size="5"><b>South Sandwich Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/119088.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Shield volcano<br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Caldera</td><td width="50%" align="left"><b>Summit Elev:</b> 1370 m<br /><b>Latitude:</b> 58.42&deg;S<br /><b>Longitude:</b> 26.33&deg;W</td></tr><tr><td colspan="2"><p align="justify">The largest of the South Sandwich Islands, Montagu consists of a massive shield volcano cut by a 6-km-wide ice-filled summit caldera.  The summit of the 10 x 12 km wide island rises about 3000 m from the sea floor between Bristol and Saunders Islands.  Around 90% of the island is ice-covered; glaciers extending to the sea typically form vertical ice cliffs.  The name Mount Belinda has been applied both to the high point at the southern end of the summit caldera and to the young central cone.  Mount Oceanite, an isolated 900-m-high peak with a 270-m-wide summit crater, lies at the SE tip of the island and was the source of lava flows exposed at Mathias Point and Allen Point.  There was no record of Holocene or historical eruptive activity at Montagu until MODIS satellite data, beginning in late 2001, revealed thermal anomalies consistent with lava lake activity that has been persistent since then.  Apparent plumes and single anomalous pixels were observed intermittently on AVHRR images during the period March 1995 to February 1998, possibly indicating earlier unconfirmed and more sporadic volcanic activity.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-081&amp;volpage=photos&amp;photo=119088">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-081">Smithsonian Volcano Information</a></td></tr></table>	(-58.420000000000002,-26.329999999999998)
1297	Michael	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Michael</b></font><br /><font size="5"><b>South Sandwich Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/109094.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 990 m<br /><b>Latitude:</b> 57.78&deg;S<br /><b>Longitude:</b> 26.45&deg;W</td></tr><tr><td colspan="2"><p align="justify">The young constructional Mount Michael stratovolcano dominates glacier-covered Saunders Island.  Symmetrical 990-m-high Mount Michael has a 700-m-wide summit crater and a remnant of  a somma rim to the SE.  Tephra layers visible in ice cliffs surrounding the island are evidence of recent eruptions.  Ash clouds were reported from the summit crater in 1819, and an effusive eruption was inferred to have occurred from a north-flank fissure around the end of the 19th century and beginning of the 20th century.  A low ice-free lava platform, Blackstone Plain, is located on the north coast, surrounding a group of former sea stacks.  A cluster of parasitic cones on the SE flank, the Ashen Hills, appear to have been modified since 1820 (LeMasurier and Thomson 1990).  Vapor emission is frequently reported from the summit crater.  Recent AVHRR and MODIS satellite imagery has revealed evidence for lava lake activity in the summit crater of Mount Michael.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-09=&amp;volpage=photos&amp;photo=109094">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-09=">Smithsonian Volcano Information</a></td></tr></table>	(-57.780000000000001,-26.449999999999999)
1298	Candlemas Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Candlemas Island</b></font><br /><font size="5"><b>South Sandwich Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110092.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 550 m<br /><b>Latitude:</b> 57.08&deg;S<br /><b>Longitude:</b> 26.67&deg;W</td></tr><tr><td colspan="2"><p align="justify">The southern end of Candlemas Island consists of an eroded, glacier-covered basaltic stratovolcano cut by steep cliffs on the east.  Lava flows along the cliff dip to the west, suggesting that the original summit vent was beyond the eastern shoreline.  The northern end of the irregularly shaped, 6-km-long island consists of an andesitic-to-dacitic complex of scoria cones with radiating lava flows.  These initially formed a separate island but now consist of a low attached platform that is estimated to be no more than a few hundred years old (LeMasurier and Thomson, 1990).  Dark brown clouds mixed with white steam were reported in 1823 and 1911, but it has not been demonstrated which, if any, of the young north flank lava flows formed since the island was discovered in 1775.  Geysers and hot pools have been observed on several occasions during the 20th century.  Vindication Island, of possible Holocene age, is located 4.5 km west of Candlemas Island.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-10=&amp;volpage=photos&amp;photo=110092">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-10=">Smithsonian Volcano Information</a></td></tr></table>	(-57.079999999999998,-26.670000000000002)
1299	Hodson	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Hodson</b></font><br /><font size="5"><b>South Sandwich Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110093.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Scoria cones</td><td width="50%" align="left"><b>Summit Elev:</b> 1005 m<br /><b>Latitude:</b> 56.70&deg;S<br /><b>Longitude:</b> 27.15&deg;W</td></tr><tr><td colspan="2"><p align="justify">The largely ice-covered, 6 x 8 km Visokoi Island consists of a single stratovolcano, Mount Hodson, whose rounded 1005-m-high summit lies west of the center of the island.  Numerous basaltic scoria cones were constructed on the lower flanks of the oval-shaped island, which is part of the Traverse Islands in the northern part of the South Sandwich Island chain.  The youthful morphology of Visokoi Island suggests that volcanic activity has continued until virtually the present time (LeMasurier and Thomson, 1990).  Possible eruptive activity was reported during 1830 and 1930, and the summit is usually obscured by &quot;smoke&quot; or steam.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-11=&amp;volpage=photos&amp;photo=110093">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-11=">Smithsonian Volcano Information</a></td></tr></table>	(-56.700000000000003,-27.149999999999999)
1300	Leskov Island	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Leskov Island</b></font><br /><font size="5"><b>South Sandwich Islands</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano</td><td width="50%" align="left"><b>Summit Elev:</b> 190 m<br /><b>Latitude:</b> 56.67&deg;S<br /><b>Longitude:</b> 28.13&deg;W</td></tr><tr><td colspan="2"><p align="justify">The small crescent-shaped Leskov Island lies about 50 km west of the main axis of the South Sandwich Islands, but appears to be comparable in age to volcanoes along the main arc.  Leskov Island, only 900 m long and 400 m wide, is bounded by steep cliffs and is the eroded remnant of a small andesitic stratovolcano.  Its arcuate, NE-facing escarpment is concave toward Crater Bay, the site of the main eruptive center.  The age of Leskov Island is not known.  A single Potassium-Argon determination gave an age of 0.5 million years, but fumarolic activity was recorded along the summit ridge in 1911 and 1964 (LeMasurier and Thomson, 1990).</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-12=">Smithsonian Volcano Information</a></td></tr></table>	(-56.670000000000002,-28.129999999999999)
1301	Zavodovski	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Zavodovski</b></font><br /><font size="5"><b>South Sandwich Islands</b></font></td></tr><tr align="center"><td colspan="2"><img src = "http://www.volcano.si.edu/ge/photos/110091.jpg"></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Stratovolcano<br />&nbsp;&nbsp;&nbsp; Pyroclastic cones</td><td width="50%" align="left"><b>Summit Elev:</b> 551 m<br /><b>Latitude:</b> 56.30&deg;S<br /><b>Longitude:</b> 27.57&deg;W</td></tr><tr><td colspan="2"><p align="justify">The 5-km-wide Zavodovski Island, the northernmost of the South Sandwich Islands, consists of a single 551-m-high basaltic stratovolcano with two parasitic cones on the east side.  Mount Curry, the island's summit, lies west of the center of the island, which is more eroded on that side.  Two fissures extend NE from the summit towards the east-flank craters, and a lava platform is located along the eastern coast.  Zavodovski is the most frequently visited of the South Sandwich Islands.  It was erupting when first seen in 1819 by the explorer Bellingshausen, and the volcano has been reported to be smoking during subsequent visits.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"><i><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-13=&amp;volpage=photos&amp;photo=110091">Larger photo with caption and credit.</a></i></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-13=">Smithsonian Volcano Information</a></td></tr></table>	(-56.299999999999997,-27.57)
1302	Protector Shoal	<table border="0" cellspacing="3" width="320" align="center"><tr align="left"><td colspan="2"><a href="http://www.volcano.si.edu/"><img src="http://www.volcano.si.edu/ge/gvplogo.png" width="227" height="43" /></a></td></tr><tr align="center"><td colspan="2"><hr /><font size="6"><b>Protector Shoal</b></font><br /><font size="5"><b>South Sandwich Islands</b></font></td></tr><tr align="left" valign="top"><td width="50%" align="left"><b>Volcano types:</b><br />&nbsp;&nbsp;&nbsp; Submarine volcano</td><td width="50%" align="left"><b>Summit Elev:</b> -27 m<br /><b>Latitude:</b> 55.92&deg;S<br /><b>Longitude:</b> 28.08&deg;W</td></tr><tr><td colspan="2"><p align="justify">Protector Shoal seamount, located 56 km NW of Zavodovski Island, forms the northernmost volcano of the arcuate South Sandwich Islands.  The broad, gently sloping cone rises from a depth of 1200 m to within 27 m of the sea surface.  The submarine volcano has a gentle gradient to the north, but is steeper on the south side.  At least two satellitic cones are present.  Large amounts of rhyolitic pumice, first detected by the Royal Navy Ice Patrol Vessel H.M.S. Protector, were ejected during its only recorded eruption in 1962 and formed an extensive pumice raft which drifted as far as New Zealand.</p></td></tr><tr><td align="left" width="33%"><a href="http://www.volcano.si.edu/info/about/about_ge.cfm">About Volcano Data</a></td><td align="right" width="66%"></td></tr><tr height="6"><td colspan="2"><hr /></td></tr></table><table border="0" cellspacing="0" cellpadding="0" width="320" align="center"><tr align="center"><td width="33%"><a href="http://www.volcano.si.edu/world/volcano.cfm?vnum=1900-14-">Smithsonian Volcano Information</a></td></tr></table>	(-55.920000000000002,-28.079999999999998)
\.


--
-- Name: public; Type: ACL; Schema: -; Owner: postgres
--

REVOKE ALL ON SCHEMA public FROM PUBLIC;
REVOKE ALL ON SCHEMA public FROM postgres;
GRANT ALL ON SCHEMA public TO postgres;
GRANT ALL ON SCHEMA public TO PUBLIC;


--
-- PostgreSQL database dump complete
--

